/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(J){for(var e=[],L=0,n=J.length;L<n;L++)e[L]=ne[J[L]];return e};define(ne[98],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function L(n,k){if(!n)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=L}),define(ne[48],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function L(T){return T?T.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=L;class n{constructor(R,b,w){this.id=R,this.definition=b,this.description=w,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(T,R){const b=["codicon","codicon-"+T];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=k;var _;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function b(E){if(E instanceof n)return["codicon","codicon-"+E.id];const g=R.exec(E.id);if(!g)return b(n.error);let[,p,f]=g;const y=["codicon","codicon-"+p];return f&&y.push("codicon-modifier-"+f.substr(1)),y}T.asClassNameArray=b;function w(E){return b(E).join(" ")}T.asClassName=w;function P(E){return"."+b(E).join(".")}T.asCSSSelector=P})(_=e.CSSIcon||(e.CSSIcon={}))}),define(ne[66],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const L=Object.prototype.hasOwnProperty;function n(P){const E=[];for(let g in P)L.call(P,g)&&E.push(P[g]);return E}e.values=n;function k(P,E){for(let g in P)if(L.call(P,g)&&E({key:g,value:P[g]},function(){delete P[g]})===!1)return}e.forEach=k;function _(P,E){const g=Object.create(null);for(const p of P){const f=E(p);let y=g[f];y||(y=g[f]=[]),y.push(p)}return g}e.groupBy=_;function T(P){const E=Object.create(null);return P&&P.forEach((g,p)=>{E[p]=g}),E}e.fromMap=T;function R(P,E){const g=[],p=[];for(let f of P)E.has(f)||g.push(f);for(let f of E)P.has(f)||p.push(f);return{removed:g,added:p}}e.diffSets=R;function b(P,E){const g=[],p=[];for(let[f,y]of P)E.has(f)||g.push(y);for(let[f,y]of E)P.has(f)||p.push(y);return{removed:g,added:p}}e.diffMaps=b;class w{constructor(){this.map=new Map}add(E,g){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(g)}delete(E,g){const p=this.map.get(E);!p||(p.delete(g),p.size===0&&this.map.delete(E))}forEach(E,g){const p=this.map.get(E);!p||p.forEach(g)}}e.SetMap=w}),define(ne[53],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function L(T){return(R,b,w)=>{let P=null,E=null;if(typeof w.value=="function"?(P="value",E=w.value):typeof w.get=="function"&&(P="get",E=w.get),!E)throw new Error("not supported");w[P]=T(E,b)}}e.createDecorator=L;function n(T,R,b){let w=null,P=null;if(typeof b.value=="function"?(w="value",P=b.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(w="get",P=b.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;b[w]=function(...g){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[E]}}e.memoize=n;function k(T,R,b){return L((w,P)=>{const E=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...p){this[g]||(this[g]=b?b():void 0),clearTimeout(this[E]),R&&(this[g]=R(this[g],...p),p=[this[g]]),this[E]=setTimeout(()=>{w.apply(this,p),this[g]=b?b():void 0},T)}})}e.debounce=k;function _(T,R,b){return L((w,P)=>{const E=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,f=`$throttle$pending$${P}`;return function(...y){if(this[g]||(this[g]=b?b():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[g]=R(this[g],...y)),this[f])return;const C=this[p]+T;C<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[g]]),this[g]=b?b():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),w.apply(this,[this[g]]),this[g]=b?b():void 0},C-Date.now()))}})}e.throttle=_}),define(ne[8],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=L,e.errorHandler=new L;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function k(u){b(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function _(u){b(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=_;function T(u){if(u instanceof Error){let{name:r,message:a}=u;const i=u.stacktrace||u.stack;return{$isError:!0,name:r,message:a,stack:i}}return u}e.transformErrorForSerialization=T;const R="Canceled";function b(u){return u instanceof Error&&u.name===R&&u.message===R}e.isPromiseCanceledError=b;class w extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=w;function P(){const u=new Error(R);return u.name=u.message,u}e.canceled=P;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function g(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=g;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function f(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=f;function y(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=y;class C extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=C;class d extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=d;class S extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=S;function m(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=m;function l(u,r=Object.create(null)){const a=new Error(u);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=l}),define(ne[16],ie([0,1,8]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(F,j=0){return F[F.length-(1+j)]}e.tail=n;function k(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=k;function _(F,j,H=(W,x)=>W===x){if(F===j)return!0;if(!F||!j||F.length!==j.length)return!1;for(let W=0,x=F.length;W<x;W++)if(!H(F[W],j[W]))return!1;return!0}e.equals=_;function T(F,j,H){let W=0,x=F.length-1;for(;W<=x;){const re=(W+x)/2|0,se=H(F[re],j);if(se<0)W=re+1;else if(se>0)x=re-1;else return re}return-(W+1)}e.binarySearch=T;function R(F,j){let H=0,W=F.length;if(W===0)return 0;for(;H<W;){const x=Math.floor((H+W)/2);j(F[x])?W=x:H=x+1}return H}e.findFirstInSorted=R;function b(F,j,H){if(F=F|0,F>=j.length)throw new TypeError("invalid index");let W=j[Math.floor(j.length*Math.random())],x=[],re=[],se=[];for(let ce of j){const he=H(ce,W);he<0?x.push(ce):he>0?re.push(ce):se.push(ce)}return F<x.length?b(F,x,H):F<x.length+se.length?se[0]:b(F-(x.length+se.length),re,H)}e.quickSelect=b;function w(F,j){const H=[];let W;for(const x of F.slice(0).sort(j))!W||j(W[0],x)!==0?(W=[x],H.push(W)):W.push(x);return H}e.groupBy=w;function P(F,j,H){const W=[];function x(ce,he,Se){if(he===0&&Se.length===0)return;const ge=W[W.length-1];ge&&ge.start+ge.deleteCount===ce?(ge.deleteCount+=he,ge.toInsert.push(...Se)):W.push({start:ce,deleteCount:he,toInsert:Se})}let re=0,se=0;for(;;){if(re===F.length){x(re,0,j.slice(se));break}if(se===j.length){x(re,F.length-re,[]);break}const ce=F[re],he=j[se],Se=H(ce,he);Se===0?(re+=1,se+=1):Se<0?(x(re,1,[]),re+=1):Se>0&&(x(re,0,[he]),se+=1)}return W}e.sortedDiff=P;function E(F,j,H){const W=P(F,j,H),x=[],re=[];for(const se of W)x.push(...F.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:x,added:re}}e.delta=E;function g(F,j,H){if(H===0)return[];const W=F.slice(0,H).sort(j);return f(F,j,W,H,F.length),W}e.top=g;function p(F,j,H,W,x){return H===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const ce=F.length,he=F.slice(0,H).sort(j);for(let Se=H,ge=Math.min(H+W,ce);Se<ce;Se=ge,ge=Math.min(ge+W,ce)){if(Se>H&&await new Promise(ye=>setTimeout(ye)),x&&x.isCancellationRequested)throw(0,L.canceled)();f(F,j,he,Se,ge)}return he})().then(re,se)})}e.topAsync=p;function f(F,j,H,W,x){for(const re=H.length;W<x;W++){const se=F[W];if(j(se,H[re-1])<0){H.pop();const ce=R(H,he=>j(se,he)<0);H.splice(ce,0,se)}}}function y(F){return F.filter(j=>!!j)}e.coalesce=y;function C(F){let j=0;for(let H=0;H<F.length;H++)F[H]&&(F[j]=F[H],j+=1);F.length=j}e.coalesceInPlace=C;function d(F,j,H){F.splice(H,0,F.splice(j,1)[0])}e.move=d;function S(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=S;function m(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=m;function l(F,j=H=>H){const H=new Set;return F.filter(W=>{const x=j(W);return H.has(x)?!1:(H.add(x),!0)})}e.distinct=l;function u(F){const j=new Set;return H=>{const W=F(H);return j.has(W)?!1:(j.add(W),!0)}}e.uniqueFilter=u;function r(F,j){const H=a(F,j);if(H!==-1)return F[H]}e.findLast=r;function a(F,j){for(let H=F.length-1;H>=0;H--){const W=F[H];if(j(W))return H}return-1}e.lastIndex=a;function i(F,j){return F.length>0?F[0]:j}e.firstOrDefault=i;function t(F,j,H=(W,x)=>W===x){let W=0;for(let x=0,re=Math.min(F.length,j.length);x<re&&H(F[x],j[x]);x++)W++;return W}e.commonPrefixLength=t;function s(F){return[].concat(...F)}e.flatten=s;function o(F,j){let H=typeof j=="number"?F:0;typeof j=="number"?H=F:(H=0,j=F);const W=[];if(H<=j)for(let x=H;x<j;x++)W.push(x);else for(let x=H;x>j;x--)W.push(x);return W}e.range=o;function c(F,j,H){return F.reduce((W,x)=>(W[j(x)]=H?H(x):x,W),Object.create(null))}e.index=c;function h(F,j){return F.push(j),()=>v(F,j)}e.insert=h;function v(F,j){const H=F.indexOf(j);if(H>-1)return F.splice(H,1),j}e.remove=v;function I(F,j,H){const W=F.slice(0,j),x=F.slice(j);return W.concat(H,x)}e.arrayInsert=I;function A(F,j){let H;if(typeof j=="number"){let W=j;H=()=>{const x=Math.sin(W++)*179426549;return x-Math.floor(x)}}else H=Math.random;for(let W=F.length-1;W>0;W-=1){const x=Math.floor(H()*(W+1)),re=F[W];F[W]=F[x],F[x]=re}}e.shuffle=A;function O(F,j){const H=F.indexOf(j);H>-1&&(F.splice(H,1),F.unshift(j))}e.pushToStart=O;function N(F,j){const H=F.indexOf(j);H>-1&&(F.splice(H,1),F.push(j))}e.pushToEnd=N;function $(F,j){return Array.isArray(F)?F.map(j):j(F)}e.mapArrayOrNot=$;function D(F){return Array.isArray(F)?F:[F]}e.asArray=D;function M(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=M;function z(F,j){for(const H of F){const W=j(H);if(W!==void 0)return W}}e.mapFind=z;function U(F,j,H){const W=Y(F,j),x=F.length,re=H.length;F.length=x+re;for(let se=x-1;se>=W;se--)F[se+re]=F[se];for(let se=0;se<re;se++)F[se+W]=H[se]}e.insertInto=U;function V(F,j,H,W){const x=Y(F,j),re=F.splice(x,H);return U(F,x,W),re}e.splice=V;function Y(F,j){return j<0?Math.max(j+F.length,0):Math.min(j,F.length)}function B(F,j){return(H,W)=>j(F(H),F(W))}e.compareBy=B;const q=(F,j)=>F-j;e.numberComparator=q;function X(F,j){if(F.length===0)return;let H=F[0];for(let W=1;W<F.length;W++){const x=F[W];j(x,H)>0&&(H=x)}return H}e.findMaxBy=X;function G(F,j){if(F.length===0)return;let H=F[0];for(let W=1;W<F.length;W++){const x=F[W];j(x,H)>=0&&(H=x)}return H}e.findLastMaxBy=G;function ee(F,j){return X(F,(H,W)=>-j(H,W))}e.findMinBy=ee;class K{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let H=this.firstIdx;for(;H<this.items.length&&j(this.items[H]);)H++;const W=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,W}takeFromEndWhile(j){let H=this.lastIdx;for(;H>=0&&j(this.items[H]);)H--;const W=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,W}peek(){return this.items[this.firstIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}takeCount(j){const H=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,H}}e.ArrayQueue=K}),define(ne[67],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(n){const k=this;let _=!1,T;return function(){return _||(_=!0,T=n.apply(k,arguments)),T}}e.once=L}),define(ne[54],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(n){function k(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=k;const _=Object.freeze([]);function T(){return _}n.empty=T;function*R(u){yield u}n.single=R;function b(u){return u||_}n.from=b;function w(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=w;function P(u){return u[Symbol.iterator]().next().value}n.first=P;function E(u,r){for(const a of u)if(r(a))return!0;return!1}n.some=E;function g(u,r){for(const a of u)if(r(a))return a}n.find=g;function*p(u,r){for(const a of u)r(a)&&(yield a)}n.filter=p;function*f(u,r){let a=0;for(const i of u)yield r(i,a++)}n.map=f;function*y(...u){for(const r of u)for(const a of r)yield a}n.concat=y;function*C(u){for(const r of u)for(const a of r)yield a}n.concatNested=C;function d(u,r,a){let i=a;for(const t of u)i=r(i,t);return i}n.reduce=d;function*S(u,r,a=u.length){for(r<0&&(r+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);r<a;r++)yield u[r]}n.slice=S;function m(u,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,u];const i=u[Symbol.iterator]();for(let t=0;t<r;t++){const s=i.next();if(s.done)return[a,n.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return i}}]}n.consume=m;function l(u,r,a=(i,t)=>i===t){const i=u[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=i.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}n.equals=l})(L=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(r){r.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function T(r,a=!1){let i=0,t=r.length,s="",o=0,c=16,h=0;function v(M){let z=0,U=0;for(;z<M;){const V=r.charCodeAt(i);if(V>=48&&V<=57)U=U*16+V-48;else if(V>=65&&V<=70)U=U*16+V-65+10;else if(V>=97&&V<=102)U=U*16+V-97+10;else break;i++,z++}return z<M&&(U=-1),U}function I(M){i=M,s="",o=0,c=16,h=0}function A(){const M=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&w(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&w(r.charCodeAt(i)))for(i++;i<r.length&&w(r.charCodeAt(i));)i++;else return h=3,r.substring(M,i);let z=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&w(r.charCodeAt(i))){for(i++;i<r.length&&w(r.charCodeAt(i));)i++;z=i}else h=3;return r.substring(M,z)}function O(){let M="",z=i;for(;;){if(i>=t){M+=r.substring(z,i),h=2;break}const U=r.charCodeAt(i);if(U===34){M+=r.substring(z,i),i++;break}if(U===92){if(M+=r.substring(z,i),i++,i>=t){h=2;break}switch(r.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const Y=v(4);Y>=0?M+=String.fromCharCode(Y):h=4;break}default:h=5}z=i;continue}if(U>=0&&U<=31)if(b(U)){M+=r.substring(z,i),h=2;break}else h=6;i++}return M}function N(){if(s="",h=0,o=i,i>=t)return o=t,c=17;let M=r.charCodeAt(i);if(R(M)){do i++,s+=String.fromCharCode(M),M=r.charCodeAt(i);while(R(M));return c=15}if(b(M))return i++,s+=String.fromCharCode(M),M===13&&r.charCodeAt(i)===10&&(i++,s+=`
`),c=14;switch(M){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,s=O(),c=10;case 47:{const z=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return s=r.substring(z,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const U=t-1;let V=!1;for(;i<U;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,V=!0;break}i++}return V||(i++,h=1),s=r.substring(z,i),c=13}return s+=String.fromCharCode(M),i++,c=16}case 45:if(s+=String.fromCharCode(M),i++,i===t||!w(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),c=11;default:for(;i<t&&$(M);)i++,M=r.charCodeAt(i);if(o!==i){switch(s=r.substring(o,i),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(M),i++,c=16}}function $(M){if(R(M)||b(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function D(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>i,scan:a?D:N,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>h}}e.createScanner=T;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function w(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function E(r,a){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(v,I,A,O){o.value=v,o.offset=I,o.length=A,o.type=O,o.colonOffset=void 0,s=o}try{m(r,{onObjectBegin:(v,I)=>{if(a<=v)throw t;s=void 0,c=a>v,i.push("")},onObjectProperty:(v,I,A)=>{if(a<I||(h(v,I,A,"property"),i[i.length-1]=v,a<=I+A))throw t},onObjectEnd:(v,I)=>{if(a<=v)throw t;s=void 0,i.pop()},onArrayBegin:(v,I)=>{if(a<=v)throw t;s=void 0,i.push(0)},onArrayEnd:(v,I)=>{if(a<=v)throw t;s=void 0,i.pop()},onLiteralValue:(v,I,A)=>{if(a<I||(h(v,I,A,u(v)),a<=I+A))throw t},onSeparator:(v,I,A)=>{if(a<=I)throw t;if(v===":"&&s&&s.type==="property")s.colonOffset=I,c=!1,s=void 0;else if(v===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(c=!0,i[i.length-1]=""),s=void 0}}})}catch(v){if(v!==t)throw v}return{path:i,previousNode:s,isAtPropertyKey:c,matches:v=>{let I=0;for(let A=0;I<v.length&&A<i.length;A++)if(v[I]===i[A]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}e.getLocation=E;function g(r,a=[],i=_.DEFAULT){let t=null,s=[];const o=[];function c(v){Array.isArray(s)?s.push(v):t!==null&&(s[t]=v)}return m(r,{onObjectBegin:()=>{const v={};c(v),o.push(s),s=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const v=[];c(v),o.push(s),s=v,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(v,I,A)=>{a.push({error:v,offset:I,length:A})}},i),s[0]}e.parse=g;function p(r,a=[],i=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function o(v){return t.children.push(v),v}m(r,{onObjectBegin:v=>{t=o({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,I,A)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:I,length:A,parent:t})},onObjectEnd:(v,I)=>{t.length=v+I-t.offset,t=t.parent,s(v+I)},onArrayBegin:(v,I)=>{t=o({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,I)=>{t.length=v+I-t.offset,t=t.parent,s(v+I)},onLiteralValue:(v,I,A)=>{o({type:u(v),offset:I,length:A,parent:t,value:v}),s(I+A)},onSeparator:(v,I,A)=>{t.type==="property"&&(v===":"?t.colonOffset=I:v===","&&s(I))},onError:(v,I,A)=>{a.push({error:v,offset:I,length:A})}},i);const h=t.children[0];return h&&delete h.parent,h}e.parseTree=p;function f(r,a){if(!r)return;let i=r;for(let t of a)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=f;function y(r){if(!r.parent||!r.parent.children)return[];const a=y(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;a.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&a.push(i)}return a}e.getNodePath=y;function C(r){switch(r.type){case"array":return r.children.map(C);case"object":{const a=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(a[i.children[0].value]=C(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=C;function d(r,a,i=!1){return a>=r.offset&&a<r.offset+r.length||i&&a===r.offset+r.length}e.contains=d;function S(r,a,i=!1){if(d(r,a,i)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=S(t[s],a,i);if(o)return o}return r}}e.findNodeAtOffset=S;function m(r,a,i=_.DEFAULT){const t=T(r,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(K){return K?F=>K(F,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(a.onObjectBegin),h=o(a.onObjectProperty),v=s(a.onObjectEnd),I=s(a.onArrayBegin),A=s(a.onArrayEnd),O=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),D=o(a.onError),M=i&&i.disallowComments,z=i&&i.allowTrailingComma;function U(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:M||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(K){case 12:case 13:M?V(10):$();break;case 16:V(1);break;case 15:case 14:break;default:return K}}}function V(K,F=[],j=[]){if(D(K),F.length+j.length>0){let H=t.getToken();for(;H!==17;){if(F.indexOf(H)!==-1){U();break}else if(j.indexOf(H)!==-1)break;H=U()}}}function Y(K){const F=t.getTokenValue();return K?O(F):h(F),U(),!0}function B(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(V(2),K=0)}catch{V(2)}O(K);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function q(){return t.getToken()!==10?(V(3,[],[2,5]),!1):(Y(!1),t.getToken()===6?(N(":"),U(),ee()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function X(){c(),U();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||V(4,[],[]),N(","),U(),t.getToken()===2&&z)break}else K&&V(6,[],[]);q()||V(4,[],[2,5]),K=!0}return v(),t.getToken()!==2?V(7,[2],[]):U(),!0}function G(){I(),U();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||V(4,[],[]),N(","),U(),t.getToken()===4&&z)break}else K&&V(6,[],[]);ee()||V(4,[],[4,5]),K=!0}return A(),t.getToken()!==4?V(8,[4],[]):U(),!0}function ee(){switch(t.getToken()){case 3:return G();case 1:return X();case 10:return Y(!0);default:return B()}}return U(),t.getToken()===17?i.allowEmptyContent?!0:(V(4,[],[]),!1):ee()?(t.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=m;function l(r,a){let i=T(r),t=[],s,o=0,c;do switch(c=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==c&&t.push(r.substring(o,c)),a!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(s!==17);return t.join("")}e.stripComments=l;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ne[49],ie([0,1,35]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(w,P,E){let g,p,f,y,C;if(P){for(y=P.offset,C=y+P.length,f=y;f>0&&!b(w,f-1);)f--;let c=C;for(;c<w.length&&!b(w,c);)c++;p=w.substring(f,c),g=T(p,E)}else p=w,g=0,f=0,y=0,C=w.length;const d=R(E,w);let S=!1,m=0,l;E.insertSpaces?l=_(" ",E.tabSize||4):l="	";const u=(0,L.createScanner)(p,!1);let r=!1;function a(){return d+_(l,g+m)}function i(){let c=u.scan();for(S=!1;c===15||c===14;)S=S||c===14,c=u.scan();return r=c===16||u.getTokenError()!==0,c}const t=[];function s(c,h,v){!r&&h<C&&v>y&&w.substring(h,v)!==c&&t.push({offset:h,length:v-h,content:c})}let o=i();if(o!==17){const c=u.getTokenOffset()+f,h=_(l,g);s(h,f,c)}for(;o!==17;){let c=u.getTokenOffset()+u.getTokenLength()+f,h=i(),v="";for(;!S&&(h===12||h===13);){const A=u.getTokenOffset()+f;s(" ",c,A),c=u.getTokenOffset()+u.getTokenLength()+f,v=h===12?a():"",h=i()}if(h===2)o!==1&&(m--,v=a());else if(h===4)o!==3&&(m--,v=a());else{switch(o){case 3:case 1:m++,v=a();break;case 5:case 12:v=a();break;case 13:S?v=a():v=" ";break;case 6:v=" ";break;case 10:if(h===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?v=" ":h!==5&&h!==17&&(r=!0);break;case 16:r=!0;break}S&&(h===12||h===13)&&(v=a())}const I=u.getTokenOffset()+f;s(v,c,I),o=h}return t}e.format=n;function k(w,P){const E=JSON.stringify(w,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.toFormattedString=k;function _(w,P){let E="";for(let g=0;g<P;g++)E+=w;return E}function T(w,P){let E=0,g=0;const p=P.tabSize||4;for(;E<w.length;){const f=w.charAt(E);if(f===" ")g++;else if(f==="	")g+=p;else break;E++}return Math.floor(g/p)}function R(w,P){for(let E=0;E<P.length;E++){const g=P.charAt(E);if(g==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=R;function b(w,P){return`\r
`.indexOf(w.charAt(P))!==-1}e.isEOL=b}),define(ne[68],ie([0,1,35,49]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(w,P,E){return _(w,P,void 0,E)}e.removeProperty=k;function _(w,P,E,g,p){const f=P.slice(),y=[],C=(0,L.parseTree)(w,y);let d,S;for(;f.length>0&&(S=f.pop(),d=(0,L.findNodeAtLocation)(C,f),d===void 0&&E!==void 0);)typeof S=="string"?E={[S]:E}:E=[E];if(d)if(d.type==="object"&&typeof S=="string"&&Array.isArray(d.children)){const m=(0,L.findNodeAtLocation)(d,[S]);if(m!==void 0)if(E===void 0){if(!m.parent)throw new Error("Malformed AST");const l=d.children.indexOf(m.parent);let u,r=m.parent.offset+m.parent.length;if(l>0){const a=d.children[l-1];u=a.offset+a.length}else u=d.offset+1,d.children.length>1&&(r=d.children[1].offset);return T(w,{offset:u,length:r-u,content:""},g)}else return T(w,{offset:m.offset,length:m.length,content:JSON.stringify(E)},g);else{if(E===void 0)return[];const l=`${JSON.stringify(S)}: ${JSON.stringify(E)}`,u=p?p(d.children.map(a=>a.children[0].value)):d.children.length;let r;if(u>0){const a=d.children[u-1];r={offset:a.offset+a.length,length:0,content:","+l}}else d.children.length===0?r={offset:d.offset+1,length:0,content:l}:r={offset:d.offset+1,length:0,content:l+","};return T(w,r,g)}}else if(d.type==="array"&&typeof S=="number"&&Array.isArray(d.children))if(E!==void 0){const m=`${JSON.stringify(E)}`;let l;if(d.children.length===0||S===0)l={offset:d.offset+1,length:0,content:d.children.length===0?m:m+","};else{const u=S===-1||S>d.children.length?d.children.length:S,r=d.children[u-1];l={offset:r.offset+r.length,length:0,content:","+m}}return T(w,l,g)}else{const m=S,l=d.children[m];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===m){const r=d.children[m-1],a=r.offset+r.length,i=d.offset+d.length;u={offset:a,length:i-2-a,content:""}}else u={offset:l.offset,length:d.children[m+1].offset-l.offset,content:""};return T(w,u,g)}else throw new Error(`Can not add ${typeof S!="number"?"index":"property"} to parent of type ${d.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return T(w,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(E)},g)}}e.setProperty=_;function T(w,P,E){let g=R(w,P),p=P.offset,f=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,n.isEOL)(g,p-1);)p--;for(;f<g.length&&!(0,n.isEOL)(g,f);)f++}const y=(0,n.format)(g,{offset:p,length:f-p},E);for(let d=y.length-1;d>=0;d--){const S=y[d];g=R(g,S),p=Math.min(p,S.offset),f=Math.max(f,S.offset+S.length),f+=S.content.length-S.length}const C=w.length-(g.length-f)-p;return[{offset:p,length:C,content:g.substring(p,f)}]}e.withFormatting=T;function R(w,P){return w.substring(0,P.offset)+P.content+w.substring(P.offset+P.length)}e.applyEdit=R;function b(w,P){let E=P.slice(0).sort((p,f)=>{const y=p.offset-f.offset;return y===0?p.length-f.length:y}),g=w.length;for(let p=E.length-1;p>=0;p--){let f=E[p];if(f.offset+f.length<=g)w=R(w,f);else throw new Error("Overlapping edit");g=f.offset}return w}e.applyEdits=b}),define(ne[99],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new L(()=>k(this.getValue()))}}e.Lazy=L}),define(ne[2],ie([0,1,67,54]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let _=null;function T(t){_=t}if(e.setDisposableTracker=T,k){const t="__is_disposable_tracked__";T(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==S.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==S.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return _?.trackDisposable(t),t}function b(t){_?.markAsDisposed(t)}function w(t,s){_?.setParent(t,s)}function P(t,s){if(!!_)for(const o of t)_.setParent(o,s)}function E(t){return _?.markAsSingleton(t),t}e.markAsSingleton=E;class g extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=g;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function f(t){if(n.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new g(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function y(...t){const s=C(()=>f(t));return P(t,s),s}e.combinedDisposable=y;function C(t){const s=R({dispose:(0,L.once)(()=>{b(s),t()})});return s}e.toDisposable=C;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return w(s,this),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class S{constructor(){this._store=new d,R(this),w(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=S,S.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&w(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&w(s,null),s}}e.MutableDisposable=m;class l{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class u{constructor(){this.references=new Map}acquire(s,...o){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,c));const{object:h}=c,v=(0,L.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:h,dispose:v}}}e.ReferenceCollection=u;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const c=this.referenceCollection.acquire(s,...o);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(h){throw c.dispose(),h}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function i(t){const s=new d;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=i}),define(ne[100],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(_){this.element=_,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class n{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let _=this._first;for(;_!==L.Undefined;){const T=_.next;_.prev=L.Undefined,_.next=L.Undefined,_=T}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,T){const R=new L(_);if(this._first===L.Undefined)this._first=R,this._last=R;else if(T){const w=this._last;this._last=R,R.prev=w,w.next=R}else{const w=this._first;this._first=R,R.next=w,w.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==L.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==L.Undefined&&_.next!==L.Undefined){const T=_.prev;T.next=_.next,_.next.prev=T}else _.prev===L.Undefined&&_.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):_.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):_.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==L.Undefined;)yield _.element,_=_.next}}e.LinkedList=n}),function(){function J(k){const _=[];typeof k=="number"&&_.push("code/timeOrigin",k);function T(b){_.push(b,Date.now())}function R(){const b=[];for(let w=0;w<_.length;w+=2)b.push({name:_[w],startTime:_[w+1]});return b}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const T of performance.getEntriesByType("mark"))_.push({name:T.name,startTime:Math.round(k+T.startTime)});return _}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=L(n))}(),define(ne[4],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const L="en";let n=!1,k=!1,_=!1,T=!1,R=!1,b=!1,w=!1,P=!1,E,g=L,p,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const C=typeof y?.versions?.electron=="string",d=C&&y?.type==="renderer";if(e.isElectronSandboxed=d&&y?.sandboxed,typeof navigator=="object"&&!d)f=navigator.userAgent,n=f.indexOf("Windows")>=0,k=f.indexOf("Macintosh")>=0,P=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=f.indexOf("Linux")>=0,b=!0,E=navigator.language,g=E;else if(typeof y=="object"){n=y.platform==="win32",k=y.platform==="darwin",_=y.platform==="linux",T=_&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,w=C,E=L,g=L;const s=y.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),c=o.availableLanguages["*"];E=o.locale,g=c||L,p=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var S;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function m(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let l=0;k?l=1:n?l=3:_&&(l=2),e.isWindows=n,e.isMacintosh=k,e.isLinux=_,e.isLinuxSnap=T,e.isNative=R,e.isElectron=w,e.isWeb=b,e.isIOS=P,e.platform=l,e.userAgent=f,e.language=g;var u;(function(s){function o(){return e.language}s.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function h(){return e.language==="en"}s.isDefault=h})(u=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=p,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let h=0,v=s.length;h<v;h++){const I=s[h];if(I.id===c.data.vscodeScheduleAsyncWork){s.splice(h,1),I.callback();return}}});let o=0;return c=>{const h=++o;s.push({id:h,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:h},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||P?2:n?1:3;let a=!0,i=!1;function t(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(ne[31],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.process!="undefined"){const k=L.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[9],ie([0,1,31]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,_=90,T=122,R=46,b=47,w=92,P=58,E=63;class g extends Error{constructor(l,u,r){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const i=l.indexOf(".")!==-1?"property":"argument";let t=`The "${l}" ${i} ${a} of type ${u}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function p(m,l){if(typeof m!="string")throw new g(l,"string",m)}function f(m){return m===b||m===w}function y(m){return m===b}function C(m){return m>=n&&m<=_||m>=k&&m<=T}function d(m,l,u,r){let a="",i=0,t=-1,s=0,o=0;for(let c=0;c<=m.length;++c){if(c<m.length)o=m.charCodeAt(c);else{if(r(o))break;o=b}if(r(o)){if(!(t===c-1||s===1))if(s===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const h=a.lastIndexOf(u);h===-1?(a="",i=0):(a=a.slice(0,h),i=a.length-1-a.lastIndexOf(u)),t=c,s=0;continue}else if(a.length!==0){a="",i=0,t=c,s=0;continue}}l&&(a+=a.length>0?`${u}..`:"..",i=2)}else a.length>0?a+=`${u}${m.slice(t+1,c)}`:a=m.slice(t+1,c),i=c-t-1;t=c,s=0}else o===R&&s!==-1?++s:s=-1}return a}function S(m,l){if(l===null||typeof l!="object")throw new g("pathObject","Object",l);const u=l.dir||l.root,r=l.base||`${l.name||""}${l.ext||""}`;return u?u===l.root?`${u}${r}`:`${u}${m}${r}`:r}e.win32={resolve(...m){let l="",u="",r=!1;for(let a=m.length-1;a>=-1;a--){let i;if(a>=0){if(i=m[a],p(i,"path"),i.length===0)continue}else l.length===0?i=L.cwd():(i=L.env[`=${l}`]||L.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==l.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${l}\\`));const t=i.length;let s=0,o="",c=!1;const h=i.charCodeAt(0);if(t===1)f(h)&&(s=1,c=!0);else if(f(h))if(c=!0,f(i.charCodeAt(1))){let v=2,I=v;for(;v<t&&!f(i.charCodeAt(v));)v++;if(v<t&&v!==I){const A=i.slice(I,v);for(I=v;v<t&&f(i.charCodeAt(v));)v++;if(v<t&&v!==I){for(I=v;v<t&&!f(i.charCodeAt(v));)v++;(v===t||v!==I)&&(o=`\\\\${A}\\${i.slice(I,v)}`,s=v)}}}else s=1;else C(h)&&i.charCodeAt(1)===P&&(o=i.slice(0,2),s=2,t>2&&f(i.charCodeAt(2))&&(c=!0,s=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(r){if(l.length>0)break}else if(u=`${i.slice(s)}\\${u}`,r=c,c&&l.length>0)break}return u=d(u,!r,"\\",f),r?`${l}\\${u}`:`${l}${u}`||"."},normalize(m){p(m,"path");const l=m.length;if(l===0)return".";let u=0,r,a=!1;const i=m.charCodeAt(0);if(l===1)return y(i)?"\\":m;if(f(i))if(a=!0,f(m.charCodeAt(1))){let s=2,o=s;for(;s<l&&!f(m.charCodeAt(s));)s++;if(s<l&&s!==o){const c=m.slice(o,s);for(o=s;s<l&&f(m.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!f(m.charCodeAt(s));)s++;if(s===l)return`\\\\${c}\\${m.slice(o)}\\`;s!==o&&(r=`\\\\${c}\\${m.slice(o,s)}`,u=s)}}}else u=1;else C(i)&&m.charCodeAt(1)===P&&(r=m.slice(0,2),u=2,l>2&&f(m.charCodeAt(2))&&(a=!0,u=3));let t=u<l?d(m.slice(u),!a,"\\",f):"";return t.length===0&&!a&&(t="."),t.length>0&&f(m.charCodeAt(l-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(m){p(m,"path");const l=m.length;if(l===0)return!1;const u=m.charCodeAt(0);return f(u)||l>2&&C(u)&&m.charCodeAt(1)===P&&f(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let l,u;for(let i=0;i<m.length;++i){const t=m[i];p(t,"path"),t.length>0&&(l===void 0?l=u=t:l+=`\\${t}`)}if(l===void 0)return".";let r=!0,a=0;if(typeof u=="string"&&f(u.charCodeAt(0))){++a;const i=u.length;i>1&&f(u.charCodeAt(1))&&(++a,i>2&&(f(u.charCodeAt(2))?++a:r=!1))}if(r){for(;a<l.length&&f(l.charCodeAt(a));)a++;a>=2&&(l=`\\${l.slice(a)}`)}return e.win32.normalize(l)},relative(m,l){if(p(m,"from"),p(l,"to"),m===l)return"";const u=e.win32.resolve(m),r=e.win32.resolve(l);if(u===r||(m=u.toLowerCase(),l=r.toLowerCase(),m===l))return"";let a=0;for(;a<m.length&&m.charCodeAt(a)===w;)a++;let i=m.length;for(;i-1>a&&m.charCodeAt(i-1)===w;)i--;const t=i-a;let s=0;for(;s<l.length&&l.charCodeAt(s)===w;)s++;let o=l.length;for(;o-1>s&&l.charCodeAt(o-1)===w;)o--;const c=o-s,h=t<c?t:c;let v=-1,I=0;for(;I<h;I++){const O=m.charCodeAt(a+I);if(O!==l.charCodeAt(s+I))break;O===w&&(v=I)}if(I!==h){if(v===-1)return r}else{if(c>h){if(l.charCodeAt(s+I)===w)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>h&&(m.charCodeAt(a+I)===w?v=I:I===2&&(v=3)),v===-1&&(v=0)}let A="";for(I=a+v+1;I<=i;++I)(I===i||m.charCodeAt(I)===w)&&(A+=A.length===0?"..":"\\..");return s+=v,A.length>0?`${A}${r.slice(s,o)}`:(r.charCodeAt(s)===w&&++s,r.slice(s,o))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const l=e.win32.resolve(m);if(l.length<=2)return m;if(l.charCodeAt(0)===w){if(l.charCodeAt(1)===w){const u=l.charCodeAt(2);if(u!==E&&u!==R)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(C(l.charCodeAt(0))&&l.charCodeAt(1)===P&&l.charCodeAt(2)===w)return`\\\\?\\${l}`;return m},dirname(m){p(m,"path");const l=m.length;if(l===0)return".";let u=-1,r=0;const a=m.charCodeAt(0);if(l===1)return f(a)?m:".";if(f(a)){if(u=r=1,f(m.charCodeAt(1))){let s=2,o=s;for(;s<l&&!f(m.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&f(m.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!f(m.charCodeAt(s));)s++;if(s===l)return m;s!==o&&(u=r=s+1)}}}}else C(a)&&m.charCodeAt(1)===P&&(u=l>2&&f(m.charCodeAt(2))?3:2,r=u);let i=-1,t=!0;for(let s=l-1;s>=r;--s)if(f(m.charCodeAt(s))){if(!t){i=s;break}}else t=!1;if(i===-1){if(u===-1)return".";i=u}return m.slice(0,i)},basename(m,l){l!==void 0&&p(l,"ext"),p(m,"path");let u=0,r=-1,a=!0,i;if(m.length>=2&&C(m.charCodeAt(0))&&m.charCodeAt(1)===P&&(u=2),l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let t=l.length-1,s=-1;for(i=m.length-1;i>=u;--i){const o=m.charCodeAt(i);if(f(o)){if(!a){u=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=m.length),m.slice(u,r)}for(i=m.length-1;i>=u;--i)if(f(m.charCodeAt(i))){if(!a){u=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":m.slice(u,r)},extname(m){p(m,"path");let l=0,u=-1,r=0,a=-1,i=!0,t=0;m.length>=2&&m.charCodeAt(1)===P&&C(m.charCodeAt(0))&&(l=r=2);for(let s=m.length-1;s>=l;--s){const o=m.charCodeAt(s);if(f(o)){if(!i){r=s+1;break}continue}a===-1&&(i=!1,a=s+1),o===R?u===-1?u=s:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||a===-1||t===0||t===1&&u===a-1&&u===r+1?"":m.slice(u,a)},format:S.bind(null,"\\"),parse(m){p(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const u=m.length;let r=0,a=m.charCodeAt(0);if(u===1)return f(a)?(l.root=l.dir=m,l):(l.base=l.name=m,l);if(f(a)){if(r=1,f(m.charCodeAt(1))){let v=2,I=v;for(;v<u&&!f(m.charCodeAt(v));)v++;if(v<u&&v!==I){for(I=v;v<u&&f(m.charCodeAt(v));)v++;if(v<u&&v!==I){for(I=v;v<u&&!f(m.charCodeAt(v));)v++;v===u?r=v:v!==I&&(r=v+1)}}}}else if(C(a)&&m.charCodeAt(1)===P){if(u<=2)return l.root=l.dir=m,l;if(r=2,f(m.charCodeAt(2))){if(u===3)return l.root=l.dir=m,l;r=3}}r>0&&(l.root=m.slice(0,r));let i=-1,t=r,s=-1,o=!0,c=m.length-1,h=0;for(;c>=r;--c){if(a=m.charCodeAt(c),f(a)){if(!o){t=c+1;break}continue}s===-1&&(o=!1,s=c+1),a===R?i===-1?i=c:h!==1&&(h=1):i!==-1&&(h=-1)}return s!==-1&&(i===-1||h===0||h===1&&i===s-1&&i===t+1?l.base=l.name=m.slice(t,s):(l.name=m.slice(t,i),l.base=m.slice(t,s),l.ext=m.slice(i,s))),t>0&&t!==r?l.dir=m.slice(0,t-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let l="",u=!1;for(let r=m.length-1;r>=-1&&!u;r--){const a=r>=0?m[r]:L.cwd();p(a,"path"),a.length!==0&&(l=`${a}/${l}`,u=a.charCodeAt(0)===b)}return l=d(l,!u,"/",y),u?`/${l}`:l.length>0?l:"."},normalize(m){if(p(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===b,u=m.charCodeAt(m.length-1)===b;return m=d(m,!l,"/",y),m.length===0?l?"/":u?"./":".":(u&&(m+="/"),l?`/${m}`:m)},isAbsolute(m){return p(m,"path"),m.length>0&&m.charCodeAt(0)===b},join(...m){if(m.length===0)return".";let l;for(let u=0;u<m.length;++u){const r=m[u];p(r,"path"),r.length>0&&(l===void 0?l=r:l+=`/${r}`)}return l===void 0?".":e.posix.normalize(l)},relative(m,l){if(p(m,"from"),p(l,"to"),m===l||(m=e.posix.resolve(m),l=e.posix.resolve(l),m===l))return"";const u=1,r=m.length,a=r-u,i=1,t=l.length-i,s=a<t?a:t;let o=-1,c=0;for(;c<s;c++){const v=m.charCodeAt(u+c);if(v!==l.charCodeAt(i+c))break;v===b&&(o=c)}if(c===s)if(t>s){if(l.charCodeAt(i+c)===b)return l.slice(i+c+1);if(c===0)return l.slice(i+c)}else a>s&&(m.charCodeAt(u+c)===b?o=c:c===0&&(o=0));let h="";for(c=u+o+1;c<=r;++c)(c===r||m.charCodeAt(c)===b)&&(h+=h.length===0?"..":"/..");return`${h}${l.slice(i+o)}`},toNamespacedPath(m){return m},dirname(m){if(p(m,"path"),m.length===0)return".";const l=m.charCodeAt(0)===b;let u=-1,r=!0;for(let a=m.length-1;a>=1;--a)if(m.charCodeAt(a)===b){if(!r){u=a;break}}else r=!1;return u===-1?l?"/":".":l&&u===1?"//":m.slice(0,u)},basename(m,l){l!==void 0&&p(l,"ext"),p(m,"path");let u=0,r=-1,a=!0,i;if(l!==void 0&&l.length>0&&l.length<=m.length){if(l===m)return"";let t=l.length-1,s=-1;for(i=m.length-1;i>=0;--i){const o=m.charCodeAt(i);if(o===b){if(!a){u=i+1;break}}else s===-1&&(a=!1,s=i+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=m.length),m.slice(u,r)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===b){if(!a){u=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":m.slice(u,r)},extname(m){p(m,"path");let l=-1,u=0,r=-1,a=!0,i=0;for(let t=m.length-1;t>=0;--t){const s=m.charCodeAt(t);if(s===b){if(!a){u=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?l===-1?l=t:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||r===-1||i===0||i===1&&l===r-1&&l===u+1?"":m.slice(l,r)},format:S.bind(null,"/"),parse(m){p(m,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return l;const u=m.charCodeAt(0)===b;let r;u?(l.root="/",r=1):r=0;let a=-1,i=0,t=-1,s=!0,o=m.length-1,c=0;for(;o>=r;--o){const h=m.charCodeAt(o);if(h===b){if(!s){i=o+1;break}continue}t===-1&&(s=!1,t=o+1),h===R?a===-1?a=o:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const h=i===0&&u?1:i;a===-1||c===0||c===1&&a===t-1&&a===i+1?l.base=l.name=m.slice(h,t):(l.name=m.slice(h,a),l.base=m.slice(h,t),l.ext=m.slice(a,t))}return i>0?l.dir=m.slice(0,i-1):u&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=L.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=L.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=L.platform==="win32"?e.win32.join:e.posix.join,e.resolve=L.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=L.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=L.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=L.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=L.platform==="win32"?e.win32.extname:e.posix.extname,e.format=L.platform==="win32"?e.win32.format:e.posix.format,e.parse=L.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=L.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=L.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=L.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[101],ie([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(E){const g=(0,L.extname)(E),p=k[g.toLowerCase()];return p!==void 0?p:R(E)}e.getMediaOrTextMime=T;function R(E){const g=(0,L.extname)(E);return _[g.toLowerCase()]}e.getMediaMime=R;function b(E){for(const g in _)if(_[g]===E)return g}e.getExtensionForMimeType=b;const w=/^(.+)\/(.+?)(;.+)?$/;function P(E,g){const p=w.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:g?void 0:E}e.normalizeMimeType=P}),define(ne[102],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var n;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(_,...T){const R=T.reduce((P,E)=>(P[E]=!0,P),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(P=>!R[P]).forEach(P=>{for(let E=0;E<b.length;E++)if(P.search(b[E])!==-1){delete _[P];break}})}e.sanitizeProcessEnvironment=k}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var n in L)(typeof exports=="object"?exports:J)[n]=L[n]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function L(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return J[n].call(k.exports,k,k.exports,L),k.l=!0,k.exports}return L.m=J,L.c=e,L.d=function(n,k,_){L.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:_})},L.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},L.t=function(n,k){if(1&k&&(n=L(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var _=Object.create(null);if(L.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var T in n)L.d(_,T,function(R){return n[R]}.bind(null,T));return _},L.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return L.d(k,"a",k),k},L.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},L.p="",L(L.s=0)}([function(J,e,L){(function(n){var k;e=J.exports=j,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],w=0,P=w++;b[P]="0|[1-9]\\d*";var E=w++;b[E]="[0-9]+";var g=w++;b[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;b[p]="("+b[P]+")\\.("+b[P]+")\\.("+b[P]+")";var f=w++;b[f]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var y=w++;b[y]="(?:"+b[P]+"|"+b[g]+")";var C=w++;b[C]="(?:"+b[E]+"|"+b[g]+")";var d=w++;b[d]="(?:-("+b[y]+"(?:\\."+b[y]+")*))";var S=w++;b[S]="(?:-?("+b[C]+"(?:\\."+b[C]+")*))";var m=w++;b[m]="[0-9A-Za-z-]+";var l=w++;b[l]="(?:\\+("+b[m]+"(?:\\."+b[m]+")*))";var u=w++,r="v?"+b[p]+b[d]+"?"+b[l]+"?";b[u]="^"+r+"$";var a="[v=\\s]*"+b[f]+b[S]+"?"+b[l]+"?",i=w++;b[i]="^"+a+"$";var t=w++;b[t]="((?:<|>)?=?)";var s=w++;b[s]=b[E]+"|x|X|\\*";var o=w++;b[o]=b[P]+"|x|X|\\*";var c=w++;b[c]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[d]+")?"+b[l]+"?)?)?";var h=w++;b[h]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[S]+")?"+b[l]+"?)?)?";var v=w++;b[v]="^"+b[t]+"\\s*"+b[c]+"$";var I=w++;b[I]="^"+b[t]+"\\s*"+b[h]+"$";var A=w++;b[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;b[O]="(?:~>?)";var N=w++;b[N]="(\\s*)"+b[O]+"\\s+",R[N]=new RegExp(b[N],"g");var $=w++;b[$]="^"+b[O]+b[c]+"$";var D=w++;b[D]="^"+b[O]+b[h]+"$";var M=w++;b[M]="(?:\\^)";var z=w++;b[z]="(\\s*)"+b[M]+"\\s+",R[z]=new RegExp(b[z],"g");var U=w++;b[U]="^"+b[M]+b[c]+"$";var V=w++;b[V]="^"+b[M]+b[h]+"$";var Y=w++;b[Y]="^"+b[t]+"\\s*("+a+")$|^$";var B=w++;b[B]="^"+b[t]+"\\s*("+r+")$|^$";var q=w++;b[q]="(\\s*)"+b[t]+"\\s*("+a+"|"+b[c]+")",R[q]=new RegExp(b[q],"g");var X=w++;b[X]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var G=w++;b[G]="^\\s*("+b[h]+")\\s+-\\s+("+b[h]+")\\s*$";var ee=w++;b[ee]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)k(K,b[K]),R[K]||(R[K]=new RegExp(b[K]));function F(te,ae){if(te instanceof j)return te;if(typeof te!="string"||te.length>_||!(ae?R[i]:R[u]).test(te))return null;try{return new j(te,ae)}catch{return null}}function j(te,ae){if(te instanceof j){if(te.loose===ae)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof j))return new j(te,ae);k("SemVer",te,ae),this.loose=ae;var ue=te.trim().match(ae?R[i]:R[u]);if(!ue)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<T)return Ce}return be}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=F,e.valid=function(te,ae){var ue=F(te,ae);return ue?ue.version:null},e.clean=function(te,ae){var ue=F(te.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(te){return k("SemVer.compare",this.version,this.loose,te),te instanceof j||(te=new j(te,this.loose)),this.compareMain(te)||this.comparePre(te)},j.prototype.compareMain=function(te){return te instanceof j||(te=new j(te,this.loose)),W(this.major,te.major)||W(this.minor,te.minor)||W(this.patch,te.patch)},j.prototype.comparePre=function(te){if(te instanceof j||(te=new j(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],be=te.prerelease[ae];if(k("prerelease compare",ae,ue,be),ue===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ue===void 0)return-1;if(ue!==be)return W(ue,be)}while(++ae)},j.prototype.inc=function(te,ae){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,ae,ue,be){typeof ue=="string"&&(be=ue,ue=void 0);try{return new j(te,ue).inc(ae,be).version}catch{return null}},e.diff=function(te,ae){if(ce(te,ae))return null;var ue=F(te),be=F(ae);if(ue.prerelease.length||be.prerelease.length){for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return Ce},e.compareIdentifiers=W;var H=/^[0-9]+$/;function W(te,ae){var ue=H.test(te),be=H.test(ae);return ue&&be&&(te=+te,ae=+ae),ue&&!be?-1:be&&!ue?1:te<ae?-1:te>ae?1:0}function x(te,ae,ue){return new j(te,ue).compare(new j(ae,ue))}function re(te,ae,ue){return x(te,ae,ue)>0}function se(te,ae,ue){return x(te,ae,ue)<0}function ce(te,ae,ue){return x(te,ae,ue)===0}function he(te,ae,ue){return x(te,ae,ue)!==0}function Se(te,ae,ue){return x(te,ae,ue)>=0}function ge(te,ae,ue){return x(te,ae,ue)<=0}function ye(te,ae,ue,be){var Ce;switch(ae){case"===":typeof te=="object"&&(te=te.version),typeof ue=="object"&&(ue=ue.version),Ce=te===ue;break;case"!==":typeof te=="object"&&(te=te.version),typeof ue=="object"&&(ue=ue.version),Ce=te!==ue;break;case"":case"=":case"==":Ce=ce(te,ue,be);break;case"!=":Ce=he(te,ue,be);break;case">":Ce=re(te,ue,be);break;case">=":Ce=Se(te,ue,be);break;case"<":Ce=se(te,ue,be);break;case"<=":Ce=ge(te,ue,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function pe(te,ae){if(te instanceof pe){if(te.loose===ae)return te;te=te.value}if(!(this instanceof pe))return new pe(te,ae);k("comparator",te,ae),this.loose=ae,this.parse(te),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(te,ae){return W(ae,te)},e.major=function(te,ae){return new j(te,ae).major},e.minor=function(te,ae){return new j(te,ae).minor},e.patch=function(te,ae){return new j(te,ae).patch},e.compare=x,e.compareLoose=function(te,ae){return x(te,ae,!0)},e.rcompare=function(te,ae,ue){return x(ae,te,ue)},e.sort=function(te,ae){return te.sort(function(ue,be){return e.compare(ue,be,ae)})},e.rsort=function(te,ae){return te.sort(function(ue,be){return e.rcompare(ue,be,ae)})},e.gt=re,e.lt=se,e.eq=ce,e.neq=he,e.gte=Se,e.lte=ge,e.cmp=ye,e.Comparator=pe;var Ie={};function Ee(te,ae){if(te instanceof Ee)return te.loose===ae?te:new Ee(te.raw,ae);if(te instanceof pe)return new Ee(te.value,ae);if(!(this instanceof Ee))return new Ee(te,ae);if(this.loose=ae,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function De(te){return!te||te.toLowerCase()==="x"||te==="*"}function Fe(te,ae,ue,be,Ce,$e,Le,Oe,Ae,Z,oe,le,fe){return((ae=De(ue)?"":De(be)?">="+ue+".0.0":De(Ce)?">="+ue+"."+be+".0":">="+ae)+" "+(Oe=De(Ae)?"":De(Z)?"<"+(+Ae+1)+".0.0":De(oe)?"<"+Ae+"."+(+Z+1)+".0":le?"<="+Ae+"."+Z+"."+oe+"-"+le:"<="+Oe)).trim()}function Ue(te,ae){for(var ue=0;ue<te.length;ue++)if(!te[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<te.length;ue++)if(k(te[ue].semver),te[ue].semver!==Ie&&te[ue].semver.prerelease.length>0){var be=te[ue].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function Ne(te,ae,ue){try{ae=new Ee(ae,ue)}catch{return!1}return ae.test(te)}function ze(te,ae,ue,be){var Ce,$e,Le,Oe,Ae;switch(te=new j(te,be),ae=new Ee(ae,be),ue){case">":Ce=re,$e=ge,Le=se,Oe=">",Ae=">=";break;case"<":Ce=se,$e=Se,Le=re,Oe="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(te,ae,be))return!1;for(var Z=0;Z<ae.set.length;++Z){var oe=ae.set[Z],le=null,fe=null;if(oe.forEach(function(me){me.semver===Ie&&(me=new pe(">=0.0.0")),le=le||me,fe=fe||me,Ce(me.semver,le.semver,be)?le=me:Le(me.semver,fe.semver,be)&&(fe=me)}),le.operator===Oe||le.operator===Ae||(!fe.operator||fe.operator===Oe)&&$e(te,fe.semver)||fe.operator===Ae&&Le(te,fe.semver))return!1}return!0}pe.prototype.parse=function(te){var ae=this.loose?R[Y]:R[B],ue=te.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+te);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new j(ue[2],this.loose):this.semver=Ie},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(te){return k("Comparator.test",te,this.loose),this.semver===Ie||(typeof te=="string"&&(te=new j(te,this.loose)),ye(te,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(te,ae){if(!(te instanceof pe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ee(te.value,ae),Ne(this.value,ue,ae);if(te.operator==="")return ue=new Ee(this.value,ae),Ne(te.semver,ue,ae);var be=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),$e=this.semver.version===te.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),Oe=ye(this.semver,"<",te.semver,ae)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),Ae=ye(this.semver,">",te.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return be||Ce||$e&&Le||Oe||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(te){var ae=this.loose;te=te.trim(),k("range",te,ae);var ue=ae?R[G]:R[X];te=te.replace(ue,Fe),k("hyphen replace",te),te=te.replace(R[q],"$1$2$3"),k("comparator trim",te,R[q]),te=(te=(te=te.replace(R[N],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var be=ae?R[Y]:R[B],Ce=te.split(" ").map(function($e){return function(Le,Oe){return k("comp",Le),Le=function(Ae,Z){return Ae.trim().split(/\s+/).map(function(oe){return function(le,fe){k("caret",le,fe);var me=fe?R[V]:R[U];return le.replace(me,function(Te,we,Re,ke,Pe){var _e;return k("caret",le,Te,we,Re,ke,Pe),De(we)?_e="":De(Re)?_e=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?_e=we==="0"?">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+".0 <"+(+we+1)+".0.0":Pe?(k("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),_e=we==="0"?Re==="0"?">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+Re+"."+(+ke+1):">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+"."+ke+Pe+" <"+(+we+1)+".0.0"):(k("no pr"),_e=we==="0"?Re==="0"?">="+we+"."+Re+"."+ke+" <"+we+"."+Re+"."+(+ke+1):">="+we+"."+Re+"."+ke+" <"+we+"."+(+Re+1)+".0":">="+we+"."+Re+"."+ke+" <"+(+we+1)+".0.0"),k("caret return",_e),_e})}(oe,Z)}).join(" ")}(Le,Oe),k("caret",Le),Le=function(Ae,Z){return Ae.trim().split(/\s+/).map(function(oe){return function(le,fe){var me=fe?R[D]:R[$];return le.replace(me,function(Te,we,Re,ke,Pe){var _e;return k("tilde",le,Te,we,Re,ke,Pe),De(we)?_e="":De(Re)?_e=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?_e=">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0":Pe?(k("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),_e=">="+we+"."+Re+"."+ke+Pe+" <"+we+"."+(+Re+1)+".0"):_e=">="+we+"."+Re+"."+ke+" <"+we+"."+(+Re+1)+".0",k("tilde return",_e),_e})}(oe,Z)}).join(" ")}(Le,Oe),k("tildes",Le),Le=function(Ae,Z){return k("replaceXRanges",Ae,Z),Ae.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var me=fe?R[I]:R[v];return le.replace(me,function(Te,we,Re,ke,Pe,_e){k("xRange",le,Te,we,Re,ke,Pe,_e);var We=De(Re),Be=We||De(ke),xe=Be||De(Pe);return we==="="&&xe&&(we=""),We?Te=we===">"||we==="<"?"<0.0.0":"*":we&&xe?(Be&&(ke=0),xe&&(Pe=0),we===">"?(we=">=",Be?(Re=+Re+1,ke=0,Pe=0):xe&&(ke=+ke+1,Pe=0)):we==="<="&&(we="<",Be?Re=+Re+1:ke=+ke+1),Te=we+Re+"."+ke+"."+Pe):Be?Te=">="+Re+".0.0 <"+(+Re+1)+".0.0":xe&&(Te=">="+Re+"."+ke+".0 <"+Re+"."+(+ke+1)+".0"),k("xRange return",Te),Te})}(oe,Z)}).join(" ")}(Le,Oe),k("xrange",Le),Le=function(Ae,Z){return k("replaceStars",Ae,Z),Ae.trim().replace(R[ee],"")}(Le,Oe),k("stars",Le),Le}($e,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function($e){return!!$e.match(be)})),Ce=Ce.map(function($e){return new pe($e,ae)})},Ee.prototype.intersects=function(te,ae){if(!(te instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(be){return te.set.some(function(Ce){return Ce.every(function($e){return be.intersects($e,ae)})})})})},e.toComparators=function(te,ae){return new Ee(te,ae).set.map(function(ue){return ue.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new j(te,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ue(this.set[ae],te))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(te,ae,ue){var be=null,Ce=null;try{var $e=new Ee(ae,ue)}catch{return null}return te.forEach(function(Le){$e.test(Le)&&(be&&Ce.compare(Le)!==-1||(Ce=new j(be=Le,ue)))}),be},e.minSatisfying=function(te,ae,ue){var be=null,Ce=null;try{var $e=new Ee(ae,ue)}catch{return null}return te.forEach(function(Le){$e.test(Le)&&(be&&Ce.compare(Le)!==1||(Ce=new j(be=Le,ue)))}),be},e.validRange=function(te,ae){try{return new Ee(te,ae).range||"*"}catch{return null}},e.ltr=function(te,ae,ue){return ze(te,ae,"<",ue)},e.gtr=function(te,ae,ue){return ze(te,ae,">",ue)},e.outside=ze,e.prerelease=function(te,ae){var ue=F(te,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(te,ae,ue){return te=new Ee(te,ue),ae=new Ee(ae,ue),te.intersects(ae)},e.coerce=function(te){if(te instanceof j)return te;if(typeof te!="string")return null;var ae=te.match(R[A]);return ae==null?null:F((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,L(1))},function(J,e){var L,n,k=J.exports={};function _(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(C){if(L===setTimeout)return setTimeout(C,0);if((L===_||!L)&&setTimeout)return L=setTimeout,setTimeout(C,0);try{return L(C,0)}catch{try{return L.call(null,C,0)}catch{return L.call(this,C,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:_}catch{L=_}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var b,w=[],P=!1,E=-1;function g(){P&&b&&(P=!1,b.length?w=b.concat(w):E=-1,w.length&&p())}function p(){if(!P){var C=R(g);P=!0;for(var d=w.length;d;){for(b=w,w=[];++E<d;)b&&b[E].run();E=-1,d=w.length}b=null,P=!1,function(S){if(n===clearTimeout)return clearTimeout(S);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(S);try{n(S)}catch{try{return n.call(null,S)}catch{return n.call(this,S)}}}(C)}}function f(C,d){this.fun=C,this.array=d}function y(){}k.nextTick=function(C){var d=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)d[S-1]=arguments[S];w.push(new f(C,d)),w.length!==1||P||R(p)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[103],ie([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,b,w){this.level=R,this.key=b,this.value=w,this.forward=[]}}const k=void 0;class _{constructor(R,b=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(R){return Boolean(_._search(this,R,this.comparator))}get(R){return _._search(this,R,this.comparator)?.value}set(R,b){return _._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=_._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let w=this._header.forward[0];for(;w;)R.call(b,w.value,w.key,this),w=w.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,w){let P=R._header;for(let E=R._level-1;E>=0;E--)for(;P.forward[E]&&w(P.forward[E].key,b)<0;)P=P.forward[E];if(P=P.forward[0],P&&w(P.key,b)===0)return P}static _insert(R,b,w,P){let E=[],g=R._header;for(let p=R._level-1;p>=0;p--){for(;g.forward[p]&&P(g.forward[p].key,b)<0;)g=g.forward[p];E[p]=g}if(g=g.forward[0],g&&P(g.key,b)===0)return g.value=w,!1;{let p=_._randomLevel(R);if(p>R._level){for(let f=R._level;f<p;f++)E[f]=R._header;R._level=p}g=new n(p,b,w);for(let f=0;f<p;f++)g.forward[f]=E[f].forward[f],E[f].forward[f]=g;return!0}}static _randomLevel(R,b=.5){let w=1;for(;Math.random()<b&&w<R._maxLevel;)w+=1;return w}static _delete(R,b,w){let P=[],E=R._header;for(let g=R._level-1;g>=0;g--){for(;E.forward[g]&&w(E.forward[g].key,b)<0;)E=E.forward[g];P[g]=E}if(E=E.forward[0],!E||w(E.key,b)!==0)return!1;for(let g=0;g<R._level&&P[g].forward[g]===E;g++)P[g].forward[g]=E.forward[g];for(;R._level>0&&R._header.forward[R._level-1]===k;)R._level-=1;return!0}}e.SkipList=_}),define(ne[104],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=L.globals.performance&&typeof L.globals.performance.now=="function";class k{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new k(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],ie([0,1,8,67,2,100,104]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(l){l.None=()=>k.Disposable.None;function u(Y){return(B,q=null,X)=>{let G=!1,ee;return ee=Y(K=>{if(!G)return ee?ee.dispose():G=!0,B.call(q,K)},null,X),G&&ee.dispose(),ee}}l.once=u;function r(Y,B){return c((q,X=null,G)=>Y(ee=>q.call(X,B(ee)),null,G))}l.map=r;function a(Y,B){return c((q,X=null,G)=>Y(ee=>{B(ee),q.call(X,ee)},null,G))}l.forEach=a;function i(Y,B){return c((q,X=null,G)=>Y(ee=>B(ee)&&q.call(X,ee),null,G))}l.filter=i;function t(Y){return Y}l.signal=t;function s(...Y){return(B,q=null,X)=>(0,k.combinedDisposable)(...Y.map(G=>G(ee=>B.call(q,ee),null,X)))}l.any=s;function o(Y,B,q){let X=q;return r(Y,G=>(X=B(X,G),X))}l.reduce=o;function c(Y){let B;const q=new g({onFirstListenerAdd(){B=Y(q.fire,q)},onLastListenerRemove(){B.dispose()}});return q.event}function h(Y,B,q,X=100,G=!1){let ee,K,F=0;return Y(j=>{F++,ee=q(ee,j),G&&!K&&(B(ee),ee=void 0),clearTimeout(K),K=setTimeout(()=>{const H=ee;ee=void 0,K=void 0,(!G||F>1)&&B(H),F=0},X)})}l.debouncedListener=h;function v(Y,B,q=100,X=!1,G){let ee,K,F,j=0;const H=new g({leakWarningThreshold:G,onFirstListenerAdd(){ee=Y(W=>{j++,K=B(K,W),X&&!F&&(H.fire(K),K=void 0),clearTimeout(F),F=setTimeout(()=>{const x=K;K=void 0,F=void 0,(!X||j>1)&&H.fire(x),j=0},q)})},onLastListenerRemove(){ee.dispose()}});return H.event}l.debounce=v;function I(Y,B=(q,X)=>q===X){let q=!0,X;return i(Y,G=>{const ee=q||!B(G,X);return q=!1,X=G,ee})}l.latch=I;function A(Y,B){return[l.filter(Y,B),l.filter(Y,q=>!B(q))]}l.split=A;function O(Y,B=!1,q=[]){let X=q.slice(),G=Y(F=>{X?X.push(F):K.fire(F)});const ee=()=>{X&&X.forEach(F=>K.fire(F)),X=null},K=new g({onFirstListenerAdd(){G||(G=Y(F=>K.fire(F)))},onFirstListenerDidAdd(){X&&(B?setTimeout(ee):ee())},onLastListenerRemove(){G&&G.dispose(),G=null}});return K.event}l.buffer=O;class N{constructor(B){this.event=B}map(B){return new N(r(this.event,B))}forEach(B){return new N(a(this.event,B))}filter(B){return new N(i(this.event,B))}reduce(B,q){return new N(o(this.event,B,q))}latch(){return new N(I(this.event))}debounce(B,q=100,X=!1,G){return new N(v(this.event,B,q,X,G))}on(B,q,X){return this.event(B,q,X)}once(B,q,X){return u(this.event)(B,q,X)}}function $(Y){return new N(Y)}l.chain=$;function D(Y,B,q=X=>X){const X=(...F)=>K.fire(q(...F)),G=()=>Y.on(B,X),ee=()=>Y.removeListener(B,X),K=new g({onFirstListenerAdd:G,onLastListenerRemove:ee});return K.event}l.fromNodeEventEmitter=D;function M(Y,B,q=X=>X){const X=(...F)=>K.fire(q(...F)),G=()=>Y.addEventListener(B,X),ee=()=>Y.removeEventListener(B,X),K=new g({onFirstListenerAdd:G,onLastListenerRemove:ee});return K.event}l.fromDOMEventEmitter=M;function z(Y){return new Promise(B=>u(Y)(B))}l.toPromise=z;function U(Y,B){return B(void 0),Y(q=>B(q))}l.runAndSubscribe=U;function V(Y,B){let q=null;function X(ee){q?.dispose(),q=new k.DisposableStore,B(ee,q)}X(void 0);const G=Y(ee=>X(ee));return(0,k.toDisposable)(()=>{G.dispose(),q?.dispose()})}l.runAndSubscribeWithStore=V})(R=e.Event||(e.Event={}));class b{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${b._idPool++}`}start(u){this._stopWatch=new T.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let w=-1;function P(l){const u=w;return w=l,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=P;class E{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=w;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,c]of this._stacks)(!t||s<c)&&(t=o,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class g{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,a)=>{this._listeners||(this._listeners=new _.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[u,r]:u);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof k.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(i){(0,L.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class p extends g{async fireAsync(u,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof i=="function"?i:i[0])),s.push(c)}};try{typeof i=="function"?i.call(void 0,o):i[0].call(i[1],o)}catch(c){(0,L.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const h of c)h.status==="rejected"&&(0,L.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=p;class f extends g{constructor(u){super(u);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=f;class y extends f{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=y;class C extends g{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=C;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,k.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class S{constructor(){this.buffers=[]}wrapEvent(u){return(r,a,i)=>u(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,i)}bufferEvents(u){const r=[];this.buffers.push(r);const a=u();return this.buffers.pop(),r.forEach(i=>i()),a}}e.EventBufferer=S;class m{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=k.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=m}),define(ne[25],ie([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,b){const w=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(w)}}});var k;(function(R){function b(w){return w===R.None||w===R.Cancelled||w instanceof _?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=k.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=T}),define(ne[105],ie([0,1,25]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new L.CancellationTokenSource,R=this.task(T.token);return this.result={promise:R,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=n;class k{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const R=JSON.stringify(T);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=k}),define(ne[40],ie([0,1,8,2]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(m){const l=m;return l?[l.on,l.pause,l.resume,l.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=k;function _(m){const l=m;return l?k(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=_;function T(m,l){return new R(m,l)}e.newWriteableStream=T;class R{constructor(l,u){this.reducer=l,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(u=>u(l))}emitError(l){this.listeners.error.length===0?(0,L.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(u=>u(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,u){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(l,u){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(u);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(m,l){const u=[];let r;for(;(r=m.read())!==null;)u.push(r);return l(u)}e.consumeReadable=b;function w(m,l,u){const r=[];let a;for(;(a=m.read())!==null&&r.length<u;)r.push(a);return a===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return m.read()}}}e.peekReadable=w;function P(m,l){return new Promise((u,r)=>{const a=[];E(m,{onData:i=>{l&&a.push(i)},onError:i=>{l?r(i):u(void 0)},onEnd:()=>{u(l?l(a):void 0)}})})}e.consumeStream=P;function E(m,l){let u=!1;return m.on("error",r=>{u||l.onError(r)}),m.on("end",()=>{u||l.onEnd()}),m.on("data",r=>{u||l.onData(r)}),(0,n.toDisposable)(()=>u=!0)}e.listenStream=E;function g(m,l){return new Promise((u,r)=>{const a=new n.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>l)return a.dispose(),m.pause(),u({stream:m,buffer:i,ended:!1})},s=c=>r(c),o=()=>u({stream:m,buffer:i,ended:!0});a.add((0,n.toDisposable)(()=>m.removeListener("error",s))),m.on("error",s),a.add((0,n.toDisposable)(()=>m.removeListener("end",o))),m.on("end",o),a.add((0,n.toDisposable)(()=>m.removeListener("data",t))),m.on("data",t)})}e.peekStream=g;function p(m,l){const u=T(l);return u.end(m),u}e.toStream=p;function f(){const m=T(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=f;function y(m){let l=!1;return{read:()=>l?null:(l=!0,m)}}e.toReadable=y;function C(m,l,u){const r=T(u);return E(m,{onData:a=>r.write(l.data(a)),onError:a=>r.error(l.error?l.error(a):a),onEnd:()=>r.end()}),r}e.transform=C;function d(m,l,u){let r=!1;return{read:()=>{const a=l.read();return r?a:(r=!0,a!==null?u([m,a]):m)}}}e.prefixedReadable=d;function S(m,l,u){let r=!1;const a=T(u);return E(l,{onData:i=>r?a.write(i):(r=!0,a.write(u([m,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(m)),a.end()}}),a}e.prefixedStream=S}),define(ne[17],ie([0,1,40]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let k,_;class T{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new T(Buffer.allocUnsafe(h)):new T(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new T(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(h)):(k||(k=new TextEncoder),new T(k.encode(h)))}static fromByteArray(h){const v=T.alloc(h.length);for(let I=0,A=h.length;I<A;I++)v.buffer[I]=h[I];return v}static concat(h,v){if(typeof v=="undefined"){v=0;for(let O=0,N=h.length;O<N;O++)v+=h[O].byteLength}const I=T.alloc(v);let A=0;for(let O=0,N=h.length;O<N;O++){const $=h[O];I.set($,A),A+=$.byteLength}return I}clone(){const h=T.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(h,v){return new T(this.buffer.subarray(h,v))}set(h,v){if(h instanceof T)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return w(this.buffer,h)}writeUInt32BE(h,v){P(this.buffer,h,v)}readUInt32LE(h){return E(this.buffer,h)}writeUInt32LE(h,v){g(this.buffer,h,v)}readUInt8(h){return p(this.buffer,h)}writeUInt8(h,v){f(this.buffer,h,v)}}e.VSBuffer=T;function R(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=R;function b(c,h,v){c[v+0]=h&255,h=h>>>8,c[v+1]=h&255}e.writeUInt16LE=b;function w(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=w;function P(c,h,v){c[v+3]=h,h=h>>>8,c[v+2]=h,h=h>>>8,c[v+1]=h,h=h>>>8,c[v]=h}e.writeUInt32BE=P;function E(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=E;function g(c,h,v){c[v+0]=h&255,h=h>>>8,c[v+1]=h&255,h=h>>>8,c[v+2]=h&255,h=h>>>8,c[v+3]=h&255}e.writeUInt32LE=g;function p(c,h){return c[h]}e.readUInt8=p;function f(c,h,v){c[v]=h}e.writeUInt8=f;function y(c){return L.consumeReadable(c,h=>T.concat(h))}e.readableToBuffer=y;function C(c){return L.toReadable(c)}e.bufferToReadable=C;function d(c){return L.consumeStream(c,h=>T.concat(h))}e.streamToBuffer=d;async function S(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await d(c.stream)])}e.bufferedStreamToBuffer=S;function m(c){return L.toStream(c,h=>T.concat(h))}e.bufferToStream=m;function l(c){return L.transform(c,{data:h=>typeof h=="string"?T.fromString(h):T.wrap(h)},h=>T.concat(h))}e.streamToBufferReadableStream=l;function u(c){return L.newWriteableStream(h=>T.concat(h),c)}e.newWriteableBufferStream=u;function r(c,h){return L.prefixedReadable(c,h,v=>T.concat(v))}e.prefixedBufferReadable=r;function a(c,h){return L.prefixedStream(c,h,v=>T.concat(v))}e.prefixedBufferStream=a;function i(c){let h=0,v=0,I=0;const A=new Uint8Array(Math.floor(c.length/4*3)),O=$=>{switch(v){case 3:A[I++]=h|$,v=0;break;case 2:A[I++]=h|$>>>2,h=$<<6,v=3;break;case 1:A[I++]=h|$>>>4,h=$<<4,v=2;break;default:h=$<<2,v=1}};for(let $=0;$<c.length;$++){const D=c.charCodeAt($);if(D>=65&&D<=90)O(D-65);else if(D>=97&&D<=122)O(D-97+26);else if(D>=48&&D<=57)O(D-48+52);else if(D===43||D===45)O(62);else if(D===47||D===95)O(63);else{if(D===61)break;throw new SyntaxError(`Unexpected base64 character ${c[$]}`)}}const N=I;for(;v>0;)O(0);return T.wrap(A).slice(0,N)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},h=!0,v=!1){const I=v?s:t;let A="";const O=c.byteLength%3;let N=0;for(;N<c.byteLength-O;N+=3){const $=c[N+0],D=c[N+1],M=c[N+2];A+=I[$>>>2],A+=I[($<<4|D>>>4)&63],A+=I[(D<<2|M>>>6)&63],A+=I[M&63]}if(O===1){const $=c[N+0];A+=I[$>>>2],A+=I[$<<4&63],h&&(A+="==")}else if(O===2){const $=c[N+0],D=c[N+1];A+=I[$>>>2],A+=I[($<<4|D>>>4)&63],A+=I[D<<2&63],h&&(A+="=")}return A}e.encodeBase64=o}),define(ne[27],ie([0,1,105,99]),function(J,e,L,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.isFalsyOrWhitespace=_;const T=/{(\d+)}/g;function R(Z,...oe){return oe.length===0?Z:Z.replace(T,function(le,fe){const me=parseInt(fe,10);return isNaN(me)||me<0||me>=oe.length?le:oe[me]})}e.format=R;const b=/{([^}]+)}/g;function w(Z,oe){return Z.replace(b,(le,fe)=>oe[fe]??le)}e.format2=w;function P(Z){return Z.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function E(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function g(Z,oe){let le=0;const fe=oe.charCodeAt(0);for(let me=Z.length-1;me>=0;me--)Z.charCodeAt(me)===fe&&le++;return le}e.count=g;function p(Z,oe,le="\u2026"){return Z.length<=oe?Z:`${Z.substr(0,oe)}${le}`}e.truncate=p;function f(Z,oe=" "){const le=y(Z,oe);return C(le,oe)}e.trim=f;function y(Z,oe){if(!Z||!oe)return Z;const le=oe.length;if(le===0||Z.length===0)return Z;let fe=0;for(;Z.indexOf(oe,fe)===fe;)fe=fe+le;return Z.substring(fe)}e.ltrim=y;function C(Z,oe){if(!Z||!oe)return Z;const le=oe.length,fe=Z.length;if(le===0||fe===0)return Z;let me=fe,Te=-1;for(;Te=Z.lastIndexOf(oe,me-1),!(Te===-1||Te+le!==me);){if(Te===0)return"";me=Te}return Z.substring(0,me)}e.rtrim=C;function d(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function S(Z){return Z.replace(/\*/g,"")}e.stripWildcards=S;function m(Z,oe,le={}){if(!Z)throw new Error("Cannot create regex from empty string");oe||(Z=E(Z)),le.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Z,fe)}e.createRegExp=m;function l(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.regExpLeadsToEndlessLoop=l;function u(Z){return!!Z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(Z){return(Z.global?"g":"")+(Z.ignoreCase?"i":"")+(Z.multiline?"m":"")+(Z.unicode?"u":"")}e.regExpFlags=r;function a(Z){return Z.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Z){for(let oe=0,le=Z.length;oe<le;oe++){const fe=Z.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Z,oe=0,le=Z.length){for(let fe=oe;fe<le;fe++){const me=Z.charCodeAt(fe);if(me!==32&&me!==9)return Z.substring(oe,fe)}return Z.substring(oe,le)}e.getLeadingWhitespace=t;function s(Z,oe=Z.length-1){for(let le=oe;le>=0;le--){const fe=Z.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function o(Z,oe){return Z<oe?-1:Z>oe?1:0}e.compare=o;function c(Z,oe,le=0,fe=Z.length,me=0,Te=oe.length){for(;le<fe&&me<Te;le++,me++){let ke=Z.charCodeAt(le),Pe=oe.charCodeAt(me);if(ke<Pe)return-1;if(ke>Pe)return 1}const we=fe-le,Re=Te-me;return we<Re?-1:we>Re?1:0}e.compareSubstring=c;function h(Z,oe){return v(Z,oe,0,Z.length,0,oe.length)}e.compareIgnoreCase=h;function v(Z,oe,le=0,fe=Z.length,me=0,Te=oe.length){for(;le<fe&&me<Te;le++,me++){let ke=Z.charCodeAt(le),Pe=oe.charCodeAt(me);if(ke===Pe)continue;if(ke>=128||Pe>=128)return c(Z.toLowerCase(),oe.toLowerCase(),le,fe,me,Te);I(ke)&&(ke-=32),I(Pe)&&(Pe-=32);const _e=ke-Pe;if(_e!==0)return _e}const we=fe-le,Re=Te-me;return we<Re?-1:we>Re?1:0}e.compareSubstringIgnoreCase=v;function I(Z){return Z>=97&&Z<=122}e.isLowerAsciiLetter=I;function A(Z){return Z>=65&&Z<=90}e.isUpperAsciiLetter=A;function O(Z,oe){return Z.length===oe.length&&v(Z,oe)===0}e.equalsIgnoreCase=O;function N(Z,oe){const le=oe.length;return oe.length>Z.length?!1:v(Z,oe,0,le)===0}e.startsWithIgnoreCase=N;function $(Z,oe){let le,fe=Math.min(Z.length,oe.length);for(le=0;le<fe;le++)if(Z.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=$;function D(Z,oe){let le,fe=Math.min(Z.length,oe.length);const me=Z.length-1,Te=oe.length-1;for(le=0;le<fe;le++)if(Z.charCodeAt(me-le)!==oe.charCodeAt(Te-le))return le;return fe}e.commonSuffixLength=D;function M(Z){return 55296<=Z&&Z<=56319}e.isHighSurrogate=M;function z(Z){return 56320<=Z&&Z<=57343}e.isLowSurrogate=z;function U(Z,oe){return(Z-55296<<10)+(oe-56320)+65536}e.computeCodePoint=U;function V(Z,oe,le){const fe=Z.charCodeAt(le);if(M(fe)&&le+1<oe){const me=Z.charCodeAt(le+1);if(z(me))return U(fe,me)}return fe}e.getNextCodePoint=V;function Y(Z,oe){const le=Z.charCodeAt(oe-1);if(z(le)&&oe>1){const fe=Z.charCodeAt(oe-2);if(M(fe))return U(fe,le)}return le}class B{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=Y(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=V(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class q{constructor(oe,le=0){this._iterator=new B(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let me=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Te=le.offset,we=oe.getGraphemeBreakType(le.nextCodePoint());if(ze(me,we)){le.setOffset(Te);break}me=we}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let me=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Te=le.offset,we=oe.getGraphemeBreakType(le.prevCodePoint());if(ze(we,me)){le.setOffset(Te);break}me=we}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function X(Z,oe){return new q(Z,oe).nextGraphemeLength()}e.nextCharLength=X;function G(Z,oe){return new q(Z,oe).prevGraphemeLength()}e.prevCharLength=G;function ee(Z,oe){oe>0&&z(Z.charCodeAt(oe))&&oe--;const le=oe+X(Z,oe);return[le-G(Z,le),le]}e.getCharContainingOffset=ee;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(Z){return K.test(Z)}e.containsRTL=F;const j=/^[\t\n\r\x20-\x7E]*$/;function H(Z){return j.test(Z)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(Z){return e.UNUSUAL_LINE_TERMINATORS.test(Z)}e.containsUnusualLineTerminators=W;function x(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.isFullWidthCharacter=x;function re(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.isEmojiImprecise=re;function se(Z,oe){if(Z.length<oe)return Z;const le=/\b/g;let fe=0;for(;le.test(Z)&&!(Z.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Z.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,Se=/\x1b\[0?m/g;function ge(Z){return Z&&(Z=Z.replace(ce,""),Z=Z.replace(he,""),Z=Z.replace(Se,"")),Z}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ye(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ye;function pe(Z){return ye(Z)?Z.substr(1):Z}e.stripUTF8BOM=pe;function Ie(Z,oe){if(!Z||!oe||Z.length<oe.length)return!1;const le=oe.length,fe=Z.toLowerCase();let me=0,Te=-1;for(;me<le;){const we=fe.indexOf(oe[me],Te+1);if(we<0)return!1;Te=we,me++}return!0}e.fuzzyContains=Ie;function Ee(Z,oe=!1){return Z?(oe&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.containsUppercaseCharacter=Ee;function De(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.uppercaseFirstLetter=De;function Fe(Z,oe=1){if(oe===0)return"";let le=-1;do le=Z.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Z:(Z[le-1]==="\r"&&le--,Z.substr(0,le))}e.getNLines=Fe;function Ue(Z){const oe=90-65+1;return Z=Z%(2*oe),Z<oe?String.fromCharCode(97+Z):String.fromCharCode(65+Z-oe)}e.singleLetterHash=Ue;function Ne(Z){return ae.getInstance().getGraphemeBreakType(Z)}e.getGraphemeBreakType=Ne;function ze(Z,oe){return Z===0?oe!==5&&oe!==7:Z===2&&oe===3?!1:Z===4||Z===2||Z===3||oe===4||oe===2||oe===3?!0:!(Z===8&&(oe===8||oe===9||oe===11||oe===12)||(Z===11||Z===9)&&(oe===9||oe===10)||(Z===12||Z===10)&&oe===10||oe===5||oe===13||oe===7||Z===1||Z===13&&oe===14||Z===6&&oe===6)}var te;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(te=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let me=1;for(;me<=fe;)if(oe<le[3*me])me=2*me;else if(oe>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(Z,oe){if(Z===0)return 0;const le=Ce(Z,oe);if(le!==void 0)return le;const fe=new B(oe,Z);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=be;function Ce(Z,oe){const le=new B(oe,Z);let fe=le.prevCodePoint();for(;$e(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!re(fe))return;let me=le.offset;return me>0&&le.prevCodePoint()===8205&&(me=le.offset),me}function $e(Z){return 127995<=Z&&Z<=127999}var Le;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,k=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new L.LRUCachedComputed(Z=>{function oe(Pe){const _e=new Map;for(let We=0;We<Pe.length;We+=2)_e.set(Pe[We],Pe[We+1]);return _e}function le(Pe,_e){const We=new Map(Pe);for(const[Be,xe]of _e)We.set(Be,xe);return We}function fe(Pe,_e){if(!Pe)return _e;const We=new Map;for(const[Be,xe]of Pe)_e.has(Be)&&We.set(Be,xe);return We}const me=k.ambiguousCharacterData.getValue();let Te=Z.filter(Pe=>!Pe.startsWith("_")&&Pe in me);Te.length===0&&(Te=["_default"]);let we;for(const Pe of Te){const _e=oe(me[Pe]);we=fe(we,_e)}const Re=oe(me._common),ke=le(Re,we);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Z=>!Z.startsWith("_")));class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(oe){return Ae.getData().has(oe)}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae,Ae._data=void 0}),define(ne[106],ie([0,1,27]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(d){return k(d,0)}e.hash=n;function k(d,S){switch(typeof d){case"object":return d===null?_(349,S):Array.isArray(d)?b(d,S):w(d,S);case"string":return R(d,S);case"boolean":return T(d,S);case"number":return _(d,S);case"undefined":return _(937,S);default:return _(617,S)}}e.doHash=k;function _(d,S){return(S<<5)-S+d|0}e.numberHash=_;function T(d,S){return _(d?433:863,S)}function R(d,S){S=_(149417,S);for(let m=0,l=d.length;m<l;m++)S=_(d.charCodeAt(m),S);return S}e.stringHash=R;function b(d,S){return S=_(104579,S),d.reduce((m,l)=>k(l,m),S)}function w(d,S){return S=_(181387,S),Object.keys(d).sort().reduce((m,l)=>(m=R(l,m),k(d[l],m)),S)}class P{constructor(){this._value=0}get value(){return this._value}hash(S){return this._value=k(S,this._value),this._value}}e.Hasher=P;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function g(d,S,m=32){const l=m-S,u=~((1<<l)-1);return(d<<S|(u&d)>>>l)>>>0}function p(d,S=0,m=d.byteLength,l=0){for(let u=0;u<m;u++)d[S+u]=l}function f(d,S,m="0"){for(;d.length<S;)d=m+d;return d}function y(d,S=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(m=>m.toString(16).padStart(2,"0")).join(""):f((d>>>0).toString(16),S/4)}e.toHexString=y;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(S){const m=S.length;if(m===0)return;const l=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,a,i;for(r!==0?(a=r,i=-1,r=0):(a=S.charCodeAt(0),i=0);;){let t=a;if(L.isHighSurrogate(a))if(i+1<m){const s=S.charCodeAt(i+1);L.isLowSurrogate(s)?(i++,t=L.computeCodePoint(a,s)):t=65533}else{r=a;break}else L.isLowSurrogate(a)&&(t=65533);if(u=this._push(l,u,t),i++,i<m)a=S.charCodeAt(i);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(S,m,l){return l<128?S[m++]=l:l<2048?(S[m++]=192|(l&1984)>>>6,S[m++]=128|(l&63)>>>0):l<65536?(S[m++]=224|(l&61440)>>>12,S[m++]=128|(l&4032)>>>6,S[m++]=128|(l&63)>>>0):(S[m++]=240|(l&1835008)>>>18,S[m++]=128|(l&258048)>>>12,S[m++]=128|(l&4032)>>>6,S[m++]=128|(l&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,S[0]=S[64+0],S[1]=S[64+1],S[2]=S[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const S=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(S/4294967296),!1),this._buffDV.setUint32(60,S%4294967296,!1),this._step()}_step(){const S=C._bigBlock32,m=this._buffDV;for(let c=0;c<64;c+=4)S.setUint32(c,m.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)S.setUint32(c,g(S.getUint32(c-12,!1)^S.getUint32(c-32,!1)^S.getUint32(c-56,!1)^S.getUint32(c-64,!1),1),!1);let l=this._h0,u=this._h1,r=this._h2,a=this._h3,i=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=u&r|~u&a,s=1518500249):c<40?(t=u^r^a,s=1859775393):c<60?(t=u&r|u&a|r&a,s=2400959708):(t=u^r^a,s=3395469782),o=g(l,5)+t+i+s+S.getUint32(c*4,!1)&4294967295,i=a,a=r,r=g(u,30),u=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(J,e,L,n,k){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?k.call(J,L):k?k.value=L:e.set(J,L),L},Ke=this&&this.__classPrivateFieldGet||function(J,e,L,n){if(L==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!n:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return L==="m"?n:L==="a"?n.call(J):n?n.value:e.get(J)};define(ne[39],ie([0,1,16,27]),function(J,e,L,n){"use strict";var k,_,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,s){let o=i.get(t);return o===void 0&&(o=s,i.set(t,o)),o}e.getOrSet=R;function b(i){const t=[];return i.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function w(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=w;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class g{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var p;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(p||(p={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(C||(C={}));class d{constructor(t){this._iter=t}static forUris(t=()=>!1){return new d(new f(t))}static forPaths(t=!1){return new d(new g(void 0,!t))}static forStrings(){return new d(new P)}static forConfigKeys(){return new d(new E)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,L.shuffle)(o);for(let c of o)this.set(c,t)}else{const o=t.slice(0);(0,L.shuffle)(o);for(let c of o)this.set(c[0],c[1])}}set(t,s){const o=this._iter.reset(t);let c;this._root||(this._root=new y,this._root.segment=o.value());const h=[];for(c=this._root;;){const I=o.cmp(c.segment);if(I>0)c.left||(c.left=new y,c.left.segment=o.value()),h.push([-1,c]),c=c.left;else if(I<0)c.right||(c.right=new y,c.right.segment=o.value()),h.push([1,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new y,c.mid.segment=o.value()),h.push([0,c]),c=c.mid;else break}const v=c.value;c.value=s,c.key=t;for(let I=h.length-1;I>=0;I--){const A=h[I][1];A.updateHeight();const O=A.balanceFactor();if(O<-1||O>1){const N=h[I][0],$=h[I+1][0];if(N===1&&$===1)h[I][1]=A.rotateLeft();else if(N===-1&&$===-1)h[I][1]=A.rotateRight();else if(N===1&&$===-1)A.right=h[I+1][1]=h[I+1][1].rotateRight(),h[I][1]=A.rotateLeft();else if(N===-1&&$===1)A.left=h[I+1][1]=h[I+1][1].rotateLeft(),h[I][1]=A.rotateRight();else throw new Error;if(I>0)switch(h[I-1][0]){case-1:h[I-1][1].left=h[I][1];break;case 1:h[I-1][1].right=h[I][1];break;case 0:h[I-1][1].mid=h[I][1];break}else this._root=h[0][1]}}return v}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),c=[];let h=this._root;for(;h;){const v=o.cmp(h.segment);if(v>0)c.push([-1,h]),h=h.left;else if(v<0)c.push([1,h]),h=h.right;else if(o.hasNext())o.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(s?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this._min(h.right),{key:I,value:A,segment:O}=v;this._delete(v.key,!1),h.key=I,h.value=A,h.segment=O}else{const v=h.left??h.right;if(c.length>0){const[I,A]=c[c.length-1];switch(I){case-1:A.left=v;break;case 0:A.mid=v;break;case 1:A.right=v;break}}else this._root=v}for(let v=c.length-1;v>=0;v--){const I=c[v][1];I.updateHeight();const A=I.balanceFactor();if(A>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),c[v][1]=I.rotateLeft()):A<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),c[v][1]=I.rotateRight()),v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=d;class S{constructor(t,s){this.uri=t,this.value=s}}class m{constructor(t,s){this[k]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=s??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new S(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=m,m.defaultToKey=i=>i.toString();var l;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class u{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let c=this._map.get(t);if(c)c.value=s,o!==0&&this.touch(c,o);else{switch(c={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let c=this._head;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.key,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.value,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:[o.key,o.value],done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return c}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,c=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=u;class r extends u{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){T.set(this,void 0),Pt(this,T,t,"f")}get size(){return Ke(this,T,"f").size}forEach(t,s){Ke(this,T,"f").forEach(t,s)}get(t){return Ke(this,T,"f").get(t)}has(t){return Ke(this,T,"f").has(t)}entries(){return Ke(this,T,"f").entries()}keys(){return Ke(this,T,"f").keys()}values(){return Ke(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ke(this,T,"f").entries()}}e.ReadonlyMapView=a}),define(ne[69],ie([0,1,39]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new L.LRUCache(1e4);function k(w){return b(w,"NFC",n)}e.normalizeNFC=k;const _=new L.LRUCache(1e4);function T(w){return b(w,"NFD",_)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function b(w,P,E){if(!w)return w;const g=E.get(w);if(g)return g;let p;return R.test(w)?p=w.normalize(P):p=w,E.set(w,p),p}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(P){return T(P).replace(w,"")}}()}),define(ne[15],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function L(h){return Array.isArray(h)}e.isArray=L;function n(h){return typeof h=="string"}e.isString=n;function k(h){return Array.isArray(h)&&h.every(v=>n(v))}e.isStringArray=k;function _(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=_;function T(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=T;function R(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=R;function b(h){return h===!0||h===!1}e.isBoolean=b;function w(h){return typeof h=="undefined"}e.isUndefined=w;function P(h){return!E(h)}e.isDefined=P;function E(h){return w(h)||h===null}e.isUndefinedOrNull=E;function g(h,v){if(!h)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=g;function p(h){if(E(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=p;function f(...h){const v=[];for(let I=0;I<h.length;I++){const A=h[I];if(E(A))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);v.push(A)}return v}e.assertAllDefined=f;const y=Object.prototype.hasOwnProperty;function C(h){if(!_(h))return!1;for(let v in h)if(y.call(h,v))return!1;return!0}e.isEmptyObject=C;function d(h){return typeof h=="function"}e.isFunction=d;function S(...h){return h.length>0&&h.every(d)}e.areFunctions=S;function m(h,v){const I=Math.min(h.length,v.length);for(let A=0;A<I;A++)l(h[A],v[A])}e.validateConstraints=m;function l(h,v){if(n(v)){if(typeof h!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(d(v)){try{if(h instanceof v)return}catch{}if(!E(h)&&h.constructor===v||v.length===1&&v.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function u(h){let v=[],I=Object.getPrototypeOf(h);for(;Object.prototype!==I;)v=v.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return v}e.getAllPropertyNames=u;function r(h){const v=[];for(const I of u(h))typeof h[I]=="function"&&v.push(I);return v}e.getAllMethodNames=r;function a(h,v){const I=O=>function(){const N=Array.prototype.slice.call(arguments,0);return v(O,N)};let A={};for(const O of h)A[O]=I(O);return A}e.createProxyObject=a;function i(h){return h===null?void 0:h}e.withNullAsUndefined=i;function t(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=t;function s(h){return class{constructor(){return new Proxy({},{get(v,I){if(v[I])return v[I];throw new Error(`Not Implemented: ${h}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(h,v="Unreachable"){throw new Error(v)}e.assertNever=o;function c(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=c}),define(ne[41],ie([0,1,9,4,27,15]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(s){return s===47||s===92}e.isPathSeparator=T;function R(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function b(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=b;function w(s,o=L.posix.sep){if(!s)return"";const c=s.length,h=s.charCodeAt(0);if(T(h)){if(T(s.charCodeAt(1))&&!T(s.charCodeAt(2))){let I=3;const A=I;for(;I<c&&!T(s.charCodeAt(I));I++);if(A!==I&&!T(s.charCodeAt(I+1))){for(I+=1;I<c;I++)if(T(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(d(h)&&s.charCodeAt(1)===58)return T(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(T(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=w;function P(s){if(!n.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let c=2;const h=c;for(;c<s.length&&(o=s.charCodeAt(c),o!==92);c++);return!(h===c||(o=s.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=P;const E=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,o=n.isWindows){const c=o?E:g;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||o&&p.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function y(s,o,c){const h=s===o;return!c||h?h:!s||!o?!1:(0,k.equalsIgnoreCase)(s,o)}e.isEqual=y;function C(s,o,c,h=L.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(c){if(!(0,k.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===h&&I--,s.charAt(I)===h}return o.charAt(o.length-1)!==h&&(o+=h),s.indexOf(o)===0}e.isEqualOrParent=C;function d(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=d;function S(s,o){return n.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(o,s)),s=(0,L.normalize)(s),n.isWindows?(s=(0,k.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,k.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=S;function m(s){const o=(0,L.normalize)(s);return n.isWindows?s.length>3?!1:l(o)&&(s.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=m;function l(s,o){return(o!==void 0?o:n.isWindows)?d(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function u(s){return l(s)?s[0]:void 0}e.getDriveLetter=u;function r(s,o,c){return o.length>s.length?-1:s===o?0:(c&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function a(s){const o=s.split(":");let c,h,v;for(const I of o){const A=Number(I);(0,_.isNumber)(A)?h===void 0?h=A:v===void 0&&(v=A):c=c?[c,I].join(":"):I}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,c=8){let h="";for(let I=0;I<c;I++)h+=i.charAt(Math.floor(Math.random()*i.length));let v;return o?v=`${o}-${h}`:v=h,s?(0,L.join)(s,v):v}e.randomPath=t}),define(ne[28],ie([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const C=Array.isArray(y)?[]:{};return Object.keys(y).forEach(d=>{y[d]&&typeof y[d]=="object"?C[d]=n(y[d]):C[d]=y[d]}),C}e.deepClone=n;function k(y){if(!y||typeof y!="object")return y;const C=[y];for(;C.length>0;){const d=C.shift();Object.freeze(d);for(const S in d)if(_.call(d,S)){const m=d[S];typeof m=="object"&&!Object.isFrozen(m)&&C.push(m)}}return y}e.deepFreeze=k;const _=Object.prototype.hasOwnProperty;function T(y,C){return R(y,C,new Set)}e.cloneAndChange=T;function R(y,C,d){if((0,L.isUndefinedOrNull)(y))return y;const S=C(y);if(typeof S!="undefined")return S;if((0,L.isArray)(y)){const m=[];for(const l of y)m.push(R(l,C,d));return m}if((0,L.isObject)(y)){if(d.has(y))throw new Error("Cannot clone recursive data-structure");d.add(y);const m={};for(let l in y)_.call(y,l)&&(m[l]=R(y[l],C,d));return d.delete(y),m}return y}function b(y,C,d=!0){return(0,L.isObject)(y)?((0,L.isObject)(C)&&Object.keys(C).forEach(S=>{S in y?d&&((0,L.isObject)(y[S])&&(0,L.isObject)(C[S])?b(y[S],C[S],d):y[S]=C[S]):y[S]=C[S]}),y):C}e.mixin=b;function w(y,C){if(y===C)return!0;if(y==null||C===null||C===void 0||typeof y!=typeof C||typeof y!="object"||Array.isArray(y)!==Array.isArray(C))return!1;let d,S;if(Array.isArray(y)){if(y.length!==C.length)return!1;for(d=0;d<y.length;d++)if(!w(y[d],C[d]))return!1}else{const m=[];for(S in y)m.push(S);m.sort();const l=[];for(S in C)l.push(S);if(l.sort(),!w(m,l))return!1;for(d=0;d<m.length;d++)if(!w(y[m[d]],C[m[d]]))return!1}return!0}e.equals=w;function P(y){const C=new Set;return JSON.stringify(y,(d,S)=>{if((0,L.isObject)(S)||Array.isArray(S)){if(C.has(S))return"[Circular]";C.add(S)}return S})}e.safeStringify=P;function E(y,C,d){const S=C(y);return typeof S=="undefined"?d:S}e.getOrDefault=E;function g(y,C){const d=Object.create(null);return!y||!C||Object.keys(C).forEach(m=>{const l=y[m],u=C[m];w(l,u)||(d[m]=u)}),d}e.distinct=g;function p(y,C){const d=C.toLowerCase(),S=Object.keys(y).find(m=>m.toLowerCase()===d);return S?y[S]:y[C]}e.getCaseInsensitive=p;function f(y,C){const d=Object.create(null);for(const[S,m]of Object.entries(y))C(S,m)&&(d[S]=m);return d}e.filter=f}),define(ne[7],ie([0,1,9,4]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,_=/^\//,T=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!_.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function w(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,s,o,c,h,v=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=b(t,v),this.authority=s||P,this.path=w(this.scheme,o||P),this.query=c||P,this.fragment=h||P,R(this,v))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:c,query:h,fragment:v}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),c===void 0?c=this.path:c===null&&(c=P),h===void 0?h=this.query:h===null&&(h=P),v===void 0?v=this.fragment:v===null&&(v=P),s===this.scheme&&o===this.authority&&c===this.path&&h===this.query&&v===this.fragment?this:new y(s,o,c,h,v)}static parse(t,s=!1){const o=g.exec(t);return o?new y(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new y(P,P,P,P,P)}static file(t){let s=P;if(n.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(s=t.substring(2),t=E):(s=t.substring(2,o),t=t.substring(o)||E)}return new y("file",s,t,P,P)}static from(t){const s=new y(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&t.scheme==="file"?o=p.file(L.win32.join(m(t,!0),...s)).path:o=L.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return l(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const s=new y(t);return s._formatted=t.external,s._fsPath=t._sep===f?t.fsPath:null,s}}else return t}}e.URI=p;const f=n.isWindows?1:void 0;class y extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,t){let s,o=-1;for(let c=0;c<i.length;c++){const h=i.charCodeAt(c);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||t&&h===47)o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s!==void 0&&(s+=i.charAt(c));else{s===void 0&&(s=i.substr(0,c));const v=C[h];v!==void 0?(o!==-1&&(s+=encodeURIComponent(i.substring(o,c)),o=-1),s+=v):o===-1&&(o=c)}}return o!==-1&&(s+=encodeURIComponent(i.substring(o))),s!==void 0?s:i}function S(i){let t;for(let s=0;s<i.length;s++){const o=i.charCodeAt(s);o===35||o===63?(t===void 0&&(t=i.substr(0,s)),t+=C[o]):t!==void 0&&(t+=i[s])}return t!==void 0?t:i}function m(i,t){let s;return i.authority&&i.path.length>1&&i.scheme==="file"?s=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?s=i.path.substr(1):s=i.path[1].toLowerCase()+i.path.substr(2):s=i.path,n.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=m;function l(i,t){const s=t?S:d;let o="",{scheme:c,authority:h,path:v,query:I,fragment:A}=i;if(c&&(o+=c,o+=":"),(h||c==="file")&&(o+=E,o+=E),h){let O=h.indexOf("@");if(O!==-1){const N=h.substr(0,O);h=h.substr(O+1),O=N.indexOf(":"),O===-1?o+=s(N,!1):(o+=s(N.substr(0,O),!1),o+=":",o+=s(N.substr(O+1),!1)),o+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?o+=s(h,!1):(o+=s(h.substr(0,O),!1),o+=h.substr(O))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const O=v.charCodeAt(1);O>=65&&O<=90&&(v=`/${String.fromCharCode(O+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const O=v.charCodeAt(0);O>=65&&O<=90&&(v=`${String.fromCharCode(O+32)}:${v.substr(2)}`)}o+=s(v,!0)}return I&&(o+="?",o+=s(I,!1)),A&&(o+="#",o+=t?A:d(A,!1)),o}function u(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+u(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,t=>u(t)):i}}),define(ne[107],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(w){const P=w;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=n;function k(w){const P=[];let E;try{const g=JSON.parse(w.arguments),p=g[g.length-1];p&&p.__$stack&&(g.pop(),E=p.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",w.arguments)}return{args:P,stack:E}}e.parse=k;function _(w){if(typeof w!="string")return _(k(w).stack);const P=w;if(P){const E=T(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=_;function T(w){if(!w)return w;const P=w.indexOf(`
`);return P===-1?w:w.substring(0,P)}function R(w,P){const{args:E,stack:g}=k(w),p=typeof E[0]=="string"&&E.length===1;let f=T(g);f&&(f=`(${f.trim()})`);let y=[];if(typeof E[0]=="string"?f&&p?y=[`%c[${P}] %c${E[0]} %c${f}`,b("blue"),b(""),b("grey")]:y=[`%c[${P}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:y=[`%c[${P}]%`,b("blue"),...E],f&&!p&&y.push(f),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,y)}e.log=R;function b(w){return`color: ${w}`}}),define(ne[108],ie([0,1,17,27,7]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(P){return JSON.stringify(P,b)}e.stringify=_;function T(P){let E=JSON.parse(P);return E=w(E),E}e.parse=T;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function b(P,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,n.regExpFlags)(E)}:E}function w(P,E=0){if(!P||E>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let g=0;g<P.length;++g)P[g]=w(P[g],E+1);else for(const g in P)Object.hasOwnProperty.call(P,g)&&(P[g]=w(P[g],E+1))}return P}e.revive=w}),define(ne[18],ie([0,1,4,7]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,w,P){this._hosts[b]=w,this._ports[b]=P}setConnectionToken(b,w){this._connectionTokens[b]=w}rewrite(b){if(this._delegate)return this._delegate(b);const w=b.authority;let P=this._hosts[w];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const E=this._ports[w],g=this._connectionTokens[w];let p=`path=${encodeURIComponent(b.path)}`;return typeof g=="string"&&(p+=`&tkn=${encodeURIComponent(g)}`),n.URI.from({scheme:L.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${P}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new _;class T{asBrowserUri(b,w){const P=this.toUri(b,w);return P.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===k.file&&(L.isNative||typeof L.globals.importScripts=="function"&&L.globals.origin===`${k.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?P.with({scheme:k.vscodeFileResource,authority:P.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(b,w){const P=this.toUri(b,w);return P.scheme===k.vscodeFileResource?P.with({scheme:k.file,authority:P.authority!==T.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(b,w){return n.URI.isUri(b)?b:n.URI.parse(w.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ne[19],ie([0,1,41,18,9,4,27,7]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=b;class w{constructor(f){this._ignorePathCasing=f}compare(f,y,C=!1){return f===y?0:(0,T.compare)(this.getComparisonKey(f,C),this.getComparisonKey(y,C))}isEqual(f,y,C=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,C)===this.getComparisonKey(y,C)}getComparisonKey(f,y=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,y,C=!1){if(f.scheme===y.scheme){if(f.scheme===n.Schemas.file)return L.isEqualOrParent(b(f),b(y),this._ignorePathCasing(f))&&f.query===y.query&&(C||f.fragment===y.fragment);if((0,e.isEqualAuthority)(f.authority,y.authority))return L.isEqualOrParent(f.path,y.path,this._ignorePathCasing(f),"/")&&f.query===y.query&&(C||f.fragment===y.fragment)}return!1}joinPath(f,...y){return R.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===n.Schemas.file?y=R.URI.file(k.dirname(b(f))).path:(y=k.posix.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===n.Schemas.file?y=R.URI.file(k.normalize(b(f))).path:y=k.posix.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.isEqualAuthority)(f.authority,y.authority))return;if(f.scheme===n.Schemas.file){const S=k.relative(b(f),b(y));return _.isWindows?L.toSlashes(S):S}let C=f.path||"/",d=y.path||"/";if(this._ignorePathCasing(f)){let S=0;for(const m=Math.min(C.length,d.length);S<m&&!(C.charCodeAt(S)!==d.charCodeAt(S)&&C.charAt(S).toLowerCase()!==d.charAt(S).toLowerCase());S++);C=d.substr(0,S)+C.substr(S)}return k.posix.relative(C,d)}resolvePath(f,y){if(f.scheme===n.Schemas.file){const C=R.URI.file(k.resolve(b(f),y));return f.with({authority:C.authority,path:C.path})}return y=L.toPosixPath(y),f.with({path:k.posix.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(f,y)}hasTrailingPathSeparator(f,y=k.sep){if(f.scheme===n.Schemas.file){const C=b(f);return C.length>L.getRoot(C).length&&C[C.length-1]===y}else{const C=f.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=k.sep){return(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=k.sep){let C=!1;if(f.scheme===n.Schemas.file){const d=b(f);C=d!==void 0&&d.length===L.getRoot(d).length&&d[d.length-1]===y}else{y="/";const d=f.path;C=d.length===1&&d.charCodeAt(d.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(f,y)?f.with({path:f.path+"/"}):f}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(p=>p.scheme===n.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new w(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,f){const y=[];for(let C=0;C<p.length;C++){const d=f(p[C]);p.some((S,m)=>m===C?!1:(0,e.isEqualOrParent)(d,f(S)))||y.push(p[C])}return y}e.distinctParents=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(y){const C=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[l,u]=m.split(":");l&&u&&C.set(l,u)});const S=y.path.substring(0,y.path.indexOf(";"));return S&&C.set(p.META_DATA_MIME,S),C}p.parseMetaData=f})(E=e.DataUri||(e.DataUri={}));function g(p,f,y){if(f){let C=p.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),p.with({scheme:y,authority:f,path:C})}return p.with({scheme:y})}e.toLocalResource=g}),define(ne[5],ie([0,1,25,8,3,2,19,4]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(K){return!!K&&typeof K.then=="function"}e.isThenable=b;function w(K){const F=new L.CancellationTokenSource,j=K(F.token),H=new Promise((W,x)=>{const re=F.token.onCancellationRequested(()=>{re.dispose(),F.dispose(),x((0,n.canceled)())});Promise.resolve(j).then(se=>{re.dispose(),F.dispose(),W(se)},se=>{re.dispose(),F.dispose(),x(se)})});return new class{cancel(){F.cancel()}then(W,x){return H.then(W,x)}catch(W){return this.then(void 0,W)}finally(W){return H.finally(W)}}}e.createCancelablePromise=w;function P(K,F,j){return Promise.race([K,new Promise(H=>F.onCancellationRequested(()=>H(j)))])}e.raceCancellation=P;async function E(K){let F=-1;const j=K.map((W,x)=>W.then(re=>(F=x,re))),H=await Promise.race(j);return K.forEach((W,x)=>{x!==F&&W.cancel()}),H}e.raceCancellablePromises=E;function g(K,F,j){let H;const W=setTimeout(()=>{H?.(void 0),j?.()},F);return Promise.race([K.finally(()=>clearTimeout(W)),new Promise(x=>H=x)])}e.raceTimeout=g;function p(K){return new Promise((F,j)=>{const H=K();b(H)?H.then(F,j):F(H)})}e.asPromise=p;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const H=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,H};this.queuedPromise=new Promise(H=>{this.activePromise.then(j,j).then(H)})}return new Promise((j,H)=>{this.queuedPromise.then(j,H)})}return this.activePromise=F(),new Promise((j,H)=>{this.activePromise.then(W=>{this.activePromise=null,j(W)},W=>{this.activePromise=null,H(W)})})}}e.Throttler=f;class y{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=y;class C{constructor(){this.promiseMap=new Map}queue(F,j){const W=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=C;const d=(K,F)=>{let j=!0;const H=setTimeout(()=>{j=!1,F()},K);return{isTriggered:()=>j,dispose:()=>{clearTimeout(H),j=!1}}},S=K=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,K())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class m{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,j=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,x)=>{this.doResolve=W,this.doReject=x}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}}));const H=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===e.MicrotaskDelay?S(H):d(j,H),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,n.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=m;class l{constructor(F){this.delayer=new m(F),this.throttler=new f}trigger(F,j){return this.delayer.trigger(()=>this.throttler.queue(F),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,j)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class r extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(K,F){return F?new Promise((j,H)=>{const W=setTimeout(()=>{x.dispose(),j()},K),x=F.onCancellationRequested(()=>{clearTimeout(W),x.dispose(),H((0,n.canceled)())})}):w(j=>a(K,j))}e.timeout=a;function i(K,F=0){const j=setTimeout(K,F);return(0,_.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=i;function t(K){const F=[];let j=0;const H=K.length;function W(){return j<H?K[j++]():null}function x(re){re!=null&&F.push(re);const se=W();return se?se.then(x):Promise.resolve(F)}return Promise.resolve(null).then(x)}e.sequence=t;function s(K,F=H=>!!H,j=null){let H=0;const W=K.length,x=()=>{if(H>=W)return Promise.resolve(j);const re=K[H++];return Promise.resolve(re()).then(ce=>F(ce)?Promise.resolve(ce):x())};return x()}e.first=s;function o(K,F=H=>!!H,j=null){if(K.length===0)return Promise.resolve(j);let H=K.length;const W=()=>{H=-1;for(const x of K)x.cancel?.()};return new Promise((x,re)=>{for(const se of K)se.then(ce=>{--H>=0&&F(ce)?(W(),x(ce)):H===0&&x(j)}).catch(ce=>{--H>=0&&(W(),re(ce))})})}e.firstParallel=o;class c{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((j,H)=>{this.outstandingPromises.push({factory:F,c:j,e:H}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const j=F.factory();j.then(F.c,F.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class h extends c{constructor(){super(1)}}e.Queue=h;class v{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new Y;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,j=T.extUri){const H=j.getComparisonKey(F);let W=this.queues.get(H);return W||(W=new h,k.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(H),this.onDidQueueFinish()}),this.queues.set(H,W)),W}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=v;class I{constructor(F,j){this._token=-1,typeof F=="function"&&typeof j=="number"&&this.setIfNotSet(F,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},j)}setIfNotSet(F,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},j))}}e.TimeoutTimer=I;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setInterval(()=>{F()},j)}}e.IntervalTimer=A;class O{constructor(F,j){this.timeoutToken=-1,this.runner=F,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class N{constructor(F,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class $ extends O{constructor(F,j){super(F,j);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class D extends _.Disposable{constructor(F,j,H,W){super();this.maxWorkChunkSize=F,this.maxPendingWork=j,this.throttleDelay=H,this.handler=W,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=D,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,R.setTimeout0)(()=>{if(F)return;const j=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(K,F)=>{const j=requestIdleCallback(K,typeof F=="number"?{timeout:F}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(j))}}}}();class M{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function z(K,F,j){let H;for(let W=0;W<j;W++)try{return await K()}catch(x){H=x,await a(F)}throw H}e.retry=z;class U{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,j,H){return this._pending={taskId:F,cancel:()=>H?.(),promise:j},j.then(()=>this.donePending(F),()=>this.donePending(F)),j}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let j,H;const W=new Promise((x,re)=>{j=x,H=re});this._next={run:F,promise:W,promiseResolve:j,promiseReject:H}}return this._next.promise}}e.TaskSequentializer=U;class V{constructor(F,j=()=>Date.now()){this.interval=F,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,j)=>{this.completeCallback=F,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(j=>{this.completeCallback(F),this.resolved=!0,j()})}error(F){return new Promise(j=>{this.errorCallback(F),this.rejected=!0,j()})}cancel(){new Promise(F=>{this.errorCallback((0,n.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=Y;var B;(function(K){async function F(H){let W;const x=await Promise.all(H.map(re=>re.then(se=>se,se=>{W||(W=se)})));if(typeof W!="undefined")throw W;return x}K.settled=F;function j(H){return new Promise(async(W,x)=>{try{await H(W,x)}catch(re){x(re)}})}K.withAsyncBody=j})(B=e.Promises||(e.Promises={}));var q;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(q||(q={}));class X{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const j={emitOne:H=>this.emitOne(H),emitMany:H=>this.emitMany(H),reject:H=>this.reject(H)};try{await Promise.resolve(F(j)),this.resolve()}catch(H){this.reject(H)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}static fromArray(F){return new X(j=>{j.emitMany(F)})}static fromPromise(F){return new X(async j=>{j.emitMany(await F)})}static fromPromises(F){return new X(async j=>{await Promise.all(F.map(async H=>j.emitOne(await H)))})}static merge(F){return new X(async j=>{await Promise.all(F.map(async H=>{for await(const W of H)j.emitOne(W)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,j){return new X(async H=>{for await(const W of F)H.emitOne(j(W))})}map(F){return X.map(this,F)}static filter(F,j){return new X(async H=>{for await(const W of F)j(W)&&H.emitOne(W)})}filter(F){return X.filter(this,F)}static coalesce(F){return X.filter(F,j=>!!j)}coalesce(){return X.coalesce(this)}static async toPromise(F){const j=[];for await(const H of F)j.push(H);return j}toPromise(){return X.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class G extends X{constructor(F,j){super(j);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=G;function ee(K){const F=new L.CancellationTokenSource,j=K(F.token);return new G(F,async H=>{const W=F.token.onCancellationRequested(()=>{W.dispose(),F.dispose(),H.reject((0,n.canceled)())});try{for await(const x of j){if(F.token.isCancellationRequested)return;H.emitOne(x)}W.dispose(),F.dispose()}catch(x){W.dispose(),F.dispose(),H.reject(x)}})}e.createCancelableAsyncIterable=ee}),define(ne[109],ie([0,1,5,41,39,9,27]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",w="[^/\\\\]",P=/\//g;function E(Y){switch(Y){case 0:return"";case 1:return`${w}*?`;default:return`(?:${b}|${w}+${b}|${b}${w}+)*?`}}function g(Y,B){if(!Y)return[];const q=[];let X=!1,G=!1,ee="";for(const K of Y){switch(K){case B:if(!X&&!G){q.push(ee),ee="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":G=!0;break;case"]":G=!1;break}ee+=K}return ee&&q.push(ee),q}e.splitGlobAware=g;function p(Y){if(!Y)return"";let B="";const q=g(Y,e.GLOB_SPLIT);if(q.every(X=>X===e.GLOBSTAR))B=".*";else{let X=!1;q.forEach((G,ee)=>{if(G===e.GLOBSTAR){X||(B+=E(2),X=!0);return}let K=!1,F="",j=!1,H="";for(const W of G){if(W!=="}"&&K){F+=W;continue}if(j&&(W!=="]"||!H)){let x;W==="-"?x=W:(W==="^"||W==="!")&&!H?x="^":W===e.GLOB_SPLIT?x="":x=T.escapeRegExpCharacters(W),H+=x;continue}switch(W){case"{":K=!0;continue;case"[":j=!0;continue;case"}":{B+=`(?:${g(F,",").map(se=>p(se)).join("|")})`,K=!1,F="";break}case"]":B+="["+H+"]",j=!1,H="";break;case"?":B+=w;continue;case"*":B+=E(1);continue;default:B+=T.escapeRegExpCharacters(W)}}ee<q.length-1&&(q[ee+1]!==e.GLOBSTAR||ee+2<q.length)&&(B+=b),X=!1})}return B}const f=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new k.LRUCache(1e4),u=function(){return!1},r=function(){return null};function a(Y,B){if(!Y)return r;let q;typeof Y!="string"?q=Y.pattern:q=Y,q=q.trim();const X=`${q}_${!!B.trimForExclusions}`;let G=l.get(X);if(G)return i(G,Y);let ee;if(f.test(q)){const K=q.substr(4);G=function(F,j){return typeof F=="string"&&F.endsWith(K)?q:null}}else(ee=y.exec(t(q,B)))?G=s(ee[1],q):(B.trimForExclusions?d:C).test(q)?G=o(q,B):(ee=S.exec(t(q,B)))?G=c(ee[1].substr(1),q,!0):(ee=m.exec(t(q,B)))?G=c(ee[1],q,!1):G=h(q);return l.set(X,G),i(G,Y)}function i(Y,B){return typeof B=="string"?Y:function(q,X){return n.isEqualOrParent(q,B.base)?Y(_.relative(B.base,q),X):null}}function t(Y,B){return B.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function s(Y,B){const q=`/${Y}`,X=`\\${Y}`,G=function(K,F){return typeof K!="string"?null:F?F===Y?B:null:K===Y||K.endsWith(q)||K.endsWith(X)?B:null},ee=[Y];return G.basenames=ee,G.patterns=[B],G.allBasenames=ee,G}function o(Y,B){const q=V(Y.slice(1,-1).split(",").map(F=>a(F,B)).filter(F=>F!==r),Y),X=q.length;if(!X)return r;if(X===1)return q[0];const G=function(F,j){for(let H=0,W=q.length;H<W;H++)if(q[H](F,j))return Y;return null},ee=q.find(F=>!!F.allBasenames);ee&&(G.allBasenames=ee.allBasenames);const K=q.reduce((F,j)=>j.allPaths?F.concat(j.allPaths):F,[]);return K.length&&(G.allPaths=K),G}function c(Y,B,q){const X=_.sep===_.posix.sep,G=X?Y:Y.replace(P,_.sep),ee=_.sep+G,K=_.posix.sep+Y,F=q?function(j,H){return typeof j=="string"&&(j===G||j.endsWith(ee)||!X&&(j===Y||j.endsWith(K)))?B:null}:function(j,H){return typeof j=="string"&&(j===G||!X&&j===Y)?B:null};return F.allPaths=[(q?"*/":"./")+Y],F}function h(Y){try{const B=new RegExp(`^${p(Y)}$`);return function(q){return B.lastIndex=0,typeof q=="string"&&B.test(q)?Y:null}}catch{return r}}function v(Y,B,q){return!Y||typeof B!="string"?!1:I(Y)(B,void 0,q)}e.match=v;function I(Y,B={}){if(!Y)return u;if(typeof Y=="string"||$(Y)){const q=a(Y,B);if(q===r)return u;const X=function(G,ee){return!!q(G,ee)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return z(Y,B)}e.parse=I;function A(Y){if(!Y)return;let B;return q=>(B||(B=(Y()||Promise.resolve([])).then(X=>X?N(X):{})),B.then(X=>!!X[q]))}e.hasSiblingPromiseFn=A;function O(Y){if(!Y)return;let B;return q=>{if(!B){const X=Y();B=X?N(X):{}}return!!B[q]}}e.hasSiblingFn=O;function N(Y){const B={};for(const q of Y)B[q]=!0;return B}function $(Y){const B=Y;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=$;function D(Y){return Y.allBasenames||[]}e.getBasenameTerms=D;function M(Y){return Y.allPaths||[]}e.getPathTerms=M;function z(Y,B){const q=V(Object.getOwnPropertyNames(Y).map(F=>U(F,Y[F],B)).filter(F=>F!==r)),X=q.length;if(!X)return r;if(!q.some(F=>!!F.requiresSiblings)){if(X===1)return q[0];const F=function(W,x){for(let re=0,se=q.length;re<se;re++){const ce=q[re](W,x);if(ce)return ce}return null},j=q.find(W=>!!W.allBasenames);j&&(F.allBasenames=j.allBasenames);const H=q.reduce((W,x)=>x.allPaths?W.concat(x.allPaths):W,[]);return H.length&&(F.allPaths=H),F}const G=function(F,j,H){let W;for(let x=0,re=q.length;x<re;x++){const se=q[x];se.requiresSiblings&&H&&(j||(j=_.basename(F)),W||(W=j.substr(0,j.length-_.extname(F).length)));const ce=se(F,j,W,H);if(ce)return ce}return null},ee=q.find(F=>!!F.allBasenames);ee&&(G.allBasenames=ee.allBasenames);const K=q.reduce((F,j)=>j.allPaths?F.concat(j.allPaths):F,[]);return K.length&&(G.allPaths=K),G}function U(Y,B,q){if(B===!1)return r;const X=a(Y,q);if(X===r)return r;if(typeof B=="boolean")return X;if(B){const G=B.when;if(typeof G=="string"){const ee=(K,F,j,H)=>{if(!H||!X(K,F))return null;const W=G.replace("$(basename)",j),x=H(W);return(0,L.isThenable)(x)?x.then(re=>re?Y:null):x?Y:null};return ee.requiresSiblings=!0,ee}}return X}function V(Y,B){const q=Y.filter(F=>!!F.basenames);if(q.length<2)return Y;const X=q.reduce((F,j)=>{const H=j.basenames;return H?F.concat(H):F},[]);let G;if(B){G=[];for(let F=0,j=X.length;F<j;F++)G.push(B)}else G=q.reduce((F,j)=>{const H=j.patterns;return H?F.concat(H):F},[]);const ee=function(F,j){if(typeof F!="string")return null;if(!j){let W;for(W=F.length;W>0;W--){const x=F.charCodeAt(W-1);if(x===47||x===92)break}j=F.substr(W)}const H=X.indexOf(j);return H!==-1?G[H]:null};ee.basenames=X,ee.patterns=G,ee.allBasenames=X;const K=Y.filter(F=>!F.basenames);return K.push(ee),K}}),define(ne[110],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(P){return P.toJSON()}class k{constructor(E){this._uriTransformer=E}transformIncoming(E){const g=this._uriTransformer.transformIncoming(E);return g===E?E:n(L.URI.from(g))}transformOutgoing(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:n(L.URI.from(g))}transformOutgoingURI(E){const g=this._uriTransformer.transformOutgoing(E);return g===E?E:L.URI.from(g)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function _(P,E,g){if(!P||g>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return E.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const f=_(P[p],E,g+1);f!==null&&(P[p]=f)}}return null}function T(P,E){const g=_(P,E,0);return g===null?P:g}e.transformOutgoingURIs=T;function R(P,E,g,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return g?L.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);for(let f in P)if(Object.hasOwnProperty.call(P,f)){const y=R(P[f],E,g,p+1);y!==null&&(P[f]=y)}}return null}function b(P,E){const g=R(P,E,!1,0);return g===null?P:g}e.transformIncomingURIs=b;function w(P,E){const g=R(P,E,!0,0);return g===null?P:g}e.transformAndReviveIncomingURIs=w}),define(ne[29],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return L.test(b)}e.isUUID=n;const k=new Uint8Array(16),_=[];for(let b=0;b<256;b++)_.push(b.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(b){for(let w=0;w<b.length;w++)b[w]=Math.floor(Math.random()*256);return b};function R(){T(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let b=0,w="";return w+=_[k[b++]],w+=_[k[b++]],w+=_[k[b++]],w+=_[k[b++]],w+="-",w+=_[k[b++]],w+=_[k[b++]],w+="-",w+=_[k[b++]],w+=_[k[b++]],w+="-",w+=_[k[b++]],w+=_[k[b++]],w+="-",w+=_[k[b++]],w+=_[k[b++]],w+=_[k[b++]],w+=_[k[b++]],w+=_[k[b++]],w+=_[k[b++]],w}e.generateUuid=R}),define(ne[111],ie([0,1,247]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(_="utf8"){this.stringDecoder=new L.StringDecoder(_),this.remaining=null}write(_){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(R.length<1)return T;let b=0,w,P=b;for(;P<R.length;)if(w=R.charCodeAt(P),w===13||w===10){if(T.push(R.substring(b,P)),P++,P<R.length){const E=w;w=R.charCodeAt(P),(E===13&&w===10||E===10&&w===13)&&P++}b=P}else P++;return this.remaining=b<R.length?R.substr(b):null,T}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,32]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function _(){const T=(0,L.networkInterfaces)();for(let R in T){const b=T[R];if(b){for(const{mac:w}of b)if(k(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ne[113],ie([0,1,32,8,39,29,112]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,E=0;const g=(0,L.networkInterfaces)();for(let p in g){const f=g[p];if(f)for(const{mac:y,internal:C}of f)C||(E+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(P+=1))}this._value=E>0?P/E:0}return this._value}};let R;async function b(){return R||(R=(async()=>await w()||_.generateUuid())()),R}e.getMachineId=b;async function w(){try{const P=await new Promise((g,p)=>{J(["crypto"],g,p)}),E=(0,T.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){n.onUnexpectedError(P);return}}}),define(ne[22],ie([0,1,50,32,248,5,41,69,9,4,19,7]),function(J,e,L,n,k,_,T,R,b,w,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function p(M,z=g.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===g.UNLINK?y(M):f(M)}async function f(M){try{const z=(0,T.randomPath)((0,n.tmpdir)());try{await L.promises.rename(M,z)}catch{return y(M)}y(z).catch(U=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function y(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function C(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");L.rmdirSync(M,{recursive:!0})}e.rimrafSync=C;async function d(M,z){return l(await(z?S(M):(0,k.promisify)(L.readdir)(M)))}async function S(M){try{return await(0,k.promisify)(L.readdir)(M,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const z=[],U=await d(M);for(const V of U){let Y=!1,B=!1,q=!1;try{const X=await e.Promises.lstat((0,b.join)(M,V));Y=X.isFile(),B=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}z.push({name:V,isFile:()=>Y,isDirectory:()=>B,isSymbolicLink:()=>q})}return z}function m(M){return l(L.readdirSync(M))}e.readdirSync=m;function l(M){return M.map(z=>typeof z=="string"?w.isMacintosh?(0,R.normalizeNFC)(z):z:(z.name=w.isMacintosh?(0,R.normalizeNFC)(z.name):z.name,z))}async function u(M){const z=await d(M),U=[];for(const V of z)await a.existsDirectory((0,b.join)(M,V))&&U.push(V);return U}function r(M,z=1e3){return new Promise(U=>{let V=!1;const Y=setInterval(()=>{V||(V=!0,L.access(M,B=>{V=!1,B&&(clearInterval(Y),U(void 0))}))},z)})}e.whenDeleted=r;var a;(function(M){async function z(Y){let B;try{if(B=await e.Promises.lstat(Y),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(w.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw X}throw q}}M.stat=z;async function U(Y){try{const{stat:B,symbolicLink:q}=await M.stat(Y);return B.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=U;async function V(Y){try{const{stat:B,symbolicLink:q}=await M.stat(Y);return B.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=V})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new _.ResourceQueue;function t(M,z,U){return i.queueFor(E.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const V=h(U);return new Promise((Y,B)=>o(M,z,V,q=>q?B(q):Y()))})}let s=!0;function o(M,z,U,V){if(!s)return L.writeFile(M,z,{mode:U.mode,flag:U.flag},V);L.open(M,U.flag,U.mode,(Y,B)=>{if(Y)return V(Y);L.writeFile(B,z,q=>{if(q)return L.close(B,()=>V(q));L.fdatasync(B,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),s=!1),L.close(B,G=>V(G))))})})}function c(M,z,U){const V=h(U);if(!s)return L.writeFileSync(M,z,{mode:V.mode,flag:V.flag});const Y=L.openSync(M,V.flag,V.mode);try{L.writeFileSync(Y,z);try{L.fdatasyncSync(Y)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),s=!1}}finally{L.closeSync(Y)}}e.writeFileSync=c;function h(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function v(M,z){if(M===z)return;async function U(V){try{const Y=await e.Promises.lstat(V);if(Y.isDirectory()||Y.isSymbolicLink())return;await e.Promises.utimes(V,Y.atime,new Date)}catch{}}try{await e.Promises.rename(M,z),await U(z)}catch(V){if(M.toLowerCase()!==z.toLowerCase()&&V.code==="EXDEV"||M.endsWith("."))await I(M,z,{preserveSymlinks:!1}),await p(M,g.MOVE),await U(z);else throw V}}async function I(M,z,U){return O(M,z,{root:{source:M,target:z},options:U,handledSourcePaths:new Set})}const A=511;async function O(M,z,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:V,symbolicLink:Y}=await a.stat(M);if(Y){if(U.options.preserveSymlinks)try{return await D(M,z,U)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(Y.dangling)return}return V.isDirectory()?N(M,z,V.mode&A,U):$(M,z,V.mode&A)}async function N(M,z,U,V){await e.Promises.mkdir(z,{recursive:!0,mode:U});const Y=await d(M);for(const B of Y)await O((0,b.join)(M,B),(0,b.join)(z,B),V)}async function $(M,z,U){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,U)}async function D(M,z,U){let V=await e.Promises.readlink(M);(0,T.isEqualOrParent)(V,U.root.source,!w.isLinux)&&(V=(0,b.join)(U.root.target,V.substr(U.root.source.length+1))),await e.Promises.symlink(V,z)}e.Promises=new class{get access(){return(0,k.promisify)(L.access)}get stat(){return(0,k.promisify)(L.stat)}get lstat(){return(0,k.promisify)(L.lstat)}get utimes(){return(0,k.promisify)(L.utimes)}get read(){return(0,k.promisify)(L.read)}get readFile(){return(0,k.promisify)(L.readFile)}get write(){return(0,k.promisify)(L.write)}get appendFile(){return(0,k.promisify)(L.appendFile)}get fdatasync(){return(0,k.promisify)(L.fdatasync)}get truncate(){return(0,k.promisify)(L.truncate)}get rename(){return(0,k.promisify)(L.rename)}get copyFile(){return(0,k.promisify)(L.copyFile)}get open(){return(0,k.promisify)(L.open)}get close(){return(0,k.promisify)(L.close)}get symlink(){return(0,k.promisify)(L.symlink)}get readlink(){return(0,k.promisify)(L.readlink)}get chmod(){return(0,k.promisify)(L.chmod)}get mkdir(){return(0,k.promisify)(L.mkdir)}get unlink(){return(0,k.promisify)(L.unlink)}get rmdir(){return(0,k.promisify)(L.rmdir)}get realpath(){return(0,k.promisify)(L.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return p}get move(){return v}get copy(){return I}}}),define(ne[114],ie([0,1,50,9,4,27,22]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(g){if(k.isLinux)return g;const p=(0,n.dirname)(g);if(g===p)return g;const f=((0,n.basename)(g)||g).toLowerCase();try{const C=(0,T.readdirSync)(p).filter(d=>d.toLowerCase()===f);if(C.length===1){const d=R(p);if(d)return(0,n.join)(d,C[0])}else if(C.length>1){const d=C.indexOf(f);if(d>=0){const S=R(p);if(S)return(0,n.join)(S,C[d])}}}catch{}return null}e.realcaseSync=R;async function b(g){if(k.isLinux)return g;const p=(0,n.dirname)(g);if(g===p)return g;const f=((0,n.basename)(g)||g).toLowerCase();try{const C=(await T.Promises.readdir(p)).filter(d=>d.toLowerCase()===f);if(C.length===1){const d=await b(p);if(d)return(0,n.join)(d,C[0])}else if(C.length>1){const d=C.indexOf(f);if(d>=0){const S=await b(p);if(S)return(0,n.join)(S,C[d])}}}catch{}return null}e.realcase=b;async function w(g){try{return await T.Promises.realpath(g)}catch{const f=E(g);return await T.Promises.access(f,L.constants.R_OK),f}}e.realpath=w;function P(g){try{return L.realpathSync(g)}catch{const f=E(g);return L.accessSync(f,L.constants.R_OK),f}}e.realpathSync=P;function E(g){return(0,_.rtrim)((0,n.normalize)(g),n.sep)}}),define(ne[115],ie([0,1,55]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,b,w,P=1){let E=!1;return new Promise(g=>{const p=setTimeout(()=>{if(!E)return E=!0,g(0)},w);k(R,b,P,f=>{if(!E)return E=!0,clearTimeout(p),g(f)})})}e.findFreePort=n;function k(R,b,w,P){if(b===0)return P(0);const E=new L.Socket;E.once("connect",()=>(T(E),k(R+w,b-1,w,P))),E.once("data",()=>{}),E.once("error",g=>(T(E),g.code!=="ECONNREFUSED"?k(R+w,b-1,w,P):P(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(R,b,w){let P=!1,E,g=1;const p=L.createServer({pauseOnConnect:!0});function f(y,C){P||(P=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),C(y))}return new Promise(y=>{E=setTimeout(()=>{f(0,y)},w),p.on("listening",()=>{f(R,y)}),p.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&g<b?(R++,g++,p.listen(R,"127.0.0.1")):f(0,y)}),p.on("close",()=>{f(0,y)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=_;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(ne[70],ie([0,1,32,9,22]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(b||(b={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(u,r,a){this.exePath=u,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:l=!1}={}){return l?w===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:l=!1,findPreview:u=!1}={}){const r=g({useAlternateBitness:l});if(!r)return null;const a=n.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let i=-1,t=null;for(const c of await k.Promises.readdir(a)){let h=-1;if(u){const I=c.indexOf("-");if(I<0)continue;const A=c.substring(0,I);if(!_.test(A)||c.substring(I+1)!=="preview")continue;h=parseInt(A,10)}else{if(!_.test(c))continue;h=parseInt(c,10)}if(h<=i)continue;const v=n.join(a,c,"pwsh.exe");!await k.SymlinkSupport.existsFile(v)||(t=v,i=h)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=u?" Preview":"";return new E(t,`PowerShell${o}${s}`,!0)}async function f({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const u=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=l?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(u))if(r.test(i)){const t=n.join(u,i,"pwsh.exe");return new E(t,a)}return null}function y(){const l=n.join(L.homedir(),".dotnet","tools","pwsh.exe");return new E(l,".NET Core PowerShell Global Tool")}function C(){const l=n.join(process.env.windir,w===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(l,"Windows PowerShell",!0)}async function*d(){let l=await p();l&&(yield l),l=await p({useAlternateBitness:!0}),l&&(yield l),l=await f(),l&&(yield l),l=y(),l&&(yield l),l=await p({findPreview:!0}),l&&(yield l),l=await f({findPreview:!0}),l&&(yield l),l=await p({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=C(),l&&(yield l)}async function*S(){for await(const l of d())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=S;async function m(){for await(const l of S())return l;return null}e.getFirstAvailablePowerShellInstallation=m}),define(ne[116],ie([0,1,45,18]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(T){return new Promise((R,b)=>{let w;const P=new Map;function E(p,f,y,C,d){const S=P.get(f);if(p===T||S){const m={name:g(y),cmd:y,pid:p,ppid:f,load:C,mem:d};P.set(p,m),p===T&&(w=m),S&&(S.children||(S.children=[]),S.children.push(m),S.children.length>1&&(S.children=S.children.sort((l,u)=>l.pid-u.pid)))}}function g(p){const f=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,d=/--utility-sub-type=network/,S=/--crashes-directory/,m=/\\pipe\\winpty-control/,l=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(S.exec(p))return"electron-crash-reporter";if(m.exec(p))return"winpty-process";if(l.exec(p))return"console-window-host (Windows internal process)";let r=u.exec(p);if(r&&r.length===2)return r[1]==="renderer"?f.exec(p)?"shared-process":y.exec(p)?"issue-reporter":C.exec(p)?"process-explorer":"window":r[1]==="utility"&&d.exec(p)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let i="";do r=a.exec(p),r&&(i+=r+" ");while(r);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,y)=>{J(["windows-process-tree"],f,y)}).then(f=>{f.getProcessList(T,y=>{f.getProcessCpuUsage(y,C=>{const d=new Map;C.forEach(S=>{const m=p(S.commandLine||"");d.set(S.pid,{name:g(m),cmd:m,pid:S.pid,ppid:S.ppid,load:S.cpu||0,mem:S.memory||0})}),w=d.get(T),w?(d.forEach(S=>{const m=d.get(S.ppid);m&&(m.children||(m.children=[]),m.children.push(S))}),d.forEach(S=>{S.children&&(S.children=S.children.sort((m,l)=>m.pid-l.pid))}),R(w)):b(new Error(`Root process ${T} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let p=function(){let f=[w];const y=[];for(;f.length;){const d=f.shift();d&&(y.push(d.pid),d.children&&(f=f.concat(d.children)))}let C=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);C+=" "+y.join(" "),(0,L.exec)(C,{},(d,S,m)=>{if(d||m)b(d||new Error(m.toString()));else{const l=S.toString().split(`
`);for(let u=0;u<y.length;u++){const r=P.get(y[u]);r.load=parseFloat(l[u])}if(!w){b(new Error(`Root process ${T} not found`));return}R(w)}})};(0,L.exec)("which ps",{},(f,y,C)=>{if(f||C)if(process.platform!=="linux")b(f||new Error(C.toString()));else{const d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,L.exec)(d,{},(S,m,l)=>{S||l?b(S||new Error(l.toString())):(_(m,E),p())})}else{const d=y.toString().trim(),S="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${d} ${S}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,l,u)=>{m||u&&!u.includes("screen size is bogus")?b(m||new Error(u.toString())):(_(l,E),process.platform==="linux"?p():w?R(w):b(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=k;function _(T,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=T.toString().split(`
`);for(const P of w){const E=b.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var de=this&&this.__decorate||function(J,e,L,n){var k=arguments.length,_=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,L):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(J,e,L,n);else for(var R=J.length-1;R>=0;R--)(T=J[R])&&(_=(k<3?T(_):k>3?T(e,L,_):T(e,L))||_);return k>3&&_&&Object.defineProperty(e,L,_),_};define(ne[36],ie([0,1,16,5,17,25,53,8,3,2,108,27,15]),function(J,e,L,n,k,_,T,R,b,w,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function f(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function C(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(d||(d={}));class S{constructor(q){this.buffer=q,this.pos=0}read(q){const X=this.buffer.slice(this.pos,this.pos+q);return this.pos+=X.byteLength,X}}class m{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var l;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(l||(l={}));function u(B){const q=k.VSBuffer.alloc(4);return q.writeUInt32BE(B,0),q}function r(B){return B.read(4).readUInt32BE(0)}function a(B){const q=k.VSBuffer.alloc(1);return q.writeUInt8(B,0),q}const i={Undefined:a(l.Undefined),String:a(l.String),Buffer:a(l.Buffer),VSBuffer:a(l.VSBuffer),Array:a(l.Array),Object:a(l.Object)},t=typeof Buffer!="undefined";function s(B,q){if(typeof q=="undefined")B.write(i.Undefined);else if(typeof q=="string"){const X=k.VSBuffer.fromString(q);B.write(i.String),B.write(u(X.byteLength)),B.write(X)}else if(t&&Buffer.isBuffer(q)){const X=k.VSBuffer.wrap(q);B.write(i.Buffer),B.write(u(X.byteLength)),B.write(X)}else if(q instanceof k.VSBuffer)B.write(i.VSBuffer),B.write(u(q.byteLength)),B.write(q);else if(Array.isArray(q)){B.write(i.Array),B.write(u(q.length));for(const X of q)s(B,X)}else{const X=k.VSBuffer.fromString(JSON.stringify(q));B.write(i.Object),B.write(u(X.byteLength)),B.write(X)}}function o(B){switch(B.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return B.read(r(B)).toString();case l.Buffer:return B.read(r(B)).buffer;case l.VSBuffer:return B.read(r(B));case l.Array:{const X=r(B),G=[];for(let ee=0;ee<X;ee++)G.push(o(B));return G}case l.Object:return JSON.parse(B.read(r(B)).toString())}}class c{constructor(q,X,G=null,ee=1e3){this.protocol=q,this.ctx=X,this.logger=G,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(q,X){this.channels.set(q,X),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const X=this.send([q.type]);this.logger&&this.logger.logOutgoing(X,0,1,C(q.type));return}case 201:case 202:case 204:case 203:{const X=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(X,q.id,1,C(q.type),q.data);return}}}send(q,X=void 0){const G=new m;return s(G,q),s(G,X),this.sendBuffer(G.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const X=new S(q),G=o(X),ee=o(X),K=G[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,G[1],1,`${f(K)}: ${G[2]}.${G[3]}`,ee),this.onPromise({type:K,id:G[1],channelName:G[2],name:G[3],arg:ee});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,G[1],1,`${f(K)}: ${G[2]}.${G[3]}`,ee),this.onEventListen({type:K,id:G[1],channelName:G[2],name:G[3],arg:ee});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,G[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,G[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:G[1]})}}onPromise(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const G=new _.CancellationTokenSource;let ee;try{ee=X.call(this.ctx,q.name,q.arg,G.token)}catch(j){ee=Promise.reject(j)}const K=q.id;ee.then(j=>{this.sendResponse({id:K,data:j,type:201}),this.activeRequests.delete(q.id)},j=>{j instanceof Error?this.sendResponse({id:K,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:K,data:j,type:203}),this.activeRequests.delete(q.id)});const F=(0,w.toDisposable)(()=>G.cancel());this.activeRequests.set(q.id,F)}onEventListen(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const G=q.id,K=X.listen(this.ctx,q.name,q.arg)(F=>this.sendResponse({id:G,data:F,type:204}));this.activeRequests.set(q.id,K)}disposeActiveRequest(q){const X=this.activeRequests.get(q.id);X&&(X.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let X=this.pendingRequests.get(q.channelName);X||(X=[],this.pendingRequests.set(q.channelName,X));const G=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:q,timeoutTimer:G})}flushPendingRequests(q){const X=this.pendingRequests.get(q);if(X){for(const G of X)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var h;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(q,X=null){this.protocol=q,this.isDisposed=!1,this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=X}getChannel(q){const X=this;return{call(G,ee,K){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(q,G,ee,K)},listen(G,ee){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(q,G,ee)}}}requestPromise(q,X,G,ee=_.CancellationToken.None){const K=this.lastRequestId++,j={id:K,type:100,channelName:q,name:X,arg:G};if(ee.isCancellationRequested)return Promise.reject(R.canceled());let H;return new Promise((x,re)=>{if(ee.isCancellationRequested)return re(R.canceled());const se=()=>{const ge=ye=>{switch(ye.type){case 201:this.handlers.delete(K),x(ye.data);break;case 202:{this.handlers.delete(K);const pe=new Error(ye.data.message);pe.stack=ye.data.stack,pe.name=ye.data.name,re(pe);break}case 203:this.handlers.delete(K),re(ye.data);break}};this.handlers.set(K,ge),this.sendRequest(j)};let ce=null;this.state===d.Idle?se():(ce=(0,n.createCancelablePromise)(ge=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:K,type:101}),re(R.canceled())},Se=ee.onCancellationRequested(he);H=(0,w.combinedDisposable)((0,w.toDisposable)(he),Se),this.activeRequests.add(H)}).finally(()=>{this.activeRequests.delete(H)})}requestEvent(q,X,G){const ee=this.lastRequestId++,F={id:ee,type:102,channelName:q,name:X,arg:G};let j=null;const H=new b.Emitter({onFirstListenerAdd:()=>{j=(0,n.createCancelablePromise)(x=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(H),this.sendRequest(F)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(H),this.sendRequest({id:ee,type:103}))}}),W=x=>H.fire(x.data);return this.handlers.set(ee,W),H.event}sendRequest(q){switch(q.type){case 100:case 102:{const X=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(X,q.id,0,`${f(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const X=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(X,q.id,0,f(q.type));return}}}send(q,X=void 0){const G=new m;return s(G,q),s(G,X),this.sendBuffer(G.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const X=new S(q),G=o(X),ee=o(X),K=G[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,C(K)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,G[1],0,C(K),ee),this.onResponse({type:G[0],id:G[1],data:ee})}}onResponse(q){if(q.type===200){this.state=d.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(q.id);X&&X(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([T.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:X,onDidClientDisconnect:G})=>{b.Event.once(X.onMessage)(K=>{const F=new S(K),j=o(F),H=new c(X,j),W=new v(X);this.channels.forEach((re,se)=>H.registerChannel(se,re));const x={channelServer:H,channelClient:W,ctx:j};this._connections.add(x),this._onDidAddConnection.fire(x),G(()=>{H.dispose(),W.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)})})})}get connections(){const q=[];return this._connections.forEach(X=>q.push(X)),q}getChannel(q,X){const G=this;return{call(ee,K,F){let j;if((0,g.isFunction)(X)){let W=(0,L.getRandomElement)(G.connections.filter(X));j=W?Promise.resolve(W):b.Event.toPromise(b.Event.filter(G.onDidAddConnection,X))}else j=X.routeCall(G,ee,K);const H=j.then(W=>W.channelClient.getChannel(q));return O(H).call(ee,K,F)},listen(ee,K){if((0,g.isFunction)(X))return G.getMulticastEvent(q,X,ee,K);const F=X.routeEvent(G,ee,K).then(j=>j.channelClient.getChannel(q));return O(F).listen(ee,K)}}}getMulticastEvent(q,X,G,ee){const K=this;let F=new w.DisposableStore;const j=new b.Emitter({onFirstListenerAdd:()=>{F=new w.DisposableStore;const H=new b.EventMultiplexer,W=new Map,x=se=>{const he=se.channelClient.getChannel(q).listen(G,ee),Se=H.add(he);W.set(se,Se)},re=se=>{const ce=W.get(se);!ce||(ce.dispose(),W.delete(se))};K.connections.filter(X).forEach(x),b.Event.filter(K.onDidAddConnection,X)(x,void 0,F),K.onDidRemoveConnection(re,void 0,F),H.event(j.fire,j,F),F.add(H)},onLastListenerRemove:()=>{F.dispose()}});return j.event}registerChannel(q,X){this.channels.set(q,X),this._connections.forEach(G=>{G.channelServer.registerChannel(q,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class A{constructor(q,X,G=null){const ee=new m;s(ee,X),q.send(ee.buffer),this.channelClient=new v(q,G),this.channelServer=new c(q,X,G)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,X){this.channelServer.registerChannel(q,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function O(B){return{call(q,X,G){return B.then(ee=>ee.call(q,X,G))},listen(q,X){const G=new b.Relay;return B.then(ee=>G.input=ee.listen(q,X)),G.event}}}e.getDelayedChannel=O;function N(B){let q=!1;return{call(X,G,ee){return q?B.call(X,G,ee):(0,n.timeout)(0).then(()=>q=!0).then(()=>B.call(X,G,ee))},listen(X,G){if(q)return B.listen(X,G);const ee=new b.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>ee.input=B.listen(X,G)),ee.event}}}e.getNextTickChannel=N;class ${constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const X of q.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=$;var D;(function(B){function q(K,F){const j=K,H=F&&F.disableMarshalling,W=new Map;for(const x in j)G(x)&&W.set(x,b.Event.buffer(j[x],!0));return new class{listen(x,re,se){const ce=W.get(re);if(ce)return ce;if(ee(re)){const he=j[re];if(typeof he=="function")return he.call(j,se)}throw new Error(`Event not found: ${re}`)}call(x,re,se){const ce=j[re];if(typeof ce=="function"){if(!H&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(j,se)}throw new Error(`Method not found: ${re}`)}}}B.fromService=q;function X(K,F){const j=F&&F.disableMarshalling;return new Proxy({},{get(H,W){if(typeof W=="string")return F?.properties?.has(W)?F.properties.get(W):ee(W)?function(x){return K.listen(W,x)}:G(W)?K.listen(W):async function(...x){let re;F&&!(0,g.isUndefinedOrNull)(F.context)?re=[F.context,...x]:re=x;const se=await K.call(W,re);return j?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(W)}`)}})}B.toService=X;function G(K){return K[0]==="o"&&K[1]==="n"&&E.isUpperAsciiLetter(K.charCodeAt(2))}function ee(K){return/^onDynamic/.test(K)&&E.isUpperAsciiLetter(K.charCodeAt(9))}})(D=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let q=B.toString();if(q!=="[object Object]")return q}return B}function U(B){return Array.isArray(B)?B.map(z):z(B)}function V(B,q,X,G,ee,K,F){F=U(F);const j=M[ee],H=j[G%j.length];let W=[`%c[${B}]%c[${String(q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(K)?(W=W.concat(F),W.push(")")):W.push(F),console.log.apply(console,W)}e.logWithColors=V;class Y{constructor(q,X){this._outgoingPrefix=q,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,X,G,ee,K){this._totalOutgoing+=q,V(this._outgoingPrefix,this._totalOutgoing,q,X,G,ee,K)}logIncoming(q,X,G,ee,K){this._totalIncoming+=q,V(this._incomingPrefix,this._totalIncoming,q,X,G,ee,K)}}e.IPCLogger=Y}),define(ne[117],ie([0,1,17,3,36]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",w=>L.VSBuffer.wrap(w.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class T extends k.IPCClient{constructor(b,w){const P=new _(b);super(P,w);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[71],ie([0,1,17,3,2,36]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(v,I){if(!s.has(v)){const A=String(++o);s.set(v,A)}return s.get(v)}function h(v,I,A,O){if(!t.enableDiagnostics)return;const N=c(v,I);if(O instanceof L.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const $=L.VSBuffer.alloc(O.byteLength);$.set(O),t.records.push({timestamp:Date.now(),id:N,label:I,type:A,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:A,data:O})}t.traceSocketEvent=h})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function P(){return w||(w=L.VSBuffer.alloc(0)),w}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let c=L.VSBuffer.alloc(s),h=0,v=0;for(;s>0;){const I=this._chunks[v];if(I.byteLength>s){const A=I.slice(0,s);c.set(A,h),h+=s,o&&(this._chunks[v]=I.slice(s),this._totalLength-=s),s-=s}else c.set(I,h),h+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):v++,s-=I.byteLength}return c}}e.ChunkStream=E;var g;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(g||(g={}));function p(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var f;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,o,c,h){this.type=s,this.id=o,this.ack=c,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(s){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,h=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new y(c,h,v,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=L.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const c=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,c}_bufferTake(){const s=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class S extends k.Disposable{constructor(s){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=S;class m extends _.IPCClient{constructor(s,o,c=null){super(s,o,c);this.protocol=s}static fromSocket(s,o){return new m(new S(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=m;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class u{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,c=this._first;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new u(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let h=0;h<a._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=o&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(s,o=null,c=a.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let c=0,h=o.length;c<h;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new y(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,h=o.length;c<h;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new y(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const o=new y(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-o,2e4-c,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,72,3,36,117]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends k.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(w,P)=>P);return n.Event.map(b,w=>{const{port1:P,port2:E}=new MessageChannel,p={protocol:new _.Protocol(P),onDidClientDisconnect:n.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[E]),p})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[119],ie([0,1,17,8]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((P,E)=>{w.open(R.type||"GET",R.url||"",!0,R.user,R.password),_(w,R),w.responseType="arraybuffer",w.onerror=g=>E(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=g=>{P({res:{statusCode:w.status,headers:T(w)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=g=>E(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(w.timeout=R.timeout),w.send(R.data),b.onCancellationRequested(()=>{w.abort(),E((0,n.canceled)())})})}e.request=k;function _(R,b){if(b.headers){e:for(let w in b.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(w,b.headers[w])}}}function T(R){const b=Object.create(null);for(const w of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const P=w.indexOf(":");b[w.substr(0,P).trim().toLowerCase()]=w.substr(P+1).trim()}return b}}),define(ne[73],ie([0,1,5,3,2,15]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function R(E){const g=E;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b||(b={}));class w extends k.Disposable{constructor(g,p=Object.create(null)){super();this.database=g,this.options=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((p,f)=>this.accept(f,p)),g.deleted?.forEach(p=>this.accept(p,void 0))}accept(g,p){if(this.state===b.Closed)return;let f=!1;(0,_.isUndefinedOrNull)(p)?f=this.cache.delete(g):this.cache.get(g)!==p&&(this.cache.set(g,p),f=!0),f&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,p){const f=this.cache.get(g);return(0,_.isUndefinedOrNull)(f)?p:f}getBoolean(g,p){const f=this.get(g);return(0,_.isUndefinedOrNull)(f)?p:f==="true"}getNumber(g,p){const f=this.get(g);return(0,_.isUndefinedOrNull)(f)?p:parseInt(f,10)}async set(g,p){if(this.state===b.Closed)return;if((0,_.isUndefinedOrNull)(p))return this.delete(g);const f=String(p);if(this.cache.get(g)!==f)return this.cache.set(g,f),this.pendingInserts.set(g,f),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===b.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((p,f)=>this.items.set(f,p)),g.delete&&g.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[120],ie([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[56],ie([0,1,120]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,_=k*24,T=_*7,R=_*30,b=_*365;function w(E,g){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,L.localize)(0,null,w(new Date().getTime()+p*1e3,!1));if(p<30)return(0,L.localize)(1,null);let f;return p<n?(f=p,g?f===1?(0,L.localize)(2,null,f):(0,L.localize)(3,null,f):f===1?(0,L.localize)(4,null,f):(0,L.localize)(5,null,f)):p<k?(f=Math.floor(p/n),g?f===1?(0,L.localize)(6,null,f):(0,L.localize)(7,null,f):f===1?(0,L.localize)(8,null,f):(0,L.localize)(9,null,f)):p<_?(f=Math.floor(p/k),g?f===1?(0,L.localize)(10,null,f):(0,L.localize)(11,null,f):f===1?(0,L.localize)(12,null,f):(0,L.localize)(13,null,f)):p<T?(f=Math.floor(p/_),g?f===1?(0,L.localize)(14,null,f):(0,L.localize)(15,null,f):f===1?(0,L.localize)(16,null,f):(0,L.localize)(17,null,f)):p<R?(f=Math.floor(p/T),g?f===1?(0,L.localize)(18,null,f):(0,L.localize)(19,null,f):f===1?(0,L.localize)(20,null,f):(0,L.localize)(21,null,f)):p<b?(f=Math.floor(p/R),g?f===1?(0,L.localize)(22,null,f):(0,L.localize)(23,null,f):f===1?(0,L.localize)(24,null,f):(0,L.localize)(25,null,f)):(f=Math.floor(p/b),g?f===1?(0,L.localize)(26,null,f):(0,L.localize)(27,null,f):f===1?(0,L.localize)(28,null,f):(0,L.localize)(29,null,f))}e.fromNow=w;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[121],ie([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,121]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(w,P){return P&&(w.stack||w.stacktrace)?k.localize(0,null,R(w),T(w.stack)||T(w.stacktrace)):R(w)}function T(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function b(w=null,P=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const E=L.coalesce(w),g=b(E[0],P);return E.length>1?k.localize(4,null,g,E.length):g}if(n.isString(w))return w;if(w.detail){const E=w.detail;if(E.error)return _(E.error,P);if(E.exception)return _(E.exception,P)}return w.stack?_(w,P):w.message?w.message:k.localize(5,null)}e.toErrorMessage=b}),define(ne[122],ie([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ne[74],ie([0,1,45,41,18,28,9,4,31,102,15,111,22,122]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function f(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(r,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const t=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,c)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?f(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{L.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function C(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=C;function d(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=d;class S{constructor(a,i,t,s){if(i!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=i,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(b.env).forEach(c=>{o[c]=b.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(T.sep);return i!==-1&&(a=a.substring(i+1)),S.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(i=>{let t,s;const o=new Promise((c,h)=>{t=c,s=h});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=L.exec(c,this.options,(h,v,I)=>{this.childProcess=null;const A=h;A&&A.killed?s({killed:this.terminateRequested,stdout:v.toString(),stderr:I.toString()}):this.handleExec(t,a,h,v,I)})}else{let c=null;const h=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(v)&&(I.cmdCode=v),t(I)};if(this.shell&&R.isWindows){const v=_.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let I=!1,A=!1;const O=[];let N=this.ensureQuotes(this.cmd);O.push(N.value),I=N.quoted,this.args&&this.args.forEach(D=>{N=this.ensureQuotes(D),O.push(N.value),A=A&&N.quoted});const $=["/s","/c"];I?A?$.push('"'+O.join(" ")+'"'):O.length>1?$.push('"'+O[0]+'" '+O.slice(1).join(" ")):$.push('"'+O[0]+'"'):$.push(O.join(" ")),c=L.spawn(d(),$,v)}else this.cmd&&(c=L.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(P.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",v=>{this.childProcess=null,s({terminated:this.terminateRequested,error:v})}),c.pid&&(this.childProcess.on("close",h),this.handleSpawn(c,t,a,s,!0)))}return o})}handleClose(a,i,t,s){}ensureQuotes(a){return S.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,y(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=L.spawn(d(),["/s","/c"]);i.on("error",t=>a(!0)),i.on("exit",t=>a(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class m extends S{constructor(a,i,t,s){super(a,i,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,t,s,o){[s,o].forEach((c,h)=>{const v=new E.LineDecoder;v.write(c).forEach(O=>{i({line:O,source:h===0?0:1})});const A=v.end();A&&i({line:A,source:h===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,i,t,s,o){const c=new E.LineDecoder,h=new E.LineDecoder;a.stdout.on("data",v=>{c.write(v).forEach(A=>t({line:A,source:0}))}),a.stderr.on("data",v=>{h.write(v).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=h}handleClose(a,i,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=m;function l(r){let a=[],i=!1;const t=function(s){if(i){a.push(s);return}(!r.send(s,c=>{if(c&&console.error(c),i=!1,a.length>0){const h=a.slice(0);a=[],h.forEach(v=>t(v))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=l;var u;(function(r){async function a(i,t,s){if(T.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),T.dirname(i)!=="."||(s===void 0&&P.isString(b.env.PATH)&&(s=b.env.PATH.split(T.delimiter)),s===void 0||s.length===0))return T.join(t,i);async function c(h){if(await g.Promises.exists(h)){let v;try{v=await g.Promises.stat(h)}catch(I){I.message.startsWith("EACCES")&&(v=await g.Promises.lstat(h))}return v?!v.isDirectory():!1}return!1}for(let h of s){let v;if(T.isAbsolute(h)?v=T.join(h,i):v=T.join(t,h,i),await c(v))return v;let I=v+".com";if(await c(I)||(I=v+".exe",await c(I)))return I}return T.join(t,i)}r.findExecutable=a})(u=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,32,4,70,74]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(p,f){return p===1?n.isWindows?E():_.getWindowsShell(f):w(p,f)}e.getSystemShell=T;function R(p,f){return p===1?n.isWindows?g(f):_.getWindowsShell(f):w(p,f)}e.getSystemShellSync=R;let b=null;function w(p,f){if(n.isLinux&&p===2||n.isMacintosh&&p===3)return"/bin/bash";if(!b){let y;if(n.isWindows)y="/bin/bash";else{if(y=f.SHELL,!y)try{y=(0,L.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}b=y}return b}let P=null;async function E(){return P||(P=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),P}function g(p){if(P)return P;const f=n.isWindows&&parseFloat((0,L.release)())>=10,y=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${p.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?C:_.getWindowsShell(p)}}),define(ne[57],ie([0,1,45,5,17,25,107,8,3,2,28,74,36]),function(J,e,L,n,k,_,T,R,b,w,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends g.ChannelServer{constructor(C){super({send:d=>{try{process.send&&process.send(d.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",d=>k.VSBuffer.wrap(Buffer.from(d,"base64")))},C);process.once("disconnect",()=>this.dispose())}}e.Server=p;class f{constructor(C,d){this.modulePath=C,this.options=d,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=d&&d.timeout?d.timeout:6e4;this.disposeDelayer=new n.Delayer(S),this.child=null,this._client=null}getChannel(C){const d=this;return{call(S,m,l){return d.requestPromise(C,S,m,l)},listen(S,m){return d.requestEvent(C,S,m)}}}requestPromise(C,d,S,m=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(C),u=(0,n.createCancelablePromise)(i=>l.call(d,S,i)),r=m.onCancellationRequested(()=>u.cancel()),a=(0,w.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(C,d,S){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let m;const l=new b.Emitter({onFirstListenerAdd:()=>{m=this.getCachedChannel(C).listen(d,S)(l.fire,l),this.activeRequests.add(m)},onLastListenerRemove:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const C=this.options&&this.options.args?this.options.args:[],d=Object.create(null);d.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(d.env={...d.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(d.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(d.env),this.child=(0,L.fork)(this.modulePath,C,d);const S=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}S.fire(k.VSBuffer.wrap(Buffer.from(t,"base64")))});const l=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,u=t=>this.child&&this.child.connected&&l.send(t.buffer.toString("base64")),r=S.event,a={send:u,onMessage:r};this._client=new g.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",i),this.activeRequests.forEach(o=>(0,w.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(C){let d=this.channels.get(C);return d||(d=this.client.getChannel(C),this.channels.set(C,d)),d}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=f}),define(ne[124],ie([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(T){T.Team="team",T.Internal="internal",T.Insiders="insider",T.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var k;(function(T){T.Market="X-MSEdge-Market",T.CorpNet="X-FD-Corpnet",T.ApplicationVersion="X-VSCode-AppVersion",T.Build="X-VSCode-Build",T.ClientId="X-MSEdge-ClientId",T.ExtensionName="X-VSCode-ExtensionName",T.Language="X-VSCode-Language",T.TargetPopulation="X-VSCode-TargetPopulation"})(k=e.Filters||(e.Filters={}));class _{constructor(R,b,w,P){this.version=R,this.appName=b,this.machineId=w,this.targetPopulation=P}getFilterValue(R){switch(R){case k.ApplicationVersion:return this.version;case k.Build:return this.appName;case k.ClientId:return this.machineId;case k.Language:return L.language;case k.ExtensionName:return"vscode-core";case k.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(k);for(let w of b)R.set(w,this.getFilterValue(w));return R}}e.AssignmentFilterProvider=_}),define(ne[75],ie([0,1,56,53,18,9,31,19,7]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(y,C,d){this._args=y,this.paths=C,this.productService=d}get appRoot(){return(0,_.dirname)(k.FileAccess.asFileUri("",J).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,_.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=T.env.VSCODE_PORTABLE;return y?b.URI.file((0,_.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,_.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,_.resolve)(y):(0,_.normalize)((0,_.join)(k.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,_.resolve)(y):(0,_.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,_.resolve)(y);const C=T.env.VSCODE_EXTENSIONS;if(C)return C;const d=T.env.VSCODE_PORTABLE;return d?(0,_.join)(d,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(C=>/^[^:/?#]+?:\/\//.test(C)?b.URI.parse(C):b.URI.file((0,_.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?b.URI.parse(y):b.URI.file((0,_.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,_.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],w.prototype,"appRoot",null),de([n.memoize],w.prototype,"userHome",null),de([n.memoize],w.prototype,"userDataPath",null),de([n.memoize],w.prototype,"appSettingsHome",null),de([n.memoize],w.prototype,"tmpDir",null),de([n.memoize],w.prototype,"cacheHome",null),de([n.memoize],w.prototype,"userRoamingDataHome",null),de([n.memoize],w.prototype,"settingsResource",null),de([n.memoize],w.prototype,"userDataSyncHome",null),de([n.memoize],w.prototype,"userDataSyncLogResource",null),de([n.memoize],w.prototype,"sync",null),de([n.memoize],w.prototype,"machineSettingsResource",null),de([n.memoize],w.prototype,"globalStorageHome",null),de([n.memoize],w.prototype,"workspaceStorageHome",null),de([n.memoize],w.prototype,"keybindingsResource",null),de([n.memoize],w.prototype,"keyboardLayoutResource",null),de([n.memoize],w.prototype,"argvResource",null),de([n.memoize],w.prototype,"snippetsHome",null),de([n.memoize],w.prototype,"isExtensionDevelopment",null),de([n.memoize],w.prototype,"untitledWorkspacesHome",null),de([n.memoize],w.prototype,"installSourcePath",null),de([n.memoize],w.prototype,"builtinExtensionsPath",null),de([n.memoize],w.prototype,"extensionsPath",null),de([n.memoize],w.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],w.prototype,"extensionDevelopmentKind",null),de([n.memoize],w.prototype,"extensionTestsLocationURI",null),de([n.memoize],w.prototype,"debugExtensionHost",null),de([n.memoize],w.prototype,"serviceMachineIdResource",null),de([n.memoize],w.prototype,"telemetryLogResource",null),de([n.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function P(f,y){return p(f["inspect-extensions"],f["inspect-brk-extensions"],5870,y,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=P;function E(f,y){return p(f["inspect-search"],f["inspect-brk-search"],5876,y,f.extensionEnvironment)}e.parseSearchPort=E;function g(f,y){return p(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,y,f.extensionEnvironment)}e.parsePtyHostPort=g;function p(f,y,C,d,S,m){const u=Number(y||f)||(d?null:C),r=u?Boolean(!!y):!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:u,break:r,debugId:S,env:a}}}),define(ne[150],ie([0,1,249,4,126]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(f,y,C=T){const d={},S=[],m=[];for(let a in y){const i=y[a];i.alias&&(d[a]=i.alias),i.type==="string"||i.type==="string[]"?(S.push(a),i.deprecates&&S.push(...i.deprecates)):i.type==="boolean"&&(m.push(a),i.deprecates&&m.push(...i.deprecates))}const l=L(f,{string:S,boolean:m,alias:d}),u={},r=l;u._=l._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in y){const i=y[a];i.alias&&delete r[i.alias];let t=r[a];if(i.deprecates)for(const s of i.deprecates)r.hasOwnProperty(s)&&(t||(t=r[s],t&&C.onDeprecatedOption(s,a)),delete r[s]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),C.onMultipleValues(a,t)),u[a]=t),delete r[a]}for(let a in r)C.onUnknownOption(a);return u}e.parseArgs=R;function b(f,y){let C="";return y.args&&(Array.isArray(y.args)?C=` <${y.args.join("> <")}>`:C=` <${y.args}>`),y.alias?`-${y.alias} --${f}${C}`:`--${f}${C}`}function w(f,y){let C=0,d=[];for(const u in f){const r=f[u],a=b(u,r);C=Math.max(C,a.length),d.push([a,r.description])}let S=C+2+1;if(y-S<25)return d.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let m=y-S-1,l=[];for(const u of d){let r=u[0],a=E(u[1],m),i=P(S-r.length-2);l.push("  "+r+i+a[0]);for(let t=1;t<a.length;t++)l.push(P(S)+a[t])}return l}e.formatOptions=w;function P(f){return" ".repeat(f)}function E(f,y){let C=[];for(;f.length;){let d=f.length<y?f.length:f.lastIndexOf(" ",y),S=f.slice(0,d).trim();f=f.slice(d),C.push(S)}return C}function g(f,y,C,d,S){const m=process.stdout.isTTY&&process.stdout.columns||80,l=S?.noInputFiles!==!0?`[${(0,k.localize)(33,null)}...]`:"",u=[`${f} ${C}`];u.push(""),u.push(`${(0,k.localize)(34,null)}: ${y} [${(0,k.localize)(35,null)}]${l}`),u.push(""),S?.noPipe!==!0&&(n.isWindows?u.push((0,k.localize)(36,null,y)):u.push((0,k.localize)(37,null,y)),u.push(""));const r={};for(const a in d){const i=d[a];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[a]=i}}for(let a in r){const i=a;let t=r[i];t&&(u.push(_[i]),u.push(...w(t,m)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=g;function p(f,y){return`${f||(0,k.localize)(38,null)}
${y||(0,k.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function J(e,L,n,k){function _(R){const b=T(R),w=[b];return e.isAbsolute(b)||w.unshift(k),e.resolve(...w)}function T(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,n);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(E,"AppData","Roaming")}break;case"darwin":w=e.join(L.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,n)}return{getUserDataPath:_}}if(typeof define=="function")define(ne[151],ie([0,152,32,18,19,31]),function(e,L,n,k,_,T){const R=_.dirname(k.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(_.joinPath(R,"package.json").fsPath);return J(L,n,b.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),L=require("path"),n=require("os");module.exports=J(L,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[153],ie([0,1,32,75,151]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class _ extends n.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,k.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=_}),define(ne[154],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,_=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(C){const d=C.match(T);return d?d[1]:null}function P(C){if(C.indexOf("://")===-1){const d=C.match(n);return d?w(d[2]):null}try{const d=L.URI.parse(C);if(d.authority)return w(d.authority)}catch{}return null}function E(C,d){const S=new Set;let m;for(;m=R.exec(C);){const u=P(m[1]);u&&S.add(u)}const l=new Set(d);return Array.from(S).map(u=>l.has(u)?u:u.replace(b,"a"))}e.getDomainsOfRemotes=E;function g(C){const d=C.match(_);return d?d[2]:null}function p(C,d,S){return C&&d?(S&&d.endsWith(".git")&&(d=d.substr(0,d.length-4)),d.indexOf("/")===0?`${C}${d}`:`${C}/${d}`):null}function f(C,d){if(C.indexOf("://")===-1){const S=C.match(k);if(S)return p(S[2],S[3],d)}try{const S=L.URI.parse(C);if(S.authority)return p(g(S.authority),S.path,d)}catch{}return null}function y(C,d=!1){const S=[];let m;for(;m=R.exec(C);){const l=f(m[1],d);l&&S.push(l)}return S}e.getRemotes=y}),define(ne[155],ie([0,1,28]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function k(_,T){const R=b=>{if(typeof b!="string")return;const w=n.exec(b);if(!w)return;const P=T[w[1]]??b;return typeof P=="string"?P:typeof P.message=="string"?P.message:b};return(0,L.cloneAndChange)(_,R)}e.localizeManifest=k}),define(ne[156],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(_){this.channel=_}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(_,T,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[_,T,R,b])}promptWorkspaceRecommendations(_){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class n{constructor(_){this.service=_}listen(_,T){throw new Error(`Event not found: ${T}`)}call(_,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[76],ie([0,1,135]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function _(g){return g=g.trim(),g==="*"||n.test(g)}e.isValidVersionStr=_;function T(g){if(!_(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=g.match(n);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=T;function R(g){if(!g)return null;let p=g.majorBase,f=g.majorMustEqual,y=g.minorBase,C=g.minorMustEqual,d=g.patchBase,S=g.patchMustEqual;g.hasCaret&&(p===0||(C=!1),S=!1);let m=0;if(g.preRelease){const l=k.exec(g.preRelease);if(l){const[,u,r,a]=l;m=Date.UTC(Number(u),Number(r)-1,Number(a))}}return{majorBase:p,majorMustEqual:f,minorBase:y,minorMustEqual:C,patchBase:d,patchMustEqual:S,isMinimum:g.hasGreaterEquals,notBefore:m}}e.normalizeVersion=R;function b(g,p,f){let y;typeof g=="string"?y=R(T(g)):y=g;let C;p instanceof Date?C=p.getTime():typeof p=="string"&&(C=new Date(p).getTime());let d;if(typeof f=="string"?d=R(T(f)):d=f,!y||!d)return!1;let S=y.majorBase,m=y.minorBase,l=y.patchBase,u=d.majorBase,r=d.minorBase,a=d.patchBase,i=d.notBefore,t=d.majorMustEqual,s=d.minorMustEqual,o=d.patchMustEqual;return d.isMinimum?S>u?!0:S<u?!1:m>r?!0:m<r||C&&C<i?!1:l>=a:(S===1&&u===0&&(!t||!s||!o)&&(u=1,r=0,a=0,t=!0,s=!1,o=!1),S<u?!1:S>u?!t:m<r?!1:m>r?!s:l<a?!1:l>a?!o:!(C&&C<i))}e.isValidVersion=b;function w(g,p,f,y){return f.isBuiltin||typeof f.main=="undefined"?!0:E(g,p,f.engines.vscode,y)}e.isValidExtensionVersion=w;function P(g,p,f){return g==="*"||E(p,f,g)}e.isEngineValid=P;function E(g,p,f,y=[]){let C=R(T(f));if(!C)return y.push(L.localize(0,null,f)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return y.push(L.localize(1,null,f)),!1}else if(!C.majorMustEqual)return y.push(L.localize(2,null,f)),!1;return b(g,p,C)?!0:(y.push(L.localize(3,null,g,f)),!1)}}),define(ne[51],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(k,_=[],T=!1){this.ctor=k,this.staticArguments=_,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=L}),define(ne[77],ie([0,1,51]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function k(T,R,b){R instanceof L.SyncDescriptor||(R=new L.SyncDescriptor(R,[],b)),n.push([T,R])}e.registerSingleton=k;function _(){return n}e.getSingletonServiceDescriptors=_}),define(ne[157],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=L;class n{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let T of this._nodes.values())T.outgoing.size===0&&_.push(T);return _}insertEdge(_,T){const R=this.lookupOrInsertNode(_),b=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),b),b.incoming.set(this._hashFn(_),R)}removeNode(_){const T=this._hashFn(_);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(_){const T=this._hashFn(_);let R=this._nodes.get(T);return R||(R=new L(_),this._nodes.set(T,R)),R}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[T,R]of this._nodes)_.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,T]of this._nodes){const R=new Set([_]),b=this._findCycle(T,R);if(b)return b}}_findCycle(_,T){for(let[R,b]of _.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const w=this._findCycle(b,T);if(w)return w;T.delete(R)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(T,R,b,w){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:T,index:b,optional:w}):(R[L.DI_DEPENDENCIES]=[{id:T,index:b,optional:w}],R[L.DI_TARGET]=R)}function k(T){if(L.serviceIds.has(T))return L.serviceIds.get(T);const R=function(b,w,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,b,P,!1)};return R.toString=()=>T,L.serviceIds.set(T,R),R}e.createDecorator=k;function _(T){return T}e.refineServiceDecorator=_}),define(ne[158],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(ne[20],ie([0,1,15,7,6]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function _(C){return C&&typeof C=="object"&&(!C.overrideIdentifier||typeof C.overrideIdentifier=="string")&&(!C.resource||C.resource instanceof n.URI)}e.isConfigurationOverrides=_;function T(C){return C&&typeof C=="object"&&(!C.overrideIdentifiers||L.isArray(C.overrideIdentifiers))&&!C.overrideIdentifier&&(!C.resource||C.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(C){C[C.USER=1]="USER",C[C.USER_LOCAL=2]="USER_LOCAL",C[C.USER_REMOTE=3]="USER_REMOTE",C[C.WORKSPACE=4]="WORKSPACE",C[C.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",C[C.DEFAULT=6]="DEFAULT",C[C.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(C){switch(C){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function w(C,d){const S=Object.create(null);for(let m in C)P(S,m,C[m],d);return S}e.toValuesTree=w;function P(C,d,S,m){const l=d.split("."),u=l.pop();let r=C;for(let a=0;a<l.length;a++){let i=l[a],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${d} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[u]=S}catch{m(`Ignoring ${d} as ${l.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${d} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function E(C,d){const S=d.split(".");g(C,S)}e.removeFromValueTree=E;function g(C,d){const S=d.shift();if(d.length===0){delete C[S];return}if(Object.keys(C).indexOf(S)!==-1){const m=C[S];typeof m=="object"&&!Array.isArray(m)&&(g(m,d),Object.keys(m).length===0&&delete C[S])}}function p(C,d,S){function m(r,a){let i=r;for(const t of a){if(typeof i!="object"||i===null)return;i=i[t]}return i}const l=d.split("."),u=m(C,l);return typeof u=="undefined"?S:u}e.getConfigurationValue=p;function f(C,d,S){Object.keys(d).forEach(m=>{m!=="__proto__"&&(m in C?L.isObject(C[m])&&L.isObject(d[m])?f(C[m],d[m],S):S&&(C[m]=d[m]):C[m]=d[m])})}e.merge=f;function y(C,d,S){const m=C.inspect(d),l=C.inspect(S);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:m.defaultValue}e.getMigratedSettingValue=y}),define(ne[159],ie([0,1,4,27,6]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=L.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",L.isMacintosh),T.set("isLinux",L.isLinux),T.set("isWindows",L.isWindows),T.set("isWeb",L.isWeb),T.set("isMacNative",L.isMacintosh&&!L.isWeb),T.set("isEdge",_.indexOf("Edg/")>=0),T.set("isFirefox",_.indexOf("Firefox")>=0),T.set("isChrome",_.indexOf("Chrome")>=0),T.set("isSafari",_.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var b;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return g.INSTANCE}static true(){return p.INSTANCE}static has(D){return f.create(D)}static equals(D,M){return y.create(D,M)}static notEquals(D,M){return S.create(D,M)}static regex(D,M){return t.create(D,M)}static in(D,M){return C.create(D,M)}static not(D){return m.create(D)}static and(...D){return c.create(D,null)}static or(...D){return h.create(D,null,!0)}static greater(D,M){return u.create(D,M)}static greaterEquals(D,M){return r.create(D,M)}static smaller(D,M){return a.create(D,M)}static smallerEquals(D,M){return i.create(D,M)}static deserialize(D,M=!1){if(!!D)return this._deserializeOrExpression(D,M)}static _deserializeOrExpression(D,M){let z=D.split("||");return h.create(z.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(D,M){let z=D.split("&&");return c.create(z.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(D,M){if(D=D.trim(),D.indexOf("!=")>=0){let z=D.split("!=");return S.create(z[0].trim(),this._deserializeValue(z[1],M))}if(D.indexOf("==")>=0){let z=D.split("==");return y.create(z[0].trim(),this._deserializeValue(z[1],M))}if(D.indexOf("=~")>=0){let z=D.split("=~");return t.create(z[0].trim(),this._deserializeRegexValue(z[1],M))}if(D.indexOf(" in ")>=0){let z=D.split(" in ");return C.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const z=D.split(">=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const z=D.split(">");return u.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const z=D.split("<=");return i.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const z=D.split("<");return a.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(D)?m.create(D.substr(1).trim()):f.create(D)}static _deserializeValue(D,M){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let z=/^'([^']*)'$/.exec(D);return z?z[1].trim():D}static _deserializeRegexValue(D,M){if((0,n.isFalsyOrWhitespace)(D)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let z=D.indexOf("/"),U=D.lastIndexOf("/");if(z===U||z<0){if(M)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let V=D.slice(z+1,U),Y=D[U+1]==="i"?"i":"";try{return new RegExp(V,Y)}catch(B){if(M)throw new Error(`bad regexp-value '${D}', parse error: ${B}`);return console.warn(`bad regexp-value '${D}', parse error: ${B}`),null}}}e.ContextKeyExpr=w;function P($,D){const M=$?$.substituteConstants():void 0,z=D?D.substituteConstants():void 0;return!M&&!z?!0:!M||!z?!1:M.equals(z)}e.expressionsAreEqualWithConstantSubstitution=P;function E($,D){return $.cmp(D)}class g{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class p{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class f{constructor(D,M){this.key=D,this.negated=M,this.type=2}static create(D,M=null){const z=T.get(D);return typeof z=="boolean"?z?p.INSTANCE:g.INSTANCE:new f(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?p.INSTANCE:g.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class y{constructor(D,M,z){this.key=D,this.value=M,this.negated=z,this.type=4}static create(D,M,z=null){if(typeof M=="boolean")return M?f.create(D,z):m.create(D,z);const U=T.get(D);return typeof U=="boolean"?M===(U?"true":"false")?p.INSTANCE:g.INSTANCE:new y(D,M,z)}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const M=D?"true":"false";return this.value===M?p.INSTANCE:g.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class C{constructor(D,M){this.key=D,this.valueKey=M,this.type=10,this.negated=null}static create(D,M){return new C(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const M=D.getValue(this.valueKey),z=D.getValue(this.key);return Array.isArray(M)?M.indexOf(z)>=0:typeof z=="string"&&typeof M=="object"&&M!==null?R.call(M,z):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyInExpr=C;class d{constructor(D){this._actual=D,this.type=11}static create(D){return new d(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new d(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=d;class S{constructor(D,M,z){this.key=D,this.value=M,this.negated=z,this.type=5}static create(D,M,z=null){if(typeof M=="boolean")return M?m.create(D,z):f.create(D,z);const U=T.get(D);return typeof U=="boolean"?M===(U?"true":"false")?g.INSTANCE:p.INSTANCE:new S(D,M,z)}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=T.get(this.key);if(typeof D=="boolean"){const M=D?"true":"false";return this.value===M?g.INSTANCE:p.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class m{constructor(D,M){this.key=D,this.negated=M,this.type=3}static create(D,M=null){const z=T.get(D);return typeof z=="boolean"?z?g.INSTANCE:p.INSTANCE:new m(D,M)}cmp(D){return D.type!==this.type?this.type-D.type:I(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=T.get(this.key);return typeof D=="boolean"?D?g.INSTANCE:p.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function l($,D){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?D($):g.INSTANCE}class u{constructor(D,M,z){this.key=D,this.value=M,this.negated=z,this.type=12}static create(D,M,z=null){return l(M,U=>new u(D,U,z))}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class r{constructor(D,M,z){this.key=D,this.value=M,this.negated=z,this.type=13}static create(D,M,z=null){return l(M,U=>new r(D,U,z))}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(D,M,z){this.key=D,this.value=M,this.negated=z,this.type=14}static create(D,M,z=null){return l(M,U=>new a(D,U,z))}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class i{constructor(D,M,z){this.key=D,this.value=M,this.negated=z,this.type=15}static create(D,M,z=null){return l(M,U=>new i(D,U,z))}cmp(D){return D.type!==this.type?this.type-D.type:A(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(D,M){this.key=D,this.regexp=M,this.type=7,this.negated=null}static create(D,M){return new t(D,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const M=this.regexp?this.regexp.source:"",z=D.regexp?D.regexp.source:"";return M<z?-1:M>z?1:0}equals(D){if(D.type===this.type){const M=this.regexp?this.regexp.source:"",z=D.regexp?D.regexp.source:"";return this.key===D.key&&M===z}return!1}substituteConstants(){return this}evaluate(D){let M=D.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(D){this._actual=D,this.type=8}static create(D){return new s(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new s(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let D=null;for(let M=0,z=$.length;M<z;M++){const U=$[M].substituteConstants();if($[M]!==U&&D===null){D=[];for(let V=0;V<M;V++)D[V]=$[V]}D!==null&&(D[M]=U)}return D===null?$:D}class c{constructor(D,M){this.expr=D,this.negated=M,this.type=6}static create(D,M){return c._normalizeArr(D,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const U=E(this.expr[M],D.expr[M]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:c.create(D,this.negated)}evaluate(D){for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].evaluate(D))return!1;return!0}static _normalizeArr(D,M){const z=[];let U=!1;for(const V of D)if(!!V){if(V.type===1){U=!0;continue}if(V.type===0)return g.INSTANCE;if(V.type===6){z.push(...V.expr);continue}z.push(V)}if(z.length===0&&U)return p.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(E);for(let V=1;V<z.length;V++)z[V-1].equals(z[V])&&(z.splice(V,1),V--);if(z.length===1)return z[0];for(;z.length>1;){const V=z[z.length-1];if(V.type!==9)break;z.pop();const Y=z.pop(),B=z.length===0,q=h.create(V.expr.map(X=>c.create([X,Y],null)),null,B);q&&(z.push(q),z.sort(E))}return z.length===1?z[0]:new c(z,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let M of this.expr)D.push(...M.keys());return D}map(D){return new c(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.negated){const D=[];for(let M of this.expr)D.push(M.negate());this.negated=h.create(D,this,!0)}return this.negated}}class h{constructor(D,M){this.expr=D,this.negated=M,this.type=9}static create(D,M,z){return h._normalizeArr(D,M,z)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let M=0,z=this.expr.length;M<z;M++){const U=E(this.expr[M],D.expr[M]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let M=0,z=this.expr.length;M<z;M++)if(!this.expr[M].equals(D.expr[M]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:h.create(D,this.negated,!1)}evaluate(D){for(let M=0,z=this.expr.length;M<z;M++)if(this.expr[M].evaluate(D))return!0;return!1}static _normalizeArr(D,M,z){let U=[],V=!1;if(D){for(let Y=0,B=D.length;Y<B;Y++){const q=D[Y];if(!!q){if(q.type===0){V=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&V)return g.INSTANCE;U.sort(E)}if(U.length!==0){if(U.length===1)return U[0];for(let Y=1;Y<U.length;Y++)U[Y-1].equals(U[Y])&&(U.splice(Y,1),Y--);if(U.length===1)return U[0];if(z){for(let Y=0;Y<U.length;Y++)for(let B=Y+1;B<U.length;B++)O(U[Y],U[B])&&(U.splice(B,1),B--);if(U.length===1)return U[0]}return new h(U,M)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let M of this.expr)D.push(...M.keys());return D}map(D){return new h(this.expr.map(M=>M.map(D)),null)}negate(){if(!this.negated){let D=[];for(let M of this.expr)D.push(M.negate());for(;D.length>1;){const M=D.shift(),z=D.shift(),U=[];for(const Y of N(M))for(const B of N(z))U.push(c.create([Y,B],null));const V=D.length===0;D.unshift(h.create(U,null,V))}this.negated=D[0]}return this.negated}}class v extends f{constructor(D,M,z){super(D,null);this._defaultValue=M,typeof z=="object"?v._info.push({...z,key:D}):z!==!0&&v._info.push({key:D,description:z,type:M!=null?typeof M:void 0})}static all(){return v._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return S.create(this.key,D)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I($,D){return $<D?-1:$>D?1:0}function A($,D,M,z){return $<M?-1:$>M?1:D<z?-1:D>z?1:0}function O($,D){if(D.type===6&&$.type!==9&&$.type!==6){for(const U of D.expr)if($.equals(U))return!0}const M=$.negate(),z=N(M).concat(N(D));z.sort(E);for(let U=0;U<z.length;U++){const Y=z[U].negate();for(let B=U+1;B<z.length;B++){const q=z[B];if(Y.equals(q))return!0}}return!1}e.implies=O;function N($){return $.type===9?$.expr:[$]}}),define(ne[78],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function n(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=n}),define(ne[79],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(ne[13],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[30],ie([0,1,18,130,6]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function T(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function b(m,l){switch(m){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function w(m,l){return l==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function P(m,l,u){return w(l,u)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===u?!0:E(u).includes(m)}e.isTargetPlatformCompatible=P;function E(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function g(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=g;var p;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var f;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Install="install",m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var C;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(C=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var d;(function(m){m.Unsupported="Unsupported",m.UnsupportedPreRelease="UnsupportedPreRelease",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(d=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(l,u){super(l);this.code=u,this.name=u}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")});var Q=this&&this.__param||function(J,e){return function(L,n){e(L,n,J)}};define(ne[160],ie([0,1,2,30]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let k=class extends L.Disposable{constructor(T){super();T.removeDeprecatedExtensions(),T.migrateUnsupportedExtensions()}};k=de([Q(0,n.IExtensionManagementService)],k),e.ExtensionsCleaner=k}),define(ne[161],ie([0,1,3,2,28,7,110,30]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(y,C){return _.URI.revive(C?C.transformIncoming(y):y)}function w(y,C){return C?C.transformOutgoingURI(y):y}function P(y,C){C=C||T.DefaultURITransformer;const d=y.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...y,manifest:void 0},C),manifest:d}}function E(y,C){return C?(0,k.cloneAndChange)(y,d=>d instanceof _.URI?C.transformOutgoingURI(d):void 0):y}class g{constructor(C,d){this.service=C,this.getUriTransformer=d,this.onInstallExtension=L.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(C.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,d){const S=this.getUriTransformer(C);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,m=>m.map(l=>({...l,local:l.local?E(l.local,S):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,d,S){const m=this.getUriTransformer(C);switch(d){case"zip":return this.service.zip(P(S[0],m)).then(l=>w(l,m));case"unzip":return this.service.unzip(b(S[0],m));case"install":return this.service.install(b(S[0],m),S[1]);case"getManifest":return this.service.getManifest(b(S[0],m));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(S[0]);case"installFromGallery":return this.service.installFromGallery(S[0],S[1]);case"uninstall":return this.service.uninstall(P(S[0],m),S[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(S[0],m));case"getInstalled":return this.service.getInstalled(S[0]).then(l=>l.map(u=>E(u,m)));case"updateMetadata":return this.service.updateMetadata(P(S[0],m),S[1]).then(l=>E(l,m));case"updateExtensionScope":return this.service.updateExtensionScope(P(S[0],m),S[1]).then(l=>E(l,m));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class p extends n.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(d=>this._onInstallExtension.fire({identifier:d.identifier,source:this.isUriComponents(d.source)?_.URI.revive(d.source):d.source}))),this._register(this.channel.listen("onDidInstallExtensions")(d=>this._onDidInstallExtensions.fire(d.map(S=>({...S,local:S.local?P(S.local,null):S.local,source:this.isUriComponents(S.source)?_.URI.revive(S.source):S.source}))))),this._register(this.channel.listen("onUninstallExtension")(d=>this._onUninstallExtension.fire(d))),this._register(this.channel.listen("onDidUninstallExtension")(d=>this._onDidUninstallExtension.fire(d)))}isUriComponents(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(C){const d=await this.getTargetPlatform();return C.allTargetPlatforms.some(S=>(0,R.isTargetPlatformCompatible)(S,C.allTargetPlatforms,d))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(d=>_.URI.revive(d)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,d){return Promise.resolve(this.channel.call("install",[C,d])).then(S=>P(S,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}installFromGallery(C,d){return Promise.resolve(this.channel.call("installFromGallery",[C,d])).then(S=>P(S,null))}uninstall(C,d){return Promise.resolve(this.channel.call("uninstall",[C,d]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(d=>d.map(S=>P(S,null)))}updateMetadata(C,d){return Promise.resolve(this.channel.call("updateMetadata",[C,d])).then(S=>P(S,null))}updateExtensionScope(C,d){return Promise.resolve(this.channel.call("updateExtensionScope",[C,d])).then(S=>P(S,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class f{constructor(C){this.service=C}listen(C,d){throw new Error("Invalid listen")}call(C,d,S){switch(d){case"getConfigBasedTips":return this.service.getConfigBasedTips(_.URI.revive(S[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=f}),define(ne[80],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var _;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(_=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[14],ie([0,1,39,9,27,15,7,137,6]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function w(U){return U.create===!0}e.isFileOpenForWriteOptions=w;var P;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var g;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function f(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=f;function y(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function C(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=C;function d(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=d;var S;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(V,Y){super(V);this.code=Y}}e.FileSystemProviderError=m;function l(U,V){const Y=new m(U.toString(),V);return r(Y,V),Y}e.createFileSystemProviderError=l;function u(U){return U||l((0,R.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=u;function r(U,V){return U.name=V?`${V} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function a(U){if(!U)return S.Unknown;if(U instanceof m)return U.code;const V=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!V)return S.Unknown;switch(V[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=a;function i(U){if(U instanceof v)return U.fileOperationResult;switch(a(U)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(V,Y,B){this.resource=V,this.operation=Y,this.target=B}isOperation(V){return this.operation===V}}e.FileOperationEvent=s;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class c{constructor(V,Y){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const q of V){const X=B.get(q.type);X?X.push([q.resource,q]):B.set(q.type,[[q.resource,q]])}for(const[q,X]of B)switch(q){case 1:this.added=L.TernarySearchTree.forUris(()=>Y),this.added.fill(X);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>Y),this.updated.fill(X);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>Y),this.deleted.fill(X);break}}contains(V,...Y){return this.doContains(V,{includeChildren:!1},...Y)}affects(V,...Y){return this.doContains(V,{includeChildren:!0},...Y)}doContains(V,Y,...B){if(!V)return!1;const q=B.length>0;return!!((!q||B.includes(1))&&(this.added?.get(V)||Y.includeChildren&&this.added?.findSuperstr(V))||(!q||B.includes(0))&&(this.updated?.get(V)||Y.includeChildren&&this.updated?.findSuperstr(V))||(!q||B.includes(2))&&(this.deleted?.findSubstr(V)||Y.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function h(U,V,Y){return!U||!V||U===V||V.length>U.length?!1:(V.charAt(V.length-1)!==n.sep&&(V+=n.sep),Y?(0,k.startsWithIgnoreCase)(U,V):U.indexOf(V)===0)}e.isParent=h;class v extends Error{constructor(V,Y,B){super(V);this.fileOperationResult=Y,this.options=B}}e.FileOperationError=v;class I extends v{constructor(V,Y,B){super(V,2,B);this.stat=Y}}e.NotModifiedSinceFileOperationError=I;var A;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function $(U,V){if(!V.hasProvider(T.URI.from({scheme:U.scheme})))return new Promise(Y=>{const B=V.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(B.dispose(),Y())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class D{static formatSize(V){return(0,_.isNumber)(V)||(V=0),V<D.KB?(0,R.localize)(1,null,V.toFixed(0)):V<D.MB?(0,R.localize)(2,null,(V/D.KB).toFixed(2)):V<D.GB?(0,R.localize)(3,null,(V/D.MB).toFixed(2)):V<D.TB?(0,R.localize)(4,null,(V/D.GB).toFixed(2)):(0,R.localize)(5,null,(V/D.TB).toFixed(2))}}e.ByteSize=D,D.KB=1024,D.MB=D.KB*D.KB,D.GB=D.MB*D.KB,D.TB=D.GB*D.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function z(U){return{maxFileSize:U===0?300*D.MB:16*D.GB,maxHeapSize:U===0?700*D.MB:2*700*D.MB}}e.getPlatformLimits=z}),define(ne[162],ie([0,1,81,40,14]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let _=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((w,P)=>{const E=(0,L.createHash)("md5");(0,n.listenStream)(b,{onData:g=>E.update(g.buffer),onError:g=>P(g),onEnd:()=>w(E.digest("base64").replace(/=+$/,""))})})}};_=de([Q(0,k.IFileService)],_),e.ChecksumService=_}),define(ne[163],ie([0,1,250,127,150,14]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(g,p){const f={onUnknownOption:C=>{console.warn((0,n.localize)(0,null,C))},onMultipleValues:(C,d)=>{console.warn((0,n.localize)(1,null,C,d))},onDeprecatedOption:(C,d)=>{console.warn((0,n.localize)(2,null,C,d))}},y=(0,k.parseArgs)(g,k.OPTIONS,p?f:void 0);return y.goto&&y._.forEach(C=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,n.localize)(3,null))),y["max-memory"]&&L(parseInt(y["max-memory"])>=_.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${_.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function R(g){const p=g.findIndex(f=>!/^-/.test(f));if(p>-1)return[...g.slice(0,p),...g.slice(p+1)]}function b(g){let[,...p]=g;process.env.VSCODE_DEV&&(p=R(p)||[]);const f=!E(process.env);return T(p,f)}e.parseMainProcessArgv=b;function w(g){const[,,...p]=g;return T(p,!0)}e.parseCLIProcessArgv=w;function P(g,...p){const f=g.indexOf("--");return f===-1?g.push(...p):g.splice(f,0,...p),g}e.addArg=P;function E(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(ne[164],ie([0,1,45,9,128,25,37,8,4,29,123,163,5]),function(J,e,L,n,k,_,T,R,b,w,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let f;async function y(d,S,m){return S["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(m)&&!S["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(m)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=g.Promises.withAsyncBody(async(l,u)=>{const r=new _.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),u(new Error((0,k.localize)(0,null)))},p);try{l(await C(d,r.token))}catch(i){!(0,R.isPromiseCanceledError)(i)&&!r.token.isCancellationRequested?u(new Error((0,k.localize)(1,null,(0,T.toErrorMessage)(i)))):l({})}finally{clearTimeout(a),r.dispose()}})),f)}e.getResolvedShellEnv=y;async function C(d,S){const m=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",m);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",l);const u=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",a);const i=await(0,P.getSystemShell)(b.OS,a);return d.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(S.isCancellationRequested)return s((0,R.canceled)());const o=(0,n.basename)(i);let c,h;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${v} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,h=["-Login","-Command"]):(c=`'${process.execPath}' ${v} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?h=["-ic"]:h=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),c);const I=(0,L.spawn)(i,[...h,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});S.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",N=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(N)),s(N)});const A=[];I.stdout.on("data",N=>A.push(N));const O=[];I.stderr.on("data",N=>O.push(N)),I.on("close",(N,$)=>{const D=Buffer.concat(A).toString("utf8");d.trace("getUnixShellEnvironment#raw",D);const M=Buffer.concat(O).toString("utf8");if(M.trim()&&d.trace("getUnixShellEnvironment#stderr",M),N||$)return s(new Error((0,k.localize)(2,null,N,$)));const z=r.exec(D),U=z?z[1]:"{}";try{const V=JSON.parse(U);m?V.ELECTRON_RUN_AS_NODE=m:delete V.ELECTRON_RUN_AS_NODE,l?V.ELECTRON_NO_ATTACH_CONSOLE=l:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",V),t(V)}catch(V){d.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(V)),s(V)}})})}}),define(ne[165],ie([0,1,17,37,8,3,2,40,7,29,14]),function(J,e,L,n,k,_,T,R,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends T.Disposable{constructor(p,f){super();this.channel=p,this.extraCapabilities=f,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,f){const{buffer:y}=await this.channel.call("readFile",[p,f]);return y}readFileStream(p,f,y){const C=(0,R.newWriteableStream)(S=>L.VSBuffer.concat(S.map(m=>L.VSBuffer.wrap(m))).buffer),d=this.channel.listen("readFileStream",[p,f])(S=>{if(S instanceof L.VSBuffer)C.write(S.buffer);else{if(S==="end")C.end();else{let m=S;m instanceof Error||(m=(0,P.createFileSystemProviderError)((0,n.toErrorMessage)(m),P.FileSystemProviderErrorCode.Unknown)),C.error(m),C.end()}d.dispose()}});return y.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),d.dispose()}),C}writeFile(p,f,y){return this.channel.call("writeFile",[p,L.VSBuffer.wrap(f),y])}open(p,f){return this.channel.call("open",[p,f])}close(p){return this.channel.call("close",[p])}async read(p,f,y,C,d){const[S,m]=await this.channel.call("read",[p,f,d]);return y.set(S.buffer.slice(0,m),C),m}write(p,f,y,C,d){return this.channel.call("write",[p,f,L.VSBuffer.wrap(y),C,d])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,f){return this.channel.call("delete",[p,f])}rename(p,f,y){return this.channel.call("rename",[p,f,y])}copy(p,f,y){return this.channel.call("copy",[p,f,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const f=p;this._onDidChange.fire(f.map(y=>({resource:b.URI.revive(y.resource),type:y.type})))}else{const f=p;this._onDidWatchError.fire(f)}}))}watch(p,f){const y=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,y,p,f]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=E}),define(ne[82],ie([0,1,17,8,138,14]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(P,E,g,p,f,y){let C;try{await R(P,E,g,p,f,y)}catch(d){C=d}finally{C&&f.errorTransformer&&(C=f.errorTransformer(C)),typeof C!="undefined"&&g.error(C),g.end()}}e.readFileIntoStream=T;async function R(P,E,g,p,f,y){b(y);const C=await P.open(E,{create:!1});try{b(y);let d=0,S=0,m=f&&typeof f.length=="number"?f.length:void 0,l=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof m=="number"?m:f.bufferSize)),u=f&&typeof f.position=="number"?f.position:0,r=0;do S=await P.read(C,u,l.buffer,r,l.byteLength-r),u+=S,r+=S,d+=S,typeof m=="number"&&(m-=S),r===l.byteLength&&(await g.write(p(l)),l=L.VSBuffer.alloc(Math.min(f.bufferSize,typeof m=="number"?m:f.bufferSize)),r=0);while(S>0&&(typeof m!="number"||m>0)&&b(y)&&w(d,f));if(r>0){let a=r;typeof m=="number"&&(a=Math.min(r,m)),g.write(p(l.slice(0,a)))}}catch(d){throw(0,_.ensureFileSystemProviderError)(d)}finally{await P.close(C)}}function b(P){if(P.isCancellationRequested)throw(0,n.canceled)();return!0}function w(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,_.createFileSystemProviderError)((0,k.localize)(0,null),_.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,_.createFileSystemProviderError)((0,k.localize)(1,null),_.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[58],ie([0,1,2,4,7,14]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class T extends L.Disposable{constructor(E,g,p){super();this.onFileChanges=E,this.onLogMessage=g,this.verboseLogging=p,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const E=new L.DisposableStore;this.watcherDisposables.value=E,this.watcher=this.createWatcher(E),this.watcher.setVerboseLogging(this.verboseLogging),E.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),E.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),E.add(this.watcher.onDidError(g=>this.onError(g)))}onError(E){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${E}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${E}`)}restart(E){this.restartCounter++,this.init(),this.watch(E)}async watch(E){this.requests=E,await this.watcher?.watch(E)}async setVerboseLogging(E){this.verboseLogging=E,await this.watcher?.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${E}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=T,T.MAX_RESTARTS=5;function R(P){return P.map(E=>({type:E.type,resource:k.URI.file(E.path)}))}e.toFileChanges=R;function b(P){const E=new w;for(const g of P)E.processEvent(g);return E.coalesce()}e.coalesceEvents=b;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(E){return n.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const g=this.mapPathToChange.get(this.toKey(E));let p=!1;if(g){const f=g.type,y=E.type;g.path!==E.path&&(E.type===2||E.type===1)?p=!0:f===1&&y===2?(this.mapPathToChange.delete(this.toKey(E)),this.coalesced.delete(g)):f===2&&y===1?g.type=0:f===1&&y===0||(g.type=y)}else p=!0;p&&(this.coalesced.add(E),this.mapPathToChange.set(this.toKey(E),E))}coalesce(){const E=[],g=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(E.push(p),!1):!0).sort((p,f)=>p.path.length-f.path.length).filter(p=>g.some(f=>(0,_.isParent)(p.path,f,!n.isLinux))?!1:(g.push(p.path),!0)).concat(E)}}}),define(ne[166],ie([0,1,50,5,25,41,109,2,69,9,4,114,22,58]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class f extends R.Disposable{constructor(d,S,m,l){super();this.request=d,this.onDidFilesChange=S,this.onLogMessage=m,this.verboseLogging=l,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(f.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(u=>(0,T.parse)(u)),this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const d=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${d} (excludes: ${this.request.excludes}))}`);const S=await g.Promises.stat(d);this._register(await this.doWatch(d,S.isDirectory()))}catch(d){d.code!=="ENOENT"?this.error(d):this.trace(d)}}async normalizePath(d){let S=d.path;try{S=await g.Promises.realpath(d.path),d.path===S&&(S=await(0,E.realcase)(d.path)??d.path),d.path!==S&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${S})`)}catch{}return S}async doWatch(d,S){if(P.isMacintosh&&(0,_.isEqualOrParent)(d,"/Volumes/"))return this.error(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=new k.CancellationTokenSource(this.cts.token);let l=new R.DisposableStore;try{const u=(0,w.basename)(d),r=(0,L.watch)(d);l.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()}));const a=new Set;if(S)try{for(const t of await g.Promises.readdir(d))a.add(t)}catch(t){this.error(t)}const i=new Map;l.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,s)=>{this.error(`Failed to watch ${d} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),r.on("change",(t,s)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),P.isMacintosh&&(o=(0,b.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(S)if(t==="rename"){i.get(o)?.dispose();const c=setTimeout(async()=>{if(i.delete(o),o===u&&!await g.Promises.exists(d)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const h=await this.existsChildStrictCase((0,w.join)(d,o));if(m.token.isCancellationRequested)return;let v;h?a.has(o)?v=0:(v=1,a.add(o)):(a.delete(o),v=2),this.onFileChange({path:(0,w.join)(this.request.path,o),type:v})},f.FILE_DELETE_HANDLER_DELAY);i.set(o,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;a.has(o)?c=0:(c=1,a.add(o)),this.onFileChange({path:(0,w.join)(this.request.path,o),type:c})}else if(t==="rename"||o!==u){const c=setTimeout(async()=>{const h=await g.Promises.exists(d);m.token.isCancellationRequested||(h?(this.onFileChange({path:this.request.path,type:0},!0),l.add(await this.doWatch(d,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);l.clear(),l.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await g.Promises.exists(d)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${d} for changes using fs.watch() (${u.toString()})`)}return(0,R.toDisposable)(()=>{m.dispose(!0),l.dispose()})}async onFileChange(d,S=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!S&&this.excludes.some(m=>m(d.path))?this.verboseLogging&&this.trace(` >> ignored ${d.path}`):this.fileChangesBuffer.push(d);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const l=(0,p.coalesceEvents)(m);if(this.verboseLogging)for(const u of l)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);l.length>0&&this.onDidFilesChange(l)})}catch{}}}async existsChildStrictCase(d){if(P.isLinux)return g.Promises.exists(d);try{const S=(0,w.basename)(d);return(await g.Promises.readdir((0,w.dirname)(d))).some(l=>l===S)}catch(S){return this.trace(S),!1}}setVerboseLogging(d){this.verboseLogging=d}error(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}warn(d){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}trace(d){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.trace("stopping file watcher"),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=50;async function y(C,d,S,m=512){const l=await g.Promises.open(C,"r"),u=Buffer.allocUnsafe(m),r=new k.CancellationTokenSource(S);let a,i=!1;const t={path:C,excludes:[]},s=new f(t,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(i)return;i=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:h}=await g.Promises.read(l,u,0,m,null);if(!h||r.token.isCancellationRequested)break;d(u.slice(0,h))}}catch(h){a=new Error(h),r.dispose(!0)}finally{i=!1}}})()});return new Promise((o,c)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await g.Promises.close(l)}catch(h){a=new Error(h)}a?c(a):o()})})}e.watchFileContents=y}),define(ne[167],ie([0,1,18,36,57,58]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class T extends _.AbstractRecursiveWatcherClient{constructor(b,w,P){super(b,w,P);this.init()}createWatcher(b){const w=b.add(new k.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(w.onDidProcessExit(({code:P,signal:E})=>this.onError(`terminated by itself with code ${P}, signal: ${E}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(w.getChannel("watcher")))}}e.ParcelWatcherClient=T}),define(ne[83],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...k){this._entries=new Map;for(let[_,T]of k)this.set(_,T)}set(k,_){const T=this._entries.get(k);return this._entries.set(k,_),T}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=L}),define(ne[168],ie([0,1,5,8,51,157,6,83]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const b=!1;class w extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class P{constructor(f=new R.ServiceCollection,y=!1,C){this._activeInstantiations=new Set,this._services=f,this._strict=y,this._parent=C,this._services.set(T.IInstantiationService,this)}createChild(f){return new P(f,this._strict,this)}invokeFunction(f,...y){let C=g.traceInvocation(f),d=!1;try{return f({get:m=>{if(d)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(m,C);if(!l)throw new Error(`[invokeFunction] unknown service '${m}'`);return l}},...y)}finally{d=!0,C.stop()}}createInstance(f,...y){let C,d;return f instanceof k.SyncDescriptor?(C=g.traceCreation(f.ctor),d=this._createInstance(f.ctor,f.staticArguments.concat(y),C)):(C=g.traceCreation(f),d=this._createInstance(f,y,C)),C.stop(),d}_createInstance(f,y=[],C){let d=T._util.getServiceDependencies(f).sort((l,u)=>l.index-u.index),S=[];for(const l of d){let u=this._getOrCreateServiceInstance(l.id,C);if(!u&&this._strict&&!l.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`);S.push(u)}let m=d.length>0?d[0].index:y.length;if(y.length!==m){console.warn(`[createInstance] First service dependency of ${f.name} at position ${m+1} conflicts with ${y.length} static arguments`);let l=m-y.length;l>0?y=y.concat(new Array(l)):y=y.slice(0,m)}return new f(...[...y,...S])}_setServiceInstance(f,y){if(this._services.get(f)instanceof k.SyncDescriptor)this._services.set(f,y);else if(this._parent)this._parent._setServiceInstance(f,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let y=this._services.get(f);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):y}_getOrCreateServiceInstance(f,y){let C=this._getServiceInstanceOrDescriptor(f);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,C,y.branch(f,!0)):(y.branch(f,!1),C)}_safeCreateAndCacheServiceInstance(f,y,C){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,y,C)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,y,C){const d=new _.Graph(l=>l.id.toString());let S=0;const m=[{id:f,desc:y,_trace:C}];for(;m.length;){const l=m.pop();if(d.lookupOrInsertNode(l),S++>1e3)throw new w(d);for(let u of T._util.getServiceDependencies(l.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`),r instanceof k.SyncDescriptor){const a={id:u.id,desc:r,_trace:l._trace.branch(u.id,!0)};d.insertEdge(l,a),m.push(a)}}}for(;;){const l=d.roots();if(l.length===0){if(!d.isEmpty())throw new w(d);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}d.removeNode(u)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,y,C=[],d,S){if(this._services.get(f)instanceof k.SyncDescriptor)return this._createServiceInstance(y,C,d,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,y,C,d,S);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(f,y=[],C,d){if(C){const S=new L.IdleValue(()=>this._createInstance(f,y,d));return new Proxy(Object.create(null),{get(m,l){if(l in m)return m[l];let u=S.value,r=u[l];return typeof r!="function"||(r=r.bind(u),m[l]=r),r},set(m,l,u){return S.value[l]=u,!0}})}else return this._createInstance(f,y,d)}}e.InstantiationService=P;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class g{constructor(f,y){this.type=f,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return b?new g(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(f){return b?new g(0,f.name):g._None}branch(f,y){let C=new g(2,f.toString());return this._dep.push([f,y,C]),C}stop(){let f=Date.now()-this._start;g._totals+=f;let y=!1;function C(S,m){let l=[],u=new Array(S+1).join("	");for(const[r,a,i]of m._dep)if(a&&i){y=!0,l.push(`${u}CREATES -> ${r}`);let t=C(S+1,i);t&&l.push(t)}else l.push(`${u}uses -> ${r}`);return l.join(`
`)}let d=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(f>2||y)&&console.log(d.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(ne[169],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(k,_){this.server=k,this.router=_}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,_){this.server.registerChannel(k,_)}}e.MessagePortMainProcessService=L}),define(ne[170],ie([0,1,36,51,77,6]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(p,f,y){const C=y.getChannel(p);return R(f)?new f.channelClientCtor(C):L.ProxyChannel.toService(C,f?.proxyOptions)}}function R(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,_.createDecorator)("mainProcessService");let b=class extends T{constructor(p,f,y){super(p,f,y)}};b=de([Q(2,e.IMainProcessService)],b);function w(g,p,f){(0,k.registerSingleton)(g,new n.SyncDescriptor(b,[p,f],f?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,_.createDecorator)("sharedProcessService");let P=class extends T{constructor(p,f,y){super(p,f,y)}};P=de([Q(2,e.ISharedProcessService)],P);function E(g,p,f){(0,k.registerSingleton)(g,new n.SyncDescriptor(P,[p,f],f?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(ne[59],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,L.createDecorator)("localizationsService");function n(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const _ of k.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[171],ie([0,1,2,59]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends L.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([Q(0,n.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(ne[10],ie([0,1,37,3,2,4,6]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function w(a,i,t){switch(i){case b.Trace:a.trace(t);break;case b.Debug:a.debug(t);break;case b.Info:a.info(t);break;case b.Warning:a.warn(t);break;case b.Error:a.error(t);break;case b.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=w;function P(a){let i="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(t>0?" ":"")+s}return i}e.format=P;class E extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class g extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(b.Error,P(s))}else this.log(b.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=g;class p extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!_.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class f extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class y extends E{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,L.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class C extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const s of this.logServices)s.trace(i,...t)}debug(i,...t){for(const s of this.logServices)s.debug(i,...t)}info(i,...t){for(const s of this.logServices)s.info(i,...t)}warn(i,...t){for(const s of this.logServices)s.warn(i,...t)}error(i,...t){for(const s of this.logServices)s.error(i,...t)}critical(i,...t){for(const s of this.logServices)s.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=C;class d extends k.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=d;class S extends k.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class m{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=m;function l(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const i=u(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=u;function r(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(ne[172],ie([0,1,5,8,2,9,22,13,10]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends k.Disposable{constructor(E,g){super();this.environmentService=E,this.logService=g,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,_.basename)(this.environmentService.logsPath),g=(0,_.dirname)(this.environmentService.logsPath),y=(await T.Promises.readdir(g)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==E),C=y.slice(0,Math.max(0,y.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(d=>T.Promises.rm((0,_.join)(g,d)))))}catch(E){(0,n.onUnexpectedError)(E)}}};w=de([Q(0,R.IEnvironmentService),Q(1,b.ILogService)],w),e.LogsDataCleaner=w}),define(ne[173],ie([0,1,5,8,2,9,22,13,10]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class mt extends k.Disposable{constructor(E,g,p){super();this.backupWorkspacesPath=E,this.environmentService=g,this.logService=p,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(y=>y.backupFolder),f=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(f.map(async y=>{y.length===mt.NON_EMPTY_WORKSPACE_ID_LENGTH||y===mt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(y)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${y}.`),await T.Promises.rm((0,_.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(E){(0,n.onUnexpectedError)(E)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",w=de([Q(1,R.INativeEnvironmentService),Q(2,b.ILogService)],w),e.StorageDataCleaner=w}),define(ne[174],ie([0,1,45,5,37,3,2,18,9,22,13,10]),function(J,e,L,n,k,_,T,R,b,w,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends T.Disposable{constructor(f,y){super();this.environmentService=f,this.logService=y,this.processesLimiter=new n.Limiter(5)}async postUninstall(f){const y=this.parseScript(f,"uninstall");return y&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${C}`)))),w.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(f,y){const C=`vscode:${y}`;if(f.location.scheme===R.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[C]=="string"){const d=f.manifest.scripts[C].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${C} should be a node script`),null):{script:(0,b.join)(f.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}runLifecycleHook(f,y,C,d,S){return new Promise((m,l)=>{const u=this.start(f,y,C,S);let r;const a=i=>{r&&(clearTimeout(r),r=null),i?l(i):m(void 0)};u.on("error",i=>{a((0,k.toErrorMessage)(i)||"Unknown")}),u.on("exit",(i,t)=>{a(i?`post-${y} process exited with code ${i}`:void 0)}),d&&(r=setTimeout(()=>{r=null,u.kill(),l("timed out")},5e3))})}start(f,y,C,d){const S={silent:!0,execArgv:void 0},m=(0,L.fork)(f,[`--type=extension-post-${y}`,...C],S);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const l=_.Event.fromNodeEventEmitter(m.stdout,"data"),u=_.Event.fromNodeEventEmitter(m.stderr,"data");l(i=>this.logService.info(d.identifier.id,d.manifest.version,`post-${y}`,i)),u(i=>this.logService.error(d.identifier.id,d.manifest.version,`post-${y}`,i));const r=_.Event.any(_.Event.map(l,i=>({data:`%c${i}`,format:[""]})),_.Event.map(u,i=>({data:`%c${i}`,format:["color: red"]})));return _.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),m}getExtensionStoragePath(f){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};g=de([Q(0,P.IEnvironmentService),Q(1,E.ILogService)],g),e.ExtensionsLifecycle=g}),define(ne[175],ie([0,1,16,5,8,3,2,9,58,10]),function(J,e,L,n,k,_,T,R,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends T.Disposable{constructor(g){super();this.logService=g,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(g,p){return p.recursive?this.watchRecursive(g,p):this.watchNonRecursive(g,p)}watchRecursive(g,p){const f={path:this.toFilePath(g),excludes:p.excludes},y=(0,L.insert)(this.recursiveFoldersToWatch,f);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(g=>(0,k.onUnexpectedError)(g))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(g=>this._onDidChangeFile.fire((0,b.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(g,p){return g.watch(p)}watchNonRecursive(g,p){const f=new T.DisposableStore,y=f.add(this.createNonRecursiveWatcher({path:this.toFilePath(g),excludes:p.excludes},C=>this._onDidChangeFile.fire((0,b.toFileChanges)(C)),C=>this.onWatcherLogMessage(C),this.logService.getLevel()===w.LogLevel.Trace));return f.add(this.logService.onDidChangeLogLevel(()=>{y.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})),f}onWatcherLogMessage(g){g.type==="error"&&this._onDidWatchError.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,R.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[176],ie([0,1,16,5,17,25,3,54,2,39,18,177,19,40,136,14,82,10]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class Xe extends b.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Xe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new y.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Xe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new y.FileChangesEvent(u,!0)))),this.nonRecursiveWatchedResources=w.TernarySearchTree.forUris(u=>{const r=this.getProvider(u.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,u){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:u});const r=new b.DisposableStore;return r.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:l}))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:u}),this.provider.delete(l),(0,b.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){u.push(r)}}),!this.provider.has(l)&&await n.Promises.settled(u)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,u){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return R.Iterable.map(this.provider,([l,u])=>({scheme:l,capabilities:u.capabilities}))}async withProvider(l){if(!(0,g.isAbsolutePath)(l))throw new y.FileOperationError((0,f.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const u=this.provider.get(l.scheme);if(!u){const r=new Error;throw r.name="ENOPRO",r.message=(0,f.localize)(1,null,l.toString()),r}return u}async withReadProvider(l){const u=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasReadWriteCapability)(u)||(0,y.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const u=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,u){try{return await this.doResolveFile(l,u)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,f.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(l,u){const r=await this.withProvider(l),a=this.isPathCaseSensitive(r),i=u?.resolveTo,t=u?.resolveSingleChildDescendants,s=u?.resolveMetadata,o=await r.stat(l);let c;return this.toFileStat(r,l,o,void 0,!!s,(h,v)=>(c||(c=w.TernarySearchTree.forUris(()=>!a),c.set(l,!0),i&&c.fill(!0,i)),c.get(h.resource)||c.findSuperstr(h.resource.with({query:null,fragment:null}))?!0:h.isDirectory&&t?v===1:!1))}async toFileStat(l,u,r,a,i,t){const{providerExtUri:s}=this.getExtUri(l),o={resource:u,name:s.basename(u),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const c=await l.readdir(u),h=await n.Promises.settled(c.map(async([v,I])=>{try{const A=s.joinPath(u,v),O=i?await l.stat(A):{type:I};return await this.toFileStat(l,A,O,c.length,i,t)}catch(A){return this.logService.trace(A),null}}));o.children=(0,L.coalesce)(h)}catch(c){this.logService.trace(c),o.children=[]}return o}return o}async resolveAll(l){return n.Promises.settled(l.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(l){const u=await this.withProvider(l);try{return!!await u.stat(l)}catch{return!1}}async canCreateFile(l,u){try{await this.doValidateCreateFile(l,u)}catch(r){return r}return!0}async doValidateCreateFile(l,u){if(!u?.overwrite&&await this.exists(l))throw new y.FileOperationError((0,f.localize)(3,null,this.resourceForError(l)),3,u)}async createFile(l,u=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const a=await this.writeFile(l,u);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,a)),a}async writeFile(l,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(a);try{await this.validateWriteFile(a,l,r)||await this.mkdirp(a,i.dirname(l));let s;if((0,y.hasReadWriteCapability)(a)&&!(u instanceof k.VSBuffer))if((0,p.isReadableStream)(u)){const o=await(0,p.peekStream)(u,3);o.ended?s=k.VSBuffer.concat(o.buffer):s=o}else s=(0,p.peekReadable)(u,o=>k.VSBuffer.concat(o),3);else s=u;!(0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)&&s instanceof k.VSBuffer?await this.doWriteUnbuffered(a,l,r,s):await this.doWriteBuffered(a,l,r,s instanceof k.VSBuffer?(0,k.bufferToReadable)(s):s)}catch(t){throw new y.FileOperationError((0,f.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,u,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(u)));let i;try{i=await l.stat(u)}catch{return}if((i.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,f.localize)(6,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:i.size}))throw new y.FileOperationError((0,f.localize)(7,null),3,r);return i}async readFile(l,u,r){const a=await this.withReadProvider(l);return u?.atomic?this.doReadFileAtomic(a,l,u,r):this.doReadFile(a,l,u,r)}async doReadFileAtomic(l,u,r,a){return new Promise((i,t)=>{this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,u,r,a);i(s)}catch(s){t(s)}})})}async doReadFile(l,u,r,a){const i=await this.doReadFileStream(l,u,{...r,preferUnbuffered:!0},a);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(l,u,r){const a=await this.withReadProvider(l);return this.doReadFileStream(a,l,u,r)}async doReadFileStream(l,u,r,a){const i=new _.CancellationTokenSource(a),t=this.validateReadFile(u,r).then(o=>o,o=>{throw i.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await t,r?.atomic&&(0,y.hasFileAtomicReadCapability)(l)||!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&r?.preferUnbuffered?s=this.readFileUnbuffered(l,u,r):(0,y.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,u,i.token,r):s=this.readFileBuffered(l,u,i.token,r),{...await t,value:s}}catch(o){s&&await(0,p.consumeStream)(s);const c=(0,f.localize)(8,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(o).toString());throw o instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(c,o.stat,r):new y.FileOperationError(c,(0,y.toFileOperationResult)(o),r)}}readFileStreamed(l,u,r,a=Object.create(null)){const i=l.readFileStream(u,a,r);return(0,p.transform)(i,{data:t=>t instanceof k.VSBuffer?t:k.VSBuffer.wrap(t),error:t=>new y.FileOperationError((0,f.localize)(9,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},t=>k.VSBuffer.concat(t))}readFileBuffered(l,u,r,a=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,C.readFileIntoStream)(l,u,i,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new y.FileOperationError((0,f.localize)(10,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},r),i}readFileUnbuffered(l,u,r){const a=(0,p.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,y.hasFileAtomicReadCapability)(l)?i=await l.readFile(u,{atomic:!0}):i=await l.readFile(u),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(u,i.byteLength,r),a.end(k.VSBuffer.wrap(i))}catch(i){a.error(i),a.end()}})(),a}async validateReadFile(l,u){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,f.localize)(11,null,this.resourceForError(l)),0,u);if(typeof u?.etag=="string"&&u.etag!==y.ETAG_DISABLED&&u.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,f.localize)(12,null),r,u);return this.validateReadFileLimits(l,r.size,u),r}validateReadFileLimits(l,u,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&u>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&u>r.limits.size&&(a=7),typeof a=="number")throw new y.FileOperationError((0,f.localize)(13,null,this.resourceForError(l)),a)}}async canMove(l,u,r){return this.doCanMoveCopy(l,u,"move",r)}async canCopy(l,u,r){return this.doCanMoveCopy(l,u,"copy",r)}async doCanMoveCopy(l,u,r,a){if(l.toString()!==u.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(i,l,t,u,r,a)}catch(i){return i}return!0}async move(l,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,l,i,u,"move",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,t==="move"?2:3,s)),s}async copy(l,u,r){const a=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,l,i,u,"copy",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,t==="copy"?3:2,s)),s}async doMoveCopy(l,u,r,a,i,t){if(u.toString()===a.toString())return i;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,u,r,a,i,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),i==="copy"){if(l===r&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(u,a,{overwrite:t});else{const c=await this.resolve(u);c.isDirectory?await this.doCopyFolder(l,c,r,a):await this.doCopyFile(l,u,r,a)}return i}else return l===r?(await l.rename(u,a,{overwrite:t}),i):(await this.doMoveCopy(l,u,r,a,"copy",t),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(l,u,r,a){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,u,r,a);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,u,r,a);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,u,r,a);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,u,r,a)}async doCopyFolder(l,u,r,a){await r.mkdir(a),Array.isArray(u.children)&&await n.Promises.settled(u.children.map(async i=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),r,t):this.doCopyFile(l,i.resource,r,t)}))}async doValidateMoveCopy(l,u,r,a,i,t){let s=!1;if(l===r){const{providerExtUri:c,isPathCaseSensitive:h}=this.getExtUri(l);if(h||(s=c.isEqual(u,a)),s&&i==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!s&&c.isEqualOrParent(a,u))throw new Error((0,f.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new y.FileOperationError((0,f.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(l===r){const{providerExtUri:c}=this.getExtUri(l);if(c.isEqualOrParent(u,a))throw new Error((0,f.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const u=this.isPathCaseSensitive(l);return{providerExtUri:u?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(u,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,r)),r}async mkdirp(l,u){const r=[],{providerExtUri:a}=this.getExtUri(l);for(;!a.isEqual(u,a.dirname(u));)try{if(((await l.stat(u)).type&y.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(u)));break}catch(i){if((0,y.toFileSystemProviderErrorCode)(i)!==y.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(a.basename(u)),u=a.dirname(u)}for(let i=r.length-1;i>=0;i--){u=a.joinPath(u,r[i]);try{await l.mkdir(u)}catch(t){if((0,y.toFileSystemProviderErrorCode)(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(l,u){try{await this.doValidateDelete(l,u)}catch(r){return r}return!0}async doValidateDelete(l,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!u?.useTrash&&!(r.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(l)));let i;try{i=await r.stat(l)}catch{}if(i)this.throwIfFileIsReadonly(l,i);else throw new y.FileOperationError((0,f.localize)(20,null,this.resourceForError(l)),1);if(!!!u?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(l)))}return r}async del(l,u){const r=await this.doValidateDelete(l,u),a=!!u?.useTrash,i=!!u?.recursive;await r.delete(l,{recursive:i,useTrash:a}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}onDidChangeFile(l,u){this._onDidChangeFilesRaw.fire({changes:l});let r,a;{for(const i of l)this.nonRecursiveWatchedResources.has(i.resource)?(r||(r=[]),r.push(i)):(a||(a=[]),a.push(i));r&&this._onDidFilesChange.fire(new y.FileChangesEvent(r,!u))}if(a){const i=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(a)&&Xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,u={recursive:!1,excludes:[]}){const r=new b.DisposableStore;let a=!1,i=()=>{a=!0};return r.add((0,b.toDisposable)(()=>i())),(async()=>{try{const t=await this.doWatch(l,u);a?(0,b.dispose)(t):i=()=>(0,b.dispose)(t)}catch(t){this.logService.error(t)}})(),u.recursive||(this.nonRecursiveWatchedResources.set(l,(this.nonRecursiveWatchedResources.get(l)??0)+1),r.add((0,b.toDisposable)(()=>{const t=this.nonRecursiveWatchedResources.get(l);typeof t=="number"&&(t<=1?this.nonRecursiveWatchedResources.delete(l):this.nonRecursiveWatchedResources.set(l,t-1))}))),r}async doWatch(l,u){const r=await this.withProvider(l),a=this.toWatchKey(r,l,u);let i=this.activeWatchers.get(a);return i||(i={count:0,disposable:r.watch(l,u)},this.activeWatchers.set(a,i)),i.count+=1,(0,b.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,b.dispose)(i.disposable),this.activeWatchers.delete(a)))})}toWatchKey(l,u,r){const{providerExtUri:a}=this.getExtUri(l);return[a.getComparisonKey(u),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,b.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(l,i,a):await this.doWriteReadableBufferedQueued(l,i,a)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,u,r){let a=0,i;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,u,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((t,s)=>{(0,p.listenStream)(i,{onData:async o=>{i.pause();try{await this.doWriteBuffer(l,u,o,o.byteLength,a,0)}catch(c){return s(c)}a+=o.byteLength,setTimeout(()=>i.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(l,u,r){let a=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(l,u,i,i.byteLength,a,0),a+=i.byteLength}async doWriteBuffer(l,u,r,a,i,t){let s=0;for(;s<a;)s+=await l.write(u,i+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(l,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,u,r,a))}async doWriteUnbufferedQueued(l,u,r,a){let i;a instanceof k.VSBuffer?i=a:(0,p.isReadableStream)(a)?i=await(0,k.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?i=await(0,k.bufferedStreamToBuffer)(a):i=(0,k.readableToBuffer)(a),await l.writeFile(u,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,u,r,a))}async doPipeBufferedQueued(l,u,r,a){let i,t;try{i=await l.open(u,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=k.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,c=0,h=0;do h=await l.read(i,o,s.buffer,c,s.byteLength-c),await this.doWriteBuffer(r,t,s,h,o,c),o+=h,c+=h,c===s.byteLength&&(c=0);while(h>0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,u,r,a))}async doPipeUnbufferedQueued(l,u,r,a){return r.writeFile(a,await l.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,u,r,a))}async doPipeUnbufferedToBufferedQueued(l,u,r,a){const i=await r.open(a,{create:!0,unlock:!1});try{const t=await l.readFile(u);await this.doWriteBuffer(r,i,k.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(l,u,r,a){const i=await(0,k.streamToBuffer)(this.readFileBuffered(l,u,_.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,i)}throwIfFileSystemIsReadonly(l,u){if(l.capabilities&2048)throw new y.FileOperationError((0,f.localize)(22,null,this.resourceForError(u)),6);return l}throwIfFileIsReadonly(l,u){if((u.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,f.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=de([Q(0,d.ILogService)],S),e.FileService=S}),define(ne[178],ie([0,1,50,251,5,39,17,3,41,2,9,4,19,40,22,139,14,82,166,167,175,37]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(a)}`)}})();class r extends l.AbstractDiskFileSystemProvider{constructor(i,t){super(i);this.options=t,this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new _.ResourceMap(s=>g.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await f.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,g.joinPath)(i,o.name))).type:c=this.toType(o),s.push([o.name,c])}catch(c){this.logService.trace(c)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let s;return t?.dangling?s=C.FileType.Unknown:i.isFile()?s=C.FileType.File:i.isDirectory()?s=C.FileType.Directory:s=C.FileType.Unknown,t&&(s|=C.FileType.SymbolicLink),s}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const s=new k.Barrier;return this.resourceLocks.set(i,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,w.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),s.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),s=await this.createResourceLock(i));const o=this.toFilePath(i);return await f.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(i,t,s){const o=(0,p.newWriteableStream)(c=>T.VSBuffer.concat(c.map(h=>T.VSBuffer.wrap(h))).buffer);return(0,d.readFileIntoStream)(this,i,o,c=>c.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){let o;try{const c=this.toFilePath(i);if(!s.create||!s.overwrite){if(await f.Promises.exists(c)){if(!s.overwrite)throw(0,C.createFileSystemProviderError)((0,y.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,C.createFileSystemProviderError)((0,y.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof o=="number"&&await this.close(o)}}async open(i,t){let s;(0,C.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(i));let o;try{const c=this.toFilePath(i);if((0,C.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:v}=await f.SymlinkSupport.stat(c);v.mode&128||await f.Promises.chmod(c,v.mode|128)}catch(v){this.logService.trace(v)}let h;if((0,C.isFileOpenForWriteOptions)(t)){if(E.isWindows)try{await f.Promises.truncate(c,0),h="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}h||(h="w")}else h="r";o=await f.Promises.open(c,h)}catch(c){throw s?.dispose(),(0,C.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(o,0),(0,C.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(o,i),s&&this.mapHandleToLock.set(o,s),o}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await f.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await f.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,s,o,c){const h=this.normalizePos(i,t);let v=null;try{const I=await f.Promises.read(i,s,o,c,h);return typeof I=="number"?v=I:v=I.bytesRead,v}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(i,h,v)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,s){const o=this.mapHandleToPos.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(i,o+s):this.mapHandleToPos.delete(i)))}async write(i,t,s,o,c){return(0,k.retry)(()=>this.doWrite(i,t,s,o,c),100,3)}async doWrite(i,t,s,o,c){const h=this.normalizePos(i,t);let v=null;try{const I=await f.Promises.write(i,s,o,c,h);return typeof I=="number"?v=I:v=I.bytesWritten,v}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),I)}finally{this.updatePos(i,h,v)}}async mkdir(i){try{await f.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const s=this.toFilePath(i);t.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"move",s.overwrite),await f.Promises.move(o,c)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,y.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,t,s){const o=this.toFilePath(i),c=this.toFilePath(t);if(o!==c)try{await this.validateTargetDeleted(i,t,"copy",s.overwrite),await f.Promises.copy(o,c,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,y.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(c)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,t,s,o){const c=this.toFilePath(i),h=this.toFilePath(t);let v=!1;if(!!(this.capabilities&1024)||(v=(0,b.isEqual)(c,h,!0)),v&&s==="copy")throw(0,C.createFileSystemProviderError)((0,y.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!v&&await f.Promises.exists(h)){if(!o)throw(0,C.createFileSystemProviderError)((0,y.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(i,t,s){return new m.ParcelWatcherClient(o=>i(o),o=>t(o),s)}doWatch(i,t){const s=this.options?.watcher?.usePolling;if(s===!0)for(const o of t)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const o of t)s.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(i,t)}createNonRecursiveWatcher(i,t,s,o){return new S.NodeJSFileWatcher(i,c=>t(c),c=>s(c),o)}toFileSystemProviderError(i){if(i instanceof C.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=C.FileSystemProviderErrorCode.NoPermissions;break;default:t=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let s=this.toFileSystemProviderError(t);if(i&&s.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await f.SymlinkSupport.stat(this.toFilePath(i));o.mode&128||(s=(0,C.createFileSystemProviderError)(t,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(ne[84],ie([0,1,3,7,10]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(g){this.service=g,this.onDidChangeLogLevel=L.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(g,p,f){switch(p){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=_;class T{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){T.setLevel(this.channel,g)}static setLevel(g,p){return g.call("setLevel",p)}}e.LogLevelChannelClient=T;class R{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,p){throw new Error(`Event not found: ${p}`)}async call(g,p,f){switch(p){case"createLogger":this.createLogger(n.URI.revive(f[0]),f[1]);return;case"log":return this.log(n.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${p}`)}createLogger(g,p){this.loggers.set(g.toString(),this.loggerService.createLogger(g,p))}consoleLog(g,p){let f=console.log;switch(g){case k.LogLevel.Error:f=console.error;break;case k.LogLevel.Warning:f=console.warn;break;case k.LogLevel.Info:f=console.info;break}f.call(console,...p)}log(g,p){const f=this.loggers.get(g.toString());if(!f)throw new Error("Create the logger before logging");for(const[y,C]of p)(0,k.log)(f,y,C)}}e.LoggerChannel=R;class b extends k.AbstractLoggerService{constructor(g,p,f){super(g,p);this.channel=f}createConsoleMainLogger(){return new k.AdapterLogger({log:(g,p)=>{this.channel.call("consoleLog",[g,p])}})}doCreateLogger(g,p,f){return new w(this.channel,g,p,f)}}e.LoggerChannelClient=b;class w extends k.AbstractMessageLogger{constructor(g,p,f,y){super(y?.always);this.channel=g,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[p,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,p){const f=[[g,p]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(g){this.channel.call("log",[this.file,g])}}class P extends k.LogService{constructor(g,p){super(p);this.parent=g,this._register(g.onDidChangeLogLevel(f=>p.setLevel(f)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=P}),define(ne[60],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(ne[85],ie([0,1,18,4,31,19]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,_.dirname)(L.FileAccess.asFileUri("",J));T=J.__$__nodeRequire((0,_.joinPath)(R,"product.json").fsPath);const b=J.__$__nodeRequire((0,_.joinPath)(R,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:b.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(ne[26],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[179],ie([0,1,5,8,2,9,22,10,26]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends k.Disposable{constructor(E,g,p){super();this.productService=g,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),p=(0,_.dirname)(E),f=(0,_.basename)(E),y=await T.Promises.readdir(p);await Promise.all(y.map(async C=>{if(C===f)return;const d=(0,_.join)(p,C),S=await T.Promises.stat(d);if(S.isDirectory()&&g-S.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),T.Promises.rm(d)}))}catch(g){(0,n.onUnexpectedError)(g)}}};w=de([Q(1,b.IProductService),Q(2,R.ILogService)],w),e.CodeCacheCleaner=w}),define(ne[180],ie([0,1,5,8,2,9,22,13,10,26]),function(J,e,L,n,k,_,T,R,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends k.Disposable{constructor(g,p,f){super();this.environmentService=g,this.logService=p,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),p=JSON.parse(await T.Promises.readFile((0,_.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let S of Object.keys(p)){const m=p[S];g[`${m.hash}.${S}`]=!0}const f=(0,_.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(f))return;const C=await T.Promises.readdir(f);for(const S of C){if(g[S]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${S}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${S}`),await T.Promises.rm((0,_.join)(f,S))}const d=Date.now();for(const S of Object.keys(g)){const m=(0,_.join)(f,S),l=await T.Promises.readdir(m);for(const u of l){if(u==="tcf.json")continue;const r=(0,_.join)(m,u),a=await T.Promises.stat(r);a.isDirectory()&&d-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,_.join)(S,u)}`),await T.Promises.rm(r))}}}catch(g){(0,n.onUnexpectedError)(g)}}};P=de([Q(0,R.INativeEnvironmentService),Q(1,b.ILogService),Q(2,w.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[181],ie([0,1,9,6]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(_){function T(R,b="noAbsolutePaths"){for(const w of R.nodes)w.callFrame&&w.callFrame.url&&((0,L.isAbsolute)(w.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(w.callFrame.url))&&(w.callFrame.url=(0,L.join)(b,(0,L.basename)(w.callFrame.url)));return R}_.rewriteAbsolutePaths=T})(k=e.Utils||(e.Utils={}))}),define(ne[182],ie([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(_){const R=await(await new Promise((w,P)=>{J(["v8-inspect-profiler"],w,P)})).startProfiling({port:_.port,checkForPaused:!0}),b=(0,L.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(_){const T=this._sessions.get(_);if(!T)throw new Error(`UNKNOWN session '${_}'`);const R=await T.stop();return this._sessions.delete(_),R.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,98,15]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(T,R){L.ok(n.isString(T)),L.ok(n.isObject(R)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new k}),define(ne[86],ie([0,1,3,38]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class _{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,w){this.schemasById[k(b)]=w,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new _;n.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[42],ie([0,1,16,3,15,125,86,38]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(T.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const a=this.doRegisterConfigurations(u,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:u,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(u,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(a)})}registerDefaultConfigurations(u){const r=[],a=[];for(const{overrides:i,source:t}of u)for(const s in i)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...i[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const c={type:"object",default:o,description:_.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:k.isString(t)?void 0:t};a.push(...f(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:i[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const r=[];for(const{overrides:a,source:i}of u)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=k.isString(i)?i:i?.id,c=k.isString(s?.source)?s?.source:s?.source?.id;if(o===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const h=this.configurationProperties[t];h&&(this.updatePropertyDefaultValue(t,h),this.updateSchema(t,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const a=[];return u.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(u){const r=[],a=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>a(t))};for(const i of u){a(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(u,r=!0,a,i,t=3){t=k.isUndefinedOrNull(u.scope)?t:u.scope;let s=[],o=u.properties;if(o)for(let h in o){if(r&&S(h)){delete o[h];continue}const v=o[h];if(v.source=a,v.defaultDefaultValue=o[h].default,this.updatePropertyDefaultValue(h,v),e.OVERRIDE_PROPERTY_REGEX.test(h)?v.scope=void 0:(v.scope=k.isUndefinedOrNull(v.scope)?t:v.scope,v.restricted=k.isUndefinedOrNull(v.restricted)?!!i?.includes(h):v.restricted),o[h].hasOwnProperty("included")&&!o[h].included){this.excludedConfigurationProperties[h]=o[h],delete o[h];continue}else this.configurationProperties[h]=o[h];!o[h].deprecationMessage&&o[h].markdownDeprecationMessage&&(o[h].deprecationMessage=o[h].markdownDeprecationMessage),s.push(h)}let c=u.allOf;if(c)for(let h of c)s.push(...this.validateAndRegisterProperties(h,r,a,i,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const r=a=>{let i=a.properties;if(i)for(const s in i)this.updateSchema(s,i[s]);let t=a.allOf;t&&t.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,a={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){const a=this.configurationDefaultsOverrides.get(u);let i=a?.value,t=a?.source;k.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),k.isUndefined(i)&&(i=C(r.type)),r.default=i,r.defaultValueSource=t}}const g="\\[([^\\]]+)\\]",p=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(l){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=p.exec(l);for(;r?.length;){const a=r[1].trim();a&&u.push(a),r=p.exec(l)}}return(0,L.distinct)(u)}e.overrideIdentifiersFromKey=f;function y(l){return l.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function C(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=C;const d=new E;R.Registry.add(e.Extensions.Configuration,d);function S(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?_.localize(7,null,l):d.getConfigurationProperties()[l]!==void 0?_.localize(8,null,l):null:_.localize(6,null)}e.validateProperty=S;function m(){const l=[],u=d.getConfigurationProperties();for(const r of Object.keys(u))l.push([r,u[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=m}),define(ne[87],ie([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(J,e,L,n,k,_,T,R,b,w,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},t=[],s=[]){this._contents=i,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,P.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const s=this.getContentsForOverrideIdentifer(t);return s?i?(0,P.getConfigurationValue)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return L.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const c of i){this.mergeContents(t,c.contents);for(const h of c.overrides){const[v]=s.filter(I=>L.equals(I.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=L.distinct(v.keys)):s.push(R.deepClone(h))}for(const h of c.keys)o.indexOf(h)===-1&&o.push(h)}return new p(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o],h=t[o];h&&(typeof c=="object"&&typeof h=="object"?(c=R.deepClone(c),this.mergeContents(c,h)):c=h),s[o]=c}return new p(s,this.keys,this.overrides)}mergeContents(i,t){for(const s of Object.keys(t)){if(s in i&&b.isObject(i[s])&&b.isObject(t[s])){this.mergeContents(i[s],t[s]);continue}i[s]=R.deepClone(t[s])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,s=null;const o=c=>{c&&(s?this.mergeContents(s,c):s=R.deepClone(c))};for(const c of this.overrides)L.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,P.addToValueTree)(this.contents,i,t,s=>{throw new Error(s)})}removeValue(i){this.removeKey(i)&&(0,P.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let s=0;s<t;s++)i.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class f extends p{constructor(i={}){const t=g.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),c=[];for(const h in t){const v=i[h],I=v!==void 0?v:t[h].default;(0,P.addToValueTree)(o,h,I,A=>console.error(`Conflict in default settings: ${A}`))}for(const h of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,E.overrideIdentifiersFromKey)(h),keys:Object.keys(o[h]),contents:(0,P.toValuesTree)(o[h],v=>console.error(`Conflict in default settings file: ${v}`))});super(o,s,c)}}e.DefaultConfigurationModel=f;class y{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const s=this.doParseContent(i);this.parseRaw(s,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:s,keys:o,overrides:c,restricted:h}=this.doParseRaw(i,t);this._configurationModel=new p(s,o,c),this._restrictedConfigurations=h||[]}doParseContent(i){let t={},s=null,o=[],c=[],h=[];function v(A){Array.isArray(o)?o.push(A):s!==null&&(o[s]=A)}let I={onObjectBegin:()=>{let A={};v(A),c.push(o),o=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let A=[];v(A),c.push(o),o=A,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:v,onError:(A,O,N)=>{h.push({error:A,offset:O,length:N})}};if(i)try{k.visit(i,I),t=o[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(i,t){const s=g.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,s,!0,t);i=o.raw;const c=(0,P.toValuesTree)(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),h=Object.keys(i),v=this.toOverrides(i,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:c,keys:h,overrides:v,restricted:o.restricted}}filter(i,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const c={},h=[];for(let v in i)if(E.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const I=this.filter(i[v],t,!1,o);c[v]=I.raw,h.push(...I.restricted)}else{const I=t[v],A=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&h.push(v),(A===void 0||o.scopes===void 0||o.scopes.includes(A))&&(o.skipRestricted&&I?.restricted||(c[v]=i[v]))}return{raw:c,restricted:h}}toOverrides(i,t){const s=[];for(const o of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const h in i[o])c[h]=i[o][h];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=y;class C extends _.Disposable{constructor(i,t,s,o){super();this.userSettingsResource=i,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=C;class d{constructor(i,t,s=new p,o=new p,c=new T.ResourceMap,h=new p,v=new T.ResourceMap,I=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=v,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new p,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,s){const o=this.getConsolidateConfigurationModel(t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),h=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,v=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),A=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,$=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,D=t.overrideIdentifier?h.override(t.overrideIdentifier).getValue(i):h.getValue(i),M=o.getValue(i),z=L.distinct(L.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(i,U)!==void 0);return{defaultValue:v,userValue:I,userLocalValue:A,userRemoteValue:O,workspaceValue:N,workspaceFolderValue:$,memoryValue:D,value:M,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:c?.freeze().getValue(i),override:t.overrideIdentifier?c?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:D!==void 0?{value:h.getValue(i),override:t.overrideIdentifier?h.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:z.length?z:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:c,removed:h}=u(this._defaultConfiguration,i);t=[...o,...c,...h]}for(const o of t)for(const c of(0,E.overrideIdentifiersFromKey)(o)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),v=i.getKeysForOverrideIdentifier(c),I=[...v.filter(A=>h.indexOf(A)===-1),...h.filter(A=>v.indexOf(A)===-1),...h.filter(A=>!R.equals(this._defaultConfiguration.override(c).getValue(A),i.override(c).getValue(A)))];s.push([c,I])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=u(this.localUserConfiguration,i),h=[...t,...s,...o];return h.length&&this.updateLocalUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=u(this.remoteUserConfiguration,i);let h=[...t,...s,...o];return h.length&&this.updateRemoteUserConfiguration(i),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:c}=u(this.workspaceConfiguration,i);let h=[...t,...s,...o];return h.length&&this.updateWorkspaceConfiguration(i),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:c,removed:h,overrides:v}=u(s,t);let I=[...o,...c,...h];return(I.length||!s)&&this.updateFolderConfiguration(i,t),{keys:I,overrides:v}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:c,overrides:h}=u(t,void 0);return{keys:[...s,...o,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let s=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?s.override(i.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:i},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const o=t.getFolder(i);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(i);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=s}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:s,overrides:o,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>i.add(s))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),s=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((h,v)=>(h.set(w.URI.revive(v[0]),this.parseConfigurationModel(v[1])),h),new T.ResourceMap);return new d(t,s,new p,o,c,new p,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=d;function S(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,t=new Map;for(const o of a)o.keys.forEach(c=>i.add(c)),o.overrides.forEach(([c,h])=>{const v=(0,T.getOrSet)(t,c,new Set);h.forEach(I=>v.add(I))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...i.values()],overrides:s}}e.mergeChanges=S;class m{constructor(i,t,s,o){this.change=i,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(v=>c.add(v)),i.overrides.forEach(([,v])=>v.forEach(I=>c.add(I))),this.affectedKeys=[...c.values()];const h=new p;this.affectedKeys.forEach(v=>h.setValue(v,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(i=i[o],!i)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=m;class l extends m{constructor(i,t,s,o){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l;function u(a,i){const{added:t,removed:s,updated:o}=r(i,a),c=[],h=a?.getAllOverrideIdentifiers()||[],v=i?.getAllOverrideIdentifiers()||[];if(i){const I=v.filter(A=>!h.includes(A));for(const A of I)c.push([A,i.getKeysForOverrideIdentifier(A)])}if(a){const I=h.filter(A=>!v.includes(A));for(const A of I)c.push([A,a.getKeysForOverrideIdentifier(A)])}if(i&&a){for(const I of h)if(v.includes(I)){const A=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:i.getOverrideValue(void 0,I)||{},keys:i.getKeysForOverrideIdentifier(I)});c.push([I,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function r(a,i){const t=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],s=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],o=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const h=(0,P.getConfigurationValue)(i.contents,c),v=(0,P.getConfigurationValue)(a.contents,c);R.equals(h,v)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(ne[183],ie([0,1,5,3,2,19,20,87,42,38]),function(J,e,L,n,k,_,T,R,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends k.Disposable{constructor(g,p){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,_.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:f})=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,p){const f=typeof g=="string"?g:void 0,y=(0,T.isConfigurationOverrides)(g)?g:(0,T.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(f,y,void 0)}updateValue(g,p,f,y){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const p=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(f,p,1)}onDidDefaultConfigurationChange(g){const p=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,g);this.trigger(f,p,6)}trigger(g,p,f){const y=new R.ConfigurationChangeEvent(g,{data:p},this.configuration);y.source=f,y.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[184],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var n;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(T,R=n.Unknown,b){super(T);this._message=T,this._code=R,this._detail=b,this.isHandled=R===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(T){return T instanceof k&&T._code===n.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof k&&T._code===n.NoResolverFound}static isHandled(T){return T instanceof k&&T.isHandled}}e.RemoteAuthorityResolverError=k}),define(ne[185],ie([0,1,5,17,25,8,3,2,29,71,184]),function(J,e,L,n,k,_,T,R,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var g;(function(G){G[G.Management=1]="Management",G[G.ExtensionHost=2]="ExtensionHost",G[G.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function p(G){switch(G){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(G){const ee=new k.CancellationTokenSource;return setTimeout(()=>ee.cancel(),G),ee.token}function y(G,ee){if(G.isCancellationRequested||ee.isCancellationRequested)return k.CancellationToken.Cancelled;const K=new k.CancellationTokenSource;return G.onCancellationRequested(()=>K.cancel()),ee.onCancellationRequested(()=>K.cancel()),K.token}class C{constructor(ee){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((K,F)=>{this._resolvePromise=K,this._rejectPromise=F}),ee.isCancellationRequested?this._timeout():this._disposables.add(ee.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(ee){this._state==="pending"?this._disposables.add(ee):ee.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const ee=new Error("Time limit reached");return ee.code="ETIMEDOUT",ee.syscall="connect",ee}resolve(ee){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(ee))}reject(ee){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(ee))}}function d(G,ee){const K=new C(ee);return K.registerDisposable(G.onControlMessage(F=>{const j=JSON.parse(F.toString()),H=V(j);H?K.reject(H):K.resolve(j)})),K.promise}function S(G,ee,K,F,j,H,W){const x=new C(W);return ee.connect(K,F,j,H,(re,se)=>{x.didTimeout?(re&&G.error(re),se?.dispose()):re||!se?x.reject(re):x.resolve(se)}),x.promise}function m(G,ee){const K=new C(ee);return G.then(F=>{K.didTimeout||K.resolve(F)},F=>{K.didTimeout||K.reject(F)}),K.promise}async function l(G,ee,K,F){const j=q(G,ee);G.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let H;try{H=await S(G.logService,G.socketFactory,G.host,G.port,`reconnectionToken=${G.reconnectionToken}&reconnection=${G.reconnectionProtocol?"true":"false"}`,`renderer-${p(ee)}-${G.reconnectionToken}`,F)}catch(ce){throw G.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),G.logService.error(ce),ce}G.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let W,x;G.reconnectionProtocol?(G.reconnectionProtocol.beginAcceptReconnection(H,null),W=G.reconnectionProtocol,x=!1):(W=new w.PersistentProtocol(H,null),x=!0),G.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const re=await m(G.signService.createNewMessage((0,b.generateUuid)()),F),se={type:"auth",auth:G.connectionToken||"00000000000000000000",data:re.data};W.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await d(W,y(F,f(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}if(G.logService.trace(`${j} 4/6. received SignRequest control message.`),!await m(G.signService.validate(re,ce.signedData),F)){const ye=new Error("Refused to connect to unsupported server");throw ye.code="VSCODE_CONNECTION_ERROR",ye}const Se=await m(G.signService.sign(ce.data),F),ge={type:"connectionType",commit:G.commit,signedData:Se,desiredConnectionType:ee};return K&&(ge.args=K),G.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(n.VSBuffer.fromString(JSON.stringify(ge))),{protocol:W,ownsProtocol:x}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(G.logService.error(`${j} the handshake timed out. Error:`),G.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(G.logService.error(`${j} received error control message when negotiating connection. Error:`),G.logService.error(ce)),x&&U(W),ce}}async function u(G,ee,K,F){const j=Date.now(),H=q(G,ee),{protocol:W,ownsProtocol:x}=await l(G,ee,K,F),re=new C(F);return re.registerDisposable(W.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=V(ce);he?(G.logService.error(`${H} received error control message when negotiating connection. Error:`),G.logService.error(he),x&&U(W),re.reject(he)):(G.reconnectionProtocol&&G.reconnectionProtocol.endAcceptReconnection(),G.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${X(j)}!`),re.resolve({protocol:W,firstMessage:ce}))})),re.promise}async function r(G,ee){const{protocol:K}=await u(G,1,void 0,ee);return{protocol:K}}async function a(G,ee,K){const{protocol:F,firstMessage:j}=await u(G,2,ee,K),H=j&&j.debugPort;return{protocol:F,debugPort:H}}async function i(G,ee,K){const F=Date.now(),j=q(G,3),{protocol:H}=await l(G,3,ee,K);return G.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${X(F)}!`),H}async function t(G,ee,K){const{host:F,port:j,connectionToken:H}=await G.addressProvider.getAddress();return{commit:G.commit,host:F,port:j,connectionToken:H,reconnectionToken:ee,reconnectionProtocol:K,socketFactory:G.socketFactory,signService:G.signService,logService:G.logService}}async function s(G,ee,K){try{const F=(0,b.generateUuid)(),j=await t(G,F,null),{protocol:H}=await r(j,k.CancellationToken.None);return new M(G,ee,K,F,H)}catch(F){throw G.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),G.logService.error(F),D.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=s;async function o(G,ee){try{const K=(0,b.generateUuid)(),F=await t(G,K,null),{protocol:j,debugPort:H}=await a(F,ee,k.CancellationToken.None);return new z(G,ee,K,j,H)}catch(K){throw G.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),G.logService.error(K),D.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=o;async function c(G,ee,K){const F=await t(G,(0,b.generateUuid)(),null);return await i(F,{host:ee,port:K},k.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function h(G){return(0,L.createCancelablePromise)(ee=>new Promise((K,F)=>{const j=setTimeout(K,G*1e3);ee.onCancellationRequested(()=>{clearTimeout(j),K()})}))}var v;(function(G){G[G.ConnectionLost=0]="ConnectionLost",G[G.ReconnectionWait=1]="ReconnectionWait",G[G.ReconnectionRunning=2]="ReconnectionRunning",G[G.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",G[G.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(ee,K){this.reconnectionToken=ee,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=I;class A{constructor(ee,K,F,j){this.reconnectionToken=ee,this.millisSinceLastIncomingData=K,this.durationSeconds=F,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=A;class O{constructor(ee,K,F){this.reconnectionToken=ee,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(ee,K,F){this.reconnectionToken=ee,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(ee,K,F,j){this.reconnectionToken=ee,this.millisSinceLastIncomingData=K,this.attempt=F,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class D extends R.Disposable{constructor(ee,K,F,j){super();this._connectionType=ee,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=F,this.protocol=j,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(j.onSocketClose(H=>{const W=B(this._connectionType,this.reconnectionToken,!0);H?H.type===0?(this._options.logService.info(`${W} received socket close event (hadError: ${H.hadError}).`),H.error&&this._options.logService.error(H.error)):(this._options.logService.info(`${W} received socket close event (wasClean: ${H.wasClean}, code: ${H.code}, reason: ${H.reason}).`),H.event&&this._options.logService.error(H.event)):this._options.logService.info(`${W} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(()=>{const H=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${H} received socket timeout event.`),this._beginReconnecting()})),D._instances.push(this),D._permanentFailure&&this._gotoPermanentFailure(D._permanentFailureMillisSinceLastIncomingData,D._permanentFailureAttempt,D._permanentFailureHandled)}static triggerPermanentFailure(ee,K,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=ee,this._permanentFailureAttempt=K,this._permanentFailureHandled=F,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(ee=>ee._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(ee=>ee._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(D._permanentFailure)return;const ee=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${ee} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const j=F<K.length?K[F]:K[K.length-1];try{if(j>0){const W=h(j);this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,W)),this._options.logService.info(`${ee} waiting for ${j} seconds before reconnecting...`);try{await W}catch{}}if(D._permanentFailure){this._options.logService.error(`${ee} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${ee} resolving connection...`);const H=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${ee} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,f(E)),this._options.logService.info(`${ee} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${ee} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${ee} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${ee} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${ee} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,_.isPromiseCanceledError)(H)){this._options.logService.info(`${ee} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${ee} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,P.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${ee} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!D._permanentFailure)}_gotoPermanentFailure(ee,K,F){this._onDidStateChange.fire(new $(this.reconnectionToken,ee,K,F)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=D,D._permanentFailure=!1,D._permanentFailureMillisSinceLastIncomingData=0,D._permanentFailureAttempt=0,D._permanentFailureHandled=!1,D._instances=[];class M extends D{constructor(ee,K,F,j,H){super(1,ee,j,H);this.client=this._register(new w.Client(H,{remoteAuthority:K,clientId:F},ee.ipcLogger))}async _reconnect(ee,K){await r(ee,K)}}e.ManagementPersistentConnection=M;class z extends D{constructor(ee,K,F,j,H){super(2,ee,F,j);this._startArguments=K,this.debugPort=H}async _reconnect(ee,K){await a(ee,this._startArguments,K)}}e.ExtensionHostPersistentConnection=z;function U(G){try{G.acceptDisconnect();const ee=G.getSocket();G.dispose(),ee.dispose()}catch(ee){(0,_.onUnexpectedError)(ee)}}function V(G){if(G&&G.type==="error"){const ee=new Error(`Connection error: ${G.reason}`);return ee.code="VSCODE_CONNECTION_ERROR",ee}return null}function Y(G,ee){for(;G.length<ee;)G+=" ";return G}function B(G,ee,K){return`[remote-connection][${Y(p(G),13)}][${ee.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function q(G,ee){return`${B(ee,G.reconnectionToken,!!G.reconnectionProtocol)}[${G.host}:${G.port}]`}function X(G){return`${Date.now()-G} ms`}}),define(ne[186],ie([0,1,18]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(w){return w.scheme===L.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=n;function k(w){if(!w)return;const P=w.indexOf("+");return P<0?w:w.substr(0,P)}e.getRemoteName=k;function _(w){return w.scheme!==L.Schemas.file&&w.scheme!==L.Schemas.vscodeRemote}e.isVirtualResource=_;function T(w){if(w.folders.length)return w.folders.every(P=>_(P.uri))?w.folders[0].uri:void 0;if(w.configuration&&_(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=T;function R(w){return T(w)?.scheme}e.getVirtualWorkspaceScheme=R;function b(w){return T(w)!==void 0}e.isVirtualWorkspace=b}),define(ne[88],ie([0,1,27,6,186]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=_;function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,f){if(typeof p=="undefined"||p===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){let y=typeof p=="string"?p:p.value,C=typeof f=="string"?f:f.value;return L.equalsIgnoreCase(y,C)}return p._lower===f._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=b;function w(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function P(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function E(g,p){if(p){const f=`onResolveRemoteAuthority:${(0,k.getRemoteName)(p)}`;return g.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],ie([0,1,27,88]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(f,y){return f.uuid&&y.uuid?f.uuid===y.uuid:f.id===y.id?!0:(0,L.compareIgnoreCase)(f.id,y.id)===0}e.areSameExtensions=k;class _{constructor(y,C){this.version=C,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof _?k(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=_;function T(f,y){return`${f}.${y}`}e.getExtensionId=T;function R(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(f,y){return R(T(f,y))}e.getGalleryExtensionId=b;function w(f,y){const C=[],d=S=>{for(const m of C)if(m.some(l=>k(y(l),y(S))))return m;return null};for(const S of f){const m=d(S);m?m.push(S):C.push([S])}return C}e.groupByExtension=w;function P(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function g(f){const y=new Set;if(f.malicious)for(const C of f.malicious)y.add(C.id);return y}e.getMaliciousExtensionsSet=g;function p(f,y){const C=[],d=y.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const S=d.shift();if(S&&C.every(m=>!k(m.identifier,{id:S}))){const m=f.filter(l=>k(l.identifier,{id:S}));m.length===1&&(C.push(m[0]),d.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return C}e.getExtensionDependencies=p}),define(ne[187],ie([0,1,5,8,2,4,19,61,7,29,22,13,30,33,14,10]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let d=class extends k.Disposable{constructor(m,l,u,r){super();this.fileService=l,this.extensionGalleryService=u,this.logService=r,this.extensionsDownloadDir=b.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,l){await this.cleanUpPromise;const u=this.getName(m),r=(0,T.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(r)){const a=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(m,a,l);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return r}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,l,u){try{await P.Promises.rename(m.fsPath,l.fsPath)}catch(r){if(_.isWindows&&r&&r.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${m} to ${l} with 'EPERM' error. Trying again...`),this.rename(m,l,u);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const l=[],u=[];for(const i of m.children){const t=this.parse(i.name);t&&u.push([t,i])}const r=(0,p.groupByExtension)(u,([i])=>i),a=[];for(const i of r)i.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),l.push(...i.slice(1).map(t=>t[1].resource)),a.push(i[0][1]);a.sort((i,t)=>i.mtime-t.mtime),l.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await L.Promises.settled(l.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?`${new p.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase()}${m.properties.targetPlatform!=="undefined"?`-${m.properties.targetPlatform}`:""}`:(0,w.generateUuid)()}parse(m){const l=C.exec(m);return l&&l[1]&&l[2]?new p.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};d=de([Q(0,E.INativeEnvironmentService),Q(1,f.IFileService),Q(2,g.IExtensionGalleryService),Q(3,y.ILogService)],d),e.ExtensionsDownloader=d}),define(ne[188],ie([0,1,2,9,22,88]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(b,w){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,_.MANIFEST_CACHE_FOLDER,_.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(w.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(b){b.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[189],ie([0,1,81,16,5,2,18,9,22,13,30,33,59,10]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let f=class extends _.Disposable{constructor(d,S,m){super();this.extensionManagementService=d,this.logService=m,this.cache=this._register(new y(S,m)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const d=await this.cache.getLanguagePacks(),S=["en",...Object.keys(d)];return(0,n.distinct)(S)}async postInstallExtension(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",d.identifier.id),await this.update())}async postUninstallExtension(d){const S=await this.cache.getLanguagePacks();Object.keys(S).some(m=>S[m]&&S[m].extensions.some(l=>(0,E.areSameExtensions)(l.extensionIdentifier,d.identifier)))&&(this.logService.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),m=await this.cache.update(S);return!(0,n.equals)(Object.keys(d),Object.keys(m))}};f=de([Q(0,P.IExtensionManagementService),Q(1,w.INativeEnvironmentService),Q(2,p.ILogService)],f),e.LocalizationsService=f;let y=class extends _.Disposable{constructor(d,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(d.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(d){return this.withLanguagePacks(S=>{Object.keys(S).forEach(m=>delete S[m]),this.createLanguagePacksFromExtensions(S,...d)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(d,...S){for(const m of S)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(d,m);Object.keys(d).forEach(m=>this.updateHash(d[m]))}createLanguagePacksFromExtension(d,S){const m=S.identifier,l=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const u of l)if(S.location.scheme===T.Schemas.file&&(0,g.isValidLocalization)(u)){let r=d[u.languageId];r||(r={hash:"",extensions:[],translations:{}},d[u.languageId]=r);let a=r.extensions.filter(i=>(0,E.areSameExtensions)(i.extensionIdentifier,m))[0];a?a.version=S.manifest.version:r.extensions.push({extensionIdentifier:m,version:S.manifest.version});for(const i of u.translations)r.translations[i.id]=(0,R.join)(S.location.fsPath,i.path)}}updateHash(d){if(d){const S=(0,L.createHash)("md5");for(const m of d.extensions)S.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);d.hash=S.digest("hex")}}withLanguagePacks(d=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(S=d(m),m)).then(m=>{for(const u of Object.keys(m))m[u]||delete m[u];this.languagePacks=m,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),b.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>S,m=>this.logService.error(m))})}};y=de([Q(0,w.INativeEnvironmentService),Q(1,p.ILogService)],y)}),define(ne[190],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,10]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var T;(function(f){f.Http="http",f.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=E;function g(f,y){return y?y!==1&&f<1024:!n.isWindows&&f<1024}e.isPortPrivileged=g;let p=class{constructor(y){this.logService=y,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,C){return this._tunnelProvider=y,y?(this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],C=Array.from(this._tunnels.values());for(let d of C){const S=Array.from(d.values());for(let m of S){const l=await m.value;l&&y.push(l)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:C}of y.values())await C.then(d=>d?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,C,d,S,m=!1,l=R.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${C}:${d} on local port ${S}.`),!y)return;C||(C="localhost");const r=this.retainOrCreateTunnel(y,C,d,S,m,l,u);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(C,d);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(a);return(a.tunnelRemoteHost!==C||a.tunnelRemotePort!==d)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const C=this._tunnels.get(y.tunnelRemoteHost);if(C){const d=C.get(y.tunnelRemotePort);d&&(d.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,d))}}}}async tryDisposeTunnel(y,C,d){if(d.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${C}.`);const S=d.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(C),S}}async closeTunnel(y,C){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${C} `);const d=this._tunnels.get(y);if(d&&d.has(C)){const S=d.get(C);S.refcount=0,await this.tryDisposeTunnel(y,C,S)}}addTunnelToMap(y,C,d){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(C,{refcount:1,value:d})}async removeEmptyTunnelFromMap(y,C){const d=this._tunnels.get(y);d&&(await d.get(C)||d.delete(C),d.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,C){let d=[y];P(y)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):E(y)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const S=d.map(m=>this._tunnels.get(m));for(const m of S){const l=m?.get(C);if(l)return l}}canTunnel(y){return!!w(y)}createWithProvider(y,C,d,S,m,l,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${C}:${d} on local port ${S}.`);const a={elevationRequired:m?g(S===void 0?d:S):!1},i={remoteAddress:{host:C,port:d},localAddressPort:S,privacy:l,public:l!==R.Private,protocol:u},t=y.forwardPort(i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(C,d,t),t}};p=de([Q(0,_.ILogService)],p),e.AbstractTunnelService=p}),define(ne[191],ie([0,1,10,62,2,8,5]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let b=class It extends k.Disposable{constructor(P,E){super();this._tunnelService=P,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(P,E,g,p,f,y){const C=new R,d=await Promise.resolve(this._tunnelService.openTunnel(P,C,g,p,f,y));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${g}:${p} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),C.dispose(),await d.dispose(),(0,_.canceled)();return C.setTunnel(d),this._tunnels.set(E,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${d.localAddress} (local) to ${g}:${p} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(P,E){const g=this._tunnels.get(P);!g||g.setAddress(E)}async destroyTunnel(P){const E=this._tunnels.get(P);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await E.dispose();return}this._disposedTunnels.add(P)}};b._lastId=0,b=de([Q(0,n.ISharedTunnelsService),Q(1,L.ILogService)],b),e.SharedProcessTunnelService=b}),define(ne[192],ie([0,1,119,20,10]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let _=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(R,b)}async resolveProxy(R){}};_=de([Q(0,n.IConfigurationService),Q(1,k.ILogService)],_),e.RequestService=_}),define(ne[43],ie([0,1,17,140,42,6,38]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,_.createDecorator)("requestService");function R(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=R;function b(f){return f.res.statusCode===204}async function w(f){if(!R(f))throw new Error("Server returned "+f.res.statusCode);return b(f)?null:(await(0,L.streamToBuffer)(f.stream)).toString()}e.asText=w;async function P(f){if(!R(f))throw new Error("Server returned "+f.res.statusCode);if(b(f))return null;const C=(await(0,L.streamToBuffer)(f.stream)).toString();try{return JSON.parse(C)}catch(d){throw d.message+=`:
`+C,d}}e.asJson=P;function E(f){p(f)}e.updateProxyConfigurationsScope=E;let g;function p(f){const y=T.Registry.as(k.Extensions.Configuration),C=g;g={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[g],remove:C?[C]:[]})}p(2)}),define(ne[193],ie([0,1,25,18,14,43]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(b,w){this.requestService=b,this.fileService=w}async download(b,w,P=L.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,w);return}const E={type:"GET",url:b.toString()},g=await this.requestService.request(E,P);if(g.res.statusCode===200)await this.fileService.writeFile(w,g.stream);else{const p=await(0,_.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${p}`)}}};T=de([Q(0,_.IRequestService),Q(1,k.IFileService)],T),e.DownloadService=T}),define(ne[194],ie([0,1,16,25,66,2,19,154,14,10,26,43]),function(J,e,L,n,k,_,T,R,b,w,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends _.Disposable{constructor(f,y,C,d){super();this.fileService=f,this.productService=y,this.requestService=C,this.logService=d,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:S})=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(f){return this.getValidConfigBasedTips(f)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(f){const y=[];for(const[C,d]of this.allConfigBasedTips)if(!(d.configScheme&&d.configScheme!==f.scheme))try{const S=await this.fileService.readFile((0,T.joinPath)(f,C)),m=new Map;(0,k.forEach)(d.recommendations,({key:u,value:r})=>{if((0,L.isNonEmptyArray)(r.remotes))for(const a of r.remotes)m.set(a,{extensionId:u,extensionName:r.name,configName:d.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else y.push({extensionId:u,extensionName:r.name,configName:d.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const l=(0,R.getDomainsOfRemotes)(S.value.toString(),[...m.keys()]);for(const u of l){const r=m.get(u);r&&y.push(r)}}catch{}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const f=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(f.res.statusCode!==200)return[];const y=await(0,E.asJson)(f);return y?y.workspaceRecommendations||[]:[]}catch(f){return this.logService.error(f),[]}}};g=de([Q(0,b.IFileService),Q(1,P.IProductService),Q(2,E.IRequestService),Q(3,w.ILogService)],g),e.ExtensionTipsService=g}),define(ne[46],ie([0,1,17,29]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(_,T,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const P=(await T.readFile(_.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(P)?P:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await T.writeFile(_.serviceMachineIdResource,L.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=k}),define(ne[89],ie([0,1,106,6]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(_){return(0,L.hash)({moduleId:_.process.moduleId,windowId:_.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[195],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[196],ie([0,1,72,152,5,25,3,2,18,4,29,13,10,26,89,195]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let C=class{constructor(m,l,u){this.logService=m,this.productService=l,this.environmentService=u,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(m){const l=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${l})`);const u=(0,f.hash)(m);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${l})`),this.doDisposeWorker(m));const r=new _.CancellationTokenSource;let a,i,t;this.processeDisposables.set(u,h=>{r.dispose(!0),a?.terminate(m,_.CancellationToken.None),i?.close(),t?.close(),this.processeDisposables.delete(u);const v=this.processResolvers.get(u);v&&(this.processResolvers.delete(u),v({reason:h}))}),a=await this.getOrCreateWebWorker(m);const s=new Promise(h=>{this.processResolvers.set(u,h)});if(r.token.isCancellationRequested)return s;const{port1:o,port2:c}=new MessageChannel;return i=o,t=c,await a.spawn(m,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${l})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",m,[i])),s}getOrCreateWebWorker(m){let l=this.workers.get(m.process.moduleId);if(!l){this.logService.trace(`SharedProcess: creating new web worker (${m.process.moduleId})`);const u=new d(m.process.type,this.logService,this.productService,this.environmentService);l=u.init(),u.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(m.process.moduleId,l)}return l}async disposeWorker(m){return this.doDisposeWorker(m)}doDisposeWorker(m,l){const u=this.processeDisposables.get((0,f.hash)(m));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),u(l))}};C=de([Q(0,g.ILogService),Q(1,p.IProductService),Q(2,E.INativeEnvironmentService)],C),e.SharedProcessWorkerService=C;class d extends R.Disposable{constructor(m,l,u,r){super();this.type=m,this.logService=l,this.productService=u,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const m=new k.DeferredPromise,l=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return l.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},l.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},l.onmessage=u=>{const{id:r,message:a,configuration:i,nonce:t}=u.data;switch(r){case y.SharedProcessWorkerMessages.Ready:m.complete(l);break;case y.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case y.SharedProcessWorkerMessages.SelfTerminated:i&&a&&this._onDidProcessSelfTerminate.fire({configuration:i,reason:JSON.parse(a)});break;case y.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case y.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},l.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),m.p}async send(m,l,u){const r=await this.workerReady;if(!l.isCancellationRequested)return new Promise(a=>{const i=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(i,a);const t={...m,nonce:i};u?r.postMessage(t,[u]):r.postMessage(t),l.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(i)&&a()})})}spawn(m,l,u){const r={id:y.SharedProcessWorkerMessages.Spawn,configuration:m,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,u,l)}getSharedProcessWorkerEnvironment(){const m={bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",J).fsPath,env:Object.create(null)};if(w.isLinux){const l={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},u=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&u&&(0,P.isUUID)(u)){const t=r["linux-x64"];l.submitURL=t.concat("&uid=",u,"&iid=",u,"&sid=",u),l.uploadToServer=!0}const i=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;m.env.BREAKPAD_DUMP_LOCATION=(0,n.join)(i,this.type),m.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(l)}return m}terminate(m,l){const u={id:y.SharedProcessWorkerMessages.Terminate,configuration:m};return this.send(u,l)}}}),define(ne[197],ie([0,1,53,18,153]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class _ extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([L.memoize],_.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=_}),define(ne[90],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[198],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((k,_)=>J(["vsda"],k,_))}async createNewMessage(k){try{const _=await this.vsda(),T=new _.validator;if(T){const R=String(L._nextId++);return this.validators.set(R,T),{id:R,data:T.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,_){if(!k.id)return!0;const T=this.validators.get(k.id);if(!T)return!1;this.validators.delete(k.id);try{return T.validate(_)==="ok"}catch{return!1}}async sign(k){try{const _=await this.vsda(),T=new _.signer;if(T)return T.sign(k)}catch{}return k}}e.SignService=L,L._nextId=1}),define(ne[23],ie([0,1,5,3,2,177,15,73,6]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var P;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var g;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class p extends k.Disposable{constructor(d={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,S){S===w?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:S,target:this.getKeyTargets(d)[S]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,S,m){return this.getStorage(S)?.get(d,m)}getBoolean(d,S,m){return this.getStorage(S)?.getBoolean(d,m)}getNumber(d,S,m){return this.getStorage(S)?.getNumber(d,m)}store(d,S,m,l){if((0,T.isUndefinedOrNull)(S)){this.remove(d,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,m,l),this.getStorage(m)?.set(d,S)})}remove(d,S){this.withPausedEmitters(()=>{this.updateKeyTarget(d,S,void 0),this.getStorage(S)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,S){const m=[],l=this.getKeyTargets(d);for(const u of Object.keys(l))l[u]===S&&m.push(u);return m}updateKeyTarget(d,S,m){const l=this.getKeyTargets(S);typeof m=="number"?l[d]!==m&&(l[d]=m,this.getStorage(S)?.set(w,JSON.stringify(l))):typeof l[d]=="number"&&(delete l[d],this.getStorage(S)?.set(w,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const S=this.get(w,d);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=P.NONE){this._onWillSaveState.fire({reason:d});const S=this.getStorage(0),m=this.getStorage(1);switch(d){case P.NONE:await L.Promises.settled([S?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([S?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const d=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return y(d,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class f extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}e.InMemoryStorageService=f;async function y(C,d,S,m){const l=o=>{try{return JSON.parse(o)}catch{return o}},u=new Map,r=new Map;C.forEach((o,c)=>{u.set(c,o),r.set(c,l(o))});const a=new Map,i=new Map;d.forEach((o,c)=>{a.set(c,o),i.set(c,l(o))}),console.group(`Storage: Global (path: ${S})`);let t=[];u.forEach((o,c)=>{t.push({key:c,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${m})`);let s=[];a.forEach((o,c)=>{s.push({key:c,value:o})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=y}),define(ne[199],ie([0,1,3,2,15,30,33,23]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(E,g){super();this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(E)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(g.onDidInstallExtensions(p=>p.forEach(({local:f,operation:y})=>{f&&y===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(E,g){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:g}),!0):!1}async disableExtension(E,g){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let g=this.getDisabledExtensions();return g.every(p=>!(0,T.areSameExtensions)(p,E))?(g.push(E),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(E){let g=this.getDisabledExtensions();for(let p=0;p<g.length;p++){const f=g[p];if((0,T.areSameExtensions)(f,E))return g.splice(p,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(E){this._setExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,g){this.storageManger.set(E,g,0)}};b=de([Q(0,R.IStorageService),Q(1,_.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class w extends n.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(E,g){let p;return g===0?((0,k.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,g)),p=this.storage[E]):p=this._get(E,g),JSON.parse(p)}set(E,g,p){let f=JSON.stringify(g.map(({id:C,uuid:d})=>({id:C,uuid:d})));this._get(E,p)!==f&&(p===0&&(g.length?this.storage[E]=f:delete this.storage[E]),this._set(E,g.length?f:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const f=this.get(E.key,E.scope),y=p.filter(d=>!f.some(S=>(0,T.areSameExtensions)(d,S))),C=f.filter(d=>!p.some(S=>(0,T.areSameExtensions)(S,d)));(y.length||C.length)&&this._onDidChange.fire([...y,...C])}}_get(E,g){return this.storageService.get(E,g,"[]")}_set(E,g,p){g?this.storageService.store(E,g,p,1):this.storageService.remove(E,p)}}e.StorageManager=w}),define(ne[200],ie([0,1,3,2]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends n.Disposable{constructor(w,P){super();this.channel=w,this.workspace=P}async getItems(){const w={workspace:this.workspace},P=await this.channel.call("getItems",w);return new Map(P)}updateItems(w){const P={workspace:this.workspace};return w.insert&&(P.insert=Array.from(w.insert.entries())),w.delete&&(P.delete=Array.from(w.delete.values())),this.channel.call("updateItems",P)}}class _ extends k{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class T extends k{constructor(w,P){super(w,P);this.onDidChangeItemsExternal=L.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class R extends n.Disposable{constructor(w,P){super();this.channel=w,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new _(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[201],ie([0,1,5,2,19,73,23,200]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(P,E,g){super();this.mainProcessService=E,this.environmentService=g,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new _.Storage(P.globalStorage);return this._register(E.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),E}createWorkspaceStorage(P){const E=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(E.workspaceStorage){const g=new _.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=g.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,g}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await L.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const E=this.workspaceStorage,g=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,f]of g)this.workspaceStorage.set(p,f)}}e.NativeStorageService=b}),define(ne[202],ie([0,1,4,31,7,29]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(w){if(L.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function R(w,P,E,g,p,f,y,C,d,S){const m=Object.create(null);m["common.machineId"]=y,m.sessionID=(0,_.generateUuid)()+Date.now(),m.commitHash=p,m.version=f,m["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,L.PlatformToString)(L.platform),m["common.nodePlatform"]=n.platform,m["common.nodeArch"]=g,m["common.product"]=S||"desktop";const l=b(C||[]);l&&(m["common.msftInternal"]=l);let u=0;const r=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),L.isLinuxSnap&&(m["common.snap"]="true");const a=T(E);a&&(m["common.platformDetail"]=a);try{const i=await w.readFile(k.URI.file(d));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=R;function b(w){const P=n.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return w.some(g=>E===g)}e.verifyMicrosoftInternalDomain=b}),define(ne[21],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[203],ie([0,1,32,54,5,35,18,9,4,7,113,22,116,78,14,26,21]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function d(r,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=L.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(s+"/onedrive")||O.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(s+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(s+"/owncloud/")}];break}const o=new Map,c=new Map,h=2e4;function v(O,N,$,D){for(const z of t){const U=O.toLowerCase();z.matcher(U)&&c.set(z.tag,1)}const M=N.substring(O.length+1);return k.Promises.withAsyncBody(async z=>{let U;try{U=await E.Promises.readdir(N,{withFileTypes:!0})}catch{z();return}if(D.count>=h){D.count+=U.length,D.maxReached=!0,z();return}let V=U.length;if(V===0){z();return}let Y=U;D.count+U.length>h&&(D.maxReached=!0,V=h-D.count,Y=U.slice(0,V)),D.count+=U.length;for(const B of Y)if(B.isDirectory()){if($.includes(B.name)||await v(O,(0,R.join)(N,B.name),$,D),--V==0){z();return}}else{const q=B.name.lastIndexOf(".");if(q>=0){const X=B.name.substring(q+1);X&&o.set(X,(o.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(M)!==!1&&X.filePattern.test(B.name)&&c.set(X.tag,(c.get(X.tag)??0)+1);if(--V==0){z();return}}})}const I={count:0,maxReached:!1};await v(r,r,a,I);const A=await l(r);return{configFiles:S(c),fileTypes:S(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:A}}e.collectWorkspaceStats=d;function S(r){return[...n.Iterable.map(r.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function m(){const r={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=L.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=m;async function l(r){try{const a=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await E.Promises.readFile(i),s=[],o=(0,_.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${i}`),[];if((0,_.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const h=c.type;h&&(a.has(h)?a.set(h,a.get(h)+1):a.set(h,1))}return S(a)}catch{return[]}}e.collectLaunchConfigs=l;let u=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(L.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||i.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),i.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,g.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,c=this.formatProcessList(a,s);return i.forEach(h=>{if((0,p.isRemoteDiagnosticError)(h))c+=`
${h.errorMessage}`,o+=`
${h.errorMessage}`;else if(c+=`

Remote: ${h.hostName}`,h.processes&&(c+=`
${this.formatProcessList(a,h.processes)}`),h.workspaceMetadata){o+=`
|  Remote: ${h.hostName}`;for(const v of Object.keys(h.workspaceMetadata)){const I=h.workspaceMetadata[v];let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),o+=`|    Folder (${v}): ${A}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(a,i){const{memory:t,vmHint:s,os:o,cpus:c}=m(),h={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return b.isWindows||(h.load=`${L.loadavg().map(v=>Math.round(v)).join(", ")}`),b.isLinux&&(h.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(h)}async getDiagnostics(a,i){const t=[];return(0,g.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),i.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const h=o.workspaceMetadata[c];let v=`${h.fileCount} files`;h.maxFilesReached&&(v=`more than ${v}`),t.push(`Folder (${c}): ${v}`),t.push(this.formatWorkspaceStats(h))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const i=[],t=60;let s=0;const o=(I,A)=>{const O=` ${I}(${A})`;s+O.length>t?(i.push(c),c="|                 ",s=c.length):s+=O.length,c+=O};let c="|      File types:";const h=10;let v=a.fileTypes.length>h?h:a.fileTypes.length;for(let I=0;I<v;I++){const A=a.fileTypes[I];o(A.name,A.count)}if(i.push(c),a.configFiles.length>=0&&(c="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),i.push(c)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(A=>{I+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),i.push(I)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(i.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=w.URI.revive(o);if(c.scheme===T.Schemas.file){const h=c.fsPath;t.push(d(h,["node_modules",".git"]).then(v=>{let I=`${v.fileCount} files`;v.maxFilesReached&&(I=`more than ${I}`),i.push(`|    Folder (${(0,R.basename)(h)}): ${I}`),i.push(this.formatWorkspaceStats(v))}).catch(v=>{i.push(`|      Error: Unable to collect workspace stats for folder ${h} (${v.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>i.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,i){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,t,s,i,0),s.join(`
`)}formatProcessItem(a,i,t,s,o){const c=o===0;let h;c?h=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(h=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(h=`${h} (${i.get(s.pid)})`));const v=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${h}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,i,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const t=w.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const s=t.fsPath;try{const o=await d(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};u=de([Q(0,C.ITelemetryService),Q(1,y.IProductService)],u),e.DiagnosticsService=u}),define(ne[204],ie([0,1,16,5,25,8,3,2,4,15,7,129,30,33,10,26,21]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=class extends R.Disposable{constructor(a,i,t,s){super();this.galleryService=a,this.telemetryService=i,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,g.isTargetPlatformCompatible)(t,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new g.ExtensionManagementError(E.localize(0,null),g.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw l(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),m(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const i=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=i.find(v=>(0,p.areSameExtensions)(v.identifier,{id:t}));if(!o)continue;const c=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!c){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const h=await this.galleryService.getManifest(c,k.CancellationToken.None);if(!h){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(h,c,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(v){this.logService.error(v)}}}catch(a){this.logService.error(a)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.findGalleryExtension(a);if(!i)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,t){if(!P.URI.isUri(i)){let v=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(v)return this.logService.info("Extensions is already requested to install",i.identifier.id),v.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],c=this.createInstallExtensionTask(a,i,t);P.URI.isUri(i)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:i}),this.logService.info("Installing extension:",c.identifier.id),s.push({task:c,manifest:a});let h=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:A,manifest:O}of I)if(h=h||!!O.extensionDependencies?.some(N=>(0,p.areSameExtensions)({id:N},c.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(A.identifier,A.version).key()))this.logService.info("Extension is already requested to install",A.identifier.id);else{const N=this.createInstallExtensionTask(O,A,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(N.identifier,O.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:A}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:O})}}catch(I){if(P.URI.isUri(c.source))(0,L.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,I.message),(0,L.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),I}const v=s.reduce((I,{task:A,manifest:O})=>(I.set(A.identifier.id.toLowerCase(),{task:A,manifest:O}),I),new Map);for(;v.size;){let I;const A=[...v.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(N=>v.has(N.toLowerCase())));A.length?I=v.size===1?A:A.filter(({task:O})=>!(O===c&&!h)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:O})=>O.identifier.id)),I=[...v.values()]),await this.joinAllSettled(I.map(async({task:O})=>{const N=new Date().getTime(),$=(0,w.isUndefined)(t.operation)?O.operation:t.operation;try{const D=await O.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(D,O.source,t,k.CancellationToken.None))),!P.URI.isUri(O.source)&&(l(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,void 0),b.isWeb&&$!==3))try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"install")}catch{}o.push({local:D,identifier:O.identifier,operation:$,source:O.source})}catch(D){throw P.URI.isUri(O.source)||l(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-N,D),this.logService.error("Error while installing the extension:",O.identifier.id),D}finally{v.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,p.areSameExtensions)(I,c.identifier))[0].local}catch(v){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<I.length;A++){const O=I[A],{identifier:N}=o[A];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,_.getErrorMessage)(O.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,_.getErrorMessage)(I),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),v}finally{for(const{task:v,manifest:I}of s)if(!P.URI.isUri(v.source)){const A=new p.ExtensionIdentifierWithVersion(v.identifier,I.version).key();this.installingExtensions.delete(A)||this.logService.warn("Installation task is not found in the cache",A)}}}async joinAllSettled(a){const i=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?i.push(o.value):t.push(o.reason);if(t.length)throw S(t);return i}async getAllDepsAndPackExtensionsToInstall(a,i,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[a,...o.map(I=>I.identifier)],h=[],v=async(I,A)=>{const O=A.extensionDependencies||[],N=[...O];if(A.extensionPack){const $=t?o.find(D=>(0,p.areSameExtensions)(D.identifier,I)):void 0;for(const D of A.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(M=>(0,p.areSameExtensions)({id:M},{id:D}))||N.every(M=>!(0,p.areSameExtensions)({id:M},{id:D}))&&N.push(D)}if(N.length){const $=[...c,...h.map(M=>M.gallery.identifier)],D=N.filter(M=>$.every(z=>!(0,p.areSameExtensions)(z,{id:M})));if(D.length){const M=await this.galleryService.query({names:D,pageSize:N.length},k.CancellationToken.None);for(const z of M.firstPage){if($.find(Y=>(0,p.areSameExtensions)(Y,z.identifier)))continue;const U=O.some(Y=>(0,p.areSameExtensions)({id:Y},z.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(z,!0,s)}catch(Y){if(Y instanceof g.ExtensionManagementError&&Y.code===g.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id);continue}else throw Y}h.push({gallery:V.extension,manifest:V.manifest}),await v(V.extension.identifier,A)}}}};return await v(a,i),o=await this.getInstalled(),h.filter(I=>!o.some(A=>(0,p.areSameExtensions)(A.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,t){const s=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new g.ExtensionManagementError(E.localize(3,null,a.identifier.id),g.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new g.ExtensionManagementError(E.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),g.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const h=await this.getTargetPlatform();throw new g.ExtensionManagementError(E.localize(5,null,a.identifier.id,this.productService.nameLong,(0,g.TargetPlatformToString)(h)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,i,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new g.ExtensionManagementError(E.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new g.ExtensionManagementError(E.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),g.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const c=await this.galleryService.getManifest(o,k.CancellationToken.None);if(c===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new g.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(a,i,t){const s=await this.getTargetPlatform();let o=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&i&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,i){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(v,I)=>{const A=this.createUninstallExtensionTask(v,I);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),A},o=(v,I)=>{I?this.logService.error("Failed to uninstall extension:",v.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),l(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(v),void 0,I),this._onDidUninstallExtension.fire({identifier:v.identifier,error:I?.code})},c=[],h=[];try{c.push(s(a,{}));const v=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,v);for(const A of I)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):c.push(s(A,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(I=>I.extension),v,a),await this.joinAllSettled(c.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(I.extension,i,k.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(A){const O=A instanceof g.ExtensionManagementError?A:new g.ExtensionManagementError((0,_.getErrorMessage)(A),g.ExtensionManagementErrorCode.Internal);throw o(I.extension,O),O}finally{h.push(I)}}))}catch(v){const I=v instanceof g.ExtensionManagementError?v:new g.ExtensionManagementError((0,_.getErrorMessage)(v),g.ExtensionManagementErrorCode.Internal);for(const A of c){try{A.cancel()}catch{}h.includes(A)||o(A.extension,I)}throw I}finally{for(const v of c)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(a,i,t){for(const s of a){const o=this.getDependents(s,i);if(o.length){const c=o.filter(h=>!a.some(v=>(0,p.areSameExtensions)(v.identifier,h.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(s,c,t))}}}getDependentsErrorMessage(a,i,t){return t===a?i.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=i.filter(h=>!h.isBuiltin&&s.some(v=>(0,p.areSameExtensions)({id:v},h.identifier))),c=[];for(const h of o)c.push(...this.getAllPackExtensionsToUninstall(h,i,t));return[...o,...c]}return[]}getDependents(a,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,p.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const i=await this.findGalleryExtensionById(a.identifier.uuid);return i||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};d=de([Q(0,g.IExtensionGalleryService),Q(1,C.ITelemetryService),Q(2,f.ILogService),Q(3,y.IProductService)],d),e.AbstractExtensionManagementService=d;function S(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=S;function m(r){if(r instanceof g.ExtensionManagementError)return r;const a=new g.ExtensionManagementError(r.message,g.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function l(r,a,i,t,s){const o=s?s instanceof g.ExtensionManagementError?s.code:g.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...i,success:!s,duration:t,errorcode:o})}e.reportTelemetry=l;class u{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((i,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,_.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=u}),define(ne[205],ie([0,1,16,5,66,3,9,4,31,7,131,13,30,194,80,14,10,60,26,43,23,21]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let i=class extends p.ExtensionTipsService{constructor(s,o,c,h,v,I,A,O,N,$){super(A,O,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=c,this.storageService=h,this.nativeHostService=v,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,k.forEach)(O.exeBasedExtensionTips,({key:D,value:M})=>{const z=[],U=[],V=[];(0,k.forEach)(M.recommendations,({key:Y,value:B})=>{B.important?M.important?z.push({extensionId:Y,extensionName:B.name,isExtensionPack:!!B.isExtensionPack}):U.push({extensionId:Y,extensionName:B.name,isExtensionPack:!!B.isExtensionPack}):V.push({extensionId:Y,extensionName:B.name,isExtensionPack:!!B.isExtensionPack})}),z.length&&this.highImportanceExecutableTips.set(D,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:z}),U.length&&this.mediumImportanceExecutableTips.set(D,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:U}),V.length&&this.allOtherExecutableTips.set(D,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:V})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,c)}groupImportantTipsByExe(s,o){const c=new Map;s.forEach(O=>c.set(O.extensionId.toLowerCase(),O));const{installed:h,uninstalled:v}=this.groupByInstalled([...c.keys()],o);for(const O of h){const N=c.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of v){const N=c.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),A=new Map;for(const O of v){const N=c.get(O);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let $=A.get(N.exeName);$||($=[],A.set(N.exeName,$)),$.push(N)}}return A}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const h=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,c=7*24*60*60*1e3;if(o<c){const I=this._register((0,n.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},c-o));return}const[h,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(v[0].exeName,v);const A=this._register((0,n.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const A=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(A(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const A=this._register((0,n.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:h})=>h.toLowerCase()),c=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,c,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const c=this.getPromptedExecutableTips();c[s]=o.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(s,o){const c=[],h=[],v=o.reduce((I,A)=>(I.add(A.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{v.has(I.toLowerCase())?c.push(I):h.push(I)}),{installed:c,uninstalled:h}}async getValidExecutableBasedExtensionTips(s){const o=[],c=new Map;for(const h of s.keys()){const v=s.get(h);if(!v||!(0,L.isNonEmptyArray)(v.recommendations))continue;const I=[];R.isWindows?v.windowsPath&&I.push(v.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(I.push((0,T.join)("/usr/local/bin",h)),I.push((0,T.join)("/usr/bin",h)),I.push((0,T.join)(this.environmentService.userHome.fsPath,h)));for(const A of I){let O=c.get(A);if(O===void 0&&(O=await this.fileService.exists(w.URI.file(A)),c.set(A,O)),O)for(const{extensionId:N,extensionName:$,isExtensionPack:D}of v.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:D,exeName:h,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return o}};i=de([Q(0,E.INativeEnvironmentService),Q(1,u.ITelemetryService),Q(2,g.IExtensionManagementService),Q(3,l.IStorageService),Q(4,d.INativeHostService),Q(5,f.IExtensionRecommendationNotificationService),Q(6,y.IFileService),Q(7,S.IProductService),Q(8,m.IRequestService),Q(9,C.ILogService)],i),e.ExtensionTipsService=i}),define(ne[91],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(_){this.appenders=_}listen(_,T){throw new Error(`Event not found: ${T}`)}call(_,T,{eventName:R,data:b}){return this.appenders.forEach(w=>w.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class n{constructor(_){this.channel=_}log(_,T){return this.channel.call("log",{eventName:_,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[44],ie([0,1,28,15,20,21]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(d,S){return Promise.resolve(void 0)}publicLog2(d,S){return this.publicLog(d,S)}publicLogError(d,S){return Promise.resolve(void 0)}publicLogError2(d,S){return this.publicLogError(d,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class R{async publicLog(d,S,m){}async publicLogError(d,S,m){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(C,d){return d.onDidChangeConfiguration(S=>{S.source!==6&&C.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(S.source),configurationKeys:f(S.sourceConfig)})})}e.configurationTelemetry=b;function w(C,d){return!(d.disableTelemetry||!C.enableTelemetry)}e.supportsTelemetry=w;function P(C){const d=C.getValue(_.TELEMETRY_SETTING_ID),S=C.getValue("telemetry.enableCrashReporter");if(C.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function E(C){const d=Object.create(null),S=Object.create(null),m=Object.create(null);p(C,m);for(let l in m){l=l.length>150?l.substr(l.length-149):l;const u=m[l];typeof u=="number"?S[l]=u:typeof u=="boolean"?S[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),d[l]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(d[l]=u)}return{properties:d,measurements:S}}e.validateTelemetryData=E;function g(C){if(!C)return"none";let d="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(m=>{C.indexOf(`${m}+`)===0&&(d=m)}),d}e.cleanRemoteAuthority=g;function p(C,d,S=0,m){if(!!C)for(let l of Object.getOwnPropertyNames(C)){const u=C[l],r=m?m+l:l;Array.isArray(u)?d[r]=(0,L.safeStringify)(u):u instanceof Date?d[r]=u.toISOString():(0,n.isObject)(u)?S<2?p(u,d,S+1,r+"."):d[r]=(0,L.safeStringify)(u):d[r]=u}}function f(C){if(!C)return[];const d=[];return y(d,"",C),d}function y(C,d,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(m=>y(C,d?`${d}.${m}`:m,S[m])):C.push(d)}}),define(ne[206],ie([0,1,44,149]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class k{constructor(){}setSharedProperty(b,w){}postEvent(b,w){}}class _{constructor(b,w,P,E,g){this.getMachineId=b,this.configurationService=w,this.productService=P,this.telemetry=E,this.keyValueStorage=g,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,L.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),f=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(y=>setTimeout(y,f))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const w=this.configurationService.getValue("experiments.override."+b);if(w!==void 0)return w;if(!this.tasClient||!this.experimentsEnabled)return;let P;const E=await this.tasClient;return this.networkInitialized?P=E.getTreatmentVariable("vscode",b):P=await E.getTreatmentVariableAsync("vscode",b,!0),P=E.getTreatmentVariable("vscode",b),P}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,w=await this.getMachineId(),P=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,w,b),E=this.productService.tasConfig,g=new(await new Promise((p,f)=>{J(["tas-client-umd"],p,f)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await g.initializePromise,g.initialFetch.then(()=>this.networkInitialized=!0),g}}e.BaseAssignmentService=_;class T extends _{constructor(b,w,P){super(()=>Promise.resolve(b),w,P,new k)}}e.AssignmentService=T}),define(ne[207],ie([0,1,16,25,8,28,4,31,15,7,20,13,30,33,76,14,10,26,43,46,23,21,44]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=T.isWeb?"web":(0,g.getTargetPlatform)(T.platform,R.arch);var i;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(i||(i={}));function t(...W){return String(W.reduce((x,re)=>x|re,0))}var s;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class I{constructor(x=v){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,re=this.state.pageSize){return new I({...this.state,pageNumber:x,pageSize:re})}withFilter(x,...re){const se=[...this.state.criteria,...re.length?re.map(ce=>({filterType:x,value:ce})):[{filterType:x}]];return new I({...this.state,criteria:se})}withSortBy(x){return new I({...this.state,sortBy:x})}withSortOrder(x){return new I({...this.state,sortOrder:x})}withFlags(...x){return new I({...this.state,flags:x.reduce((re,se)=>re|se,0)})}withAssetTypes(...x){return new I({...this.state,assetTypes:x})}get raw(){const{criteria:x,pageNumber:re,pageSize:se,sortBy:ce,sortOrder:he,flags:Se,assetTypes:ge}=this.state;return{filters:[{criteria:x,pageNumber:re,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:ge,flags:Se}}get searchText(){const x=this.state.criteria.filter(re=>re.filterType===s.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(W,x){const re=(W||[]).filter(se=>se.statisticName===x)[0];return re?re.value:0}function O(W){const x="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(se=>se.assetType.indexOf(x)===0).reduce((se,ce)=>{const he=M(W,ce.assetType);return he&&se.push([ce.assetType.substring(x.length),he]),se},[])}function N(W){if(W.properties){const x=W.properties.filter(ce=>ce.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=x.filter(ce=>re.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return M(W,o.Repository)}function $(W){return{uri:`${W.fallbackAssetUri}/${o.VSIX}?redirect=true${W.targetPlatform?`&targetPlatform=${W.targetPlatform}`:""}`,fallbackUri:`${W.fallbackAssetUri}/${o.VSIX}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`}}function D(W){const x=M(W,o.Icon);if(x)return x;const re=g.DefaultIconPath;return{uri:re,fallbackUri:re}}function M(W,x){return W.files.filter(se=>se.assetType===x)[0]?{uri:`${W.assetUri}/${x}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`,fallbackUri:`${W.fallbackAssetUri}/${x}${W.targetPlatform?`?targetPlatform=${W.targetPlatform}`:""}`}:null}function z(W,x){const re=W.properties?W.properties.filter(ce=>ce.key===x):[],se=re.length>0&&re[0].value;return se?se.split(",").map(ce=>(0,p.adoptToGalleryExtensionId)(ce)):[]}function U(W){const x=W.properties?W.properties.filter(re=>re.key===c.Engine):[];return x.length>0&&x[0].value||""}function V(W){const x=W.properties?W.properties.filter(re=>re.key===c.PreRelease):[];return x.length>0&&x[0].value==="true"}function Y(W){const x=W.properties?W.properties.filter(se=>se.key===c.LocalizedLanguages):[],re=x.length>0&&x[0].value||"";return re?re.split(","):[]}function B(W){return W.indexOf("preview")!==-1}function q(W){return W.targetPlatform?(0,g.toTargetPlatform)(W.targetPlatform):"undefined"}function X(W){const x=(0,L.distinct)(W.versions.map(q)),re=!!W.tags?.includes(g.WEB_EXTENSION_TAG),se=x.indexOf("web");return re?se===-1&&x.push("web"):se!==-1&&x.splice(se,1),x}function G(W,x){const re=(0,g.getFallbackTargetPlarforms)(x);for(let se=0;se<W.length;se++){const ce=W[se];if(ce.version===W[se-1]?.version){let he=se;const Se=q(ce);if(Se===x)for(;he>0&&W[he-1].version===ce.version;)he--;else if(re.includes(Se))for(;he>0&&W[he-1].version===ce.version&&q(W[he-1])!==x;)he--;he!==se&&(W.splice(se,1),W.splice(he,0,ce))}}return W}e.sortExtensionVersions=G;function ee(W,x,re,se,ce){const he=W.versions[0],Se={manifest:M(x,o.Manifest),readme:M(x,o.Details),changelog:M(x,o.Changelog),license:M(x,o.License),repository:N(x),download:$(x),icon:D(x),coreTranslations:O(x)};return{identifier:{id:(0,p.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:x.version,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,publisherDomain:W.publisher.domain?{link:W.publisher.domain,verified:!!W.publisher.isDomainVerified}:void 0,description:W.shortDescription||"",installCount:A(W.statistics,"install"),rating:A(W.statistics,"averagerating"),ratingCount:A(W.statistics,"ratingcount"),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),allTargetPlatforms:re,assets:Se,properties:{dependencies:z(x,c.Dependency),extensionPack:z(x,c.ExtensionPack),engine:U(x),localizedLanguages:Y(x),targetPlatform:q(x),isPreReleaseVersion:V(x)},hasPreReleaseVersion:V(he),hasReleaseVersion:se,preview:B(W.flags),telemetryData:ce}}let K=class{constructor(x,re,se,ce,he,Se,ge,ye){this.requestService=re,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=Se,this.productService=ge,this.configurationService=ye;const pe=ge.extensionsGallery;this.extensionsGalleryUrl=pe&&pe.serviceUrl,this.extensionsControlUrl=pe&&pe.controlUrl,this.commonHeadersPromise=H(ge.version,ge,this.environmentService,this.configurationService,this.fileService,x)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,re,se){const ce=(0,b.isBoolean)(re)?re:!1,he=(0,b.isBoolean)(re)?se:re;let Se=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,x.length).withFilter(s.ExtensionName,...x.map(({id:pe})=>pe.toLowerCase()));x.every(pe=>!pe.version)&&(Se=Se.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:ge}=await this.queryGallery(Se,a,n.CancellationToken.None),ye=ge.map(pe=>{const Ie=(0,p.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName);return{rawGalleryExtension:pe,version:x.find(Ee=>(0,p.areSameExtensions)(Ee,{id:Ie}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ye,Se,a,()=>{},he)}async getExtensions2(x){const re=[],se=[];for(const ge of x)ge.uuid?se.push(ge.uuid):re.push(ge.id.toLowerCase());let ce=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly).withPage(1,x.length);se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),re.length&&(ce=ce.withFilter(s.ExtensionId,...re));const{galleryExtensions:he}=await this.queryGallery(ce,a,n.CancellationToken.None),Se=he.map(ge=>{const ye=(0,p.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName),pe=x.find(Ie=>(0,p.areSameExtensions)(Ie,{id:ye,uuid:ge.extensionId}));return{rawGalleryExtension:ge,preRelease:!!pe?.preRelease}});return this.converToGalleryExtensions(Se,ce,a,()=>{},n.CancellationToken.None)}async getCompatibleExtension(x,re,se){const ce=(0,g.isIExtensionIdentifier)(x)?null:x;if(ce){if((0,g.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,re,se))return ce}const{id:he,uuid:Se}=ce?ce.identifier:x;let ge=new I().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);Se?ge=ge.withFilter(s.ExtensionId,Se):ge=ge.withFilter(s.ExtensionName,he);const{galleryExtensions:ye}=await this.queryGallery(ge,se,n.CancellationToken.None),[pe]=ye;if(!pe||!pe.versions.length)return null;const Ie=X(pe);if((0,g.isNotWebExtensionInWebTargetPlatform)(Ie,se))return null;for(let Ee of pe.versions){if(!U(Ee)){const De=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:c.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(Ee,re,Ie,se)){const De=pe.versions.some(Fe=>!V(Fe));return ee(pe,Ee,Ie,De)}}return null}async isExtensionCompatible(x,re,se){if(!(0,g.isTargetPlatformCompatible)(x.properties.targetPlatform,x.allTargetPlatforms,se)||!re&&x.properties.isPreReleaseVersion)return!1;let ce=x.properties.engine;if(!ce){const he=await this.getManifest(x,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,f.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(x,re,se,ce){if(!(0,g.isTargetPlatformCompatible)(q(x),se,ce)||!re&&V(x))return!1;const he=await this.getEngine(x);return(0,f.isEngineValid)(he,this.productService.version,this.productService.date)}async query(x,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=x.text||"";const ce=(0,_.getOrDefault)(x,Ee=>Ee.pageSize,50);let he=new I().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Fe)=>(he=he.withFilter(s.Category,Fe||De),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Fe)=>(he=he.withFilter(s.Tag,Fe||De),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):x.ids?he=he.withFilter(s.ExtensionId,...x.ids):x.names?he=he.withFilter(s.ExtensionName,...x.names):he=he.withSortBy(4),typeof x.sortBy=="number"&&(he=he.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(he=he.withSortOrder(x.sortOrder));const{galleryExtensions:Se,total:ge}=await this.queryGallery(he,a,re),ye=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:x.source}),pe=await this.converToGalleryExtensions(Se.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!x.includePreRelease})),he,a,ye,re),Ie=async(Ee,De)=>{if(De.isCancellationRequested)throw(0,k.canceled)();const Fe=he.withPage(Ee+1),{galleryExtensions:Ue}=await this.queryGallery(Fe,a,De);return await this.converToGalleryExtensions(Ue.map(Ne=>({rawGalleryExtension:Ne,preRelease:!!x.includePreRelease})),Fe,a,ye,re)};return{firstPage:pe,total:ge,pageSize:he.pageSize,getPage:Ie}}async converToGalleryExtensions(x,re,se,ce,he){const Se=(pe,Ie,Ee,De,Fe)=>{const Ue=!(Ee.flags&i.IncludeLatestVersionOnly),Ne=X(pe);let ze=pe.versions[0];return ze=pe.versions.find(te=>te.version===ze.version&&(0,g.isTargetPlatformCompatible)(q(te),Ne,se))||ze,Ue&&V(ze)&&!Fe&&(ze=pe.versions.find(te=>te.version!==ze.version&&!V(te))||ze),ee(pe,ze,Ne,De,ce(Ie))},ge=[],ye=new Map;for(let pe=0;pe<x.length;pe++){const{rawGalleryExtension:Ie,version:Ee,preRelease:De}=x[pe],Fe=Ie.versions.some(Ue=>!V(Ue));if(Ee){const Ue=Ie.versions.find(Ne=>Ne.version===Ee);Ue&&ge.push([pe,ee(Ie,Ue,X(Ie),Fe)])}else{const Ue=Se(Ie,pe,re,Fe,De);Ue.properties.isPreReleaseVersion?ye.set(Ue.identifier.uuid,{index:pe,preRelease:De}):ge.push([pe,Ue])}}if(ye.size){const pe=new Date().getTime(),Ie=new I().withFlags(i.IncludeVersions,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,ye.size).withFilter(s.ExtensionId,...ye.keys()),{galleryExtensions:Ee}=await this.queryGallery(Ie,se,he);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-pe,count:ye.size}),Ee.length!==ye.size)throw new Error("Not all extensions with latest versions are returned");for(const De of Ee){const Fe=De.versions.some(te=>!V(te)),{index:Ue,preRelease:Ne}=ye.get(De.extensionId),ze=Se(De,Ue,Ie,Fe,Ne);ge.push([Ue,ze])}}return ge.sort((pe,Ie)=>pe[0]-Ie[0]).map(([,pe])=>pe)}async queryGallery(x,re,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,t(i.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(x.raw),Se={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},ge=new Date().getTime();let ye,pe,Ie=0;try{if(ye=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:Se},se),ye.res.statusCode&&ye.res.statusCode>=400&&ye.res.statusCode<500)return{galleryExtensions:[],total:Ie};const Ee=await(0,S.asJson)(ye);if(Ee){const De=Ee.results[0],Fe=De.extensions;Fe.forEach(Ne=>G(Ne.versions,re));const Ue=De.resultMetadata&&De.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ie=Ue&&Ue.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Fe,total:Ie}}return{galleryExtensions:[],total:Ie}}catch(Ee){throw pe=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-ge,success:!!ye&&(0,S.isSuccess)(ye),responseBodySize:ye?.res.headers["Content-Length"],statusCode:ye?String(ye.res.statusCode):void 0,errorCode:pe?(0,k.isPromiseCanceledError)(pe)?"canceled":(0,k.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ie)})}}async reportStatistic(x,re,se,ce){if(!this.isEnabled())return;const he=T.isWeb?this.api(`/itemName/${x}.${re}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${re}/${se}/stats?statType=${ce}`),Se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.commonHeadersPromise,Accept:Se};try{await this.requestService.request({type:"POST",url:he,headers:ye},n.CancellationToken.None)}catch{}}async download(x,re,se){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const ce=(0,p.getGalleryExtensionTelemetryData)(x),he=new Date().getTime(),Se=Ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ie}),ge=se===2?"install":se===3?"update":"",ye=ge?{uri:`${x.assets.download.uri}${w.URI.parse(x.assets.download.uri).query?"&":"?"}${ge}=true`,fallbackUri:`${x.assets.download.fallbackUri}${w.URI.parse(x.assets.download.fallbackUri).query?"&":"?"}${ge}=true`}:x.assets.download,pe=await this.getAsset(ye);await this.fileService.writeFile(re,pe.stream),Se(new Date().getTime()-he)}async getReadme(x,re){if(x.assets.readme){const se=await this.getAsset(x.assets.readme,{},re);return await(0,S.asText)(se)||""}return""}async getManifest(x,re){if(x.assets.manifest){const se=await this.getAsset(x.assets.manifest,{},re),ce=await(0,S.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(x,re){const se=M(x,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,S.asJson)(he)}async getCoreTranslation(x,re){const se=x.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,S.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(x,re){if(x.assets.changelog){const se=await this.getAsset(x.assets.changelog,{},re);return await(0,S.asText)(se)||""}return""}async getAllCompatibleVersions(x,re,se){let ce=new I().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);x.identifier.uuid?ce=ce.withFilter(s.ExtensionId,x.identifier.uuid):ce=ce.withFilter(s.ExtensionName,x.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,n.CancellationToken.None);if(!he.length)return[];const Se=X(he[0]);if((0,g.isNotWebExtensionInWebTargetPlatform)(Se,se))return[];const ge=[];for(const ye of he[0].versions)try{ge[ge.length-1]?.version!==ye.version&&await this.isRawExtensionVersionCompatible(ye,re,Se,se)&&ge.push({version:ye.version,date:ye.lastUpdated,isPreReleaseVersion:V(ye)})}catch{}return ge}async getAsset(x,re={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},Se={...ce,...re.headers||{}};re={...re,...he,headers:Se};const ge=x.uri,ye=x.fallbackUri,pe={...re,url:ge};try{const Ie=await this.requestService.request(pe,se);if(Ie.res.statusCode===200)return Ie;const Ee=await(0,S.asText)(Ie);throw new Error(`Expected 200, got back ${Ie.res.statusCode} instead.

${Ee}`)}catch(Ie){if((0,k.isPromiseCanceledError)(Ie))throw Ie;const Ee=(0,k.getErrorMessage)(Ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ge,message:Ee});const De={...re,url:ye};return this.requestService.request(De,se)}}async getEngine(x){let re=U(x);if(!re){const se=await this.getManifestFromRawExtensionVersion(x,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");re=se.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,S.asJson)(x),se=[],ce={};if(re){for(const he of re.malicious)se.push({id:he});if(re.unsupported)for(const he of Object.keys(re.unsupported)){const Se=re.unsupported[he];(0,b.isBoolean)(Se)||(ce[he.toLowerCase()]=Se.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};K=de([Q(1,S.IRequestService),Q(2,C.ILogService),Q(3,E.IEnvironmentService),Q(4,u.ITelemetryService),Q(5,y.IFileService),Q(6,d.IProductService),Q(7,P.IConfigurationService)],K);let F=class extends K{constructor(x,re,se,ce,he,Se,ge,ye){super(x,re,se,ce,he,Se,ge,ye)}};F=de([Q(0,l.IStorageService),Q(1,S.IRequestService),Q(2,C.ILogService),Q(3,E.IEnvironmentService),Q(4,u.ITelemetryService),Q(5,y.IFileService),Q(6,d.IProductService),Q(7,P.IConfigurationService)],F),e.ExtensionGalleryService=F;let j=class extends K{constructor(x,re,se,ce,he,Se,ge){super(void 0,x,re,se,ce,he,Se,ge)}};j=de([Q(0,S.IRequestService),Q(1,C.ILogService),Q(2,E.IEnvironmentService),Q(3,u.ITelemetryService),Q(4,y.IFileService),Q(5,d.IProductService),Q(6,P.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j;async function H(W,x,re,se,ce,he){const Se={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W} (${x.nameShort})`},ge=await(0,m.getServiceMachineId)(re,ce,he);return(0,r.supportsTelemetry)(x,re)&&(0,r.getTelemetryLevel)(se)===3&&(Se["X-Market-User-Id"]=ge),Se}e.resolveMarketplaceHeaders=H}),define(ne[92],ie([0,1,2,13,10,44]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends L.Disposable{constructor(b,w,P=""){super();this.prefix=P;const E=b.getLogger(w.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,w){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,_.validateTelemetryData)(w))}};T=de([Q(0,k.ILoggerService),Q(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[93],ie([0,1,2,28,4,27,141,20,42,85,38,21,44]),function(J,e,L,n,k,_,T,R,b,w,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(C,d){this._configurationService=d,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=C.appenders,this._commonProperties=C.commonProperties||Promise.resolve({}),this._piiPaths=C.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!C.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const m=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!m})})}setExperimentProperty(C,d){this._experimentProperties[C]=d}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const C=await this._commonProperties;let d=C.sessionID,S=C["common.machineId"],m=C["common.firstSessionDate"],l=C["common.msftInternal"];return{sessionId:d,machineId:S,firstSessionDate:m,msftInternal:l}}dispose(){this._disposables.dispose()}_log(C,d,S,m){return this.telemetryLevel<d?Promise.resolve(void 0):this._commonProperties.then(l=>{S=(0,n.mixin)(S,l),S=(0,n.mixin)(S,this._experimentProperties),S=(0,n.cloneAndChange)(S,u=>{if(typeof u=="string")return this._cleanupInfo(u,m)}),this._appenders.forEach(u=>u.log(C,S))},l=>{console.error(l)})}publicLog(C,d,S){return this._log(C,3,d,S)}publicLog2(C,d,S){return this.publicLog(C,d,S)}publicLogError(C,d){return this.sendErrorTelemetry?this._log(C,2,d,!0):Promise.resolve(void 0)}publicLogError2(C,d){return this.publicLogError(C,d)}_anonymizeFilePaths(C){let d=C;const S=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(C);if(!a)break;S.push([a.index,r.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(d="";;){const r=l.exec(C);if(!r)break;!m.test(r[0])&&S.every(([a,i])=>r.index<a||r.index>=i)&&(d+=C.substring(u,r.index)+"<REDACTED: user-file-path>",u=l.lastIndex)}return u<C.length&&(d+=C.substr(u)),d}_removePropertiesWithPossibleUserInfo(C){if(!C)return C;const d=C.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(d)?"<REDACTED: secret>":S.test(d)?"<REDACTED: email>":C}_cleanupInfo(C,d){let S=C;d&&(S=this._anonymizeFilePaths(S));for(let m of this._cleanupPatterns)S=S.replace(m,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([Q(1,R.IConfigurationService)],p),e.TelemetryService=p;function f(){const y=(0,T.localize)(0,null,w.default.nameLong),C=w.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=k.isWeb?"":(0,T.localize)(3,null),S=(0,T.localize)(4,null),m=(0,T.localize)(5,null),l=(0,T.localize)(6,null),u=(0,T.localize)(7,null),r=`
|       | ${S} | ${m} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${y} ${C} ${d}

&nbsp;

${u}
${r}

&nbsp;

${a}
`}P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,T.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,T.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[208],ie([0,1,8,28,44]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(R,b){const w=await new Promise((E,g)=>{J(["applicationinsights"],E,g)});let P;return w.defaultClient?(P=new w.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(w.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=w.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class T{constructor(b,w,P,E,g){this._eventPrefix=b,this._defaultData=w,this.testCollector=E,this.mirrored=g,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(w=>{b(w)},w=>{(0,L.onUnexpectedError)(w),console.error(w)})}}log(b,w){!this._aiClient||(w=(0,n.mixin)(w,this._defaultData),w=(0,k.validateTelemetryData)(w),this.testCollector&&(w.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+b,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(ne[209],ie([0,1,18,57,20,13,10,21,91,92,93]),function(J,e,L,n,k,_,T,R,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,f,y,C){this.configurationService=p,this.telemetryService=f,this.loggerService=y,this.environmentService=C,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:f,sessionId:y}=await this.telemetryService.getTelemetryInfo(),C=Object.create(null);C["common.vscodemachineid"]=f,C["common.vscodesessionid"]=y;const d=[p.id,JSON.stringify(C),p.aiKey],m=new n.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new b.TelemetryAppenderClient(m),new w.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:l,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,f,y){await(await this.getCustomTelemetryService(p)).publicLog(f,y)}async publicLogError(p,f,y){await(await this.getCustomTelemetryService(p)).publicLogError(f,y)}};E=de([Q(0,k.IConfigurationService),Q(1,R.ITelemetryService),Q(2,T.ILoggerService),Q(3,_.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(ne[210],ie([0,1,5,25,3,2,10]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends _.Disposable{constructor(w,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((P,E)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,P),this._onCreateRequest.fire({requestId:g,...w});const p=new n.CancellationTokenSource;(0,L.timeout)(this._timeout,p.token).then(()=>E(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,_.toDisposable)(()=>p.cancel())])})}acceptReply(w,P){const E=this._pendingRequests.get(w);E?(this._pendingRequests.delete(w),(0,_.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),E(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};R=de([Q(1,T.ILogService)],R),e.RequestStore=R}),define(ne[94],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var _;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(_=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(d){d.TerminalView="view",d.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(d){d.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(p=e.TerminalCapability||(e.TerminalCapability={}));var f;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}))}),define(ne[211],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(ne[212],ie([0,1,32,28,9,4,31,15,22]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let g=0;return E&&E.length===4&&(g=parseInt(E[3])),g}e.getWindowsBuildNumber=w;async function P(E,g,p,f=T.env,y=b.Promises.exists){if(k.isAbsolute(E))return await y(E)?E:void 0;if(g===void 0&&(g=T.cwd()),k.dirname(E)!=="."){const m=k.join(g,E);return await y(m)?m:void 0}const d=(0,n.getCaseInsensitive)(f,"PATH");if(p===void 0&&(0,R.isString)(d)&&(p=d.split(k.delimiter)),p===void 0||p.length===0){const m=k.join(g,E);return await y(m)?m:void 0}for(let m of p){let l;if(k.isAbsolute(m)?l=k.join(m,E):l=k.join(g,m,E),await y(l))return l;if(_.isWindows){let u=l+".com";if(await y(u)||(u=l+".exe",await y(u)))return u}}const S=k.join(g,E);return await y(S)?S:void 0}e.findExecutable=P}),define(ne[213],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var L;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(L=e.ColorScheme||(e.ColorScheme={}))}),define(ne[95],ie([0,1,48,3,2,6,38,213]),function(J,e,L,n,k,_,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var b;(function(C){function d(S){return S&&typeof S=="object"&&typeof S.id=="string"}C.isThemeColor=d})(b=e.ThemeColor||(e.ThemeColor={}));function w(C){return{id:C}}e.themeColorFromId=w;var P;(function(C){function d(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}C.isThemeIcon=d;const S=new RegExp(`^\\$\\((${L.CSSIcon.iconNameExpression}(?:${L.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const s=S.exec(t);if(!s)return;let[,o]=s;return{id:o}}C.fromString=m;function l(t){return{id:t}}C.fromId=l;function u(t,s){let o=t.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),s&&(o=`${o}~${s}`),{id:o}}C.modify=u;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}C.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}C.isEqual=a;function i(t,s){return{id:t.id,color:s?w(s):void 0}}C.asThemeIcon=i,C.asClassNameArray=L.CSSIcon.asClassNameArray,C.asClassName=L.CSSIcon.asClassName,C.asCSSSelector=L.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=L.Codicon.file,e.FolderThemeIcon=L.Codicon.folder;function E(C){switch(C){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(d){return this.themingParticipants.push(d),this.onThemingParticipantAddedEmitter.fire(d),(0,k.toDisposable)(()=>{const S=this.themingParticipants.indexOf(d);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new g;T.Registry.add(e.Extensions.ThemingContribution,p);function f(C){return p.onColorThemeChange(C)}e.registerThemingParticipant=f;class y extends k.Disposable{constructor(d){super();this.themeService=d,this.theme=d.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(d){this.theme=d,this.updateStyles()}updateStyles(){}getColor(d,S){let m=this.theme.getColor(d);return m&&S&&(m=S(m,this.theme)),m?m.toString():null}}e.Themable=y}),define(ne[214],ie([0,1,48,7,95]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(E,g){const p=E.map(f=>({name:f.profileName,description:T(f)}));return g&&p.push(...g.map(f=>({name:f.title,description:R(f)}))),{values:p.map(f=>f.name),markdownDescriptions:p.map(f=>f.description)}}e.createProfileSchemaEnums=_;function T(E){let g=`$(${k.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:L.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?g+=`
- args: "${E.args}"`:g+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(g+=`
- overrideName: ${E.overrideName}`),E.color&&(g+=`
- color: ${E.color}`),E.env&&(g+=`
- env: ${JSON.stringify(E.env)}`),g}function R(E){return`$(${k.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:L.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function b(E,g){if(!E&&!g)return!0;if(typeof E=="string"&&typeof g=="string")return E===g;if(Array.isArray(E)&&Array.isArray(g)){if(E.length!==g.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==g[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function w(E,g){if(!E&&!g)return!0;if(!E||!g)return!1;if(k.ThemeIcon.isThemeIcon(E)&&k.ThemeIcon.isThemeIcon(g))return E.id===g.id&&E.color===g.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof g=="object"&&g&&"light"in g&&"dark"in g){const p=E,f=g;if((n.URI.isUri(p.light)||P(p.light))&&(n.URI.isUri(p.dark)||P(p.dark))&&(n.URI.isUri(f.light)||P(f.light))&&(n.URI.isUri(f.dark)||P(f.dark)))return p.light.path===f.light.path&&p.dark.path===f.dark.path}if(n.URI.isUri(E)&&n.URI.isUri(g)||P(E)||P(g)){const p=E,f=g;return p.path===f.path&&p.scheme===f.scheme}return!1}e.terminalIconsEqual=w;function P(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=P}),define(ne[215],ie([0,1,48,142,42,38,214]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(L.Codicon.getAll(),l=>l.id),markdownEnumDescriptions:Array.from(L.Codicon.getAll(),l=>`$(${l.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},w={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),g=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:g},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){_.Registry.as(k.Extensions.Configuration).registerConfiguration(C),m()}e.registerTerminalPlatformConfiguration=d;let S;function m(l,u){const r=_.Registry.as(k.Extensions.Configuration);let a;l&&(a=(0,T.createProfileSchemaEnums)(l?.profiles,u));const i=S;S={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?a?.values:void 0,markdownEnumDescriptions:l?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?a?.values:void 0,markdownEnumDescriptions:l?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?a?.values:void 0,markdownEnumDescriptions:l?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[S],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(ne[216],ie([0,1,45,48,9,4,22,70,212,95]),function(J,e,L,n,k,_,T,R,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,E=!0;function g(a,i,t,s,o=process.env,c,h,v,I){return c=c||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},_.isWindows?p(t,c,o,h,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:s.getValue("terminal.integrated.defaultProfile.windows"),I,v):l(c,h,t,a&&typeof a=="object"?{...a}:s.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:s.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,v,o)}e.detectAvailableProfiles=g;async function p(a,i,t,s,o,c,h,v,I){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let N=!1;(0,b.getWindowsBuildNumber)()>=16299&&(N=!0),await C(v);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),u(c,$);const D=await f($.entries(),h,i,t,s,I);if(a||!a&&o)try{const M=await S(`${O}\\${N?"wsl":"bash"}.exe`,h);for(const z of M)(!c||!(z.profileName in c))&&D.push(z)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return D}async function f(a,i,t,s=process.env,o,c){const h=[];for(const[v,I]of a){if(I===null)continue;let A,O,N;if("source"in I){const M=P?.get(I.source);if(!M)continue;A=M.paths,O=I.args||M.args,I.icon?N=y(I.icon):M.icon&&(N=M.icon)}else A=Array.isArray(I.path)?I.path:[I.path],O=_.isWindows||Array.isArray(I.args)?I.args:void 0,N=y(I.icon);const $=await c?.(A)||A.slice(),D=await r(v,i,$,t,s,O,I.env,I.overrideName,I.isAutoDetected,o);D?(D.isAutoDetected=I.isAutoDetected,D.icon=N,D.color=I.color,h.push(D)):o?.trace("profile not validated",v,A)}return h}function y(a){return typeof a=="string"?{id:a}:a}async function C(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await d(),icon:w.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function d(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function S(a,i){const t=[],s=await new Promise((h,v)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,A)=>{if(I)return v("Problem occurred when getting wsl distros");h(A)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),c=s.split(o).filter(h=>h.trim().length>0&&h!=="");for(const h of c){if(h===""||h.startsWith("docker-desktop"))continue;const v=`${h} (WSL)`,I={profileName:v,path:a,args:["-d",`${h}`],isDefault:v===i,icon:m(h),isAutoDetected:!1};t.push(I)}return t}function m(a){return a.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?w.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function l(a,i,t,s,o,c,h,v){const I=new Map;if(t){const A=(await a.readFile("/etc/shells")).toString(),O=c||A.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of O){let D=(0,k.basename)($),M=N.get(D)||0;M++,M>1&&(D=`${D} (${M})`),N.set(D,M),I.set(D,{path:$,isAutoDetected:!0})}}return u(s,I),await f(I.entries(),o,a,v,i,h)}function u(a,i){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?i.delete(t):(s.icon=s.icon||i.get(t)?.icon,i.set(t,s))}async function r(a,i,t,s,o,c,h,v,I,A){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,i,t,s,o,c,h,v,I);const N={profileName:a,path:O,args:c,env:h,overrideName:v,isAutoDetected:I,isDefault:a===i};if((0,k.basename)(O)===O){const D=o.PATH?o.PATH.split(k.delimiter):void 0,M=await(0,b.findExecutable)(O,void 0,D,void 0,s.existsFile);return M?(N.path=M,N.isFromPath=!0,N):r(a,i,t,s,o,c)}return await s.existsFile((0,k.normalize)(O))?N:r(a,i,t,s,o,c,h,v,I)}}),define(ne[217],ie([0,1,3,2,18,4,36,57,20,13,75,164,10,84,21,210,94,215,216]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let l=0,u=class extends n.Disposable{constructor(a,i,t,s,o){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,d.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(_.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const t=new R.Client(k.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(C.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const o=t.getChannel(C.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(C.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(h=>this._onProcessData.fire(h))),this._register(c.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(c.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(c.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(c.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(c.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(c.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,t,s,o,c,h,v,I,A,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),C.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,i,t,s,o,c,h,v,I,A,O);return clearTimeout(N),l=Math.max(l,$),$}updateTitle(a,i,t){return this._proxy.updateTitle(a,i,t)}updateIcon(a,i,t){return this._proxy.updateIcon(a,i,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,t){return this._proxy.resize(a,i,t)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,t,s=!1){const o=await this._shellEnv;return(0,S.detectAvailableProfiles)(i,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,t){return this._proxy.updateProperty(a,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier+C.HeartbeatConstants.BeatInterval*C.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${C.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};u=de([Q(1,b.IConfigurationService),Q(2,w.IEnvironmentService),Q(3,g.ILogService),Q(4,f.ITelemetryService)],u),e.PtyHostService=u}),define(ne[34],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(ne[218],ie([0,1,3,2,7,13,33,14,10,34]),function(J,e,L,n,k,_,T,R,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends n.Disposable{constructor(g,p,f,y,C){super();this.extensionsManagementService=g,this.logService=y,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(S=>this.onInstallExtension(S))),this._register(g.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(g.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const d=k.URI.file(f.extensionsPath);this._register(p.watch(d)),this._register(L.Event.filter(p.onDidChangeFilesRaw,S=>S.changes.some(m=>this.doesChangeAffects(m,d)))(()=>this.onDidChange()))}doesChangeAffects(g,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(g.resource),p)?this.uriIdentityService.extUri.isEqual(g.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(g.type!==1&&g.type!==2||this.uriIdentityService.extUri.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const p of g)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(p=>!(0,T.areSameExtensions)(p,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,T.areSameExtensions)(p,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),p=g.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,T.areSameExtensions)(C,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),f=this.installedExtensions.filter(y=>this.installingExtensions.some(C=>(0,T.areSameExtensions)(C,y))?!1:g.every(C=>!(0,T.areSameExtensions)(C.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=g.map(y=>y.identifier),(p.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:f})}}};P=de([Q(1,R.IFileService),Q(2,_.INativeEnvironmentService),Q(3,b.ILogService),Q(4,w.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ne[219],ie([0,1,34,77,14,19,103,3,2]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(g){this.uri=g,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let P=class{constructor(g){this._fileService=g,this._dispooables=new b.DisposableStore,this._limit=2**16;const p=new Map,f=y=>{let C=p.get(y.scheme);return C===void 0&&(C=g.hasProvider(y)&&!this._fileService.hasCapability(y,1024),p.set(y.scheme,C)),C};this._dispooables.add(R.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(y=>{p.delete(y.scheme)})),this.extUri=new _.ExtUri(f),this._canonicalUris=new T.SkipList((y,C)=>this.extUri.compare(y,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(g){this._fileService.hasProvider(g)&&(g=(0,_.normalizePath)(g));let p=this._canonicalUris.get(g);return p?p.touch().uri.with({fragment:g.fragment}):(this._canonicalUris.set(g,new w(g)),this._checkTrim(),g)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const g=[...this._canonicalUris.entries()].sort((f,y)=>f[1].touch<y[1].touch?1:f[1].touch>y[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let f=0;f<p;f++)this._canonicalUris.set(g[f][0],g[f][1].touch())}};P=de([Q(0,k.IFileService)],P),e.UriIdentityService=P,(0,n.registerSingleton)(L.IUriIdentityService,P,!0)}),define(ne[220],ie([0,1,3,2,40,39,17]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(w,P,E,g,p){super();this.fileSystemScheme=w,this.fileSystemProvider=P,this.userDataScheme=E,this.logService=p,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(g.onDidFilesChange(f=>this.handleFileChanges(f)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(w,P){this.watchResources.set(w,w);const E=this.fileSystemProvider.watch(this.toFileSystemResource(w),P);return(0,n.toDisposable)(()=>{this.watchResources.delete(w),E.dispose()})}stat(w){return this.fileSystemProvider.stat(this.toFileSystemResource(w))}mkdir(w){return this.fileSystemProvider.mkdir(this.toFileSystemResource(w))}rename(w,P,E){return this.fileSystemProvider.rename(this.toFileSystemResource(w),this.toFileSystemResource(P),E)}readFile(w){return this.fileSystemProvider.readFile(this.toFileSystemResource(w),{atomic:!0})}readFileStream(w,P,E){const g=(0,k.newWriteableStream)(p=>T.VSBuffer.concat(p.map(f=>T.VSBuffer.wrap(f))).buffer);return(async()=>{try{const p=await this.readFile(w);g.end(p)}catch(p){g.error(p),g.end()}})(),g}readdir(w){return this.fileSystemProvider.readdir(this.toFileSystemResource(w))}writeFile(w,P,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(w),P,E)}delete(w,P){return this.fileSystemProvider.delete(this.toFileSystemResource(w),P)}handleFileChanges(w){const P=[];for(const E of[{raw:w.rawAdded,type:1},{raw:w.rawUpdated,type:0},{raw:w.rawDeleted,type:2}])if(E.raw)for(const[g]of E.raw){if(g.scheme!==this.fileSystemScheme)continue;const p=this.toUserDataResource(g);this.watchResources.findSubstr(p)&&P.push({resource:p,type:E.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(w){return w.with({scheme:this.fileSystemScheme})}toUserDataResource(w){return w.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[52],ie([0,1,68]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,b,w){const P=(0,L.setProperty)(T,R,b,w)[0];return P&&(T=T.substring(0,P.offset)+P.content+T.substring(P.offset+P.length)),T}e.edit=n;function k(T,R,b){let w=b;for(;w>=0;){if(T.charAt(w)===R.charAt(R.length-1)&&R.length===1)return w+1;if(w--,R.length===2&&w>=0&&T.charAt(w)===R.charAt(0))return w+2}return 0}e.getLineStartOffset=k;function _(T,R,b){let w=b;for(;w>=0;)if(T.charAt(w)===R.charAt(R.length-1)&&R.length===1||(w++,R.length===2&&w>=0&&T.charAt(w)===R.charAt(1)))return w;return T.length-1}e.getLineEndOffset=_}),define(ne[221],ie([0,1,28,61,15]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(g,p,f,y,C){const d=[],S=[],m=[];if(!p){const O=g.filter(({identifier:N})=>C.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:d,removed:S,updated:m},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}g=g.map(P),p=p.map(P),f=f?f.map(P):null;const l=new Map,u=O=>{O.uuid&&l.set(O.id.toLowerCase(),O.uuid)};g.forEach(({identifier:O})=>u(O)),p.forEach(({identifier:O})=>u(O)),f&&f.forEach(({identifier:O})=>u(O));const r=O=>{const N=O.identifier.uuid||l.get(O.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,N)=>(O.set(r(N),N),O),i=g.reduce(a,new Map),t=p.reduce(a,new Map),s=p.reduce((O,N)=>{const $=r(N);N=(0,L.deepClone)(N);const D=i.get($);return D&&(D.installed&&(N.installed=!0),N.version||(N.version=D.version)),a(O,N)},new Map),o=f?f.reduce(a,new Map):null,c=y.reduce(a,new Map),h=C.reduce((O,N)=>{const $=l.get(N.toLowerCase());return O.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),v=T(i,t,h);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const O=T(o,i,h),N=T(o,t,h),$=(D,M)=>{const z=i.get(D);if(z){const U=t.get(D),V=M?U:z;return{...V,version:(U.version&&n.gt(U.version,z.version),z.version),state:R(z,U,o?.get(D)),preRelease:(0,k.isUndefined)(V.preRelease)?z.preRelease:V.preRelease}}};for(const D of N.removed.values()){const M=i.get(D);M&&S.push(M.identifier)}for(const D of N.added.values())if(O.added.has(D)){if(v.updated.has(D)){const M=$(D,!0);M&&(m.push(E(M,D)),s.set(D,M))}}else{const M=t.get(D);M.installed&&d.push(E(M,D))}for(const D of N.updated.values()){const M=$(D,!0);M&&(m.push(E(M,D)),s.set(D,M))}for(const D of O.added.values())N.added.has(D)||s.set(D,i.get(D));for(const D of O.updated.values())if(!N.removed.has(D)&&!N.updated.has(D)){const M=$(D,!1);M&&(s.get(D)?.installed&&(M.installed=!0),s.set(D,M))}for(const D of O.removed.values())!c.has(D)&&!N.updated.has(D)&&o?.get(D)?.installed&&s.delete(D)}const I=[],A=T(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&s.forEach((O,N)=>I.push(E(O,N))),{local:{added:d,removed:S,updated:m},remote:I.length?{added:[...A.added].map(O=>s.get(O)),updated:[...A.updated].map(O=>s.get(O)),removed:[...A.removed].map(O=>t.get(O)),all:I}:null}}e.merge=_;function T(g,p,f,{checkInstalledProperty:y,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const d=g?[...g.keys()].filter(r=>!f.has(r)):[],S=[...p.keys()].filter(r=>!f.has(r)),m=S.filter(r=>d.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=d.filter(r=>S.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),u=new Set;for(const r of d){if(l.has(r))continue;const a=g.get(r),i=p.get(r);(!i||a.disabled!==i.disabled||a.preRelease!==i.preRelease||!w(a.state,i.state)||C&&a.version!==i.version||y&&a.installed!==i.installed)&&u.add(r)}return{added:m,removed:l,updated:u}}function R(g,p,f){const y=g.state,C=p.state,d=f?.state;if(!p.version||y&&n.gt(g.version,p.version))return y;if(C&&n.gt(p.version,g.version)||!y)return C;if(!C)return y;const S=(0,L.deepClone)(y),m=d?b(d,C):{added:Object.keys(C).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},l=d?b(d,y):{added:Object.keys(y).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...m.added.values(),...m.updated.values()])S[u]=C[u];for(const u of m.removed.values())l.updated.has(u)||delete S[u];return S}function b(g,p){const f=Object.keys(g),y=Object.keys(p),C=y.filter(m=>f.indexOf(m)===-1).reduce((m,l)=>(m.add(l),m),new Set),d=f.filter(m=>y.indexOf(m)===-1).reduce((m,l)=>(m.add(l),m),new Set),S=new Set;for(const m of f){if(d.has(m))continue;const l=g[m],u=p[m];(0,L.equals)(l,u)||S.add(m)}return{added:C,removed:d,updated:S}}function w(g={},p={}){const{added:f,removed:y,updated:C}=b(g,p);return f.size===0&&y.size===0&&C.size===0}function P(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function E(g,p){const f={identifier:{id:g.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!g.preRelease};return g.version&&(f.version=g.version),g.disabled&&(f.disabled=!0),g.installed&&(f.installed=!0),g.state&&(f.state=g.state),f}}),define(ne[96],ie([0,1,16,3,2,33,6,26,23]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,T.createDecorator)("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let P=class it extends k.Disposable{constructor(g,p){super();this.storageService=g,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new n.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(f=>this.onDidChangeStorageValue(f)))}static toKey(g){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const p=w.exec(g);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const g=this.storageService.keys(0,1);for(const p of g){const f=it.fromKey(p);f&&this.extensionsWithKeysForSync.add(f.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(g.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,p){this.storageService.store(it.toKey(g),JSON.stringify(p),0,1)}getKeysForSync(g){const p=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],f=this.storageService.get(it.toKey(g),0),y=f?JSON.parse(f):void 0;return y&&p?(0,L.distinct)([...y,...p]):y||p}};P=de([Q(0,b.IStorageService),Q(1,R.IProductService)],P),e.ExtensionsStorageSyncService=P}),define(ne[97],ie([0,1,16,20,6]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let _=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==R&&P!==`-${R}`),b&&w.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(R,b){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return w=w.filter(P=>P!==R&&P!==`-${R}`),b&&w.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(R){const b=R.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),P=[],E=[];if(Array.isArray(w))for(const g of w)g.startsWith("-")?E.push(g.substring(1)):P.push(g);return(0,L.distinct)([...b,...P].filter(g=>E.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};_=de([Q(0,n.IConfigurationService)],_),e.IgnoredExtensionsManagementService=_}),define(ne[222],ie([0,1,16,35,28,159,52]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(l){return(0,n.parse)(l)||[]}e.parseKeybindings=R;async function b(l,u,r,a,i){const t=R(l),s=R(u),o=r?R(r):null,c=[...t,...s,...o||[]].map(U=>U.key),h=await i.resolveUserBindings(c);let v=P(t,s,o,h);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const I=g(t),A=g(s),O=o?g(o):null,N=f(I,A,h),$=O?f(O,I,h):{added:[...I.keys()].reduce((U,V)=>(U.add(V),U),new Set),removed:new Set,updated:new Set},D=O?f(O,A,h):{added:[...A.keys()].reduce((U,V)=>(U.add(V),U),new Set),removed:new Set,updated:new Set},M=w(N,$,D);let z=l;for(const U of M.removed.values())M.conflicts.has(U)||(z=S(z,U,a));for(const U of M.added.values()){if(M.conflicts.has(U))continue;const V=A.get(U);if(V.some(Y=>Y.command!==`-${U}`&&v.conflicts.has(h[Y.key]))){M.conflicts.add(U);continue}z=d(z,V,a)}for(const U of M.updated.values()){if(M.conflicts.has(U))continue;const V=A.get(U);if(V.some(Y=>Y.command!==`-${U}`&&v.conflicts.has(h[Y.key]))){M.conflicts.add(U);continue}z=m(z,U,V,a)}return{mergeContent:z,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=b;function w(l,u,r){const a=new Set,i=new Set,t=new Set,s=new Set;for(const o of u.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(u.updated.has(o)?s.add(o):i.add(o));for(const o of u.added.values())s.has(o)||r.added.has(o)&&l.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(u.added.has(o)?l.updated.has(o)&&s.add(o):a.add(o));for(const o of u.updated.values())s.has(o)||r.updated.has(o)&&l.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(u.updated.has(o)?l.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:i,updated:t,conflicts:s}}function P(l,u,r,a){const i=new Set,t=E(l,a),s=E(u,a),o=r?E(r,a):null,c=p(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const h=o?p(o,t):{added:[...t.keys()].reduce(($,D)=>($.add(D),$),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const v=o?p(o,s):{added:[...s.keys()].reduce(($,D)=>($.add(D),$),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:I,removed:A,updated:O,conflicts:N}=w(c,h,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:A,updated:O,conflicts:N}}function E(l,u){const r=new Map;for(const a of l){const i=u[a.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(a)}return r}function g(l){const u=new Map;for(const r of l){const a=r.command[0]==="-"?r.command.substring(1):r.command;let i=u.get(a);i||(i=[],u.set(a,i)),i.push(r)}return u}function p(l,u){const r=[...l.keys()],a=[...u.keys()],i=a.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const c=l.get(o).map(v=>({...v,key:o})),h=u.get(o).map(v=>({...v,key:o}));(0,L.equals)(c,h,(v,I)=>C(v,I))||s.add(o)}return{added:i,removed:t,updated:s}}function f(l,u,r){const a=[...l.keys()],i=[...u.keys()],t=i.filter(c=>a.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),s=a.filter(c=>i.indexOf(c)===-1).reduce((c,h)=>(c.add(h),c),new Set),o=new Set;for(const c of a){if(s.has(c))continue;const h=l.get(c).map(I=>({...I,key:r[I.key]})),v=u.get(c).map(I=>({...I,key:r[I.key]}));y(h,v)||o.add(c)}return{added:t,removed:s,updated:o}}function y(l,u){return!(!(0,L.equals)(l.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,a)=>C(r,a))||!(0,L.equals)(l.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,a)=>C(r,a)))}function C(l,u){if(l.command!==u.command||l.key!==u.key)return!1;const r=_.ContextKeyExpr.deserialize(l.when),a=_.ContextKeyExpr.deserialize(u.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!k.equals(l.args,u.args))}function d(l,u,r){for(const a of u)l=T.edit(l,[-1],a,r);return l}function S(l,u,r){const a=R(l);for(let i=a.length-1;i>=0;i--)(a[i].command===u||a[i].command===`-${u}`)&&(l=T.edit(l,[i],void 0,r));return l}function m(l,u,r,a){const i=R(l),t=i.findIndex(s=>s.command===u||s.command===`-${u}`);for(let s=i.length-1;s>=0;s--)(i[s].command===u||i[s].command===`-${u}`)&&(l=T.edit(l,[s],void 0,a));for(let s=r.length-1;s>=0;s--)l=T.edit(l,[t],r[s],a);return l}}),define(ne[223],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(_,T,R){const b={},w={},P=new Set;if(!T)return{local:{added:b,updated:w,removed:[...P.values()]},remote:{added:_,updated:{},removed:[]},conflicts:[]};const E=n(_,T);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:w,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=n(R,_),p=n(R,T),f={},y={},C=new Set,d=new Set;for(const S of g.removed.values())p.updated.has(S)?b[S]=T[S]:C.add(S);for(const S of p.removed.values())d.has(S)||(g.updated.has(S)?d.add(S):P.add(S));for(const S of g.updated.values())d.has(S)||(p.updated.has(S)?E.updated.has(S)&&d.add(S):y[S]=_[S]);for(const S of p.updated.values())d.has(S)||(g.updated.has(S)?E.updated.has(S)&&d.add(S):_[S]!==void 0&&(w[S]=T[S]));for(const S of g.added.values())d.has(S)||(p.added.has(S)?E.updated.has(S)&&d.add(S):f[S]=_[S]);for(const S of p.added.values())d.has(S)||(g.added.has(S)?E.updated.has(S)&&d.add(S):b[S]=T[S]);return{local:{added:b,removed:[...P.values()],updated:w},remote:{added:f,removed:[...C.values()],updated:y},conflicts:[...d.values()]}}e.merge=L;function n(_,T){const R=_?Object.keys(_):[],b=T?Object.keys(T):[],w=b.filter(g=>R.indexOf(g)===-1).reduce((g,p)=>(g.add(p),g),new Set),P=R.filter(g=>b.indexOf(g)===-1).reduce((g,p)=>(g.add(p),g),new Set),E=new Set;for(const g of R){if(P.has(g))continue;const p=_[g],f=T[g];p!==f&&E.add(g)}return{added:w,removed:P,updated:E}}function k(_,T){const{added:R,removed:b,updated:w}=n(_,T);return R.size===0&&b.size===0&&w.size===0}e.areSame=k}),define(ne[24],ie([0,1,16,19,15,147,42,30,6,86,38]),function(J,e,L,n,k,_,T,R,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function g(){const o=P.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(I=>!!o[I].ignoreSync),h=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),v=E();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...h,...v])}e.getDefaultIgnoredSettings=g,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const o="vscode://schemas/ignoredSettings",c=P.Registry.as(T.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,_.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=P.Registry.as(w.Extensions.JSONContribution),v=()=>{const I=E(),A=g().filter(D=>D!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(T.allSettings.properties).filter(D=>A.indexOf(D)===-1),N=A.filter(D=>I.indexOf(D)===-1),$={items:{type:"string",enum:[...O,...N.map(D=>`-${D}`)]}};h.registerSchema(o,$)};return c.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=p;function f(o){return o&&(0,k.isObject)(o)&&(0,k.isString)(o.id)&&(0,k.isArray)(o.scopes)}e.isAuthenticationProvider=f;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function C(o,c,h){return h.joinPath(c.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function d(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=d;var S;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(S=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class m extends Error{constructor(c,h,v,I){super(c);this.code=h,this.resource=v,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class l extends m{constructor(c,h,v,I,A){super(c,v,void 0,A);this.url=h,this.serverCode=I}}e.UserDataSyncStoreError=l;class u extends m{constructor(c,h){super(c,h)}}e.UserDataAutoSyncError=u,function(o){function c(h){if(h instanceof o)return h;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(v&&v[1]){const I=v[2]==="unknown"?void 0:v[2],A=v[3]==="unknown"?void 0:v[3];return new o(h.message,v[1],I,A)}return new o(h.message,"Unknown")}o.toUserDataSyncError=c}(m=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,c){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(o,(0,n.joinPath)(c.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ne[47],ie([0,1,16,5,17,25,3,35,2,27,15,7,143,20,13,14,10,46,23,21,34,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends b.Disposable{constructor(c,h,v,I,A,O,N,$,D,M,z){super();this.resource=c,this.fileService=h,this.environmentService=v,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=D,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,w.uppercaseFirstLetter)(this.resource),this.extUri=z.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(c,v,this.extUri),this.currentMachineIdPromise=(0,d.getServiceMachineId)(v,h,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const h=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(h)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const h=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),h==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,h={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),h)}async preview(c,h,v={}){return this._sync(c,!1,h,v)}async apply(c,h={}){try{this.syncHeaders={...h};const v=await this.doApply(c);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,h,v,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const O=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(c,O);return A=await this.performSync(N,O,h,v),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(c){const h=await this.resolveContent(c);if(!h)return!1;const v=this.parseSyncData(h);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,I),O=await this.isRemoteDataFromCurrentMachine(A),N=await this.generateSyncPreview({ref:A.ref,syncData:v},I,O,this.getUserDataSyncConfiguration(),_.CancellationToken.None),$=[];for(const D of N){const M=await this.getAcceptResult(D,D.remoteResource,void 0,_.CancellationToken.None),{remoteChange:z}=await this.getAcceptResult(D,D.previewResource,D.remoteContent,_.CancellationToken.None);$.push([D,{...M,remoteChange:z!==0?z:2}])}await this.applyResult(A,I,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const h=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===h}async getLatestRemoteUserData(c,h){if(h){const v=c&&c.latest?c.latest[this.resource]:void 0;if(h.ref===v||v===void 0&&h.syncData===null)return h}return this.getRemoteUserData(h)}async performSync(c,h,v,I){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,g.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,h,v,I)}catch(A){if(A instanceof u.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,h,v,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),h=await this.getLastSyncUserData(),this.performSync(c,h,v,I)}throw A}}async doSync(c,h,v,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(c,h,v,I,O)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(c){return await this.updateSyncResourcePreview(c,async h=>{const v=await this.getMergeResult(h,_.CancellationToken.None);await this.fileService.writeFile(h.previewResource,k.VSBuffer.fromString(v?.content||""));const I=v&&!v.hasConflicts?await this.getAcceptResult(h,h.previewResource,void 0,_.CancellationToken.None):void 0;return h.acceptResult=I,h.mergeState=v.hasConflicts?"conflict":I?"accepted":"preview",h.localChange=I?I.localChange:v.localChange,h.remoteChange=I?I.remoteChange:v.remoteChange,h}),this.syncPreviewPromise}async accept(c,h){return await this.updateSyncResourcePreview(c,async v=>{const I=await this.getAcceptResult(v,c,h,_.CancellationToken.None);return v.acceptResult=I,v.mergeState="accepted",v.localChange=I.localChange,v.remoteChange=I.remoteChange,v}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async h=>{const v=await this.getMergeResult(h,_.CancellationToken.None);return await this.fileService.writeFile(h.previewResource,k.VSBuffer.fromString(v.content||"")),h.acceptResult=void 0,h.mergeState="preview",h.localChange=v.localChange,h.remoteChange=v.remoteChange,h}),this.syncPreviewPromise}async updateSyncResourcePreview(c,h){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const I=v.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:N})=>this.extUri.isEqual(A,c)||this.extUri.isEqual(O,c)||this.extUri.isEqual(N,c));I!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async A=>{const O=[...v.resourcePreviews];return O[I]=await h(O[I]),{...v,resourcePreviews:O}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const h=await this.syncPreviewPromise;return h.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":h.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(h.remoteUserData,h.lastSyncUserData,h.resourcePreviews.map(v=>[v,v.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const h=c.filter(({mergeState:v})=>v==="conflict");(0,L.equals)(this._conflicts,h,(v,I)=>this.extUri.isEqual(v.previewResource,I.previewResource))||(this._conflicts=h,this._onDidChangeConflicts.fire(h))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:h,ref:v})=>({created:h,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:h,ref:v})=>({created:h,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(c){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:v}=await this.getUserData(h);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(c){const h=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(h))){const{content:v}=await this.getUserData(h);return v}return this.extUri.isEqual(c,this.toLocalBackupResource(h))?this.userDataSyncBackupStoreService.resolveContent(this.resource,h):null}async resolvePreviewContent(c){const h=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(h)for(const v of h.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,c))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,c))return v.remoteContent;if(this.extUri.isEqual(v.localResource,c))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,h,v,I,A){const O=await this.isRemoteDataFromCurrentMachine(c),N=await this.generateSyncPreview(c,h,O,I,A),$=[];for(const D of N){const M=D.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(D.localChange===0&&D.remoteChange===0)$.push({...D,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const z=v?await this.getMergeResult(D,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(D.previewResource,k.VSBuffer.fromString(z?.content||""));const U=z&&!z.hasConflicts?await this.getAcceptResult(D,D.previewResource,void 0,A):void 0;$.push({...D,acceptResult:U,mergeState:z?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:z?z.localChange:D.localChange,remoteChange:U?U.remoteChange:z?z.remoteChange:D.remoteChange})}}return{remoteUserData:c,lastSyncUserData:h,resourcePreviews:$,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),h=JSON.parse(c.value.toString()),v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=h.version&&v&&h.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${h.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const I=h;if(I.content===null)return{ref:h.ref,syncData:null};const A=JSON.parse(I.content);if(r(A))return{...h,syncData:A,content:void 0}}catch(c){c instanceof y.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,h={}){if(h.ref||h.content||h.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:v,...h};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(c){const{ref:h,content:v}=await this.getUserData(c);let I=null;return v!==null&&(I=this.parseSyncData(v)),{ref:h,syncData:I}}parseSyncData(c){try{const h=JSON.parse(c);if(r(h))return h}catch(h){this.logService.error(h)}throw new u.UserDataSyncError((0,g.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,P.isString)(c)){const h=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:h}}else{const h=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,h,this.syncHeaders)}}async updateRemoteUserData(c,h){const v=await this.currentMachineIdPromise,I={version:this.version,machineId:v,content:c};return h=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),h,this.syncHeaders),{ref:h,syncData:I}}async backupLocal(c){const h={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(h))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([Q(1,y.IFileService),Q(2,f.IEnvironmentService),Q(3,S.IStorageService),Q(4,u.IUserDataSyncStoreService),Q(5,u.IUserDataSyncBackupStoreService),Q(6,u.IUserDataSyncEnablementService),Q(7,m.ITelemetryService),Q(8,u.IUserDataSyncLogService),Q(9,p.IConfigurationService),Q(10,l.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(c,h,v,I,A,O,N,$,D,M,z,U){super(h,v,I,A,O,N,$,D,M,z,U);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(V=>this.onFileChanges(V)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,h,v){try{h?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c),v?void 0:h):await this.fileService.createFile(this.file,k.VSBuffer.fromString(c),{overwrite:v})}catch(I){throw I instanceof y.FileOperationError&&I.fileOperationResult===1||I instanceof y.FileOperationError&&I.fileOperationResult===3?new u.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};i=de([Q(2,y.IFileService),Q(3,f.IEnvironmentService),Q(4,S.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,m.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,p.IConfigurationService),Q(11,l.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(c,h,v,I,A,O,N,$,D,M,z,U,V){super(c,h,v,I,A,O,N,$,D,M,U,V);this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(c){const h=[];return(0,R.parse)(c,h,{allowEmptyContent:!0,allowTrailingComma:!0}),h.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([Q(2,y.IFileService),Q(3,f.IEnvironmentService),Q(4,S.IStorageService),Q(5,u.IUserDataSyncStoreService),Q(6,u.IUserDataSyncBackupStoreService),Q(7,u.IUserDataSyncEnablementService),Q(8,m.ITelemetryService),Q(9,u.IUserDataSyncLogService),Q(10,u.IUserDataSyncUtilService),Q(11,p.IConfigurationService),Q(12,l.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(c,h,v,I,A){this.resource=c,this.environmentService=h,this.logService=v,this.fileService=I,this.extUri=A.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,h,this.extUri)}async initialize({ref:c,content:h}){if(!h){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(h);if(!!v)try{await this.doInitialize({ref:c,syncData:v})}catch(I){this.logService.error(I)}}parseSyncData(c){try{const h=JSON.parse(c);if(r(h))return h}catch(h){this.logService.error(h)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,h={}){const v={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...h};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(v)))}};s=de([Q(1,f.IEnvironmentService),Q(2,C.ILogService),Q(3,y.IFileService),Q(4,l.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ne[224],ie([0,1,5,25,8,3,49,27,7,20,13,30,33,14,10,23,21,34,47,221,96,97,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(c,h){const v=JSON.parse(c.content);if(c.version===1||c.version===2){const I=(await h.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of v)c.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),c.version===2&&I.every(O=>!(0,g.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return v}function i(c,h,v){const I=v.get((0,g.getExtensionId)(c,h),0)||"{}";return JSON.parse(I)}e.getExtensionStorageState=i;function t(c,h,v,I){I.store((0,g.getExtensionId)(c,h),JSON.stringify(v),0,1)}e.storeExtensionStorageState=t;let s=class vt extends S.AbstractSynchroniser{constructor(h,v,I,A,O,N,$,D,M,z,U,V,Y,B,q){super("extensions",v,h,I,A,O,V,Y,M,U,q);this.storageService=I,this.extensionManagementService=N,this.extensionEnablementService=$,this.ignoredExtensionsManagementService=D,this.extensionGalleryService=z,this.extensionsStorageSyncService=B,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.debounce(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,X=>X.some(({local:G})=>!!G)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,X=>!X.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(h,v){const I=h.syncData?await a(h.syncData,this.extensionManagementService):null,A=v?.skippedExtensions||[],O=v?.syncData?await a(v.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),$=this.getLocalExtensions(N),D=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:z}=(0,m.merge)($,I,O,A,D),U={local:M,remote:z,content:this.getPreviewContent($,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:z!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.stringify($,!1),localExtensions:$,remoteResource:this.remoteResource,remoteContent:I?this.stringify(I,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const v=h.syncData?await a(h.syncData,this.extensionManagementService):null,I=await this.extensionManagementService.getInstalled(void 0,!0),A=this.getLocalExtensions(I),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),{remote:N}=(0,m.merge)(A,v,v,h.skippedExtensions||[],O);return N!==null}getPreviewContent(h,v,I,A){const O=[...v,...I],N=new Set,$=D=>{N.add(D.id.toLowerCase()),D.uuid&&N.add(D.uuid)};O.forEach(({identifier:D})=>$(D)),A.forEach($);for(const D of h)N.has(D.identifier.id.toLowerCase())||D.identifier.uuid&&N.has(D.identifier.uuid)||O.push(D);return this.stringify(O,!1)}async getMergeResult(h,v){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,v,I,A){if(this.extUri.isEqual(v,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(v,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(v,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${v.toString()}`)}async acceptLocal(h){const v=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),A=(0,m.merge)(h.localExtensions,null,null,h.skippedExtensions,I),{local:O,remote:N}=A;return{content:h.localContent,local:O,remote:N,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(h){const v=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),A=h.remoteContent?JSON.parse(h.remoteContent):null;if(A!==null){const O=(0,m.merge)(h.localExtensions,A,h.localExtensions,[],I),{local:N,remote:$}=O;return{content:h.remoteContent,local:N,remote:$,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,v,I,A){let{skippedExtensions:O,localExtensions:N}=I[0][0],{local:$,remote:D,localChange:M,remoteChange:z}=I[0][1];if(M===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(N)),O=await this.updateLocalExtensions($.added,$.removed,$.updated,O)),D){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(D.all);h=await this.updateRemoteUserData(U,A?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${D.added.length?` Added: ${JSON.stringify(D.added.map(V=>V.identifier.id))}.`:""}${D.updated.length?` Updated: ${JSON.stringify(D.updated.map(V=>V.identifier.id))}.`:""}${D.removed.length?` Removed: ${JSON.stringify(D.removed.map(V=>V.identifier.id))}.`:""}`)}v?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(h,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,vt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),O=this.getLocalExtensions(I).filter(N=>!A.some($=>(0,g.areSameExtensions)({id:$},N.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const I=await this.resolvePreviewContent(h);return I&&this.stringify(JSON.parse(I),!0)}let v=await super.resolveContent(h);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(h)),v){const I=this.parseSyncData(v);if(I)switch(this.extUri.basename(h)){case"extensions.json":return this.stringify(this.parseExtensions(I),!0)}}return null}stringify(h,v){return h.sort((I,A)=>!I.identifier.uuid&&A.identifier.uuid?-1:I.identifier.uuid&&!A.identifier.uuid?1:(0,R.compare)(I.identifier.id,A.identifier.id)),v?(0,T.toFormattedString)(h,{}):JSON.stringify(h)}async hasLocalData(){try{const h=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(h).some(I=>I.installed||I.disabled))return!0}catch{}return!1}async updateLocalExtensions(h,v,I,A){const O=[],N=[],$=await this.extensionManagementService.getInstalled();if(v.length){const M=$.filter(({identifier:z,isBuiltin:U})=>!U&&v.some(V=>(0,g.areSameExtensions)(z,V)));await L.Promises.settled(M.map(async z=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,z.identifier.id),await this.extensionManagementService.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,z.identifier.id),O.push(z.identifier)}))}(h.length||I.length)&&await L.Promises.settled([...h,...I].map(async M=>{const z=$.find(V=>(0,g.areSameExtensions)(V.identifier,M.identifier));if(z&&z.isBuiltin){M.state&&z.manifest.version===M.version&&this.updateExtensionState(M.state,z.manifest.publisher,z.manifest.name,z.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(Y=>(0,g.areSameExtensions)(Y,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),O.push(M.identifier);return}const U=(await this.extensionGalleryService.getExtensions([M.identifier],!!M.preRelease,n.CancellationToken.None))[0];if(M.state&&(z?z.manifest.version===M.version:!!U)){const V=z?z.manifest.publisher:U.publisher,Y=z?z.manifest.name:U.name;this.updateExtensionState(M.state,V,Y,z?.manifest.version)}if(U)try{this.extensionEnablementService.getDisabledExtensions().some(Y=>(0,g.areSameExtensions)(Y,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,U.version))),(!z||z.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,U.version),O.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),N.push(M)))}catch(V){N.push(M),V instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(V.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(V),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else N.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const D=[];for(const M of A)O.some(z=>(0,g.areSameExtensions)(z,M.identifier))||D.push(M);for(const M of N)D.some(z=>(0,g.areSameExtensions)(z.identifier,M.identifier))||D.push(M);return D}updateExtensionState(h,v,I,A){const O=i(v,I,this.storageService),N=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,g.getGalleryExtensionId)(v,I),version:A}):void 0;N?N.forEach($=>{O[$]=h[$]}):Object.keys(h).forEach($=>O[$]=h[$]),t(v,I,O,this.storageService)}parseExtensions(h){return JSON.parse(h.content)}getLocalExtensions(h){const v=this.extensionEnablementService.getDisabledExtensions();return h.map(({identifier:I,isBuiltin:A,manifest:O,preRelease:N})=>{const $={identifier:I,preRelease:N,version:O.version};v.some(D=>(0,g.areSameExtensions)(D,I))&&($.disabled=!0),A||($.installed=!0);try{const D=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:O.version});if(D){const M=i(O.publisher,O.name,this.storageService);$.state=Object.keys(M).reduce((z,U)=>(D.includes(U)&&(z[U]=M[U]),z),{})}}catch(D){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(D))}return $})}};s.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=de([Q(0,P.IEnvironmentService),Q(1,p.IFileService),Q(2,y.IStorageService),Q(3,r.IUserDataSyncStoreService),Q(4,r.IUserDataSyncBackupStoreService),Q(5,E.IExtensionManagementService),Q(6,E.IGlobalExtensionEnablementService),Q(7,u.IIgnoredExtensionsManagementService),Q(8,r.IUserDataSyncLogService),Q(9,E.IExtensionGalleryService),Q(10,w.IConfigurationService),Q(11,r.IUserDataSyncEnablementService),Q(12,C.ITelemetryService),Q(13,l.IExtensionsStorageSyncService),Q(14,d.IUriIdentityService)],s),e.ExtensionsSynchroniser=s;let o=class extends S.AbstractInitializer{constructor(h,v,I,A,O,N){super("extensions",A,O,I,N);this.extensionManagementService=h,this.ignoredExtensionsManagementService=v}async parseExtensions(h){return h.syncData?await a(h.syncData,this.extensionManagementService):null}generatePreview(h,v){const I=[],A=[],O=[];for(const N of h){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const $=v.find(D=>(0,g.areSameExtensions)(D.identifier,N.identifier));$?(I.push($),N.disabled&&O.push(N.identifier)):N.installed&&(A.push(N.identifier),N.disabled&&O.push(N.identifier))}return{installedExtensions:I,newExtensions:A,disabledExtensions:O,remoteExtensions:h}}};o=de([Q(0,E.IExtensionManagementService),Q(1,u.IIgnoredExtensionsManagementService),Q(2,p.IFileService),Q(3,P.IEnvironmentService),Q(4,f.ILogService),Q(5,d.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[225],ie([0,1,28,24]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(R,b,w,P,E){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const g=_(R,b);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=w?_(w,b):{added:Object.keys(b).reduce((S,m)=>(S.add(m),S),new Set),removed:new Set,updated:new Set},f=w?_(w,R):{added:Object.keys(R).reduce((S,m)=>(S.add(m),S),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},C=L.deepClone(b),d=!w;for(const S of f.added.values())S!==n.SYNC_SERVICE_URL_TYPE&&d&&p.added.has(S)||(C[S]=R[S]);for(const S of f.updated.values())C[S]=R[S];for(const S of f.removed.values())P.unregistered.includes(S)||delete C[S];for(const S of p.added.values()){const m=b[S];if(P.machine.includes(S)){E.info(`GlobalState: Skipped adding ${S} in local storage because it is declared as machine scoped.`);continue}if(w&&f.added.has(S))continue;const l=R[S];l&&l.value===m.value||S===n.SYNC_SERVICE_URL_TYPE&&d&&f.added.has(S)||(l?y.updated[S]=m:y.added[S]=m)}for(const S of p.updated.values()){const m=b[S];if(P.machine.includes(S)){E.info(`GlobalState: Skipped updating ${S} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(S)||f.removed.has(S))continue;const l=R[S];l&&l.value===m.value||(y.updated[S]=m)}for(const S of p.removed.values()){if(P.machine.includes(S)){E.trace(`GlobalState: Skipped removing ${S} in local storage because it is declared as machine scoped.`);continue}f.updated.has(S)||f.removed.has(S)||y.removed.push(S)}return{local:y,remote:T(C,b)?null:C}}e.merge=k;function _(R,b){const w=Object.keys(R),P=Object.keys(b),E=P.filter(f=>w.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),g=w.filter(f=>P.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),p=new Set;for(const f of w){if(g.has(f))continue;const y=R[f],C=b[f];L.equals(y,C)||p.add(f)}return{added:E,removed:g,updated:p}}function T(R,b){const{added:w,removed:P,updated:E}=_(R,b);return w.size===0&&P.size===0&&E.size===0}}),define(ne[226],ie([0,1,17,8,3,35,49,4,7,29,20,13,14,10,46,23,21,34,47,52,225,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function i(h,v){const I=h.storage?Object.keys(h.storage).sort():[],A={};return I.forEach(O=>A[O]=h.storage[O]),h.storage=A,v?(0,T.toFormattedString)(h,{}):JSON.stringify(h)}const t=1;let s=class pt extends S.AbstractSynchroniser{constructor(v,I,A,O,N,$,D,M,z,U){super("globalState",v,N,z,I,A,$,D,O,M,U);this.storageService=z,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(v.onDidFilesChange,V=>V.contains(this.environmentService.argvResource)),k.Event.filter(z.onDidChangeValue,V=>V.scope===0&&V.target!==void 0?V.target===0:z.keys(0,0).includes(V.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,I,A){const O=v.syncData?JSON.parse(v.syncData.content):null;I=I===null&&A?v:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const D=this.getStorageKeys(N),{local:M,remote:z}=(0,l.merge)($.storage,O?O.storage:null,N?N.storage:null,D,this.logService),U={content:null,local:M,remote:z,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:z!==null?2:0};return[{localResource:this.localResource,localContent:i($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:D}]}async hasRemoteChanged(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(I===null)return!0;const A=await this.getLocalGlobalState(),O=this.getStorageKeys(I),{remote:N}=(0,l.merge)(A.storage,I.storage,I.storage,O,this.logService);return N!==null}async getMergeResult(v,I){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,I,A,O){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(I,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const I=JSON.parse(v.remoteContent),{local:A,remote:O}=(0,l.merge)(v.localUserData.storage,I.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:A,remote:O,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,I,A,O){let{localUserData:N}=A[0][0],{local:$,remote:D,localChange:M,remoteChange:z}=A[0][1];if(M===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),z!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:D});v=await this.updateRemoteUserData(U,O?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,pt.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return i(A,!0)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)){const A=await this.resolvePreviewContent(v);return A&&i(JSON.parse(A),!0)}let I=await super.resolveContent(v);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(v)),I){const A=this.parseSyncData(I);if(A)switch(this.extUri.basename(v)){case"globalState.json":return i(JSON.parse(A.content),!0)}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const v={},I=await this.getLocalArgvContent(),A=(0,_.parse)(I);for(const O of a)A[O]!==void 0&&(v[`${r}${O}`]={version:1,value:A[O]});for(const O of this.storageService.keys(0,0)){const N=this.storageService.get(O,0);N&&(v[O]={version:1,value:N})}return{storage:v}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const v=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),v.value.toString()}catch(v){this.logService.debug((0,n.getErrorMessage)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:I,updated:A}){const O={},N={},$=(M,z)=>{for(const U of M){if(U.startsWith(r)){O[U.substring(r.length)]=z?z[U].value:void 0;continue}if(z){const V=z[U];V.value!==String(this.storageService.get(U,0))&&(N[U]=V.value)}else this.storageService.get(U,0)!==void 0&&(N[U]=void 0)}};if($(Object.keys(v),v),$(Object.keys(A),A),$(I),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(N))this.storageService.store(M,N[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(v){const I=await this.getLocalArgvContent();let A=I;for(const O of Object.keys(v))A=(0,m.edit)(A,[O],v[O],{});I!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const I=this.storageService.keys(0,0),A=this.storageService.keys(0,1),O=[...I,...A],N=v?.storage?Object.keys(v.storage).filter($=>!$.startsWith(r)&&!O.includes($)&&this.storageService.get($,0)!==void 0):[];if(!R.isWeb){const $=[...u.ALL_SYNC_RESOURCES.map(D=>(0,u.getEnablementKey)(D)),u.SYNC_SERVICE_URL_TYPE];N.push(...$),A.push(...$)}return{user:I,machine:A,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([Q(0,g.IFileService),Q(1,u.IUserDataSyncStoreService),Q(2,u.IUserDataSyncBackupStoreService),Q(3,u.IUserDataSyncLogService),Q(4,E.IEnvironmentService),Q(5,u.IUserDataSyncEnablementService),Q(6,C.ITelemetryService),Q(7,P.IConfigurationService),Q(8,y.IStorageService),Q(9,d.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends S.AbstractInitializer{constructor(v,I,A,O,N){super("globalState",A,O,I,N);this.storageService=v}async doInitialize(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},O={};for(const N of Object.keys(I.storage))N.startsWith(r)?A[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(O[N]=I.storage[N].value);if(Object.keys(A).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(A))N=(0,m.edit)(N,[$],A[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(N))}if(Object.keys(O).length)for(const N of Object.keys(O))this.storageService.store(N,O[N],0,0)}};o=de([Q(0,y.IStorageService),Q(1,g.IFileService),Q(2,E.IEnvironmentService),Q(3,u.IUserDataSyncLogService),Q(4,d.IUriIdentityService)],o),e.GlobalStateInitializer=o;let c=class{constructor(v,I,A,O,N){this.userDataSyncStoreClient=v,this.storageService=I,this.environmentService=A,this.fileService=O,this.logService=N}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const I=(0,u.createSyncHeaders)((0,w.generateUuid)());try{return await this.doSync(v,I)}catch(A){if(A instanceof u.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,I)}throw A}}async doSync(v,I){const A=await this.userDataSyncStoreClient.read("globalState",null,I),O=this.parseGlobalState(A)||{storage:{}};O.storage[u.SYNC_SERVICE_URL_TYPE]={value:v,version:t};const N=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:N,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),A.ref,I)}parseGlobalState({content:v}){if(!v)return null;const I=JSON.parse(v);if((0,S.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};c=de([Q(1,y.IStorageService),Q(2,E.IEnvironmentService),Q(3,g.IFileService),Q(4,p.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ne[227],ie([0,1,16,17,3,35,4,15,144,20,13,14,23,21,34,47,222,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function S(u,r,a){try{const i=JSON.parse(u);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}e.getKeybindingsContentFromSyncContent=S;let m=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,h,v,I,A){super(c.keybindingsResource,"keybindings",o,c,h,r,a,s,I,i,v,t,A);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,i,t){const s=r.syncData?S(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&i?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),h=await this.getFormattingOptions();let v=null,I=!1,A=!1,O=!1;if(s){let $=c?c.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new d.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const D=await(0,C.merge)($,s,o,h,this.userDataSyncUtilService);D.hasChanges&&(v=D.mergeContent,O=D.hasConflicts,I=O||D.mergeContent!==$,A=O||D.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=c.value.toString(),A=!0);const N={content:v,localChange:I?c?2:1:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",s=await this.getFormattingOptions(),o=await(0,C.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,i,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:h}=i[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new d.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),h!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(v,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,_.parse)(r.value.toString());if((0,L.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return S(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:S(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let i={};try{i=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};m=de([Q(0,d.IUserDataSyncStoreService),Q(1,d.IUserDataSyncBackupStoreService),Q(2,d.IUserDataSyncLogService),Q(3,w.IConfigurationService),Q(4,d.IUserDataSyncEnablementService),Q(5,E.IFileService),Q(6,P.IEnvironmentService),Q(7,g.IStorageService),Q(8,d.IUserDataSyncUtilService),Q(9,p.ITelemetryService),Q(10,f.IUriIdentityService)],m),e.KeybindingsSynchroniser=m;let l=class extends y.AbstractInitializer{constructor(r,a,i,t){super("keybindings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,_.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return S(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};l=de([Q(0,E.IFileService),Q(1,P.IEnvironmentService),Q(2,d.IUserDataSyncLogService),Q(3,f.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[228],ie([0,1,16,35,68,49,28,52,24]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(o,c,h){let v=[];h?v=E(h):v=P(c);const I=[],A=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const O of v)O.startsWith("-")?A.push(O.substring(1)):I.push(O);return(0,L.distinct)([...o,...I].filter(O=>A.indexOf(O)===-1))}e.getIgnoredSettings=w;function P(o){let c=o.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=o.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const c=(0,n.parse)(o);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function g(o,c,h,v){if(h.length){const I=s(c),A=(0,n.parse)(c),O=(0,n.parse)(o),N=[];for(const $ of h){const D=A[$],M=O[$];D===void 0?o=R.edit(o,[$],void 0,v):M!==void 0?o=R.edit(o,[$],D,v):N.push(u($,I))}N.sort(($,D)=>$.startOffset-D.startOffset),N.forEach($=>o=d($.setting.key,c,o,v))}return o}e.updateIgnoredSettings=g;function p(o,c,h,v,I,A){const O=g(o,c,v,A),N=h!==O,$=h!==c;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:g(c,o,v,A),remoteContent:null,hasConflicts:!1};if(h===null&&y(o)){const W=f(o,c,v)?null:g(c,o,v,A);return{conflictsSettings:[],localContent:W,remoteContent:null,hasConflicts:!1}}let D=o,M=c;const z=(0,n.parse)(o),U=(0,n.parse)(c),V=h?(0,n.parse)(h):null,Y=v.reduce((W,x)=>(W.add(x),W),new Set),B=C(z,U,Y),q=C(V,z,Y),X=C(V,U,Y),G=new Map,ee=new Set,K=W=>{ee.add(W);const x=I.filter(({key:re})=>re===W)[0];x?(D=R.edit(D,[W],x.value,A),M=R.edit(M,[W],x.value,A)):G.set(W,{key:W,localValue:z[W],remoteValue:U[W]})};for(const W of q.removed.values())X.updated.has(W)?K(W):M=R.edit(M,[W],void 0,A);for(const W of X.removed.values())ee.has(W)||(q.updated.has(W)?K(W):D=R.edit(D,[W],void 0,A));for(const W of q.updated.values())ee.has(W)||(X.updated.has(W)?B.updated.has(W)&&K(W):M=R.edit(M,[W],z[W],A));for(const W of X.updated.values())ee.has(W)||(q.updated.has(W)?B.updated.has(W)&&K(W):D=R.edit(D,[W],U[W],A));for(const W of q.added.values())ee.has(W)||(X.added.has(W)?B.updated.has(W)&&K(W):M=d(W,D,M,A));for(const W of X.added.values())ee.has(W)||(q.added.has(W)?B.updated.has(W)&&K(W):D=d(W,M,D,A));const F=G.size>0||!f(D,M,v),j=F||!f(D,o,[]),H=F||!f(M,c,[]);return{localContent:j?D:null,remoteContent:H?M:null,conflictsSettings:[...G.values()],hasConflicts:F}}e.merge=p;function f(o,c,h){if(o===c)return!0;const v=(0,n.parse)(o),I=(0,n.parse)(c),A=h.reduce(($,D)=>($.add(D),$),new Set),O=s(o).filter($=>!($.setting&&A.has($.setting.key))),N=s(c).filter($=>!($.setting&&A.has($.setting.key)));if(O.length!==N.length)return!1;for(let $=0;$<O.length;$++){const D=O[$],M=N[$];if(D.setting&&M.setting){if(D.setting.key!==M.setting.key||!T.equals(v[D.setting.key],I[D.setting.key]))return!1}else if(!D.setting&&!M.setting){if(D.value!==M.value)return!1}else return!1}return!0}e.areSame=f;function y(o){return o?s(o).length===0:!0}e.isEmpty=y;function C(o,c,h){const v=o?Object.keys(o).filter($=>!h.has($)):[],I=Object.keys(c).filter($=>!h.has($)),A=I.filter($=>v.indexOf($)===-1).reduce(($,D)=>($.add(D),$),new Set),O=v.filter($=>I.indexOf($)===-1).reduce(($,D)=>($.add(D),$),new Set),N=new Set;if(o)for(const $ of v){if(O.has($))continue;const D=o[$],M=c[$];T.equals(D,M)||N.add($)}return{added:A,removed:O,updated:N}}function d(o,c,h,v){const I=(0,n.parse)(c),A=s(c),O=s(h),N=S(o,A,O);return m(h,o,I[o],N,O,v)}e.addSetting=d;function S(o,c,h){const v=c.findIndex(A=>A.setting?.key===o),I=c[v-1];if(I){if(I.setting){const O=u(I.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!0}}else{const O=r(v,c);if(O){const N=u(O.setting.key,h);if(N){const $=a(h.indexOf(N),h),D=i(c,O,c[v]);if($){const M=i(h,N,$),z=t(D,M);return z?{index:h.indexOf(z),insertAfter:!0}:{index:h.indexOf($),insertAfter:!1}}else{const M=i(h,N,h[h.length-1]),z=t(D,M);return z?{index:h.indexOf(z),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const A=c[v+1];if(A)if(A.setting){const O=u(A.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!1}}else{const O=a(v,c);if(O){const N=u(O.setting.key,h);if(N){const $=r(h.indexOf(N),h),D=i(c,c[v],O);if($){const M=i(h,$,N),z=t(D.reverse(),M.reverse());return z?{index:h.indexOf(z),insertAfter:!1}:{index:h.indexOf($),insertAfter:!0}}else{const M=i(h,h[0],N),z=t(D.reverse(),M.reverse());return z?{index:h.indexOf(z),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function m(o,c,h,v,I,A){let O;return v.index===-1?O=(0,k.setProperty)(o,[c],h,A):O=l(o,c,h,v,I,A).map(N=>(0,k.withFormatting)(o,N,A)[0]),(0,k.applyEdits)(o,O)}function l(o,c,h,v,I,A){const O=`${JSON.stringify(c)}: ${JSON.stringify(h)}`,N=(0,_.getEOL)(A,o),$=I[v.index];if(v.insertAfter){const D=[];if($.setting)D.push({offset:$.endOffset,length:0,content:","+O});else{const M=a(v.index,I),z=r(v.index,I),U=z?.setting?.commaOffset;z&&U===void 0&&D.push({offset:z.endOffset,length:0,content:","});const V=U!==void 0&&U>$.endOffset;D.push({offset:V?U+1:$.endOffset,length:0,content:M?N+O+",":N+O})}return D}else{if($.setting)return[{offset:$.startOffset,length:0,content:O+","}];const D=(I[v.index-1]&&!I[v.index-1].setting?N:"")+O+(a(v.index,I)?",":"")+N;return[{offset:$.startOffset,length:0,content:D}]}}function u(o,c){return c.filter(h=>h.setting?.key===o)[0]}function r(o,c){for(let h=o-1;h>=0;h--)if(c[h].setting)return c[h]}function a(o,c){for(let h=o+1;h<c.length;h++)if(c[h].setting)return c[h]}function i(o,c,h){const v=o.indexOf(c),I=o.indexOf(h);return o.filter((A,O)=>v<O&&O<I)}function t(o,c){if(o.length&&c.length){let h=0;for(;h<c.length&&h<o.length;h++)if(o[h].value!==c[h].value)return c[h-1];return c[h-1]}}function s(o){const c=[];let h=-1,v,I;const A={onObjectBegin:O=>{h++},onObjectProperty:(O,N,$)=>{h===0&&(v=N,I=O)},onObjectEnd:(O,N)=>{h--,h===0&&c.push({startOffset:v,endOffset:O+N,value:o.substring(v,O+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(O,N)=>{h++},onArrayEnd:(O,N)=>{h--,h===0&&c.push({startOffset:v,endOffset:O+N,value:o.substring(v,O+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(O,N,$)=>{h===0&&c.push({startOffset:v,endOffset:N+$,value:o.substring(v,N+$),setting:{key:I,commaOffset:void 0}})},onSeparator:(O,N,$)=>{if(h===0&&O===","){let D=c.length-1;for(;D>=0&&!c[D].setting;D--);const M=c[D];M&&c.splice(D,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:N}})}},onComment:(O,N)=>{h===0&&c.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,n.visit)(o,A),c}}),define(ne[229],ie([0,1,17,3,145,20,87,13,30,14,23,21,34,47,52,228,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function S(u){const r=JSON.parse(u);return d(r)?r:{settings:u}}e.parseSettingsSyncContent=S;let m=class extends p.AbstractJsonFileSynchroniser{constructor(r,a,i,t,s,o,c,h,v,I,A,O){super(a.settingsResource,"settings",r,a,i,t,s,v,I,o,c,h,O);this.extensionManagementService=A,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(i),s=new T.ConfigurationModelParser(C.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(C.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,i){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);a=a===null&&i?r:a;const c=a?this.getSettingsSyncContent(a):null,h=await this.getIgnoredSettings();let v=null,I=!1,A=!1,O=!1;if(o){let $=t?t.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const D=(0,y.merge)($,o.settings,c?c.settings:null,h,[],s);v=D.localContent||D.remoteContent,I=D.localContent!==null,A=D.remoteContent!==null,O=D.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),v=t.value.toString(),A=!0);const N={content:v,localChange:I?2:0,remoteChange:A?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,y.merge)(t||"{}",a.settings,a.settings,s,[],o).remoteContent!==null}async getMergeResult(r,a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,y.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,a,i,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,y.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,y.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,y.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:s}=i[0][0];let{content:o,localChange:c,remoteChange:h}=i[0][1];if(c===0&&h===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),h!==0){const v=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),A=await this.getIgnoredSettings(o);o=(0,y.updateIgnoredSettings)(o,I?I.settings:"{}",A,v),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),i=(0,f.edit)(r.value.toString(),[C.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,y.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,y.updateIgnoredSettings)(a,"{}",t,i)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return S(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new C.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};m=de([Q(0,w.IFileService),Q(1,R.IEnvironmentService),Q(2,P.IStorageService),Q(3,C.IUserDataSyncStoreService),Q(4,C.IUserDataSyncBackupStoreService),Q(5,C.IUserDataSyncLogService),Q(6,C.IUserDataSyncUtilService),Q(7,_.IConfigurationService),Q(8,C.IUserDataSyncEnablementService),Q(9,E.ITelemetryService),Q(10,b.IExtensionManagementService),Q(11,g.IUriIdentityService)],m),e.SettingsSynchroniser=m;let l=class extends p.AbstractInitializer{constructor(r,a,i,t){super("settings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,y.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return S(r)}catch(a){this.logService.error(a)}return null}};l=de([Q(0,w.IFileService),Q(1,R.IEnvironmentService),Q(2,C.IUserDataSyncLogService),Q(3,g.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[230],ie([0,1,17,3,28,20,13,14,23,21,34,47,223,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let f=class extends E.AbstractSynchroniser{constructor(d,S,m,l,u,r,a,i,t,s){super("snippets",S,d,m,l,u,i,t,r,a,s);this.version=1,this.snippetsFolder=d.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(d,S,m){const l=await this.getSnippetsFileContents(),u=this.toSnippetsContents(l),r=d.syncData?this.parseSnippets(d.syncData):null;S=S===null&&m?d:S;const a=S&&S.syncData?this.parseSnippets(S.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,g.merge)(u,r,a);return this.getResourcePreviews(i,l,r||{})}async hasRemoteChanged(d){const S=d.syncData?this.parseSnippets(d.syncData):null;if(S===null)return!0;const m=await this.getSnippetsFileContents(),l=this.toSnippetsContents(m),u=(0,g.merge)(l,S,S);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(d,S){return d.previewResult}async getAcceptResult(d,S,m,l){if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(S,this.syncPreviewFolder))return m===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:m,localChange:m===null?d.fileContent!==null?3:0:2,remoteChange:m===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async applyResult(d,S,m,l){const u=m.map(([r,a])=>({...r,acceptResult:a}));u.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,l)),u.some(({remoteChange:r})=>r!==0)&&(d=await this.updateRemoteSnippets(u,d,l)),S?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of u)try{await this.fileService.del(r)}catch{}}getResourcePreviews(d,S,m){const l=new Map;for(const u of Object.keys(d.local.added)){const r={content:d.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};l.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.local.updated)){const r={content:d.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.remote.added)){const r={content:d.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(d.remote.updated)){const r={content:d.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u],localContent:S[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of d.conflicts){const r={content:S[u]?S[u].value.toString():null,hasConflicts:!0,localChange:S[u]?2:1,remoteChange:m[u]?2:1};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(S))if(!l.has(u)){const r={content:S[u]?S[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[u]||null,localContent:S[u]?S[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...l.values()]}async getAssociatedResources({uri:d}){let S=await super.resolveContent(d);if(S){const m=this.parseSyncData(S);if(m){const l=this.parseSnippets(m),u=[];for(const r of Object.keys(l)){const a=this.extUri.joinPath(d,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);u.push({resource:a,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(d){if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(d);let S=await super.resolveContent(d);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(d)),S){const m=this.parseSyncData(S);if(m)return this.parseSnippets(m)[this.extUri.basename(d)]||null}return null}async hasLocalData(){try{const d=await this.getSnippetsFileContents();if(Object.keys(d).length)return!0}catch{}return!1}async updateLocalBackup(d){const S={};for(const m of d)m.fileContent&&(S[this.extUri.basename(m.localResource)]=m.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(S)))}async updateLocalSnippets(d,S){for(const{fileContent:m,acceptResult:l,localResource:u,remoteResource:r,localChange:a}of d)if(a!==0){const i=r?this.extUri.basename(r):this.extUri.basename(u),t=this.extUri.joinPath(this.snippetsFolder,i);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,L.VSBuffer.fromString(l.content),{overwrite:S}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,L.VSBuffer.fromString(l.content),S?void 0:m),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(d,S,m){const l=S.syncData?this.parseSnippets(S.syncData):{},u=(0,k.deepClone)(l);for(const{acceptResult:r,localResource:a,remoteResource:i,remoteChange:t}of d)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(i);t===3?delete u[s]:u[s]=r.content}return(0,g.areSame)(l,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),S=await this.updateRemoteUserData(JSON.stringify(u),m?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),S}parseSnippets(d){return JSON.parse(d.content)}toSnippetsContents(d){const S={};for(const m of Object.keys(d))S[m]=d[m].value.toString();return S}async getSnippetsFileContents(){const d={};let S;try{S=await this.fileService.resolve(this.snippetsFolder)}catch(m){if(m instanceof R.FileOperationError&&m.fileOperationResult===1)return d;throw m}for(const m of S.children||[]){const l=m.resource,u=this.extUri.extname(l);if(u===".json"||u===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,l),a=await this.fileService.readFile(l);d[r]=a}}return d}};f=de([Q(0,T.IEnvironmentService),Q(1,R.IFileService),Q(2,b.IStorageService),Q(3,p.IUserDataSyncStoreService),Q(4,p.IUserDataSyncBackupStoreService),Q(5,p.IUserDataSyncLogService),Q(6,_.IConfigurationService),Q(7,p.IUserDataSyncEnablementService),Q(8,w.ITelemetryService),Q(9,P.IUriIdentityService)],f),e.SnippetsSynchroniser=f;let y=class extends E.AbstractInitializer{constructor(d,S,m,l){super("snippets",S,m,d,l)}async doInitialize(d){const S=d.syncData?JSON.parse(d.syncData.content):null;if(!S){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(S)){const u=S[l];if(u){const r=this.extUri.joinPath(this.environmentService.snippetsHome,l);await this.fileService.createFile(r,L.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(d)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};y=de([Q(0,R.IFileService),Q(1,T.IEnvironmentService),Q(2,p.IUserDataSyncLogService),Q(3,P.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(ne[63],ie([0,1,3,2,6,24]),function(J,e,L,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{constructor(b,w){super();this.userDataSyncStoreService=b,this.logService=w,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};T=de([Q(0,_.IUserDataSyncStoreService),Q(1,_.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[231],ie([0,1,5,17,56,2,19,20,13,14,24]),function(J,e,L,n,k,_,T,R,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends _.Disposable{constructor(p,f,y,C){super();this.environmentService=p,this.fileService=f,this.configurationService=y,this.logService=C,P.ALL_SYNC_RESOURCES.forEach(d=>this.cleanUpBackup(d))}async getAllRefs(p){const f=(0,T.joinPath)(this.environmentService.userDataSyncHome,p),y=await this.fileService.resolve(f);return y.children?y.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort().reverse().map(d=>({ref:d.name,created:this.getCreationTime(d)})):[]}async resolveContent(p,f){if(!f){const y=await this.getAllRefs(p);y.length&&(f=y[y.length-1].ref)}if(f){const y=(0,T.joinPath)(this.environmentService.userDataSyncHome,p,f);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(p,f){const y=(0,T.joinPath)(this.environmentService.userDataSyncHome,p),C=(0,T.joinPath)(y,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,n.VSBuffer.fromString(f))}catch(d){this.logService.error(d)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const f=(0,T.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(f))return}catch{return}const y=await this.fileService.resolve(f);if(y.children){const C=y.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),d=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let S=C.filter(l=>Date.now()-this.getCreationTime(l)>d);const m=C.length-S.length;m<10&&(S=S.slice(10-m)),await L.Promises.settled(S.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=de([Q(0,b.IEnvironmentService),Q(1,w.IFileService),Q(2,R.IConfigurationService),Q(3,P.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(ne[232],ie([0,1,3,2,4,13,23,21,24]),function(J,e,L,n,k,_,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let P=class extends n.Disposable{constructor(g,p,f,y){super();this.storageService=g,this.telemetryService=p,this.environmentService=f,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(g.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(g){g&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(w,{enabled:g}),this.storageService.store(w,g,0,1))}isResourceEnabled(g){return this.storageService.getBoolean((0,b.getEnablementKey)(g),0,!0)}setResourceEnablement(g,p){if(this.isResourceEnabled(g)!==p){const f=(0,b.getEnablementKey)(g);this.telemetryService.publicLog2(f,{enabled:p}),this.storeResourceEnablement(f,p)}}getResourceSyncStateVersion(g){}storeResourceEnablement(g,p){this.storageService.store(g,p,0,k.isWeb?0:1)}onDidStorageChange(g){if(g.scope!==0)return;if(w===g.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=b.ALL_SYNC_RESOURCES.filter(f=>(0,b.getEnablementKey)(f)===g.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=de([Q(0,T.IStorageService),Q(1,R.ITelemetryService),Q(2,_.IEnvironmentService),Q(3,b.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[233],ie([0,1,2,7]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(g){this.service=g}listen(g,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(g,p,f){switch(p){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class _{constructor(g){this.service=g}listen(g,p){throw new Error(`Event not found: ${p}`)}call(g,p,f){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=_;class T{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(g){this.service=g}listen(g,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(g,p,f){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablement":return this.service.setEnablement(f[0],f[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(g){this.service=g}listen(g,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(g,p,f){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class w{constructor(g){this.service=g}listen(g,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(g,p,f){switch(p){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class P extends L.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:n.URI.revive(g.url),type:g.type,defaultUrl:n.URI.revive(g.defaultUrl),insidersUrl:n.URI.revive(g.insidersUrl),stableUrl:n.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[234],ie([0,1,13,10]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(T,R){super();this.logger=this._register(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}critical(T,...R){this.logger.critical(T,...R)}flush(){this.logger.flush()}};k=de([Q(0,n.ILoggerService),Q(1,L.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[64],ie([0,1,3,2,4,27,148,13,14,6,26,46,23,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName";let y=class et extends n.Disposable{constructor(d,S,m,l,u,r){super();this.storageService=m,this.userDataSyncStoreService=l,this.logService=u,this.productService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(d,S,m)}async getMachines(d){const S=await this.currentMachineIdPromise;return(await this.readMachinesData(d)).machines.map(l=>({...l,isCurrent:l.id===S}))}async addCurrentMachine(d){const S=await this.currentMachineIdPromise,m=await this.readMachinesData(d);m.machines.some(({id:l})=>l===S)||(m.machines.push({id:S,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(d){const S=await this.currentMachineIdPromise,m=await this.readMachinesData(d),l=m.machines.filter(({id:u})=>u!==S);l.length!==m.machines.length&&(m.machines=l,await this.writeMachinesData(m))}async renameMachine(d,S,m){const l=await this.currentMachineIdPromise,u=await this.readMachinesData(m),r=u.machines.find(({id:a})=>a===d);r&&(r.name=S,await this.writeMachinesData(u),u.machines.some(({id:a})=>a===l)&&this.storageService.store(f,S,0,1))}async setEnablement(d,S){const m=await this.readMachinesData(),l=m.machines.find(({id:u})=>u===d);l&&(l.disabled=S?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(d){const S=this.storageService.get(f,0);if(S)return S;const m=`${this.productService.nameLong} (${(0,k.PlatformToString)(k.isWeb?0:k.platform)})`,l=new RegExp(`${(0,_.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let u=0;for(const r of d){const a=l.exec(r.name),i=a?parseInt(a[1]):0;u=i>u?i:u}return`${m} #${u+1}`}async readMachinesData(d){this.userData=await this.readUserData(d);const S=this.parse(this.userData);if(S.version!==et.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return S}async writeMachinesData(d){const S=JSON.stringify(d),m=await this.userDataSyncStoreService.write(et.RESOURCE,S,this.userData?.ref||null);this.userData={ref:m,content:S},this._onDidChange.fire()}async readUserData(d){if(this.userData){const S=d&&d.latest?d.latest[et.RESOURCE]:void 0;if(this.userData.ref===S)return this.userData;if(S===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(d){if(d.content!==null)try{return JSON.parse(d.content)}catch(S){this.logService.error(S)}return{version:et.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=de([Q(0,R.IEnvironmentService),Q(1,b.IFileService),Q(2,g.IStorageService),Q(3,p.IUserDataSyncStoreService),Q(4,p.IUserDataSyncLogService),Q(5,P.IProductService)],y),e.UserDataSyncMachinesService=y}),define(ne[235],ie([0,1,5,56,37,8,3,2,4,19,7,146,26,23,21,24,63,64]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const S="sync.disableMachineEventually",m="sync.sessionId",l="sync.storeUrl",u="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,c,h,v,I,A,O,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=h,this.logService=v,this.userDataSyncAccountService=I,this.telemetryService=A,this.userDataSyncMachinesService=O,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(h.onDidChangeLocal,($,D)=>$?[...$,D]:[D],1e3)($=>this.triggerSync($,!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(l,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(l,t.toString(),0,1):this.storageService.remove(l,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(t){t?this.storageService.store(u,t,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(m,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(s)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=y.UserDataSyncError.toUserDataSyncError(t);s instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?b.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(S,!0,0,1),await(0,L.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(S,0,!1)}stopDisableMachineEventually(){this.storageService.remove(S,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Q(0,g.IProductService),Q(1,y.IUserDataSyncStoreManagementService),Q(2,y.IUserDataSyncStoreService),Q(3,y.IUserDataSyncEnablementService),Q(4,y.IUserDataSyncService),Q(5,y.IUserDataSyncLogService),Q(6,C.IUserDataSyncAccountService),Q(7,f.ITelemetryService),Q(8,d.IUserDataSyncMachinesService),Q(9,p.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,c,h,v,I,A){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=h,this.userDataSyncMachinesService=v,this.logService=I,this.storageService=A,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,L.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,_.isPromiseCanceledError)(h))return}return this.doSync(t,s,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,w.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,w.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,w.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const h=this.storageService.get(m,0);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=v.find(A=>A.isCurrent);if(I?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(A){throw new y.UserDataAutoSyncError((0,k.toErrorMessage)(A),A instanceof y.UserDataSyncError?A.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(m,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),c=h}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ne[236],ie([0,1,16,5,37,3,2,19,15,29,20,30,6,23,21,224,226,227,229,230,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const u="sync.lastSyncTime";let r=class extends T.Disposable{constructor(o,c,h,v,I,A,O,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=c,this.instantiationService=h,this.configurationService=v,this.logService=I,this.telemetryService=A,this.storageService=O,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new T.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(u,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,c){this.checkEnablement();const h=(0,w.generateUuid)();try{const N=(0,l.createSyncHeaders)(h);c&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=l.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,h),$}let v=!1;const I=this,A=this.getEnabledSynchronizers();let O;return{manifest:o,async run(){if(v)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(N=>I.sync(A,o,h,N)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),I.status!=="idle")return I.stop(A)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new l.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,w.generateUuid)(),c=(0,l.createSyncHeaders)(o);let h;try{h=await this.userDataSyncStoreService.manifest(null,c)}catch(I){const A=l.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(A,o),A}await this.resetLocal();const v=this.getEnabledSynchronizers();return new a(o,h,c,v,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,c,h,v){if(v.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const A=(0,l.createSyncHeaders)(h);for(const O of o){if(v.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(c,A)}catch(N){let $=!1;if(N instanceof l.UserDataSyncError)switch(N.code){case"TooLarge":N=new l.UserDataSyncError(N.message,N.code,O.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const D=l.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(D,h),$)throw D;this.logService.error(N),this.logService.error(`${O.resource}: ${(0,k.toErrorMessage)(N)}`),this._syncErrors.push([O.resource,D])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(A){const O=l.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(O,h),O}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const c of o)try{c.status!=="idle"&&await c.stop()}catch(h){this.logService.error(h)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(o))return!0})}async accept(o,c,h,v){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(c,h),v&&await I.apply(!1,(0,l.createSyncHeaders)((0,w.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async c=>{const h=await c.resolveContent(o);if(h)return h})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async h=>{if(h.resource===o)return h.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async h=>{if(h.resource===o)return h.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,c){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getAssociatedResources(c)})||[]}async getMachineId(o,c){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return await v.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(u,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(c){this.logService.error(`${o.resource}: ${(0,k.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const c=new T.DisposableStore;try{const h=this.synchronizers.value||c.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),v=[...h.enabled,...h.disabled.map(I=>c.add(h.createSynchronizer(I)))];for(const I of v){const A=await o(I);if(!(0,b.isUndefined)(A))return A}return null}finally{c.dispose()}}setStatus(o){const c=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const c=this.computeStatus(o);this.setStatus(c)}updateConflicts(o){const c=this.computeConflicts(o);(0,L.equals)(this._conflicts,c,([h,v],[I,A])=>h===h&&(0,L.equals)(v,A,(O,N)=>(0,R.isEqual)(O.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(c))}computeConflicts(o){return o.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(c=>c.status==="hasConflicts")?"hasConflicts":o.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(u,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,c){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof l.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof l.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([Q(0,l.IUserDataSyncStoreService),Q(1,l.IUserDataSyncStoreManagementService),Q(2,g.IInstantiationService),Q(3,P.IConfigurationService),Q(4,l.IUserDataSyncLogService),Q(5,f.ITelemetryService),Q(6,p.IStorageService),Q(7,l.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends T.Disposable{constructor(o,c,h,v,I,A,O){super();this.id=o,this.manifest=c,this.syncHeaders=h,this.synchronisers=v,this.onStop=I,this.configurationService=A,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new _.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,c){try{return await this.performAction(o,h=>h.accept(o,c))}catch(h){throw this.logService.error(h),h}}async merge(o){try{return o?await this.performAction(o,c=>c.merge(o)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(o){try{return await this.performAction(o,c=>c.discard(o))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,c]of this.previews)for(const h of c.resourcePreviews)h.mergeState==="conflict"&&o.push(h.previewResource);for(const c of o)await this.discard(c);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(A=>A.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(A=>A.resource===c);for(const A of h.resourcePreviews)(A.localChange!==0||A.remoteChange!==0)&&A.mergeState==="preview"&&await v.merge(A.previewResource);const I=await v.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(v.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(A=>A[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(v=>v.resource===o);for(const v of c.resourcePreviews)await h.accept(v.remoteResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const h=this.synchronisers.find(v=>v.resource===o);for(const v of c.resourcePreviews)await h.accept(v.localResource);await h.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const h=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:z,previewResource:U,remoteResource:V})=>(0,R.isEqual)(o,z)||(0,R.isEqual)(o,U)||(0,R.isEqual)(o,V)));if(h===-1)return this.previews;const[v,I]=this.previews[h],A=I.resourcePreviews.find(({localResource:M,remoteResource:z,previewResource:U})=>(0,R.isEqual)(M,o)||(0,R.isEqual)(z,o)||(0,R.isEqual)(U,o));if(!A)return this.previews;let O=this.synchronizingResources.find(M=>M[0]===v);O||(O=[v,[]],this.synchronizingResources.push(O)),O[1].some(M=>(0,R.isEqual)(M,A.localResource))||(O[1].push(A.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(M=>M.resource===this.previews[h][0]),$=await c(N);$?this.previews.splice(h,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(h,1);const D=this.synchronizingResources.findIndex(M=>M[0]===v);return this.synchronizingResources[D][1].splice(O[1].findIndex(M=>(0,R.isEqual)(M,A.localResource)),1),O[1].length||(this.synchronizingResources.splice(D,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[c,h]of this.previews){this.synchronizingResources.push([c,h.resourcePreviews.map(A=>A.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(A=>A.resource===c);let I=h;for(const A of h.resourcePreviews)(A.localChange!==0||A.remoteChange!==0)&&A.mergeState==="preview"&&(I=await v.merge(A.previewResource));I&&o.push(this.toSyncResourcePreview(v.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(A=>A[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const c=[],h=await this.getUserDataSyncConfiguration();for(const v of this.synchronisers){if(o.isCancellationRequested)return[];const I=await v.preview(this.manifest,h,this.syncHeaders);I&&c.push(this.toSyncResourcePreview(v.resource,I))}return c}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(h=>h instanceof S.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...c}}toSyncResourcePreview(o,c){return[o,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends T.Disposable{constructor(o,c,h,v,I,A,O){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=c,this.onDidChangeLocal=h,this.userDataSyncEnablementService=v,this.instantiationService=I,this.extensionGalleryService=A,this.logService=O,this._enabled=[],this._register(v.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of l.ALL_SYNC_RESOURCES)v.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,c)=>o[1]-c[1]).map(([o])=>o)}get disabled(){return l.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,c){c?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new T.DisposableStore,h=c.add(this.createSynchronizer(o));c.add(h.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(h.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(h.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const v=this.getOrder(o);this._enabled.push([h,v,c])}deRegisterSynchronizer(o){const c=this._enabled.findIndex(([h])=>h.resource===o);if(c!==-1){const h=this._enabled.splice(c,1);for(const[v,,I]of h){if(v.status!=="idle"){const A=v.conflicts.length>0;v.stop(),A&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(S.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(m.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(C.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(y.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([Q(3,l.IUserDataSyncEnablementService),Q(4,g.IInstantiationService),Q(5,E.IExtensionGalleryService),Q(6,l.IUserDataSyncLogService)],i);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(ne[237],ie([0,1,3,2,15,7,24]),function(J,e,L,n,k,_,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(E,g){this.service=E,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(E,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(E,g,p){try{return await this._call(E,g,p)}catch(f){throw this.logService.error(f),f}}async _call(E,g,p){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(_.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],_.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(_.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:_.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:_.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const f=g.substring("manualSync/".length),y=p[0],C=this.getManualSyncTask(y);switch(p=p.slice(1),f){case"preview":return C.preview();case"accept":return C.accept(_.URI.revive(p[0]),p[1]);case"merge":return C.merge(_.URI.revive(p[0]));case"discard":return C.discard(_.URI.revive(p[0]));case"discardConflicts":return C.discardConflicts();case"apply":return C.apply();case"pull":return C.pull();case"push":return C.push();case"stop":return C.stop();case"_getStatus":return C.status;case"dispose":return this.disposeManualSyncTask(C)}}throw new Error("Invalid call")}getManualSyncTask(E){const g=this.manualSyncTasks.get(this.createKey(E));if(!g)throw new Error(`Manual sync taks not found: ${E}`);return g.manualSyncTask}async createManualSyncTask(){const E=new n.DisposableStore,g=E.add(await this.service.createManualSyncTask());return E.add(g.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:p}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:E}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(E){E.dispose();const g=this.createKey(E.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=R;class b extends n.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,p,f){return E.call(g,p,f).then(null,y=>{throw T.UserDataSyncError.toUserDataSyncError(y)})},listen(g,p){return E.listen(g,p)}},this.channel.call("_getInitialData").then(([g,p,f])=>{this.updateStatus(g),this.updateConflicts(p),f&&this.updateLastSyncTime(f),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([p,f])=>[p,T.UserDataSyncError.toUserDataSyncError(f)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:g,status:p}=await this.channel.call("createManualSyncTask"),f=this,y=new w(E,g,p,{async call(C,d,S){return f.channel.call(`manualSync/${C}`,[E,...(0,k.isArray)(d)?d:[d]],S)},listen(C,d){return L.Event.map(L.Event.filter(f.channel.listen(`manualSync/${C}`,d),S=>!y.isDiposed()&&S.manualSyncTaskId===E),S=>S.data)}});return y}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,g,p,f){return this.channel.call("accept",[E,g,p,f])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:f})=>({created:p,uri:_.URI.revive(f)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:f})=>({created:p,uri:_.URI.revive(f)}))}async getAssociatedResources(E,g){return(await this.channel.call("getAssociatedResources",[E,g])).map(({resource:f,comparableResource:y})=>({resource:_.URI.revive(f),comparableResource:_.URI.revive(y)}))}async getMachineId(E,g){return this.channel.call("getMachineId",[E,g])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([g,p])=>[g,p.map(f=>({...f,localResource:_.URI.revive(f.localResource),remoteResource:_.URI.revive(f.remoteResource),previewResource:_.URI.revive(f.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class w extends n.Disposable{constructor(E,g,p,f){super();this.id=E,this.manifest=g,this._disposed=!1,this._status=p;const y=this;this.channel={async call(C,d,S){try{const m=await f.call(C,d,S);return y.isDiposed()||(y._status=await f.call("_getStatus")),m}catch(m){throw T.UserDataSyncError.toUserDataSyncError(m)}},listen(C,d){return f.listen(C,d)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,g){const p=await this.channel.call("accept",[E,g]);return this.deserializePreviews(p)}async merge(E){const g=await this.channel.call("merge",[E]);return this.deserializePreviews(g)}async discard(E){const g=await this.channel.call("discard",[E]);return this.deserializePreviews(g)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([g,p])=>[g,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(f=>({...f,localResource:_.URI.revive(f.localResource),remoteResource:_.URI.revive(f.remoteResource),previewResource:_.URI.revive(f.previewResource),acceptedResource:_.URI.revive(f.acceptedResource)}))}])}}}),define(ne[238],ie([0,1,5,25,8,3,2,101,4,19,15,7,29,20,13,14,26,43,46,23,24]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends T.Disposable{constructor(O,N,$){super();this.productService=O,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new _.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(_.Event.filter($.onDidChangeValue,D=>D.key===l.SYNC_SERVICE_URL_TYPE&&D.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=b.isWeb&&O?.web?{...O,...O.web}:O;const $={...O||{},...N||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(D=>(0,P.isArray)($.authenticationProviders[D].scopes))){const D=$,M=!!D.canSwitch&&!N?.url,z=D.url===D.insidersUrl?"insiders":"stable",U=(M?this.userDataSyncStoreType:void 0)||z,V=N?.url||(U==="insiders"?D.insidersUrl:U==="stable"?D.stableUrl:D.url);return{url:E.URI.parse(V),type:U,defaultType:z,defaultUrl:E.URI.parse(D.url),stableUrl:E.URI.parse(D.stableUrl),insidersUrl:E.URI.parse(D.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(D.authenticationProviders).reduce((Y,B)=>(Y.push({id:B,scopes:D.authenticationProviders[B].scopes}),Y),[])}}}};o=de([Q(0,C.IProductService),Q(1,p.IConfigurationService),Q(2,m.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let c=class extends o{constructor(O,N,$){super(O,N,$);const D=this.storageService.get(u,0);D&&(this.previousConfigurationSyncStore=JSON.parse(D));const M=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(u,JSON.stringify(M),0,1):this.storageService.remove(u,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([Q(0,C.IProductService),Q(1,p.IConfigurationService),Q(2,m.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let h=class extends T.Disposable{constructor(O,N,$,D,M,z,U){super();this.requestService=$,this.logService=D,this.storageService=U,this._onTokenFailed=this._register(new _.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new _.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new _.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,S.getServiceMachineId)(M,z,U).then(V=>{const Y={"X-Client-Name":`${N.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(Y["X-Client-Commit"]=N.commit),Y}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,w.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",O),$={},D=await this.request(N.toString(),{type:"GET",headers:$},[],n.CancellationToken.None);return(await(0,d.asJson)(D)||[]).map(({url:z,created:U})=>({ref:(0,w.relativePath)(N,N.with({path:z})),created:U*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),D={};D["Cache-Control"]="no-cache";const M=await this.request($,{type:"GET",headers:D},[],n.CancellationToken.None);return await(0,d.asText)(M)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async read(O,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const M=await this.request(D,{type:"GET",headers:$},[304],n.CancellationToken.None);let z=null;if(M.res.statusCode===304&&(z=N),z===null){const U=M.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);const V=await(0,d.asText)(M);if(!V&&M.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",D,"EmptyResponse",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);z={ref:U,content:V}}return z}async write(O,N,$,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();D={...D},D["Content-Type"]=R.Mimes.text,$&&(D["If-Match"]=$);const z=await this.request(M,{type:"POST",data:N,headers:D},[],n.CancellationToken.None),U=z.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",z.res.statusCode,z.res.headers[l.HEADER_OPERATION_ID]);return U}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,w.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const D=await this.request($,{type:"GET",headers:N},[304],n.CancellationToken.None);let M=null;if(D.res.statusCode===304&&(M=O),!M){const U=D.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",D.res.statusCode,D.res.headers[l.HEADER_OPERATION_ID]);const V=await(0,d.asText)(D);if(!V&&D.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",$,"EmptyResponse",D.res.statusCode,D.res.headers[l.HEADER_OPERATION_ID]);V&&(M={...JSON.parse(V),ref:U})}const z=this.storageService.get(a,0);return z&&M&&z!==M.session&&this.clearSession(),M===null&&z&&this.clearSession(),M&&this.storageService.store(a,M.session,0,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(i,0)}async request(O,N,$,D){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;N.headers={...N.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let z;try{z=await this.session.request(O,N,D)}catch(B){if(!(B instanceof l.UserDataSyncStoreError)){let q="RequestFailed";const X=(0,k.getErrorMessage)(B).toLowerCase();X.includes("xhr timeout")?q="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?q="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":X.includes("headers must be an object")?q="RequestHeadersNotObject":(0,k.isPromiseCanceledError)(B)&&(q="RequestCanceled"),B=new l.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),B}const U=z.res.headers[l.HEADER_OPERATION_ID],V={url:O,status:z.res.statusCode,"execution-id":N.headers[l.HEADER_EXECUTION_ID],"operation-id":U},Y=(0,d.isSuccess)(z)||z.res.statusCode&&$.indexOf(z.res.statusCode)!==-1;if(Y?this.logService.trace("Request succeeded",V):this.logService.info("Request failed",V),z.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",z.res.statusCode,U);if(this._onTokenSucceed.fire(),z.res.statusCode===409)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",z.res.statusCode,U);if(z.res.statusCode===410)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",z.res.statusCode,U);if(z.res.statusCode===412)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",z.res.statusCode,U);if(z.res.statusCode===413)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",z.res.statusCode,U);if(z.res.statusCode===426)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",z.res.statusCode,U);if(z.res.statusCode===429){const B=z.res.headers["retry-after"];throw B?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(B)*1e3)),new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",z.res.statusCode,U)):new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",z.res.statusCode,U)}if(!Y)throw new l.UserDataSyncStoreError("Server returned "+z.res.statusCode,O,"Unknown",z.res.statusCode,U);return z}addSessionHeaders(O){let N=this.storageService.get(i,0);N===void 0&&(N=(0,g.generateUuid)(),this.storageService.store(i,N,0,1)),O["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(O["X-User-Session-Id"]=$)}};h=de([Q(1,C.IProductService),Q(2,d.IRequestService),Q(3,l.IUserDataSyncLogService),Q(4,f.IEnvironmentService),Q(5,y.IFileService),Q(6,m.IStorageService)],h),e.UserDataSyncStoreClient=h;let v=class extends h{constructor(O,N,$,D,M,z,U){super(O.userDataSyncStore?.url,N,$,D,M,z,U);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};v=de([Q(0,l.IUserDataSyncStoreManagementService),Q(1,C.IProductService),Q(2,d.IRequestService),Q(3,l.IUserDataSyncLogService),Q(4,f.IEnvironmentService),Q(5,y.IFileService),Q(6,m.IStorageService)],v),e.UserDataSyncStoreService=v;class I{constructor(O,N,$,D){this.limit=O,this.interval=N,this.requestService=$,this.logService=D,this.requests=[],this.startTime=void 0}request(O,N,$){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ne[239],ie([0,1,3,60,26,23,21,235,24,63,64]),function(J,e,L,n,k,_,T,R,b,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(p,f,y,C,d,S,m,l,u,r,a){super(p,f,y,C,d,m,l,u,r,a);this._register(L.Event.debounce(L.Event.any(L.Event.map(S.onDidFocusWindow,()=>"windowFocus"),L.Event.map(S.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};E=de([Q(0,k.IProductService),Q(1,b.IUserDataSyncStoreManagementService),Q(2,b.IUserDataSyncStoreService),Q(3,b.IUserDataSyncEnablementService),Q(4,b.IUserDataSyncService),Q(5,n.INativeHostService),Q(6,b.IUserDataSyncLogService),Q(7,w.IUserDataSyncAccountService),Q(8,T.ITelemetryService),Q(9,P.IUserDataSyncMachinesService),Q(10,_.IStorageService)],E),e.UserDataAutoSyncService=E}),define(ne[240],ie([0,1,5,3,2]),function(J,e,L,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends k.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>w()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ne[65],ie([0,1,50,5,9,15,22,124,252,253]),function(J,e,L,n,k,_,T,R,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let i=a.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=a}}e.ExtractError=P;function E(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,i)=>a+i,r&61440)}function g(u){if(u instanceof P)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new P(r,u)}function p(u,r,a,i,t,s){const o=k.dirname(r),c=k.join(i,o);if(!c.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const h=k.join(i,r);let v;return s.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((I,A)=>{if(!s.isCancellationRequested)try{v=(0,L.createWriteStream)(h,{mode:a}),v.once("close",()=>I()),v.once("error",A),u.once("error",A),u.pipe(v)}catch(O){A(O)}}))}function f(u,r,a,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{t.cancel(),u.close()}),new Promise((o,c)=>{const h=new n.Sequencer,v=I=>{I.isCancellationRequested||(s++,u.readEntry())};u.once("error",c),u.once("close",()=>t.then(()=>{i.isCancellationRequested||u.entryCount===s?o():c(new P("Incomplete",new Error(R.localize(1,null,s,u.entryCount))))},c)),u.readEntry(),u.on("entry",I=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){v(i);return}const A=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(A)){const $=k.join(r,A);t=(0,n.createCancelablePromise)(D=>T.Promises.mkdir($,{recursive:!0}).then(()=>v(D)).then(void 0,c));return}const O=C(u,I),N=E(I);t=(0,n.createCancelablePromise)($=>h.queue(()=>O.then(D=>p(D,A,N,r,a,$).then(()=>v($)))).then(null,c))})})}function y(u,r=!1){return new Promise((a,i)=>{(0,b.open)(u,r?{lazyEntries:!0}:void 0,(t,s)=>{t?i(g(t)):a((0,_.assertIsDefined)(s))})})}function C(u,r){return new Promise((a,i)=>{u.openReadStream(r,(t,s)=>{t?i(g(t)):a((0,_.assertIsDefined)(s))})})}function d(u,r){return new Promise((a,i)=>{const t=new w.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,L.createWriteStream)(u);t.outputStream.pipe(s),t.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>a(u))})}e.zip=d;function S(u,r,a={},i){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=y(u,!0);return a.overwrite&&(s=s.then(o=>T.Promises.rm(r).then(()=>o))),s.then(o=>f(o,r,{sourcePathRegex:t},i))}e.extract=S;function m(u,r){return y(u).then(a=>new Promise((i,t)=>{a.on("entry",s=>{s.fileName===r&&C(a,s).then(o=>i(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function l(u,r){return m(u,r).then(a=>new Promise((i,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=l}),define(ne[241],ie([0,1,65,133]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(_){return(0,L.buffer)(_,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(ne[242],ie([0,1,16,5,8,2,18,9,4,19,61,7,29,22,65,134,13,30,33,155,14,10,26]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends _.Disposable{constructor(t,s,o,c,h){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=c,this.productService=h,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new d.ExtensionManagementError(this.joinErrors(o).message,d.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new d.ExtensionManagementError(this.joinErrors(o).message,d.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,L.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(c=>!s[new S.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(o=(0,S.groupByExtension)(o,h=>h.identifier).map(h=>h.sort((v,I)=>P.rcompare(v.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,c){const h=t.key(),v=R.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),I=R.join(this.extensionsPath,h);try{await p.Promises.rm(I)}catch{try{await p.Promises.rm(I)}catch{}throw new d.ExtensionManagementError((0,y.localize)(0,null,I,t.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,v,c);let A=await this.scanExtension(E.URI.file(v),1);if(!A)throw new Error((0,y.localize)(1,null,v));await this.storeMetadata(A,{...o,installedTimestamp:Date.now()});try{await this.rename(t,v,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(O){try{await p.Promises.rm(v)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(O)}. Deleted from extracted location`,v),O}try{A=await this.scanExtension(E.URI.file(I),1)}catch{}if(A)return A;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),c=await p.Promises.readFile(o,"utf8"),{manifest:h}=await this.parseManifest(c);return h.__metadata=s,await p.Promises.writeFile(o,JSON.stringify(h,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new S.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(c=>o[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const o=(await this.scanExtensions(1)).find(c=>new S.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await p.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new S.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,c){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await p.Promises.rm(o)}catch(h){throw new d.ExtensionManagementError(this.joinErrors(h).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(s,o,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(h){try{await p.Promises.rm(o)}catch{}let v=d.ExtensionManagementErrorCode.Extract;throw h instanceof f.ExtractError&&(h.type==="CorruptZip"?v=d.ExtensionManagementErrorCode.CorruptZip:h.type==="Incomplete"&&(v=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(h.message,v)}}async rename(t,s,o,c){try{await p.Promises.rename(s,o)}catch(h){if(b.isWindows&&h&&h.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,c);throw new d.ExtensionManagementError(h.message||(0,y.localize)(3,null,s,o),h.code||d.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,c]=await Promise.all([t,s]);return[...o,...c]}async scanExtensionsInDir(t,s){const o=new n.Limiter(10),c=await this.fileService.resolve(E.URI.file(t));return c.children?(await Promise.all(c.children.filter(v=>v.isDirectory).map(v=>o.queue(async()=>s===1&&(0,w.basename)(v.resource).indexOf(".")===0?null:this.scanExtension(v.resource,s))))).filter(v=>v&&v.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:c,metadata:h}=await this.readManifest(t.fsPath),v=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,A={id:(0,S.getGalleryExtensionId)(c.publisher,c.name)},O={type:s,identifier:A,manifest:c,location:t,readmeUrl:v,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(O,h),O}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(c=>(0,S.areSameExtensions)(o.identifier,{id:c})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const v of s)t[new S.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]||o.add(v.identifier.id.toLowerCase());const c=(0,S.groupByExtension)(s,v=>v.identifier);await n.Promises.settled(c.map(async v=>{const I=v.sort((A,O)=>P.rcompare(A.manifest.version,O.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const h=s.filter(v=>t[new S.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]);await n.Promises.settled(h.map(v=>this.removeUninstalledExtension(v)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,S.groupByExtension)(t,c=>c.identifier);s.push(...(0,L.flatten)(o.map(c=>c.sort((h,v)=>P.rcompare(h.manifest.version,v.manifest.version)).slice(1)))),await n.Promises.settled(s.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(T.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[p.Promises.readFile(R.join(t,"package.json"),"utf8").then(v=>this.parseManifest(v)),p.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,v=>v.code!=="ENOENT"?Promise.reject(v):"{}").then(v=>JSON.parse(v))],[{manifest:o,metadata:c},h]=await Promise.all(s);return{manifest:(0,m.localizeManifest)(o,h),metadata:c}}parseManifest(t){return new Promise((s,o)=>{try{const c=JSON.parse(t),h=c.__metadata||null;s({manifest:c,metadata:h})}catch{o(new Error((0,y.localize)(4,null)))}})}};a=de([Q(1,l.IFileService),Q(2,u.ILogService),Q(3,C.INativeEnvironmentService),Q(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ne[243],ie([0,1,37,8,18,9,4,31,19,61,7,29,22,65,132,79,13,204,30,33,187,174,241,188,242,218,76,14,6,10,26,21,34]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u,r,a,i,t,s,o,c,h,v,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends d.AbstractExtensionManagementService{constructor(U,V,Y,B,q,X,G,ee,K){super(U,V,Y,ee);this.environmentService=B,this.downloadService=q,this.fileService=G;const F=this._register(X.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(i.ExtensionsScanner,H=>F.postUninstall(H))),this.manifestCache=this._register(new a.ExtensionsManifestCache(B,this)),this.extensionsDownloader=this._register(X.createInstance(l.ExtensionsDownloader));const j=this._register(new t.ExtensionsWatcher(this,G,B,Y,K));this._register(j.onDidChangeExtensionsByAnotherSource(({added:H,removed:W})=>{H.length&&this._onDidInstallExtensions.fire(H.map(x=>({identifier:x.identifier,operation:1,local:x}))),W.forEach(x=>this._onDidUninstallExtension.fire({identifier:x}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),V=(0,S.getTargetPlatform)(U?"alpine":T.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",V),V})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let U;try{U=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(Y){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(Y))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const V=await this.collectFiles(U),Y=await(0,p.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,V);return P.URI.file(Y)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const V=await this.downloadVsix(U),Y=_.resolve(V.fsPath);return(0,r.getManifest)(Y)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,V={}){this.logService.trace("ExtensionManagementService#install",U.toString());const Y=await this.downloadVsix(U),B=await(0,r.getManifest)(_.resolve(Y.fsPath));if(B.engines&&B.engines.vscode&&!(0,s.isEngineValid)(B.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,m.getGalleryExtensionId)(B.publisher,B.name),this.productService.version));return this.installExtension(B,Y,V)}async updateMetadata(U,V){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const Y={...U.manifest.__metadata||{},...V};return V.isPreReleaseVersion&&(Y.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,Y),this.manifestCache.invalidate(),U}async updateExtensionScope(U,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:V}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===k.Schemas.file)return U;const V=(0,b.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,V),V}createInstallExtensionTask(U,V,Y){return P.URI.isUri(V)?new D(U,V,Y,this.galleryService,this.extensionsScanner,this.logService):new $(V,Y,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,V){return new M(U,V,this.extensionsScanner)}async collectFiles(U){const V=async B=>{let q=await g.Promises.readdir(B);q=q.map(ee=>_.join(B,ee));const X=await Promise.all(q.map(ee=>g.Promises.stat(ee)));let G=Promise.resolve([]);return X.forEach((ee,K)=>{const F=q[K];ee.isFile()&&(G=G.then(j=>[...j,F])),ee.isDirectory()&&(G=G.then(j=>V(F).then(H=>[...j,...H])))}),G};return(await V(U.location.fsPath)).map(B=>({path:`extension/${_.relative(U.location.fsPath,B)}`,localPath:B}))}};O=de([Q(0,S.IExtensionGalleryService),Q(1,I.ITelemetryService),Q(2,h.ILogService),Q(3,C.INativeEnvironmentService),Q(4,y.IDownloadService),Q(5,c.IInstantiationService),Q(6,o.IFileService),Q(7,v.IProductService),Q(8,A.IUriIdentityService)],O),e.ExtensionManagementService=O;class N extends d.AbstractExtensionTask{constructor(U,V,Y,B){super();this.identifier=U,this.source=V,this.extensionsScanner=Y,this.logService=B,this._operation=2}get operation(){return this._operation}async installExtension(U,V){try{const Y=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(Y)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(Y,{...Y.manifest.__metadata||{},...U.metadata}):Y}catch{throw T.isMacintosh?new S.ExtensionManagementError(f.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(f.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(U,V)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const Y=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),Y}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:V,metadata:Y},B){let q=await this.extensionsScanner.extractUserExtension(V,U,Y,B);return this.logService.info("Extracting completed.",V.id),q}}class $ extends N{constructor(U,V,Y,B,q){super(U.identifier,U,B,q);this.gallery=U,this.options=V,this.extensionsDownloader=Y}async doRun(U){const Y=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,m.areSameExtensions)(q.identifier,this.gallery.identifier));Y&&(this._operation=3);const B=await this.downloadInstallableExtension(this.gallery,this._operation);B.metadata.isMachineScoped=this.options.isMachineScoped||Y?.isMachineScoped,B.metadata.isBuiltin=this.options.isBuiltin||Y?.isBuiltin,B.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,B.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:Y?.preRelease;try{const q=await this.installExtension(B,U);return Y&&w.neq(Y.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(Y),q}catch(q){throw await this.deleteDownloadedVSIX(B.zipPath),q}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(P.URI.file(U))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,n.getErrorMessage)(V))}}async downloadInstallableExtension(U,V){const Y={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let B;try{this.logService.trace("Started downloading extension:",U.identifier.id),B=(await this.extensionsDownloader.downloadExtension(U,V)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,B)}catch(q){throw new S.ExtensionManagementError((0,d.joinErrors)(q).message,S.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(B);return{zipPath:B,identifierWithVersion:new m.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:Y}}catch(q){throw await this.deleteDownloadedVSIX(B),new S.ExtensionManagementError((0,d.joinErrors)(q).message,S.ExtensionManagementErrorCode.Invalid)}}}class D extends N{constructor(U,V,Y,B,q,X){super({id:(0,m.getGalleryExtensionId)(U.publisher,U.name)},V,q,X);this.manifest=U,this.location=V,this.options=Y,this.galleryService=B}async doRun(U){const V=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),B=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,m.areSameExtensions)(this.identifier,X.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(q.isMachineScoped=this.options.isMachineScoped||B?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||B?.isBuiltin,B)if(this._operation=3,V.equals(new m.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version)))try{await this.extensionsScanner.removeExtension(B,"existing")}catch{throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else w.gt(B.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(B);else{const X=await this.unsetUninstalledAndGetLocal(V);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:_.resolve(this.location.fsPath),identifierWithVersion:V,metadata:q},U)}async getMetadata(U,V,Y){try{let[B]=await this.galleryService.getExtensions([{id:U,version:V}],Y);if(B||([B]=await this.galleryService.getExtensions([{id:U}],Y)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion}}catch{}return{}}}class M extends d.AbstractExtensionTask{constructor(U,V,Y){super();this.extension=U,this.options=V,this.extensionsScanner=Y}async doRun(U){const V=[],Y=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const B=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);V.push(...Y.filter(q=>B.equals(new m.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else V.push(...Y.filter(B=>(0,m.areSameExtensions)(B.identifier,this.extension.identifier)));if(!V.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const B of V)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(B)}catch(q){throw new Error(f.localize(6,null,(0,L.toErrorMessage)(q)))}}}}),define(ne[244],ie([0,1,81,55,32,17,8,3,2,9,4,29,36,71,254]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(I,A=""){this.debugLabel=A,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,T.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,A){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,A)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const A=O=>{this.traceSocketEvent("read",O),I(_.VSBuffer.wrap(O))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(I){const A=O=>{this.traceSocketEvent("close",{hadError:O}),I({type:0,hadError:O,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(I){const A=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,T.onUnexpectedError)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=y;var C;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(C||(C={}));var d;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(d||(d={}));class S extends b.Disposable{constructor(I,A,O,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:O?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new m(this,A,O,N,this._onData,($,D)=>this._write($,D))),this._register(this._flowManager.onError($=>{console.error($),(0,T.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,A){this.socket.traceSocketEvent(I,A)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,A){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let O=2;I.byteLength<126?O+=0:I.byteLength<2**16?O+=2:O+=8;const N=_.VSBuffer.alloc(O);if(A?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this.socket.write(_.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),O=A.readUInt8(0),N=(O&128)>>>7,$=(O&64)>>>6,D=A.readUInt8(1),M=(D&128)>>>7,z=D&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(z===126?2:0)+(z===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),O=A.readUInt8(1),N=(O&128)>>>7;let $=O&127,D=1;$===126?$=A.readUInt8(++D)*2**8+A.readUInt8(++D):$===127&&($=A.readUInt8(++D)*0+A.readUInt8(++D)*0+A.readUInt8(++D)*0+A.readUInt8(++D)*0+A.readUInt8(++D)*2**24+A.readUInt8(++D)*2**16+A.readUInt8(++D)*2**8+A.readUInt8(++D));let M=0;N&&(M=A.readUInt8(++D)*2**24+A.readUInt8(++D)*2**16+A.readUInt8(++D)*2**8+A.readUInt8(++D)),this._state.state=3,this._state.readLen=$,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),r(A,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(A,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class m extends b.Disposable{constructor(I,A,O,N,$,D){super();this._tracer=I,this._onData=$,this._writeFn=D,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,A?(this._zlibInflateStream=this._register(new l(this._tracer,N,O,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const A=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(A,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,A){return new Promise((O,N)=>{I.write(A),I.flush($=>O($))})}acceptFrame(I,A,O){this._readQueue.push({data:I,isCompressed:A,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const A=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(A)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,A,O){return new Promise((N,$)=>{I.write(A),O&&I.write(_.VSBuffer.fromByteArray([0,0,255,255])),I.flush(D=>N(D))})}}class l extends b.Disposable{constructor(I,A,O,N){super();this._tracer=I,this._recordInflateBytes=A,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=f.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(_.VSBuffer.wrap($))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const A=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(A)})}}class u extends b.Disposable{constructor(I,A){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(_.VSBuffer.wrap(O))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let A=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.byteLength-4),I(A)})}}function r(v,I){if(I===0)return;let A=v.byteLength>>>2;for(let z=0;z<A;z++){const U=v.readUInt32BE(z*4);v.writeUInt32BE(U^I,z*4)}let O=A*4,N=v.byteLength-O;const $=I>>>24&255,D=I>>>16&255,M=I>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(O)^$,O),N>=2&&v.writeUInt8(v.readUInt8(O+1)^D,O+1),N>=3&&v.writeUInt8(v.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const v=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):I=(0,w.join)((0,k.tmpdir)(),`vscode-ipc-${v}.sock`),s(I),I}e.createRandomIPCHandle=i;function t(v,I,A){const O=(0,L.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${A}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${A}-${I}.sock`):N=(0,w.join)(v,`${A}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(v){const I=a[P.platform];typeof I=="number"&&v.length>=I&&console.warn(`WARNING: IPC handle "${v}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends g.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const A=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(A,O=>({protocol:new p.Protocol(new y(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(v){return new Promise((I,A)=>{const O=(0,n.createServer)();O.on("error",A),O.listen(v,()=>{O.removeListener("error",A),I(new o(O))})})}e.serve=c;function h(v,I){return new Promise((A,O)=>{const N=(0,n.createConnection)(v,()=>{N.removeListener("error",O),A(p.Client.fromSocket(new y(N,`ipc-client${I}`),I))});N.once("error",O)})}e.connect=h}),define(ne[245],ie([0,1,55,244]),function(J,e,L,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,_,T,R,b){const w=E=>b(E,void 0),P=L.createConnection({host:k,port:_},()=>{P.removeListener("error",w);const E=Buffer.alloc(16);for(let y=0;y<16;y++)E[y]=Math.round(Math.random()*256);const g=E.toString("base64"),p=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${_}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];P.write(p.join(`\r
`)+`\r
\r
`);const f=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",f),b(void 0,new n.NodeSocket(P,R)))};P.on("data",f)});P.setNoDelay(!0),P.once("error",w)}}}),define(ne[246],ie([0,1,55,115,245,5,2,20,10,26,185,62,90]),function(J,e,L,n,k,_,T,R,b,w,P,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(S,m,l,u,r){let a;for(let i=3;i&&(a&&a.dispose(),a=await new f(S,m,l,u,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));i--);return a}class f extends T.Disposable{constructor(m,l,u,r,a){super();this.defaultTunnelHost=l,this.suggestedLocalPort=a,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){let m=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(m){m.pause();const l=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,P.connectRemoteAgentTunnel)(this._options,l,this.tunnelRemotePort),r=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&m.write(a.buffer),m.on("end",()=>{this._socketsDispose.delete(m.localAddress),r.end()}),m.on("close",()=>r.end()),m.on("error",()=>{this._socketsDispose.delete(m.localAddress),r.destroy()}),r.on("end",()=>m.end()),r.on("close",()=>m.end()),r.on("error",()=>{m.destroy()}),m.pipe(r),r.pipe(m),this._socketsDispose.set(m.localAddress,()=>{m.end(),r.end()})}}let y=class extends E.AbstractTunnelService{constructor(m,l,u,r,a){super(l);this.socketFactory=m,this.signService=u,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,l,u,r,a,i,t){const s=this.getTunnelFromMap(l,u);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,u,r,a,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${u} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},c=p(o,this.defaultTunnelHost,l,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,u,c),c}}};y=de([Q(1,b.ILogService),Q(2,g.ISignService),Q(3,w.IProductService),Q(4,R.IConfigurationService)],y),e.BaseTunnelService=y;let C=class extends y{constructor(m,l,u,r){super(k.nodeSocketFactory,m,l,u,r)}};C=de([Q(0,b.ILogService),Q(1,g.ISignService),Q(2,w.IProductService),Q(3,R.IConfigurationService)],C),e.TunnelService=C;let d=class extends T.Disposable{constructor(m,l,u,r){super();this.logService=m,this.productService=l,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(m,l,u,r,a,i,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${a}.`),!this._tunnelServices.has(m)){const o=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(m,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(l,u,r,a,i,t,s)}};d=de([Q(0,b.ILogService),Q(1,w.IProductService),Q(2,g.ISignService),Q(3,R.IConfigurationService)],d),e.SharedTunnelsService=d}),define(ne[255],ie([0,1,72,32,37,8,2,18,19,7,36,118,179,160,180,171,172,173,158,162,20,183,78,203,79,193,13,197,199,207,30,161,205,243,80,156,14,176,178,51,6,168,83,169,170,59,189,10,84,60,85,26,192,43,23,201,202,21,91,92,93,44,208,209,94,211,217,96,97,24,63,231,233,234,64,232,236,237,238,239,240,90,198,62,246,190,191,89,196,206,34,219,4,220,165,182,181]),function(J,e,L,n,k,_,T,R,b,w,P,E,g,p,f,y,C,d,S,m,l,u,r,a,i,t,s,o,c,h,v,I,A,O,N,$,D,M,z,U,V,Y,B,q,X,G,ee,K,F,j,H,W,x,re,se,ce,he,Se,ge,ye,pe,Ie,Ee,De,Fe,Ue,Ne,ze,te,ae,ue,be,Ce,$e,Le,Oe,Ae,Z,oe,le,fe,me,Te,we,Re,ke,Pe,_e,We,Be,xe,Rt,Dt,kt,St,Tt,yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends T.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Me="vscode:electron-main->shared-process=disposeWorker",je=(Ye,qe)=>this.onDisposeWorker(qe);L.ipcRenderer.on(Me,je),this._register((0,T.toDisposable)(()=>L.ipcRenderer.removeListener(Me,je)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Me=>{const je=Me.get(K.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ve.createInstance(g.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(f.LanguagePackCachedDataCleaner),ve.createInstance(d.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(C.LogsDataCleaner),ve.createInstance(y.LocalizationsUpdater),ve.createInstance(p.ExtensionsCleaner)))}async initServices(){const ve=new B.ServiceCollection,Me={_serviceBrand:void 0,...H.default};ve.set(W.IProductService,Me);const je=new P.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,je);ve.set(X.IMainProcessService,Ye);const qe=new o.SharedProcessEnvironmentService(this.configuration.args,Me);ve.set(s.INativeEnvironmentService,qe);const rt=new F.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Qe=new F.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ye.getChannel("logger"));ve.set(K.ILoggerService,Qe);const at=this._register(new K.MultiplexLogService([this._register(new K.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,b.joinPath)(w.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new F.FollowerLogService(rt,at));ve.set(K.ILogService,Je),this.sharedProcessWorkerService=new We.SharedProcessWorkerService(Je,Me,qe),ve.set(_e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new M.FileService(Je));ve.set(D.IFileService,Ve);const ct=this._register(new z.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,ct);const lt=this._register(new kt.FileUserDataProvider(R.Schemas.file,this._register(new St.DiskFileSystemProviderClient(Ye.getChannel(St.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Dt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,lt);const He=this._register(new u.ConfigurationService(qe.settingsResource,Ve));ve.set(l.IConfigurationService,He);const tt=new ce.NativeStorageService(void 0,Ye,qe);ve.set(se.IStorageService,tt),this._register((0,T.toDisposable)(()=>tt.flush())),await Promise.all([He.initialize(),tt.initialize()]),ve.set(xe.IUriIdentityService,new Rt.UriIdentityService(Ve)),ve.set(re.IRequestService,new U.SyncDescriptor(x.RequestService)),ve.set(S.IChecksumService,new U.SyncDescriptor(m.ChecksumService)),ve.set(yt.IV8InspectProfilingService,new U.SyncDescriptor(Tt.InspectProfilingService));const st=P.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(j.INativeHostService,st),ve.set(i.IDownloadService,new U.SyncDescriptor(t.DownloadService));const ut=this._register(new fe.ActiveWindowManager(st)),ht=new P.StaticRouter(Ge=>ut.getActiveClientId().then(ft=>Ge===ft));ve.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));const dt=new Be.AssignmentService(this.configuration.machineId,He,Me);let nt;const Ze=[];if((0,Ie.supportsTelemetry)(Me,qe)){const Ge=new ye.TelemetryLogAppender(Qe,qe);Ze.push(Ge);const{appRoot:ft,extensionsPath:Ot,installSourcePath:Mt}=qe;if(Me.aiConfig&&Me.aiConfig.asimovKey){const ot=await dt.getTreatment("telemetryMigration")??!1,gt=Me.quality!=="stable";if(gt&&ot){const Ct=new Ee.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ot,!0);this._register((0,T.toDisposable)(()=>Ct.flush())),Ze.push(Ct)}const bt=new Ee.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,gt?!1:ot,ot&&gt);this._register((0,T.toDisposable)(()=>bt.flush())),Ze.push(bt)}nt=new pe.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Mt),sendErrorTelemetry:!0,piiPaths:[ft,Ot]},He)}else{nt=Ie.NullTelemetryService;const Ge=Ie.NullAppender;Ze.push(Ge)}this.server.registerChannel("telemetryAppender",new ge.TelemetryAppenderChannel(Ze)),ve.set(Se.ITelemetryService,nt);const At=new De.CustomEndpointTelemetryService(He,nt,Qe,qe);ve.set(Se.ICustomEndpointTelemetryService,At),ve.set(v.IExtensionManagementService,new U.SyncDescriptor(O.ExtensionManagementService)),ve.set(v.IExtensionGalleryService,new U.SyncDescriptor(h.ExtensionGalleryService)),ve.set(v.IExtensionTipsService,new U.SyncDescriptor(A.ExtensionTipsService)),ve.set(G.ILocalizationsService,new U.SyncDescriptor(ee.LocalizationsService)),ve.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),ve.set(ue.IUserDataSyncAccountService,new U.SyncDescriptor(ue.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new U.SyncDescriptor($e.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),ve.set(v.IGlobalExtensionEnablementService,new U.SyncDescriptor(c.GlobalExtensionEnablementService)),ve.set(te.IIgnoredExtensionsManagementService,new U.SyncDescriptor(te.IgnoredExtensionsManagementService)),ve.set(ze.IExtensionsStorageSyncService,new U.SyncDescriptor(ze.ExtensionsStorageSyncService)),ve.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(oe.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(oe.UserDataSyncStoreService)),ve.set(Le.IUserDataSyncMachinesService,new U.SyncDescriptor(Le.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Oe.UserDataSyncEnablementService)),ve.set(ae.IUserDataSyncService,new U.SyncDescriptor(Ae.UserDataSyncService));const Et=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,qe,Je,nt);return await Et.initialize(),ve.set(Ue.ILocalPtyService,this._register(Et)),ve.set(me.ISignService,new U.SyncDescriptor(Te.SignService)),ve.set(we.ISharedTunnelsService,new U.SyncDescriptor(Re.SharedTunnelsService)),ve.set(ke.ISharedProcessTunnelService,new U.SyncDescriptor(Pe.SharedProcessTunnelService)),new Y.InstantiationService(ve)}initChannels(ve){const Me=new I.ExtensionManagementChannel(ve.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const je=P.ProxyChannel.fromService(ve.get(G.ILocalizationsService));this.server.registerChannel("localizations",je);const Ye=P.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const qe=new I.ExtensionTipsChannel(ve.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const rt=P.ProxyChannel.fromService(ve.get(S.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=P.ProxyChannel.fromService(ve.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Qe);const at=new Ce.UserDataSyncMachinesServiceChannel(ve.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",at);const Je=P.ProxyChannel.fromService(ve.get(Se.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(ve.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const ct=new Ce.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ct);const lt=new Z.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(K.ILogService));this.server.registerChannel("userDataSync",lt);const He=this._register(ve.get(V.IInstantiationService).createInstance(le.UserDataAutoSyncService)),tt=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",tt);const st=ve.get(Ue.ILocalPtyService),ut=P.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,ut);const ht=P.ProxyChannel.fromService(ve.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ht);const dt=P.ProxyChannel.fromService(ve.get(_e.ISharedProcessWorkerService));this.server.registerChannel(_e.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,_.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,_.setUnexpectedErrorHandler)(Me=>{const je=(0,k.toErrorMessage)(Me,!0);!je||ve.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function _t(wt){const ve=new Lt(wt);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=_t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a06afb22ce06dbd4f01d3bb5bf946e08bff55180/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
