/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ee=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/errors","vs/base/common/resources","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/node/pfs","vs/base/common/strings","os","vs/base/common/extpath","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/labels","vs/base/common/process","vs/base/common/map","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","child_process","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/url/common/url","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],te=function(G){for(var e=[],v=0,n=G.length;v<n;v++)e[v]=ee[G[v]];return e};define(ee[102],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(n,D){if(!n)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(ee[103],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function v(k){return k?k.replace(/\$\((.*?)\)/g,(P,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=v;class n{constructor(P,f,m){this.id=P,this.definition=f,this.description=m,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(k,P){const f=["codicon","codicon-"+k];return P&&f.push("codicon-modifier-"+P),f}e.getClassNamesArray=D;var C;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function f(I){if(I instanceof n)return["codicon","codicon-"+I.id];const p=P.exec(I.id);if(!p)return f(n.error);let[,S,t]=p;const g=["codicon","codicon-"+S];return t&&g.push("codicon-modifier-"+t.substr(1)),g}k.asClassNameArray=f;function m(I){return f(I).join(" ")}k.asClassName=m;function E(I){return"."+f(I).join(".")}k.asCSSSelector=E})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ee[46],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(k){return(P,f,m)=>{let E=null,I=null;if(typeof m.value=="function"?(E="value",I=m.value):typeof m.get=="function"&&(E="get",I=m.get),!I)throw new Error("not supported");m[E]=k(I,f)}}e.createDecorator=v;function n(k,P,f){let m=null,E=null;if(typeof f.value=="function"?(m="value",E=f.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(m="get",E=f.get),!E)throw new Error("not supported");const I=`$memoize$${P}`;f[m]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,p)}),this[I]}}e.memoize=n;function D(k,P,f){return v((m,E)=>{const I=`$debounce$${E}`,p=`$debounce$result$${E}`;return function(...S){this[p]||(this[p]=f?f():void 0),clearTimeout(this[I]),P&&(this[p]=P(this[p],...S),S=[this[p]]),this[I]=setTimeout(()=>{m.apply(this,S),this[p]=f?f():void 0},k)}})}e.debounce=D;function C(k,P,f){return v((m,E)=>{const I=`$throttle$timer$${E}`,p=`$throttle$result$${E}`,S=`$throttle$lastRun$${E}`,t=`$throttle$pending$${E}`;return function(...g){if(this[p]||(this[p]=f?f():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),P&&(this[p]=P(this[p],...g)),this[t])return;const y=this[S]+k;y<=Date.now()?(this[S]=Date.now(),m.apply(this,[this[p]]),this[p]=f?f():void 0):(this[t]=!0,this[I]=setTimeout(()=>{this[t]=!1,this[S]=Date.now(),m.apply(this,[this[p]]),this[p]=f?f():void 0},y-Date.now()))}})}e.throttle=C}),define(ee[15],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(o){setTimeout(()=>{throw o.stack?new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.listeners.push(o),()=>{this._removeListener(o)}}emit(o){this.listeners.forEach(h=>{h(o)})}_removeListener(o){this.listeners.splice(this.listeners.indexOf(o),1)}setUnexpectedErrorHandler(o){this.unexpectedErrorHandler=o}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(o){this.unexpectedErrorHandler(o),this.emit(o)}onUnexpectedExternalError(o){this.unexpectedErrorHandler(o)}}e.ErrorHandler=v,e.errorHandler=new v;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function D(l){f(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function C(l){f(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=C;function k(l){if(l instanceof Error){let{name:o,message:h}=l;const s=l.stacktrace||l.stack;return{$isError:!0,name:o,message:h,stack:s}}return l}e.transformErrorForSerialization=k;const P="Canceled";function f(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=f;class m extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=m;function E(){const l=new Error(P);return l.name=l.message,l}e.canceled=E;function I(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=I;function p(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=p;function S(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function t(l){const o=new Error(`${l} has been disposed`);return o.name="DISPOSED",o}e.disposed=t;function g(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=g;class y extends Error{constructor(o){super("NotImplemented");o&&(this.message=o)}}e.NotImplementedError=y;class w extends Error{constructor(o){super("NotSupported");o&&(this.message=o)}}e.NotSupportedError=w;class M extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=M;function c(l){const o=l;return o instanceof Error&&Array.isArray(o.actions)}e.isErrorWithActions=c;function a(l,o=Object.create(null)){const h=new Error(l);return o.actions&&(h.actions=o.actions),h}e.createErrorWithActions=a}),define(ee[31],te([0,1,15]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(A,_=0){return A[A.length-(1+_)]}e.tail=n;function D(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=D;function C(A,_,N=(O,z)=>O===z){if(A===_)return!0;if(!A||!_||A.length!==_.length)return!1;for(let O=0,z=A.length;O<z;O++)if(!N(A[O],_[O]))return!1;return!0}e.equals=C;function k(A,_,N){let O=0,z=A.length-1;for(;O<=z;){const x=(O+z)/2|0,ie=N(A[x],_);if(ie<0)O=x+1;else if(ie>0)z=x-1;else return x}return-(O+1)}e.binarySearch=k;function P(A,_){let N=0,O=A.length;if(O===0)return 0;for(;N<O;){const z=Math.floor((N+O)/2);_(A[z])?O=z:N=z+1}return N}e.findFirstInSorted=P;function f(A,_,N){if(A=A|0,A>=_.length)throw new TypeError("invalid index");let O=_[Math.floor(_.length*Math.random())],z=[],x=[],ie=[];for(let oe of _){const Z=N(oe,O);Z<0?z.push(oe):Z>0?x.push(oe):ie.push(oe)}return A<z.length?f(A,z,N):A<z.length+ie.length?ie[0]:f(A-(z.length+ie.length),x,N)}e.quickSelect=f;function m(A,_){const N=[];let O;for(const z of A.slice(0).sort(_))!O||_(O[0],z)!==0?(O=[z],N.push(O)):O.push(z);return N}e.groupBy=m;function E(A,_,N){const O=[];function z(oe,Z,ce){if(Z===0&&ce.length===0)return;const le=O[O.length-1];le&&le.start+le.deleteCount===oe?(le.deleteCount+=Z,le.toInsert.push(...ce)):O.push({start:oe,deleteCount:Z,toInsert:ce})}let x=0,ie=0;for(;;){if(x===A.length){z(x,0,_.slice(ie));break}if(ie===_.length){z(x,A.length-x,[]);break}const oe=A[x],Z=_[ie],ce=N(oe,Z);ce===0?(x+=1,ie+=1):ce<0?(z(x,1,[]),x+=1):ce>0&&(z(x,0,[Z]),ie+=1)}return O}e.sortedDiff=E;function I(A,_,N){const O=E(A,_,N),z=[],x=[];for(const ie of O)z.push(...A.slice(ie.start,ie.start+ie.deleteCount)),x.push(...ie.toInsert);return{removed:z,added:x}}e.delta=I;function p(A,_,N){if(N===0)return[];const O=A.slice(0,N).sort(_);return t(A,_,O,N,A.length),O}e.top=p;function S(A,_,N,O,z){return N===0?Promise.resolve([]):new Promise((x,ie)=>{(async()=>{const oe=A.length,Z=A.slice(0,N).sort(_);for(let ce=N,le=Math.min(N+O,oe);ce<oe;ce=le,le=Math.min(le+O,oe)){if(ce>N&&await new Promise(he=>setTimeout(he)),z&&z.isCancellationRequested)throw(0,v.canceled)();t(A,_,Z,ce,le)}return Z})().then(x,ie)})}e.topAsync=S;function t(A,_,N,O,z){for(const x=N.length;O<z;O++){const ie=A[O];if(_(ie,N[x-1])<0){N.pop();const oe=P(N,Z=>_(ie,Z)<0);N.splice(oe,0,ie)}}}function g(A){return A.filter(_=>!!_)}e.coalesce=g;function y(A){let _=0;for(let N=0;N<A.length;N++)A[N]&&(A[_]=A[N],_+=1);A.length=_}e.coalesceInPlace=y;function w(A,_,N){A.splice(N,0,A.splice(_,1)[0])}e.move=w;function M(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=M;function c(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=c;function a(A,_=N=>N){const N=new Set;return A.filter(O=>{const z=_(O);return N.has(z)?!1:(N.add(z),!0)})}e.distinct=a;function l(A){const _=new Set;return N=>{const O=A(N);return _.has(O)?!1:(_.add(O),!0)}}e.uniqueFilter=l;function o(A,_){const N=h(A,_);if(N!==-1)return A[N]}e.findLast=o;function h(A,_){for(let N=A.length-1;N>=0;N--){const O=A[N];if(_(O))return N}return-1}e.lastIndex=h;function s(A,_){return A.length>0?A[0]:_}e.firstOrDefault=s;function i(A,_,N=(O,z)=>O===z){let O=0;for(let z=0,x=Math.min(A.length,_.length);z<x&&N(A[z],_[z]);z++)O++;return O}e.commonPrefixLength=i;function r(A){return[].concat(...A)}e.flatten=r;function u(A,_){let N=typeof _=="number"?A:0;typeof _=="number"?N=A:(N=0,_=A);const O=[];if(N<=_)for(let z=N;z<_;z++)O.push(z);else for(let z=N;z>_;z--)O.push(z);return O}e.range=u;function d(A,_,N){return A.reduce((O,z)=>(O[_(z)]=N?N(z):z,O),Object.create(null))}e.index=d;function b(A,_){return A.push(_),()=>L(A,_)}e.insert=b;function L(A,_){const N=A.indexOf(_);if(N>-1)return A.splice(N,1),_}e.remove=L;function R(A,_,N){const O=A.slice(0,_),z=A.slice(_);return O.concat(N,z)}e.arrayInsert=R;function T(A,_){let N;if(typeof _=="number"){let O=_;N=()=>{const z=Math.sin(O++)*179426549;return z-Math.floor(z)}}else N=Math.random;for(let O=A.length-1;O>0;O-=1){const z=Math.floor(N()*(O+1)),x=A[O];A[O]=A[z],A[z]=x}}e.shuffle=T;function U(A,_){const N=A.indexOf(_);N>-1&&(A.splice(N,1),A.unshift(_))}e.pushToStart=U;function Q(A,_){const N=A.indexOf(_);N>-1&&(A.splice(N,1),A.push(_))}e.pushToEnd=Q;function se(A,_){return Array.isArray(A)?A.map(_):_(A)}e.mapArrayOrNot=se;function ne(A){return Array.isArray(A)?A:[A]}e.asArray=ne;function V(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=V;function J(A,_){for(const N of A){const O=_(N);if(O!==void 0)return O}}e.mapFind=J;function q(A,_,N){const O=j(A,_),z=A.length,x=N.length;A.length=z+x;for(let ie=z-1;ie>=O;ie--)A[ie+x]=A[ie];for(let ie=0;ie<x;ie++)A[ie+O]=N[ie]}e.insertInto=q;function K(A,_,N,O){const z=j(A,_),x=A.splice(z,N);return q(A,z,O),x}e.splice=K;function j(A,_){return _<0?Math.max(_+A.length,0):Math.min(_,A.length)}function B(A,_){return(N,O)=>_(A(N),A(O))}e.compareBy=B;const $=(A,_)=>A-_;e.numberComparator=$;function Y(A,_){if(A.length===0)return;let N=A[0];for(let O=1;O<A.length;O++){const z=A[O];_(z,N)>0&&(N=z)}return N}e.findMaxBy=Y;function H(A,_){if(A.length===0)return;let N=A[0];for(let O=1;O<A.length;O++){const z=A[O];_(z,N)>=0&&(N=z)}return N}e.findLastMaxBy=H;function F(A,_){return Y(A,(N,O)=>-_(N,O))}e.findMinBy=F;class W{constructor(_){this.items=_,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(_){let N=this.firstIdx;for(;N<this.items.length&&_(this.items[N]);)N++;const O=N===this.firstIdx?null:this.items.slice(this.firstIdx,N);return this.firstIdx=N,O}takeFromEndWhile(_){let N=this.lastIdx;for(;N>=0&&_(this.items[N]);)N--;const O=N===this.lastIdx?null:this.items.slice(N+1,this.lastIdx+1);return this.lastIdx=N,O}peek(){return this.items[this.firstIdx]}dequeue(){const _=this.items[this.firstIdx];return this.firstIdx++,_}takeCount(_){const N=this.items.slice(this.firstIdx,this.firstIdx+_);return this.firstIdx+=_,N}}e.ArrayQueue=W}),define(ee[42],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(n){const D=this;let C=!1,k;return function(){return C||(C=!0,k=n.apply(D,arguments)),k}}e.once=v}),define(ee[69],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(n){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=D;const C=Object.freeze([]);function k(){return C}n.empty=k;function*P(l){yield l}n.single=P;function f(l){return l||C}n.from=f;function m(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=m;function E(l){return l[Symbol.iterator]().next().value}n.first=E;function I(l,o){for(const h of l)if(o(h))return!0;return!1}n.some=I;function p(l,o){for(const h of l)if(o(h))return h}n.find=p;function*S(l,o){for(const h of l)o(h)&&(yield h)}n.filter=S;function*t(l,o){let h=0;for(const s of l)yield o(s,h++)}n.map=t;function*g(...l){for(const o of l)for(const h of o)yield h}n.concat=g;function*y(l){for(const o of l)for(const h of o)yield h}n.concatNested=y;function w(l,o,h){let s=h;for(const i of l)s=o(s,i);return s}n.reduce=w;function*M(l,o,h=l.length){for(o<0&&(o+=l.length),h<0?h+=l.length:h>l.length&&(h=l.length);o<h;o++)yield l[o]}n.slice=M;function c(l,o=Number.POSITIVE_INFINITY){const h=[];if(o===0)return[h,l];const s=l[Symbol.iterator]();for(let i=0;i<o;i++){const r=s.next();if(r.done)return[h,n.empty()];h.push(r.value)}return[h,{[Symbol.iterator](){return s}}]}n.consume=c;function a(l,o,h=(s,i)=>s===i){const s=l[Symbol.iterator](),i=o[Symbol.iterator]();for(;;){const r=s.next(),u=i.next();if(r.done!==u.done)return!1;if(r.done)return!0;if(!h(r.value,u.value))return!1}}n.equals=a})(v=e.Iterable||(e.Iterable={}))}),define(ee[43],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(o){o[o.None=0]="None",o[o.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=2]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",o[o.InvalidUnicode=4]="InvalidUnicode",o[o.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",o[o.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var n;(function(o){o[o.OpenBraceToken=1]="OpenBraceToken",o[o.CloseBraceToken=2]="CloseBraceToken",o[o.OpenBracketToken=3]="OpenBracketToken",o[o.CloseBracketToken=4]="CloseBracketToken",o[o.CommaToken=5]="CommaToken",o[o.ColonToken=6]="ColonToken",o[o.NullKeyword=7]="NullKeyword",o[o.TrueKeyword=8]="TrueKeyword",o[o.FalseKeyword=9]="FalseKeyword",o[o.StringLiteral=10]="StringLiteral",o[o.NumericLiteral=11]="NumericLiteral",o[o.LineCommentTrivia=12]="LineCommentTrivia",o[o.BlockCommentTrivia=13]="BlockCommentTrivia",o[o.LineBreakTrivia=14]="LineBreakTrivia",o[o.Trivia=15]="Trivia",o[o.Unknown=16]="Unknown",o[o.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(o){o[o.InvalidSymbol=1]="InvalidSymbol",o[o.InvalidNumberFormat=2]="InvalidNumberFormat",o[o.PropertyNameExpected=3]="PropertyNameExpected",o[o.ValueExpected=4]="ValueExpected",o[o.ColonExpected=5]="ColonExpected",o[o.CommaExpected=6]="CommaExpected",o[o.CloseBraceExpected=7]="CloseBraceExpected",o[o.CloseBracketExpected=8]="CloseBracketExpected",o[o.EndOfFileExpected=9]="EndOfFileExpected",o[o.InvalidCommentToken=10]="InvalidCommentToken",o[o.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",o[o.UnexpectedEndOfString=12]="UnexpectedEndOfString",o[o.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",o[o.InvalidUnicode=14]="InvalidUnicode",o[o.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",o[o.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(o){o.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function k(o,h=!1){let s=0,i=o.length,r="",u=0,d=16,b=0;function L(V){let J=0,q=0;for(;J<V;){const K=o.charCodeAt(s);if(K>=48&&K<=57)q=q*16+K-48;else if(K>=65&&K<=70)q=q*16+K-65+10;else if(K>=97&&K<=102)q=q*16+K-97+10;else break;s++,J++}return J<V&&(q=-1),q}function R(V){s=V,r="",u=0,d=16,b=0}function T(){const V=s;if(o.charCodeAt(s)===48)s++;else for(s++;s<o.length&&m(o.charCodeAt(s));)s++;if(s<o.length&&o.charCodeAt(s)===46)if(s++,s<o.length&&m(o.charCodeAt(s)))for(s++;s<o.length&&m(o.charCodeAt(s));)s++;else return b=3,o.substring(V,s);let J=s;if(s<o.length&&(o.charCodeAt(s)===69||o.charCodeAt(s)===101))if(s++,(s<o.length&&o.charCodeAt(s)===43||o.charCodeAt(s)===45)&&s++,s<o.length&&m(o.charCodeAt(s))){for(s++;s<o.length&&m(o.charCodeAt(s));)s++;J=s}else b=3;return o.substring(V,J)}function U(){let V="",J=s;for(;;){if(s>=i){V+=o.substring(J,s),b=2;break}const q=o.charCodeAt(s);if(q===34){V+=o.substring(J,s),s++;break}if(q===92){if(V+=o.substring(J,s),s++,s>=i){b=2;break}switch(o.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const j=L(4);j>=0?V+=String.fromCharCode(j):b=4;break}default:b=5}J=s;continue}if(q>=0&&q<=31)if(f(q)){V+=o.substring(J,s),b=2;break}else b=6;s++}return V}function Q(){if(r="",b=0,u=s,s>=i)return u=i,d=17;let V=o.charCodeAt(s);if(P(V)){do s++,r+=String.fromCharCode(V),V=o.charCodeAt(s);while(P(V));return d=15}if(f(V))return s++,r+=String.fromCharCode(V),V===13&&o.charCodeAt(s)===10&&(s++,r+=`
`),d=14;switch(V){case 123:return s++,d=1;case 125:return s++,d=2;case 91:return s++,d=3;case 93:return s++,d=4;case 58:return s++,d=6;case 44:return s++,d=5;case 34:return s++,r=U(),d=10;case 47:{const J=s-1;if(o.charCodeAt(s+1)===47){for(s+=2;s<i&&!f(o.charCodeAt(s));)s++;return r=o.substring(J,s),d=12}if(o.charCodeAt(s+1)===42){s+=2;const q=i-1;let K=!1;for(;s<q;){if(o.charCodeAt(s)===42&&o.charCodeAt(s+1)===47){s+=2,K=!0;break}s++}return K||(s++,b=1),r=o.substring(J,s),d=13}return r+=String.fromCharCode(V),s++,d=16}case 45:if(r+=String.fromCharCode(V),s++,s===i||!m(o.charCodeAt(s)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=T(),d=11;default:for(;s<i&&se(V);)s++,V=o.charCodeAt(s);if(u!==s){switch(r=o.substring(u,s),r){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return r+=String.fromCharCode(V),s++,d=16}}function se(V){if(P(V)||f(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let V;do V=Q();while(V>=12&&V<=15);return V}return{setPosition:R,getPosition:()=>s,scan:h?ne:Q,getToken:()=>d,getTokenValue:()=>r,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>b}}e.createScanner=k;function P(o){return o===32||o===9||o===11||o===12||o===160||o===5760||o>=8192&&o<=8203||o===8239||o===8287||o===12288||o===65279}function f(o){return o===10||o===13||o===8232||o===8233}function m(o){return o>=48&&o<=57}var E;(function(o){o[o.nullCharacter=0]="nullCharacter",o[o.maxAsciiCharacter=127]="maxAsciiCharacter",o[o.lineFeed=10]="lineFeed",o[o.carriageReturn=13]="carriageReturn",o[o.lineSeparator=8232]="lineSeparator",o[o.paragraphSeparator=8233]="paragraphSeparator",o[o.nextLine=133]="nextLine",o[o.space=32]="space",o[o.nonBreakingSpace=160]="nonBreakingSpace",o[o.enQuad=8192]="enQuad",o[o.emQuad=8193]="emQuad",o[o.enSpace=8194]="enSpace",o[o.emSpace=8195]="emSpace",o[o.threePerEmSpace=8196]="threePerEmSpace",o[o.fourPerEmSpace=8197]="fourPerEmSpace",o[o.sixPerEmSpace=8198]="sixPerEmSpace",o[o.figureSpace=8199]="figureSpace",o[o.punctuationSpace=8200]="punctuationSpace",o[o.thinSpace=8201]="thinSpace",o[o.hairSpace=8202]="hairSpace",o[o.zeroWidthSpace=8203]="zeroWidthSpace",o[o.narrowNoBreakSpace=8239]="narrowNoBreakSpace",o[o.ideographicSpace=12288]="ideographicSpace",o[o.mathematicalSpace=8287]="mathematicalSpace",o[o.ogham=5760]="ogham",o[o._=95]="_",o[o.$=36]="$",o[o._0=48]="_0",o[o._1=49]="_1",o[o._2=50]="_2",o[o._3=51]="_3",o[o._4=52]="_4",o[o._5=53]="_5",o[o._6=54]="_6",o[o._7=55]="_7",o[o._8=56]="_8",o[o._9=57]="_9",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.ampersand=38]="ampersand",o[o.asterisk=42]="asterisk",o[o.at=64]="at",o[o.backslash=92]="backslash",o[o.bar=124]="bar",o[o.caret=94]="caret",o[o.closeBrace=125]="closeBrace",o[o.closeBracket=93]="closeBracket",o[o.closeParen=41]="closeParen",o[o.colon=58]="colon",o[o.comma=44]="comma",o[o.dot=46]="dot",o[o.doubleQuote=34]="doubleQuote",o[o.equals=61]="equals",o[o.exclamation=33]="exclamation",o[o.greaterThan=62]="greaterThan",o[o.lessThan=60]="lessThan",o[o.minus=45]="minus",o[o.openBrace=123]="openBrace",o[o.openBracket=91]="openBracket",o[o.openParen=40]="openParen",o[o.percent=37]="percent",o[o.plus=43]="plus",o[o.question=63]="question",o[o.semicolon=59]="semicolon",o[o.singleQuote=39]="singleQuote",o[o.slash=47]="slash",o[o.tilde=126]="tilde",o[o.backspace=8]="backspace",o[o.formFeed=12]="formFeed",o[o.byteOrderMark=65279]="byteOrderMark",o[o.tab=9]="tab",o[o.verticalTab=11]="verticalTab"})(E||(E={}));function I(o,h){const s=[],i=new Object;let r;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function b(L,R,T,U){u.value=L,u.offset=R,u.length=T,u.type=U,u.colonOffset=void 0,r=u}try{c(o,{onObjectBegin:(L,R)=>{if(h<=L)throw i;r=void 0,d=h>L,s.push("")},onObjectProperty:(L,R,T)=>{if(h<R||(b(L,R,T,"property"),s[s.length-1]=L,h<=R+T))throw i},onObjectEnd:(L,R)=>{if(h<=L)throw i;r=void 0,s.pop()},onArrayBegin:(L,R)=>{if(h<=L)throw i;r=void 0,s.push(0)},onArrayEnd:(L,R)=>{if(h<=L)throw i;r=void 0,s.pop()},onLiteralValue:(L,R,T)=>{if(h<R||(b(L,R,T,l(L)),h<=R+T))throw i},onSeparator:(L,R,T)=>{if(h<=R)throw i;if(L===":"&&r&&r.type==="property")r.colonOffset=R,d=!1,r=void 0;else if(L===","){const U=s[s.length-1];typeof U=="number"?s[s.length-1]=U+1:(d=!0,s[s.length-1]=""),r=void 0}}})}catch(L){if(L!==i)throw L}return{path:s,previousNode:r,isAtPropertyKey:d,matches:L=>{let R=0;for(let T=0;R<L.length&&T<s.length;T++)if(L[R]===s[T]||L[R]==="*")R++;else if(L[R]!=="**")return!1;return R===L.length}}}e.getLocation=I;function p(o,h=[],s=C.DEFAULT){let i=null,r=[];const u=[];function d(L){Array.isArray(r)?r.push(L):i!==null&&(r[i]=L)}return c(o,{onObjectBegin:()=>{const L={};d(L),u.push(r),r=L,i=null},onObjectProperty:L=>{i=L},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const L=[];d(L),u.push(r),r=L,i=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:d,onError:(L,R,T)=>{h.push({error:L,offset:R,length:T})}},s),r[0]}e.parse=p;function S(o,h=[],s=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(L){i.type==="property"&&(i.length=L-i.offset,i=i.parent)}function u(L){return i.children.push(L),L}c(o,{onObjectBegin:L=>{i=u({type:"object",offset:L,length:-1,parent:i,children:[]})},onObjectProperty:(L,R,T)=>{i=u({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:L,offset:R,length:T,parent:i})},onObjectEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,r(L+R)},onArrayBegin:(L,R)=>{i=u({type:"array",offset:L,length:-1,parent:i,children:[]})},onArrayEnd:(L,R)=>{i.length=L+R-i.offset,i=i.parent,r(L+R)},onLiteralValue:(L,R,T)=>{u({type:l(L),offset:R,length:T,parent:i,value:L}),r(R+T)},onSeparator:(L,R,T)=>{i.type==="property"&&(L===":"?i.colonOffset=R:L===","&&r(R))},onError:(L,R,T)=>{h.push({error:L,offset:R,length:T})}},s);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=S;function t(o,h){if(!o)return;let s=o;for(let i of h)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function g(o){if(!o.parent||!o.parent.children)return[];const h=g(o.parent);if(o.parent.type==="property"){const s=o.parent.children[0].value;h.push(s)}else if(o.parent.type==="array"){const s=o.parent.children.indexOf(o);s!==-1&&h.push(s)}return h}e.getNodePath=g;function y(o){switch(o.type){case"array":return o.children.map(y);case"object":{const h=Object.create(null);for(let s of o.children){const i=s.children[1];i&&(h[s.children[0].value]=y(i))}return h}case"null":case"string":case"number":case"boolean":return o.value;default:return}}e.getNodeValue=y;function w(o,h,s=!1){return h>=o.offset&&h<o.offset+o.length||s&&h===o.offset+o.length}e.contains=w;function M(o,h,s=!1){if(w(o,h,s)){const i=o.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=h;r++){const u=M(i[r],h,s);if(u)return u}return o}}e.findNodeAtOffset=M;function c(o,h,s=C.DEFAULT){const i=k(o,!1);function r(W){return W?()=>W(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(W){return W?A=>W(A,i.getTokenOffset(),i.getTokenLength()):()=>!0}const d=r(h.onObjectBegin),b=u(h.onObjectProperty),L=r(h.onObjectEnd),R=r(h.onArrayBegin),T=r(h.onArrayEnd),U=u(h.onLiteralValue),Q=u(h.onSeparator),se=r(h.onComment),ne=u(h.onError),V=s&&s.disallowComments,J=s&&s.allowTrailingComma;function q(){for(;;){const W=i.scan();switch(i.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:V||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(W){case 12:case 13:V?K(10):se();break;case 16:K(1);break;case 15:case 14:break;default:return W}}}function K(W,A=[],_=[]){if(ne(W),A.length+_.length>0){let N=i.getToken();for(;N!==17;){if(A.indexOf(N)!==-1){q();break}else if(_.indexOf(N)!==-1)break;N=q()}}}function j(W){const A=i.getTokenValue();return W?U(A):b(A),q(),!0}function B(){switch(i.getToken()){case 11:{let W=0;try{W=JSON.parse(i.getTokenValue()),typeof W!="number"&&(K(2),W=0)}catch{K(2)}U(W);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return q(),!0}function $(){return i.getToken()!==10?(K(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(Q(":"),q(),F()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Y(){d(),q();let W=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(W||K(4,[],[]),Q(","),q(),i.getToken()===2&&J)break}else W&&K(6,[],[]);$()||K(4,[],[2,5]),W=!0}return L(),i.getToken()!==2?K(7,[2],[]):q(),!0}function H(){R(),q();let W=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(W||K(4,[],[]),Q(","),q(),i.getToken()===4&&J)break}else W&&K(6,[],[]);F()||K(4,[],[4,5]),W=!0}return T(),i.getToken()!==4?K(8,[4],[]):q(),!0}function F(){switch(i.getToken()){case 3:return H();case 1:return Y();case 10:return j(!0);default:return B()}}return q(),i.getToken()===17?s.allowEmptyContent?!0:(K(4,[],[]),!1):F()?(i.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}e.visit=c;function a(o,h){let s=k(o),i=[],r,u=0,d;do switch(d=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:u!==d&&i.push(o.substring(u,d)),h!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,h)),u=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=a;function l(o){switch(typeof o){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(o){if(Array.isArray(o))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ee[104],te([0,1,43]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(m,E,I){let p,S,t,g,y;if(E){for(g=E.offset,y=g+E.length,t=g;t>0&&!f(m,t-1);)t--;let d=y;for(;d<m.length&&!f(m,d);)d++;S=m.substring(t,d),p=k(S,I)}else S=m,p=0,t=0,g=0,y=m.length;const w=P(I,m);let M=!1,c=0,a;I.insertSpaces?a=C(" ",I.tabSize||4):a="	";const l=(0,v.createScanner)(S,!1);let o=!1;function h(){return w+C(a,p+c)}function s(){let d=l.scan();for(M=!1;d===15||d===14;)M=M||d===14,d=l.scan();return o=d===16||l.getTokenError()!==0,d}const i=[];function r(d,b,L){!o&&b<y&&L>g&&m.substring(b,L)!==d&&i.push({offset:b,length:L-b,content:d})}let u=s();if(u!==17){const d=l.getTokenOffset()+t,b=C(a,p);r(b,t,d)}for(;u!==17;){let d=l.getTokenOffset()+l.getTokenLength()+t,b=s(),L="";for(;!M&&(b===12||b===13);){const T=l.getTokenOffset()+t;r(" ",d,T),d=l.getTokenOffset()+l.getTokenLength()+t,L=b===12?h():"",b=s()}if(b===2)u!==1&&(c--,L=h());else if(b===4)u!==3&&(c--,L=h());else{switch(u){case 3:case 1:c++,L=h();break;case 5:case 12:L=h();break;case 13:M?L=h():L=" ";break;case 6:L=" ";break;case 10:if(b===6){L="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?L=" ":b!==5&&b!==17&&(o=!0);break;case 16:o=!0;break}M&&(b===12||b===13)&&(L=h())}const R=l.getTokenOffset()+t;r(L,d,R),u=b}return i}e.format=n;function D(m,E){const I=JSON.stringify(m,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?I.replace(/\r\n|\r|\n/g,E.eol):I}e.toFormattedString=D;function C(m,E){let I="";for(let p=0;p<E;p++)I+=m;return I}function k(m,E){let I=0,p=0;const S=E.tabSize||4;for(;I<m.length;){const t=m.charAt(I);if(t===" ")p++;else if(t==="	")p+=S;else break;I++}return Math.floor(p/S)}function P(m,E){for(let I=0;I<E.length;I++){const p=E.charAt(I);if(p==="\r")return I+1<E.length&&E.charAt(I+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=P;function f(m,E){return`\r
`.indexOf(m.charAt(E))!==-1}e.isEOL=f}),define(ee[105],te([0,1,43,104]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(m,E,I){return C(m,E,void 0,I)}e.removeProperty=D;function C(m,E,I,p,S){const t=E.slice(),g=[],y=(0,v.parseTree)(m,g);let w,M;for(;t.length>0&&(M=t.pop(),w=(0,v.findNodeAtLocation)(y,t),w===void 0&&I!==void 0);)typeof M=="string"?I={[M]:I}:I=[I];if(w)if(w.type==="object"&&typeof M=="string"&&Array.isArray(w.children)){const c=(0,v.findNodeAtLocation)(w,[M]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const a=w.children.indexOf(c.parent);let l,o=c.parent.offset+c.parent.length;if(a>0){const h=w.children[a-1];l=h.offset+h.length}else l=w.offset+1,w.children.length>1&&(o=w.children[1].offset);return k(m,{offset:l,length:o-l,content:""},p)}else return k(m,{offset:c.offset,length:c.length,content:JSON.stringify(I)},p);else{if(I===void 0)return[];const a=`${JSON.stringify(M)}: ${JSON.stringify(I)}`,l=S?S(w.children.map(h=>h.children[0].value)):w.children.length;let o;if(l>0){const h=w.children[l-1];o={offset:h.offset+h.length,length:0,content:","+a}}else w.children.length===0?o={offset:w.offset+1,length:0,content:a}:o={offset:w.offset+1,length:0,content:a+","};return k(m,o,p)}}else if(w.type==="array"&&typeof M=="number"&&Array.isArray(w.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let a;if(w.children.length===0||M===0)a={offset:w.offset+1,length:0,content:w.children.length===0?c:c+","};else{const l=M===-1||M>w.children.length?w.children.length:M,o=w.children[l-1];a={offset:o.offset+o.length,length:0,content:","+c}}return k(m,a,p)}else{const c=M,a=w.children[c];let l;if(w.children.length===1)l={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===c){const o=w.children[c-1],h=o.offset+o.length,s=w.offset+w.length;l={offset:h,length:s-2-h,content:""}}else l={offset:a.offset,length:w.children[c+1].offset-a.offset,content:""};return k(m,l,p)}else throw new Error(`Can not add ${typeof M!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(m,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(I)},p)}}e.setProperty=C;function k(m,E,I){let p=P(m,E),S=E.offset,t=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;S>0&&!(0,n.isEOL)(p,S-1);)S--;for(;t<p.length&&!(0,n.isEOL)(p,t);)t++}const g=(0,n.format)(p,{offset:S,length:t-S},I);for(let w=g.length-1;w>=0;w--){const M=g[w];p=P(p,M),S=Math.min(S,M.offset),t=Math.max(t,M.offset+M.length),t+=M.content.length-M.length}const y=m.length-(p.length-t)-S;return[{offset:S,length:y,content:p.substring(S,t)}]}e.withFormatting=k;function P(m,E){return m.substring(0,E.offset)+E.content+m.substring(E.offset+E.length)}e.applyEdit=P;function f(m,E){let I=E.slice(0).sort((S,t)=>{const g=S.offset-t.offset;return g===0?S.length-t.length:g}),p=m.length;for(let S=I.length-1;S>=0;S--){let t=I[S];if(t.offset+t.length<=p)m=P(m,t);else throw new Error("Overlapping edit");p=t.offset}return m}e.applyEdits=f}),define(ee[80],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var v;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(v=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,y){this._keyCodeToStr[g]=y,this._strToKeyCode[y.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const C=new D,k=new D,P=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const f=[],m=Object.create(null),E=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>E[t]||0,toEnum:t=>m[t]||0,toString:t=>f[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let y=[],w=[];for(const M of g){const[c,a,l,o,h,s,i,r,u,d]=M;if(w[l]||(w[l]=!0,f[l]=o,m[o]=l,E[o.toLowerCase()]=l,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[l]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[h]=l))),!y[h]){if(y[h]=!0,!s)throw new Error(`String representation missing for key code ${h} around scan code ${o}`);C.define(h,s),k.define(h,u||s),P.define(h,d||u||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=h),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=h)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(t){function g(l){return C.keyCodeToStr(l)}t.toString=g;function y(l){return C.strToKeyCode(l)}t.fromString=y;function w(l){return k.keyCodeToStr(l)}t.toUserSettingsUS=w;function M(l){return P.keyCodeToStr(l)}t.toUserSettingsGeneral=M;function c(l){return k.strToKeyCode(l)||P.strToKeyCode(l)}t.fromUserSettings=c;function a(l){if(l>=93&&l<=108)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(l)}t.toElectronAccelerator=a})(I=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(p=e.KeyMod||(e.KeyMod={}));function S(t,g){const y=(g&65535)<<16>>>0;return(t|y)>>>0}e.KeyChord=S}),define(ee[59],te([0,1,15]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(n||(n={}));function D(I,p){if(I===0)return null;const S=(I&65535)>>>0,t=(I&4294901760)>>>16;return t!==0?new P([C(S,p),C(t,p)]):new P([C(S,p)])}e.createKeybinding=D;function C(I,p){const S=!!(I&2048),t=!!(I&256),g=p===2?t:S,y=!!(I&1024),w=!!(I&512),M=p===2?S:t,c=I&255;return new k(g,y,w,M,c)}e.createSimpleKeybinding=C;class k{constructor(p,S,t,g,y){this.ctrlKey=p,this.shiftKey=S,this.altKey=t,this.metaKey=g,this.keyCode=y}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.keyCode===p.keyCode}getHashCode(){const p=this.ctrlKey?"1":"0",S=this.shiftKey?"1":"0",t=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${p}${S}${t}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new P([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=k;class P{constructor(p){if(p.length===0)throw(0,v.illegalArgument)("parts");this.parts=p}getHashCode(){let p="";for(let S=0,t=this.parts.length;S<t;S++)S!==0&&(p+=";"),p+=this.parts[S].getHashCode();return p}equals(p){if(p===null||this.parts.length!==p.parts.length)return!1;for(let S=0;S<this.parts.length;S++)if(!this.parts[S].equals(p.parts[S]))return!1;return!0}}e.ChordKeybinding=P;class f{constructor(p,S,t,g,y){this.ctrlKey=p,this.shiftKey=S,this.altKey=t,this.metaKey=g,this.scanCode=y}equals(p){return this.ctrlKey===p.ctrlKey&&this.shiftKey===p.shiftKey&&this.altKey===p.altKey&&this.metaKey===p.metaKey&&this.scanCode===p.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=f;class m{constructor(p,S,t,g,y,w){this.ctrlKey=p,this.shiftKey=S,this.altKey=t,this.metaKey=g,this.keyLabel=y,this.keyAriaLabel=w}}e.ResolvedKeybindingPart=m;class E{}e.ResolvedKeybinding=E}),define(ee[106],te([0,1,80,59]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let P=!1,f=!1,m=!1,E=!1,I;do I=!1,/^ctrl(\+|\-)/.test(k)&&(P=!0,k=k.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(k)&&(f=!0,k=k.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(k)&&(m=!0,k=k.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(k)&&(E=!0,k=k.substr("meta-".length),I=!0),/^win(\+|\-)/.test(k)&&(E=!0,k=k.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(k)&&(E=!0,k=k.substr("cmd-".length),I=!0);while(I);let p;const S=k.indexOf(" ");return S>0?(p=k.substring(0,S),k=k.substring(S)):(p=k,k=""),{remains:k,ctrl:P,shift:f,alt:m,meta:E,key:p}}static parseSimpleKeybinding(k){const P=this._readModifiers(k),f=v.KeyCodeUtils.fromUserSettings(P.key);return[new n.SimpleKeybinding(P.ctrl,P.shift,P.alt,P.meta,f),P.remains]}static parseKeybinding(k,P){if(!k)return null;const f=[];let m;do[m,k]=this.parseSimpleKeybinding(k),f.push(m);while(k.length>0);return new n.ChordKeybinding(f)}static parseSimpleUserBinding(k){const P=this._readModifiers(k),f=P.key.match(/^\[([^\]]+)\]$/);if(f){const E=f[1],I=v.ScanCodeUtils.lowerCaseToEnum(E);return[new n.ScanCodeBinding(P.ctrl,P.shift,P.alt,P.meta,I),P.remains]}const m=v.KeyCodeUtils.fromUserSettings(P.key);return[new n.SimpleKeybinding(P.ctrl,P.shift,P.alt,P.meta,m),P.remains]}static parseUserBinding(k){if(!k)return[];const P=[];let f;for(;k.length>0;)[f,k]=this.parseSimpleUserBinding(k),P.push(f);return P}}e.KeybindingParser=D}),define(ee[107],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new v(()=>D(this.getValue()))}}e.Lazy=v}),define(ee[2],te([0,1,42,69]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function k(i){C=i}if(e.setDisposableTracker=k,D){const i="__is_disposable_tracked__";k(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[i]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==M.None)try{r[i]=!0}catch{}}markAsDisposed(r){if(r&&r!==M.None)try{r[i]=!0}catch{}}markAsSingleton(r){}})}function P(i){return C?.trackDisposable(i),i}function f(i){C?.markAsDisposed(i)}function m(i,r){C?.setParent(i,r)}function E(i,r){if(!!C)for(const u of i)C.setParent(u,r)}function I(i){return C?.markAsSingleton(i),i}e.markAsSingleton=I;class p extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=p;function S(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=S;function t(i){if(n.Iterable.is(i)){let r=[];for(const u of i)if(u)try{u.dispose()}catch(d){r.push(d)}if(r.length===1)throw r[0];if(r.length>1)throw new p(r);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function g(...i){const r=y(()=>t(i));return E(i,r),r}e.combinedDisposable=g;function y(i){const r=P({dispose:(0,v.once)(()=>{f(r),i()})});return r}e.toDisposable=y;class w{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return m(r,this),this._isDisposed?w.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=w,w.DISABLE_DISPOSED_WARNING=!1;class M{constructor(){this._store=new w,P(this),m(this._store,this)}dispose(){f(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=M,M.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&m(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&m(r,null),r}}e.MutableDisposable=c;class a{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class l{constructor(){this.references=new Map}acquire(r,...u){let d=this.references.get(r);d||(d={counter:0,object:this.createReferencedObject(r,...u)},this.references.set(r,d));const{object:b}=d,L=(0,v.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(r,d.object),this.references.delete(r))});return d.counter++,{object:b,dispose:L}}}e.ReferenceCollection=l;class o{constructor(r){this.referenceCollection=r}async acquire(r,...u){const d=this.referenceCollection.acquire(r,...u);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(b){throw d.dispose(),b}}}e.AsyncReferenceCollection=o;class h{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=h;function s(i){const r=new w;try{i(r)}finally{r.dispose()}}e.disposeOnReturn=s}),define(ee[108],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(C){this.element=C,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class n{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let C=this._first;for(;C!==v.Undefined;){const k=C.next;C.prev=v.Undefined,C.next=v.Undefined,C=k}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,k){const P=new v(C);if(this._first===v.Undefined)this._first=P,this._last=P;else if(k){const m=this._last;this._last=P,P.prev=m,m.next=P}else{const m=this._first;this._first=P,P.next=m,m.prev=P}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==v.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==v.Undefined&&C.next!==v.Undefined){const k=C.prev;k.next=C.next,C.next.prev=k}else C.prev===v.Undefined&&C.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):C.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):C.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==v.Undefined;)yield C.element,C=C.next}}e.LinkedList=n}),function(){function G(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function k(f){C.push(f,Date.now())}function P(){const f=[];for(let m=0;m<C.length;m+=2)f.push({name:C[m],startTime:C[m+1]});return f}return{mark:k,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))C.push({name:k.name,startTime:Math.round(D+k.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=v(n))}(),define(ee[3],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let n=!1,D=!1,C=!1,k=!1,P=!1,f=!1,m=!1,E=!1,I,p=v,S,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const y=typeof g?.versions?.electron=="string",w=y&&g?.type==="renderer";if(e.isElectronSandboxed=w&&g?.sandboxed,typeof navigator=="object"&&!w)t=navigator.userAgent,n=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,E=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,f=!0,I=navigator.language,p=I;else if(typeof g=="object"){n=g.platform==="win32",D=g.platform==="darwin",C=g.platform==="linux",k=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,m=y,I=v,p=v;const r=g.env.VSCODE_NLS_CONFIG;if(r)try{const u=JSON.parse(r),d=u.availableLanguages["*"];I=u.locale,p=d||v,S=u._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var M;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(M=e.Platform||(e.Platform={}));function c(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;D?a=1:n?a=3:C&&(a=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=k,e.isNative=P,e.isElectron=m,e.isWeb=f,e.isIOS=E,e.platform=a,e.userAgent=t,e.language=p;var l;(function(r){function u(){return e.language}r.value=u;function d(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=d;function b(){return e.language==="en"}r.isDefault=b})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeScheduleAsyncWork)for(let b=0,L=r.length;b<L;b++){const R=r[b];if(R.id===d.data.vscodeScheduleAsyncWork){r.splice(b,1),R.callback();return}}});let u=0;return d=>{const b=++u;r.push({id:b,callback:d}),e.globals.postMessage({vscodeScheduleAsyncWork:b},"*")}}return r=>setTimeout(r)})();var o;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||E?2:n?1:3;let h=!0,s=!1;function i(){if(!s){s=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,h=new Uint16Array(r.buffer)[0]===(2<<8)+1}return h}e.isLittleEndian=i}),define(ee[34],te([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const D=v.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ee[9],te([0,1,34]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,C=90,k=122,P=46,f=47,m=92,E=58,I=63;class p extends Error{constructor(a,l,o){let h;typeof l=="string"&&l.indexOf("not ")===0?(h="must not be",l=l.replace(/^not /,"")):h="must be";const s=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${s} ${h} of type ${l}`;i+=`. Received type ${typeof o}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function S(c,a){if(typeof c!="string")throw new p(a,"string",c)}function t(c){return c===f||c===m}function g(c){return c===f}function y(c){return c>=n&&c<=C||c>=D&&c<=k}function w(c,a,l,o){let h="",s=0,i=-1,r=0,u=0;for(let d=0;d<=c.length;++d){if(d<c.length)u=c.charCodeAt(d);else{if(o(u))break;u=f}if(o(u)){if(!(i===d-1||r===1))if(r===2){if(h.length<2||s!==2||h.charCodeAt(h.length-1)!==P||h.charCodeAt(h.length-2)!==P){if(h.length>2){const b=h.lastIndexOf(l);b===-1?(h="",s=0):(h=h.slice(0,b),s=h.length-1-h.lastIndexOf(l)),i=d,r=0;continue}else if(h.length!==0){h="",s=0,i=d,r=0;continue}}a&&(h+=h.length>0?`${l}..`:"..",s=2)}else h.length>0?h+=`${l}${c.slice(i+1,d)}`:h=c.slice(i+1,d),s=d-i-1;i=d,r=0}else u===P&&r!==-1?++r:r=-1}return h}function M(c,a){if(a===null||typeof a!="object")throw new p("pathObject","Object",a);const l=a.dir||a.root,o=a.base||`${a.name||""}${a.ext||""}`;return l?l===a.root?`${l}${o}`:`${l}${c}${o}`:o}e.win32={resolve(...c){let a="",l="",o=!1;for(let h=c.length-1;h>=-1;h--){let s;if(h>=0){if(s=c[h],S(s,"path"),s.length===0)continue}else a.length===0?s=v.cwd():(s=v.env[`=${a}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===m)&&(s=`${a}\\`));const i=s.length;let r=0,u="",d=!1;const b=s.charCodeAt(0);if(i===1)t(b)&&(r=1,d=!0);else if(t(b))if(d=!0,t(s.charCodeAt(1))){let L=2,R=L;for(;L<i&&!t(s.charCodeAt(L));)L++;if(L<i&&L!==R){const T=s.slice(R,L);for(R=L;L<i&&t(s.charCodeAt(L));)L++;if(L<i&&L!==R){for(R=L;L<i&&!t(s.charCodeAt(L));)L++;(L===i||L!==R)&&(u=`\\\\${T}\\${s.slice(R,L)}`,r=L)}}}else r=1;else y(b)&&s.charCodeAt(1)===E&&(u=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(d=!0,r=3));if(u.length>0)if(a.length>0){if(u.toLowerCase()!==a.toLowerCase())continue}else a=u;if(o){if(a.length>0)break}else if(l=`${s.slice(r)}\\${l}`,o=d,d&&a.length>0)break}return l=w(l,!o,"\\",t),o?`${a}\\${l}`:`${a}${l}`||"."},normalize(c){S(c,"path");const a=c.length;if(a===0)return".";let l=0,o,h=!1;const s=c.charCodeAt(0);if(a===1)return g(s)?"\\":c;if(t(s))if(h=!0,t(c.charCodeAt(1))){let r=2,u=r;for(;r<a&&!t(c.charCodeAt(r));)r++;if(r<a&&r!==u){const d=c.slice(u,r);for(u=r;r<a&&t(c.charCodeAt(r));)r++;if(r<a&&r!==u){for(u=r;r<a&&!t(c.charCodeAt(r));)r++;if(r===a)return`\\\\${d}\\${c.slice(u)}\\`;r!==u&&(o=`\\\\${d}\\${c.slice(u,r)}`,l=r)}}}else l=1;else y(s)&&c.charCodeAt(1)===E&&(o=c.slice(0,2),l=2,a>2&&t(c.charCodeAt(2))&&(h=!0,l=3));let i=l<a?w(c.slice(l),!h,"\\",t):"";return i.length===0&&!h&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),o===void 0?h?`\\${i}`:i:h?`${o}\\${i}`:`${o}${i}`},isAbsolute(c){S(c,"path");const a=c.length;if(a===0)return!1;const l=c.charCodeAt(0);return t(l)||a>2&&y(l)&&c.charCodeAt(1)===E&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,l;for(let s=0;s<c.length;++s){const i=c[s];S(i,"path"),i.length>0&&(a===void 0?a=l=i:a+=`\\${i}`)}if(a===void 0)return".";let o=!0,h=0;if(typeof l=="string"&&t(l.charCodeAt(0))){++h;const s=l.length;s>1&&t(l.charCodeAt(1))&&(++h,s>2&&(t(l.charCodeAt(2))?++h:o=!1))}if(o){for(;h<a.length&&t(a.charCodeAt(h));)h++;h>=2&&(a=`\\${a.slice(h)}`)}return e.win32.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a)return"";const l=e.win32.resolve(c),o=e.win32.resolve(a);if(l===o||(c=l.toLowerCase(),a=o.toLowerCase(),c===a))return"";let h=0;for(;h<c.length&&c.charCodeAt(h)===m;)h++;let s=c.length;for(;s-1>h&&c.charCodeAt(s-1)===m;)s--;const i=s-h;let r=0;for(;r<a.length&&a.charCodeAt(r)===m;)r++;let u=a.length;for(;u-1>r&&a.charCodeAt(u-1)===m;)u--;const d=u-r,b=i<d?i:d;let L=-1,R=0;for(;R<b;R++){const U=c.charCodeAt(h+R);if(U!==a.charCodeAt(r+R))break;U===m&&(L=R)}if(R!==b){if(L===-1)return o}else{if(d>b){if(a.charCodeAt(r+R)===m)return o.slice(r+R+1);if(R===2)return o.slice(r+R)}i>b&&(c.charCodeAt(h+R)===m?L=R:R===2&&(L=3)),L===-1&&(L=0)}let T="";for(R=h+L+1;R<=s;++R)(R===s||c.charCodeAt(R)===m)&&(T+=T.length===0?"..":"\\..");return r+=L,T.length>0?`${T}${o.slice(r,u)}`:(o.charCodeAt(r)===m&&++r,o.slice(r,u))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===m){if(a.charCodeAt(1)===m){const l=a.charCodeAt(2);if(l!==I&&l!==P)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(y(a.charCodeAt(0))&&a.charCodeAt(1)===E&&a.charCodeAt(2)===m)return`\\\\?\\${a}`;return c},dirname(c){S(c,"path");const a=c.length;if(a===0)return".";let l=-1,o=0;const h=c.charCodeAt(0);if(a===1)return t(h)?c:".";if(t(h)){if(l=o=1,t(c.charCodeAt(1))){let r=2,u=r;for(;r<a&&!t(c.charCodeAt(r));)r++;if(r<a&&r!==u){for(u=r;r<a&&t(c.charCodeAt(r));)r++;if(r<a&&r!==u){for(u=r;r<a&&!t(c.charCodeAt(r));)r++;if(r===a)return c;r!==u&&(l=o=r+1)}}}}else y(h)&&c.charCodeAt(1)===E&&(l=a>2&&t(c.charCodeAt(2))?3:2,o=l);let s=-1,i=!0;for(let r=a-1;r>=o;--r)if(t(c.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(l===-1)return".";s=l}return c.slice(0,s)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let l=0,o=-1,h=!0,s;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===E&&(l=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,r=-1;for(s=c.length-1;s>=l;--s){const u=c.charCodeAt(s);if(t(u)){if(!h){l=s+1;break}}else r===-1&&(h=!1,r=s+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return l===o?o=r:o===-1&&(o=c.length),c.slice(l,o)}for(s=c.length-1;s>=l;--s)if(t(c.charCodeAt(s))){if(!h){l=s+1;break}}else o===-1&&(h=!1,o=s+1);return o===-1?"":c.slice(l,o)},extname(c){S(c,"path");let a=0,l=-1,o=0,h=-1,s=!0,i=0;c.length>=2&&c.charCodeAt(1)===E&&y(c.charCodeAt(0))&&(a=o=2);for(let r=c.length-1;r>=a;--r){const u=c.charCodeAt(r);if(t(u)){if(!s){o=r+1;break}continue}h===-1&&(s=!1,h=r+1),u===P?l===-1?l=r:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||h===-1||i===0||i===1&&l===h-1&&l===o+1?"":c.slice(l,h)},format:M.bind(null,"\\"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.length;let o=0,h=c.charCodeAt(0);if(l===1)return t(h)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(h)){if(o=1,t(c.charCodeAt(1))){let L=2,R=L;for(;L<l&&!t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&t(c.charCodeAt(L));)L++;if(L<l&&L!==R){for(R=L;L<l&&!t(c.charCodeAt(L));)L++;L===l?o=L:L!==R&&(o=L+1)}}}}else if(y(h)&&c.charCodeAt(1)===E){if(l<=2)return a.root=a.dir=c,a;if(o=2,t(c.charCodeAt(2))){if(l===3)return a.root=a.dir=c,a;o=3}}o>0&&(a.root=c.slice(0,o));let s=-1,i=o,r=-1,u=!0,d=c.length-1,b=0;for(;d>=o;--d){if(h=c.charCodeAt(d),t(h)){if(!u){i=d+1;break}continue}r===-1&&(u=!1,r=d+1),h===P?s===-1?s=d:b!==1&&(b=1):s!==-1&&(b=-1)}return r!==-1&&(s===-1||b===0||b===1&&s===r-1&&s===i+1?a.base=a.name=c.slice(i,r):(a.name=c.slice(i,s),a.base=c.slice(i,r),a.ext=c.slice(s,r))),i>0&&i!==o?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",l=!1;for(let o=c.length-1;o>=-1&&!l;o--){const h=o>=0?c[o]:v.cwd();S(h,"path"),h.length!==0&&(a=`${h}/${a}`,l=h.charCodeAt(0)===f)}return a=w(a,!l,"/",g),l?`/${a}`:a.length>0?a:"."},normalize(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===f,l=c.charCodeAt(c.length-1)===f;return c=w(c,!a,"/",g),c.length===0?a?"/":l?"./":".":(l&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return S(c,"path"),c.length>0&&c.charCodeAt(0)===f},join(...c){if(c.length===0)return".";let a;for(let l=0;l<c.length;++l){const o=c[l];S(o,"path"),o.length>0&&(a===void 0?a=o:a+=`/${o}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const l=1,o=c.length,h=o-l,s=1,i=a.length-s,r=h<i?h:i;let u=-1,d=0;for(;d<r;d++){const L=c.charCodeAt(l+d);if(L!==a.charCodeAt(s+d))break;L===f&&(u=d)}if(d===r)if(i>r){if(a.charCodeAt(s+d)===f)return a.slice(s+d+1);if(d===0)return a.slice(s+d)}else h>r&&(c.charCodeAt(l+d)===f?u=d:d===0&&(u=0));let b="";for(d=l+u+1;d<=o;++d)(d===o||c.charCodeAt(d)===f)&&(b+=b.length===0?"..":"/..");return`${b}${a.slice(s+u)}`},toNamespacedPath(c){return c},dirname(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===f;let l=-1,o=!0;for(let h=c.length-1;h>=1;--h)if(c.charCodeAt(h)===f){if(!o){l=h;break}}else o=!1;return l===-1?a?"/":".":a&&l===1?"//":c.slice(0,l)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let l=0,o=-1,h=!0,s;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,r=-1;for(s=c.length-1;s>=0;--s){const u=c.charCodeAt(s);if(u===f){if(!h){l=s+1;break}}else r===-1&&(h=!1,r=s+1),i>=0&&(u===a.charCodeAt(i)?--i==-1&&(o=s):(i=-1,o=r))}return l===o?o=r:o===-1&&(o=c.length),c.slice(l,o)}for(s=c.length-1;s>=0;--s)if(c.charCodeAt(s)===f){if(!h){l=s+1;break}}else o===-1&&(h=!1,o=s+1);return o===-1?"":c.slice(l,o)},extname(c){S(c,"path");let a=-1,l=0,o=-1,h=!0,s=0;for(let i=c.length-1;i>=0;--i){const r=c.charCodeAt(i);if(r===f){if(!h){l=i+1;break}continue}o===-1&&(h=!1,o=i+1),r===P?a===-1?a=i:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||o===-1||s===0||s===1&&a===o-1&&a===l+1?"":c.slice(a,o)},format:M.bind(null,"/"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const l=c.charCodeAt(0)===f;let o;l?(a.root="/",o=1):o=0;let h=-1,s=0,i=-1,r=!0,u=c.length-1,d=0;for(;u>=o;--u){const b=c.charCodeAt(u);if(b===f){if(!r){s=u+1;break}continue}i===-1&&(r=!1,i=u+1),b===P?h===-1?h=u:d!==1&&(d=1):h!==-1&&(d=-1)}if(i!==-1){const b=s===0&&l?1:s;h===-1||d===0||d===1&&h===i-1&&h===s+1?a.base=a.name=c.slice(b,i):(a.name=c.slice(b,h),a.base=c.slice(b,i),a.ext=c.slice(h,i))}return s>0?a.dir=c.slice(0,s-1):l&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ee[81],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var n;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...k){const P=k.reduce((E,I)=>(E[I]=!0,E),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(E=>!P[E]).forEach(E=>{for(let I=0;I<f.length;I++)if(E.search(f[I])!==-1){delete C[E];break}})}e.sanitizeProcessEnvironment=D}),define(ee[109],te([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(k){this._highResolution=n&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ee[4],te([0,1,15,42,2,108,109]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(a){a.None=()=>D.Disposable.None;function l(j){return(B,$=null,Y)=>{let H=!1,F;return F=j(W=>{if(!H)return F?F.dispose():H=!0,B.call($,W)},null,Y),H&&F.dispose(),F}}a.once=l;function o(j,B){return d(($,Y=null,H)=>j(F=>$.call(Y,B(F)),null,H))}a.map=o;function h(j,B){return d(($,Y=null,H)=>j(F=>{B(F),$.call(Y,F)},null,H))}a.forEach=h;function s(j,B){return d(($,Y=null,H)=>j(F=>B(F)&&$.call(Y,F),null,H))}a.filter=s;function i(j){return j}a.signal=i;function r(...j){return(B,$=null,Y)=>(0,D.combinedDisposable)(...j.map(H=>H(F=>B.call($,F),null,Y)))}a.any=r;function u(j,B,$){let Y=$;return o(j,H=>(Y=B(Y,H),Y))}a.reduce=u;function d(j){let B;const $=new p({onFirstListenerAdd(){B=j($.fire,$)},onLastListenerRemove(){B.dispose()}});return $.event}function b(j,B,$,Y=100,H=!1){let F,W,A=0;return j(_=>{A++,F=$(F,_),H&&!W&&(B(F),F=void 0),clearTimeout(W),W=setTimeout(()=>{const N=F;F=void 0,W=void 0,(!H||A>1)&&B(N),A=0},Y)})}a.debouncedListener=b;function L(j,B,$=100,Y=!1,H){let F,W,A,_=0;const N=new p({leakWarningThreshold:H,onFirstListenerAdd(){F=j(O=>{_++,W=B(W,O),Y&&!A&&(N.fire(W),W=void 0),clearTimeout(A),A=setTimeout(()=>{const z=W;W=void 0,A=void 0,(!Y||_>1)&&N.fire(z),_=0},$)})},onLastListenerRemove(){F.dispose()}});return N.event}a.debounce=L;function R(j,B=($,Y)=>$===Y){let $=!0,Y;return s(j,H=>{const F=$||!B(H,Y);return $=!1,Y=H,F})}a.latch=R;function T(j,B){return[a.filter(j,B),a.filter(j,$=>!B($))]}a.split=T;function U(j,B=!1,$=[]){let Y=$.slice(),H=j(A=>{Y?Y.push(A):W.fire(A)});const F=()=>{Y&&Y.forEach(A=>W.fire(A)),Y=null},W=new p({onFirstListenerAdd(){H||(H=j(A=>W.fire(A)))},onFirstListenerDidAdd(){Y&&(B?setTimeout(F):F())},onLastListenerRemove(){H&&H.dispose(),H=null}});return W.event}a.buffer=U;class Q{constructor(B){this.event=B}map(B){return new Q(o(this.event,B))}forEach(B){return new Q(h(this.event,B))}filter(B){return new Q(s(this.event,B))}reduce(B,$){return new Q(u(this.event,B,$))}latch(){return new Q(R(this.event))}debounce(B,$=100,Y=!1,H){return new Q(L(this.event,B,$,Y,H))}on(B,$,Y){return this.event(B,$,Y)}once(B,$,Y){return l(this.event)(B,$,Y)}}function se(j){return new Q(j)}a.chain=se;function ne(j,B,$=Y=>Y){const Y=(...A)=>W.fire($(...A)),H=()=>j.on(B,Y),F=()=>j.removeListener(B,Y),W=new p({onFirstListenerAdd:H,onLastListenerRemove:F});return W.event}a.fromNodeEventEmitter=ne;function V(j,B,$=Y=>Y){const Y=(...A)=>W.fire($(...A)),H=()=>j.addEventListener(B,Y),F=()=>j.removeEventListener(B,Y),W=new p({onFirstListenerAdd:H,onLastListenerRemove:F});return W.event}a.fromDOMEventEmitter=V;function J(j){return new Promise(B=>l(j)(B))}a.toPromise=J;function q(j,B){return B(void 0),j($=>B($))}a.runAndSubscribe=q;function K(j,B){let $=null;function Y(F){$?.dispose(),$=new D.DisposableStore,B(F,$)}Y(void 0);const H=j(F=>Y(F));return(0,D.toDisposable)(()=>{H.dispose(),$?.dispose()})}a.runAndSubscribeWithStore=K})(P=e.Event||(e.Event={}));class f{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${f._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let m=-1;function E(a){const l=m;return m=a,{dispose(){m=l}}}e.setGlobalLeakWarningThreshold=E;class I{constructor(l,o=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=o,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let o=m;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||l<o)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(h)||0;if(this._stacks.set(h,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let i,r=0;for(const[u,d]of this._stacks)(!i||r<d)&&(i=u,r=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${r}):`),console.warn(i)}return()=>{const i=this._stacks.get(h)||0;this._stacks.set(h,i-1)}}}class p{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=m>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(l,o,h)=>{this._listeners||(this._listeners=new C.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(o?[l,o]:l);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,o);const r=this._leakageMon?.check(this._listeners.size),u=(0,D.toDisposable)(()=>{r&&r(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(u):Array.isArray(h)&&h.push(u),u}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,h]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,h):o[0].call(o[1],h)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=p;class S extends p{async fireAsync(l,o,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,l]);for(;this._asyncDeliveryQueue.size>0&&!o.isCancellationRequested;){const[s,i]=this._asyncDeliveryQueue.shift(),r=[],u={...i,token:o,waitUntil:d=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");h&&(d=h(d,typeof s=="function"?s:s[0])),r.push(d)}};try{typeof s=="function"?s.call(void 0,u):s[0].call(s[1],u)}catch(d){(0,v.onUnexpectedError)(d);continue}Object.freeze(r),await Promise.allSettled(r).then(d=>{for(const b of d)b.status==="rejected"&&(0,v.onUnexpectedError)(b.reason)})}}}}e.AsyncEmitter=S;class t extends p{constructor(l){super(l);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=t;class g extends t{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=g;class y extends p{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(o=>super.fire(o)),this._queuedEvents=[]})}}e.MicrotaskEmitter=y;class w{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new p({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const o={event:l,listener:null};this.events.push(o),this.hasListeners&&this.hook(o);const h=()=>{this.hasListeners&&this.unhook(o);const s=this.events.indexOf(o);this.events.splice(s,1)};return(0,D.toDisposable)((0,n.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(o=>this.emitter.fire(o))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=w;class M{constructor(){this.buffers=[]}wrapEvent(l){return(o,h,s)=>l(i=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>o.call(h,i)):o.call(h,i)},void 0,s)}bufferEvents(l){const o=[];this.buffers.push(o);const h=l();return this.buffers.pop(),o.forEach(s=>s()),h}}e.EventBufferer=M;class c{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new p({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(ee[21],te([0,1,4]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(P,f){const m=setTimeout(P.bind(f),0);return{dispose(){clearTimeout(m)}}});var D;(function(P){function f(m){return m===P.None||m===P.Cancelled||m instanceof C?!0:!m||typeof m!="object"?!1:typeof m.isCancellationRequested=="boolean"&&typeof m.onCancellationRequested=="function"}P.isCancellationToken=f,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(ee[110],te([0,1,21]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new v.CancellationTokenSource,P=this.task(k.token);return this.result={promise:P,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=n;class D{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const P=JSON.stringify(k);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=D}),define(ee[51],te([0,1,15,2]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function C(c){const a=c;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(c,a){return new P(c,a)}e.newWriteableStream=k;class P{constructor(a,l){this.reducer=a,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(l=>l(a))}emitError(a){this.listeners.error.length===0?(0,v.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(l=>l(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,l){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(a,l){if(this.state.destroyed)return;let o;switch(a){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const h=o.indexOf(l);h>=0&&o.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(c,a){const l=[];let o;for(;(o=c.read())!==null;)l.push(o);return a(l)}e.consumeReadable=f;function m(c,a,l){const o=[];let h;for(;(h=c.read())!==null&&o.length<l;)o.push(h);return h===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof h!="undefined"){const s=h;return h=void 0,s}return c.read()}}}e.peekReadable=m;function E(c,a){return new Promise((l,o)=>{const h=[];I(c,{onData:s=>{a&&h.push(s)},onError:s=>{a?o(s):l(void 0)},onEnd:()=>{l(a?a(h):void 0)}})})}e.consumeStream=E;function I(c,a){let l=!1;return c.on("error",o=>{l||a.onError(o)}),c.on("end",()=>{l||a.onEnd()}),c.on("data",o=>{l||a.onData(o)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=I;function p(c,a){return new Promise((l,o)=>{const h=new n.DisposableStore,s=[],i=d=>{if(s.push(d),s.length>a)return h.dispose(),c.pause(),l({stream:c,buffer:s,ended:!1})},r=d=>o(d),u=()=>l({stream:c,buffer:s,ended:!0});h.add((0,n.toDisposable)(()=>c.removeListener("error",r))),c.on("error",r),h.add((0,n.toDisposable)(()=>c.removeListener("end",u))),c.on("end",u),h.add((0,n.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=p;function S(c,a){const l=k(a);return l.end(c),l}e.toStream=S;function t(){const c=k(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function g(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=g;function y(c,a,l){const o=k(l);return I(c,{onData:h=>o.write(a.data(h)),onError:h=>o.error(a.error?a.error(h):h),onEnd:()=>o.end()}),o}e.transform=y;function w(c,a,l){let o=!1;return{read:()=>{const h=a.read();return o?h:(o=!0,h!==null?l([c,h]):c)}}}e.prefixedReadable=w;function M(c,a,l){let o=!1;const h=k(l);return I(a,{onData:s=>o?h.write(s):(o=!0,h.write(l([c,s]))),onError:s=>h.error(s),onEnd:()=>{o||(o=!0,h.write(c)),h.end()}}),h}e.prefixedStream=M}),define(ee[17],te([0,1,51]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let D,C;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return n?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return n&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,L){return!(L?.dontUseNodeBuffer||!1)&&n?new k(Buffer.from(b)):(D||(D=new TextEncoder),new k(D.encode(b)))}static fromByteArray(b){const L=k.alloc(b.length);for(let R=0,T=b.length;R<T;R++)L.buffer[R]=b[R];return L}static concat(b,L){if(typeof L=="undefined"){L=0;for(let U=0,Q=b.length;U<Q;U++)L+=b[U].byteLength}const R=k.alloc(L);let T=0;for(let U=0,Q=b.length;U<Q;U++){const se=b[U];R.set(se,T),T+=se.byteLength}return R}clone(){const b=k.alloc(this.byteLength);return b.set(this),b}toString(){return n?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(b,L){return new k(this.buffer.subarray(b,L))}set(b,L){if(b instanceof k)this.buffer.set(b.buffer,L);else if(b instanceof Uint8Array)this.buffer.set(b,L);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),L);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),L);else throw new Error("Unkown argument 'array'")}readUInt32BE(b){return m(this.buffer,b)}writeUInt32BE(b,L){E(this.buffer,b,L)}readUInt32LE(b){return I(this.buffer,b)}writeUInt32LE(b,L){p(this.buffer,b,L)}readUInt8(b){return S(this.buffer,b)}writeUInt8(b,L){t(this.buffer,b,L)}}e.VSBuffer=k;function P(d,b){return d[b+0]<<0>>>0|d[b+1]<<8>>>0}e.readUInt16LE=P;function f(d,b,L){d[L+0]=b&255,b=b>>>8,d[L+1]=b&255}e.writeUInt16LE=f;function m(d,b){return d[b]*2**24+d[b+1]*2**16+d[b+2]*2**8+d[b+3]}e.readUInt32BE=m;function E(d,b,L){d[L+3]=b,b=b>>>8,d[L+2]=b,b=b>>>8,d[L+1]=b,b=b>>>8,d[L]=b}e.writeUInt32BE=E;function I(d,b){return d[b+0]<<0>>>0|d[b+1]<<8>>>0|d[b+2]<<16>>>0|d[b+3]<<24>>>0}e.readUInt32LE=I;function p(d,b,L){d[L+0]=b&255,b=b>>>8,d[L+1]=b&255,b=b>>>8,d[L+2]=b&255,b=b>>>8,d[L+3]=b&255}e.writeUInt32LE=p;function S(d,b){return d[b]}e.readUInt8=S;function t(d,b,L){d[L]=b}e.writeUInt8=t;function g(d){return v.consumeReadable(d,b=>k.concat(b))}e.readableToBuffer=g;function y(d){return v.toReadable(d)}e.bufferToReadable=y;function w(d){return v.consumeStream(d,b=>k.concat(b))}e.streamToBuffer=w;async function M(d){return d.ended?k.concat(d.buffer):k.concat([...d.buffer,await w(d.stream)])}e.bufferedStreamToBuffer=M;function c(d){return v.toStream(d,b=>k.concat(b))}e.bufferToStream=c;function a(d){return v.transform(d,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=a;function l(d){return v.newWriteableStream(b=>k.concat(b),d)}e.newWriteableBufferStream=l;function o(d,b){return v.prefixedReadable(d,b,L=>k.concat(L))}e.prefixedBufferReadable=o;function h(d,b){return v.prefixedStream(d,b,L=>k.concat(L))}e.prefixedBufferStream=h;function s(d){let b=0,L=0,R=0;const T=new Uint8Array(Math.floor(d.length/4*3)),U=se=>{switch(L){case 3:T[R++]=b|se,L=0;break;case 2:T[R++]=b|se>>>2,b=se<<6,L=3;break;case 1:T[R++]=b|se>>>4,b=se<<4,L=2;break;default:b=se<<2,L=1}};for(let se=0;se<d.length;se++){const ne=d.charCodeAt(se);if(ne>=65&&ne<=90)U(ne-65);else if(ne>=97&&ne<=122)U(ne-97+26);else if(ne>=48&&ne<=57)U(ne-48+52);else if(ne===43||ne===45)U(62);else if(ne===47||ne===95)U(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${d[se]}`)}}const Q=R;for(;L>0;)U(0);return k.wrap(T).slice(0,Q)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:d},b=!0,L=!1){const R=L?r:i;let T="";const U=d.byteLength%3;let Q=0;for(;Q<d.byteLength-U;Q+=3){const se=d[Q+0],ne=d[Q+1],V=d[Q+2];T+=R[se>>>2],T+=R[(se<<4|ne>>>4)&63],T+=R[(ne<<2|V>>>6)&63],T+=R[V&63]}if(U===1){const se=d[Q+0];T+=R[se>>>2],T+=R[se<<4&63],b&&(T+="==")}else if(U===2){const se=d[Q+0],ne=d[Q+1];T+=R[se>>>2],T+=R[(se<<4|ne>>>4)&63],T+=R[ne<<2&63],b&&(T+="=")}return T}e.encodeBase64=u}),define(ee[25],te([0,1,110,107]),function(G,e,v,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function C(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=C;const k=/{(\d+)}/g;function P(X,...ae){return ae.length===0?X:X.replace(k,function(ue,pe){const Ie=parseInt(pe,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?ue:ae[Ie]})}e.format=P;const f=/{([^}]+)}/g;function m(X,ae){return X.replace(f,(ue,pe)=>ae[pe]??ue)}e.format2=m;function E(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=E;function I(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function p(X,ae){let ue=0;const pe=ae.charCodeAt(0);for(let Ie=X.length-1;Ie>=0;Ie--)X.charCodeAt(Ie)===pe&&ue++;return ue}e.count=p;function S(X,ae,ue="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ue}`}e.truncate=S;function t(X,ae=" "){const ue=g(X,ae);return y(ue,ae)}e.trim=t;function g(X,ae){if(!X||!ae)return X;const ue=ae.length;if(ue===0||X.length===0)return X;let pe=0;for(;X.indexOf(ae,pe)===pe;)pe=pe+ue;return X.substring(pe)}e.ltrim=g;function y(X,ae){if(!X||!ae)return X;const ue=ae.length,pe=X.length;if(ue===0||pe===0)return X;let Ie=pe,Re=-1;for(;Re=X.lastIndexOf(ae,Ie-1),!(Re===-1||Re+ue!==Ie);){if(Re===0)return"";Ie=Re}return X.substring(0,Ie)}e.rtrim=y;function w(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=w;function M(X){return X.replace(/\*/g,"")}e.stripWildcards=M;function c(X,ae,ue={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=I(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let pe="";return ue.global&&(pe+="g"),ue.matchCase||(pe+="i"),ue.multiline&&(pe+="m"),ue.unicode&&(pe+="u"),new RegExp(X,pe)}e.createRegExp=c;function a(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function l(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function o(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=o;function h(X){return X.split(/\r\n|\r|\n/)}e.splitLines=h;function s(X){for(let ae=0,ue=X.length;ae<ue;ae++){const pe=X.charCodeAt(ae);if(pe!==32&&pe!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function i(X,ae=0,ue=X.length){for(let pe=ae;pe<ue;pe++){const Ie=X.charCodeAt(pe);if(Ie!==32&&Ie!==9)return X.substring(ae,pe)}return X.substring(ae,ue)}e.getLeadingWhitespace=i;function r(X,ae=X.length-1){for(let ue=ae;ue>=0;ue--){const pe=X.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function u(X,ae){return X<ae?-1:X>ae?1:0}e.compare=u;function d(X,ae,ue=0,pe=X.length,Ie=0,Re=ae.length){for(;ue<pe&&Ie<Re;ue++,Ie++){let Ne=X.charCodeAt(ue),We=ae.charCodeAt(Ie);if(Ne<We)return-1;if(Ne>We)return 1}const _e=pe-ue,Ke=Re-Ie;return _e<Ke?-1:_e>Ke?1:0}e.compareSubstring=d;function b(X,ae){return L(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=b;function L(X,ae,ue=0,pe=X.length,Ie=0,Re=ae.length){for(;ue<pe&&Ie<Re;ue++,Ie++){let Ne=X.charCodeAt(ue),We=ae.charCodeAt(Ie);if(Ne===We)continue;if(Ne>=128||We>=128)return d(X.toLowerCase(),ae.toLowerCase(),ue,pe,Ie,Re);R(Ne)&&(Ne-=32),R(We)&&(We-=32);const $e=Ne-We;if($e!==0)return $e}const _e=pe-ue,Ke=Re-Ie;return _e<Ke?-1:_e>Ke?1:0}e.compareSubstringIgnoreCase=L;function R(X){return X>=97&&X<=122}e.isLowerAsciiLetter=R;function T(X){return X>=65&&X<=90}e.isUpperAsciiLetter=T;function U(X,ae){return X.length===ae.length&&L(X,ae)===0}e.equalsIgnoreCase=U;function Q(X,ae){const ue=ae.length;return ae.length>X.length?!1:L(X,ae,0,ue)===0}e.startsWithIgnoreCase=Q;function se(X,ae){let ue,pe=Math.min(X.length,ae.length);for(ue=0;ue<pe;ue++)if(X.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return pe}e.commonPrefixLength=se;function ne(X,ae){let ue,pe=Math.min(X.length,ae.length);const Ie=X.length-1,Re=ae.length-1;for(ue=0;ue<pe;ue++)if(X.charCodeAt(Ie-ue)!==ae.charCodeAt(Re-ue))return ue;return pe}e.commonSuffixLength=ne;function V(X){return 55296<=X&&X<=56319}e.isHighSurrogate=V;function J(X){return 56320<=X&&X<=57343}e.isLowSurrogate=J;function q(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=q;function K(X,ae,ue){const pe=X.charCodeAt(ue);if(V(pe)&&ue+1<ae){const Ie=X.charCodeAt(ue+1);if(J(Ie))return q(pe,Ie)}return pe}e.getNextCodePoint=K;function j(X,ae){const ue=X.charCodeAt(ae-1);if(J(ue)&&ae>1){const pe=X.charCodeAt(ae-2);if(V(pe))return q(pe,ue)}return ue}class B{constructor(ae,ue=0){this._str=ae,this._len=ae.length,this._offset=ue}get offset(){return this._offset}setOffset(ae){this._offset=ae}prevCodePoint(){const ae=j(this._str,this._offset);return this._offset-=ae>=65536?2:1,ae}nextCodePoint(){const ae=K(this._str,this._len,this._offset);return this._offset+=ae>=65536?2:1,ae}eol(){return this._offset>=this._len}}e.CodePointIterator=B;class ${constructor(ae,ue=0){this._iterator=new B(ae,ue)}get offset(){return this._iterator.offset}nextGraphemeLength(){const ae=Be.getInstance(),ue=this._iterator,pe=ue.offset;let Ie=ae.getGraphemeBreakType(ue.nextCodePoint());for(;!ue.eol();){const Re=ue.offset,_e=ae.getGraphemeBreakType(ue.nextCodePoint());if(Te(Ie,_e)){ue.setOffset(Re);break}Ie=_e}return ue.offset-pe}prevGraphemeLength(){const ae=Be.getInstance(),ue=this._iterator,pe=ue.offset;let Ie=ae.getGraphemeBreakType(ue.prevCodePoint());for(;ue.offset>0;){const Re=ue.offset,_e=ae.getGraphemeBreakType(ue.prevCodePoint());if(Te(_e,Ie)){ue.setOffset(Re);break}Ie=_e}return pe-ue.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=$;function Y(X,ae){return new $(X,ae).nextGraphemeLength()}e.nextCharLength=Y;function H(X,ae){return new $(X,ae).prevGraphemeLength()}e.prevCharLength=H;function F(X,ae){ae>0&&J(X.charCodeAt(ae))&&ae--;const ue=ae+Y(X,ae);return[ue-H(X,ue),ue]}e.getCharContainingOffset=F;const W=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function A(X){return W.test(X)}e.containsRTL=A;const _=/^[\t\n\r\x20-\x7E]*$/;function N(X){return _.test(X)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function O(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=O;function z(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=z;function x(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=x;function ie(X,ae){if(X.length<ae)return X;const ue=/\b/g;let pe=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<ae);)pe=ue.lastIndex,ue.lastIndex+=1;return X.substring(pe).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(X){return X&&(X=X.replace(oe,""),X=X.replace(Z,""),X=X.replace(ce,"")),X}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function ge(X){return he(X)?X.substr(1):X}e.stripUTF8BOM=ge;function be(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ue=ae.length,pe=X.toLowerCase();let Ie=0,Re=-1;for(;Ie<ue;){const _e=pe.indexOf(ae[Ie],Re+1);if(_e<0)return!1;Re=_e,Ie++}return!0}e.fuzzyContains=be;function fe(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=fe;function me(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=me;function Se(X,ae=1){if(ae===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=Se;function Pe(X){const ae=90-65+1;return X=X%(2*ae),X<ae?String.fromCharCode(97+X):String.fromCharCode(65+X-ae)}e.singleLetterHash=Pe;function Me(X){return Be.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=Me;function Te(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var Oe;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=He()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,pe=ue.length/3;let Ie=1;for(;Ie<=pe;)if(ae<ue[3*Ie])Ie=2*Ie;else if(ae>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}Be._INSTANCE=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function wt(X,ae){if(X===0)return 0;const ue=at(X,ae);if(ue!==void 0)return ue;const pe=new B(ae,X);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=wt;function at(X,ae){const ue=new B(ae,X);let pe=ue.prevCodePoint();for(;ct(pe)||pe===65039||pe===8419;){if(ue.offset===0)return;pe=ue.prevCodePoint()}if(!x(pe))return;let Ie=ue.offset;return Ie>0&&ue.prevCodePoint()===8205&&(Ie=ue.offset),Ie}function ct(X){return 127995<=X&&X<=127999}var lt;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={})),e.noBreakWhitespace="\xA0";class Ve{constructor(ae){this.confusableDictionary=ae}static getInstance(ae){return Ve.cache.get(Array.from(ae))}static getLocales(){return Ve._locales.getValue()}isAmbiguous(ae){return this.confusableDictionary.has(ae)}getPrimaryConfusable(ae){return this.confusableDictionary.get(ae)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Ve,D=Ve,Ve.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.cache=new v.LRUCachedComputed(X=>{function ae(We){const $e=new Map;for(let qe=0;qe<We.length;qe+=2)$e.set(We[qe],We[qe+1]);return $e}function ue(We,$e){const qe=new Map(We);for(const[Ye,ut]of $e)qe.set(Ye,ut);return qe}function pe(We,$e){if(!We)return $e;const qe=new Map;for(const[Ye,ut]of We)$e.has(Ye)&&qe.set(Ye,ut);return qe}const Ie=D.ambiguousCharacterData.getValue();let Re=X.filter(We=>!We.startsWith("_")&&We in Ie);Re.length===0&&(Re=["_default"]);let _e;for(const We of Re){const $e=ae(Ie[We]);_e=pe(_e,$e)}const Ke=ae(Ie._common),Ne=ue(Ke,_e);return new Ve(Ne)}),Ve._locales=new n.Lazy(()=>Object.keys(Ve.ambiguousCharacterData.getValue()).filter(X=>!X.startsWith("_")));class je{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(je.getRawData())),this._data}static isInvisibleCharacter(ae){return je.getData().has(ae)}static get codePoints(){return je.getData()}}e.InvisibleCharacters=je,je._data=void 0}),define(ee[82],te([0,1,25]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(w){return D(w,0)}e.hash=n;function D(w,M){switch(typeof w){case"object":return w===null?C(349,M):Array.isArray(w)?f(w,M):m(w,M);case"string":return P(w,M);case"boolean":return k(w,M);case"number":return C(w,M);case"undefined":return C(937,M);default:return C(617,M)}}e.doHash=D;function C(w,M){return(M<<5)-M+w|0}e.numberHash=C;function k(w,M){return C(w?433:863,M)}function P(w,M){M=C(149417,M);for(let c=0,a=w.length;c<a;c++)M=C(w.charCodeAt(c),M);return M}e.stringHash=P;function f(w,M){return M=C(104579,M),w.reduce((c,a)=>D(a,c),M)}function m(w,M){return M=C(181387,M),Object.keys(w).sort().reduce((c,a)=>(c=P(a,c),D(w[a],c)),M)}class E{constructor(){this._value=0}get value(){return this._value}hash(M){return this._value=D(M,this._value),this._value}}e.Hasher=E;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(w,M,c=32){const a=c-M,l=~((1<<a)-1);return(w<<M|(l&w)>>>a)>>>0}function S(w,M=0,c=w.byteLength,a=0){for(let l=0;l<c;l++)w[M+l]=a}function t(w,M,c="0"){for(;w.length<M;)w=c+w;return w}function g(w,M=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((w>>>0).toString(16),M/4)}e.toHexString=g;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(M){const c=M.length;if(c===0)return;const a=this._buff;let l=this._buffLen,o=this._leftoverHighSurrogate,h,s;for(o!==0?(h=o,s=-1,o=0):(h=M.charCodeAt(0),s=0);;){let i=h;if(v.isHighSurrogate(h))if(s+1<c){const r=M.charCodeAt(s+1);v.isLowSurrogate(r)?(s++,i=v.computeCodePoint(h,r)):i=65533}else{o=h;break}else v.isLowSurrogate(h)&&(i=65533);if(l=this._push(a,l,i),s++,s<c)h=M.charCodeAt(s);else break}this._buffLen=l,this._leftoverHighSurrogate=o}_push(M,c,a){return a<128?M[c++]=a:a<2048?(M[c++]=192|(a&1984)>>>6,M[c++]=128|(a&63)>>>0):a<65536?(M[c++]=224|(a&61440)>>>12,M[c++]=128|(a&4032)>>>6,M[c++]=128|(a&63)>>>0):(M[c++]=240|(a&1835008)>>>18,M[c++]=128|(a&258048)>>>12,M[c++]=128|(a&4032)>>>6,M[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,M[0]=M[64+0],M[1]=M[64+1],M[2]=M[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const M=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(M/4294967296),!1),this._buffDV.setUint32(60,M%4294967296,!1),this._step()}_step(){const M=y._bigBlock32,c=this._buffDV;for(let d=0;d<64;d+=4)M.setUint32(d,c.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)M.setUint32(d,p(M.getUint32(d-12,!1)^M.getUint32(d-32,!1)^M.getUint32(d-56,!1)^M.getUint32(d-64,!1),1),!1);let a=this._h0,l=this._h1,o=this._h2,h=this._h3,s=this._h4,i,r,u;for(let d=0;d<80;d++)d<20?(i=l&o|~l&h,r=1518500249):d<40?(i=l^o^h,r=1859775393):d<60?(i=l&o|l&h|o&h,r=2400959708):(i=l^o^h,r=3395469782),u=p(a,5)+i+s+r+M.getUint32(d*4,!1)&4294967295,s=h,h=o,o=p(l,30),l=a,a=u;this._h0=this._h0+a&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+o&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(G,e,v,n,D){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!D:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?D.call(G,v):D?D.value=v:e.set(G,v),v},Ge=this&&this.__classPrivateFieldGet||function(G,e,v,n){if(v==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!n:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?n:v==="a"?n.call(G):n?n.value:e.get(G)};define(ee[35],te([0,1,31,25]),function(G,e,v,n){"use strict";var D,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(s,i,r){let u=s.get(i);return u===void 0&&(u=r,s.set(i,u)),u}e.getOrSet=P;function f(s){const i=[];return s.forEach((r,u)=>{i.push(`${u} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=f;function m(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=m;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),u=this._value.charCodeAt(this._pos);return r-u}value(){return this._value[this._pos]}}e.StringIterator=E;class I{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class p{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const u=this._value.charCodeAt(r);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var S;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(S||(S={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(y||(y={}));class w{constructor(i){this._iter=i}static forUris(i=()=>!1){return new w(new t(i))}static forPaths(i=!1){return new w(new p(void 0,!i))}static forStrings(){return new w(new E)}static forConfigKeys(){return new w(new I)}clear(){this._root=void 0}fill(i,r){if(r){const u=r.slice(0);(0,v.shuffle)(u);for(let d of u)this.set(d,i)}else{const u=i.slice(0);(0,v.shuffle)(u);for(let d of u)this.set(d[0],d[1])}}set(i,r){const u=this._iter.reset(i);let d;this._root||(this._root=new g,this._root.segment=u.value());const b=[];for(d=this._root;;){const R=u.cmp(d.segment);if(R>0)d.left||(d.left=new g,d.left.segment=u.value()),b.push([-1,d]),d=d.left;else if(R<0)d.right||(d.right=new g,d.right.segment=u.value()),b.push([1,d]),d=d.right;else if(u.hasNext())u.next(),d.mid||(d.mid=new g,d.mid.segment=u.value()),b.push([0,d]),d=d.mid;else break}const L=d.value;d.value=r,d.key=i;for(let R=b.length-1;R>=0;R--){const T=b[R][1];T.updateHeight();const U=T.balanceFactor();if(U<-1||U>1){const Q=b[R][0],se=b[R+1][0];if(Q===1&&se===1)b[R][1]=T.rotateLeft();else if(Q===-1&&se===-1)b[R][1]=T.rotateRight();else if(Q===1&&se===-1)T.right=b[R+1][1]=b[R+1][1].rotateRight(),b[R][1]=T.rotateLeft();else if(Q===-1&&se===1)T.left=b[R+1][1]=b[R+1][1].rotateLeft(),b[R][1]=T.rotateRight();else throw new Error;if(R>0)switch(b[R-1][0]){case-1:b[R-1][1].left=b[R][1];break;case 1:b[R-1][1].right=b[R][1];break;case 0:b[R-1][1].mid=b[R][1];break}else this._root=b[0][1]}}return L}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let u=this._root;for(;u;){const d=r.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else break}return u}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const u=this._iter.reset(i),d=[];let b=this._root;for(;b;){const L=u.cmp(b.segment);if(L>0)d.push([-1,b]),b=b.left;else if(L<0)d.push([1,b]),b=b.right;else if(u.hasNext())u.next(),d.push([0,b]),b=b.mid;else break}if(!!b){if(r?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const L=this._min(b.right),{key:R,value:T,segment:U}=L;this._delete(L.key,!1),b.key=R,b.value=T,b.segment=U}else{const L=b.left??b.right;if(d.length>0){const[R,T]=d[d.length-1];switch(R){case-1:T.left=L;break;case 0:T.mid=L;break;case 1:T.right=L;break}}else this._root=L}for(let L=d.length-1;L>=0;L--){const R=d[L][1];R.updateHeight();const T=R.balanceFactor();if(T>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),d[L][1]=R.rotateLeft()):T<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),d[L][1]=R.rotateRight()),L>0)switch(d[L-1][0]){case-1:d[L-1][1].left=d[L][1];break;case 1:d[L-1][1].right=d[L][1];break;case 0:d[L-1][1].mid=d[L][1];break}else this._root=d[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let u=this._root,d;for(;u;){const b=r.cmp(u.segment);if(b>0)u=u.left;else if(b<0)u=u.right;else if(r.hasNext())r.next(),d=u.value||d,u=u.mid;else break}return u&&u.value||d}findSuperstr(i){const r=this._iter.reset(i);let u=this._root;for(;u;){const d=r.cmp(u.segment);if(d>0)u=u.left;else if(d<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(i){for(const[r,u]of this)i(u,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const u=r.balanceFactor();return u<-1||u>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=w;class M{constructor(i,r){this.uri=i,this.value=r}}class c{constructor(i,r){this[D]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=r??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new M(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[u,d]of this.map)i(d.value,d.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=s=>s.toString();var a;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class l{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const u=this._map.get(i);if(!!u)return r!==0&&this.touch(u,r),u.value}set(i,r,u=0){let d=this._map.get(i);if(d)d.value=r,u!==0&&this.touch(d,u);else{switch(d={key:i,value:r,next:void 0,previous:void 0},u){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(i,d),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const u=this._state;let d=this._head;for(;d;){if(r?i.bind(r)(d.value,d.key,this):i(d.value,d.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const i=this,r=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.key,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return d}values(){const i=this,r=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:u.value,done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return d}entries(){const i=this,r=this._state;let u=this._head;const d={[Symbol.iterator](){return d},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const b={value:[u.key,u.value],done:!1};return u=u.next,b}else return{value:void 0,done:!0}}};return d}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,u=this.size;for(;r&&u>i;)this._map.delete(r.key),r=r.next,u--;this._head=r,this._size=u,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,u=i.previous;if(!r||!u)throw new Error("Invalid list");r.previous=u,u.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const u=i.next,d=i.previous;i===this._tail?(d.next=void 0,this._tail=d):(u.previous=d,d.next=u),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const u=i.next,d=i.previous;i===this._head?(u.previous=void 0,this._head=u):(u.previous=d,d.next=u),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,u)=>{i.push([u,r])}),i}fromJSON(i){this.clear();for(const[r,u]of i)this.set(r,u)}}e.LinkedMap=l;class o extends l{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class h{constructor(i){k.set(this,void 0),kt(this,k,i,"f")}get size(){return Ge(this,k,"f").size}forEach(i,r){Ge(this,k,"f").forEach(i,r)}get(i){return Ge(this,k,"f").get(i)}has(i){return Ge(this,k,"f").has(i)}entries(){return Ge(this,k,"f").entries()}keys(){return Ge(this,k,"f").keys()}values(){return Ge(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ge(this,k,"f").entries()}}e.ReadonlyMapView=h}),define(ee[70],te([0,1,35]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new v.LRUCache(1e4);function D(m){return f(m,"NFC",n)}e.normalizeNFC=D;const C=new v.LRUCache(1e4);function k(m){return f(m,"NFD",C)}e.normalizeNFD=k;const P=/[^\u0000-\u0080]/;function f(m,E,I){if(!m)return m;const p=I.get(m);if(p)return p;let S;return P.test(m)?S=m.normalize(E):S=m,I.set(m,S),S}e.removeAccents=function(){const m=/[\u0300-\u036f]/g;return function(E){return k(E).replace(m,"")}}()}),define(ee[13],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(b){return Array.isArray(b)}e.isArray=v;function n(b){return typeof b=="string"}e.isString=n;function D(b){return Array.isArray(b)&&b.every(L=>n(L))}e.isStringArray=D;function C(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=C;function k(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=k;function P(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=P;function f(b){return b===!0||b===!1}e.isBoolean=f;function m(b){return typeof b=="undefined"}e.isUndefined=m;function E(b){return!I(b)}e.isDefined=E;function I(b){return m(b)||b===null}e.isUndefinedOrNull=I;function p(b,L){if(!b)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=p;function S(b){if(I(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=S;function t(...b){const L=[];for(let R=0;R<b.length;R++){const T=b[R];if(I(T))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);L.push(T)}return L}e.assertAllDefined=t;const g=Object.prototype.hasOwnProperty;function y(b){if(!C(b))return!1;for(let L in b)if(g.call(b,L))return!1;return!0}e.isEmptyObject=y;function w(b){return typeof b=="function"}e.isFunction=w;function M(...b){return b.length>0&&b.every(w)}e.areFunctions=M;function c(b,L){const R=Math.min(b.length,L.length);for(let T=0;T<R;T++)a(b[T],L[T])}e.validateConstraints=c;function a(b,L){if(n(L)){if(typeof b!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(w(L)){try{if(b instanceof L)return}catch{}if(!I(b)&&b.constructor===L||L.length===1&&L.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function l(b){let L=[],R=Object.getPrototypeOf(b);for(;Object.prototype!==R;)L=L.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return L}e.getAllPropertyNames=l;function o(b){const L=[];for(const R of l(b))typeof b[R]=="function"&&L.push(R);return L}e.getAllMethodNames=o;function h(b,L){const R=U=>function(){const Q=Array.prototype.slice.call(arguments,0);return L(U,Q)};let T={};for(const U of b)T[U]=R(U);return T}e.createProxyObject=h;function s(b){return b===null?void 0:b}e.withNullAsUndefined=s;function i(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=i;function r(b){return class{constructor(){return new Proxy({},{get(L,R){if(L[R])return L[R];throw new Error(`Not Implemented: ${b}->${String(R)}`)}})}}}e.NotImplementedProxy=r;function u(b,L="Unreachable"){throw new Error(L)}e.assertNever=u;function d(b){return!!b&&typeof b.then=="function"&&typeof b.catch=="function"}e.isPromise=d}),define(ee[27],te([0,1,9,3,25,13]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function P(r){return r.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=P;function f(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=f;function m(r,u=v.posix.sep){if(!r)return"";const d=r.length,b=r.charCodeAt(0);if(k(b)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let R=3;const T=R;for(;R<d&&!k(r.charCodeAt(R));R++);if(T!==R&&!k(r.charCodeAt(R+1))){for(R+=1;R<d;R++)if(k(r.charCodeAt(R)))return r.slice(0,R+1).replace(/[\\/]/g,u)}}return u}else if(w(b)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+u:r.slice(0,2);let L=r.indexOf("://");if(L!==-1){for(L+=3;L<d;L++)if(k(r.charCodeAt(L)))return r.slice(0,L+1)}return""}e.getRoot=m;function E(r){if(!n.isWindows||!r||r.length<5)return!1;let u=r.charCodeAt(0);if(u!==92||(u=r.charCodeAt(1),u!==92))return!1;let d=2;const b=d;for(;d<r.length&&(u=r.charCodeAt(d),u!==92);d++);return!(b===d||(u=r.charCodeAt(d+1),isNaN(u)||u===92))}e.isUNC=E;const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,u=n.isWindows){const d=u?I:p;return!(!r||r.length===0||/^\s+$/.test(r)||(d.lastIndex=0,d.test(r))||u&&S.test(r)||r==="."||r===".."||u&&r[r.length-1]==="."||u&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function g(r,u,d){const b=r===u;return!d||b?b:!r||!u?!1:(0,D.equalsIgnoreCase)(r,u)}e.isEqual=g;function y(r,u,d,b=v.sep){if(r===u)return!0;if(!r||!u||u.length>r.length)return!1;if(d){if(!(0,D.startsWithIgnoreCase)(r,u))return!1;if(u.length===r.length)return!0;let R=u.length;return u.charAt(u.length-1)===b&&R--,r.charAt(R)===b}return u.charAt(u.length-1)!==b&&(u+=b),r.indexOf(u)===0}e.isEqualOrParent=y;function w(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=w;function M(r,u){return n.isWindows&&r.endsWith(":")&&(r+=v.sep),(0,v.isAbsolute)(r)||(r=(0,v.join)(u,r)),r=(0,v.normalize)(r),n.isWindows?(r=(0,D.rtrim)(r,v.sep),r.endsWith(":")&&(r+=v.sep)):(r=(0,D.rtrim)(r,v.sep),r||(r=v.sep)),r}e.sanitizeFilePath=M;function c(r){const u=(0,v.normalize)(r);return n.isWindows?r.length>3?!1:a(u)&&(r.length===2||u.charCodeAt(2)===92):u===v.posix.sep}e.isRootOrDriveLetter=c;function a(r,u){return(u!==void 0?u:n.isWindows)?w(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function l(r){return a(r)?r[0]:void 0}e.getDriveLetter=l;function o(r,u,d){return u.length>r.length?-1:r===u?0:(d&&(r=r.toLowerCase(),u=u.toLowerCase()),r.indexOf(u))}e.indexOfPath=o;function h(r){const u=r.split(":");let d,b,L;for(const R of u){const T=Number(R);(0,C.isNumber)(T)?b===void 0?b=T:L===void 0&&(L=T):d=d?[d,R].join(":"):R}if(!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:b!==void 0?b:void 0,column:L!==void 0?L:b!==void 0?1:void 0}}e.parseLineAndColumnAware=h;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,u,d=8){let b="";for(let R=0;R<d;R++)b+=s.charAt(Math.floor(Math.random()*s.length));let L;return u?L=`${u}-${b}`:L=b,r?(0,v.join)(r,L):L}e.randomPath=i}),define(ee[47],te([0,1,13]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const y=Array.isArray(g)?[]:{};return Object.keys(g).forEach(w=>{g[w]&&typeof g[w]=="object"?y[w]=n(g[w]):y[w]=g[w]}),y}e.deepClone=n;function D(g){if(!g||typeof g!="object")return g;const y=[g];for(;y.length>0;){const w=y.shift();Object.freeze(w);for(const M in w)if(C.call(w,M)){const c=w[M];typeof c=="object"&&!Object.isFrozen(c)&&y.push(c)}}return g}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function k(g,y){return P(g,y,new Set)}e.cloneAndChange=k;function P(g,y,w){if((0,v.isUndefinedOrNull)(g))return g;const M=y(g);if(typeof M!="undefined")return M;if((0,v.isArray)(g)){const c=[];for(const a of g)c.push(P(a,y,w));return c}if((0,v.isObject)(g)){if(w.has(g))throw new Error("Cannot clone recursive data-structure");w.add(g);const c={};for(let a in g)C.call(g,a)&&(c[a]=P(g[a],y,w));return w.delete(g),c}return g}function f(g,y,w=!0){return(0,v.isObject)(g)?((0,v.isObject)(y)&&Object.keys(y).forEach(M=>{M in g?w&&((0,v.isObject)(g[M])&&(0,v.isObject)(y[M])?f(g[M],y[M],w):g[M]=y[M]):g[M]=y[M]}),g):y}e.mixin=f;function m(g,y){if(g===y)return!0;if(g==null||y===null||y===void 0||typeof g!=typeof y||typeof g!="object"||Array.isArray(g)!==Array.isArray(y))return!1;let w,M;if(Array.isArray(g)){if(g.length!==y.length)return!1;for(w=0;w<g.length;w++)if(!m(g[w],y[w]))return!1}else{const c=[];for(M in g)c.push(M);c.sort();const a=[];for(M in y)a.push(M);if(a.sort(),!m(c,a))return!1;for(w=0;w<c.length;w++)if(!m(g[c[w]],y[c[w]]))return!1}return!0}e.equals=m;function E(g){const y=new Set;return JSON.stringify(g,(w,M)=>{if((0,v.isObject)(M)||Array.isArray(M)){if(y.has(M))return"[Circular]";y.add(M)}return M})}e.safeStringify=E;function I(g,y,w){const M=y(g);return typeof M=="undefined"?w:M}e.getOrDefault=I;function p(g,y){const w=Object.create(null);return!g||!y||Object.keys(y).forEach(c=>{const a=g[c],l=y[c];m(a,l)||(w[c]=l)}),w}e.distinct=p;function S(g,y){const w=y.toLowerCase(),M=Object.keys(g).find(c=>c.toLowerCase()===w);return M?g[M]:g[y]}e.getCaseInsensitive=S;function t(g,y){const w=Object.create(null);for(const[M,c]of Object.entries(g))y(M,c)&&(w[M]=c);return w}e.filter=t}),define(ee[7],te([0,1,9,3]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,k=/^\/\//;function P(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(s,i){return!s&&!i?"file":s}function m(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const E="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(i,r,u,d,b,L=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=f(i,L),this.authority=r||E,this.path=m(this.scheme,u||E),this.query=d||E,this.fragment=b||E,P(this,L))}static isUri(i){return i instanceof S?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:u,path:d,query:b,fragment:L}=i;return r===void 0?r=this.scheme:r===null&&(r=E),u===void 0?u=this.authority:u===null&&(u=E),d===void 0?d=this.path:d===null&&(d=E),b===void 0?b=this.query:b===null&&(b=E),L===void 0?L=this.fragment:L===null&&(L=E),r===this.scheme&&u===this.authority&&d===this.path&&b===this.query&&L===this.fragment?this:new g(r,u,d,b,L)}static parse(i,r=!1){const u=p.exec(i);return u?new g(u[2]||E,h(u[4]||E),h(u[5]||E),h(u[7]||E),h(u[9]||E),r):new g(E,E,E,E,E)}static file(i){let r=E;if(n.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const u=i.indexOf(I,2);u===-1?(r=i.substring(2),i=I):(r=i.substring(2,u),i=i.substring(u)||I)}return new g("file",r,i,E,E)}static from(i){const r=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return P(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return n.isWindows&&i.scheme==="file"?u=S.file(v.win32.join(c(i,!0),...r)).path:u=v.posix.join(i.path,...r),i.with({path:u})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof S)return i;{const r=new g(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=S;const t=n.isWindows?1:void 0;class g extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let r,u=-1;for(let d=0;d<s.length;d++){const b=s.charCodeAt(d);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)u!==-1&&(r+=encodeURIComponent(s.substring(u,d)),u=-1),r!==void 0&&(r+=s.charAt(d));else{r===void 0&&(r=s.substr(0,d));const L=y[b];L!==void 0?(u!==-1&&(r+=encodeURIComponent(s.substring(u,d)),u=-1),r+=L):u===-1&&(u=d)}}return u!==-1&&(r+=encodeURIComponent(s.substring(u))),r!==void 0?r:s}function M(s){let i;for(let r=0;r<s.length;r++){const u=s.charCodeAt(r);u===35||u===63?(i===void 0&&(i=s.substr(0,r)),i+=y[u]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function c(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=c;function a(s,i){const r=i?M:w;let u="",{scheme:d,authority:b,path:L,query:R,fragment:T}=s;if(d&&(u+=d,u+=":"),(b||d==="file")&&(u+=I,u+=I),b){let U=b.indexOf("@");if(U!==-1){const Q=b.substr(0,U);b=b.substr(U+1),U=Q.indexOf(":"),U===-1?u+=r(Q,!1):(u+=r(Q.substr(0,U),!1),u+=":",u+=r(Q.substr(U+1),!1)),u+="@"}b=b.toLowerCase(),U=b.indexOf(":"),U===-1?u+=r(b,!1):(u+=r(b.substr(0,U),!1),u+=b.substr(U))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const U=L.charCodeAt(1);U>=65&&U<=90&&(L=`/${String.fromCharCode(U+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const U=L.charCodeAt(0);U>=65&&U<=90&&(L=`${String.fromCharCode(U+32)}:${L.substr(2)}`)}u+=r(L,!0)}return R&&(u+="?",u+=r(R,!1)),T&&(u+="#",u+=i?T:w(T,!1)),u}function l(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+l(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(s){return s.match(o)?s.replace(o,i=>l(i)):s}}),define(ee[111],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(m){const E=m;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=n;function D(m){const E=[];let I;try{const p=JSON.parse(m.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),I=S.__$stack),E.push(...p)}catch{E.push("Unable to log remote console arguments",m.arguments)}return{args:E,stack:I}}e.parse=D;function C(m){if(typeof m!="string")return C(D(m).stack);const E=m;if(E){const I=k(E),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:v.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.getFirstFrame=C;function k(m){if(!m)return m;const E=m.indexOf(`
`);return E===-1?m:m.substring(0,E)}function P(m,E){const{args:I,stack:p}=D(m),S=typeof I[0]=="string"&&I.length===1;let t=k(p);t&&(t=`(${t.trim()})`);let g=[];if(typeof I[0]=="string"?t&&S?g=[`%c[${E}] %c${I[0]} %c${t}`,f("blue"),f(""),f("grey")]:g=[`%c[${E}] %c${I[0]}`,f("blue"),f(""),...I.slice(1)]:g=[`%c[${E}]%`,f("blue"),...I],t&&!S&&g.push(t),typeof console[m.severity]!="function")throw new Error("Unknown console method");console[m.severity].apply(console,g)}e.log=P;function f(m){return`color: ${m}`}}),define(ee[112],te([0,1,17,25,7]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(E){return JSON.stringify(E,f)}e.stringify=C;function k(E){let I=JSON.parse(E);return I=m(I),I}e.parse=k;var P;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function f(E,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,n.regExpFlags)(I)}:I}function m(E,I=0){if(!E||I>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return D.URI.revive(E);case 2:return new RegExp(E.source,E.flags)}if(E instanceof v.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let p=0;p<E.length;++p)E[p]=m(E[p],I+1);else for(const p in E)Object.hasOwnProperty.call(E,p)&&(E[p]=m(E[p],I+1))}return E}e.revive=m}),define(ee[10],te([0,1,3,7]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,m,E){this._hosts[f]=m,this._ports[f]=E}setConnectionToken(f,m){this._connectionTokens[f]=m}rewrite(f){if(this._delegate)return this._delegate(f);const m=f.authority;let E=this._hosts[m];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const I=this._ports[m],p=this._connectionTokens[m];let S=`path=${encodeURIComponent(f.path)}`;return typeof p=="string"&&(S+=`&tkn=${encodeURIComponent(p)}`),n.URI.from({scheme:v.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${E}:${I}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new C;class k{asBrowserUri(f,m){const E=this.toUri(f,m);return E.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===D.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?E.with({scheme:D.vscodeFileResource,authority:E.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(f,m){const E=this.toUri(f,m);return E.scheme===D.vscodeFileResource?E.with({scheme:D.file,authority:E.authority!==k.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(f,m){return n.URI.isUri(f)?f:n.URI.parse(m.toUrl(f))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ee[16],te([0,1,27,10,9,3,25,7]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(S){return(0,P.uriToFsPath)(S,!0)}e.originalFSPath=f;class m{constructor(t){this._ignorePathCasing=t}compare(t,g,y=!1){return t===g?0:(0,k.compare)(this.getComparisonKey(t,y),this.getComparisonKey(g,y))}isEqual(t,g,y=!1){return t===g?!0:!t||!g?!1:this.getComparisonKey(t,y)===this.getComparisonKey(g,y)}getComparisonKey(t,g=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,g,y=!1){if(t.scheme===g.scheme){if(t.scheme===n.Schemas.file)return v.isEqualOrParent(f(t),f(g),this._ignorePathCasing(t))&&t.query===g.query&&(y||t.fragment===g.fragment);if((0,e.isEqualAuthority)(t.authority,g.authority))return v.isEqualOrParent(t.path,g.path,this._ignorePathCasing(t),"/")&&t.query===g.query&&(y||t.fragment===g.fragment)}return!1}joinPath(t,...g){return P.URI.joinPath(t,...g)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let g;return t.scheme===n.Schemas.file?g=P.URI.file(D.dirname(f(t))).path:(g=D.posix.dirname(t.path),t.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),g="/")),t.with({path:g})}normalizePath(t){if(!t.path.length)return t;let g;return t.scheme===n.Schemas.file?g=P.URI.file(D.normalize(f(t))).path:g=D.posix.normalize(t.path),t.with({path:g})}relativePath(t,g){if(t.scheme!==g.scheme||!(0,e.isEqualAuthority)(t.authority,g.authority))return;if(t.scheme===n.Schemas.file){const M=D.relative(f(t),f(g));return C.isWindows?v.toSlashes(M):M}let y=t.path||"/",w=g.path||"/";if(this._ignorePathCasing(t)){let M=0;for(const c=Math.min(y.length,w.length);M<c&&!(y.charCodeAt(M)!==w.charCodeAt(M)&&y.charAt(M).toLowerCase()!==w.charAt(M).toLowerCase());M++);y=w.substr(0,M)+y.substr(M)}return D.posix.relative(y,w)}resolvePath(t,g){if(t.scheme===n.Schemas.file){const y=P.URI.file(D.resolve(f(t),g));return t.with({authority:y.authority,path:y.path})}return g=v.toPosixPath(g),t.with({path:D.posix.resolve(t.path,g)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,g){return t===g||t!==void 0&&g!==void 0&&(0,k.equalsIgnoreCase)(t,g)}hasTrailingPathSeparator(t,g=D.sep){if(t.scheme===n.Schemas.file){const y=f(t);return y.length>v.getRoot(y).length&&y[y.length-1]===g}else{const y=t.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,g=D.sep){return(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,g=D.sep){let y=!1;if(t.scheme===n.Schemas.file){const w=f(t);y=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===g}else{g="/";const w=t.path;y=w.length===1&&w.charCodeAt(w.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path+"/"}):t}}e.ExtUri=m,e.extUri=new m(()=>!1),e.extUriBiasedIgnorePathCase=new m(S=>S.scheme===n.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new m(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(S,t){const g=[];for(let y=0;y<S.length;y++){const w=t(S[y]);S.some((M,c)=>c===y?!1:(0,e.isEqualOrParent)(w,t(M)))||g.push(S[y])}return g}e.distinctParents=E;var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function t(g){const y=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,l]=c.split(":");a&&l&&y.set(a,l)});const M=g.path.substring(0,g.path.indexOf(";"));return M&&y.set(S.META_DATA_MIME,M),y}S.parseMetaData=t})(I=e.DataUri||(e.DataUri={}));function p(S,t,g){if(t){let y=S.path;return y&&y[0]!==D.posix.sep&&(y=D.posix.sep+y),S.with({scheme:g,authority:t,path:y})}return S.with({scheme:g})}e.toLocalResource=p}),define(ee[8],te([0,1,21,15,4,2,16,3]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(W){return!!W&&typeof W.then=="function"}e.isThenable=f;function m(W){const A=new v.CancellationTokenSource,_=W(A.token),N=new Promise((O,z)=>{const x=A.token.onCancellationRequested(()=>{x.dispose(),A.dispose(),z((0,n.canceled)())});Promise.resolve(_).then(ie=>{x.dispose(),A.dispose(),O(ie)},ie=>{x.dispose(),A.dispose(),z(ie)})});return new class{cancel(){A.cancel()}then(O,z){return N.then(O,z)}catch(O){return this.then(void 0,O)}finally(O){return N.finally(O)}}}e.createCancelablePromise=m;function E(W,A,_){return Promise.race([W,new Promise(N=>A.onCancellationRequested(()=>N(_)))])}e.raceCancellation=E;async function I(W){let A=-1;const _=W.map((O,z)=>O.then(x=>(A=z,x))),N=await Promise.race(_);return W.forEach((O,z)=>{z!==A&&O.cancel()}),N}e.raceCancellablePromises=I;function p(W,A,_){let N;const O=setTimeout(()=>{N?.(void 0),_?.()},A);return Promise.race([W.finally(()=>clearTimeout(O)),new Promise(z=>N=z)])}e.raceTimeout=p;function S(W){return new Promise((A,_)=>{const N=W();f(N)?N.then(A,_):A(N)})}e.asPromise=S;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const _=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(_,_).then(N)})}return new Promise((_,N)=>{this.queuedPromise.then(_,N)})}return this.activePromise=A(),new Promise((_,N)=>{this.activePromise.then(O=>{this.activePromise=null,_(O)},O=>{this.activePromise=null,N(O)})})}}e.Throttler=t;class g{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=g;class y{constructor(){this.promiseMap=new Map}queue(A,_){const O=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.promiseMap.get(A)===O&&this.promiseMap.delete(A)});return this.promiseMap.set(A,O),O}}e.SequencerByKey=y;const w=(W,A)=>{let _=!0;const N=setTimeout(()=>{_=!1,A()},W);return{isTriggered:()=>_,dispose:()=>{clearTimeout(N),_=!1}}},M=W=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,W())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,_=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,z)=>{this.doResolve=O,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}}));const N=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=_===e.MicrotaskDelay?M(N):w(_,N),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,n.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class a{constructor(A){this.delayer=new c(A),this.throttler=new t}trigger(A,_){return this.delayer.trigger(()=>this.throttler.queue(A),_)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class l{constructor(){this._isOpen=!1,this._promise=new Promise((A,_)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class o extends l{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function h(W,A){return A?new Promise((_,N)=>{const O=setTimeout(()=>{z.dispose(),_()},W),z=A.onCancellationRequested(()=>{clearTimeout(O),z.dispose(),N((0,n.canceled)())})}):m(_=>h(W,_))}e.timeout=h;function s(W,A=0){const _=setTimeout(W,A);return(0,C.toDisposable)(()=>clearTimeout(_))}e.disposableTimeout=s;function i(W){const A=[];let _=0;const N=W.length;function O(){return _<N?W[_++]():null}function z(x){x!=null&&A.push(x);const ie=O();return ie?ie.then(z):Promise.resolve(A)}return Promise.resolve(null).then(z)}e.sequence=i;function r(W,A=N=>!!N,_=null){let N=0;const O=W.length,z=()=>{if(N>=O)return Promise.resolve(_);const x=W[N++];return Promise.resolve(x()).then(oe=>A(oe)?Promise.resolve(oe):z())};return z()}e.first=r;function u(W,A=N=>!!N,_=null){if(W.length===0)return Promise.resolve(_);let N=W.length;const O=()=>{N=-1;for(const z of W)z.cancel?.()};return new Promise((z,x)=>{for(const ie of W)ie.then(oe=>{--N>=0&&A(oe)?(O(),z(oe)):N===0&&z(_)}).catch(oe=>{--N>=0&&(O(),x(oe))})})}e.firstParallel=u;class d{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((_,N)=>{this.outstandingPromises.push({factory:A,c:_,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const _=A.factory();_.then(A.c,A.e),_.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=d;class b extends d{constructor(){super(1)}}e.Queue=b;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new j;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,_=k.extUri){const N=_.getComparisonKey(A);let O=this.queues.get(N);return O||(O=new b,D.Event.once(O.onFinished)(()=>{O?.dispose(),this.queues.delete(N),this.onDidQueueFinish()}),this.queues.set(N,O)),O}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class R{constructor(A,_){this._token=-1,typeof A=="function"&&typeof _=="number"&&this.setIfNotSet(A,_)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,_){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},_)}setIfNotSet(A,_){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},_))}}e.TimeoutTimer=R;class T{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,_){this.cancel(),this._token=setInterval(()=>{A()},_)}}e.IntervalTimer=T;class U{constructor(A,_){this.timeoutToken=-1,this.runner=A,this.timeout=_,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=U;class Q{constructor(A,_){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=_,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=Q;class se extends U{constructor(A,_){super(A,_);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class ne extends C.Disposable{constructor(A,_,N,O){super();this.maxWorkChunkSize=A,this.maxPendingWork=_,this.throttleDelay=N,this.handler=O,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.maxPendingWork)return!1}else if(this.pending+A.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,P.setTimeout0)(()=>{if(A)return;const _=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(W,A)=>{const _=requestIdleCallback(W,typeof A=="number"?{timeout:A}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(_))}}}}();class V{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(_){this._error=_}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function J(W,A,_){let N;for(let O=0;O<_;O++)try{return await W()}catch(z){N=z,await h(A)}throw N}e.retry=J;class q{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,_,N){return this._pending={taskId:A,cancel:()=>N?.(),promise:_},_.then(()=>this.donePending(A),()=>this.donePending(A)),_}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let _,N;const O=new Promise((z,x)=>{_=z,N=x});this._next={run:A,promise:O,promiseResolve:_,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=q;class K{constructor(A,_=()=>Date.now()){this.interval=A,this.nowFn=_,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class j{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,_)=>{this.completeCallback=A,this.errorCallback=_})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(_=>{this.completeCallback(A),this.resolved=!0,_()})}error(A){return new Promise(_=>{this.errorCallback(A),this.rejected=!0,_()})}cancel(){new Promise(A=>{this.errorCallback((0,n.canceled)()),this.rejected=!0,A()})}}e.DeferredPromise=j;var B;(function(W){async function A(N){let O;const z=await Promise.all(N.map(x=>x.then(ie=>ie,ie=>{O||(O=ie)})));if(typeof O!="undefined")throw O;return z}W.settled=A;function _(N){return new Promise(async(O,z)=>{try{await N(O,z)}catch(x){z(x)}})}W.withAsyncBody=_})(B=e.Promises||(e.Promises={}));var $;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})($||($={}));class Y{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const _={emitOne:N=>this.emitOne(N),emitMany:N=>this.emitMany(N),reject:N=>this.reject(N)};try{await Promise.resolve(A(_)),this.resolve()}catch(N){this.reject(N)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}static fromArray(A){return new Y(_=>{_.emitMany(A)})}static fromPromise(A){return new Y(async _=>{_.emitMany(await A)})}static fromPromises(A){return new Y(async _=>{await Promise.all(A.map(async N=>_.emitOne(await N)))})}static merge(A){return new Y(async _=>{await Promise.all(A.map(async N=>{for await(const O of N)_.emitOne(O)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,_){return new Y(async N=>{for await(const O of A)N.emitOne(_(O))})}map(A){return Y.map(this,A)}static filter(A,_){return new Y(async N=>{for await(const O of A)_(O)&&N.emitOne(O)})}filter(A){return Y.filter(this,A)}static coalesce(A){return Y.filter(A,_=>!!_)}coalesce(){return Y.coalesce(this)}static async toPromise(A){const _=[];for await(const N of A)_.push(N);return _}toPromise(){return Y.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class H extends Y{constructor(A,_){super(_);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function F(W){const A=new v.CancellationTokenSource,_=W(A.token);return new H(A,async N=>{const O=A.token.onCancellationRequested(()=>{O.dispose(),A.dispose(),N.reject((0,n.canceled)())});try{for await(const z of _){if(A.token.isCancellationRequested)return;N.emitOne(z)}O.dispose(),A.dispose()}catch(z){O.dispose(),A.dispose(),N.reject(z)}})}e.createCancelableAsyncIterable=F}),define(ee[113],te([0,1,8,27,35,9,25]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const f="[/\\\\]",m="[^/\\\\]",E=/\//g;function I(j){switch(j){case 0:return"";case 1:return`${m}*?`;default:return`(?:${f}|${m}+${f}|${f}${m}+)*?`}}function p(j,B){if(!j)return[];const $=[];let Y=!1,H=!1,F="";for(const W of j){switch(W){case B:if(!Y&&!H){$.push(F),F="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":H=!0;break;case"]":H=!1;break}F+=W}return F&&$.push(F),$}e.splitGlobAware=p;function S(j){if(!j)return"";let B="";const $=p(j,e.GLOB_SPLIT);if($.every(Y=>Y===e.GLOBSTAR))B=".*";else{let Y=!1;$.forEach((H,F)=>{if(H===e.GLOBSTAR){Y||(B+=I(2),Y=!0);return}let W=!1,A="",_=!1,N="";for(const O of H){if(O!=="}"&&W){A+=O;continue}if(_&&(O!=="]"||!N)){let z;O==="-"?z=O:(O==="^"||O==="!")&&!N?z="^":O===e.GLOB_SPLIT?z="":z=k.escapeRegExpCharacters(O),N+=z;continue}switch(O){case"{":W=!0;continue;case"[":_=!0;continue;case"}":{B+=`(?:${p(A,",").map(ie=>S(ie)).join("|")})`,W=!1,A="";break}case"]":B+="["+N+"]",_=!1,N="";break;case"?":B+=m;continue;case"*":B+=I(1);continue;default:B+=k.escapeRegExpCharacters(O)}}F<$.length-1&&($[F+1]!==e.GLOBSTAR||F+2<$.length)&&(B+=f),Y=!1})}return B}const t=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,w=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,M=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,a=new D.LRUCache(1e4),l=function(){return!1},o=function(){return null};function h(j,B){if(!j)return o;let $;typeof j!="string"?$=j.pattern:$=j,$=$.trim();const Y=`${$}_${!!B.trimForExclusions}`;let H=a.get(Y);if(H)return s(H,j);let F;if(t.test($)){const W=$.substr(4);H=function(A,_){return typeof A=="string"&&A.endsWith(W)?$:null}}else(F=g.exec(i($,B)))?H=r(F[1],$):(B.trimForExclusions?w:y).test($)?H=u($,B):(F=M.exec(i($,B)))?H=d(F[1].substr(1),$,!0):(F=c.exec(i($,B)))?H=d(F[1],$,!1):H=b($);return a.set(Y,H),s(H,j)}function s(j,B){return typeof B=="string"?j:function($,Y){return n.isEqualOrParent($,B.base)?j(C.relative(B.base,$),Y):null}}function i(j,B){return B.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function r(j,B){const $=`/${j}`,Y=`\\${j}`,H=function(W,A){return typeof W!="string"?null:A?A===j?B:null:W===j||W.endsWith($)||W.endsWith(Y)?B:null},F=[j];return H.basenames=F,H.patterns=[B],H.allBasenames=F,H}function u(j,B){const $=K(j.slice(1,-1).split(",").map(A=>h(A,B)).filter(A=>A!==o),j),Y=$.length;if(!Y)return o;if(Y===1)return $[0];const H=function(A,_){for(let N=0,O=$.length;N<O;N++)if($[N](A,_))return j;return null},F=$.find(A=>!!A.allBasenames);F&&(H.allBasenames=F.allBasenames);const W=$.reduce((A,_)=>_.allPaths?A.concat(_.allPaths):A,[]);return W.length&&(H.allPaths=W),H}function d(j,B,$){const Y=C.sep===C.posix.sep,H=Y?j:j.replace(E,C.sep),F=C.sep+H,W=C.posix.sep+j,A=$?function(_,N){return typeof _=="string"&&(_===H||_.endsWith(F)||!Y&&(_===j||_.endsWith(W)))?B:null}:function(_,N){return typeof _=="string"&&(_===H||!Y&&_===j)?B:null};return A.allPaths=[($?"*/":"./")+j],A}function b(j){try{const B=new RegExp(`^${S(j)}$`);return function($){return B.lastIndex=0,typeof $=="string"&&B.test($)?j:null}}catch{return o}}function L(j,B,$){return!j||typeof B!="string"?!1:R(j)(B,void 0,$)}e.match=L;function R(j,B={}){if(!j)return l;if(typeof j=="string"||se(j)){const $=h(j,B);if($===o)return l;const Y=function(H,F){return!!$(H,F)};return $.allBasenames&&(Y.allBasenames=$.allBasenames),$.allPaths&&(Y.allPaths=$.allPaths),Y}return J(j,B)}e.parse=R;function T(j){if(!j)return;let B;return $=>(B||(B=(j()||Promise.resolve([])).then(Y=>Y?Q(Y):{})),B.then(Y=>!!Y[$]))}e.hasSiblingPromiseFn=T;function U(j){if(!j)return;let B;return $=>{if(!B){const Y=j();B=Y?Q(Y):{}}return!!B[$]}}e.hasSiblingFn=U;function Q(j){const B={};for(const $ of j)B[$]=!0;return B}function se(j){const B=j;return B&&typeof B.base=="string"&&typeof B.pattern=="string"}e.isRelativePattern=se;function ne(j){return j.allBasenames||[]}e.getBasenameTerms=ne;function V(j){return j.allPaths||[]}e.getPathTerms=V;function J(j,B){const $=K(Object.getOwnPropertyNames(j).map(A=>q(A,j[A],B)).filter(A=>A!==o)),Y=$.length;if(!Y)return o;if(!$.some(A=>!!A.requiresSiblings)){if(Y===1)return $[0];const A=function(O,z){for(let x=0,ie=$.length;x<ie;x++){const oe=$[x](O,z);if(oe)return oe}return null},_=$.find(O=>!!O.allBasenames);_&&(A.allBasenames=_.allBasenames);const N=$.reduce((O,z)=>z.allPaths?O.concat(z.allPaths):O,[]);return N.length&&(A.allPaths=N),A}const H=function(A,_,N){let O;for(let z=0,x=$.length;z<x;z++){const ie=$[z];ie.requiresSiblings&&N&&(_||(_=C.basename(A)),O||(O=_.substr(0,_.length-C.extname(A).length)));const oe=ie(A,_,O,N);if(oe)return oe}return null},F=$.find(A=>!!A.allBasenames);F&&(H.allBasenames=F.allBasenames);const W=$.reduce((A,_)=>_.allPaths?A.concat(_.allPaths):A,[]);return W.length&&(H.allPaths=W),H}function q(j,B,$){if(B===!1)return o;const Y=h(j,$);if(Y===o)return o;if(typeof B=="boolean")return Y;if(B){const H=B.when;if(typeof H=="string"){const F=(W,A,_,N)=>{if(!N||!Y(W,A))return null;const O=H.replace("$(basename)",_),z=N(O);return(0,v.isThenable)(z)?z.then(x=>x?j:null):z?j:null};return F.requiresSiblings=!0,F}}return Y}function K(j,B){const $=j.filter(A=>!!A.basenames);if($.length<2)return j;const Y=$.reduce((A,_)=>{const N=_.basenames;return N?A.concat(N):A},[]);let H;if(B){H=[];for(let A=0,_=Y.length;A<_;A++)H.push(B)}else H=$.reduce((A,_)=>{const N=_.patterns;return N?A.concat(N):A},[]);const F=function(A,_){if(typeof A!="string")return null;if(!_){let O;for(O=A.length;O>0;O--){const z=A.charCodeAt(O-1);if(z===47||z===92)break}_=A.substr(O)}const N=Y.indexOf(_);return N!==-1?H[N]:null};F.basenames=Y,F.patterns=H,F.allBasenames=Y;const W=j.filter(A=>!A.basenames);return W.push(F),W}}),define(ee[33],te([0,1,27,10,9,3,16,25,7]),function(G,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function m(i,r,u){if(typeof i=="string"&&(i=f.URI.file(i)),u){const b=u.getWorkspaceFolder(i);if(b){const L=u.getWorkspace().folders.length>1;let R;if((0,k.isEqual)(b.uri,i)?R="":R=(0,k.relativePath)(b.uri,i),L){const T=b.name?b.name:(0,k.basename)(b.uri);R=R?T+" \u2022 "+R:T}return R}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(i.fsPath))return(0,D.normalize)(I(i.fsPath));let d=(0,D.normalize)(i.fsPath);return!C.isWindows&&r?.userHome&&(d=S(d,r.userHome.fsPath)),d}e.getPathLabel=m;function E(i){if(!i)return;typeof i=="string"&&(i=f.URI.file(i));const r=(0,k.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,v.isRootOrDriveLetter)(r)?I(r):r}e.getBaseLabel=E;function I(i,r){return(0,v.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let p=Object.create(null);function S(i,r){if(C.isWindows||!i||!r)return i;let u=p.original===r?p.normalized:void 0;return u||(u=`${(0,P.rtrim)(r,D.posix.sep)}${D.posix.sep}`,p={original:r,normalized:u}),(C.isLinux?i.startsWith(u):(0,P.startsWithIgnoreCase)(i,u))&&(i=`~/${i.substr(u.length)}`),i}e.tildify=S;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const g="\u2026",y="\\\\",w="~";function M(i,r=D.sep){const u=new Array(i.length);let d=!1;for(let b=0;b<i.length;b++){let L=i[b];if(L===""){u[b]=`.${r}`;continue}if(!L){u[b]=L;continue}d=!0;let R="";L.indexOf(y)===0?(R=L.substr(0,L.indexOf(y)+y.length),L=L.substr(L.indexOf(y)+y.length)):L.indexOf(r)===0?(R=L.substr(0,L.indexOf(r)+r.length),L=L.substr(L.indexOf(r)+r.length)):L.indexOf(w)===0&&(R=L.substr(0,L.indexOf(w)+w.length),L=L.substr(L.indexOf(w)+w.length));const T=L.split(r);for(let U=1;d&&U<=T.length;U++)for(let Q=T.length-U;d&&Q>=0;Q--){d=!1;let se=T.slice(Q,Q+U).join(r);for(let ne=0;!d&&ne<i.length;ne++)if(ne!==b&&i[ne]&&i[ne].indexOf(se)>-1){const V=Q+U===T.length,J=Q>0&&i[ne].indexOf(r)>-1?r+se:se,q=i[ne].endsWith(J);d=!V||q}if(!d){let ne="";(T[0].endsWith(":")||R!=="")&&(Q===1&&(Q=0,U++,se=T[0]+r+se),Q>0&&(ne=T[0]+r),ne=R+ne),Q>0&&(ne=ne+g+r),ne=ne+se,Q+U<T.length&&(ne=ne+r+g),u[b]=ne}}d&&(u[b]=L)}return u}e.shorten=M;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,r=Object.create(null)){const u=[];let d=!1,b="";for(const L of i)if(L==="$"||d&&L==="{")b&&u.push({value:b,type:c.TEXT}),b="",d=!0;else if(L==="}"&&d){const R=r[b];if(typeof R=="string")R.length&&u.push({value:R,type:c.VARIABLE});else if(R){const T=u[u.length-1];(!T||T.type!==c.SEPARATOR)&&u.push({value:R.label,type:c.SEPARATOR})}b="",d=!1}else b+=L;return b&&!d&&u.push({value:b,type:c.TEXT}),u.filter((L,R)=>{if(L.type===c.SEPARATOR){const T=u[R-1],U=u[R+1];return[T,U].every(Q=>Q&&(Q.type===c.VARIABLE||Q.type===c.TEXT)&&Q.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=a;function l(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function o(i,r){return C.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=o;function h(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=h;function s(i){const r=i.indexOf("/")!==-1?D.posix:D.win32,u=r.basename(i),d=r.dirname(i);return u.length?{name:u,parentPath:d}:{name:d,parentPath:""}}e.splitName=s}),define(ee[114],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(E){return E.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const p=this._uriTransformer.transformIncoming(I);return p===I?I:n(v.URI.from(p))}transformOutgoing(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:n(v.URI.from(p))}transformOutgoingURI(I){const p=this._uriTransformer.transformOutgoing(I);return p===I?I:v.URI.from(p)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function C(E,I,p){if(!E||p>200)return null;if(typeof E=="object"){if(E instanceof v.URI)return I.transformOutgoing(E);for(let S in E)if(Object.hasOwnProperty.call(E,S)){const t=C(E[S],I,p+1);t!==null&&(E[S]=t)}}return null}function k(E,I){const p=C(E,I,0);return p===null?E:p}e.transformOutgoingURIs=k;function P(E,I,p,S){if(!E||S>200)return null;if(typeof E=="object"){if(E.$mid===1)return p?v.URI.revive(I.transformIncoming(E)):I.transformIncoming(E);for(let t in E)if(Object.hasOwnProperty.call(E,t)){const g=P(E[t],I,p,S+1);g!==null&&(E[t]=g)}}return null}function f(E,I){const p=P(E,I,!1,0);return p===null?E:p}e.transformIncomingURIs=f;function m(E,I){const p=P(E,I,!0,0);return p===null?E:p}e.transformAndReviveIncomingURIs=m}),define(ee[32],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(f){return v.test(f)}e.isUUID=n;const D=new Uint8Array(16),C=[];for(let f=0;f<256;f++)C.push(f.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(f){for(let m=0;m<f.length;m++)f[m]=Math.floor(Math.random()*256);return f};function P(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let f=0,m="";return m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+="-",m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m+=C[D[f++]],m}e.generateUuid=P}),define(ee[115],te([0,1,15,4,2,3,13,25]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const f="$initialize";let m=!1;function E(s){!C.isWeb||(m||(m=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=E;var I;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(I||(I={}));class p{constructor(i,r,u,d){this.vsWorker=i,this.req=r,this.method=u,this.args=d,this.type=0}}class S{constructor(i,r,u,d){this.vsWorker=i,this.seq=r,this.res=u,this.err=d,this.type=1}}class t{constructor(i,r,u,d){this.vsWorker=i,this.req=r,this.eventName=u,this.arg=d,this.type=2}}class g{constructor(i,r,u){this.vsWorker=i,this.req=r,this.event=u,this.type=3}}class y{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class w{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const u=String(++this._lastSentReq);return new Promise((d,b)=>{this._pendingReplies[u]={resolve:d,reject:b},this._send(new p(this._workerId,u,i,r))})}listen(i,r){let u=null;const d=new n.Emitter({onFirstListenerAdd:()=>{u=String(++this._lastSentReq),this._pendingEmitters.set(u,d),this._send(new t(this._workerId,u,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(u),this._send(new y(this._workerId,u)),u=null}});return d.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let u=i.err;i.err.$isError&&(u=new Error,u.name=i.err.name,u.message=i.err.message,u.stack=i.err.stack),r.reject(u);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(d=>{this._send(new S(this._workerId,r,d,void 0))},d=>{d.detail instanceof Error&&(d.detail=(0,v.transformErrorForSerialization)(d.detail)),this._send(new S(this._workerId,r,void 0,(0,v.transformErrorForSerialization)(d)))})}_handleSubscribeEventMessage(i){const r=i.req,u=this._handler.handleEvent(i.eventName,i.arg)(d=>{this._send(new g(this._workerId,r,d))});this._pendingEvents.set(r,u)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let u=0;u<i.args.length;u++)i.args[u]instanceof ArrayBuffer&&r.push(i.args[u]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class M extends D.Disposable{constructor(i,r,u){super();let d=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{d&&d(U)})),this._protocol=new w({sendMessage:(U,Q)=>{this._worker.postMessage(U,Q)},handleMessage:(U,Q)=>{if(typeof u[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(u[U].apply(u,Q))}catch(se){return Promise.reject(se)}},handleEvent:(U,Q)=>{if(a(U)){const se=u[U].call(u,Q);if(typeof se!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return se}if(c(U)){const se=u[U];if(typeof se!="function")throw new Error(`Missing event ${U} on main thread host.`);return se}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let b=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?b=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(b=C.globals.requirejs.s.contexts._.config);const L=k.getAllMethodNames(u);this._onModuleLoaded=this._protocol.sendMessage(f,[this._worker.getId(),JSON.parse(JSON.stringify(b)),r,L]);const R=(U,Q)=>this._request(U,Q),T=(U,Q)=>this._protocol.listen(U,Q);this._lazyProxy=new Promise((U,Q)=>{d=Q,this._onModuleLoaded.then(se=>{U(l(se,R,T))},se=>{Q(se),this._onError("Worker failed to load "+r,se)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((u,d)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(u,d)},d)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=M;function c(s){return s[0]==="o"&&s[1]==="n"&&P.isUpperAsciiLetter(s.charCodeAt(2))}function a(s){return/^onDynamic/.test(s)&&P.isUpperAsciiLetter(s.charCodeAt(9))}function l(s,i,r){const u=L=>function(){const R=Array.prototype.slice.call(arguments,0);return i(L,R)},d=L=>function(R){return r(L,R)};let b={};for(const L of s){if(a(L)){b[L]=d(L);continue}if(c(L)){b[L]=r(L,void 0);continue}b[L]=u(L)}return b}class o{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new w({sendMessage:(u,d)=>{i(u,d)},handleMessage:(u,d)=>this._handleMessage(u,d),handleEvent:(u,d)=>this._handleEvent(u,d)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===f)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(u){return Promise.reject(u)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const u=this._requestHandler[i].call(this._requestHandler,r);if(typeof u!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return u}if(c(i)){const u=this._requestHandler[i];if(typeof u!="function")throw new Error(`Missing event ${i} on request handler.`);return u}throw new Error(`Malformed event name ${i}`)}initialize(i,r,u,d){this._protocol.setWorkerId(i);const R=l(d,(T,U)=>this._protocol.sendMessage(T,U),(T,U)=>this._protocol.listen(T,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(k.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,C.globals.require.config(r)),new Promise((T,U)=>{(C.globals.require||G)([u],se=>{if(this._requestHandler=se.create(R),!this._requestHandler){U(new Error("No RequestHandler!"));return}T(k.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=o;function h(s){return new o(s,null)}e.create=h}),define(ee[116],te([0,1,60,28,42]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(k,P){if(await new Promise((E,I)=>{const p=n.createReadStream(k),S=v.createHash("sha1");p.pipe(S);const t=(0,D.once)((g,y)=>{p.removeAllListeners(),S.removeAllListeners(),g?I(g):E(y)});p.once("error",t),p.once("end",t),S.once("error",t),S.once("data",g=>t(void 0,g.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.checksum=C}),define(ee[117],te([0,1,247]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(C="utf8"){this.stringDecoder=new v.StringDecoder(C),this.remaining=null}write(C){const k=[],P=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(P.length<1)return k;let f=0,m,E=f;for(;E<P.length;)if(m=P.charCodeAt(E),m===13||m===10){if(k.push(P.substring(f,E)),E++,E<P.length){const I=m;m=P.charCodeAt(E),(I===13&&m===10||I===10&&m===13)&&E++}f=E}else E++;return this.remaining=f<P.length?P.substr(f):null,k}end(){return this.remaining}}e.LineDecoder=n}),define(ee[118],te([0,1,26]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const P=k.replace(/\-/g,":").toLowerCase();return!n.has(P)}function C(){const k=(0,v.networkInterfaces)();for(let P in k){const f=k[P];if(f){for(const{mac:m}of f)if(D(m))return m}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(ee[71],te([0,1,26,15,35,32,118]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,I=0;const p=(0,v.networkInterfaces)();for(let S in p){const t=p[S];if(t)for(const{mac:g,internal:y}of t)y||(I+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(E+=1))}this._value=I>0?E/I:0}return this._value}};let P;async function f(){return P||(P=(async()=>await m()||C.generateUuid())()),P}e.getMachineId=f;async function m(){try{const E=await new Promise((p,S)=>{G(["crypto"],p,S)}),I=(0,k.getMac)();return E.createHash("sha256").update(I,"utf8").digest("hex")}catch(E){n.onUnexpectedError(E);return}}}),define(ee[24],te([0,1,28,26,119,8,27,70,9,3,16,7]),function(G,e,v,n,D,C,k,P,f,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function S(V,J=p.UNLINK){if((0,k.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return J===p.UNLINK?g(V):t(V)}async function t(V){try{const J=(0,k.randomPath)((0,n.tmpdir)());try{await v.promises.rename(V,J)}catch{return g(V)}g(J).catch(q=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function g(V){return e.Promises.rmdir(V,{recursive:!0,maxRetries:3})}function y(V){if((0,k.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(V,{recursive:!0})}e.rimrafSync=y;async function w(V,J){return a(await(J?M(V):(0,D.promisify)(v.readdir)(V)))}async function M(V){try{return await(0,D.promisify)(v.readdir)(V,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const J=[],q=await w(V);for(const K of q){let j=!1,B=!1,$=!1;try{const Y=await e.Promises.lstat((0,f.join)(V,K));j=Y.isFile(),B=Y.isDirectory(),$=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}J.push({name:K,isFile:()=>j,isDirectory:()=>B,isSymbolicLink:()=>$})}return J}function c(V){return a(v.readdirSync(V))}e.readdirSync=c;function a(V){return V.map(J=>typeof J=="string"?m.isMacintosh?(0,P.normalizeNFC)(J):J:(J.name=m.isMacintosh?(0,P.normalizeNFC)(J.name):J.name,J))}async function l(V){const J=await w(V),q=[];for(const K of J)await h.existsDirectory((0,f.join)(V,K))&&q.push(K);return q}function o(V,J=1e3){return new Promise(q=>{let K=!1;const j=setInterval(()=>{K||(K=!0,v.access(V,B=>{K=!1,B&&(clearInterval(j),q(void 0))}))},J)})}e.whenDeleted=o;var h;(function(V){async function J(j){let B;try{if(B=await e.Promises.lstat(j),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(j),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch($){if($.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(m.isWindows&&$.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(j)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw Y}throw $}}V.stat=J;async function q(j){try{const{stat:B,symbolicLink:$}=await V.stat(j);return B.isFile()&&$?.dangling!==!0}catch{}return!1}V.existsFile=q;async function K(j){try{const{stat:B,symbolicLink:$}=await V.stat(j);return B.isDirectory()&&$?.dangling!==!0}catch{}return!1}V.existsDirectory=K})(h=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new C.ResourceQueue;function i(V,J,q){return s.queueFor(I.URI.file(V),E.extUriBiasedIgnorePathCase).queue(()=>{const K=b(q);return new Promise((j,B)=>u(V,J,K,$=>$?B($):j()))})}let r=!0;function u(V,J,q,K){if(!r)return v.writeFile(V,J,{mode:q.mode,flag:q.flag},K);v.open(V,q.flag,q.mode,(j,B)=>{if(j)return K(j);v.writeFile(B,J,$=>{if($)return v.close(B,()=>K($));v.fdatasync(B,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),r=!1),v.close(B,H=>K(H))))})})}function d(V,J,q){const K=b(q);if(!r)return v.writeFileSync(V,J,{mode:K.mode,flag:K.flag});const j=v.openSync(V,K.flag,K.mode);try{v.writeFileSync(j,J);try{v.fdatasyncSync(j)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r=!1}}finally{v.closeSync(j)}}e.writeFileSync=d;function b(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,J){if(V===J)return;async function q(K){try{const j=await e.Promises.lstat(K);if(j.isDirectory()||j.isSymbolicLink())return;await e.Promises.utimes(K,j.atime,new Date)}catch{}}try{await e.Promises.rename(V,J),await q(J)}catch(K){if(V.toLowerCase()!==J.toLowerCase()&&K.code==="EXDEV"||V.endsWith("."))await R(V,J,{preserveSymlinks:!1}),await S(V,p.MOVE),await q(J);else throw K}}async function R(V,J,q){return U(V,J,{root:{source:V,target:J},options:q,handledSourcePaths:new Set})}const T=511;async function U(V,J,q){if(q.handledSourcePaths.has(V))return;q.handledSourcePaths.add(V);const{stat:K,symbolicLink:j}=await h.stat(V);if(j){if(q.options.preserveSymlinks)try{return await ne(V,J,q)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(j.dangling)return}return K.isDirectory()?Q(V,J,K.mode&T,q):se(V,J,K.mode&T)}async function Q(V,J,q,K){await e.Promises.mkdir(J,{recursive:!0,mode:q});const j=await w(V);for(const B of j)await U((0,f.join)(V,B),(0,f.join)(J,B),K)}async function se(V,J,q){await e.Promises.copyFile(V,J),await e.Promises.chmod(J,q)}async function ne(V,J,q){let K=await e.Promises.readlink(V);(0,k.isEqualOrParent)(K,q.root.source,!m.isLinux)&&(K=(0,f.join)(q.root.target,K.substr(q.root.source.length+1))),await e.Promises.symlink(K,J)}e.Promises=new class{get access(){return(0,D.promisify)(v.access)}get stat(){return(0,D.promisify)(v.stat)}get lstat(){return(0,D.promisify)(v.lstat)}get utimes(){return(0,D.promisify)(v.utimes)}get read(){return(0,D.promisify)(v.read)}get readFile(){return(0,D.promisify)(v.readFile)}get write(){return(0,D.promisify)(v.write)}get appendFile(){return(0,D.promisify)(v.appendFile)}get fdatasync(){return(0,D.promisify)(v.fdatasync)}get truncate(){return(0,D.promisify)(v.truncate)}get rename(){return(0,D.promisify)(v.rename)}get copyFile(){return(0,D.promisify)(v.copyFile)}get open(){return(0,D.promisify)(v.open)}get close(){return(0,D.promisify)(v.close)}get symlink(){return(0,D.promisify)(v.symlink)}get readlink(){return(0,D.promisify)(v.readlink)}get chmod(){return(0,D.promisify)(v.chmod)}get mkdir(){return(0,D.promisify)(v.mkdir)}get unlink(){return(0,D.promisify)(v.unlink)}get rmdir(){return(0,D.promisify)(v.rmdir)}get realpath(){return(0,D.promisify)(v.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return S}get move(){return L}get copy(){return R}}}),define(ee[83],te([0,1,28,9,3,25,24]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(p){if(D.isLinux)return p;const S=(0,n.dirname)(p);if(p===S)return p;const t=((0,n.basename)(p)||p).toLowerCase();try{const y=(0,k.readdirSync)(S).filter(w=>w.toLowerCase()===t);if(y.length===1){const w=P(S);if(w)return(0,n.join)(w,y[0])}else if(y.length>1){const w=y.indexOf(t);if(w>=0){const M=P(S);if(M)return(0,n.join)(M,y[w])}}}catch{}return null}e.realcaseSync=P;async function f(p){if(D.isLinux)return p;const S=(0,n.dirname)(p);if(p===S)return p;const t=((0,n.basename)(p)||p).toLowerCase();try{const y=(await k.Promises.readdir(S)).filter(w=>w.toLowerCase()===t);if(y.length===1){const w=await f(S);if(w)return(0,n.join)(w,y[0])}else if(y.length>1){const w=y.indexOf(t);if(w>=0){const M=await f(S);if(M)return(0,n.join)(M,y[w])}}}catch{}return null}e.realcase=f;async function m(p){try{return await k.Promises.realpath(p)}catch{const t=I(p);return await k.Promises.access(t,v.constants.R_OK),t}}e.realpath=m;function E(p){try{return v.realpathSync(p)}catch{const t=I(p);return v.accessSync(t,v.constants.R_OK),t}}e.realpathSync=E;function I(p){return(0,C.rtrim)((0,n.normalize)(p),n.sep)}}),define(ee[120],te([0,1,61]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(P,f,m,E=1){let I=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!I)return I=!0,p(0)},m);D(P,f,E,t=>{if(!I)return I=!0,clearTimeout(S),p(t)})})}e.findFreePort=n;function D(P,f,m,E){if(f===0)return E(0);const I=new v.Socket;I.once("connect",()=>(k(I),D(P+m,f-1,m,E))),I.once("data",()=>{}),I.once("error",p=>(k(I),p.code!=="ECONNREFUSED"?D(P+m,f-1,m,E):E(P))),I.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,f,m){let E=!1,I,p=1;const S=v.createServer({pauseOnConnect:!0});function t(g,y){E||(E=!0,S.removeAllListeners(),S.close(),I&&clearTimeout(I),y(g))}return new Promise(g=>{I=setTimeout(()=>{t(0,g)},m),S.on("listening",()=>{t(P,g)}),S.on("error",y=>{y&&(y.code==="EADDRINUSE"||y.code==="EACCES")&&p<f?(P++,p++,S.listen(P,"127.0.0.1")):t(0,g)}),S.on("close",()=>{t(0,g)}),S.listen(P,"127.0.0.1")})}e.findFreePortFaster=C;function k(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(f){console.error(f)}}}),define(ee[121],te([0,1,26,9,24]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,k=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var f;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(f||(f={}));let m;switch(process.arch){case"ia32":case"x32":m=1;break;case"arm":case"arm64":m=2;break;default:m=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class I{constructor(l,o,h){this.exePath=l,this.displayName=o,this.knownToExist=h}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function p({useAlternateBitness:a=!1}={}){return a?m===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:a=!1,findPreview:l=!1}={}){const o=p({useAlternateBitness:a});if(!o)return null;const h=n.join(o,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(h))return null;let s=-1,i=null;for(const d of await D.Promises.readdir(h)){let b=-1;if(l){const R=d.indexOf("-");if(R<0)continue;const T=d.substring(0,R);if(!C.test(T)||d.substring(R+1)!=="preview")continue;b=parseInt(T,10)}else{if(!C.test(d))continue;b=parseInt(d,10)}if(b<=s)continue;const L=n.join(h,d,"pwsh.exe");!await D.SymlinkSupport.existsFile(L)||(i=L,s=b)}if(!i)return null;const r=o.includes("x86")?" (x86)":"",u=l?" Preview":"";return new I(i,`PowerShell${u}${r}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:o,pwshMsixName:h}=a?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(l))if(o.test(s)){const i=n.join(l,s,"pwsh.exe");return new I(i,h)}return null}function g(){const a=n.join(v.homedir(),".dotnet","tools","pwsh.exe");return new I(a,".NET Core PowerShell Global Tool")}function y(){const a=n.join(process.env.windir,m===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(a,"Windows PowerShell",!0)}async function*w(){let a=await S();a&&(yield a),a=await S({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=g(),a&&(yield a),a=await S({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await S({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*M(){for await(const a of w())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=M;async function c(){for await(const a of M())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(ee[84],te([0,1,44,10]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((P,f)=>{let m;const E=new Map;function I(S,t,g,y,w){const M=E.get(t);if(S===k||M){const c={name:p(g),cmd:g,pid:S,ppid:t,load:y,mem:w};E.set(S,c),S===k&&(m=c),M&&(M.children||(M.children=[]),M.children.push(c),M.children.length>1&&(M.children=M.children.sort((a,l)=>a.pid-l.pid)))}}function p(S){const t=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,w=/--utility-sub-type=network/,M=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(M.exec(S))return"electron-crash-reporter";if(c.exec(S))return"winpty-process";if(a.exec(S))return"console-window-host (Windows internal process)";let o=l.exec(S);if(o&&o.length===2)return o[1]==="renderer"?t.exec(S)?"shared-process":g.exec(S)?"issue-reporter":y.exec(S)?"process-explorer":"window":o[1]==="utility"&&w.exec(S)?"utility-network-service":o[1];const h=/[a-zA-Z-]+\.js/g;let s="";do o=h.exec(S),o&&(s+=o+" ");while(o);return s&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${s}`:S}if(process.platform==="win32"){const S=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,g)=>{G(["windows-process-tree"],t,g)}).then(t=>{t.getProcessList(k,g=>{t.getProcessCpuUsage(g,y=>{const w=new Map;y.forEach(M=>{const c=S(M.commandLine||"");w.set(M.pid,{name:p(c),cmd:c,pid:M.pid,ppid:M.ppid,load:M.cpu||0,mem:M.memory||0})}),m=w.get(k),m?(w.forEach(M=>{const c=w.get(M.ppid);c&&(c.children||(c.children=[]),c.children.push(M))}),w.forEach(M=>{M.children&&(M.children=M.children.sort((c,a)=>c.pid-a.pid))}),P(m)):f(new Error(`Root process ${k} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let S=function(){let t=[m];const g=[];for(;t.length;){const w=t.shift();w&&(g.push(w.pid),w.children&&(t=t.concat(w.children)))}let y=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);y+=" "+g.join(" "),(0,v.exec)(y,{},(w,M,c)=>{if(w||c)f(w||new Error(c.toString()));else{const a=M.toString().split(`
`);for(let l=0;l<g.length;l++){const o=E.get(g[l]);o.load=parseFloat(a[l])}if(!m){f(new Error(`Root process ${k} not found`));return}P(m)}})};(0,v.exec)("which ps",{},(t,g,y)=>{if(t||y)if(process.platform!=="linux")f(t||new Error(y.toString()));else{const w=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,v.exec)(w,{},(M,c,a)=>{M||a?f(M||new Error(a.toString())):(C(c,I),S())})}else{const w=g.toString().trim(),M="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${w} ${M}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,l)=>{c||l&&!l.includes("screen size is bogus")?f(c||new Error(l.toString())):(C(a,I),process.platform==="linux"?S():m?P(m):f(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function C(k,P){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,m=k.toString().split(`
`);for(const E of m){const I=f.exec(E.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(ee[122],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(ee[123],te([0,1,14,13,122]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){v.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(P,f,m,E,I)=>{const p=k(P,E,m);p.popup({window:(0,n.withNullAsUndefined)(v.BrowserWindow.fromWebContents(P.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{p&&P.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=C;function k(P,f,m){const E=new v.Menu;return m.forEach(I=>{let p;I.type==="separator"?p=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?p=new v.MenuItem({submenu:k(P,f,I.submenu),label:I.label}):p=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(S,t,g)=>P.sender.send(f,I.id,g)}),E.append(p)}),E}});var de=this&&this.__decorate||function(G,e,v,n){var D=arguments.length,C=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,v):n,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(G,e,v,n);else for(var P=G.length-1;P>=0;P--)(k=G[P])&&(C=(D<3?k(C):D>3?k(e,v,C):k(e,v))||C);return D>3&&C&&Object.defineProperty(e,v,C),C};define(ee[37],te([0,1,31,8,17,21,46,15,4,2,112,25,13]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function t(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function y(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(w||(w={}));class M{constructor($){this.buffer=$,this.pos=0}read($){const Y=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Y.byteLength,Y}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(a||(a={}));function l(B){const $=D.VSBuffer.alloc(4);return $.writeUInt32BE(B,0),$}function o(B){return B.read(4).readUInt32BE(0)}function h(B){const $=D.VSBuffer.alloc(1);return $.writeUInt8(B,0),$}const s={Undefined:h(a.Undefined),String:h(a.String),Buffer:h(a.Buffer),VSBuffer:h(a.VSBuffer),Array:h(a.Array),Object:h(a.Object)},i=typeof Buffer!="undefined";function r(B,$){if(typeof $=="undefined")B.write(s.Undefined);else if(typeof $=="string"){const Y=D.VSBuffer.fromString($);B.write(s.String),B.write(l(Y.byteLength)),B.write(Y)}else if(i&&Buffer.isBuffer($)){const Y=D.VSBuffer.wrap($);B.write(s.Buffer),B.write(l(Y.byteLength)),B.write(Y)}else if($ instanceof D.VSBuffer)B.write(s.VSBuffer),B.write(l($.byteLength)),B.write($);else if(Array.isArray($)){B.write(s.Array),B.write(l($.length));for(const Y of $)r(B,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify($));B.write(s.Object),B.write(l(Y.byteLength)),B.write(Y)}}function u(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(o(B)).toString();case a.Buffer:return B.read(o(B)).buffer;case a.VSBuffer:return B.read(o(B));case a.Array:{const Y=o(B),H=[];for(let F=0;F<Y;F++)H.push(u(B));return H}case a.Object:return JSON.parse(B.read(o(B)).toString())}}class d{constructor($,Y,H=null,F=1e3){this.protocol=$,this.ctx=Y,this.logger=H,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel($,Y){this.channels.set($,Y),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Y=this.send([$.type]);this.logger&&this.logger.logOutgoing(Y,0,1,y($.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([$.type,$.id],$.data);this.logger&&this.logger.logOutgoing(Y,$.id,1,y($.type),$.data);return}}}send($,Y=void 0){const H=new c;return r(H,$),r(H,Y),this.sendBuffer(H.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Y=new M($),H=u(Y),F=u(Y),W=H[0];switch(W){case 100:return this.logger&&this.logger.logIncoming($.byteLength,H[1],1,`${t(W)}: ${H[2]}.${H[3]}`,F),this.onPromise({type:W,id:H[1],channelName:H[2],name:H[3],arg:F});case 102:return this.logger&&this.logger.logIncoming($.byteLength,H[1],1,`${t(W)}: ${H[2]}.${H[3]}`,F),this.onEventListen({type:W,id:H[1],channelName:H[2],name:H[3],arg:F});case 101:return this.logger&&this.logger.logIncoming($.byteLength,H[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:H[1]});case 103:return this.logger&&this.logger.logIncoming($.byteLength,H[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:H[1]})}}onPromise($){const Y=this.channels.get($.channelName);if(!Y){this.collectPendingRequest($);return}const H=new C.CancellationTokenSource;let F;try{F=Y.call(this.ctx,$.name,$.arg,H.token)}catch(_){F=Promise.reject(_)}const W=$.id;F.then(_=>{this.sendResponse({id:W,data:_,type:201}),this.activeRequests.delete($.id)},_=>{_ instanceof Error?this.sendResponse({id:W,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:W,data:_,type:203}),this.activeRequests.delete($.id)});const A=(0,m.toDisposable)(()=>H.cancel());this.activeRequests.set($.id,A)}onEventListen($){const Y=this.channels.get($.channelName);if(!Y){this.collectPendingRequest($);return}const H=$.id,W=Y.listen(this.ctx,$.name,$.arg)(A=>this.sendResponse({id:H,data:A,type:204}));this.activeRequests.set($.id,W)}disposeActiveRequest($){const Y=this.activeRequests.get($.id);Y&&(Y.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Y=this.pendingRequests.get($.channelName);Y||(Y=[],this.pendingRequests.set($.channelName,Y));const H=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:$,timeoutTimer:H})}flushPendingRequests($){const Y=this.pendingRequests.get($);if(Y){for(const H of Y)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var b;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor($,Y=null){this.protocol=$,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=Y}getChannel($){const Y=this;return{call(H,F,W){return Y.isDisposed?Promise.reject(P.canceled()):Y.requestPromise($,H,F,W)},listen(H,F){return Y.isDisposed?Promise.reject(P.canceled()):Y.requestEvent($,H,F)}}}requestPromise($,Y,H,F=C.CancellationToken.None){const W=this.lastRequestId++,_={id:W,type:100,channelName:$,name:Y,arg:H};if(F.isCancellationRequested)return Promise.reject(P.canceled());let N;return new Promise((z,x)=>{if(F.isCancellationRequested)return x(P.canceled());const ie=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete(W),z(he.data);break;case 202:{this.handlers.delete(W);const ge=new Error(he.data.message);ge.stack=he.data.stack,ge.name=he.data.name,x(ge);break}case 203:this.handlers.delete(W),x(he.data);break}};this.handlers.set(W,le),this.sendRequest(_)};let oe=null;this.state===w.Idle?ie():(oe=(0,n.createCancelablePromise)(le=>this.whenInitialized()),oe.then(()=>{oe=null,ie()}));const Z=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:W,type:101}),x(P.canceled())},ce=F.onCancellationRequested(Z);N=(0,m.combinedDisposable)((0,m.toDisposable)(Z),ce),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent($,Y,H){const F=this.lastRequestId++,A={id:F,type:102,channelName:$,name:Y,arg:H};let _=null;const N=new f.Emitter({onFirstListenerAdd:()=>{_=(0,n.createCancelablePromise)(z=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(N),this.sendRequest(A)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(N),this.sendRequest({id:F,type:103}))}}),O=z=>N.fire(z.data);return this.handlers.set(F,O),N.event}sendRequest($){switch($.type){case 100:case 102:{const Y=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger&&this.logger.logOutgoing(Y,$.id,0,`${t($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Y=this.send([$.type,$.id]);this.logger&&this.logger.logOutgoing(Y,$.id,0,t($.type));return}}}send($,Y=void 0){const H=new c;return r(H,$),r(H,Y),this.sendBuffer(H.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Y=new M($),H=u(Y),F=u(Y),W=H[0];switch(W){case 200:return this.logger&&this.logger.logIncoming($.byteLength,0,0,y(W)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming($.byteLength,H[1],0,y(W),F),this.onResponse({type:H[0],id:H[1],data:F})}}onResponse($){if($.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get($.id);Y&&Y($)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach($=>$.dispose()),this.activeRequests.clear()}}de([k.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class R{constructor($){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,$(({protocol:Y,onDidClientDisconnect:H})=>{f.Event.once(Y.onMessage)(W=>{const A=new M(W),_=u(A),N=new d(Y,_),O=new L(Y);this.channels.forEach((x,ie)=>N.registerChannel(ie,x));const z={channelServer:N,channelClient:O,ctx:_};this._connections.add(z),this._onDidAddConnection.fire(z),H(()=>{N.dispose(),O.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const $=[];return this._connections.forEach(Y=>$.push(Y)),$}getChannel($,Y){const H=this;return{call(F,W,A){let _;if((0,p.isFunction)(Y)){let O=(0,v.getRandomElement)(H.connections.filter(Y));_=O?Promise.resolve(O):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,Y))}else _=Y.routeCall(H,F,W);const N=_.then(O=>O.channelClient.getChannel($));return U(N).call(F,W,A)},listen(F,W){if((0,p.isFunction)(Y))return H.getMulticastEvent($,Y,F,W);const A=Y.routeEvent(H,F,W).then(_=>_.channelClient.getChannel($));return U(A).listen(F,W)}}}getMulticastEvent($,Y,H,F){const W=this;let A=new m.DisposableStore;const _=new f.Emitter({onFirstListenerAdd:()=>{A=new m.DisposableStore;const N=new f.EventMultiplexer,O=new Map,z=ie=>{const Z=ie.channelClient.getChannel($).listen(H,F),ce=N.add(Z);O.set(ie,ce)},x=ie=>{const oe=O.get(ie);!oe||(oe.dispose(),O.delete(ie))};W.connections.filter(Y).forEach(z),f.Event.filter(W.onDidAddConnection,Y)(z,void 0,A),W.onDidRemoveConnection(x,void 0,A),N.event(_.fire,_,A),A.add(N)},onLastListenerRemove:()=>{A.dispose()}});return _.event}registerChannel($,Y){this.channels.set($,Y),this._connections.forEach(H=>{H.channelServer.registerChannel($,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class T{constructor($,Y,H=null){const F=new c;r(F,Y),$.send(F.buffer),this.channelClient=new L($,H),this.channelServer=new d($,Y,H)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Y){this.channelServer.registerChannel($,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function U(B){return{call($,Y,H){return B.then(F=>F.call($,Y,H))},listen($,Y){const H=new f.Relay;return B.then(F=>H.input=F.listen($,Y)),H.event}}}e.getDelayedChannel=U;function Q(B){let $=!1;return{call(Y,H,F){return $?B.call(Y,H,F):(0,n.timeout)(0).then(()=>$=!0).then(()=>B.call(Y,H,F))},listen(Y,H){if($)return B.listen(Y,H);const F=new f.Relay;return(0,n.timeout)(0).then(()=>$=!0).then(()=>F.input=B.listen(Y,H)),F.event}}}e.getNextTickChannel=Q;class se{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Y of $.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await f.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=se;var ne;(function(B){function $(W,A){const _=W,N=A&&A.disableMarshalling,O=new Map;for(const z in _)H(z)&&O.set(z,f.Event.buffer(_[z],!0));return new class{listen(z,x,ie){const oe=O.get(x);if(oe)return oe;if(F(x)){const Z=_[x];if(typeof Z=="function")return Z.call(_,ie)}throw new Error(`Event not found: ${x}`)}call(z,x,ie){const oe=_[x];if(typeof oe=="function"){if(!N&&Array.isArray(ie))for(let Z=0;Z<ie.length;Z++)ie[Z]=(0,E.revive)(ie[Z]);return oe.apply(_,ie)}throw new Error(`Method not found: ${x}`)}}}B.fromService=$;function Y(W,A){const _=A&&A.disableMarshalling;return new Proxy({},{get(N,O){if(typeof O=="string")return A?.properties?.has(O)?A.properties.get(O):F(O)?function(z){return W.listen(O,z)}:H(O)?W.listen(O):async function(...z){let x;A&&!(0,p.isUndefinedOrNull)(A.context)?x=[A.context,...z]:x=z;const ie=await W.call(O,x);return _?ie:(0,E.revive)(ie)};throw new Error(`Property not found: ${String(O)}`)}})}B.toService=Y;function H(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}function F(W){return/^onDynamic/.test(W)&&I.isUpperAsciiLetter(W.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let $=B.toString();if($!=="[object Object]")return $}return B}function q(B){return Array.isArray(B)?B.map(J):J(B)}function K(B,$,Y,H,F,W,A){A=q(A);const _=V[F],N=_[H%_.length];let O=[`%c[${B}]%c[${String($).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(W)?(O=O.concat(A),O.push(")")):O.push(A),console.log.apply(console,O)}e.logWithColors=K;class j{constructor($,Y){this._outgoingPrefix=$,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Y,H,F,W){this._totalOutgoing+=$,K(this._outgoingPrefix,this._totalOutgoing,$,Y,H,F,W)}logIncoming($,Y,H,F,W){this._totalIncoming+=$,K(this._incomingPrefix,this._totalIncoming,$,Y,H,F,W)}}e.IPCLogger=j}),define(ee[124],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(ee[125],te([0,1,17,4,37]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(f){this.port=f,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",m=>v.VSBuffer.wrap(m.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class k extends D.IPCClient{constructor(f,m){const E=new C(f);super(E,m);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=k}),define(ee[85],te([0,1,17,4,2,37]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let u=0;function d(L,R){if(!r.has(L)){const T=String(++u);r.set(L,T)}return r.get(L)}function b(L,R,T,U){if(!i.enableDiagnostics)return;const Q=d(L,R);if(U instanceof v.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const se=v.VSBuffer.alloc(U.byteLength);se.set(U),i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,buff:se})}else i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,data:U})}i.traceSocketEvent=b})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let m=null;function E(){return m||(m=v.VSBuffer.alloc(0)),m}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,u){if(r===0)return E();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return u&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let d=v.VSBuffer.alloc(r),b=0,L=0;for(;r>0;){const R=this._chunks[L];if(R.byteLength>r){const T=R.slice(0,r);d.set(T,b),b+=r,u&&(this._chunks[L]=R.slice(r),this._totalLength-=r),r-=r}else d.set(R,b),b+=R.byteLength,u?(this._chunks.shift(),this._totalLength-=R.byteLength):L++,r-=R.byteLength}return d}}e.ChunkStream=I;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(p||(p={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(r,u,d,b){this.type=r,this.id=u,this.ack=d,this.data=b,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends D.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const d=this._state.messageType,b=this._state.id,L=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new g(d,b,L,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class w{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=v.VSBuffer.alloc(13);u.writeUInt8(r.type,0),u.writeUInt32BE(r.id,1),u.writeUInt32BE(r.ack,5),u.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(u,r.data)}_bufferAdd(r,u){const d=this._totalLength===0;return this._data.push(r,u),this._totalLength+=r.byteLength+u.byteLength,d}_bufferTake(){const r=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,u){this._bufferAdd(r,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class M extends D.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new w(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new g(1,0,0,r))}}e.Protocol=M;class c extends C.IPCClient{constructor(r,u,d=null){super(r,u,d);this.protocol=r}static fromSocket(r,u){return new c(new M(r),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class l{constructor(r){this.data=r,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],u=0,d=this._first;for(;d;)r[u++]=d.data,d=d.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const u=new l(r);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class h{constructor(){this.lastRuns=[];const r=Date.now();for(let u=0;u<h._HISTORY_LENGTH;u++)this.lastRuns[u]=r-1e3*u;setInterval(()=>{for(let u=h._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return h._INSTANCE||(h._INSTANCE=new h),h._INSTANCE}load(){const r=Date.now(),u=(1+h._HISTORY_LENGTH)*1e3;let d=0;for(let b=0;b<h._HISTORY_LENGTH;b++)r-this.lastRuns[b]<=u&&d++;return 1-d/h._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}h._HISTORY_LENGTH=10,h._INSTANCE=null;class s{constructor(r,u=null,d=h.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(b=>this._receiveMessage(b))),this._socketDisposables.push(this._socket.onClose(b=>this._onSocketClose.fire(b))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new g(5,0,0,E());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new g(7,0,0,E());this._socketWriter.write(r)}sendResume(){const r=new g(8,0,0,E());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new w(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new g(3,0,this._incomingAckId,E());this._socketWriter.write(r);const u=this._outgoingUnackMsg.toArray();for(let d=0,b=u.length;d<b;d++)this._socketWriter.write(u[d]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new g(6,0,0,E())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let d=0,b=u.length;d<b;d++)this._socketWriter.write(u[d]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new g(1,u,this._incomingAckId,r);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(r){const u=new g(2,0,0,r);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),u=Date.now()-r.writtenTime,d=Date.now()-this._socketReader.lastReadTime,b=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&d>=2e4&&b>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const L=Math.max(2e4-u,2e4-d,2e4-b,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},L)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new g(3,0,this._incomingAckId,E());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(ee[126],te([0,1,14,17,4,2,37,124]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(E,I){const p=D.Event.fromNodeEventEmitter(v.ipcMain,I,(t,g)=>({event:t,message:g})),S=D.Event.filter(p,({event:t})=>t.sender.id===E);return D.Event.map(S,({message:t})=>t&&n.VSBuffer.wrap(t))}class m extends k.IPCServer{constructor(){super(m.getOnDidClientConnect())}static getOnDidClientConnect(){const I=D.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:p})=>p);return D.Event.map(I,p=>{const S=p.id,t=m.Clients.get(S);t&&t.dispose();const g=new D.Emitter;m.Clients.set(S,(0,C.toDisposable)(()=>g.fire()));const y=f(S,"vscode:message"),w=D.Event.any(D.Event.signal(f(S,"vscode:disconnect")),g.event);return{protocol:new P.Protocol(p,y),onDidClientDisconnect:w}})}}e.Server=m,m.Clients=new Map}),define(ee[86],te([0,1,14,4,32,125]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends C.Client{constructor(m,E){super({addEventListener:(I,p)=>m.addListener(I,p),removeEventListener:(I,p)=>m.removeListener(I,p),postMessage:I=>m.postMessage(I),start:()=>m.start(),close:()=>m.close()},E)}}e.Client=k;async function P(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const m=(0,D.generateUuid)();f.webContents.send("vscode:createMessageChannel",m);const E=n.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(p,S)=>({nonce:S,port:p.ports[0]})),{port:I}=await n.Event.toPromise(n.Event.once(n.Event.filter(E,p=>p.nonce===m)));return I}e.connect=P}),define(ee[87],te([0,1,8,4,2,13]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function P(I){const p=I;return p?.changed instanceof Map||p?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var f;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(f||(f={}));class m extends D.Disposable{constructor(p,S=Object.create(null)){super();this.database=p,this.options=S,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((S,t)=>this.accept(t,S)),p.deleted?.forEach(S=>this.accept(S,void 0))}accept(p,S){if(this.state===f.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(S)?t=this.cache.delete(p):this.cache.get(p)!==S&&(this.cache.set(p,S),t=!0),t&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,S){const t=this.cache.get(p);return(0,C.isUndefinedOrNull)(t)?S:t}getBoolean(p,S){const t=this.get(p);return(0,C.isUndefinedOrNull)(t)?S:t==="true"}getNumber(p,S){const t=this.get(p);return(0,C.isUndefinedOrNull)(t)?S:parseInt(t,10)}async set(p,S){if(this.state===f.Closed)return;if((0,C.isUndefinedOrNull)(S))return this.delete(p);const t=String(S);if(this.cache.get(p)!==t)return this.cache.set(p,t),this.pendingInserts.set(p,t),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async delete(p){if(!(this.state===f.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(p){if(!!this.hasPending)return this.doFlush(p)}async doFlush(p){return this.flushDelayer.trigger(()=>this.flushPending(),p)}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((S,t)=>this.items.set(t,S)),p.delete&&p.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=E}),define(ee[127],te([0,1,8,4,35,9,24]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class P{constructor(E,I=Object.create(null)){this.path=E,this.options=I,this.name=(0,C.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const E=await this.whenConnected,I=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(S=>I.set(S.key,S.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(E){const I=await this.whenConnected;return this.doUpdateItems(I,E)}doUpdateItems(E,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,D.mapToString)(I.insert):"0"}), delete(${I.delete?(0,D.setToString)(I.delete):"0"})`),this.transaction(E,()=>{const p=I.insert,S=I.delete;if(p&&p.size>0){const t=[];t.push([]);let g=0;p.forEach((y,w)=>{let M=t[g];M.length>P.MAX_HOST_PARAMETERS&&(g++,M=[],t.push(M)),M.push(w,y)}),t.forEach(y=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,w=>w.run(y),()=>{const w=[];let M=0;return p.forEach((c,a)=>{w.push(a),M+=c.length}),`Keys: ${w.join(", ")} Length: ${M}`})})}if(S&&S.size){const t=[];t.push([]);let g=0;S.forEach(y=>{let w=t[g];w.length>P.MAX_HOST_PARAMETERS&&(g++,w=[],t.push(w)),w.push(y)}),t.forEach(y=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,w=>w.run(y),()=>{const w=[];return S.forEach(M=>{w.push(M)}),`Keys: ${w.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,E)}doClose(E,I){return new Promise((p,S)=>{E.db.close(t=>(t&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${t}`),this.path===P.IN_MEMORY_PATH?p():!E.isErroneous&&!E.isInMemory?this.backup().then(p,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),p())):typeof I=="function"?k.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const y=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:I()}).then(()=>y(),w=>(y(),Promise.reject(w)))})).then(p,S):S(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return k.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const I=await this.whenConnected,p=await this.get(I,E?"PRAGMA integrity_check":"PRAGMA quick_check"),S=E?p.integrity_check:p.quick_check;return I.isErroneous?`${S} (last error: ${I.lastError})`:I.isInMemory?`${S} (in-memory!)`:S}async connect(E,I=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${I})`);try{return await this.doConnect(E)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&I)return await(0,v.timeout)(P.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await k.Promises.unlink(E);try{await k.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(S){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${S}`),this.doConnect(P.IN_MEMORY_PATH)}}}handleSQLiteError(E,I){E.isErroneous=!0,E.lastError=I,this.logger.error(I)}doConnect(E){return new Promise((I,p)=>{new Promise((S,t)=>{G(["@vscode/sqlite3"],S,t)}).then(S=>{const t={db:new(this.logger.isTracing?S.verbose().Database:S.Database)(E,g=>g?t.db?t.db.close(()=>p(g)):p(g):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(t),y=>t.db.close(()=>p(y)))),isInMemory:E===P.IN_MEMORY_PATH};t.db.on("error",g=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&t.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},p)})}exec(E,I){return new Promise((p,S)=>{E.db.exec(I,t=>t?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${t}`),S(t)):p())})}get(E,I){return new Promise((p,S)=>{E.db.get(I,(t,g)=>t?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${t}`),S(t)):p(g))})}all(E,I){return new Promise((p,S)=>{E.db.all(I,(t,g)=>t?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${t}`),S(t)):p(g))})}transaction(E,I){return new Promise((p,S)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),I(),E.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${t}`),S(t)):p())})})}prepare(E,I,p,S){const t=E.db.prepare(I),g=y=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${y} (${I}). Details: ${S()}`)};t.on("error",g),p(t),t.finalize(y=>{y&&g(y),t.removeListener("error",g)})}}e.SQLiteStorageDatabase=P,P.IN_MEMORY_PATH=":memory:",P.BUSY_OPEN_TIMEOUT=2e3,P.MAX_HOST_PARAMETERS=256;class f{constructor(E){E&&typeof E.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(ee[128],te([12,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(ee[129],te([0,1,128]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,C=D*24,k=C*7,P=C*30,f=C*365;function m(I,p){typeof I!="number"&&(I=I.getTime());const S=Math.round((new Date().getTime()-I)/1e3);if(S<-30)return(0,v.localize)(0,null,m(new Date().getTime()+S*1e3,!1));if(S<30)return(0,v.localize)(1,null);let t;return S<n?(t=S,p?t===1?(0,v.localize)(2,null,t):(0,v.localize)(3,null,t):t===1?(0,v.localize)(4,null,t):(0,v.localize)(5,null,t)):S<D?(t=Math.floor(S/n),p?t===1?(0,v.localize)(6,null,t):(0,v.localize)(7,null,t):t===1?(0,v.localize)(8,null,t):(0,v.localize)(9,null,t)):S<C?(t=Math.floor(S/D),p?t===1?(0,v.localize)(10,null,t):(0,v.localize)(11,null,t):t===1?(0,v.localize)(12,null,t):(0,v.localize)(13,null,t)):S<k?(t=Math.floor(S/C),p?t===1?(0,v.localize)(14,null,t):(0,v.localize)(15,null,t):t===1?(0,v.localize)(16,null,t):(0,v.localize)(17,null,t)):S<P?(t=Math.floor(S/k),p?t===1?(0,v.localize)(18,null,t):(0,v.localize)(19,null,t):t===1?(0,v.localize)(20,null,t):(0,v.localize)(21,null,t)):S<f?(t=Math.floor(S/P),p?t===1?(0,v.localize)(22,null,t):(0,v.localize)(23,null,t):t===1?(0,v.localize)(24,null,t):(0,v.localize)(25,null,t)):(t=Math.floor(S/f),p?t===1?(0,v.localize)(26,null,t):(0,v.localize)(27,null,t):t===1?(0,v.localize)(28,null,t):(0,v.localize)(29,null,t))}e.fromNow=m;function E(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(ee[130],te([12,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(ee[39],te([0,1,31,13,130]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(m,E){return E&&(m.stack||m.stacktrace)?D.localize(0,null,P(m),k(m.stack)||k(m.stacktrace)):P(m)}function k(m){return Array.isArray(m)?m.join(`
`):m}function P(m){return typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?D.localize(1,null,m.message):m.message||D.localize(2,null)}function f(m=null,E=!1){if(!m)return D.localize(3,null);if(Array.isArray(m)){const I=v.coalesce(m),p=f(I[0],E);return I.length>1?D.localize(4,null,p,I.length):p}if(n.isString(m))return m;if(m.detail){const I=m.detail;if(I.error)return C(I.error,E);if(I.exception)return C(I.exception,E)}return m.stack?C(m,E):m.message?m.message:D.localize(5,null)}e.toErrorMessage=f}),define(ee[131],te([12,11]),function(G,e){return G.create("vs/base/common/keybindingLabels",e)}),define(ee[132],te([0,1,131]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(k,P,f=P){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=P,this.modifierLabels[3]=f}toLabel(k,P,f){if(P.length===0)return null;const m=[];for(let E=0,I=P.length;E<I;E++){const p=P[E],S=f(p);if(S===null)return null;m[E]=D(p,S,this.modifierLabels[k])}return m.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,k,P){if(k===null)return"";const f=[];return C.ctrlKey&&f.push(P.ctrlKey),C.shiftKey&&f.push(P.shiftKey),C.altKey&&f.push(P.altKey),C.metaKey&&f.push(P.metaKey),k!==""&&f.push(k),f.join(P.separator)}}),define(ee[133],te([12,11]),function(G,e){return G.create("vs/base/node/processes",e)}),define(ee[72],te([0,1,44,27,10,47,9,3,34,81,13,117,24,133]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return m.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return m.TerminateResponseCode}});function t(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(o,h){if(P.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};h&&(s.cwd=h);const i=v.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],s);return new Promise(r=>{i.once("error",u=>{r({success:!1,error:u})}),i.once("exit",(u,d)=>{r(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(P.isLinux||P.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(i=>{v.execFile(s,[o.pid.toString()],{encoding:"utf8",shell:!0},(r,u,d)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function y(o){!o||(delete o.DEBUG,P.isMacintosh&&delete o.DYLD_LIBRARY_PATH,P.isLinux&&delete o.LD_PRELOAD)}e.removeDangerousEnvVariables=y;function w(o=f.env){return o.comspec||"cmd.exe"}e.getWindowsShell=w;class M{constructor(h,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=h,this.args=s,this.shell=i,this.options=r;else{const u=h;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(f.env).forEach(d=>{u[d]=f.env[d]}),Object.keys(this.options.env).forEach(d=>{u[d]=this.options.env[d]}),this.options.env=u}}getSanitizedCommand(){let h=this.cmd.toLowerCase();const s=h.lastIndexOf(k.sep);return s!==-1&&(h=h.substring(s+1)),M.WellKnowCommands[h]?h:"other"}start(h){return P.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(f.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(s=>{let i,r;const u=new Promise((d,b)=>{i=d,r=b});if(s){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=v.exec(d,this.options,(b,L,R)=>{this.childProcess=null;const T=b;T&&T.killed?r({killed:this.terminateRequested,stdout:L.toString(),stderr:R.toString()}):this.handleExec(i,h,b,L,R)})}else{let d=null;const b=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,i,h,r);const R={terminated:this.terminateRequested};E.isNumber(L)&&(R.cmdCode=L),i(R)};if(this.shell&&P.isWindows){const L=C.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let R=!1,T=!1;const U=[];let Q=this.ensureQuotes(this.cmd);U.push(Q.value),R=Q.quoted,this.args&&this.args.forEach(ne=>{Q=this.ensureQuotes(ne),U.push(Q.value),T=T&&Q.quoted});const se=["/s","/c"];R?T?se.push('"'+U.join(" ")+'"'):U.length>1?se.push('"'+U[0]+'" '+U.slice(1).join(" ")):se.push('"'+U[0]+'"'):se.push(U.join(" ")),d=v.spawn(w(),se,L)}else this.cmd&&(d=v.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(E.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",L=>{this.childProcess=null,r({terminated:this.terminateRequested,error:L})}),d.pid&&(this.childProcess.on("close",b),this.handleSpawn(d,i,h,r,!0)))}return u})}handleClose(h,s,i,r){}ensureQuotes(h){return M.regexp.test(h)?{value:'"'+h+'"',quoted:!0}:{value:h,quoted:h.length>0&&h[0]==='"'&&h[h.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(h=>h.pid,h=>-1):new Promise(h=>{this.pidResolve=h})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(h=>(this.terminateRequested=!0,g(h,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),h=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(h=>{if(!this.shell||!P.isWindows)return h(!1);const s=v.spawn(w(),["/s","/c"]);s.on("error",i=>h(!0)),s.on("exit",i=>h(!1))})}}e.AbstractProcess=M,M.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},M.regexp=/^[^"].* .*[^"]/;class c extends M{constructor(h,s,i,r){super(h,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(h,s,i,r,u){[r,u].forEach((d,b)=>{const L=new I.LineDecoder;L.write(d).forEach(U=>{s({line:U,source:b===0?0:1})});const T=L.end();T&&s({line:T,source:b===0?0:1})}),h({terminated:this.terminateRequested,error:i})}handleSpawn(h,s,i,r,u){const d=new I.LineDecoder,b=new I.LineDecoder;h.stdout.on("data",L=>{d.write(L).forEach(T=>i({line:T,source:0}))}),h.stderr.on("data",L=>{b.write(L).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=b}handleClose(h,s,i,r){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&i({line:u,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&i({line:d,source:1})}}e.LineProcess=c;function a(o){let h=[],s=!1;const i=function(r){if(s){h.push(r);return}(!o.send(r,d=>{if(d&&console.error(d),s=!1,h.length>0){const b=h.slice(0);h=[],b.forEach(L=>i(L))}})||P.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=a;var l;(function(o){async function h(s,i,r){if(k.isAbsolute(s))return s;if(i===void 0&&(i=f.cwd()),k.dirname(s)!=="."||(r===void 0&&E.isString(f.env.PATH)&&(r=f.env.PATH.split(k.delimiter)),r===void 0||r.length===0))return k.join(i,s);async function d(b){if(await p.Promises.exists(b)){let L;try{L=await p.Promises.stat(b)}catch(R){R.message.startsWith("EACCES")&&(L=await p.Promises.lstat(b))}return L?!L.isDirectory():!1}return!1}for(let b of r){let L;if(k.isAbsolute(b)?L=k.join(b,s):L=k.join(i,b,s),await d(L))return L;let R=L+".com";if(await d(R)||(R=L+".exe",await d(R)))return R}return k.join(i,s)}o.findExecutable=h})(l=e.win32||(e.win32={}))}),define(ee[134],te([0,1,26,3,121,72]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(S,t){return S===1?n.isWindows?I():C.getWindowsShell(t):m(S,t)}e.getSystemShell=k;function P(S,t){return S===1?n.isWindows?p(t):C.getWindowsShell(t):m(S,t)}e.getSystemShellSync=P;let f=null;function m(S,t){if(n.isLinux&&S===2||n.isMacintosh&&S===3)return"/bin/bash";if(!f){let g;if(n.isWindows)g="/bin/bash";else{if(g=t.SHELL,!g)try{g=(0,v.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let E=null;async function I(){return E||(E=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),E}function p(S){if(E)return E;const t=n.isWindows&&parseFloat((0,v.release)())>=10,g=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${S.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?y:C.getWindowsShell(S)}}),define(ee[135],te([0,1,44,8,17,21,111,15,4,2,47,72,37]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends p.ChannelServer{constructor(y){super({send:w=>{try{process.send&&process.send(w.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",w=>D.VSBuffer.wrap(Buffer.from(w,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=S;class t{constructor(y,w){this.modulePath=y,this.options=w,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const M=w&&w.timeout?w.timeout:6e4;this.disposeDelayer=new n.Delayer(M),this.child=null,this._client=null}getChannel(y){const w=this;return{call(M,c,a){return w.requestPromise(y,M,c,a)},listen(M,c){return w.requestEvent(y,M,c)}}}requestPromise(y,w,M,c=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(y),l=(0,n.createCancelablePromise)(s=>a.call(w,M,s)),o=c.onCancellationRequested(()=>l.cancel()),h=(0,m.toDisposable)(()=>l.cancel());return this.activeRequests.add(h),l.finally(()=>{o.dispose(),this.activeRequests.delete(h),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(y,w,M){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let c;const a=new f.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(y).listen(w,M)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],w=Object.create(null);w.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(w.env={...w.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(w.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,I.removeDangerousEnvVariables)(w.env),this.child=(0,v.fork)(this.modulePath,y,w);const M=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,k.isRemoteConsoleLog)(i)){(0,k.log)(i,`IPC Library: ${this.options.serverName}`);return}M.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,l=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),o=M.event,h={send:l,onMessage:o};this._client=new p.ChannelClient(h);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(u=>(0,m.dispose)(u)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(y){let w=this.channels.get(y);return w||(w=this.client.getChannel(y),this.channels.set(y,w)),w}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(ee[136],te([12,11]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(ee[137],te([12,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ee[138],te([12,11]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ee[139],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(ee[140],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(ee[141],te([12,11]),function(G,e){return G.create("vs/platform/environment/node/shellEnv",e)}),define(ee[142],te([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ee[143],te([12,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(ee[144],te([12,11]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ee[145],te([12,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(ee[146],te([12,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(ee[147],te([12,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(ee[148],te([12,11]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ee[149],te([12,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ee[150],te([12,11]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ee[151],te([12,11]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(ee[152],te([12,11]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ee[153],te([12,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(ee[154],te([12,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(ee[155],te([12,11]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(ee[156],te([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/window",e)}),define(ee[157],te([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ee[158],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(ee[159],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ee[160],te([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ee[161],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function v(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=v}),define(ee[162],te([0,1,4,2]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(P,f,m){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:m[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:m[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:m[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:m[0],port:m[1],subId:m[2]}))}throw new Error("Method not implemented.")}listen(P,f,m){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends n.Disposable{constructor(P){super();this.channel=P}reload(P){this.channel.call("reload",[P])}get onReload(){return this.channel.listen("reload")}close(P){this.channel.call("close",[P])}get onClose(){return this.channel.listen("close")}attachSession(P,f,m){this.channel.call("attach",[P,f,m])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(P,f){this.channel.call("terminate",[P,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(P,f){return this.channel.call("openExtensionDevelopmentHostWindow",[P,f])}}e.ExtensionHostDebugChannelClient=C}),define(ee[163],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(k){this.driver=k}listen(k,P){throw new Error(`No event found: ${P}`)}call(k,P,f){switch(P){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${P}`)}}e.WindowDriverChannel=v;class n{constructor(k){this.channel=k}click(k,P,f){return this.channel.call("click",[k,P,f])}doubleClick(k){return this.channel.call("doubleClick",k)}setValue(k,P){return this.channel.call("setValue",[k,P])}getTitle(){return this.channel.call("getTitle")}isActiveElement(k){return this.channel.call("isActiveElement",k)}getElements(k,P){return this.channel.call("getElements",[k,P])}getElementXY(k,P,f){return this.channel.call("getElementXY",[k,P,f])}typeInEditor(k,P){return this.channel.call("typeInEditor",[k,P])}getTerminalBuffer(k){return this.channel.call("getTerminalBuffer",k)}writeInTerminal(k,P){return this.channel.call("writeInTerminal",[k,P])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class D{constructor(k){this.channel=k}registerWindowDriver(k){return this.channel.call("registerWindowDriver",k)}reloadWindowDriver(k){return this.channel.call("reloadWindowDriver",k)}}e.WindowDriverRegistryChannelClient=D}),define(ee[164],te([0,1,129,46,10,9,34,16,7]),function(G,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class m{constructor(g,y,w){this._args=g,this.paths=y,this.productService=w}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",G).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(f.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=k.env.VSCODE_PORTABLE;return g?f.URI.file((0,C.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,C.resolve)(g):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,C.resolve)(g):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,C.resolve)(g);const y=k.env.VSCODE_EXTENSIONS;if(y)return y;const w=k.env.VSCODE_PORTABLE;return w?(0,C.join)(w,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,C.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?f.URI.parse(g):f.URI.file((0,C.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],m.prototype,"appRoot",null),de([n.memoize],m.prototype,"userHome",null),de([n.memoize],m.prototype,"userDataPath",null),de([n.memoize],m.prototype,"appSettingsHome",null),de([n.memoize],m.prototype,"tmpDir",null),de([n.memoize],m.prototype,"cacheHome",null),de([n.memoize],m.prototype,"userRoamingDataHome",null),de([n.memoize],m.prototype,"settingsResource",null),de([n.memoize],m.prototype,"userDataSyncHome",null),de([n.memoize],m.prototype,"userDataSyncLogResource",null),de([n.memoize],m.prototype,"sync",null),de([n.memoize],m.prototype,"machineSettingsResource",null),de([n.memoize],m.prototype,"globalStorageHome",null),de([n.memoize],m.prototype,"workspaceStorageHome",null),de([n.memoize],m.prototype,"keybindingsResource",null),de([n.memoize],m.prototype,"keyboardLayoutResource",null),de([n.memoize],m.prototype,"argvResource",null),de([n.memoize],m.prototype,"snippetsHome",null),de([n.memoize],m.prototype,"isExtensionDevelopment",null),de([n.memoize],m.prototype,"untitledWorkspacesHome",null),de([n.memoize],m.prototype,"installSourcePath",null),de([n.memoize],m.prototype,"builtinExtensionsPath",null),de([n.memoize],m.prototype,"extensionsPath",null),de([n.memoize],m.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],m.prototype,"extensionDevelopmentKind",null),de([n.memoize],m.prototype,"extensionTestsLocationURI",null),de([n.memoize],m.prototype,"debugExtensionHost",null),de([n.memoize],m.prototype,"serviceMachineIdResource",null),de([n.memoize],m.prototype,"telemetryLogResource",null),de([n.memoize],m.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=m;function E(t,g){return S(t["inspect-extensions"],t["inspect-brk-extensions"],5870,g,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=E;function I(t,g){return S(t["inspect-search"],t["inspect-brk-search"],5876,g,t.extensionEnvironment)}e.parseSearchPort=I;function p(t,g){return S(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,g,t.extensionEnvironment)}e.parsePtyHostPort=p;function S(t,g,y,w,M,c){const l=Number(g||t)||(w?null:y),o=l?Boolean(!!g):!1;let h;if(c)try{h=JSON.parse(c)}catch{}return{port:l,break:o,debugId:M,env:h}}}),define(ee[88],te([0,1,248,3,139]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function P(t,g,y=k){const w={},M=[],c=[];for(let h in g){const s=g[h];s.alias&&(w[h]=s.alias),s.type==="string"||s.type==="string[]"?(M.push(h),s.deprecates&&M.push(...s.deprecates)):s.type==="boolean"&&(c.push(h),s.deprecates&&c.push(...s.deprecates))}const a=v(t,{string:M,boolean:c,alias:w}),l={},o=a;l._=a._.map(h=>String(h)).filter(h=>h.length>0),delete o._;for(let h in g){const s=g[h];s.alias&&delete o[s.alias];let i=o[h];if(s.deprecates)for(const r of s.deprecates)o.hasOwnProperty(r)&&(i||(i=o[r],i&&y.onDeprecatedOption(r,h)),delete o[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),y.onMultipleValues(h,i)),l[h]=i),delete o[h]}for(let h in o)y.onUnknownOption(h);return l}e.parseArgs=P;function f(t,g){let y="";return g.args&&(Array.isArray(g.args)?y=` <${g.args.join("> <")}>`:y=` <${g.args}>`),g.alias?`-${g.alias} --${t}${y}`:`--${t}${y}`}function m(t,g){let y=0,w=[];for(const l in t){const o=t[l],h=f(l,o);y=Math.max(y,h.length),w.push([h,o.description])}let M=y+2+1;if(g-M<25)return w.reduce((l,o)=>l.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);let c=g-M-1,a=[];for(const l of w){let o=l[0],h=I(l[1],c),s=E(M-o.length-2);a.push("  "+o+s+h[0]);for(let i=1;i<h.length;i++)a.push(E(M)+h[i])}return a}e.formatOptions=m;function E(t){return" ".repeat(t)}function I(t,g){let y=[];for(;t.length;){let w=t.length<g?t.length:t.lastIndexOf(" ",g),M=t.slice(0,w).trim();t=t.slice(w),y.push(M)}return y}function p(t,g,y,w,M){const c=process.stdout.isTTY&&process.stdout.columns||80,a=M?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${t} ${y}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${g} [${(0,D.localize)(35,null)}]${a}`),l.push(""),M?.noPipe!==!0&&(n.isWindows?l.push((0,D.localize)(36,null,g)):l.push((0,D.localize)(37,null,g)),l.push(""));const o={};for(const h in w){const s=w[h];if(s.description&&s.cat){let i=o[s.cat];i||(o[s.cat]=i={}),i[h]=s}}for(let h in o){const s=h;let i=o[s];i&&(l.push(C[s]),l.push(...m(i,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=p;function S(t,g){return`${t||(0,D.localize)(38,null)}
${g||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),define(ee[165],te([0,1,61,162,88]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends n.ExtensionHostDebugBroadcastChannel{constructor(P){super();this.windowsMainService=P}call(P,f,m){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(m[0],m[1]):super.call(P,f,m)}async openExtensionDevelopmentHostWindow(P,f){const m=(0,D.parseArgs)(P,D.OPTIONS);m.debugRenderer=f;const E=m.extensionDevelopmentPath;if(!E)return{success:!1};const[I]=this.windowsMainService.openExtensionDevelopmentHostWindow(E,{context:5,cli:m});if(!f)return{success:!0};const p=I.win;if(!p)return{success:!0};const S=p.webContents.debugger;let t=S.isAttached()?1/0:0;const g=(0,v.createServer)(y=>{t++==0&&S.attach();let w=!1;const M=l=>{w||y.write(JSON.stringify(l)+"\0")},c=(l,o,h,s)=>M({method:o,params:h,sessionId:s});p.on("close",()=>{S.removeListener("message",c),y.end(),w=!0}),S.addListener("message",c);let a=Buffer.alloc(0);y.on("data",l=>{a=Buffer.concat([a,l]);for(let o=a.indexOf(0);o!==-1;o=a.indexOf(0)){let h;try{const s=a.slice(0,o).toString("utf8");a=a.slice(o+1),h=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}S.sendCommand(h.method,h.params,h.sessionId).then(s=>M({id:h.id,sessionId:h.sessionId,result:s})).catch(s=>M({id:h.id,sessionId:h.sessionId,error:{code:0,message:s.message}}))}}),y.on("error",l=>{console.error("error on cdp pipe:",l)}),y.on("close",()=>{w=!0,--t==0&&S.detach()})});return await new Promise(y=>g.listen(0,y)),p.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function G(e,v,n,D){function C(P){const f=k(P),m=[f];return e.isAbsolute(f)||m.unshift(D),e.resolve(...m)}function k(P){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let m=process.env.VSCODE_APPDATA;if(m)return e.join(m,n);const E=P["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(m=process.env.APPDATA,!m){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");m=e.join(I,"AppData","Roaming")}break;case"darwin":m=e.join(v.homedir(),"Library","Application Support");break;case"linux":m=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(m,n)}return{getUserDataPath:C}}if(typeof define=="function")define(ee[166],te([0,249,26,10,16,34]),function(e,v,n,D,C,k){const P=C.dirname(D.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(C.joinPath(P,"package.json").fsPath);return G(v,n,f.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),n=require("os");module.exports=G(v,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ee[167],te([0,1,26,164,166]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends n.AbstractNativeEnvironmentService{constructor(P,f){super(P,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},f)}}e.NativeEnvironmentService=C}),define(ee[168],te([0,1,28,26,27]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(k){const P=(0,D.randomPath)((0,n.tmpdir)());try{return(0,v.writeFileSync)(P,""),k&&console.log(`Marker file for --wait created: ${P}`),P}catch(f){k&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=C}),define(ee[169],te([0,1,143]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(p){return p=p.trim(),p==="*"||n.test(p)}e.isValidVersionStr=C;function k(p){if(!C(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=p.match(n);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=k;function P(p){if(!p)return null;let S=p.majorBase,t=p.majorMustEqual,g=p.minorBase,y=p.minorMustEqual,w=p.patchBase,M=p.patchMustEqual;p.hasCaret&&(S===0||(y=!1),M=!1);let c=0;if(p.preRelease){const a=D.exec(p.preRelease);if(a){const[,l,o,h]=a;c=Date.UTC(Number(l),Number(o)-1,Number(h))}}return{majorBase:S,majorMustEqual:t,minorBase:g,minorMustEqual:y,patchBase:w,patchMustEqual:M,isMinimum:p.hasGreaterEquals,notBefore:c}}e.normalizeVersion=P;function f(p,S,t){let g;typeof p=="string"?g=P(k(p)):g=p;let y;S instanceof Date?y=S.getTime():typeof S=="string"&&(y=new Date(S).getTime());let w;if(typeof t=="string"?w=P(k(t)):w=t,!g||!w)return!1;let M=g.majorBase,c=g.minorBase,a=g.patchBase,l=w.majorBase,o=w.minorBase,h=w.patchBase,s=w.notBefore,i=w.majorMustEqual,r=w.minorMustEqual,u=w.patchMustEqual;return w.isMinimum?M>l?!0:M<l?!1:c>o?!0:c<o||y&&y<s?!1:a>=h:(M===1&&l===0&&(!i||!r||!u)&&(l=1,o=0,h=0,i=!0,r=!1,u=!1),M<l?!1:M>l?!i:c<o?!1:c>o?!r:a<h?!1:a>h?!u:!(y&&y<s))}e.isValidVersion=f;function m(p,S,t,g){return t.isBuiltin||typeof t.main=="undefined"?!0:I(p,S,t.engines.vscode,g)}e.isValidExtensionVersion=m;function E(p,S,t){return p==="*"||I(S,t,p)}e.isEngineValid=E;function I(p,S,t,g=[]){let y=P(k(t));if(!y)return g.push(v.localize(0,null,t)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return g.push(v.localize(1,null,t)),!1}else if(!y.majorMustEqual)return g.push(v.localize(2,null,t)),!1;return f(p,S,y)?!0:(g.push(v.localize(3,null,p,t)),!1)}}),define(ee[170],te([0,1,4,2,17,51,21]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class P extends n.Disposable{constructor(m,E){super();this.provider=m,this.logService=E,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(m,E,I){const p=this.getUriTransformer(m);switch(E){case"stat":return this.stat(p,I[0]);case"readdir":return this.readdir(p,I[0]);case"open":return this.open(p,I[0],I[1]);case"close":return this.close(I[0]);case"read":return this.read(I[0],I[1],I[2]);case"readFile":return this.readFile(p,I[0],I[1]);case"write":return this.write(I[0],I[1],I[2],I[3],I[4]);case"writeFile":return this.writeFile(p,I[0],I[1],I[2]);case"rename":return this.rename(p,I[0],I[1],I[2]);case"copy":return this.copy(p,I[0],I[1],I[2]);case"mkdir":return this.mkdir(p,I[0]);case"delete":return this.delete(p,I[0],I[1]);case"watch":return this.watch(p,I[0],I[1],I[2],I[3]);case"unwatch":return this.unwatch(I[0],I[1])}throw new Error(`IPC Command ${E} not found`)}listen(m,E,I){const p=this.getUriTransformer(m);switch(E){case"fileChange":return this.onFileChange(p,I[0]);case"readFileStream":return this.onReadFileStream(p,I[0],I[1])}throw new Error(`Unknown event ${E}`)}stat(m,E){const I=this.transformIncoming(m,E,!0);return this.provider.stat(I)}readdir(m,E){const I=this.transformIncoming(m,E);return this.provider.readdir(I)}async readFile(m,E,I){const p=this.transformIncoming(m,E,!0),S=await this.provider.readFile(p,I);return D.VSBuffer.wrap(S)}onReadFileStream(m,E,I){const p=this.transformIncoming(m,E,!0),S=new k.CancellationTokenSource,t=new v.Emitter({onLastListenerRemove:()=>{S.cancel()}}),g=this.provider.readFileStream(p,I,S.token);return(0,C.listenStream)(g,{onData:y=>t.fire(D.VSBuffer.wrap(y)),onError:y=>t.fire(y),onEnd:()=>{t.fire("end"),t.dispose(),S.dispose()}}),t.event}writeFile(m,E,I,p){const S=this.transformIncoming(m,E);return this.provider.writeFile(S,I.buffer,p)}open(m,E,I){const p=this.transformIncoming(m,E,!0);return this.provider.open(p,I)}close(m){return this.provider.close(m)}async read(m,E,I){const p=D.VSBuffer.alloc(I),S=0,t=await this.provider.read(m,E,p.buffer,S,I);return[p,t]}write(m,E,I,p,S){return this.provider.write(m,E,I.buffer,p,S)}mkdir(m,E){const I=this.transformIncoming(m,E);return this.provider.mkdir(I)}delete(m,E,I){const p=this.transformIncoming(m,E);return this.provider.delete(p,I)}rename(m,E,I,p){const S=this.transformIncoming(m,E),t=this.transformIncoming(m,I);return this.provider.rename(S,t,p)}copy(m,E,I,p){const S=this.transformIncoming(m,E),t=this.transformIncoming(m,I);return this.provider.copy(S,t,p)}onFileChange(m,E){const I=new v.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(E,this.createSessionFileWatcher(m,I))},onLastListenerRemove:()=>{(0,n.dispose)(this.sessionToWatcher.get(E)),this.sessionToWatcher.delete(E)}});return I.event}async watch(m,E,I,p,S){const t=this.sessionToWatcher.get(E);if(t){const g=this.transformIncoming(m,p),y=t.watch(I,g,S);this.watchRequests.set(E+I,y)}}async unwatch(m,E){const I=m+E,p=this.watchRequests.get(I);p&&((0,n.dispose)(p),this.watchRequests.delete(I))}dispose(){super.dispose();for(const[,m]of this.watchRequests)m.dispose();this.watchRequests.clear();for(const[,m]of this.sessionToWatcher)m.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=P}),define(ee[73],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(D,C=[],k=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=v}),define(ee[171],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=v;class n{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let k of this._nodes.values())k.outgoing.size===0&&C.push(k);return C}insertEdge(C,k){const P=this.lookupOrInsertNode(C),f=this.lookupOrInsertNode(k);P.outgoing.set(this._hashFn(k),f),f.incoming.set(this._hashFn(C),P)}removeNode(C){const k=this._hashFn(C);this._nodes.delete(k);for(let P of this._nodes.values())P.outgoing.delete(k),P.incoming.delete(k)}lookupOrInsertNode(C){const k=this._hashFn(C);let P=this._nodes.get(k);return P||(P=new v(C),this._nodes.set(k,P)),P}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[k,P]of this._nodes)C.push(`${k}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,k]of this._nodes){const P=new Set([C]),f=this._findCycle(k,P);if(f)return f}}_findCycle(C,k){for(let[P,f]of C.outgoing){if(k.has(P))return[...k,P].join(" -> ");k.add(P);const m=this._findCycle(f,k);if(m)return m;k.delete(P)}}}e.Graph=n}),define(ee[5],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function P(f){return f[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=P})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(k,P,f,m){P[v.DI_TARGET]===P?P[v.DI_DEPENDENCIES].push({id:k,index:f,optional:m}):(P[v.DI_DEPENDENCIES]=[{id:k,index:f,optional:m}],P[v.DI_TARGET]=P)}function D(k){if(v.serviceIds.has(k))return v.serviceIds.get(k);const P=function(f,m,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(P,f,E,!1)};return P.toString=()=>k,v.serviceIds.set(k,P),P}e.createDecorator=D;function C(k){return k}e.refineServiceDecorator=C}),define(ee[52],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService")}),define(ee[19],te([0,1,13,7,5]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof n.URI)}e.isConfigurationOverrides=C;function k(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||v.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=k;var P;(function(y){y[y.USER=1]="USER",y[y.USER_LOCAL=2]="USER_LOCAL",y[y.USER_REMOTE=3]="USER_REMOTE",y[y.WORKSPACE=4]="WORKSPACE",y[y.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",y[y.DEFAULT=6]="DEFAULT",y[y.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(y){switch(y){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=f;function m(y,w){const M=Object.create(null);for(let c in y)E(M,c,y[c],w);return M}e.toValuesTree=m;function E(y,w,M,c){const a=w.split("."),l=a.pop();let o=y;for(let h=0;h<a.length;h++){let s=a[h],i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${w} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[l]=M}catch{c(`Ignoring ${w} as ${a.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${w} as ${a.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=E;function I(y,w){const M=w.split(".");p(y,M)}e.removeFromValueTree=I;function p(y,w){const M=w.shift();if(w.length===0){delete y[M];return}if(Object.keys(y).indexOf(M)!==-1){const c=y[M];typeof c=="object"&&!Array.isArray(c)&&(p(c,w),Object.keys(c).length===0&&delete y[M])}}function S(y,w,M){function c(o,h){let s=o;for(const i of h){if(typeof s!="object"||s===null)return;s=s[i]}return s}const a=w.split("."),l=c(y,a);return typeof l=="undefined"?M:l}e.getConfigurationValue=S;function t(y,w,M){Object.keys(w).forEach(c=>{c!=="__proto__"&&(c in y?v.isObject(y[c])&&v.isObject(w[c])?t(y[c],w[c],M):M&&(y[c]=w[c]):y[c]=w[c])})}e.merge=t;function g(y,w,M){const c=y.inspect(w),a=y.inspect(M);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=g}),define(ee[74],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function n(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=n}),define(ee[89],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class n{constructor(C){this.machineId=C}encryption(){return new Promise((C,k)=>G(["vscode-encrypt"],C,k))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch{return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch{return C}}}e.EncryptionMainService=n}),define(ee[53],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(ee[172],te([0,1,10,142,5]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function k(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function P(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function f(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function m(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=m;function E(c,a,l){return m(a,l)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===l?!0:I(l).includes(c)}e.isTargetPlatformCompatible=E;function I(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function p(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=p;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var y;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var w;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(w=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class M extends Error{constructor(a,l){super(a);this.code=l,this.name=l}}e.ExtensionManagementError=M,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(ee[173],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(ee[174],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,v.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(ee[90],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(ee[175],te([0,1,44,10,9,3,81,24,72,144,90]),function(G,e,v,n,D,C,k,P,f,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=m.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends p{openTerminal(a,l){return this.spawnTerminal(v,a,f.getWindowsShell(),l)}spawnTerminal(a,l,o,h){const s=l.windowsExec||S.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const i=D.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(s,h?[h]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((u,d)=>{const b=y(process),L=a.spawn(o,r,{cwd:h,env:b});L.on("error",d),L.on("exit",()=>u())})}runInTerminal(a,l,o,h,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:S.getDefaultTerminalWindows();return new Promise((r,u)=>{const d=`"${l} - ${I}"`,b=`""${o.join('" "')}" & pause"`,L=["/c","start",d,"/wait",i,"/c",b],R=Object.assign({},y(process),h);Object.keys(R).filter(Q=>R[Q]===null).forEach(Q=>delete R[Q]);const T={cwd:l,env:R,windowsVerbatimArguments:!0};v.spawn(S.CMD,L,T).on("error",Q=>{u(w(Q))}),r(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S,S.CMD="cmd.exe";class t extends p{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,o,h,s){const i=s.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((r,u)=>{if(i===E.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const d=i===E.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,G).fsPath,"-t",a||I,"-w",l];for(let U of o)L.push("-a"),L.push(U);if(h){const U=Object.assign({},y(process),h);for(let Q in U){const se=U[Q];se===null?(L.push("-u"),L.push(Q)):(L.push("-e"),L.push(`${Q}=${se}`))}}let R="";const T=v.spawn(t.OSASCRIPT,L);T.on("error",U=>{u(w(U))}),T.stderr.on("data",U=>{R+=U.toString()}),T.on("exit",U=>{if(U===0)r(void 0);else if(R){const Q=R.split(`
`,1);u(new Error(Q[0]))}else u(new Error(m.localize(1,null,d,U)))})}else u(new Error(m.localize(2,null,i)))})}spawnTerminal(a,l,o){const h=l.osxExec||E.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",h];o&&r.push(o);const u=y(process),d=a.spawn("/usr/bin/open",r,{cwd:o,env:u});d.on("error",i),d.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class g extends p{openTerminal(a,l){return this.spawnTerminal(v,a,l)}runInTerminal(a,l,o,h,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,u)=>{let d=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const L=`${M(o)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;d.push(`''${L}''`);const R=Object.assign({},y(process),h);Object.keys(R).filter(se=>R[se]===null).forEach(se=>delete R[se]);const T={cwd:l,env:R};let U="";const Q=v.spawn(b,d,T);Q.on("error",se=>{u(w(se))}),Q.stderr.on("data",se=>{U+=se.toString()}),Q.on("exit",se=>{if(se===0)r(void 0);else if(U){const ne=U.split(`
`,1);u(new Error(ne[0]))}else u(new Error(m.localize(4,null,b,se)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await P.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{a?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,l,o){const h=l.linuxExec?Promise.resolve(l.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{h.then(r=>{const u=y(process),d=a.spawn(r,[],{cwd:o,env:u});d.on("error",i),d.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=m.localize(3,null);function y(c){const a={...c.env};return(0,k.sanitizeProcessEnvironment)(a),a}function w(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(m.localize(5,null,c.path)):c}function M(c){let a="";for(let l of c)l.indexOf(" ")>=0?a+='"'+l+'"':a+=l,a+=" ";return a}}),define(ee[18],te([0,1,35,9,25,13,7,146,5]),function(G,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function m(q){return q.create===!0}e.isFileOpenForWriteOptions=m;var E;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var I;(function(q){q[q.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var p;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=S;function t(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=t;function g(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function y(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=y;function w(q){return S(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var M;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(M=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(K,j){super(K);this.code=j}}e.FileSystemProviderError=c;function a(q,K){const j=new c(q.toString(),K);return o(j,K),j}e.createFileSystemProviderError=a;function l(q){return q||a((0,P.localize)(0,null),M.Unknown)}e.ensureFileSystemProviderError=l;function o(q,K){return q.name=K?`${K} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=o;function h(q){if(!q)return M.Unknown;if(q instanceof c)return q.code;const K=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!K)return M.Unknown;switch(K[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileExceedsMemoryLimit:return M.FileExceedsMemoryLimit;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}e.toFileSystemProviderErrorCode=h;function s(q){if(q instanceof L)return q.fileOperationResult;switch(h(q)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 10;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileExceedsMemoryLimit:return 9;case M.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(K,j,B){this.resource=K,this.operation=j,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=r;var u;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(K,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const $ of K){const Y=B.get($.type);Y?Y.push([$.resource,$]):B.set($.type,[[$.resource,$]])}for(const[$,Y]of B)switch($){case 1:this.added=v.TernarySearchTree.forUris(()=>j),this.added.fill(Y);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>j),this.updated.fill(Y);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>j),this.deleted.fill(Y);break}}contains(K,...j){return this.doContains(K,{includeChildren:!1},...j)}affects(K,...j){return this.doContains(K,{includeChildren:!0},...j)}doContains(K,j,...B){if(!K)return!1;const $=B.length>0;return!!((!$||B.includes(1))&&(this.added?.get(K)||j.includeChildren&&this.added?.findSuperstr(K))||(!$||B.includes(0))&&(this.updated?.get(K)||j.includeChildren&&this.updated?.findSuperstr(K))||(!$||B.includes(2))&&(this.deleted?.findSubstr(K)||j.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function b(q,K,j){return!q||!K||q===K||K.length>q.length?!1:(K.charAt(K.length-1)!==n.sep&&(K+=n.sep),j?(0,D.startsWithIgnoreCase)(q,K):q.indexOf(K)===0)}e.isParent=b;class L extends Error{constructor(K,j,B){super(K);this.fileOperationResult=j,this.options=B}}e.FileOperationError=L;class R extends L{constructor(K,j,B){super(K,2,B);this.stat=j}}e.NotModifiedSinceFileOperationError=R;var T;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function Q(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=Q;async function se(q,K){if(!K.hasProvider(k.URI.from({scheme:q.scheme})))return new Promise(j=>{const B=K.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===q.scheme&&$.added&&(B.dispose(),j())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(K){return(0,C.isNumber)(K)||(K=0),K<ne.KB?(0,P.localize)(1,null,K.toFixed(0)):K<ne.MB?(0,P.localize)(2,null,(K/ne.KB).toFixed(2)):K<ne.GB?(0,P.localize)(3,null,(K/ne.MB).toFixed(2)):K<ne.TB?(0,P.localize)(4,null,(K/ne.GB).toFixed(2)):(0,P.localize)(5,null,(K/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var V;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function J(q){return{maxFileSize:q===0?300*ne.MB:16*ne.GB,maxHeapSize:q===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=J}),define(ee[54],te([0,1,250,140,88,18]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(p,S){const t={onUnknownOption:y=>{console.warn((0,n.localize)(0,null,y))},onMultipleValues:(y,w)=>{console.warn((0,n.localize)(1,null,y,w))},onDeprecatedOption:(y,w)=>{console.warn((0,n.localize)(2,null,y,w))}},g=(0,D.parseArgs)(p,D.OPTIONS,S?t:void 0);return g.goto&&g._.forEach(y=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(y),(0,n.localize)(3,null))),g["max-memory"]&&v(parseInt(g["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function P(p){const S=p.findIndex(t=>!/^-/.test(t));if(S>-1)return[...p.slice(0,S),...p.slice(S+1)]}function f(p){let[,...S]=p;process.env.VSCODE_DEV&&(S=P(S)||[]);const t=!I(process.env);return k(S,t)}e.parseMainProcessArgv=f;function m(p){const[,,...S]=p;return k(S,!0)}e.parseCLIProcessArgv=m;function E(p,...S){const t=p.indexOf("--");return t===-1?p.push(...S):p.splice(t,0,...S),p}e.addArg=E;function I(p){return p.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(ee[91],te([0,1,44,9,141,21,39,15,3,32,134,54,8]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let t;async function g(w,M,c){return M["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(c)&&!M["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(c)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=p.Promises.withAsyncBody(async(a,l)=>{const o=new C.CancellationTokenSource,h=setTimeout(()=>{o.dispose(!0),l(new Error((0,D.localize)(0,null)))},S);try{a(await y(w,o.token))}catch(s){!(0,P.isPromiseCanceledError)(s)&&!o.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(s)))):a({})}finally{clearTimeout(h),o.dispose()}})),t)}e.getResolvedShellEnv=g;async function y(w,M){const c=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",a);const l=(0,m.generateUuid)().replace(/-/g,"").substr(0,12),o=new RegExp(l+"(.*)"+l),h={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};w.trace("getUnixShellEnvironment#env",h);const s=await(0,E.getSystemShell)(f.OS,h);return w.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(M.isCancellationRequested)return r((0,P.canceled)());const u=(0,n.basename)(s);let d,b;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(d=`& '${process.execPath}' ${L} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,b=["-Login","-Command"]):(d=`'${process.execPath}' ${L} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"?b=["-ic"]:b=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(b),d);const R=(0,v.spawn)(s,[...b,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:h});M.onCancellationRequested(()=>(R.kill(),r((0,P.canceled)()))),R.on("error",Q=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(Q)),r(Q)});const T=[];R.stdout.on("data",Q=>T.push(Q));const U=[];R.stderr.on("data",Q=>U.push(Q)),R.on("close",(Q,se)=>{const ne=Buffer.concat(T).toString("utf8");w.trace("getUnixShellEnvironment#raw",ne);const V=Buffer.concat(U).toString("utf8");if(V.trim()&&w.trace("getUnixShellEnvironment#stderr",V),Q||se)return r(new Error((0,D.localize)(2,null,Q,se)));const J=o.exec(ne),q=J?J[1]:"{}";try{const K=JSON.parse(q);c?K.ELECTRON_RUN_AS_NODE=c:delete K.ELECTRON_RUN_AS_NODE,a?K.ELECTRON_NO_ATTACH_CONSOLE=a:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",K),i(K)}catch(K){w.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(K)),r(K)}})})}}),define(ee[176],te([0,1,17,39,15,4,2,51,7,32,18]),function(G,e,v,n,D,C,k,P,f,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends k.Disposable{constructor(S,t){super();this.channel=S,this.extraCapabilities=t,this.onDidChangeCapabilities=C.Event.None,this._onDidChange=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,m.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(S){return this.channel.call("stat",[S])}readdir(S){return this.channel.call("readdir",[S])}async readFile(S,t){const{buffer:g}=await this.channel.call("readFile",[S,t]);return g}readFileStream(S,t,g){const y=(0,P.newWriteableStream)(M=>v.VSBuffer.concat(M.map(c=>v.VSBuffer.wrap(c))).buffer),w=this.channel.listen("readFileStream",[S,t])(M=>{if(M instanceof v.VSBuffer)y.write(M.buffer);else{if(M==="end")y.end();else{let c=M;c instanceof Error||(c=(0,E.createFileSystemProviderError)((0,n.toErrorMessage)(c),E.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}w.dispose()}});return g.onCancellationRequested(()=>{y.error((0,D.canceled)()),y.end(),w.dispose()}),y}writeFile(S,t,g){return this.channel.call("writeFile",[S,v.VSBuffer.wrap(t),g])}open(S,t){return this.channel.call("open",[S,t])}close(S){return this.channel.call("close",[S])}async read(S,t,g,y,w){const[M,c]=await this.channel.call("read",[S,t,w]);return g.set(M.buffer.slice(0,c),y),c}write(S,t,g,y,w){return this.channel.call("write",[S,t,v.VSBuffer.wrap(g),y,w])}mkdir(S){return this.channel.call("mkdir",[S])}delete(S,t){return this.channel.call("delete",[S,t])}rename(S,t,g){return this.channel.call("rename",[S,t,g])}copy(S,t,g){return this.channel.call("copy",[S,t,g])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(S=>{if(Array.isArray(S)){const t=S;this._onDidChange.fire(t.map(g=>({resource:f.URI.revive(g.resource),type:g.type})))}else{const t=S;this._onDidWatchError.fire(t)}}))}watch(S,t){const g=(0,m.generateUuid)();return this.channel.call("watch",[this.sessionId,g,S,t]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,g]))}}e.DiskFileSystemProviderClient=I}),define(ee[92],te([0,1,17,15,147,18]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(E,I,p,S,t,g){let y;try{await P(E,I,p,S,t,g)}catch(w){y=w}finally{y&&t.errorTransformer&&(y=t.errorTransformer(y)),typeof y!="undefined"&&p.error(y),p.end()}}e.readFileIntoStream=k;async function P(E,I,p,S,t,g){f(g);const y=await E.open(I,{create:!1});try{f(g);let w=0,M=0,c=t&&typeof t.length=="number"?t.length:void 0,a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),l=t&&typeof t.position=="number"?t.position:0,o=0;do M=await E.read(y,l,a.buffer,o,a.byteLength-o),l+=M,o+=M,w+=M,typeof c=="number"&&(c-=M),o===a.byteLength&&(await p.write(S(a)),a=v.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),o=0);while(M>0&&(typeof c!="number"||c>0)&&f(g)&&m(w,t));if(o>0){let h=o;typeof c=="number"&&(h=Math.min(o,c)),p.write(S(a.slice(0,h)))}}catch(w){throw(0,C.ensureFileSystemProviderError)(w)}finally{await E.close(y)}}function f(E){if(E.isCancellationRequested)throw(0,n.canceled)();return!0}function m(E,I){if(I?.limits){if(typeof I.limits.memory=="number"&&E>I.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&E>I.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ee[62],te([0,1,2,3,7,18]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends v.Disposable{constructor(I,p,S){super();this.onFileChanges=I,this.onLogMessage=p,this.verboseLogging=S,this.watcherDisposables=this._register(new v.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const I=new v.DisposableStore;this.watcherDisposables.value=I,this.watcher=this.createWatcher(I),this.watcher.setVerboseLogging(this.verboseLogging),I.add(this.watcher.onDidChangeFile(p=>this.onFileChanges(p))),I.add(this.watcher.onDidLogMessage(p=>this.onLogMessage(p))),I.add(this.watcher.onDidError(p=>this.onError(p)))}onError(I){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${I}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${I}`)}restart(I){this.restartCounter++,this.init(),this.watch(I)}async watch(I){this.requests=I,await this.watcher?.watch(I)}async setVerboseLogging(I){this.verboseLogging=I,await this.watcher?.setVerboseLogging(I)}error(I){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${I}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function P(E){return E.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=P;function f(E){const I=new m;for(const p of E)I.processEvent(p);return I.coalesce()}e.coalesceEvents=f;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(I){return n.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const p=this.mapPathToChange.get(this.toKey(I));let S=!1;if(p){const t=p.type,g=I.type;p.path!==I.path&&(I.type===2||I.type===1)?S=!0:t===1&&g===2?(this.mapPathToChange.delete(this.toKey(I)),this.coalesced.delete(p)):t===2&&g===1?p.type=0:t===1&&g===0||(p.type=g)}else S=!0;S&&(this.coalesced.add(I),this.mapPathToChange.set(this.toKey(I),I))}coalesce(){const I=[],p=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(I.push(S),!1):!0).sort((S,t)=>S.path.length-t.path.length).filter(S=>p.some(t=>(0,C.isParent)(S.path,t,!n.isLinux))?!1:(p.push(S.path),!0)).concat(I)}}}),define(ee[93],te([0,1,28,8,21,27,113,2,70,9,3,83,24,62]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class t extends P.Disposable{constructor(w,M,c,a){super();this.request=w,this.onDidFilesChange=M,this.onLogMessage=c,this.verboseLogging=a,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,k.parse)(l)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${w} (excludes: ${this.request.excludes}))}`);const M=await p.Promises.stat(w);this._register(await this.doWatch(w,M.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let M=w.path;try{M=await p.Promises.realpath(w.path),w.path===M&&(M=await(0,I.realcase)(w.path)??w.path),w.path!==M&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${M})`)}catch{}return M}async doWatch(w,M){if(E.isMacintosh&&(0,C.isEqualOrParent)(w,"/Volumes/"))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),P.Disposable.None;const c=new D.CancellationTokenSource(this.cts.token);let a=new P.DisposableStore;try{const l=(0,m.basename)(w),o=(0,v.watch)(w);a.add((0,P.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const h=new Set;if(M)try{for(const i of await p.Promises.readdir(w))h.add(i)}catch(i){this.error(i)}const s=new Map;a.add((0,P.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),o.on("error",(i,r)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),o.on("change",(i,r)=>{if(c.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let u="";if(r&&(u=r.toString(),E.isMacintosh&&(u=(0,f.normalizeNFC)(u))),!(!u||i!=="change"&&i!=="rename"))if(M)if(i==="rename"){s.get(u)?.dispose();const d=setTimeout(async()=>{if(s.delete(u),u===l&&!await p.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.existsChildStrictCase((0,m.join)(w,u));if(c.token.isCancellationRequested)return;let L;b?h.has(u)?L=0:(L=1,h.add(u)):(h.delete(u),L=2),this.onFileChange({path:(0,m.join)(this.request.path,u),type:L})},t.FILE_DELETE_HANDLER_DELAY);s.set(u,(0,P.toDisposable)(()=>clearTimeout(d)))}else{let d;h.has(u)?d=0:(d=1,h.add(u)),this.onFileChange({path:(0,m.join)(this.request.path,u),type:d})}else if(i==="rename"||u!==l){const d=setTimeout(async()=>{const b=await p.Promises.exists(w);c.token.isCancellationRequested||(b?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,P.toDisposable)(()=>clearTimeout(d)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await p.Promises.exists(w)&&!c.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${l.toString()})`)}return(0,P.toDisposable)(()=>{c.dispose(!0),a.dispose()})}async onFileChange(w,M=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!M&&this.excludes.some(c=>c(w.path))?this.verboseLogging&&this.trace(` >> ignored ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,S.coalesceEvents)(c);if(this.verboseLogging)for(const l of a)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);a.length>0&&this.onDidFilesChange(a)})}catch{}}}async existsChildStrictCase(w){if(E.isLinux)return p.Promises.exists(w);try{const M=(0,m.basename)(w);return(await p.Promises.readdir((0,m.dirname)(w))).some(a=>a===M)}catch(M){return this.trace(M),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace("stopping file watcher"),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function g(y,w,M,c=512){const a=await p.Promises.open(y,"r"),l=Buffer.allocUnsafe(c),o=new D.CancellationTokenSource(M);let h,s=!1;const i={path:y,excludes:[]},r=new t(i,u=>{(async()=>{for(const{type:d}of u)if(d===0){if(s)return;s=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:b}=await p.Promises.read(a,l,0,c,null);if(!b||o.token.isCancellationRequested)break;w(l.slice(0,b))}}catch(b){h=new Error(b),o.dispose(!0)}finally{s=!1}}})()});return new Promise((u,d)=>{o.token.onCancellationRequested(async()=>{r.dispose();try{await p.Promises.close(a)}catch(b){h=new Error(b)}h?d(h):u()})})}e.watchFileContents=g}),define(ee[177],te([0,1,10,37,135,62]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends C.AbstractRecursiveWatcherClient{constructor(f,m,E){super(f,m,E);this.init()}createWatcher(f){const m=f.add(new D.Client(v.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(m.onDidProcessExit(({code:E,signal:I})=>this.onError(`terminated by itself with code ${E}, signal: ${I}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(m.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(ee[75],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[C,k]of D)this.set(C,k)}set(D,C){const k=this._entries.get(D);return this._entries.set(D,C),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(ee[178],te([0,1,8,15,73,171,5,75]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class m extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class E{constructor(t=new P.ServiceCollection,g=!1,y){this._activeInstantiations=new Set,this._services=t,this._strict=g,this._parent=y,this._services.set(k.IInstantiationService,this)}createChild(t){return new E(t,this._strict,this)}invokeFunction(t,...g){let y=p.traceInvocation(t),w=!1;try{return t({get:c=>{if(w)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,y);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...g)}finally{w=!0,y.stop()}}createInstance(t,...g){let y,w;return t instanceof D.SyncDescriptor?(y=p.traceCreation(t.ctor),w=this._createInstance(t.ctor,t.staticArguments.concat(g),y)):(y=p.traceCreation(t),w=this._createInstance(t,g,y)),y.stop(),w}_createInstance(t,g=[],y){let w=k._util.getServiceDependencies(t).sort((a,l)=>a.index-l.index),M=[];for(const a of w){let l=this._getOrCreateServiceInstance(a.id,y);if(!l&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);M.push(l)}let c=w.length>0?w[0].index:g.length;if(g.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${g.length} static arguments`);let a=c-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,c)}return new t(...[...g,...M])}_setServiceInstance(t,g){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,g);else if(this._parent)this._parent._setServiceInstance(t,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let g=this._services.get(t);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):g}_getOrCreateServiceInstance(t,g){let y=this._getServiceInstanceOrDescriptor(t);return y instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,y,g.branch(t,!0)):(g.branch(t,!1),y)}_safeCreateAndCacheServiceInstance(t,g,y){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,g,y)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,g,y){const w=new C.Graph(a=>a.id.toString());let M=0;const c=[{id:t,desc:g,_trace:y}];for(;c.length;){const a=c.pop();if(w.lookupOrInsertNode(a),M++>1e3)throw new m(w);for(let l of k._util.getServiceDependencies(a.desc.ctor)){let o=this._getServiceInstanceOrDescriptor(l.id);if(!o&&!l.optional&&console.warn(`[createInstance] ${t} depends on ${l.id} which is NOT registered.`),o instanceof D.SyncDescriptor){const h={id:l.id,desc:o,_trace:a._trace.branch(l.id,!0)};w.insertEdge(a,h),c.push(h)}}}for(;;){const a=w.roots();if(a.length===0){if(!w.isEmpty())throw new m(w);break}for(const{data:l}of a){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const h=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,h)}w.removeNode(l)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,g,y=[],w,M){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(g,y,w,M);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,g,y,w,M);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(t,g=[],y,w){if(y){const M=new v.IdleValue(()=>this._createInstance(t,g,w));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let l=M.value,o=l[a];return typeof o!="function"||(o=o.bind(l),c[a]=o),o},set(c,a,l){return M.value[a]=l,!0}})}else return this._createInstance(t,g,w)}}e.InstantiationService=E;var I;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(I||(I={}));class p{constructor(t,g){this.type=t,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return f?new p(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(t){return f?new p(0,t.name):p._None}branch(t,g){let y=new p(2,t.toString());return this._dep.push([t,g,y]),y}stop(){let t=Date.now()-this._start;p._totals+=t;let g=!1;function y(M,c){let a=[],l=new Array(M+1).join("	");for(const[o,h,s]of c._dep)if(h&&s){g=!0,a.push(`${l}CREATES -> ${o}`);let i=y(M+1,s);i&&a.push(i)}else a.push(`${l}uses -> ${o}`);return a.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(t>2||g)&&console.log(w.join(`
`))}}p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ee[179],te([0,1,15,132,59]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(P,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=P,this._parts=f}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,P=>this._getLabel(P))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,P=>this._getAriaLabel(P))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,P=>this._getElectronAccelerator(P))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,P=>this._getUserSettingsLabel(P))}isWYSIWYG(){return this._parts.every(P=>this._isWYSIWYG(P))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(P=>this._getPart(P))}_getPart(P){return new D.ResolvedKeybindingPart(P.ctrlKey,P.shiftKey,P.altKey,P.metaKey,this._getLabel(P),this._getAriaLabel(P))}getDispatchParts(){return this._parts.map(P=>this._getDispatchPart(P))}getSingleModifierDispatchParts(){return this._parts.map(P=>this._getSingleModifierDispatchPart(P))}}e.BaseResolvedKeybinding=C}),define(ee[180],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class v{constructor(C,k,P,f,m,E,I){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?n(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=n(C.getSingleModifierDispatchParts())),this.bubble=k?k.charCodeAt(0)===94:!1,this.command=this.bubble?k.substr(1):k,this.commandArgs=P,this.when=f,this.isDefault=m,this.extensionId=E,this.isBuiltinExtension=I}}e.ResolvedKeybindingItem=v;function n(D){let C=[];for(let k=0,P=D.length;k<P;k++){const f=D[k];if(!f)return C;C.push(f)}return C}e.removeElementsAfterNulls=n}),define(ee[181],te([0,1,80,59,179,180]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class k extends D.BaseResolvedKeybinding{constructor(f,m){super(m,f.parts)}_keyCodeToUILabel(f){if(this._os===2)switch(f){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(f)}_getLabel(f){return f.isDuplicateModifierCase()?"":this._keyCodeToUILabel(f.keyCode)}_getAriaLabel(f){return f.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(f.keyCode)}_getElectronAccelerator(f){return v.KeyCodeUtils.toElectronAccelerator(f.keyCode)}_getUserSettingsLabel(f){if(f.isDuplicateModifierCase())return"";const m=v.KeyCodeUtils.toUserSettingsUS(f.keyCode);return m&&m.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(f){return k.getDispatchStr(f)}static getDispatchStr(f){if(f.isModifierKey())return null;let m="";return f.ctrlKey&&(m+="ctrl+"),f.shiftKey&&(m+="shift+"),f.altKey&&(m+="alt+"),f.metaKey&&(m+="meta+"),m+=v.KeyCodeUtils.toString(f.keyCode),m}_getSingleModifierDispatchPart(f){return f.keyCode===5&&!f.shiftKey&&!f.altKey&&!f.metaKey?"ctrl":f.keyCode===4&&!f.ctrlKey&&!f.altKey&&!f.metaKey?"shift":f.keyCode===6&&!f.ctrlKey&&!f.shiftKey&&!f.metaKey?"alt":f.keyCode===57&&!f.ctrlKey&&!f.shiftKey&&!f.altKey?"meta":null}static _scanCodeToKeyCode(f){const m=v.IMMUTABLE_CODE_TO_KEY_CODE[f];if(m!==-1)return m;switch(f){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(f){if(!f)return null;if(f instanceof n.SimpleKeybinding)return f;const m=this._scanCodeToKeyCode(f.scanCode);return m===0?null:new n.SimpleKeybinding(f.ctrlKey,f.shiftKey,f.altKey,f.metaKey,m)}static resolveUserBinding(f,m){const E=(0,C.removeElementsAfterNulls)(f.map(I=>this._resolveSimpleUserBinding(I)));return E.length>0?[new k(new n.ChordKeybinding(E),m)]:[]}}e.USLayoutResolvedKeybinding=k}),define(ee[182],te([0,1,8]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(D,C){if(D.length===0)return Promise.resolve(!1);const k=[];let P=!1;for(let f of D){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&k.push(f.then(m=>{m&&(P=!0)},m=>{C(m),P=!0}))}return v.Promises.settled(k).then(()=>P)}e.handleVetos=n}),define(ee[6],te([0,1,39,4,2,3,5]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function P(){return new Date().toISOString()}var f;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;function m(h,s,i){switch(s){case f.Trace:h.trace(i);break;case f.Debug:h.debug(i);break;case f.Info:h.info(i);break;case f.Warning:h.warn(i);break;case f.Error:h.error(i);break;case f.Critical:h.critical(i);break;default:throw new Error("Invalid log level")}}e.log=m;function E(h){let s="";for(let i=0;i<h.length;i++){let r=h[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}s+=(i>0?" ":"")+r}return s}e.format=E;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class p extends I{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,E([s,...i]))}debug(s,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,E([s,...i]))}info(s,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,E([s,...i]))}warn(s,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,E([s,...i]))}error(s,...i){if(this.checkLogLevel(f.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(f.Error,E(r))}else this.log(f.Error,E([s,...i]))}critical(s,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,E([s,...i]))}flush(){}}e.AbstractMessageLogger=p;class S extends I{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!C.isWindows}trace(s,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,s,...i):console.log(`[main ${P()}]`,s,...i))}debug(s,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,s,...i):console.log(`[main ${P()}]`,s,...i))}info(s,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,s,...i):console.log(`[main ${P()}]`,s,...i))}warn(s,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,s,...i):console.warn(`[main ${P()}]`,s,...i))}error(s,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,s,...i):console.error(`[main ${P()}]`,s,...i))}critical(s,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,s,...i):console.error(`[main ${P()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class t extends I{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class g extends I{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,v.toErrorMessage)(s,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class y extends I{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const r of this.logServices)r.trace(s,...i)}debug(s,...i){for(const r of this.logServices)r.debug(s,...i)}info(s,...i){for(const r of this.logServices)r.info(s,...i)}warn(s,...i){for(const r of this.logServices)r.warn(s,...i)}error(s,...i){for(const r of this.logServices)r.error(s,...i)}critical(s,...i){for(const r of this.logServices)r.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=y;class w extends D.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=w;class M extends D.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(r))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let r=this.loggers.get(s.toString());return r||(r=this.doCreateLogger(s,i?.always?f.Trace:this.logLevel,i),this.loggers.set(s.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class c{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(s){}getLevel(){return f.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(h){if(h.verbose)return f.Trace;if(typeof h.logLevel=="string"){const s=l(h.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function l(h){switch(h){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=l;function o(h){switch(h){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o}),define(ee[183],te([0,1,31,8,15,4,2,9,62,6]),function(G,e,v,n,D,C,k,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends k.Disposable{constructor(p){super();this.logService=p,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(p,S){return S.recursive?this.watchRecursive(p,S):this.watchNonRecursive(p,S)}watchRecursive(p,S){const t={path:this.toFilePath(p),excludes:S.excludes},g=(0,v.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(p=>(0,D.onUnexpectedError)(p))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(p=>this._onDidChangeFile.fire((0,f.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===m.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(p,S){return p.watch(S)}watchNonRecursive(p,S){const t=new k.DisposableStore,g=t.add(this.createNonRecursiveWatcher({path:this.toFilePath(p),excludes:S.excludes},y=>this._onDidChangeFile.fire((0,f.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===m.LogLevel.Trace));return t.add(this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)})),t}onWatcherLogMessage(p){p.type==="error"&&this._onDidWatchError.fire(p.message),this.logService[p.type](p.message)}toFilePath(p){return(0,P.normalize)(p.fsPath)}}e.AbstractDiskFileSystemProvider=E});var re=this&&this.__param||function(G,e){return function(v,n){e(v,n,G)}};define(ee[184],te([0,1,31,8,17,21,4,69,2,35,10,63,16,51,145,18,92,6]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let M=class Qe extends f.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Qe.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new g.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new n.ThrottledWorker(Qe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Qe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Qe.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new g.FileChangesEvent(l,!0)))),this.nonRecursiveWatchedResources=m.TernarySearchTree.forUris(l=>{const o=this.getProvider(l.scheme);return o?!this.isPathCaseSensitive(o):!1}),this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(a,l){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:l});const o=new f.DisposableStore;return o.add(l.onDidChangeFile(h=>this.onDidChangeFile(h,this.isPathCaseSensitive(l)))),o.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:a}))),typeof l.onDidWatchError=="function"&&o.add(l.onDidWatchError(h=>this._onDidWatchError.fire(new Error(h)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:l}),this.provider.delete(a),(0,f.dispose)(o)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(o){l.push(o)}}),!this.provider.has(a)&&await n.Promises.settled(l)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,l){const o=this.provider.get(a.scheme);return!!(o&&o.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([a,l])=>({scheme:a,capabilities:l.capabilities}))}async withProvider(a){if(!(0,p.isAbsolutePath)(a))throw new g.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const l=this.provider.get(a.scheme);if(!l){const o=new Error;throw o.name="ENOPRO",o.message=(0,t.localize)(1,null,a.toString()),o}return l}async withReadProvider(a){const l=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)||(0,g.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const l=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,l){try{return await this.doResolveFile(a,l)}catch(o){throw(0,g.toFileSystemProviderErrorCode)(o)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(o)}}async doResolveFile(a,l){const o=await this.withProvider(a),h=this.isPathCaseSensitive(o),s=l?.resolveTo,i=l?.resolveSingleChildDescendants,r=l?.resolveMetadata,u=await o.stat(a);let d;return this.toFileStat(o,a,u,void 0,!!r,(b,L)=>(d||(d=m.TernarySearchTree.forUris(()=>!h),d.set(a,!0),s&&d.fill(!0,s)),d.get(b.resource)||d.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&i?L===1:!1))}async toFileStat(a,l,o,h,s,i){const{providerExtUri:r}=this.getExtUri(a),u={resource:l,name:r.basename(l),isFile:(o.type&g.FileType.File)!=0,isDirectory:(o.type&g.FileType.Directory)!=0,isSymbolicLink:(o.type&g.FileType.SymbolicLink)!=0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:o.mtime,size:o.size})};if(u.isDirectory&&i(u,h)){try{const d=await a.readdir(l),b=await n.Promises.settled(d.map(async([L,R])=>{try{const T=r.joinPath(l,L),U=s?await a.stat(T):{type:R};return await this.toFileStat(a,T,U,d.length,s,i)}catch(T){return this.logService.trace(T),null}}));u.children=(0,v.coalesce)(b)}catch(d){this.logService.trace(d),u.children=[]}return u}return u}async resolveAll(a){return n.Promises.settled(a.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async exists(a){const l=await this.withProvider(a);try{return!!await l.stat(a)}catch{return!1}}async canCreateFile(a,l){try{await this.doValidateCreateFile(a,l)}catch(o){return o}return!0}async doValidateCreateFile(a,l){if(!l?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,l)}async createFile(a,l=D.VSBuffer.fromString(""),o){await this.doValidateCreateFile(a,o);const h=await this.writeFile(a,l);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,h)),h}async writeFile(a,l,o){const h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:s}=this.getExtUri(h);try{await this.validateWriteFile(h,a,o)||await this.mkdirp(h,s.dirname(a));let r;if((0,g.hasReadWriteCapability)(h)&&!(l instanceof D.VSBuffer))if((0,S.isReadableStream)(l)){const u=await(0,S.peekStream)(l,3);u.ended?r=D.VSBuffer.concat(u.buffer):r=u}else r=(0,S.peekReadable)(l,u=>D.VSBuffer.concat(u),3);else r=l;!(0,g.hasOpenReadWriteCloseCapability)(h)||(0,g.hasReadWriteCapability)(h)&&r instanceof D.VSBuffer?await this.doWriteUnbuffered(h,a,o,r):await this.doWriteBuffered(h,a,o,r instanceof D.VSBuffer?(0,D.bufferToReadable)(r):r)}catch(i){throw new g.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),o)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,l,o){if(!!o?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(l)));let s;try{s=await a.stat(l)}catch{return}if((s.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,t.localize)(6,null,this.resourceForError(l)),0,o);if(this.throwIfFileIsReadonly(l,s),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==g.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&o.mtime<s.mtime&&o.etag!==(0,g.etag)({mtime:o.mtime,size:s.size}))throw new g.FileOperationError((0,t.localize)(7,null),3,o);return s}async readFile(a,l,o){const h=await this.withReadProvider(a);return l?.atomic?this.doReadFileAtomic(h,a,l,o):this.doReadFile(h,a,l,o)}async doReadFileAtomic(a,l,o,h){return new Promise((s,i)=>{this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(a,l,o,h);s(r)}catch(r){i(r)}})})}async doReadFile(a,l,o,h){const s=await this.doReadFileStream(a,l,{...o,preferUnbuffered:!0},h);return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(a,l,o){const h=await this.withReadProvider(a);return this.doReadFileStream(h,a,l,o)}async doReadFileStream(a,l,o,h){const s=new C.CancellationTokenSource(h),i=this.validateReadFile(l,o).then(u=>u,u=>{throw s.cancel(),u});let r;try{return typeof o?.etag=="string"&&o.etag!==g.ETAG_DISABLED&&await i,o?.atomic&&(0,g.hasFileAtomicReadCapability)(a)||!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&o?.preferUnbuffered?r=this.readFileUnbuffered(a,l,o):(0,g.hasFileReadStreamCapability)(a)?r=this.readFileStreamed(a,l,s.token,o):r=this.readFileBuffered(a,l,s.token,o),{...await i,value:r}}catch(u){r&&await(0,S.consumeStream)(r);const d=(0,t.localize)(8,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(u).toString());throw u instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(d,u.stat,o):new g.FileOperationError(d,(0,g.toFileOperationResult)(u),o)}}readFileStreamed(a,l,o,h=Object.create(null)){const s=a.readFileStream(l,h,o);return(0,S.transform)(s,{data:i=>i instanceof D.VSBuffer?i:D.VSBuffer.wrap(i),error:i=>new g.FileOperationError((0,t.localize)(9,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),h)},i=>D.VSBuffer.concat(i))}readFileBuffered(a,l,o,h=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,y.readFileIntoStream)(a,l,s,i=>i,{...h,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new g.FileOperationError((0,t.localize)(10,null,this.resourceForError(l),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),h)},o),s}readFileUnbuffered(a,l,o){const h=(0,S.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s;o?.atomic&&(0,g.hasFileAtomicReadCapability)(a)?s=await a.readFile(l,{atomic:!0}):s=await a.readFile(l),typeof o?.position=="number"&&(s=s.slice(o.position)),typeof o?.length=="number"&&(s=s.slice(0,o.length)),this.validateReadFileLimits(l,s.byteLength,o),h.end(D.VSBuffer.wrap(s))}catch(s){h.error(s),h.end()}})(),h}async validateReadFile(a,l){const o=await this.resolve(a,{resolveMetadata:!0});if(o.isDirectory)throw new g.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,l);if(typeof l?.etag=="string"&&l.etag!==g.ETAG_DISABLED&&l.etag===o.etag)throw new g.NotModifiedSinceFileOperationError((0,t.localize)(12,null),o,l);return this.validateReadFileLimits(a,o.size,l),o}validateReadFileLimits(a,l,o){if(o?.limits){let h;if(typeof o.limits.memory=="number"&&l>o.limits.memory&&(h=9),typeof o.limits.size=="number"&&l>o.limits.size&&(h=7),typeof h=="number")throw new g.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),h)}}async canMove(a,l,o){return this.doCanMoveCopy(a,l,"move",o)}async canCopy(a,l,o){return this.doCanMoveCopy(a,l,"copy",o)}async doCanMoveCopy(a,l,o,h){if(a.toString()!==l.toString())try{const s=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(s,a,i,l,o,h)}catch(s){return s}return!0}async move(a,l,o){const h=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(h,a,s,l,"move",!!o),r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="move"?2:3,r)),r}async copy(a,l,o){const h=await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=await this.doMoveCopy(h,a,s,l,"copy",!!o),r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="copy"?3:2,r)),r}async doMoveCopy(a,l,o,h,s,i){if(l.toString()===h.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(a,l,o,h,s,i);if(r&&!u&&i&&await this.del(h,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(h)),s==="copy"){if(a===o&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(l,h,{overwrite:i});else{const d=await this.resolve(l);d.isDirectory?await this.doCopyFolder(a,d,o,h):await this.doCopyFile(a,l,o,h)}return s}else return a===o?(await a.rename(l,h,{overwrite:i}),s):(await this.doMoveCopy(a,l,o,h,"copy",i),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(a,l,o,h){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(a,l,o,h);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(a,l,o,h);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(a,l,o,h);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(o))return this.doPipeUnbuffered(a,l,o,h)}async doCopyFolder(a,l,o,h){await o.mkdir(h),Array.isArray(l.children)&&await n.Promises.settled(l.children.map(async s=>{const i=this.getExtUri(o).providerExtUri.joinPath(h,s.name);return s.isDirectory?this.doCopyFolder(a,await this.resolve(s.resource),o,i):this.doCopyFile(a,s.resource,o,i)}))}async doValidateMoveCopy(a,l,o,h,s,i){let r=!1;if(a===o){const{providerExtUri:d,isPathCaseSensitive:b}=this.getExtUri(a);if(b||(r=d.isEqual(l,h)),r&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(l),this.resourceForError(h)));if(!r&&d.isEqualOrParent(h,l))throw new Error((0,t.localize)(15,null,this.resourceForError(l),this.resourceForError(h)))}const u=await this.exists(h);if(u&&!r){if(!i)throw new g.FileOperationError((0,t.localize)(16,null,this.resourceForError(l),this.resourceForError(h)),4);if(a===o){const{providerExtUri:d}=this.getExtUri(a);if(d.isEqualOrParent(l,h))throw new Error((0,t.localize)(17,null,this.resourceForError(l),this.resourceForError(h)))}}return{exists:u,isSameResourceWithDifferentPathCase:r}}getExtUri(a){const l=this.isPathCaseSensitive(a);return{providerExtUri:l?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(l,a);const o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,o)),o}async mkdirp(a,l){const o=[],{providerExtUri:h}=this.getExtUri(a);for(;!h.isEqual(l,h.dirname(l));)try{if(((await a.stat(l)).type&g.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(l)));break}catch(s){if((0,g.toFileSystemProviderErrorCode)(s)!==g.FileSystemProviderErrorCode.FileNotFound)throw s;o.push(h.basename(l)),l=h.dirname(l)}for(let s=o.length-1;s>=0;s--){l=h.joinPath(l,o[s]);try{await a.mkdir(l)}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,l){try{await this.doValidateDelete(a,l)}catch(o){return o}return!0}async doValidateDelete(a,l){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!l?.useTrash&&!(o.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let s;try{s=await o.stat(a)}catch{}if(s)this.throwIfFileIsReadonly(a,s);else throw new g.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!l?.recursive){const r=await this.resolve(a);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return o}async del(a,l){const o=await this.doValidateDelete(a,l),h=!!l?.useTrash,s=!!l?.recursive;await o.delete(a,{recursive:s,useTrash:h}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,l){this._onDidChangeFilesRaw.fire({changes:a});let o,h;{for(const s of a)this.nonRecursiveWatchedResources.has(s.resource)?(o||(o=[]),o.push(s)):(h||(h=[]),h.push(s));o&&this._onDidFilesChange.fire(new g.FileChangesEvent(o,!l))}if(h){const s=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(h)&&Qe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${h[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,l={recursive:!1,excludes:[]}){const o=new f.DisposableStore;let h=!1,s=()=>{h=!0};return o.add((0,f.toDisposable)(()=>s())),(async()=>{try{const i=await this.doWatch(a,l);h?(0,f.dispose)(i):s=()=>(0,f.dispose)(i)}catch(i){this.logService.error(i)}})(),l.recursive||(this.nonRecursiveWatchedResources.set(a,(this.nonRecursiveWatchedResources.get(a)??0)+1),o.add((0,f.toDisposable)(()=>{const i=this.nonRecursiveWatchedResources.get(a);typeof i=="number"&&(i<=1?this.nonRecursiveWatchedResources.delete(a):this.nonRecursiveWatchedResources.set(a,i-1))}))),o}async doWatch(a,l){const o=await this.withProvider(a),h=this.toWatchKey(o,a,l);let s=this.activeWatchers.get(h);return s||(s={count:0,disposable:o.watch(a,l)},this.activeWatchers.set(h,s)),s.count+=1,(0,f.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,f.dispose)(s.disposable),this.activeWatchers.delete(h)))})}toWatchKey(a,l,o){const{providerExtUri:h}=this.getExtUri(a);return[h.getComparisonKey(l),String(o.recursive),o.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,f.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,l,o,h){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(async()=>{const s=await a.open(l,{create:!0,unlock:o?.unlock??!1});try{(0,S.isReadableStream)(h)||(0,S.isReadableBufferedStream)(h)?await this.doWriteStreamBufferedQueued(a,s,h):await this.doWriteReadableBufferedQueued(a,s,h)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await a.close(s)}})}async doWriteStreamBufferedQueued(a,l,o){let h=0,s;if((0,S.isReadableBufferedStream)(o)){if(o.buffer.length>0){const i=D.VSBuffer.concat(o.buffer);await this.doWriteBuffer(a,l,i,i.byteLength,h,0),h+=i.byteLength}if(o.ended)return;s=o.stream}else s=o;return new Promise((i,r)=>{(0,S.listenStream)(s,{onData:async u=>{s.pause();try{await this.doWriteBuffer(a,l,u,u.byteLength,h,0)}catch(d){return r(d)}h+=u.byteLength,setTimeout(()=>s.resume())},onError:u=>r(u),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,l,o){let h=0,s;for(;(s=o.read())!==null;)await this.doWriteBuffer(a,l,s,s.byteLength,h,0),h+=s.byteLength}async doWriteBuffer(a,l,o,h,s,i){let r=0;for(;r<h;)r+=await a.write(l,s+r,o.buffer,i+r,h-r)}async doWriteUnbuffered(a,l,o,h){return this.writeQueue.queueFor(l,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,l,o,h))}async doWriteUnbufferedQueued(a,l,o,h){let s;h instanceof D.VSBuffer?s=h:(0,S.isReadableStream)(h)?s=await(0,D.streamToBuffer)(h):(0,S.isReadableBufferedStream)(h)?s=await(0,D.bufferedStreamToBuffer)(h):s=(0,D.readableToBuffer)(h),await a.writeFile(l,s.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,l,o,h))}async doPipeBufferedQueued(a,l,o,h){let s,i;try{s=await a.open(l,{create:!1}),i=await o.open(h,{create:!0,unlock:!1});const r=D.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,d=0,b=0;do b=await a.read(s,u,r.buffer,d,r.byteLength-d),await this.doWriteBuffer(o,i,r,b,u,d),u+=b,d+=b,d===r.byteLength&&(d=0);while(b>0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await n.Promises.settled([typeof s=="number"?a.close(s):Promise.resolve(),typeof i=="number"?o.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,l,o,h))}async doPipeUnbufferedQueued(a,l,o,h){return o.writeFile(h,await a.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,l,o,h){return this.writeQueue.queueFor(h,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,l,o,h))}async doPipeUnbufferedToBufferedQueued(a,l,o,h){const s=await o.open(h,{create:!0,unlock:!1});try{const i=await a.readFile(l);await this.doWriteBuffer(o,s,D.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await o.close(s)}}async doPipeBufferedToUnbuffered(a,l,o,h){const s=await(0,D.streamToBuffer)(this.readFileBuffered(a,l,C.CancellationToken.None));await this.doWriteUnbuffered(o,h,void 0,s)}throwIfFileSystemIsReadonly(a,l){if(a.capabilities&2048)throw new g.FileOperationError((0,t.localize)(22,null,this.resourceForError(l)),6);return a}throwIfFileIsReadonly(a,l){if((l.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===E.Schemas.file?a.fsPath:a.toString(!0)}};M.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},M=de([re(0,w.ILogService)],M),e.FileService=M}),define(ee[185],te([0,1,14,148,3,7,18,93,9,2,62,6,170,114]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends p.AbstractDiskFileSystemProviderChannel{constructor(w,M){super(w,M)}getUriTransformer(w){return S.DefaultURITransformer}transformIncoming(w,M){return C.URI.revive(M)}async delete(w,M,c){if(!c.useTrash)return super.delete(w,M,c);const a=this.transformIncoming(w,M),l=(0,f.normalize)(a.fsPath);try{await v.shell.trashItem(l)}catch{throw(0,k.createFileSystemProviderError)(D.isWindows?(0,n.localize)(0,null,(0,f.basename)(l)):(0,n.localize)(1,null,(0,f.basename)(l)),k.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(w,M){return new g(M,this.logService)}}e.DiskFileSystemProviderChannel=t;class g extends m.Disposable{constructor(w,M){super();this.sessionEmitter=w,this.logService=M,this.watcherRequests=new Map}watch(w,M,c){if(c.recursive)throw(0,k.createFileSystemProviderError)("Recursive watcher is not supported from main process",k.FileSystemProviderErrorCode.Unavailable);const a=new m.DisposableStore;this.watcherRequests.set(w,a),a.add((0,m.toDisposable)(()=>this.watcherRequests.delete(w)));const l=a.add(new P.NodeJSFileWatcher({path:(0,f.normalize)(M.fsPath),excludes:c.excludes},o=>this.sessionEmitter.fire((0,E.toFileChanges)(o)),o=>this.onWatcherLogMessage(o),this.logService.getLevel()===I.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})),a}onWatcherLogMessage(w){w.type==="error"&&this.sessionEmitter.fire(w.message),this.logService[w.type](w.message)}dispose(){super.dispose();for(const[,w]of this.watcherRequests)w.dispose();this.watcherRequests.clear()}}}),define(ee[94],te([0,1,28,251,8,35,17,4,27,2,9,3,16,51,24,149,18,92,93,177,183,39]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(v)}catch(h){console.error(`Error enabling graceful-fs: ${(0,l.toErrorMessage)(h)}`)}})();class o extends a.AbstractDiskFileSystemProvider{constructor(s,i){super(s);this.options=i,this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new C.ResourceMap(r=>p.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,p.joinPath)(s,u.name))).type:d=this.toType(u),r.push([u.name,d])}catch(d){this.logService.trace(d)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=y.FileType.Unknown:s.isFile()?r=y.FileType.File:s.isDirectory()?r=y.FileType.Directory:r=y.FileType.Unknown,i&&(r|=y.FileType.SymbolicLink),r}async createResourceLock(s){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(s)})`);let i;for(;i=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(s)})`),await i.wait();const r=new D.Barrier;return this.resourceLocks.set(s,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(s)})`),(0,m.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(s)})`),this.resourceLocks.delete(s),r.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const u=this.toFilePath(s);return await t.Promises.readFile(u)}catch(u){throw this.toFileSystemProviderError(u)}finally{r?.dispose()}}readFileStream(s,i,r){const u=(0,S.newWriteableStream)(d=>k.VSBuffer.concat(d.map(b=>k.VSBuffer.wrap(b))).buffer);return(0,w.readFileIntoStream)(this,s,u,d=>d.buffer,{...i,bufferSize:256*1024},r),u}async writeFile(s,i,r){let u;try{const d=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(d)){if(!r.overwrite)throw(0,y.createFileSystemProviderError)((0,g.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,y.createFileSystemProviderError)((0,g.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(u,0,i,0,i.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(s,d)}finally{typeof u=="number"&&await this.close(u)}}async open(s,i){let r;(0,y.isFileOpenForWriteOptions)(i)&&(r=await this.createResourceLock(s));let u;try{const d=this.toFilePath(s);if((0,y.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:L}=await t.SymlinkSupport.stat(d);L.mode&128||await t.Promises.chmod(d,L.mode|128)}catch(L){this.logService.trace(L)}let b;if((0,y.isFileOpenForWriteOptions)(i)){if(I.isWindows)try{await t.Promises.truncate(d,0),b="r+"}catch(L){L.code!=="ENOENT"&&this.logService.trace(L)}b||(b="w")}else b="r";u=await t.Promises.open(d,b)}catch(d){throw r?.dispose(),(0,y.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,d):this.toFileSystemProviderError(d)}return this.mapHandleToPos.set(u,0),(0,y.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(u,s),r&&this.mapHandleToLock.set(u,r),u}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await t.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(s);i&&(this.mapHandleToLock.delete(s),i.dispose())}}async read(s,i,r,u,d){const b=this.normalizePos(s,i);let L=null;try{const R=await t.Promises.read(s,r,u,d,b);return typeof R=="number"?L=R:L=R.bytesRead,L}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(s,b,L)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const u=this.mapHandleToPos.get(s);typeof u=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,u+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,u,d){return(0,D.retry)(()=>this.doWrite(s,i,r,u,d),100,3)}async doWrite(s,i,r,u,d){const b=this.normalizePos(s,i);let L=null;try{const R=await t.Promises.write(s,r,u,d,b);return typeof R=="number"?L=R:L=R.bytesWritten,L}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),R)}finally{this.updatePos(s,b,L)}}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const u=this.toFilePath(s),d=this.toFilePath(i);if(u!==d)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(u,d)}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,g.localize)(2,null,(0,E.basename)(u),(0,E.basename)((0,E.dirname)(d)),b.toString()))),this.toFileSystemProviderError(b)}}async copy(s,i,r){const u=this.toFilePath(s),d=this.toFilePath(i);if(u!==d)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(u,d,{preserveSymlinks:!0})}catch(b){throw(b.code==="EINVAL"||b.code==="EBUSY"||b.code==="ENAMETOOLONG")&&(b=new Error((0,g.localize)(3,null,(0,E.basename)(u),(0,E.basename)((0,E.dirname)(d)),b.toString()))),this.toFileSystemProviderError(b)}}async validateTargetDeleted(s,i,r,u){const d=this.toFilePath(s),b=this.toFilePath(i);let L=!1;if(!!(this.capabilities&1024)||(L=(0,f.isEqual)(d,b,!0)),L&&r==="copy")throw(0,y.createFileSystemProviderError)((0,g.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!L&&await t.Promises.exists(b)){if(!u)throw(0,y.createFileSystemProviderError)((0,g.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,i,r){return new c.ParcelWatcherClient(u=>s(u),u=>i(u),r)}doWatch(s,i){const r=this.options?.watcher?.usePolling;if(r===!0)for(const u of i)u.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const u of i)r.includes(u.path)&&(u.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,i)}createNonRecursiveWatcher(s,i,r,u){return new M.NodeJSFileWatcher(s,d=>i(d),d=>r(d),u)}toFileSystemProviderError(s){if(s instanceof y.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=y.FileSystemProviderErrorCode.NoPermissions;break;default:i=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await t.SymlinkSupport.stat(this.toFilePath(s));u.mode&128||(r=(0,y.createFileSystemProviderError)(i,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return r}}e.DiskFileSystemProvider=o}),define(ee[95],te([0,1,6]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(C,k){switch(k){case v.LogLevel.Trace:return C.trace;case v.LogLevel.Debug:return C.debug;case v.LogLevel.Info:return C.info;case v.LogLevel.Warning:return C.warn;case v.LogLevel.Error:return C.error;case v.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(P=>{this._logger&&this._logger.setLevel(P)}))}set logger(k){this._logger=k;for(const{level:P,args:f}of this.buffer)n(k,P).apply(k,f);this.buffer=[]}_log(k,...P){this._logger?n(this._logger,k).apply(this._logger,P):this.getLevel()<=k&&this.buffer.push({level:k,args:P})}trace(k,...P){this._log(v.LogLevel.Trace,k,...P)}debug(k,...P){this._log(v.LogLevel.Debug,k,...P)}info(k,...P){this._log(v.LogLevel.Info,k,...P)}warn(k,...P){this._log(v.LogLevel.Warning,k,...P)}error(k,...P){this._log(v.LogLevel.Error,k,...P)}critical(k,...P){this._log(v.LogLevel.Critical,k,...P)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(ee[186],te([0,1,8,17,16,18,5,95,6]),function(G,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const m=5*C.ByteSize.MB;let E=class extends f.AbstractLogger{constructor(S,t,g,y,w){super();this.name=S,this.resource=t,this.donotUseFormatters=y,this.fileService=w,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,(0,f.format)(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,(0,f.format)(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,(0,f.format)(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,(0,f.format)(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=S.stack,this._log(f.LogLevel.Error,(0,f.format)(t))}else this._log(f.LogLevel.Error,(0,f.format)(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,(0,f.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,t){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>m&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=t:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(g))})}getCurrentTimestamp(){const S=y=>y<10?`0${y}`:y,t=y=>y<10?`00${y}`:y<100?`0${y}`:y,g=new Date;return`${g.getFullYear()}-${S(g.getMonth()+1)}-${S(g.getDate())} ${S(g.getHours())}:${S(g.getMinutes())}:${S(g.getSeconds())}.${t(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(S){switch(S){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}};E=de([re(4,C.IFileService)],E),e.FileLogger=E;let I=class extends f.AbstractLoggerService{constructor(S,t,g){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=t,this.fileService=g}doCreateLogger(S,t,g){const y=new P.BufferLogService(t);return(0,C.whenProviderRegistered)(S,this.fileService).then(()=>y.logger=this.instantiationService.createInstance(E,g?.name||(0,D.basename)(S),S,y.getLevel(),!!g?.donotUseFormatters)),y}};I=de([re(0,f.ILogService),re(1,k.IInstantiationService),re(2,C.IFileService)],I),e.FileLoggerService=I}),define(ee[187],te([0,1,4,7,6]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(p){this.service=p,this.onDidChangeLogLevel=v.Event.buffer(p.onDidChangeLogLevel,!0)}listen(p,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(p,S,t){switch(S){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=C;class k{constructor(p){this.channel=p}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(p){k.setLevel(this.channel,p)}static setLevel(p,S){return p.call("setLevel",S)}}e.LogLevelChannelClient=k;class P{constructor(p){this.loggerService=p,this.loggers=new Map}listen(p,S){throw new Error(`Event not found: ${S}`)}async call(p,S,t){switch(S){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${S}`)}createLogger(p,S){this.loggers.set(p.toString(),this.loggerService.createLogger(p,S))}consoleLog(p,S){let t=console.log;switch(p){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...S)}log(p,S){const t=this.loggers.get(p.toString());if(!t)throw new Error("Create the logger before logging");for(const[g,y]of S)(0,D.log)(t,g,y)}}e.LoggerChannel=P;class f extends D.AbstractLoggerService{constructor(p,S,t){super(p,S);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(p,S)=>{this.channel.call("consoleLog",[p,S])}})}doCreateLogger(p,S,t){return new m(this.channel,p,S,t)}}e.LoggerChannelClient=f;class m extends D.AbstractMessageLogger{constructor(p,S,t,g){super(g?.always);this.channel=p,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[S,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(p,S){const t=[[p,S]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(p){this.channel.call("log",[this.file,p])}}class E extends D.LogService{constructor(p,S){super(S);this.parent=p,this._register(p.onDidChangeLogLevel(t=>S.setLevel(t)))}setLevel(p){super.setLevel(p),this.parent.setLevel(p)}}e.FollowerLogService=E}),define(ee[96],te([0,1,18,6]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(P,f,m,E,I){try{const p=await new Promise((t,g)=>{G(["spdlog"],t,g)});p.setFlushOn(n.LogLevel.Trace);const S=await p.createAsyncRotatingLogger(P,f,m,E);return I&&S.clearFormatters(),S}catch(p){console.error(p)}return null}function C(P,f,m){switch(f){case n.LogLevel.Trace:P.trace(m);break;case n.LogLevel.Debug:P.debug(m);break;case n.LogLevel.Info:P.info(m);break;case n.LogLevel.Warning:P.warn(m);break;case n.LogLevel.Error:P.error(m);break;case n.LogLevel.Critical:P.critical(m);break;default:throw new Error("Invalid log level")}}class k extends n.AbstractMessageLogger{constructor(f,m,E,I,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(f,m,E,I),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(f,m,E,I){const p=E?6:1,S=30/p*v.ByteSize.MB,t=await D(f,m,S,p,I);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:g,message:y}of this.buffer)C(this._logger,g,y);this.buffer=[]}}log(f,m){this._logger?C(this._logger,f,m):this.getLevel()<=f&&this.buffer.push({level:f,message:m})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(ee[188],te([0,1,10,16,32,18,186,6,96]),function(G,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let m=class extends P.AbstractLoggerService{constructor(I,p){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=p}doCreateLogger(I,p,S){return I.scheme===v.Schemas.file?new f.SpdLogLogger(S?.name||(0,D.generateUuid)(),I.fsPath,!S?.donotRotate,!!S?.donotUseFormatters,p):new k.FileLogger(S?.name??(0,n.basename)(I),I,p,!!S?.donotUseFormatters,this.fileService)}};m=de([re(0,P.ILogService),re(1,C.IFileService)],m),e.LoggerService=m}),define(ee[189],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function n(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(k){return!v(k)&&!n(k)&&!D(k)}e.isMenubarMenuItemAction=C}),define(ee[55],te([0,1,10,3,34,16]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const P=n.globals.vscode.context.configuration();if(P)k=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof G?.__$__nodeRequire=="function"){const P=(0,C.dirname)(v.FileAccess.asFileUri("",G));k=G.__$__nodeRequire((0,C.joinPath)(P,"product.json").fsPath);const f=G.__$__nodeRequire((0,C.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:f.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(ee[22],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ee[190],te([0,1,60,6,22]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(P,f){this.productService=P,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(P,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const m=/^(.*)#([^#]+)$/.exec(f);if(!m)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,E,I]=m;let p=this.trustedExtensionUrlPublicKeys.get(P);if(!p){if(p=this.productService.trustedExtensionUrlPublicKeys[P],!p||p.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",P),!1;this.trustedExtensionUrlPublicKeys.set(P,[...p])}const S=Buffer.from(decodeURIComponent(I),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const t=S.slice(0,6),g=S.readUIntBE(0,6),y=Date.now()-g;if(y<0||y>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const w=S.slice(6),M=v.createVerify("SHA256");M.write(t),M.write(Buffer.from(E)),M.end();for(let c=0;c<p.length;c++){let a=p[c];if(a!==null){if(typeof a=="string")try{a=v.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),p[c]=a}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${P}:`,l),p[c]=null;continue}if(M.verify(a,w))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};C=de([re(0,D.IProductService),re(1,n.ILogService)],C),e.ExtensionUrlTrustService=C}),define(ee[56],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(ee[191],te([0,1,14,2,35,10,3,16,7,32,53,6]),function(G,e,v,n,D,C,k,P,f,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let p=class extends n.Disposable{constructor(t,g){super();this.logService=g,this.validRoots=D.TernarySearchTree.forUris(()=>!k.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(t.appRoot)),this.addValidFileRoot(f.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=v.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(g,y)=>this.handleResourceRequest(g,y)),t.protocol.interceptFileProtocol(C.Schemas.file,(g,y)=>this.handleFileRequest(g,y)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?n.Disposable.None:(this.validRoots.set(t,!0),(0,n.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,g){const y=f.URI.parse(t.url);return this.logService.error(`Refused to load resource ${y.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),g({error:-3})}handleResourceRequest(t,g){const y=f.URI.parse(t.url),w=C.FileAccess.asFileUri(y);return this.validRoots.findSubstr(w)?g({path:w.fsPath}):this.validExtensions.has((0,P.extname)(w))?g({path:w.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${w.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),g({error:-3}))}createIPCObjectUrl(){let t;const g=f.URI.from({scheme:"vscode",path:(0,m.generateUuid)()}),y=g.toString(),w=async()=>t;return v.ipcMain.handle(y,w),this.logService.trace(`IPC Object URL: Registered new channel ${y}.`),{resource:g,update:M=>t=M,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${y}.`),v.ipcMain.removeHandler(y)}}}};p=de([re(0,E.INativeEnvironmentService),re(1,I.ILogService)],p),e.ProtocolMainService=p}),define(ee[40],te([0,1,102,13]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,P){v.ok(n.isString(k)),v.ok(n.isObject(P)),v.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,P)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(ee[192],te([0,1,4,40]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,m){this.schemasById[D(f)]=m,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new C;n.Registry.add(e.Extensions.JSONContribution,k)}),define(ee[57],te([0,1,31,4,13,137,192,40]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var m;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=P.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,o=!0){this.registerConfigurations([l],o)}registerConfigurations(l,o=!0){const h=this.doRegisterConfigurations(l,o);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:h})}deregisterConfigurations(l){const o=this.doDeregisterConfigurations(l);E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:l,remove:o}){const h=[];h.push(...this.doDeregisterConfigurations(o)),h.push(...this.doRegisterConfigurations(l,!1)),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,v.distinct)(h)})}registerDefaultConfigurations(l){const o=[],h=[];for(const{overrides:s,source:i}of l)for(const r in s)if(o.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const u={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:u});const d={type:"object",default:u,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:D.isString(i)?void 0:i};h.push(...t(r)),this.configurationProperties[r]=d,this.defaultLanguageConfigurationOverridesNode.properties[r]=d}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const u=this.configurationProperties[r];u&&(this.updatePropertyDefaultValue(r,u),this.updateSchema(r,u))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const o=[];for(const{overrides:h,source:s}of l)for(const i in h){const r=this.configurationDefaultsOverrides.get(i),u=D.isString(s)?s:s?.id,d=D.isString(r?.source)?r?.source:r?.source?.id;if(u===d)if(o.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const b=this.configurationProperties[i];b&&(this.updatePropertyDefaultValue(i,b),this.updateSchema(i,b))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const o of l)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,o){const h=[];return l.forEach(s=>{h.push(...this.validateAndRegisterProperties(s,o,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),h}doDeregisterConfigurations(l){const o=[],h=s=>{if(s.properties)for(const i in s.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>h(i))};for(const s of l){h(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(l,o=!0,h,s,i=3){i=D.isUndefinedOrNull(l.scope)?i:l.scope;let r=[],u=l.properties;if(u)for(let b in u){if(o&&M(b)){delete u[b];continue}const L=u[b];if(L.source=h,L.defaultDefaultValue=u[b].default,this.updatePropertyDefaultValue(b,L),e.OVERRIDE_PROPERTY_REGEX.test(b)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?i:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!s?.includes(b):L.restricted),u[b].hasOwnProperty("included")&&!u[b].included){this.excludedConfigurationProperties[b]=u[b],delete u[b];continue}else this.configurationProperties[b]=u[b];!u[b].deprecationMessage&&u[b].markdownDeprecationMessage&&(u[b].deprecationMessage=u[b].markdownDeprecationMessage),r.push(b)}let d=l.allOf;if(d)for(let b of d)r.push(...this.validateAndRegisterProperties(b,o,h,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const o=h=>{let s=h.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=h.allOf;i&&i.forEach(o)};o(l)}updateSchema(l,o){switch(e.allSettings.properties[l]=o,o.scope){case 1:e.applicationSettings.properties[l]=o;break;case 2:e.machineSettings.properties[l]=o;break;case 6:e.machineOverridableSettings.properties[l]=o;break;case 3:e.windowSettings.properties[l]=o;break;case 4:e.resourceSettings.properties[l]=o;break;case 5:e.resourceSettings.properties[l]=o,this.resourceLanguageSettingsSchema.properties[l]=o;break}}removeFromSchema(l,o){switch(delete e.allSettings.properties[l],o.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const o=`[${l}]`,h={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,h),e.allSettings.properties[o]=h,e.applicationSettings.properties[o]=h,e.machineSettings.properties[o]=h,e.machineOverridableSettings.properties[o]=h,e.windowSettings.properties[o]=h,e.resourceSettings.properties[o]=h}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,o){const h=this.configurationDefaultsOverrides.get(l);let s=h?.value,i=h?.source;D.isUndefined(s)&&(s=o.defaultDefaultValue,i=void 0),D.isUndefined(s)&&(s=y(o.type)),o.default=s,o.defaultValueSource=i}}const p="\\[([^\\]]+)\\]",S=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let o=S.exec(a);for(;o?.length;){const h=o[1].trim();h&&l.push(h),o=S.exec(a)}}return(0,v.distinct)(l)}e.overrideIdentifiersFromKey=t;function g(a){return a.reduce((l,o)=>`${l}[${o}]`,"")}e.keyFromOverrideIdentifiers=g;function y(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const w=new I;P.Registry.add(e.Extensions.Configuration,w);function M(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?C.localize(7,null,a):w.getConfigurationProperties()[a]!==void 0?C.localize(8,null,a):null:C.localize(6,null)}e.validateProperty=M;function c(){const a=[],l=w.getConfigurationProperties();for(const o of Object.keys(l))a.push([o,l[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(ee[193],te([0,1,31,4,43,2,35,47,13,7,19,57,40]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,E.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,E.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return v.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return v.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=P.deepClone(this.contents),r=P.deepClone(this.overrides),u=[...this.keys];for(const d of s){this.mergeContents(i,d.contents);for(const b of d.overrides){const[L]=r.filter(R=>v.equals(R.identifiers,b.identifiers));L?(this.mergeContents(L.contents,b.contents),L.keys.push(...b.keys),L.keys=v.distinct(L.keys)):r.push(P.deepClone(b))}for(const b of d.keys)u.indexOf(b)===-1&&u.push(b)}return new S(i,u,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const u of v.distinct([...Object.keys(this.contents),...Object.keys(i)])){let d=this.contents[u],b=i[u];b&&(typeof d=="object"&&typeof b=="object"?(d=P.deepClone(d),this.mergeContents(d,b)):d=b),r[u]=d}return new S(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&f.isObject(s[r])&&f.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=P.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?P.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const u=d=>{d&&(r?this.mergeContents(r,d):r=P.deepClone(d))};for(const d of this.overrides)v.equals(d.identifiers,[s])?i=d.contents:d.identifiers.includes(s)&&u(d.contents);return u(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,E.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,E.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class t extends S{constructor(s={}){const i=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),u=Object.create(null),d=[];for(const b in i){const L=s[b],R=L!==void 0?L:i[b].default;(0,E.addToValueTree)(u,b,R,T=>console.error(`Conflict in default settings: ${T}`))}for(const b of Object.keys(u))I.OVERRIDE_PROPERTY_REGEX.test(b)&&d.push({identifiers:(0,I.overrideIdentifiersFromKey)(b),keys:Object.keys(u[b]),contents:(0,E.toValuesTree)(u[b],L=>console.error(`Conflict in default settings file: ${L}`))});super(u,r,d)}}e.DefaultConfigurationModel=t;class g{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!f.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:u,overrides:d,restricted:b}=this.doParseRaw(s,i);this._configurationModel=new S(r,u,d),this._restrictedConfigurations=b||[]}doParseContent(s){let i={},r=null,u=[],d=[],b=[];function L(T){Array.isArray(u)?u.push(T):r!==null&&(u[r]=T)}let R={onObjectBegin:()=>{let T={};L(T),d.push(u),u=T,r=null},onObjectProperty:T=>{r=T},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{let T=[];L(T),d.push(u),u=T,r=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:L,onError:(T,U,Q)=>{b.push({error:T,offset:U,length:Q})}};if(s)try{D.visit(s,R),i=u[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(s,i){const r=p.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=this.filter(s,r,!0,i);s=u.raw;const d=(0,E.toValuesTree)(s,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),b=Object.keys(s),L=this.toOverrides(s,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:d,keys:b,overrides:L,restricted:u.restricted}}filter(s,i,r,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:s,restricted:[]};const d={},b=[];for(let L in s)if(I.OVERRIDE_PROPERTY_REGEX.test(L)&&r){const R=this.filter(s[L],i,!1,u);d[L]=R.raw,b.push(...R.restricted)}else{const R=i[L],T=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&b.push(L),(T===void 0||u.scopes===void 0||u.scopes.includes(T))&&(u.skipRestricted&&R?.restricted||(d[L]=s[L]))}return{raw:d,restricted:b}}toOverrides(s,i){const r=[];for(const u of Object.keys(s))if(I.OVERRIDE_PROPERTY_REGEX.test(u)){const d={};for(const b in s[u])d[b]=s[u][b];r.push({identifiers:(0,I.overrideIdentifiersFromKey)(u),keys:Object.keys(d),contents:(0,E.toValuesTree)(d,i)})}return r}}e.ConfigurationModelParser=g;class y extends C.Disposable{constructor(s,i,r,u){super();this.userSettingsResource=s,this.scopes=i,this.fileService=u,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class w{constructor(s,i,r=new S,u=new S,d=new k.ResourceMap,b=new S,L=new k.ResourceMap,R=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=u,this._folderConfigurations=d,this._memoryConfiguration=b,this._memoryConfigurationByResource=L,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let u;r.resource?(u=this._memoryConfigurationByResource.get(r.resource),u||(u=new S,this._memoryConfigurationByResource.set(r.resource,u))):u=this._memoryConfiguration,i===void 0?u.removeValue(s):u.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const u=this.getConsolidateConfigurationModel(i,r),d=this.getFolderConfigurationModelForResource(i.resource,r),b=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,L=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),Q=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,se=d?i.overrideIdentifier?d.freeze().override(i.overrideIdentifier).getValue(s):d.freeze().getValue(s):void 0,ne=i.overrideIdentifier?b.override(i.overrideIdentifier).getValue(s):b.getValue(s),V=u.getValue(s),J=v.distinct(v.flatten(u.overrides.map(q=>q.identifiers))).filter(q=>u.getOverrideValue(s,q)!==void 0);return{defaultValue:L,userValue:R,userLocalValue:T,userRemoteValue:U,workspaceValue:Q,workspaceFolderValue:se,memoryValue:ne,value:V,default:L!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:d?.freeze().getValue(s),override:i.overrideIdentifier?d?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:b.getValue(s),override:i.overrideIdentifier?b.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:J.length?J:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:u,updated:d,removed:b}=l(this._defaultConfiguration,s);i=[...u,...d,...b]}for(const u of i)for(const d of(0,I.overrideIdentifiersFromKey)(u)){const b=this._defaultConfiguration.getKeysForOverrideIdentifier(d),L=s.getKeysForOverrideIdentifier(d),R=[...L.filter(T=>b.indexOf(T)===-1),...b.filter(T=>L.indexOf(T)===-1),...b.filter(T=>!P.equals(this._defaultConfiguration.override(d).getValue(T),s.override(d).getValue(T)))];r.push([d,R])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:u,overrides:d}=l(this.localUserConfiguration,s),b=[...i,...r,...u];return b.length&&this.updateLocalUserConfiguration(s),{keys:b,overrides:d}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:u,overrides:d}=l(this.remoteUserConfiguration,s);let b=[...i,...r,...u];return b.length&&this.updateRemoteUserConfiguration(s),{keys:b,overrides:d}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:u,overrides:d}=l(this.workspaceConfiguration,s);let b=[...i,...r,...u];return b.length&&this.updateWorkspaceConfiguration(s),{keys:b,overrides:d}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:u,updated:d,removed:b,overrides:L}=l(r,i);let R=[...u,...d,...b];return(R.length||!r)&&this.updateFolderConfiguration(s,i),{keys:R,overrides:L}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:u,removed:d,overrides:b}=l(i,void 0);return{keys:[...r,...u,...d],overrides:b}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const u=i.getFolder(s);u&&(r=this.getFolderConsolidatedConfiguration(u.uri)||r);const d=this._memoryConfigurationByResource.get(s);d&&(r=r.merge(d))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(s);u?(i=r.merge(u),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:u,keys:d}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:u,keys:d}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(u=>i.add(u))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),u=this.parseConfigurationModel(s.workspace),d=s.folders.reduce((b,L)=>(b.set(m.URI.revive(L[0]),this.parseConfigurationModel(L[1])),b),new k.ResourceMap);return new w(i,r,new S,u,d,new S,new k.ResourceMap,!1)}static parseConfigurationModel(s){return new S(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=w;function M(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,i=new Map;for(const u of h)u.keys.forEach(d=>s.add(d)),u.overrides.forEach(([d,b])=>{const L=(0,k.getOrSet)(i,d,new Set);b.forEach(R=>L.add(R))});const r=[];return i.forEach((u,d)=>r.push([d,[...u.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=M;class c{constructor(s,i,r,u){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=u,this._previousConfiguration=void 0;const d=new Set;s.keys.forEach(L=>d.add(L)),s.overrides.forEach(([,L])=>L.forEach(R=>d.add(R))),this.affectedKeys=[...d.values()];const b=new S;this.affectedKeys.forEach(L=>b.setValue(L,{})),this.affectedKeysTree=b.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!P.equals(r,u)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,E.toValuesTree)({[i]:!0},()=>{}),u;for(;typeof r=="object"&&(u=Object.keys(r)[0]);){if(s=s[u],!s)return!1;r=r[u]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(s,i,r,u){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=a;function l(h,s){const{added:i,removed:r,updated:u}=o(s,h),d=[],b=h?.getAllOverrideIdentifiers()||[],L=s?.getAllOverrideIdentifiers()||[];if(s){const R=L.filter(T=>!b.includes(T));for(const T of R)d.push([T,s.getKeysForOverrideIdentifier(T)])}if(h){const R=b.filter(T=>!L.includes(T));for(const T of R)d.push([T,h.getKeysForOverrideIdentifier(T)])}if(s&&h){for(const R of b)if(L.includes(R)){const T=o({contents:h.getOverrideValue(void 0,R)||{},keys:h.getKeysForOverrideIdentifier(R)},{contents:s.getOverrideValue(void 0,R)||{},keys:s.getKeysForOverrideIdentifier(R)});d.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:r,updated:u,overrides:d}}function o(h,s){const i=h?s?h.keys.filter(d=>s.keys.indexOf(d)===-1):[...h.keys]:[],r=s?h?s.keys.filter(d=>h.keys.indexOf(d)===-1):[...s.keys]:[],u=[];if(h&&s){for(const d of s.keys)if(h.keys.indexOf(d)!==-1){const b=(0,E.getConfigurationValue)(s.contents,d),L=(0,E.getConfigurationValue)(h.contents,d);P.equals(b,L)||u.push(d)}}return{added:i,removed:r,updated:u}}}),define(ee[194],te([0,1,8,4,2,16,19,193,57,40]),function(G,e,v,n,D,C,k,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends D.Disposable{constructor(p,S){super();this.settingsResource=p,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,S)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const p=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(p,S){const t=typeof p=="string"?p:void 0,g=(0,k.isConfigurationOverrides)(p)?p:(0,k.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(t,g,void 0)}updateValue(p,S,t,g){return Promise.reject(new Error("not supported"))}inspect(p){return this.configuration.inspect(p,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const p=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(p)}onDidChangeUserConfiguration(p){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(p);this.trigger(t,S,1)}onDidDefaultConfigurationChange(p){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,p);this.trigger(t,S,6)}trigger(p,S,t){const g=new P.ConfigurationChangeEvent(p,{data:S},this.configuration);g.source=t,g.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(p){switch(p){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(ee[195],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var n;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,P=n.Unknown,f){super(k);this._message=k,this._code=P,this._detail=f,this.isHandled=P===n.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===n.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===n.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(ee[196],te([0,1,8,17,21,15,4,2,32,85,195]),function(G,e,v,n,D,C,k,P,f,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var p;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function S(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(H){const F=new D.CancellationTokenSource;return setTimeout(()=>F.cancel(),H),F.token}function g(H,F){if(H.isCancellationRequested||F.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return H.onCancellationRequested(()=>W.cancel()),F.onCancellationRequested(()=>W.cancel()),W.token}class y{constructor(F){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((W,A)=>{this._resolvePromise=W,this._rejectPromise=A}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function w(H,F){const W=new y(F);return W.registerDisposable(H.onControlMessage(A=>{const _=JSON.parse(A.toString()),N=K(_);N?W.reject(N):W.resolve(_)})),W.promise}function M(H,F,W,A,_,N,O){const z=new y(O);return F.connect(W,A,_,N,(x,ie)=>{z.didTimeout?(x&&H.error(x),ie?.dispose()):x||!ie?z.reject(x):z.resolve(ie)}),z.promise}function c(H,F){const W=new y(F);return H.then(A=>{W.didTimeout||W.resolve(A)},A=>{W.didTimeout||W.reject(A)}),W.promise}async function a(H,F,W,A){const _=$(H,F);H.logService.trace(`${_} 1/6. invoking socketFactory.connect().`);let N;try{N=await M(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${S(F)}-${H.reconnectionToken}`,A)}catch(oe){throw H.logService.error(`${_} socketFactory.connect() failed or timed out. Error:`),H.logService.error(oe),oe}H.logService.trace(`${_} 2/6. socketFactory.connect() was successful.`);let O,z;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(N,null),O=H.reconnectionProtocol,z=!1):(O=new m.PersistentProtocol(N,null),z=!0),H.logService.trace(`${_} 3/6. sending AuthRequest control message.`);const x=await c(H.signService.createNewMessage((0,f.generateUuid)()),A),ie={type:"auth",auth:H.connectionToken||"00000000000000000000",data:x.data};O.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await w(O,g(A,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(H.logService.trace(`${_} 4/6. received SignRequest control message.`),!await c(H.signService.validate(x,oe.signedData),A)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await c(H.signService.sign(oe.data),A),le={type:"connectionType",commit:H.commit,signedData:ce,desiredConnectionType:F};return W&&(le.args=W),H.logService.trace(`${_} 5/6. sending ConnectionTypeRequest control message.`),O.sendControl(n.VSBuffer.fromString(JSON.stringify(le))),{protocol:O,ownsProtocol:z}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(H.logService.error(`${_} the handshake timed out. Error:`),H.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${_} received error control message when negotiating connection. Error:`),H.logService.error(oe)),z&&q(O),oe}}async function l(H,F,W,A){const _=Date.now(),N=$(H,F),{protocol:O,ownsProtocol:z}=await a(H,F,W,A),x=new y(A);return x.registerDisposable(O.onControlMessage(ie=>{const oe=JSON.parse(ie.toString()),Z=K(oe);Z?(H.logService.error(`${N} received error control message when negotiating connection. Error:`),H.logService.error(Z),z&&q(O),x.reject(Z)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${Y(_)}!`),x.resolve({protocol:O,firstMessage:oe}))})),x.promise}async function o(H,F){const{protocol:W}=await l(H,1,void 0,F);return{protocol:W}}async function h(H,F,W){const{protocol:A,firstMessage:_}=await l(H,2,F,W),N=_&&_.debugPort;return{protocol:A,debugPort:N}}async function s(H,F,W){const A=Date.now(),_=$(H,3),{protocol:N}=await a(H,3,F,W);return H.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${Y(A)}!`),N}async function i(H,F,W){const{host:A,port:_,connectionToken:N}=await H.addressProvider.getAddress();return{commit:H.commit,host:A,port:_,connectionToken:N,reconnectionToken:F,reconnectionProtocol:W,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function r(H,F,W){try{const A=(0,f.generateUuid)(),_=await i(H,A,null),{protocol:N}=await o(_,D.CancellationToken.None);return new V(H,F,W,A,N)}catch(A){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(A),ne.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(A)),A}}e.connectRemoteAgentManagement=r;async function u(H,F){try{const W=(0,f.generateUuid)(),A=await i(H,W,null),{protocol:_,debugPort:N}=await h(A,F,D.CancellationToken.None);return new J(H,F,W,_,N)}catch(W){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(W),ne.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=u;async function d(H,F,W){const A=await i(H,(0,f.generateUuid)(),null);return await s(A,{host:F,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=d;function b(H){return(0,v.createCancelablePromise)(F=>new Promise((W,A)=>{const _=setTimeout(W,H*1e3);F.onCancellationRequested(()=>{clearTimeout(_),W()})}))}var L;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(F,W){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=R;class T{constructor(F,W,A,_){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.durationSeconds=A,this.cancellableTimer=_,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class U{constructor(F,W,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.attempt=A,this.type=2}}e.ReconnectionRunningEvent=U;class Q{constructor(F,W,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.attempt=A,this.type=4}}e.ConnectionGainEvent=Q;class se{constructor(F,W,A,_){this.reconnectionToken=F,this.millisSinceLastIncomingData=W,this.attempt=A,this.handled=_,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class ne extends P.Disposable{constructor(F,W,A,_){super();this._connectionType=F,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=A,this.protocol=_,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(_.onSocketClose(N=>{const O=B(this._connectionType,this.reconnectionToken,!0);N?N.type===0?(this._options.logService.info(`${O} received socket close event (hadError: ${N.hadError}).`),N.error&&this._options.logService.error(N.error)):(this._options.logService.info(`${O} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this._options.logService.error(N.event)):this._options.logService.info(`${O} received socket close event.`),this._beginReconnecting()})),this._register(_.onSocketTimeout(()=>{const N=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${N} received socket timeout event.`),this._beginReconnecting()})),ne._instances.push(this),ne._permanentFailure&&this._gotoPermanentFailure(ne._permanentFailureMillisSinceLastIncomingData,ne._permanentFailureAttempt,ne._permanentFailureHandled)}static triggerPermanentFailure(F,W,A){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=W,this._permanentFailureHandled=A,this._instances.forEach(_=>_._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(ne._permanentFailure)return;const F=B(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let A=-1;do{A++;const _=A<W.length?W[A]:W[W.length-1];try{if(_>0){const O=b(_);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_,O)),this._options.logService.info(`${F} waiting for ${_} seconds before reconnecting...`);try{await O}catch{}}if(ne._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1)),this._options.logService.info(`${F} resolving connection...`);const N=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${N.host}:${N.port}...`),await this._reconnect(N,t(I)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A+1));break}catch(N){if(N.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(N),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(A>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(N),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(N)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((N.code==="ETIMEDOUT"||N.code==="ENETUNREACH"||N.code==="ECONNREFUSED"||N.code==="ECONNRESET")&&N.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if((0,C.isPromiseCanceledError)(N)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(N);continue}if(N instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(N),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,E.RemoteAuthorityResolverError.isHandled(N));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(N),ne.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),A+1,!1);break}}while(!ne._permanentFailure)}_gotoPermanentFailure(F,W,A){this._onDidStateChange.fire(new se(this.reconnectionToken,F,W,A)),q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ne,ne._permanentFailure=!1,ne._permanentFailureMillisSinceLastIncomingData=0,ne._permanentFailureAttempt=0,ne._permanentFailureHandled=!1,ne._instances=[];class V extends ne{constructor(F,W,A,_,N){super(1,F,_,N);this.client=this._register(new m.Client(N,{remoteAuthority:W,clientId:A},F.ipcLogger))}async _reconnect(F,W){await o(F,W)}}e.ManagementPersistentConnection=V;class J extends ne{constructor(F,W,A,_,N){super(2,F,A,_);this._startArguments=W,this.debugPort=N}async _reconnect(F,W){await h(F,this._startArguments,W)}}e.ExtensionHostPersistentConnection=J;function q(H){try{H.acceptDisconnect();const F=H.getSocket();H.dispose(),F.dispose()}catch(F){(0,C.onUnexpectedError)(F)}}function K(H){if(H&&H.type==="error"){const F=new Error(`Connection error: ${H.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function j(H,F){for(;H.length<F;)H+=" ";return H}function B(H,F,W){return`[remote-connection][${j(S(H),13)}][${F.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function $(H,F){return`${B(F,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function Y(H){return`${Date.now()-H} ms`}}),define(ee[64],te([0,1,10]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(m){return m.scheme===v.Schemas.vscodeRemote?m.authority:void 0}e.getRemoteAuthority=n;function D(m){if(!m)return;const E=m.indexOf("+");return E<0?m:m.substr(0,E)}e.getRemoteName=D;function C(m){return m.scheme!==v.Schemas.file&&m.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=C;function k(m){if(m.folders.length)return m.folders.every(E=>C(E.uri))?m.folders[0].uri:void 0;if(m.configuration&&C(m.configuration))return m.configuration}e.getVirtualWorkspaceLocation=k;function P(m){return k(m)?.scheme}e.getVirtualWorkspaceScheme=P;function f(m){return k(m)!==void 0}e.isVirtualWorkspace=f}),define(ee[197],te([0,1,25,5,64]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=C;function k(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class f{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,t){if(typeof S=="undefined"||S===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof S=="string"||typeof t=="string"){let g=typeof S=="string"?S:S.value,y=typeof t=="string"?t:t.value;return v.equalsIgnoreCase(g,y)}return S._lower===t._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=f;function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function E(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function I(p,S){if(S){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return p.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ee[198],te([0,1,25,197]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,v.compareIgnoreCase)(t.id,g.id)===0}e.areSameExtensions=D;class C{constructor(g,y){this.version=y,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof C?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=C;function k(t,g){return`${t}.${g}`}e.getExtensionId=k;function P(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function f(t,g){return P(k(t,g))}e.getGalleryExtensionId=f;function m(t,g){const y=[],w=M=>{for(const c of y)if(c.some(a=>D(g(a),g(M))))return c;return null};for(const M of t){const c=w(M);c?c.push(M):y.push([M])}return y}e.groupByExtension=m;function E(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function I(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function p(t){const g=new Set;if(t.malicious)for(const y of t.malicious)g.add(y.id);return g}e.getMaliciousExtensionsSet=p;function S(t,g){const y=[],w=g.manifest.extensionDependencies?.slice(0)??[];for(;w.length;){const M=w.shift();if(M&&y.every(c=>!D(c.identifier,{id:M}))){const c=t.filter(a=>D(a.identifier,{id:M}));c.length===1&&(y.push(c[0]),w.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.getExtensionDependencies=S}),define(ee[97],te([0,1,4,3,5,6]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(t){t.Http="http",t.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function m(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=m,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=I;function p(t,g){return g?g!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=p;let S=class{constructor(g){this.logService=g,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,y){return this._tunnelProvider=g,g?(this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],y=Array.from(this._tunnels.values());for(let w of y){const M=Array.from(w.values());for(let c of M){const a=await c.value;a&&g.push(a)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:y}of g.values())await y.then(w=>w?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,y,w,M,c=!1,a=P.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${w} on local port ${M}.`),!g)return;y||(y="localhost");const o=this.retainOrCreateTunnel(g,y,w,M,c,a,l);return o?o.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,w);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(h);return(h.tunnelRemoteHost!==y||h.tunnelRemotePort!==w)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const y=this._tunnels.get(g.tunnelRemoteHost);if(y){const w=y.get(g.tunnelRemotePort);w&&(w.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,w))}}}}async tryDisposeTunnel(g,y,w){if(w.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${y}.`);const M=w.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(y),M}}async closeTunnel(g,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${y} `);const w=this._tunnels.get(g);if(w&&w.has(y)){const M=w.get(y);M.refcount=0,await this.tryDisposeTunnel(g,y,M)}}addTunnelToMap(g,y,w){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(y,{refcount:1,value:w})}async removeEmptyTunnelFromMap(g,y){const w=this._tunnels.get(g);w&&(await w.get(y)||w.delete(y),w.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,y){let w=[g];E(g)?(w.push(...e.LOCALHOST_ADDRESSES),w.push(...e.ALL_INTERFACES_ADDRESSES)):I(g)&&w.push(...e.ALL_INTERFACES_ADDRESSES);const M=w.map(c=>this._tunnels.get(c));for(const c of M){const a=c?.get(y);if(a)return a}}canTunnel(g){return!!m(g)}createWithProvider(g,y,w,M,c,a,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${w} on local port ${M}.`);const h={elevationRequired:c?p(M===void 0?w:M):!1},s={remoteAddress:{host:y,port:w},localAddressPort:M,privacy:a,public:a!==P.Private,protocol:l},i=g.forwardPort(s,h);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(y,w,i),i}};S=de([re(0,C.ILogService)],S),e.AbstractTunnelService=S}),define(ee[48],te([0,1,17,153,57,5,40]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function P(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=P;function f(t){return t.res.statusCode===204}async function m(t){if(!P(t))throw new Error("Server returned "+t.res.statusCode);return f(t)?null:(await(0,v.streamToBuffer)(t.stream)).toString()}e.asText=m;async function E(t){if(!P(t))throw new Error("Server returned "+t.res.statusCode);if(f(t))return null;const y=(await(0,v.streamToBuffer)(t.stream)).toString();try{return JSON.parse(y)}catch(w){throw w.message+=`:
`+y,w}}e.asJson=E;function I(t){S(t)}e.updateProxyConfigurationsScope=I;let p;function S(t){const g=k.Registry.as(D.Extensions.Configuration),y=p;p={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:y?[y]:[]})}S(2)}),define(ee[199],te([0,1,200,13]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,P){return k.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:k.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(k,P,f={}){const m=(0,v.parse)(k),E=f.proxyUrl||D(m,P);if(!E)return null;const I=(0,v.parse)(E);if(!/^https?:$/.test(I.protocol||""))return null;const p={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,n.isBoolean)(f.strictSSL)?f.strictSSL:!0};return m.protocol==="http:"?new(await new Promise((S,t)=>{G(["http-proxy-agent"],S,t)}))(p):new(await new Promise((S,t)=>{G(["https-proxy-agent"],S,t)}))(p)}e.getProxyAgent=C}),define(ee[201],te([0,1,17,32]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,k,P){let f=P&&P.get("storage.serviceMachineId",0)||null;if(f)return f;try{const E=(await k.readFile(C.serviceMachineIdResource)).value.toString();f=(0,n.isUUID)(E)?E:null}catch{f=null}if(!f){f=(0,n.generateUuid)();try{await k.writeFile(C.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch{}}return P&&P.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=D}),define(ee[76],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(ee[202],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>G(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),k=new C.validator;if(k){const P=String(v._nextId++);return this.validators.set(P,k),{id:P,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),k=new C.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=v,v._nextId=1}),define(ee[38],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(ee[20],te([0,1,14,8,4,2,3,34,13,5,182,6,38]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,m.createDecorator)("lifecycleMainService");var S;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class gt extends C.Disposable{constructor(y,w){super();this.logService=y,this.stateMainService=w,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(gt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(gt.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),k.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};v.app.addListener("before-quit",y);const w=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!k.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",w),v.app.once("will-quit",M=>{this.logService.trace("Lifecycle#app.on(will-quit)"),M.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",y),v.app.removeListener("window-all-closed",w),v.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const y=[];return this._onWillShutdown.fire({join(w){y.push(w)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(y)}catch(w){this.logService.error(w)}try{await this.stateMainService.close()}catch(w){this.logService.error(w)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.logService.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const w=this.phaseWhen.get(this._phase);w&&(w.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let w=this.phaseWhen.get(y);w||(w=new n.Barrier,this.phaseWhen.set(y,w)),await w.wait()}registerWindow(y){const w=new C.DisposableStore;this.windowCounter++,w.add(y.onWillLoad(c=>this._onWillLoadWindow.fire({window:y,workspace:c.workspace,reason:c.reason})));const M=(0,f.assertIsDefined)(y.win);M.on("close",c=>{const a=y.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),c.preventDefault(),this.unload(y,1).then(l=>{if(l){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(y),y.close()})}),M.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,w.dispose(),this.windowCounter===0&&(!k.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(y,w){await this.unload(y,3)||y.reload(w)}async unload(y,w){if(!y.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${y.id}`);const M=this._quitRequested?2:w;let c=await this.onBeforeUnloadWindowInRenderer(y,M);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(y,M),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${y.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${y.id})`),await this.onWillUnloadWindowInRenderer(y,M),!1))}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,w){return new Promise(M=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,l=`vscode:cancel${c}`;v.ipcMain.once(a,()=>{M(!1)}),v.ipcMain.once(l,()=>{M(!0)}),y.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:l,reason:w})})}onBeforeUnloadWindowInMain(y,w){const M=[];return this._onBeforeUnloadWindow.fire({reason:w,window:y,veto(c){M.push(c)}}),(0,E.handleVetos)(M,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(y,w){return new Promise(M=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(a,()=>M()),y.send("vscode:onWillUnload",{replyChannel:a,reason:w})})}quit(y){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${y}`),y&&this.stateMainService.setItem(gt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(w=>{this.pendingQuitPromiseResolve=w,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(y){this.logService.trace("Lifecycle#relaunch()");const w=process.argv.slice(1);if(y?.addArgs&&w.push(...y.addArgs),y?.removeArgs)for(const a of y.removeArgs){const l=w.indexOf(a);l>=0&&w.splice(l,1)}const M=()=>{try{if(k.isWindows){const a=(0,P.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:w})};v.app.once("quit",M),await this.quit(!0)&&v.app.removeListener("quit",M)}async kill(y){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const w of v.BrowserWindow.getAllWindows())if(w&&!w.isDestroyed()){let M;w.webContents&&!w.webContents.isDestroyed()?M=new Promise(c=>w.once("closed",c)):M=Promise.resolve(),w.destroy(),await M}})()]),v.app.exit(y)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=de([re(0,I.ILogService),re(1,p.IStateMainService)],t),e.LifecycleMainService=t}),define(ee[203],te([0,1,4,2,5,20]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(m){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,m.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const m=await new Promise((E,I)=>{G(["native-keymap"],E,I)});this._keyboardLayoutData=P(m),m.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=P(m),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=de([re(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function P(f){const m=f.getKeyMap(),E=f.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:E}}}),define(ee[77],te([0,1,8,4,2,63,13,87,5]),function(G,e,v,n,D,C,k,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=(0,f.createDecorator)("storageService");var E;(function(y){y[y.NONE=0]="NONE",y[y.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(y){y[y.GLOBAL=0]="GLOBAL",y[y.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var p;(function(y){y[y.USER=0]="USER",y[y.MACHINE=1]="MACHINE"})(p=e.StorageTarget||(e.StorageTarget={}));class S extends D.Disposable{constructor(w={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=w,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,M){M===m?(w===0?this._globalKeyTargets=void 0:w===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:w})):this._onDidChangeValue.fire({scope:w,key:M,target:this.getKeyTargets(w)[M]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,M,c){return this.getStorage(M)?.get(w,c)}getBoolean(w,M,c){return this.getStorage(M)?.getBoolean(w,c)}getNumber(w,M,c){return this.getStorage(M)?.getNumber(w,c)}store(w,M,c,a){if((0,k.isUndefinedOrNull)(M)){this.remove(w,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,c,a),this.getStorage(c)?.set(w,M)})}remove(w,M){this.withPausedEmitters(()=>{this.updateKeyTarget(w,M,void 0),this.getStorage(M)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,M){const c=[],a=this.getKeyTargets(w);for(const l of Object.keys(a))a[l]===M&&c.push(l);return c}updateKeyTarget(w,M,c){const a=this.getKeyTargets(M);typeof c=="number"?a[w]!==c&&(a[w]=c,this.getStorage(M)?.set(m,JSON.stringify(a))):typeof a[w]=="number"&&(delete a[w],this.getStorage(M)?.set(m,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(w){return w===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(w){const M=this.get(m,w);if(M)try{return JSON.parse(M)}catch{}return Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=E.NONE){this._onWillSaveState.fire({reason:w});const M=this.getStorage(0),c=this.getStorage(1);switch(w){case E.NONE:await v.Promises.settled([M?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await v.Promises.settled([M?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const w=this.getStorage(0)?.items??new Map,M=this.getStorage(1)?.items??new Map;return g(w,M,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends S{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.globalStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w)))}getStorage(w){return w===0?this.globalStorage:this.workspaceStorage}getLogDetails(w){return w===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(w){}}e.InMemoryStorageService=t;async function g(y,w,M,c){const a=u=>{try{return JSON.parse(u)}catch{return u}},l=new Map,o=new Map;y.forEach((u,d)=>{l.set(d,u),o.set(d,a(u))});const h=new Map,s=new Map;w.forEach((u,d)=>{h.set(d,u),s.set(d,a(u))}),console.group(`Storage: Global (path: ${M})`);let i=[];l.forEach((u,d)=>{i.push({key:d,value:u})}),console.table(i),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${c})`);let r=[];h.forEach((u,d)=>{r.push({key:d,value:u})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=g}),define(ee[204],te([0,1,3,34,7,32]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(m){if(v.platform===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}async function P(m,E,I,p,S,t,g,y,w,M){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,C.generateUuid)()+Date.now(),c.commitHash=S,c.version=t,c["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,v.PlatformToString)(v.platform),c["common.nodePlatform"]=n.platform,c["common.nodeArch"]=p,c["common.product"]=M||"desktop";const a=f(y||[]);a&&(c["common.msftInternal"]=a);let l=0;const o=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),v.isLinuxSnap&&(c["common.snap"]="true");const h=k(I);h&&(c["common.platformDetail"]=h);try{const s=await m.readFile(D.URI.file(w));c["common.source"]=s.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function f(m){const E=n.env.USERDNSDOMAIN;if(!E)return!1;const I=E.toLowerCase();return m.some(p=>I===p)}e.verifyMicrosoftInternalDomain=f}),define(ee[29],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ee[205],te([0,1,26,69,8,43,10,9,3,7,71,24,84,74,18,22,29]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(o,h){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const r=v.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:U=>/^[a-z]:\\(my drive|shared drives)\\/.test(U)||U.startsWith(r+"\\my drive\\")},{tag:"dropbox",matcher:U=>U.startsWith(r+"\\dropbox")},{tag:"onedrive",matcher:U=>U.startsWith(r+"\\onedrive")},{tag:"box",matcher:U=>U.startsWith(r+"\\box\\")},{tag:"nextcloud",matcher:U=>U.startsWith(r+"\\nextcloud\\")},{tag:"owncloud",matcher:U=>U.startsWith(r+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:U=>U.startsWith("/volumes/googledrive/")||U.startsWith(r+"/my drive/")},{tag:"dropbox",matcher:U=>U.startsWith(r+"/dropbox")},{tag:"onedrive",matcher:U=>U.startsWith(r+"/onedrive")||U.startsWith(r+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:U=>U.startsWith(r+"/library/mobile documents/")},{tag:"box",matcher:U=>U.startsWith(r+"/box/")},{tag:"nextcloud",matcher:U=>U.startsWith(r+"/nextcloud/")},{tag:"owncloud",matcher:U=>U.startsWith(r+"/owncloud/")}];break}const u=new Map,d=new Map,b=2e4;function L(U,Q,se,ne){for(const J of i){const q=U.toLowerCase();J.matcher(q)&&d.set(J.tag,1)}const V=Q.substring(U.length+1);return D.Promises.withAsyncBody(async J=>{let q;try{q=await I.Promises.readdir(Q,{withFileTypes:!0})}catch{J();return}if(ne.count>=b){ne.count+=q.length,ne.maxReached=!0,J();return}let K=q.length;if(K===0){J();return}let j=q;ne.count+q.length>b&&(ne.maxReached=!0,K=b-ne.count,j=q.slice(0,K)),ne.count+=q.length;for(const B of j)if(B.isDirectory()){if(se.includes(B.name)||await L(U,(0,P.join)(Q,B.name),se,ne),--K==0){J();return}}else{const $=B.name.lastIndexOf(".");if($>=0){const Y=B.name.substring($+1);Y&&u.set(Y,(u.get(Y)??0)+1)}for(const Y of s)Y.relativePathPattern?.test(V)!==!1&&Y.filePattern.test(B.name)&&d.set(Y.tag,(d.get(Y.tag)??0)+1);if(--K==0){J();return}}})}const R={count:0,maxReached:!1};await L(o,o,h,R);const T=await a(o);return{configFiles:M(d),fileTypes:M(u),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=w;function M(o){return[...n.Iterable.map(o.entries(),([h,s])=>({name:h,count:s}))].sort((h,s)=>s.count-h.count)}function c(){const o={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},h=v.cpus();return h&&h.length>0&&(o.cpus=`${h[0].model} (${h.length} x ${h[0].speed})`),o}e.getMachineInfo=c;async function a(o){try{const h=new Map,s=(0,P.join)(o,".vscode","launch.json"),i=await I.Promises.readFile(s),r=[],u=(0,C.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,C.getNodeType)(u)==="object"&&u.configurations)for(const d of u.configurations){const b=d.type;b&&(h.has(b)?h.set(b,h.get(b)+1):h.set(b,1))}return M(h)}catch{return[]}}e.collectLaunchConfigs=a;let l=class{constructor(h,s){this.telemetryService=h,this.productService=s}formatMachineInfo(h){const s=[];return s.push(`OS Version:       ${h.os}`),s.push(`CPUs:             ${h.cpus}`),s.push(`Memory (System):  ${h.memory}`),s.push(`VM:               ${h.vmHint}`),s.join(`
`)}formatEnvironment(h){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),f.isWindows||s.push(`Load (avg):       ${v.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${h.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${h.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(h.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(h,s){return Promise.all([(0,p.listProcesses)(h.mainPID),this.formatWorkspaceMetadata(h)]).then(async i=>{let[r,u]=i,d=this.formatProcessList(h,r);return s.forEach(b=>{if((0,S.isRemoteDiagnosticError)(b))d+=`
${b.errorMessage}`,u+=`
${b.errorMessage}`;else if(d+=`

Remote: ${b.hostName}`,b.processes&&(d+=`
${this.formatProcessList(h,b.processes)}`),b.workspaceMetadata){u+=`
|  Remote: ${b.hostName}`;for(const L of Object.keys(b.workspaceMetadata)){const R=b.workspaceMetadata[L];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${L}): ${T}`,u+=this.formatWorkspaceStats(R)}}}),{processInfo:d,workspaceInfo:u}})}async getSystemInfo(h,s){const{memory:i,vmHint:r,os:u,cpus:d}=c(),b={os:u,memory:i,cpus:d,vmHint:r,processArgs:`${h.mainArguments.join(" ")}`,gpuStatus:h.gpuFeatureStatus,screenReader:`${h.screenReader?"yes":"no"}`,remoteData:s};return f.isWindows||(b.load=`${v.loadavg().map(L=>Math.round(L)).join(", ")}`),f.isLinux&&(b.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(b)}async getDiagnostics(h,s){const i=[];return(0,p.listProcesses)(h.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(h)),i.push(""),i.push(this.formatProcessList(h,r)),h.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(h))),s.forEach(u=>{if((0,S.isRemoteDiagnosticError)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(h,u.processes)),u.workspaceMetadata)for(const d of Object.keys(u.workspaceMetadata)){const b=u.workspaceMetadata[d];let L=`${b.fileCount} files`;b.maxFilesReached&&(L=`more than ${L}`),i.push(`Folder (${d}): ${L}`),i.push(this.formatWorkspaceStats(b))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(h){const s=[],i=60;let r=0;const u=(R,T)=>{const U=` ${R}(${T})`;r+U.length>i?(s.push(d),d="|                 ",r=d.length):r+=U.length,d+=U};let d="|      File types:";const b=10;let L=h.fileTypes.length>b?b:h.fileTypes.length;for(let R=0;R<L;R++){const T=h.fileTypes[R];u(T.name,T.count)}if(s.push(d),h.configFiles.length>=0&&(d="|      Conf files:",r=0,h.configFiles.forEach(R=>{u(R.name,R.count)}),s.push(d)),h.launchConfigFiles.length>0){let R="|      Launch Configs:";h.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(h){const s=Math.max(...Object.keys(h).map(i=>i.length));return Object.keys(h).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${h[i]}`).join(`
                  `)}formatWorkspaceMetadata(h){const s=[],i=[];return h.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(u=>{const d=m.URI.revive(u);if(d.scheme===k.Schemas.file){const b=d.fsPath;i.push(w(b,["node_modules",".git"]).then(L=>{let R=`${L.fileCount} files`;L.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,P.basename)(b)}): ${R}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${b} (${L.toString()})`)}))}else s.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(h,s){const i=new Map;h.windows.forEach(u=>i.set(u.pid,u.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(h.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(h,s,i,r,u){const d=u===0;let b;d?b=r.pid===h?`${this.productService.applicationName} main`:"remote agent":(b=`${"  ".repeat(u)} ${r.name}`,r.name==="window"&&(b=`${b} (${s.get(r.pid)})`));const L=process.platform==="win32"?r.mem:v.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${b}`),Array.isArray(r.children)&&r.children.forEach(R=>this.formatProcessItem(h,s,i,R,u+1))}async reportWorkspaceStats(h){for(const{uri:s}of h.folders){const i=m.URI.revive(s);if(i.scheme!==k.Schemas.file)continue;const r=i.fsPath;try{const u=await w(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":h.telemetryId,rendererSessionId:h.rendererSessionId}),u.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:h.rendererSessionId,type:d.name,count:d.count})}),u.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:h.rendererSessionId,type:d.name,count:d.count})}),u.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:h.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};l=de([re(0,y.ITelemetryService),re(1,g.IProductService)],l),e.DiagnosticsService=l}),define(ee[206],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(C){this.appenders=C}listen(C,k){throw new Error(`Event not found: ${k}`)}call(C,k,{eventName:P,data:f}){return this.appenders.forEach(m=>m.log(P,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class n{constructor(C){this.channel=C}log(C,k){return this.channel.call("log",{eventName:C,data:k}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ee[65],te([0,1,47,13,19,29]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(w,M){return Promise.resolve(void 0)}publicLog2(w,M){return this.publicLog(w,M)}publicLogError(w,M){return Promise.resolve(void 0)}publicLogError2(w,M){return this.publicLogError(w,M)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class P{async publicLog(w,M,c){}async publicLogError(w,M,c){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(y,w){return w.onDidChangeConfiguration(M=>{M.source!==6&&y.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(M.source),configurationKeys:t(M.sourceConfig)})})}e.configurationTelemetry=f;function m(y,w){return!(w.disableTelemetry||!y.enableTelemetry)}e.supportsTelemetry=m;function E(y){const w=y.getValue(C.TELEMETRY_SETTING_ID),M=y.getValue("telemetry.enableCrashReporter");if(y.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||M===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function I(y){const w=Object.create(null),M=Object.create(null),c=Object.create(null);S(y,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const l=c[a];typeof l=="number"?M[a]=l:typeof l=="boolean"?M[a]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${l.length}`),w[a]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(w[a]=l)}return{properties:w,measurements:M}}e.validateTelemetryData=I;function p(y){if(!y)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{y.indexOf(`${c}+`)===0&&(w=c)}),w}e.cleanRemoteAuthority=p;function S(y,w,M=0,c){if(!!y)for(let a of Object.getOwnPropertyNames(y)){const l=y[a],o=c?c+a:a;Array.isArray(l)?w[o]=(0,v.safeStringify)(l):l instanceof Date?w[o]=l.toISOString():(0,n.isObject)(l)?M<2?S(l,w,M+1,o+"."):w[o]=(0,v.safeStringify)(l):w[o]=l}}function t(y){if(!y)return[];const w=[];return g(w,"",y),w}function g(y,w,M){M&&typeof M=="object"&&!Array.isArray(M)?Object.keys(M).forEach(c=>g(y,w?`${w}.${c}`:c,M[c])):y.push(w)}}),define(ee[207],te([0,1,31,21,15,47,3,34,13,7,19,53,172,198,169,18,6,22,48,201,77,29,65]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=k.isWeb?"web":(0,p.getTargetPlatform)(k.platform,P.arch);var s;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished"})(s||(s={}));function i(...O){return String(O.reduce((z,x)=>z|x,0))}var r;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},d={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},L={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class R{constructor(z=L){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,x=this.state.pageSize){return new R({...this.state,pageNumber:z,pageSize:x})}withFilter(z,...x){const ie=[...this.state.criteria,...x.length?x.map(oe=>({filterType:z,value:oe})):[{filterType:z}]];return new R({...this.state,criteria:ie})}withSortBy(z){return new R({...this.state,sortBy:z})}withSortOrder(z){return new R({...this.state,sortOrder:z})}withFlags(...z){return new R({...this.state,flags:z.reduce((x,ie)=>x|ie,0)})}withAssetTypes(...z){return new R({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:x,pageSize:ie,sortBy:oe,sortOrder:Z,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:z,pageNumber:x,pageSize:ie,sortBy:oe,sortOrder:Z}],assetTypes:le,flags:ce}}get searchText(){const z=this.state.criteria.filter(x=>x.filterType===r.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(O,z){const x=(O||[]).filter(ie=>ie.statisticName===z)[0];return x?x.value:0}function U(O){const z="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(ie=>ie.assetType.indexOf(z)===0).reduce((ie,oe)=>{const Z=V(O,oe.assetType);return Z&&ie.push([oe.assetType.substring(z.length),Z]),ie},[])}function Q(O){if(O.properties){const z=O.properties.filter(oe=>oe.key===u.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=z.filter(oe=>x.test(oe.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return V(O,u.Repository)}function se(O){return{uri:`${O.fallbackAssetUri}/${u.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${u.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function ne(O){const z=V(O,u.Icon);if(z)return z;const x=p.DefaultIconPath;return{uri:x,fallbackUri:x}}function V(O,z){return O.files.filter(ie=>ie.assetType===z)[0]?{uri:`${O.assetUri}/${z}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${z}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function J(O,z){const x=O.properties?O.properties.filter(oe=>oe.key===z):[],ie=x.length>0&&x[0].value;return ie?ie.split(",").map(oe=>(0,S.adoptToGalleryExtensionId)(oe)):[]}function q(O){const z=O.properties?O.properties.filter(x=>x.key===d.Engine):[];return z.length>0&&z[0].value||""}function K(O){const z=O.properties?O.properties.filter(x=>x.key===d.PreRelease):[];return z.length>0&&z[0].value==="true"}function j(O){const z=O.properties?O.properties.filter(ie=>ie.key===d.LocalizedLanguages):[],x=z.length>0&&z[0].value||"";return x?x.split(","):[]}function B(O){return O.indexOf("preview")!==-1}function $(O){return O.targetPlatform?(0,p.toTargetPlatform)(O.targetPlatform):"undefined"}function Y(O){const z=(0,v.distinct)(O.versions.map($)),x=!!O.tags?.includes(p.WEB_EXTENSION_TAG),ie=z.indexOf("web");return x?ie===-1&&z.push("web"):ie!==-1&&z.splice(ie,1),z}function H(O,z){const x=(0,p.getFallbackTargetPlarforms)(z);for(let ie=0;ie<O.length;ie++){const oe=O[ie];if(oe.version===O[ie-1]?.version){let Z=ie;const ce=$(oe);if(ce===z)for(;Z>0&&O[Z-1].version===oe.version;)Z--;else if(x.includes(ce))for(;Z>0&&O[Z-1].version===oe.version&&$(O[Z-1])!==z;)Z--;Z!==ie&&(O.splice(ie,1),O.splice(Z,0,oe))}}return O}e.sortExtensionVersions=H;function F(O,z,x,ie,oe){const Z=O.versions[0],ce={manifest:V(z,u.Manifest),readme:V(z,u.Details),changelog:V(z,u.Changelog),license:V(z,u.License),repository:Q(z),download:se(z),icon:ne(z),coreTranslations:U(z)};return{identifier:{id:(0,S.getGalleryExtensionId)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:z.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,description:O.shortDescription||"",installCount:T(O.statistics,"install"),rating:T(O.statistics,"averagerating"),ratingCount:T(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:x,assets:ce,properties:{dependencies:J(z,d.Dependency),extensionPack:J(z,d.ExtensionPack),engine:q(z),localizedLanguages:j(z),targetPlatform:$(z),isPreReleaseVersion:K(z)},hasPreReleaseVersion:K(Z),hasReleaseVersion:ie,preview:B(O.flags),telemetryData:oe}}let W=class{constructor(z,x,ie,oe,Z,ce,le,he){this.requestService=x,this.logService=ie,this.environmentService=oe,this.telemetryService=Z,this.fileService=ce,this.productService=le,this.configurationService=he;const ge=le.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=N(le.version,le,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,x,ie){const oe=(0,f.isBoolean)(x)?x:!1,Z=(0,f.isBoolean)(x)?ie:x;let ce=new R().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,z.length).withFilter(r.ExtensionName,...z.map(({id:ge})=>ge.toLowerCase()));z.every(ge=>!ge.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,h,n.CancellationToken.None),he=le.map(ge=>{const be=(0,S.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName);return{rawGalleryExtension:ge,version:z.find(fe=>(0,S.areSameExtensions)(fe,{id:be}))?.version,preRelease:oe}});return this.converToGalleryExtensions(he,ce,h,()=>{},Z)}async getExtensions2(z){const x=[],ie=[];for(const le of z)le.uuid?ie.push(le.uuid):x.push(le.id.toLowerCase());let oe=new R().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly).withPage(1,z.length);ie.length&&(oe=oe.withFilter(r.ExtensionId,...ie)),x.length&&(oe=oe.withFilter(r.ExtensionId,...x));const{galleryExtensions:Z}=await this.queryGallery(oe,h,n.CancellationToken.None),ce=Z.map(le=>{const he=(0,S.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),ge=z.find(be=>(0,S.areSameExtensions)(be,{id:he,uuid:le.extensionId}));return{rawGalleryExtension:le,preRelease:!!ge?.preRelease}});return this.converToGalleryExtensions(ce,oe,h,()=>{},n.CancellationToken.None)}async getCompatibleExtension(z,x,ie){const oe=(0,p.isIExtensionIdentifier)(z)?null:z;if(oe){if((0,p.isNotWebExtensionInWebTargetPlatform)(oe.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(oe,x,ie))return oe}const{id:Z,uuid:ce}=oe?oe.identifier:z;let le=new R().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);ce?le=le.withFilter(r.ExtensionId,ce):le=le.withFilter(r.ExtensionName,Z);const{galleryExtensions:he}=await this.queryGallery(le,ie,n.CancellationToken.None),[ge]=he;if(!ge||!ge.versions.length)return null;const be=Y(ge);if((0,p.isNotWebExtensionInWebTargetPlatform)(be,ie))return null;for(let fe of ge.versions){if(!q(fe)){const me=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:d.Engine,value:me}]}}if(await this.isRawExtensionVersionCompatible(fe,x,be,ie)){const me=ge.versions.some(Se=>!K(Se));return F(ge,fe,be,me)}}return null}async isExtensionCompatible(z,x,ie){if(!(0,p.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,ie)||!x&&z.properties.isPreReleaseVersion)return!1;let oe=z.properties.engine;if(!oe){const Z=await this.getManifest(z,n.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");oe=Z.engines.vscode}return(0,t.isEngineValid)(oe,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(z,x,ie,oe){if(!(0,p.isTargetPlatformCompatible)($(z),ie,oe)||!x&&K(z))return!1;const Z=await this.getEngine(z);return(0,t.isEngineValid)(Z,this.productService.version,this.productService.date)}async query(z,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ie=z.text||"";const oe=(0,C.getOrDefault)(z,fe=>fe.pageSize,50);let Z=new R().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,oe);ie?(ie=ie.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,Se)=>(Z=Z.withFilter(r.Category,Se||me),"")),ie=ie.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,Se)=>(Z=Z.withFilter(r.Tag,Se||me),"")),ie=ie.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(r.Featured),"")),ie=ie.trim(),ie&&(ie=ie.length<200?ie:ie.substring(0,200),Z=Z.withFilter(r.SearchText,ie)),Z=Z.withSortBy(0)):z.ids?Z=Z.withFilter(r.ExtensionId,...z.ids):z.names?Z=Z.withFilter(r.ExtensionName,...z.names):Z=Z.withSortBy(4),typeof z.sortBy=="number"&&(Z=Z.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(Z=Z.withSortOrder(z.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(Z,h,x),he=fe=>({index:(Z.pageNumber-1)*Z.pageSize+fe,querySource:z.source}),ge=await this.converToGalleryExtensions(ce.map(fe=>({rawGalleryExtension:fe,preRelease:!!z.includePreRelease})),Z,h,he,x),be=async(fe,me)=>{if(me.isCancellationRequested)throw(0,D.canceled)();const Se=Z.withPage(fe+1),{galleryExtensions:Pe}=await this.queryGallery(Se,h,me);return await this.converToGalleryExtensions(Pe.map(Me=>({rawGalleryExtension:Me,preRelease:!!z.includePreRelease})),Se,h,he,x)};return{firstPage:ge,total:le,pageSize:Z.pageSize,getPage:be}}async converToGalleryExtensions(z,x,ie,oe,Z){const ce=(ge,be,fe,me,Se)=>{const Pe=!(fe.flags&s.IncludeLatestVersionOnly),Me=Y(ge);let Te=ge.versions[0];return Te=ge.versions.find(Oe=>Oe.version===Te.version&&(0,p.isTargetPlatformCompatible)($(Oe),Me,ie))||Te,Pe&&K(Te)&&!Se&&(Te=ge.versions.find(Oe=>Oe.version!==Te.version&&!K(Oe))||Te),F(ge,Te,Me,me,oe(be))},le=[],he=new Map;for(let ge=0;ge<z.length;ge++){const{rawGalleryExtension:be,version:fe,preRelease:me}=z[ge],Se=be.versions.some(Pe=>!K(Pe));if(fe){const Pe=be.versions.find(Me=>Me.version===fe);Pe&&le.push([ge,F(be,Pe,Y(be),Se)])}else{const Pe=ce(be,ge,x,Se,me);Pe.properties.isPreReleaseVersion?he.set(Pe.identifier.uuid,{index:ge,preRelease:me}):le.push([ge,Pe])}}if(he.size){const ge=new Date().getTime(),be=new R().withFlags(s.IncludeVersions,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,he.size).withFilter(r.ExtensionId,...he.keys()),{galleryExtensions:fe}=await this.queryGallery(be,ie,Z);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:he.size}),fe.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const me of fe){const Se=me.versions.some(Oe=>!K(Oe)),{index:Pe,preRelease:Me}=he.get(me.extensionId),Te=ce(me,Pe,be,Se,Me);le.push([Pe,Te])}}return le.sort((ge,be)=>ge[0]-be[0]).map(([,ge])=>ge)}async queryGallery(z,x,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,s.ExcludeNonValidated).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExcludeWithFlags,i(s.Unpublished));const oe=await this.commonHeadersPromise,Z=JSON.stringify(z.raw),ce={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},le=new Date().getTime();let he,ge,be=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:ce},ie),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:be};const fe=await(0,M.asJson)(he);if(fe){const me=fe.results[0],Se=me.extensions;Se.forEach(Me=>H(Me.versions,x));const Pe=me.resultMetadata&&me.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return be=Pe&&Pe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:be}}return{galleryExtensions:[],total:be}}catch(fe){throw ge=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-le,success:!!he&&(0,M.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ge?(0,D.isPromiseCanceledError)(ge)?"canceled":(0,D.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(be)})}}async reportStatistic(z,x,ie,oe){if(!this.isEnabled())return;const Z=k.isWeb?this.api(`/itemName/${z}.${x}/version/${ie}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${x}/${ie}/stats?statType=${oe}`),ce=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:Z,headers:he},n.CancellationToken.None)}catch{}}async download(z,x,ie){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const oe=(0,S.getGalleryExtensionTelemetryData)(z),Z=new Date().getTime(),ce=be=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:be}),le=ie===2?"install":ie===3?"update":"",he=le?{uri:`${z.assets.download.uri}${m.URI.parse(z.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${z.assets.download.fallbackUri}${m.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:z.assets.download,ge=await this.getAsset(he);await this.fileService.writeFile(x,ge.stream),ce(new Date().getTime()-Z)}async getReadme(z,x){if(z.assets.readme){const ie=await this.getAsset(z.assets.readme,{},x);return await(0,M.asText)(ie)||""}return""}async getManifest(z,x){if(z.assets.manifest){const ie=await this.getAsset(z.assets.manifest,{},x),oe=await(0,M.asText)(ie);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(z,x){const ie=V(z,u.Manifest);if(!ie)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},Z=await this.getAsset(ie,{headers:oe});return await(0,M.asJson)(Z)}async getCoreTranslation(z,x){const ie=z.assets.coreTranslations.filter(oe=>oe[0]===x.toUpperCase())[0];if(ie){const oe=await this.getAsset(ie[1]),Z=await(0,M.asText)(oe);return Z?JSON.parse(Z):null}return null}async getChangelog(z,x){if(z.assets.changelog){const ie=await this.getAsset(z.assets.changelog,{},x);return await(0,M.asText)(ie)||""}return""}async getAllCompatibleVersions(z,x,ie){let oe=new R().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?oe=oe.withFilter(r.ExtensionId,z.identifier.uuid):oe=oe.withFilter(r.ExtensionName,z.identifier.id);const{galleryExtensions:Z}=await this.queryGallery(oe,ie,n.CancellationToken.None);if(!Z.length)return[];const ce=Y(Z[0]);if((0,p.isNotWebExtensionInWebTargetPlatform)(ce,ie))return[];const le=[];for(const he of Z[0].versions)try{le[le.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,x,ce,ie)&&le.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:K(he)})}catch{}return le}async getAsset(z,x={},ie=n.CancellationToken.None){const oe=await this.commonHeadersPromise,Z={type:"GET"},ce={...oe,...x.headers||{}};x={...x,...Z,headers:ce};const le=z.uri,he=z.fallbackUri,ge={...x,url:le};try{const be=await this.requestService.request(ge,ie);if(be.res.statusCode===200)return be;const fe=await(0,M.asText)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${fe}`)}catch(be){if((0,D.isPromiseCanceledError)(be))throw be;const fe=(0,D.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:fe});const me={...x,url:he};return this.requestService.request(me,ie)}}async getEngine(z){let x=q(z);if(!x){const ie=await this.getManifestFromRawExtensionVersion(z,n.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");x=ie.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,M.asJson)(z),ie=[],oe={};if(x){for(const Z of x.malicious)ie.push({id:Z});if(x.unsupported)for(const Z of Object.keys(x.unsupported)){const ce=x.unsupported[Z];(0,f.isBoolean)(ce)||(oe[Z.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:ie,unsupportedPreReleaseExtensions:oe}}};W=de([re(1,M.IRequestService),re(2,y.ILogService),re(3,I.IEnvironmentService),re(4,l.ITelemetryService),re(5,g.IFileService),re(6,w.IProductService),re(7,E.IConfigurationService)],W);let A=class extends W{constructor(z,x,ie,oe,Z,ce,le,he){super(z,x,ie,oe,Z,ce,le,he)}};A=de([re(0,a.IStorageService),re(1,M.IRequestService),re(2,y.ILogService),re(3,I.IEnvironmentService),re(4,l.ITelemetryService),re(5,g.IFileService),re(6,w.IProductService),re(7,E.IConfigurationService)],A),e.ExtensionGalleryService=A;let _=class extends W{constructor(z,x,ie,oe,Z,ce,le){super(void 0,z,x,ie,oe,Z,ce,le)}};_=de([re(0,M.IRequestService),re(1,y.ILogService),re(2,I.IEnvironmentService),re(3,l.ITelemetryService),re(4,g.IFileService),re(5,w.IProductService),re(6,E.IConfigurationService)],_),e.ExtensionGalleryServiceWithNoStorageService=_;async function N(O,z,x,ie,oe,Z){const ce={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${z.nameShort})`},le=await(0,c.getServiceMachineId)(x,oe,Z);return(0,o.supportsTelemetry)(z,x)&&(0,o.getTelemetryLevel)(ie)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=N}),define(ee[208],te([0,1,2,47,3,25,154,19,57,55,40,29,65]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(y,w){this._configurationService=w,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=y.appenders,this._commonProperties=y.commonProperties||Promise.resolve({}),this._piiPaths=y.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!y.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let M of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(M),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(M=>{const c=/^[a-f0-9]+$/i.test(M["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(y,w){this._experimentProperties[y]=w}_updateTelemetryLevel(){this._telemetryLevel=(0,p.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const y=await this._commonProperties;let w=y.sessionID,M=y["common.machineId"],c=y["common.firstSessionDate"],a=y["common.msftInternal"];return{sessionId:w,machineId:M,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(y,w,M,c){return this.telemetryLevel<w?Promise.resolve(void 0):this._commonProperties.then(a=>{M=(0,n.mixin)(M,a),M=(0,n.mixin)(M,this._experimentProperties),M=(0,n.cloneAndChange)(M,l=>{if(typeof l=="string")return this._cleanupInfo(l,c)}),this._appenders.forEach(l=>l.log(y,M))},a=>{console.error(a)})}publicLog(y,w,M){return this._log(y,3,w,M)}publicLog2(y,w,M){return this.publicLog(y,w,M)}publicLogError(y,w){return this.sendErrorTelemetry?this._log(y,2,w,!0):Promise.resolve(void 0)}publicLogError2(y,w){return this.publicLogError(y,w)}_anonymizeFilePaths(y){let w=y;const M=[];for(let o of this._cleanupPatterns)for(;;){const h=o.exec(y);if(!h)break;M.push([h.index,o.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(w="";;){const o=a.exec(y);if(!o)break;!c.test(o[0])&&M.every(([h,s])=>o.index<h||o.index>=s)&&(w+=y.substring(l,o.index)+"<REDACTED: user-file-path>",l=a.lastIndex)}return l<y.length&&(w+=y.substr(l)),w}_removePropertiesWithPossibleUserInfo(y){if(!y)return y;const w=y.toLowerCase(),M=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(w)?"<REDACTED: secret>":M.test(w)?"<REDACTED: email>":y}_cleanupInfo(y,w){let M=y;w&&(M=this._anonymizeFilePaths(M));for(let c of this._cleanupPatterns)M=M.replace(c,"");return M=this._removePropertiesWithPossibleUserInfo(M),M}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([re(1,P.IConfigurationService)],S),e.TelemetryService=S;function t(){const g=(0,k.localize)(0,null,m.default.nameLong),y=m.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",m.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=D.isWeb?"":(0,k.localize)(3,null),M=(0,k.localize)(4,null),c=(0,k.localize)(5,null),a=(0,k.localize)(6,null),l=(0,k.localize)(7,null),o=`
|       | ${M} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,h=(0,k.localize)(8,null);return`
${g} ${y} ${w}

&nbsp;

${l}
${o}

&nbsp;

${h}
`}E.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(f.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,k.localize)(16,null,m.default.nameLong,m.default.privacyStatementUrl):(0,k.localize)(15,null,m.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ee[209],te([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(ee[210],te([0,1,103,4,2,5,40,209]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var f;(function(y){function w(M){return M&&typeof M=="object"&&typeof M.id=="string"}y.isThemeColor=w})(f=e.ThemeColor||(e.ThemeColor={}));function m(y){return{id:y}}e.themeColorFromId=m;var E;(function(y){function w(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||f.isThemeColor(i.color))}y.isThemeIcon=w;const M=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const r=M.exec(i);if(!r)return;let[,u]=r;return{id:u}}y.fromString=c;function a(i){return{id:i}}y.fromId=a;function l(i,r){let u=i.id;const d=u.lastIndexOf("~");return d!==-1&&(u=u.substring(0,d)),r&&(u=`${u}~${r}`),{id:u}}y.modify=l;function o(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}y.getModifier=o;function h(i,r){return i.id===r.id&&i.color?.id===r.color?.id}y.isEqual=h;function s(i,r){return{id:i.id,color:r?m(r):void 0}}y.asThemeIcon=s,y.asClassNameArray=v.CSSIcon.asClassNameArray,y.asClassName=v.CSSIcon.asClassName,y.asCSSSelector=v.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function I(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,D.toDisposable)(()=>{const M=this.themingParticipants.indexOf(w);this.themingParticipants.splice(M,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new p;k.Registry.add(e.Extensions.ThemingContribution,S);function t(y){return S.onColorThemeChange(y)}e.registerThemingParticipant=t;class g extends D.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(M=>this.onThemeChange(M)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,M){let c=this.theme.getColor(w);return c&&M&&(c=M(c,this.theme)),c?c.toString():null}}e.Themable=g}),define(ee[66],te([0,1,14,3,5,38]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",P="#1E1E1E",f="#000000",m="theme",E="themeBackground",I="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let p=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let t=this.stateMainService.getItem(E,null);if(!t){let g;(n.isWindows||n.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(m,"vs-dark").split(" ")[0],t=g==="hc-black"?f:g==="vs"?k:P}return n.isMacintosh&&t.toUpperCase()===P&&(t="#171717"),t}saveWindowSplash(t,g){this.stateMainService.setItems([{key:m,data:g.baseTheme},{key:E,data:g.colorInfo.background},{key:I,data:g}]),typeof t=="number"&&this.updateBackgroundColor(t,g)}updateBackgroundColor(t,g){for(const y of v.BrowserWindow.getAllWindows())if(y.id===t){y.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};p=de([re(0,C.IStateMainService)],p),e.ThemeMainService=p}),define(ee[41],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(n=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,k)=>({type:"idle",updateType:C,error:k}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(ee[211],te([0,1,3,155,57,40]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ee[212],te([0,1,4,41]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(P){this.service=P}listen(P,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(P,f,m){switch(f){case"checkForUpdates":return this.service.checkForUpdates(m);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=D;class C{constructor(P){this.channel=P,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(P){this._state=P,this._onStateChange.fire(P)}checkForUpdates(P){return this.channel.call("checkForUpdates",P)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(ee[98],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(ee[213],te([0,1,7]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(P){this.handler=P}listen(P,f){throw new Error(`Event not found: ${f}`)}call(P,f,m){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(m[0]),m[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=n;class D{constructor(P){this.channel=P}handleURL(P,f){return this.channel.call("handleURL",[P.toJSON(),f])}}e.URLHandlerChannelClient=D;class C{constructor(P){this.next=P}async routeCall(P,f,m,E){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(m){const I=v.URI.revive(m);if(I&&I.query){const p=/\bwindowId=(\d+)/.exec(I.query);if(p){const S=p[1],t=new RegExp(`window:${S}`),g=P.connections.find(y=>t.test(y.ctx));if(g)return g}}}return this.next.routeCall(P,f,m,E)}routeEvent(P,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=C}),define(ee[214],te([0,1,8,2,7,22]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(m,E){const I=[...this.handlers.values()];return(0,v.first)(I.map(p=>()=>p.handleURL(m,E)),void 0,!1).then(p=>p||!1)}registerHandler(m){return this.handlers.add(m),(0,n.toDisposable)(()=>this.handlers.delete(m))}}e.AbstractURLService=k;let P=class extends k{constructor(m){super();this.productService=m}create(m){let{authority:E,path:I,query:p,fragment:S}=m||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return E&&I&&I.indexOf("/")!==0&&(I=`/${I}`),D.URI.from({scheme:this.productService.urlProtocol,authority:E,path:I,query:p,fragment:S})}};P=de([re(0,C.IProductService)],P),e.NativeURLService=P}),define(ee[215],te([0,1,14,8,4,2,3,7]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(E){try{return P.URI.parse(E)}catch{return null}}class m{constructor(I,p,S,t,g){if(this.urlService=p,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=I,k.isWindows){const M=t.isBuilt?[]:[`"${t.appRoot}"`];M.push("--open-url","--"),v.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,M)}const y=D.Event.map(D.Event.fromNodeEventEmitter(v.app,"open-url",(M,c)=>({event:M,url:c})),({event:M,url:c})=>(M.preventDefault(),c));this.disposables.add(y(M=>{const c=f(M);!c||this.urlService.open(c,{originalUrl:M})})),S.getWindows().filter(M=>M.isReady).length>0?this.flush():D.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const p of this.uris)await this.urlService.open(p.uri,{originalUrl:p.url})||I.push(p);I.length!==0&&(this.uris=I,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=m}),define(ee[216],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(ee[217],te([0,1,14,2,10,7]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class k extends n.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(D.Schemas.vscodeWebview,f)}handleWebviewRequest(f,m){try{const E=C.URI.parse(f.url),I=k.validWebviewFilePaths.get(E.path);if(typeof I=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${I}`,S=D.FileAccess.asFileUri(p,G);return m(decodeURIComponent(S.fsPath))}else return m({error:-10})}catch{}return m({error:-2})}}e.WebviewProtocolProvider=k,k.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(ee[67],te([0,1,3]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(m){return!!m.workspaceUri}e.isWorkspaceToOpen=n;function D(m){return!!m.folderUri}e.isFolderToOpen=D;function C(m){return!!m.fileUri}e.isFileToOpen=C;function k(m){const E=P(m),I=m.getValue("window.menuBarVisibility");return I==="default"||E==="native"&&I==="compact"||v.isMacintosh&&v.isNative?"classic":I}e.getMenuBarVisibility=k;function P(m){if(v.isWeb)return"custom";const E=m.getValue("window");if(E){if(v.isMacintosh&&E.nativeTabs===!0||v.isMacintosh&&E.nativeFullScreen===!1)return"native";const S=m.getValue("workbench.colorCustomizations");if(S?.["window.activeBorder"]||S?.["window.inactiveBorder"])return"custom";const t=E.titleBarStyle;if(t==="native"||t==="custom")return t}return v.isLinux?"native":"custom"}e.getTitleBarStyle=P;function f(m=0){return Math.pow(1.2,m)}e.zoomLevelToZoomFactor=f}),define(ee[36],te([0,1,5]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var n;(function(m){m[m.INITIAL=1]="INITIAL",m[m.LOAD=2]="LOAD",m[m.RELOAD=3]="RELOAD"})(n=e.LoadReason||(e.LoadReason={}));var D;(function(m){m[m.CLOSE=1]="CLOSE",m[m.QUIT=2]="QUIT",m[m.RELOAD=3]="RELOAD",m[m.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(m){m[m.CLI=0]="CLI",m[m.DOCK=1]="DOCK",m[m.MENU=2]="MENU",m[m.DIALOG=3]="DIALOG",m[m.DESKTOP=4]="DESKTOP",m[m.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const k=function(m=1){return{width:1024,height:768,mode:m}};e.defaultWindowState=k;var P;(function(m){m[m.Maximized=0]="Maximized",m[m.Normal=1]="Normal",m[m.Minimized=2]="Minimized",m[m.Fullscreen=3]="Fullscreen"})(P=e.WindowMode||(e.WindowMode={}));var f;(function(m){m[m.UNRESPONSIVE=1]="UNRESPONSIVE",m[m.CRASHED=2]="CRASHED",m[m.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(ee[218],te([0,1,14,4,2,217,36]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let P=class extends D.Disposable{constructor(m){super();this.windowsMainService=m,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(m,E){let I;if(typeof m.windowId=="number"){const{windowId:p}=m,S=this.windowsMainService.getWindowById(p);if(!S?.win)throw new Error(`Invalid windowId: ${p}`);I=S.win.webContents}else{const{webContentsId:p}=m;if(I=v.webContents.fromId(p),!I)throw new Error(`Invalid webContentsId: ${p}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(E)}async findInFrame(m,E,I,p){const S=this.getFrameByName(m,E),t=S;if(typeof t.findInFrame=="function"){t.findInFrame(I,{findNext:p.findNext,forward:p.forward});const g=(y,w)=>{w.finalUpdate&&(this._onFoundInFrame.fire(w),S.removeListener("found-in-frame",g))};S.on("found-in-frame",g)}}async stopFindInFrame(m,E,I){const S=this.getFrameByName(m,E);typeof S.stopFindInFrame=="function"&&S.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(m,E){const I=this.windowsMainService.getWindowById(m.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${m}`);const p=I.win.webContents.mainFrame.framesInSubtree.find(S=>S.name===E);if(!p)throw new Error(`Unknown frame: ${E}`);return p}};P=de([re(0,k.IWindowsMainService)],P),e.WebviewMainService=P}),define(ee[219],te([0,1,8,4,2]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:f,getActiveWindowId:m}){super();this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(P,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>m()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(ee[220],te([0,1,35,16,7,5]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var k;(function(p){p[p.EMPTY=1]="EMPTY",p[p.FOLDER=2]="FOLDER",p[p.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function P(p){const S=p;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=P;function f(p){const S=p;return!!(S&&typeof S=="object"&&D.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=f;class m{constructor(S,t,g,y,w){this._id=S,this._transient=g,this._configuration=y,this._ignorePathCasing=w,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class E{constructor(S,t){this.raw=t,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,n.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=E;function I(p){return new E({uri:p,index:0,name:(0,n.basenameOrAuthority)(p)},{uri:p.toString()})}e.toWorkspaceFolder=I}),define(ee[30],te([0,1,27,43,105,33,10,9,3,16,7,158,5,64,220]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function y(K){return(typeof K=="string"?(0,P.extname)(K):(0,m.extname)(K))===g}e.hasWorkspaceFileExtension=y,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function w(K){return K.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function M(K){return K.hasOwnProperty("folderUri")}e.isRecentFolder=M;function c(K){return K.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(K){return K&&K.hasOwnProperty("folderUri")}e.isFolderBackupInfo=a;function l(K){return K&&K.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=l;function o(K){const j=K;return typeof j?.id=="string"&&E.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function h(K){if(K.configuration)return{id:K.id,configPath:K.configuration};if(K.folders.length===1)return{id:K.id,uri:K.folders[0].uri}}e.toWorkspaceIdentifier=h;function s(K){const j=K;return typeof j?.id=="string"&&E.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=s;function i(K){const j=K;if(j?.uri)return{id:j.id,uri:E.URI.revive(j.uri)};const B=K;if(B?.configPath)return{id:B.id,configPath:E.URI.revive(B.configPath)};if(K?.id)return{id:K.id}}e.reviveIdentifier=i;function r(K,j){return m.extUriBiasedIgnorePathCase.isEqualOrParent(K,j.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function u(K){return d(K)||b(K)}e.isStoredWorkspaceFolder=u;function d(K){const j=K;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=d;function b(K){const j=K;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=b;function L(K,j,B,$,Y=!f.isWindows,H){if(K.scheme!==$.scheme)return{name:B,uri:K.toString(!0)};let F=j?void 0:H.relativePath($,K);if(F!==void 0)F.length===0?F=".":f.isWindows&&K.scheme===k.Schemas.file&&!Y&&(F=F.replace(/\//g,"\\"));else if(K.scheme===k.Schemas.file)F=K.fsPath,f.isWindows&&(F=(0,C.normalizeDriveLetter)(F),Y&&(F=(0,v.toSlashes)(F)));else{if(!H.isEqualAuthority(K.authority,$.authority))return{name:B,uri:K.toString(!0)};F=K.path}return{name:B,path:F}}e.getStoredWorkspaceFolder=L;function R(K,j,B){let $=[],Y=new Set;const H=B.dirname(j);for(let F of K){let W;if(d(F))F.path&&(W=B.resolvePath(H,F.path));else if(b(F))try{W=E.URI.parse(F.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(A){console.warn(A)}if(W){let A=B.getComparisonKey(W);if(!Y.has(A)){Y.add(A);const _=F.name||B.basenameOrAuthority(W);$.push(new t.WorkspaceFolder({uri:W,name:_,index:$.length},F))}}}return $}e.toWorkspaceFolders=R;function T(K,j,B,$,Y){let H=U(j,K);const F=Y.dirname(j),W=Y.dirname($),A=[],_=Q(H.folders);for(const x of H.folders){const ie=d(x)?Y.resolvePath(F,x.path):E.URI.parse(x.uri);let oe;B?oe=!1:oe=!d(x)||(0,P.isAbsolute)(x.path),A.push(L(ie,oe,x.name,W,_,Y))}const N={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},O=D.setProperty(K,["folders"],A,N);let z=D.applyEdits(K,O);return(0,m.isEqualAuthority)(H.remoteAuthority,(0,S.getRemoteAuthority)($))&&(z=D.applyEdits(z,D.removeProperty(z,["remoteAuthority"],N))),z}e.rewriteWorkspaceFileForNewLocation=T;function U(K,j){let B=n.parse(j);if(B&&Array.isArray(B.folders))B.folders=B.folders.filter($=>u($));else throw new Error(`${K} looks like an invalid workspace file.`);return B}function Q(K){return f.isWindows?K.some(j=>d(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function se(K){return K.workspace&&typeof K.workspace=="object"&&typeof K.workspace.id=="string"&&typeof K.workspace.configPath=="string"}function ne(K){return typeof K.folderUri=="string"}function V(K){return typeof K.fileUri=="string"}function J(K,j){const B={workspaces:[],files:[]};if(K){const $=function(H,F){for(let W=0;W<H.length;W++)try{F(H[W],W)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(H[W])}: ${A.toString()}. Skip entry.`)}},Y=K;if(Array.isArray(Y.entries))$(Y.entries,H=>{const F=H.label,W=H.remoteAuthority;se(H)?B.workspaces.push({label:F,remoteAuthority:W,workspace:{id:H.workspace.id,configPath:E.URI.parse(H.workspace.configPath)}}):ne(H)?B.workspaces.push({label:F,remoteAuthority:W,folderUri:E.URI.parse(H.folderUri)}):V(H)&&B.files.push({label:F,remoteAuthority:W,fileUri:E.URI.parse(H.fileUri)})});else{const H=K;Array.isArray(H.workspaces3)&&$(H.workspaces3,(F,W)=>{const A=Array.isArray(H.workspaceLabels)&&H.workspaceLabels[W]||void 0;typeof F=="object"&&typeof F.id=="string"&&typeof F.configURIPath=="string"?B.workspaces.push({label:A,workspace:{id:F.id,configPath:E.URI.parse(F.configURIPath)}}):typeof F=="string"&&B.workspaces.push({label:A,folderUri:E.URI.parse(F)})}),Array.isArray(H.files2)&&$(H.files2,(F,W)=>{const A=Array.isArray(H.fileLabels)&&H.fileLabels[W]||void 0;typeof F=="string"&&B.files.push({label:A,fileUri:E.URI.parse(F)})})}}return B}e.restoreRecentlyOpened=J;function q(K){const j={entries:[]};for(const B of K.workspaces)M(B)?j.entries.push({folderUri:B.folderUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority}):j.entries.push({workspace:{id:B.workspace.id,configPath:B.workspace.configPath.toString()},label:B.label,remoteAuthority:B.remoteAuthority});for(const B of K.files)j.entries.push({fileUri:B.fileUri.toString(),label:B.label,remoteAuthority:B.remoteAuthority});return j}e.toStoreData=q}),define(ee[49],te([0,1,14,8,82,33,2,70,9,3,13,24,138,5,6,38,30]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let w=class St{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,p.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,p.localize)(2,null)},a)}pickWorkspace(c,a){const l=(0,p.localize)(3,null),o=(0,C.mnemonicButtonLabel)((0,p.localize)(4,null)),h=y.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:l,filters:h,buttonLabel:o},a)}async doPick(c,a){const l={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};l.defaultPath=c.defaultPath||this.stateMainService.getItem(St.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(l.properties=void 0,c.pickFiles&&c.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),m.isMacintosh&&l.properties.push("treatPackageAsDirectory");const o=a||v.BrowserWindow.getFocusedWindow(),h=await this.showOpenDialog(l,(0,E.withNullAsUndefined)(o));if(h&&h.filePaths&&h.filePaths.length>0)return this.stateMainService.setItem(St.workingDirPickerStorageKey,(0,f.dirname)(h.filePaths[0])),h.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new n.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?v.dialog.showMessageBox(a,c):v.dialog.showMessageBox(c))}async showSaveDialog(c,a){const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await v.dialog.showSaveDialog(a,c):o=await v.dialog.showSaveDialog(c),o.filePath=this.normalizePath(o.filePath),o})}finally{(0,k.dispose)(l)}}normalizePath(c){return c&&m.isMacintosh&&(c=(0,P.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await I.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const l=this.acquireFileDialogLock(c,a);if(!l)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let o;return a?o=await v.dialog.showOpenDialog(a,c):o=await v.dialog.showOpenDialog(c),o.filePaths=this.normalizePaths(o.filePaths),o})}finally{(0,k.dispose)(l)}}acquireFileDialogLock(c,a){if(!a)return k.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",c);let l=this.windowFileDialogLocks.get(a.id);l||(l=new Set,this.windowFileDialogLocks.set(a.id,l));const o=(0,D.hash)(c);if(!l.has(o))return this.logService.trace("[DialogMainService]: new file dialog lock created",c),l.add(o),(0,k.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",c),l?.delete(o),l?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};w.workingDirPickerStorageKey="pickerWorkingDir",w=de([re(0,g.IStateMainService),re(1,t.ILogService)],w),e.DialogMainService=w}),define(ee[221],te([0,1,4,2,30]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends n.Disposable{constructor(P,f){super();this.logService=P,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(P,f)=>(P?P.push(f):P=[f],P),C.STORAGE_CHANGE_DEBOUNCE_TIME)(P=>{P.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(P))}))}serializeGlobalStorageEvents(P){const f=new Map,m=new Set;return P.forEach(E=>{const I=this.storageMainService.globalStorage.get(E.key);typeof I=="string"?f.set(E.key,I):m.add(E.key)}),{changed:Array.from(f.entries()),deleted:Array.from(m.values())}}listen(P,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(P,f,m){const E=(0,D.reviveIdentifier)(m.workspace),I=await this.withStorageInitialized(E);switch(f){case"getItems":return Array.from(I.items.entries());case"updateItems":{const p=m;if(p.insert)for(const[S,t]of p.insert)I.set(S,t);p.delete&&p.delete.forEach(S=>I.delete(S));break}case"close":{if(E)return I.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(P){const f=P?this.storageMainService.workspaceStorage(P):this.storageMainService.globalStorage;try{await f.init()}catch(m){this.logService.error(`StorageIPC#init: Unable to init ${P?"workspace":"global"} storage due to ${m}`)}return f}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(ee[222],te([0,1,8,4,2,9,24,87,127,6,77,29,30]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class S extends D.Disposable{constructor(w){super();this.logService=w,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new P.Storage(new P.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new v.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const w=await this.doCreate();this._storage.dispose(),this._storage=w,this._register(w.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(w);const M=w.getBoolean(E.IS_NEW_KEY);M===void 0?w.set(E.IS_NEW_KEY,!0):M&&w.set(E.IS_NEW_KEY,!1)}catch(w){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${w}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===m.LogLevel.Trace?w=>this.logService.trace(w):void 0,logError:w=>this.logService.error(w)}}doInit(w){return w.init()}get items(){return this._storage.items}get(w,M){return this._storage.get(w,M)}set(w,M){return this._storage.set(w,M)}delete(w){return this._storage.delete(w)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class t extends S{constructor(w,M,c){super(M);this.options=w,this.environmentService=c}async doCreate(){let w;return this.options.useInMemoryStorage?w=f.SQLiteStorageDatabase.IN_MEMORY_PATH:w=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new P.Storage(new f.SQLiteStorageDatabase(w,{logging:this.createLoggingOptions()}))}async doInit(w){await super.doInit(w),this.updateTelemetryState(w)}updateTelemetryState(w){w.get(I.firstSessionDateStorageKey,void 0)===void 0&&w.set(I.firstSessionDateStorageKey,new Date().toUTCString());const c=w.get(I.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();w.set(I.lastSessionDateStorageKey,typeof c=="undefined"?null:c),w.set(I.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class g extends S{constructor(w,M,c,a){super(c);this.workspace=w,this.options=M,this.environmentService=a}async doCreate(){const{storageFilePath:w,wasCreated:M}=await this.prepareWorkspaceStorageFolder();return new P.Storage(new f.SQLiteStorageDatabase(w,{logging:this.createLoggingOptions()}),{hint:M?P.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const w=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),M=(0,C.join)(w,g.WORKSPACE_STORAGE_NAME);return await k.Promises.exists(w)?{storageFilePath:M,wasCreated:!1}:(await k.Promises.mkdir(w,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(w),{storageFilePath:M,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(w){let M;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?M={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(M={workspace:this.workspace.configPath.toString()}),M)try{const c=(0,C.join)(w,g.WORKSPACE_META_NAME);await k.Promises.exists(c)||await k.Promises.writeFile(c,JSON.stringify(M,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(ee[99],te([0,1,16,7,30]),function(G,e,v,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(f,m,E){for(const p of f){const S=p.openedWorkspace;if((0,D.isWorkspaceIdentifier)(S)){const t=E(S);if(t){if(t.folders.some(g=>v.extUriBiasedIgnorePathCase.isEqualOrParent(m,g.uri)))return p}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(m,S.configPath))return p}}const I=f.filter(p=>(0,D.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(m,p.openedWorkspace.uri));if(I.length)return I.sort((p,S)=>-(p.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function k(f,m){for(const E of f)if((0,D.isWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.configPath,m)||(0,D.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(E.openedWorkspace.uri,m))return E}e.findWindowOnWorkspaceOrFolder=k;function P(f,m){const E=I=>m.some(p=>v.extUriBiasedIgnorePathCase.isEqual(n.URI.file(p),n.URI.file(I)));for(const I of f)if(I.config?.extensionDevelopmentPath?.some(p=>E(p)))return I}e.findWindowOnExtensionDevelopmentPath=P}),define(ee[223],te([0,1,14,2,3,16,7,19,20,6,38,36,30]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class yt extends n.Disposable{constructor(c,a,l,o,h){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=l,this.logService=o,this.configurationService=h,this._state=t(this.stateMainService.getItem(yt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let o=this.windowsMainService.getLastActiveWindow();(!o||o.isExtensionDevelopmentHost)&&(o=this.windowsMainService.getWindows().find(h=>!h.isExtensionDevelopmentHost)),o&&(c.lastActiveWindow=this.toWindowState(o))}const a=this.windowsMainService.getWindows().find(o=>o.isExtensionDevelopmentHost&&!o.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(o=>!o.isExtensionDevelopmentHost).map(o=>this.toWindowState(o)));const l=y(c);this.stateMainService.setItem(yt.windowsStateStorageKey,l),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",l)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(l=>{const o=(0,p.isWorkspaceIdentifier)(c.openedWorkspace)&&l.workspace?.id===c.openedWorkspace.id,h=(0,p.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&l.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(l.folderUri,c.openedWorkspace.uri);(o||h)&&(l.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,p.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,p.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),l=this.configurationService.getValue("window");let o;return a.hasDefaultState?o=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):(o=!!(this.lifecycleMainService.wasRestarted||l?.restoreFullscreen),o&&D.isMacintosh&&this.windowsMainService.getWindows().some(h=>h.isFullScreen)&&(o=!1)),a.mode===3&&!o&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const r=c.workspace;if((0,p.isWorkspaceIdentifier)(r)){const d=this.state.openedWindows.filter(b=>b.workspace&&b.workspace.id===r.id).map(b=>b.uiState);if(d.length)return d[0]}if((0,p.isSingleFolderWorkspaceIdentifier)(r)){const d=this.state.openedWindows.filter(b=>b.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(b.folderUri,r.uri)).map(b=>b.uiState);if(d.length)return d[0]}else if(c.backupPath){const d=this.state.openedWindows.filter(b=>b.backupPath===c.backupPath).map(b=>b.uiState);if(d.length)return d[0]}const u=this.lastClosedState||this.state.lastActiveWindow;if(!a&&u)return u.uiState}let l;const o=v.screen.getAllDisplays();if(o.length===1)l=o[0];else{if(D.isMacintosh){const r=v.screen.getCursorScreenPoint();l=v.screen.getDisplayNearestPoint(r)}!l&&a&&(l=v.screen.getDisplayMatching(a.getBounds())),l||(l=v.screen.getPrimaryDisplay()||o[0])}let h=(0,I.defaultWindowState)();h.x=Math.round(l.bounds.x+l.bounds.width/2-h.width/2),h.y=Math.round(l.bounds.y+l.bounds.height/2-h.height/2);const s=this.configurationService.getValue("window");let i=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")h.mode=0,i=!1;else if(s.newWindowDimensions==="fullscreen")h.mode=3,i=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&a){const r=a.serializeWindowState();r.mode===3?h.mode=3:h=r,i=h.mode!==3&&s.newWindowDimensions==="offset"}}return i&&(h=this.ensureNoOverlap(h)),h.hasDefaultState=!0,h}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(l=>l.getBounds());for(;a.some(l=>l.x===c.x||l.y===c.y);)c.x+=30,c.y+=30;return c}};S.windowsStateStorageKey="windowsState",S=de([re(0,I.IWindowsMainService),re(1,E.IStateMainService),re(2,f.ILifecycleMainService),re(3,m.ILogService),re(4,P.IConfigurationService)],S),e.WindowsStateHandler=S;function t(M){const c={openedWindows:[]},a=M||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(l=>g(l))),c}e.restoreWindowsState=t;function g(M){const c={uiState:M.uiState};return M.backupPath&&(c.backupPath=M.backupPath),M.remoteAuthority&&(c.remoteAuthority=M.remoteAuthority),M.folder&&(c.folderUri=k.URI.parse(M.folder)),M.workspaceIdentifier&&(c.workspace={id:M.workspaceIdentifier.id,configPath:k.URI.parse(M.workspaceIdentifier.configURIPath)}),c}function y(M){return{lastActiveWindow:M.lastActiveWindow&&w(M.lastActiveWindow),lastPluginDevelopmentHostWindow:M.lastPluginDevelopmentHostWindow&&w(M.lastPluginDevelopmentHostWindow),openedWindows:M.openedWindows.map(c=>w(c))}}e.getWindowsStateStoreData=y;function w(M){return{workspaceIdentifier:M.workspace&&{id:M.workspace.id,configURIPath:M.workspace.configPath.toString()},folder:M.folderUri&&M.folderUri.toString(),backupPath:M.backupPath,remoteAuthority:M.remoteAuthority,uiState:M.uiState}}}),define(ee[100],te([0,1,60,28,10,3,16]),function(G,e,v,n,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function P(m){function E(){let I=m.scheme===D.Schemas.file?(0,k.originalFSPath)(m):m.toString();return C.isLinux||(I=I.toLowerCase()),(0,v.createHash)("md5").update(I).digest("hex")}return{id:E(),configPath:m}}e.getWorkspaceIdentifier=P;function f(m,E){function I(){if(m.scheme!==D.Schemas.file)return(0,v.createHash)("md5").update(m.toString()).digest("hex");if(!E)try{E=(0,n.statSync)(m.fsPath)}catch{return}let S;return C.isLinux?S=E.ino:C.isMacintosh?S=E.birthtime.getTime():C.isWindows&&(typeof E.birthtimeMs=="number"?S=Math.floor(E.birthtimeMs):S=E.birthtime.getTime()),(0,v.createHash)("md5").update(m.fsPath).update(S?String(S):"").digest("hex")}const p=I();if(typeof p=="string")return{id:p,uri:m}}e.getSingleFolderWorkspaceIdentifier=f}),define(ee[224],te([0,1,15,10,6,252,115,20]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class f{constructor(p,S){this._worker=new C.Worker(n.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",G).fsPath),this._worker.on("message",p),this._worker.on("error",S)}getId(){return 1}postMessage(p,S){this._worker.postMessage(p,S)}dispose(){this._worker.terminate()}}let m=class{constructor(p){this._logService=p}async logInfo(p){this._logService.info(p)}};m=de([re(0,D.ILogService)],m);let E=class{constructor(p,S){this._logService=p,this._shutdown=!1,this._proxy=null;const t={create:(g,y,w)=>{const M=new f(y,w);return M.postMessage(g,[]),M}};this._worker=new k.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new m(this._logService)),this._initialize(),S.onWillShutdown(g=>{this._shutdown=!0,this._proxy&&g.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(p){return this._proxy.onDynamicStdout(p)}onDynamicStderr(p){return this._proxy.onDynamicStderr(p)}onDynamicMessage(p){return this._proxy.onDynamicMessage(p)}onDynamicError(p){return this._proxy.onDynamicError(p)}onDynamicExit(p){return this._proxy.onDynamicExit(p)}async createExtensionHost(){const p=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return p.createExtensionHost()}async start(p,S){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return t.start(p,S)}async enableInspectPort(p){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return S.enableInspectPort(p)}async kill(p){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,v.canceled)();return S.kill(p)}};E=de([re(0,D.ILogService),re(1,P.ILifecycleMainService)],E),e.WorkerMainProcessExtensionHostStarter=E}),define(ee[58],te([0,1,60,61,26,17,15,4,2,9,3,32,37,85,225]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(R,T=""){this.debugLabel=T,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,k.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,T){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const T=U=>{this.traceSocketEvent("read",U),R(C.VSBuffer.wrap(U))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=U=>{this.traceSocketEvent("close",{hadError:U}),R({type:0,hadError:U,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=g;var y;(function(L){L[L.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var w;(function(L){L[L.PeekHeader=1]="PeekHeader",L[L.ReadHeader=2]="ReadHeader",L[L.ReadBody=3]="ReadBody",L[L.Fin=4]="Fin"})(w||(w={}));class M extends f.Disposable{constructor(R,T,U,Q){super();this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:U?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new c(this,T,U,Q,this._onData,(se,ne)=>this._write(se,ne))),this._register(this._flowManager.onError(se=>{console.error(se),(0,k.onUnexpectedError)(se),this._onClose.fire({type:0,hadError:!0,error:se})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(se=>this._acceptChunk(se))),this._register(this.socket.onClose(se=>this._onClose.fire(se)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let U=2;R.byteLength<126?U+=0:R.byteLength<2**16?U+=2:U+=8;const Q=C.VSBuffer.alloc(U);if(T?Q.writeUInt8(194,0):Q.writeUInt8(130,0),R.byteLength<126)Q.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){Q.writeUInt8(126,1);let se=1;Q.writeUInt8(R.byteLength>>>8&255,++se),Q.writeUInt8(R.byteLength>>>0&255,++se)}else{Q.writeUInt8(127,1);let se=1;Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(0,++se),Q.writeUInt8(R.byteLength>>>24&255,++se),Q.writeUInt8(R.byteLength>>>16&255,++se),Q.writeUInt8(R.byteLength>>>8&255,++se),Q.writeUInt8(R.byteLength>>>0&255,++se)}this.socket.write(C.VSBuffer.concat([Q,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),U=T.readUInt8(0),Q=(U&128)>>>7,se=(U&64)>>>6,ne=T.readUInt8(1),V=(ne&128)>>>7,J=ne&127;this._state.state=2,this._state.readLen=2+(V?4:0)+(J===126?2:0)+(J===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(se)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),U=T.readUInt8(1),Q=(U&128)>>>7;let se=U&127,ne=1;se===126?se=T.readUInt8(++ne)*2**8+T.readUInt8(++ne):se===127&&(se=T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*0+T.readUInt8(++ne)*2**24+T.readUInt8(++ne)*2**16+T.readUInt8(++ne)*2**8+T.readUInt8(++ne));let V=0;Q&&(V=T.readUInt8(++ne)*2**24+T.readUInt8(++ne)*2**16+T.readUInt8(++ne)*2**8+T.readUInt8(++ne)),this._state.state=3,this._state.readLen=se,this._state.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),o(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=M;class c extends f.Disposable{constructor(R,T,U,Q,se,ne){super();this._tracer=R,this._onData=se,this._writeFn=ne,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new a(this._tracer,Q,U,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(V=>this._onError.fire(V))),this._register(this._zlibDeflateStream.onError(V=>this._onError.fire(V)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(T,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,T){return new Promise((U,Q)=>{R.write(T),R.flush(se=>U(se))})}acceptFrame(R,T,U){this._readQueue.push({data:R,isCompressed:T,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,T,U){return new Promise((Q,se)=>{R.write(T),U&&R.write(C.VSBuffer.fromByteArray([0,0,255,255])),R.flush(ne=>Q(ne))})}}class a extends f.Disposable{constructor(R,T,U,Q){super();this._tracer=R,this._recordInflateBytes=T,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",se=>{this._tracer.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this._onError.fire(se)}),this._zlibInflate.on("data",se=>{this._tracer.traceSocketEvent("zlibInflateData",se),this._pendingInflateData.push(C.VSBuffer.wrap(se))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(T)})}}class l extends f.Disposable{constructor(R,T){super();this._tracer=R,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(C.VSBuffer.wrap(U))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function o(L,R){if(R===0)return;let T=L.byteLength>>>2;for(let J=0;J<T;J++){const q=L.readUInt32BE(J*4);L.writeUInt32BE(q^R,J*4)}let U=T*4,Q=L.byteLength-U;const se=R>>>24&255,ne=R>>>16&255,V=R>>>8&255;Q>=1&&L.writeUInt8(L.readUInt8(U)^se,U),Q>=2&&L.writeUInt8(L.readUInt8(U+1)^ne,U+1),Q>=3&&L.writeUInt8(L.readUInt8(U+2)^V,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function s(){const L=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${L}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${L}.sock`):R=(0,m.join)((0,D.tmpdir)(),`vscode-ipc-${L}.sock`),r(R),R}e.createRandomIPCHandle=s;function i(L,R,T){const U=(0,v.createHash)("md5").update(L).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${T}-${R}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,m.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${T}-${R}.sock`):Q=(0,m.join)(L,`${T}-${R}.sock`),r(Q),Q}e.createStaticIPCHandle=i;function r(L){const R=h[E.platform];typeof R=="number"&&L.length>=R&&console.warn(`WARNING: IPC handle "${L}" is longer than ${R} chars, try a shorter --user-data-dir`)}class u extends p.IPCServer{constructor(R){super(u.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const T=P.Event.fromNodeEventEmitter(R,"connection");return P.Event.map(T,U=>({protocol:new S.Protocol(new g(U,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function d(L){return new Promise((R,T)=>{const U=(0,n.createServer)();U.on("error",T),U.listen(L,()=>{U.removeListener("error",T),R(new u(U))})})}e.serve=d;function b(L,R){return new Promise((T,U)=>{const Q=(0,n.createConnection)(L,()=>{Q.removeListener("error",U),T(S.Client.fromSocket(new g(Q,`ipc-client${R}`),R))});Q.once("error",U)})}e.connect=b}),define(ee[226],te([0,1,58]),function(G,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(f){this.driver=f}listen(f,m){throw new Error("No event found")}call(f,m,E){switch(m){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(E);case"startTracing":return this.driver.startTracing(E[0],E[1]);case"stopTracing":return this.driver.stopTracing(E[0],E[1],E[2]);case"reloadWindow":return this.driver.reloadWindow(E);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(E[0],E[1]);case"click":return this.driver.click(E[0],E[1],E[2],E[3]);case"doubleClick":return this.driver.doubleClick(E[0],E[1]);case"setValue":return this.driver.setValue(E[0],E[1],E[2]);case"getTitle":return this.driver.getTitle(E[0]);case"isActiveElement":return this.driver.isActiveElement(E[0],E[1]);case"getElements":return this.driver.getElements(E[0],E[1],E[2]);case"getElementXY":return this.driver.getElementXY(E[0],E[1],E[2]);case"typeInEditor":return this.driver.typeInEditor(E[0],E[1],E[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(E[0],E[1]);case"writeInTerminal":return this.driver.writeInTerminal(E[0],E[1],E[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(E);case"getLocalizedStrings":return this.driver.getLocalizedStrings(E)}throw new Error(`Call not found: ${m}`)}}e.DriverChannel=n;class D{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}startTracing(f,m){return this.channel.call("startTracing",[f,m])}stopTracing(f,m,E){return this.channel.call("stopTracing",[f,m,E])}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,m){return this.channel.call("dispatchKeybinding",[f,m])}click(f,m,E,I){return this.channel.call("click",[f,m,E,I])}doubleClick(f,m){return this.channel.call("doubleClick",[f,m])}setValue(f,m,E){return this.channel.call("setValue",[f,m,E])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,m){return this.channel.call("isActiveElement",[f,m])}getElements(f,m,E){return this.channel.call("getElements",[f,m,E])}getElementXY(f,m,E,I){return this.channel.call("getElementXY",[f,m,E,I])}typeInEditor(f,m,E){return this.channel.call("typeInEditor",[f,m,E])}getTerminalBuffer(f,m){return this.channel.call("getTerminalBuffer",[f,m])}writeInTerminal(f,m,E){return this.channel.call("writeInTerminal",[f,m,E])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=D;class C{constructor(f){this.registry=f}listen(f,m){throw new Error(`Event not found: ${m}`)}call(f,m,E){switch(m){case"registerWindowDriver":return this.registry.registerWindowDriver(E);case"reloadWindowDriver":return this.registry.reloadWindowDriver(E)}throw new Error(`Call not found: ${m}`)}}e.WindowDriverRegistryChannel=C;async function k(P){const f=await(0,v.connect)(P,"driverClient"),m=f.getChannel("driver"),E=new D(m);return{client:f,driver:E}}e.connect=k}),define(ee[23],te([0,1,46,9,58,53,167,5]),function(G,e,v,n,D,C,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,P.refineServiceDecorator)(C.IEnvironmentService);class f extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([v.memoize],f.prototype,"cachedLanguagesPath",null),de([v.memoize],f.prototype,"backupHome",null),de([v.memoize],f.prototype,"backupWorkspacesPath",null),de([v.memoize],f.prototype,"mainIPCHandle",null),de([v.memoize],f.prototype,"mainLockfile",null),de([v.memoize],f.prototype,"sandbox",null),de([v.memoize],f.prototype,"driverVerbose",null),de([v.memoize],f.prototype,"disableUpdates",null),de([v.memoize],f.prototype,"disableKeytar",null),de([v.memoize],f.prototype,"codeCachePath",null),de([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(ee[227],te([0,1,60,28,27,10,9,3,16,7,24,161,19,23,18,6,30]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let w=class{constructor(c,a,l){this.configurationService=a,this.logService=l,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(o,h)=>(0,D.isEqual)(o,h,!P.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(o=>({workspace:{id:o.id,configPath:m.URI.parse(o.configURIPath)},remoteAuthority:o.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(a);let l=[];try{Array.isArray(c.folderWorkspaceInfos)?l=c.folderWorkspaceInfos.map(o=>({folderUri:m.URI.parse(o.folderUri),remoteAuthority:o.remoteAuthority})):Array.isArray(c.folderURIWorkspaces)&&(l=c.folderURIWorkspaces.map(o=>({folderUri:m.URI.parse(o),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(l),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(o=>c.workspace.id===o.workspace.id)||(this.workspaces.push(c),this.saveSync());const l=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(l,a),l}moveBackupFolderSync(c,a){if(n.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),n.existsSync(a))try{n.renameSync(a,c)}catch(l){this.logService.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,l=this.workspaces.findIndex(o=>o.workspace.id===a);l!==-1&&(this.workspaces.splice(l,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c.folderUri,a.folderUri))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(l=>this.backupUriComparer.isEqual(c,l.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const l=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,l))||(this.emptyWindows.push({backupFolder:l,remoteAuthority:a}),this.saveSync()),this.getBackupPath(l)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(l=>!!l.backupFolder&&this.backupPathComparer.isEqual(l.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,k.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,l=[];for(let o of c){const h=o.workspace;if(!(0,y.isWorkspaceIdentifier)(h))return[];if(!a.has(h.id)){a.add(h.id);const s=this.getBackupPath(h.id);await this.doHasBackups(s)?h.configPath.scheme!==C.Schemas.file||await E.Promises.exists(h.configPath.fsPath)?l.push(o):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const h=o.folderUri,s=this.backupUriComparer.getComparisonKey(h);if(!l.has(s)){l.add(s);const i=this.getBackupPath(this.getFolderHash(o));await this.doHasBackups(i)?h.scheme!==C.Schemas.file||await E.Promises.exists(h.fsPath)?a.push(o):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],l=new Set;for(let o of c){const h=o.backupFolder;if(typeof h!="string")return[];if(!l.has(h)){l.add(h);const s=this.getBackupPath(h);await this.doHasBackups(s)?a.push(o):await this.deleteStaleBackup(s)}}return a}async deleteStaleBackup(c){try{await E.Promises.exists(c)&&await E.Promises.rm(c,E.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{await E.Promises.rename(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(o=>!!o.backupFolder&&this.backupPathComparer.isEqual(o.backupFolder,a));)a=this.getRandomEmptyWindowId();const l=this.getBackupPath(a);try{n.renameSync(c,l)}catch(o){return this.logService.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return(0,I.isEmptyWindowBackupInfo)(c)?a=c.backupFolder:(0,y.isFolderBackupInfo)(c)?a=this.getBackupPath(this.getFolderHash(c)):a=this.getBackupPath(c.workspace.id),this.doHasBackups(a)}async doHasBackups(c){try{const a=await E.Promises.readdir(c);for(const l of a)try{if((await E.Promises.readdir((0,k.join)(c,l))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,E.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await E.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const a=c.folderUri;let l;return a.scheme===C.Schemas.file?l=P.isLinux?a.fsPath:a.fsPath.toLowerCase():l=a.toString().toLowerCase(),(0,v.createHash)("md5").update(l).digest("hex")}};w=de([re(0,S.IEnvironmentMainService),re(1,p.IConfigurationService),re(2,g.ILogService)],w),e.BackupMainService=w}),define(ee[228],te([0,1,8,4,106,59,2,3,37,58,163,226,23,181,20,36,18,7,9,17,6]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function l(s){return s<21}let o=class{constructor(i,r,u,d,b,L,R){this.windowServer=i,this.options=r,this.windowsMainService=u,this.lifecycleMainService=d,this.fileService=b,this.environmentMainService=L,this.logService=R,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){this.logService.info("[driver] getWindowIds(): begin");const i=this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r));return this.logService.info(`[driver] getWindowIds(): end (windowIds: ${i.join(", ")})`),i}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,u){if(!u)return;const d=await this.capturePage(i),b=Buffer.from(d,"base64");await this.fileService.writeFile(w.URI.file((0,M.join)(this.environmentMainService.logsPath,`${r}.png`)),c.VSBuffer.wrap(b))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const u=D.KeybindingParser.parseUserBinding(r);for(let d of u)await this._dispatchKeybinding(i,d)}async _dispatchKeybinding(i,r){if(r instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const u=this.windowsMainService.getWindowById(i);if(!u?.win)throw new Error("Invalid window");const d=u.win.webContents,b=new C.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),R=new S.USLayoutResolvedKeybinding(b.toChord(),P.OS).getElectronAccelerator(),T=[];r.ctrlKey&&T.push("ctrl"),r.metaKey&&T.push("meta"),r.shiftKey&&T.push("shift"),r.altKey&&T.push("alt"),d.sendInputEvent({type:"keyDown",keyCode:R,modifiers:T}),l(r.keyCode)||d.sendInputEvent({type:"char",keyCode:R,modifiers:T}),d.sendInputEvent({type:"keyUp",keyCode:R,modifiers:T}),await(0,v.timeout)(100)}async click(i,r,u,d){await(await this.getWindowDriver(i)).click(r,u,d)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,u){await(await this.getWindowDriver(i)).setValue(r,u)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,u){return await(await this.getWindowDriver(i)).getElements(r,u)}async getElementXY(i,r,u,d){return await(await this.getWindowDriver(i)).getElementXY(r,u,d)}async typeInEditor(i,r,u){await(await this.getWindowDriver(i)).typeInEditor(r,u)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,u){await(await this.getWindowDriver(i)).writeInTerminal(r,u)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){this.logService.info(`[driver] getWindowDriver(${i})`),await this.whenUnfrozen(i);const r=`window:${i}`,u=new f.StaticRouter(b=>b===r),d=this.windowServer.getChannel("windowDriver",u);return new E.WindowDriverChannelClient(d)}async whenUnfrozen(i){for(this.logService.info(`[driver] whenUnfrozen(${i}): begin`);this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event);this.logService.info(`[driver] whenUnfrozen(${i}): end`)}};o=de([re(2,g.IWindowsMainService),re(3,t.ILifecycleMainService),re(4,y.IFileService),re(5,p.IEnvironmentMainService),re(6,a.ILogService)],o),e.Driver=o;async function h(s,i,r,u){const d=r.driverVerbose,b=u.createInstance(o,s,{verbose:d}),L=new I.WindowDriverRegistryChannel(b);s.registerChannel("windowDriverRegistry",L);const R=await(0,m.serve)(i),T=new I.DriverChannel(b);return R.registerChannel("driver",T),(0,k.combinedDisposable)(R,s)}e.serve=h}),define(ee[229],te([0,1,61,58]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,k,P,f){const m=I=>f(I,void 0),E=v.createConnection({host:D,port:C},()=>{E.removeListener("error",m);const I=Buffer.alloc(16);for(let g=0;g<16;g++)I[g]=Math.round(Math.random()*256);const p=I.toString("base64"),S=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];E.write(S.join(`\r
`)+`\r
\r
`);const t=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",t),f(void 0,new n.NodeSocket(E,P)))};E.on("data",t)});E.setNoDelay(!0),E.once("error",m)}}}),define(ee[230],te([0,1,61,120,229,8,2,19,6,22,196,97,76]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(M,c,a,l,o){let h;for(let s=3;s&&(h&&h.dispose(),h=await new t(M,c,a,l,o).waitForReady(),!(o&&n.BROWSER_RESTRICTED_PORTS[o]||!n.BROWSER_RESTRICTED_PORTS[h.tunnelLocalPort]));s--);return h}class t extends k.Disposable{constructor(c,a,l,o,h){super();this.defaultTunnelHost=a,this.suggestedLocalPort=h,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=o,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,E.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),o=l.getSocket().socket,h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&c.write(h.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),o.end()}),c.on("close",()=>o.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),o.destroy()}),o.on("end",()=>c.end()),o.on("close",()=>c.end()),o.on("error",()=>{c.destroy()}),c.pipe(o),o.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),o.end()})}}let g=class extends I.AbstractTunnelService{constructor(c,a,l,o,h){super(a);this.socketFactory=c,this.signService=l,this.productService=o,this.configurationService=h}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,l,o,h,s,i){const r=this.getTunnelFromMap(a,l);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,l,o,h,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${l} on local port ${o}.`);const u={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},d=S(u,this.defaultTunnelHost,a,l,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,l,d),d}}};g=de([re(1,f.ILogService),re(2,p.ISignService),re(3,m.IProductService),re(4,P.IConfigurationService)],g),e.BaseTunnelService=g;let y=class extends g{constructor(c,a,l,o){super(D.nodeSocketFactory,c,a,l,o)}};y=de([re(0,f.ILogService),re(1,p.ISignService),re(2,m.IProductService),re(3,P.IConfigurationService)],y),e.TunnelService=y;let w=class extends k.Disposable{constructor(c,a,l,o){super();this.logService=c,this.productService=a,this.signService=l,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(c,a,l,o,h,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${o} on local port ${h}.`),!this._tunnelServices.has(c)){const u=new y(this.logService,this.signService,this.productService,this.configurationService);this._register(u),this._tunnelServices.set(c,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,l,o,h,s,i,r)}};w=de([re(0,f.ILogService),re(1,m.IProductService),re(2,p.ISignService),re(3,P.IConfigurationService)],w),e.SharedTunnelsService=w}),define(ee[231],te([0,1,200,8,17,15,2,13,19,53,91,6,199,225]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends k.Disposable{constructor(y,w,M){super();this.environmentService=w,this.logService=M,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,w){this.logService.trace("RequestService#request",y.url);const{proxyUrl:M,strictSSL:c}=this;let a;try{a=await(0,E.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(h){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",h))}const l={...process.env,...a},o=y.agent?y.agent:await(0,p.getProxyAgent)(y.url||"",l,{proxyUrl:M,strictSSL:c});return y.agent=o,y.strictSSL=c,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization}),this._request(y,w)}async getNodeRequest(y){return((0,v.parse)(y.url).protocol==="https:"?await new Promise((c,a)=>{G(["https"],c,a)}):await new Promise((c,a)=>{G(["http"],c,a)})).request}_request(y,w){return n.Promises.withAsyncBody(async(M,c)=>{let a;const l=(0,v.parse)(y.url),o=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),h={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,P.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(h.auth=y.user+":"+y.password),a=o(h,s=>{const i=(0,P.isNumber)(y.followRedirects)?y.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...y,url:s.headers.location,followRedirects:i-1},w).then(M,c);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,S.createGunzip)())),M({res:s,stream:(0,D.streamToBufferReadableStream)(r)})}}),a.on("error",c),y.timeout&&a.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&a.write(y.data),a.end(),w.onCancellationRequested(()=>{a.abort(),c((0,C.canceled)())})})}async resolveProxy(y){}};t=de([re(0,f.IConfigurationService),re(1,m.INativeEnvironmentService),re(2,I.ILogService)],t),e.RequestService=t}),define(ee[232],te([0,1,14,231]),function(G,e,v,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return v.net.request}class C extends n.RequestService{request(P,f){return super.request({...P||{},getRawRequest:D},f)}}e.RequestMainService=C}),define(ee[233],te([0,1,14,8,4,2,10,13,86,23,20,6,55,56,66,39]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let y=class extends C.Disposable{constructor(M,c,a,l,o,h,s){super();this.machineId=M,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=l,this.logService=o,this.themeMainService=h,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:createSharedProcessMessageChannel",(M,c)=>this.onWindowConnection(M,c)),v.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(M,c)=>this.onWorkerConnection(M,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(M,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(M.sender.isDestroyed())return a.close();M.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(M,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new C.DisposableStore,l=h=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${h}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},o=v.BrowserWindow.fromId(c.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!c.reply.channel){l("unavailable");return}a.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,h=>h.window.win===o)(()=>l("load"))),a.add(D.Event.fromNodeEventEmitter(o,"closed")(()=>l("closed"))),o.webContents.postMessage(c.reply.channel,c.reply.nonce,M.ports)}onWillShutdown(){const M=this.window;!M||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(M.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{M.close()}catch{}this.window=void 0},0))}send(M,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${M}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(M,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${M}' of shared process: ${(0,g.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(M=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),M()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(M=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),M()}))})()),this._whenIpcReady}createWindow(){const M=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",G).fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),M.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:p.default}),this.window.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",G).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=M=>{this.logService.trace("SharedProcess#close prevented"),M.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(M,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(M,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const M=(0,P.assertIsDefined)(this.window);return(0,f.connect)(M)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const M=this.window;return M?!M.isDestroyed()&&!M.webContents.isDestroyed():!1}};y=de([re(2,m.IEnvironmentMainService),re(3,E.ILifecycleMainService),re(4,I.ILogService),re(5,t.IThemeMainService),re(6,S.IProtocolMainService)],y),e.SharedProcess=y}),define(ee[234],te([0,1,8,17,9,13,7,23,18,6]),function(G,e,v,n,D,C,k,P,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class E{constructor(S,t,g){this.storagePath=S,this.logService=t,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,t){const g=this.storage[S];return(0,C.isUndefinedOrNull)(g)?t:g}setItem(S,t){this.setItems([{key:S,data:t}])}setItems(S){let t=!1;for(const{key:g,data:y}of S)this.storage[g]!==y&&((0,C.isUndefinedOrNull)(y)?(0,C.isUndefined)(this.storage[g])||(this.storage[g]=void 0,t=!0):(this.storage[g]=y,t=!0));t&&this.save()}removeItem(S){(0,C.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(S){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),S)}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=E;let I=class It{constructor(S,t,g){this.fileStorage=new E(k.URI.file((0,D.join)(S.userDataPath,It.STATE_FILE)),t,g)}async init(){return this.fileStorage.init()}getItem(S,t){return this.fileStorage.getItem(S,t)}setItem(S,t){this.fileStorage.setItem(S,t)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=de([re(0,P.IEnvironmentMainService),re(1,m.ILogService),re(2,f.IFileService)],I),e.StateMainService=I}),define(ee[78],te([0,1,42,2,53,23,5,20,6,77,222]),function(G,e,v,n,D,C,k,P,f,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let I=class extends n.Disposable{constructor(t,g,y){super();this.logService=t,this.environmentService=g,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{t.join(this.globalStorage.close());for(const[,g]of this.mapWorkspaceToStorage)t.join(g.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new E.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new E.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let g=this.mapWorkspaceToStorage.get(t.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),g=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,g),(0,v.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),g}};I=de([re(0,f.ILogService),re(1,D.IEnvironmentService),re(2,P.ILifecycleMainService)],I),e.StorageMainService=I,e.IGlobalStorageMainService=(0,k.createDecorator)("globalStorageMainService");let p=class extends m.AbstractStorageService{constructor(t,g){super();this.environmentMainService=t,this.storageMainService=g,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};p=de([re(0,C.IEnvironmentMainService),re(1,e.IStorageMainService)],p),e.GlobalStorageMainService=p}),define(ee[79],te([0,1,8,21,4,19,23,20,6,22,48,41]),function(G,e,v,n,D,C,k,P,f,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function p(t,g,y){return`${y.updateUrl}/api/update/${t}/${g}/${y.commit}`}e.createUpdateURL=p;let S=class{constructor(g,y,w,M,c,a){this.lifecycleMainService=g,this.configurationService=y,this.environmentMainService=w,this.requestService=M,this.logService=c,this.productService=a,this._state=I.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),y=this.getProductQuality(g);if(!y){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(y),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,w=>this.logService.error(w))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,v.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};S=de([re(0,P.ILifecycleMainService),re(1,C.IConfigurationService),re(2,k.IEnvironmentMainService),re(3,E.IRequestService),re(4,f.ILogService),re(5,m.IProductService)],S),e.AbstractUpdateService=S}),define(ee[235],te([0,1,14,46,4,2,19,23,20,6,22,48,29,41,79]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends t.AbstractUpdateService{constructor(w,M,c,a,l,o,h){super(w,M,a,l,o,h);this.telemetryService=c,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(w,M)=>M)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(w,M,c)=>({url:M,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(w,M,c,a)=>({releaseNotes:M,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(w){this.logService.error("UpdateService error:",w);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?w:void 0;this.setState(S.State.Idle(1,c))}buildUpdateFeedUrl(w){let M;this.productService.darwinUniversalAssetId?M=this.productService.darwinUniversalAssetId:M=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(M,w,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(w){this.setState(S.State.CheckingForUpdates(w)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(w){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(w))}onUpdateDownloaded(w){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:w.version}),this.setState(S.State.Ready(w)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([n.memoize],g.prototype,"onRawError",null),de([n.memoize],g.prototype,"onRawUpdateNotAvailable",null),de([n.memoize],g.prototype,"onRawUpdateAvailable",null),de([n.memoize],g.prototype,"onRawUpdateDownloaded",null),g=de([re(0,f.ILifecycleMainService),re(1,k.IConfigurationService),re(2,p.ITelemetryService),re(3,P.IEnvironmentMainService),re(4,I.IRequestService),re(5,m.ILogService),re(6,E.IProductService)],g),e.DarwinUpdateService=g}),define(ee[236],te([0,1,44,28,8,4,9,23,20,6,29,41]),function(G,e,v,n,D,C,k,P,f,m,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let p=class{constructor(g,y,w){if(this.lifecycleMainService=g,this.logService=w,this._state=I.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,y.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,M=>this.logService.error(M))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,D.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};p=de([re(0,f.ILifecycleMainService),re(1,P.IEnvironmentMainService),re(2,m.ILogService)],p);let S=class extends p{constructor(g,y,w,M,c,a){super(w,M,c);this.snap=g,this.snapRevision=y,this.telemetryService=a;const l=(0,n.watch)(k.dirname(this.snap)),o=C.Event.fromNodeEventEmitter(l,"change",(r,u)=>u),h=C.Event.filter(o,r=>r==="current"),i=C.Event.debounce(h,(r,u)=>u,2e3)(()=>this.checkForUpdates(!1));w.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+k.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((w,M)=>(0,n.realpath)(`${k.dirname(this.snap)}/current`,(c,a)=>c?M(c):w(a))),y=k.basename(g);return this.snapRevision!==y}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=de([re(2,f.ILifecycleMainService),re(3,P.IEnvironmentMainService),re(4,m.ILogService),re(5,E.ITelemetryService)],S),e.SnapUpdateService=S}),define(ee[45],te([0,1,14,28,4,43,33,2,10,9,3,16,13,24,160,52,49,23,5,6,22,99,30,100]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,M.createDecorator)("workspacesManagementMainService");let s=class extends P.Disposable{constructor(r,u,d,b,L){super();this.environmentMainService=r,this.logService=u,this.backupMainService=d,this.dialogMainService=b,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(r){return this.doResolveLocalWorkspace(r,u=>(0,n.readFileSync)(u,"utf8"))}resolveLocalWorkspace(r){return this.doResolveLocalWorkspace(r,u=>S.Promises.readFile(u,"utf8"))}doResolveLocalWorkspace(r,u){if(!!this.isWorkspacePath(r)&&r.scheme===f.Schemas.file)try{const d=u(r.fsPath);return d instanceof Promise?d.then(b=>this.doResolveWorkspace(r,b),b=>{}):this.doResolveWorkspace(r,d)}catch{return}}isWorkspacePath(r){return(0,o.isUntitledWorkspace)(r,this.environmentMainService)||(0,o.hasWorkspaceFileExtension)(r)}doResolveWorkspace(r,u){try{const d=this.doParseStoredWorkspace(r,u),b=(0,h.getWorkspaceIdentifier)(r);return{id:b.id,configPath:b.configPath,folders:(0,o.toWorkspaceFolders)(d.folders,b.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:d.remoteAuthority,transient:d.transient}}catch(d){this.logService.warn(d.toString())}}doParseStoredWorkspace(r,u){const d=(0,C.parse)(u);if(d&&Array.isArray(d.folders))d.folders=d.folders.filter(b=>(0,o.isStoredWorkspaceFolder)(b));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return d}async createUntitledWorkspace(r,u){const{workspace:d,storedWorkspace:b}=this.newUntitledWorkspace(r,u),L=d.configPath.fsPath;return await S.Promises.mkdir((0,m.dirname)(L),{recursive:!0}),await S.Promises.writeFile(L,JSON.stringify(b,null,"	")),d}createUntitledWorkspaceSync(r,u){const{workspace:d,storedWorkspace:b}=this.newUntitledWorkspace(r,u),L=d.configPath.fsPath;return(0,n.mkdirSync)((0,m.dirname)(L),{recursive:!0}),(0,S.writeFileSync)(L,JSON.stringify(b,null,"	")),d}newUntitledWorkspace(r=[],u){const d=(Date.now()+Math.round(Math.random()*1e3)).toString(),b=(0,I.joinPath)(this.untitledWorkspacesHome,d),L=(0,I.joinPath)(b,o.UNTITLED_WORKSPACE_NAME),R=[];for(const T of r)R.push((0,o.getStoredWorkspaceFolder)(T.uri,!0,T.name,b,!E.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,h.getWorkspaceIdentifier)(L),storedWorkspace:{folders:R,remoteAuthority:u}}}async getWorkspaceIdentifier(r){return(0,h.getWorkspaceIdentifier)(r)}isUntitledWorkspace(r){return(0,o.isUntitledWorkspace)(r.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(r){!this.isUntitledWorkspace(r)||(this.doDeleteUntitledWorkspaceSync(r),this._onDidDeleteUntitledWorkspace.fire(r))}async deleteUntitledWorkspace(r){this.deleteUntitledWorkspaceSync(r)}doDeleteUntitledWorkspaceSync(r){const u=(0,I.originalFSPath)(r.configPath);try{(0,S.rimrafSync)((0,m.dirname)(u));const d=(0,m.join)(this.environmentMainService.workspaceStorageHome.fsPath,r.id);(0,n.existsSync)(d)&&(0,S.writeFileSync)((0,m.join)(d,"obsolete"),"")}catch(d){this.logService.warn(`Unable to delete untitled workspace ${u} (${d}).`)}}getUntitledWorkspacesSync(){const r=[];try{const u=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(d=>(0,I.joinPath)(this.untitledWorkspacesHome,d,o.UNTITLED_WORKSPACE_NAME));for(const d of u){const b=(0,h.getWorkspaceIdentifier)(d),L=this.resolveLocalWorkspaceSync(d);L?r.push({workspace:b,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(b)}}catch(u){u.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${u}).`)}return r}async enterWorkspace(r,u,d){if(!r||!r.win||!r.isReady||!await this.isValidTargetWorkspacePath(r,u,d))return;const L=this.doEnterWorkspace(r,(0,h.getWorkspaceIdentifier)(d));if(!!L)return this._onDidEnterWorkspace.fire({window:r,workspace:L.workspace}),L}async isValidTargetWorkspacePath(r,u,d){if(!d)return!0;if((0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(r.openedWorkspace.configPath,d))return!1;if((0,l.findWindowOnWorkspaceOrFolder)(u,d)){const b={title:this.productService.nameLong,type:"info",buttons:[(0,k.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,I.basename)(d)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(b,(0,p.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(r,u){if(!r.config)return;r.focus();let d;return r.config.extensionDevelopmentPath||(d=this.backupMainService.registerWorkspaceBackupSync({workspace:u,remoteAuthority:r.remoteAuthority},r.config.backupPath)),(0,o.isWorkspaceIdentifier)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&this.deleteUntitledWorkspaceSync(r.openedWorkspace),r.config.workspace=u,r.config.backupPath=d,{workspace:u,backupPath:d}}};s=de([re(0,w.IEnvironmentMainService),re(1,c.ILogService),re(2,g.IBackupMainService),re(3,y.IDialogMainService),re(4,a.IProductService)],s),e.WorkspacesManagementMainService=s}),define(ee[101],te([0,1,14,31,21,3,13,7,24,19,54,5,6,98,36,30,45]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let w=class{constructor(c,a,l,o,h){this.logService=c,this.windowsMainService=a,this.urlService=l,this.workspacesManagementMainService=o,this.configurationService=h}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),C.isMacintosh&&v.app.focus({steal:!0});const l=this.parseOpenUrl(c);if(l.length){let o=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(o=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),o.then(()=>{for(const{uri:h,url:s}of l)this.urlService.open(h,{originalUrl:s})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,n.coalesce)(c._urls.map(a=>{try{return{uri:P.URI.parse(a),url:a}}catch{return null}})):[]}async startOpenWindow(c,a){const l=(0,E.isLaunchedFromCli)(a)?0:4;let o=[];const h=c.wait&&c.waitMarkerFilePath?P.URI.file(c.waitMarkerFilePath):void 0,s=c.remote||void 0,i={context:l,cli:c,userEnv:a,waitMarkerFileURI:h,remoteAuthority:s};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let r=!1;if(c["new-window"]||c["unity-launch"])r=!0;else if(c["reuse-window"])r=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":r=!0;break;case"off":r=!1;break;default:r=!C.isMacintosh}if(r)o=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const u=this.windowsMainService.getLastActiveWindow();u?(this.windowsMainService.openExistingWindow(u,i),o=[u]):o=this.windowsMainService.open({...i,forceEmpty:!0})}}else o=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(h&&o.length===1&&o[0])return Promise.race([o[0].whenClosedOrLoaded,(0,f.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return v.BrowserWindow.getAllWindows().forEach(a=>{const l=this.windowsMainService.getWindowById(a.id);l?c.push(this.codeWindowToInfo(l)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(o=>new Promise(h=>{const s=o.remoteAuthority;if(s){const i=`vscode:getDiagnosticInfoResponse${o.id}`,r={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(o):void 0};o.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:r}),v.ipcMain.once(i,(u,d)=>{d||h({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),h(d)}),setTimeout(()=>{h({hostName:s,errorMessage:`Connection to '${s}' could not be established`})},5e3)}else h(void 0)})))).filter(o=>!!o)}getFolderURIs(c){const a=[],l=c.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(l))a.push(l.uri);else if((0,g.isWorkspaceIdentifier)(l)){const o=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.configPath);o&&o.folders.forEach(s=>{a.push(s.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),l=(0,k.assertIsDefined)(c.win);return this.browserWindowToInfo(l,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],l){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:l}}};w=de([re(0,p.ILogService),re(1,t.IWindowsMainService),re(2,S.IURLService),re(3,y.IWorkspacesManagementMainService),re(4,m.IConfigurationService)],w),e.LaunchMainService=w}),define(ee[50],te([0,1,44,14,26,119,46,4,33,2,10,9,3,7,83,71,24,152,49,23,5,20,6,22,29,66,36,30,45]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o,h,s,i,r,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let b=class mt extends m.Disposable{constructor(R,T,U,Q,se,ne,V,J,q,K){super();this.sharedProcess=R,this.windowsMainService=T,this.dialogMainService=U,this.lifecycleMainService=Q,this.environmentMainService=se,this.telemetryService=ne,this.logService=V,this.productService=J,this.themeMainService=q,this.workspacesManagementMainService=K,this.onDidOpenWindow=P.Event.map(this.windowsMainService.onDidOpenWindow,j=>j.id),this.onDidMaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(j,B)=>B.id),j=>!!this.windowsMainService.getWindowById(j)),this.onDidUnmaximizeWindow=P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(j,B)=>B.id),j=>!!this.windowsMainService.getWindowById(j)),this.onDidBlurWindow=P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(j,B)=>B.id),j=>!!this.windowsMainService.getWindowById(j)),this.onDidFocusWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),j=>!!j),j=>j.id),P.Event.filter(P.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(j,B)=>B.id),j=>!!this.windowsMainService.getWindowById(j))),this.onDidResumeOS=P.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new P.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new P.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(j,B,$)=>$),j=>!(Array.isArray(j)&&j.length===1&&j[0]==="workArea")),P.Event.fromNodeEventEmitter(n.screen,"display-added"),P.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const T=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(R,T,U){return Array.isArray(T)?this.doOpenWindow(R,T,U):this.doOpenEmptyWindow(R,T)}async doOpenWindow(R,T,U=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(R,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},T)}async toggleFullScreen(R){const T=this.windowById(R);T&&T.toggleFullScreen()}async handleTitleDoubleClick(R){const T=this.windowById(R);T&&T.handleTitleDoubleClick()}async isMaximized(R){const T=this.windowById(R);return T?.win?T.win.isMaximized():!1}async maximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.maximize()}async unmaximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.unmaximize()}async minimizeWindow(R){const T=this.windowById(R);T?.win&&T.win.minimize()}async focusWindow(R,T){T&&typeof T.windowId=="number"&&(R=T.windowId);const U=this.windowById(R);U&&U.focus({force:T?.force??!1})}async setMinimumSize(R,T,U){const Q=this.windowById(R);if(Q?.win){const[se,ne]=Q.win.getSize(),[V,J]=Q.win.getMinimumSize(),[q,K]=[T??V,U??J],[j,B]=[Math.max(se,q),Math.max(ne,K)];(V!==q||J!==K)&&Q.win.setMinimumSize(q,K),(se!==j||ne!==B)&&Q.win.setSize(j,B)}}async saveWindowSplash(R,T){this.themeMainService.saveWindowSplash(R,T)}async installShellCommand(R){const{source:T,target:U}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await y.SymlinkSupport.stat(T);if(Q&&!Q.dangling){const se=await(0,t.realpath)(T);if(U===se)return}await y.Promises.unlink(T)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await y.Promises.symlink(U,T)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:se}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,w.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,w.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,w.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ne=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${T}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(ne)}catch{throw new Error((0,w.localize)(3,null,T))}}}async uninstallShellCommand(R){const{source:T}=await this.getShellCommandLink();try{await y.Promises.unlink(T)}catch(U){switch(U.code){case"EACCES":{const{response:Q}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,w.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,w.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const se=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,C.promisify)(v.exec)(se)}catch{throw new Error((0,w.localize)(7,null,T))}break}case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const R=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await y.Promises.exists(R))throw new Error((0,w.localize)(8,null,R));return{source:T,target:R}}async showMessageBox(R,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(R))}async showSaveDialog(R,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(R))}async showOpenDialog(R,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(R))}toBrowserWindow(R){const T=this.windowById(R);if(T?.win)return T.win}async pickFileFolderAndOpen(R,T){const U=await this.dialogMainService.pickFileFolder(T);U&&(this.sendPickerTelemetry(U,T.telemetryEventName||"openFileFolder",T.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async Q=>await y.SymlinkSupport.existsDirectory(Q)?{folderUri:S.URI.file(Q)}:{fileUri:S.URI.file(Q)})),T,R))}async pickFolderAndOpen(R,T){const U=await this.dialogMainService.pickFolder(T);U&&(this.sendPickerTelemetry(U,T.telemetryEventName||"openFolder",T.telemetryExtraData),this.doOpenPicked(U.map(Q=>({folderUri:S.URI.file(Q)})),T,R))}async pickFileAndOpen(R,T){const U=await this.dialogMainService.pickFile(T);U&&(this.sendPickerTelemetry(U,T.telemetryEventName||"openFile",T.telemetryExtraData),this.doOpenPicked(U.map(Q=>({fileUri:S.URI.file(Q)})),T,R))}async pickWorkspaceAndOpen(R,T){const U=await this.dialogMainService.pickWorkspace(T);U&&(this.sendPickerTelemetry(U,T.telemetryEventName||"openWorkspace",T.telemetryExtraData),this.doOpenPicked(U.map(Q=>({workspaceUri:S.URI.file(Q)})),T,R))}doOpenPicked(R,T,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:T.forceNewWindow})}sendPickerTelemetry(R,T,U){const Q=R?R.length:0;this.telemetryService.publicLog(T,{...U,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(R,T){n.shell.showItemInFolder(T)}async setRepresentedFilename(R,T){const U=this.windowById(R);U&&U.setRepresentedFilename(T)}async setDocumentEdited(R,T){const U=this.windowById(R);U&&U.setDocumentEdited(T)}async openExternal(R,T){return p.isLinuxSnap?this.safeSnapOpenExternal(T):n.shell.openExternal(T),!0}safeSnapOpenExternal(R){const T=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(R,T){return n.shell.trashItem(T)}async isAdmin(){let R;return p.isWindows?R=(await new Promise((T,U)=>{G(["native-is-elevated"],T,U)}))():R=process.getuid()===0,R}async writeElevated(R,T,U,Q){const se=await new Promise((ne,V)=>{G(["@vscode/sudo-prompt"],ne,V)});return new Promise((ne,V)=>{const J=[`"${this.cliPath}"`];Q?.unlock&&J.push("--file-chmod"),J.push("--file-write",`"${T.fsPath}"`,`"${U.fsPath}"`);const q={name:this.productService.nameLong.replace("-",""),icns:p.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(J.join(" "),q,(K,j,B)=>{j&&this.logService.trace(`[sudo-prompt] received stdout: ${j}`),B&&this.logService.trace(`[sudo-prompt] received stderr: ${B}`),K?V(K):ne(void 0)})})}get cliPath(){return p.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):p.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,T,U){process.kill(T,U)}async readClipboardText(R,T){return n.clipboard.readText(T)}async writeClipboardText(R,T,U){return n.clipboard.writeText(T,U)}async readClipboardFindText(R){return n.clipboard.readFindText()}async writeClipboardFindText(R,T){return n.clipboard.writeFindText(T)}async writeClipboardBuffer(R,T,U,Q){return n.clipboard.writeBuffer(T,Buffer.from(U),Q)}async readClipboardBuffer(R,T){return n.clipboard.readBuffer(T)}async hasClipboard(R,T,U){return n.clipboard.has(T,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,T){const U=this.windowById(R);U&&U.updateTouchBar(T)}async notifyReady(R){const T=this.windowById(R);T&&T.setReady()}async relaunch(R,T){return this.lifecycleMainService.relaunch(T)}async reload(R,T){const U=this.windowById(R);if(U){if((0,u.isWorkspaceIdentifier)(U.openedWorkspace)){const Q=U.openedWorkspace.configPath;if(Q.scheme===E.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,T){const U=this.windowById(T);if(U?.win)return U.win.close()}async quit(R){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(R,T){await this.lifecycleMainService.kill(T)}async resolveProxy(R,T){const Q=this.windowById(R)?.win?.webContents?.session;if(Q)return Q.resolveProxy(T)}async openDevTools(R,T){const U=this.windowById(R);U?.win&&U.win.webContents.openDevTools(T)}async toggleDevTools(R){const T=this.windowById(R);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(R,T){const U=this.windowById(R);U?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&U.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,T,U,Q){if(!p.isWindows)return;const se=await new Promise((ne,V)=>{G(["@vscode/windows-registry"],ne,V)});try{return se.GetStringRegKey(T,U,Q)}catch{return}}async getPassword(R,T,U){const Q=await this.withKeytar(),se=await Q.getPassword(T,U);if(se)try{let{content:ne,hasNextChunk:V}=JSON.parse(se);if(!ne||!V)return se;let J=1;for(;V;){const q=await Q.getPassword(T,`${U}-${J}`),K=JSON.parse(q);ne+=K.content,V=K.hasNextChunk,J++}return ne}catch{return se}return se}async setPassword(R,T,U,Q){const se=await this.withKeytar(),ne=3,V=async(J,q,K)=>{let j=0,B;for(;j<ne;)try{await se.setPassword(J,q,K);return}catch($){B=$,this.logService.warn("Error attempting to set a password: ",$),j++,await new Promise(Y=>setTimeout(Y,200))}throw B};if(p.isWindows&&Q.length>mt.MAX_PASSWORD_LENGTH){let J=0,q=0,K=!0;for(;K;){const j=Q.substring(J,J+mt.PASSWORD_CHUNK_SIZE);J+=mt.PASSWORD_CHUNK_SIZE,K=Q.length-J>0;const B={content:j,hasNextChunk:K};await V(T,q?`${U}-${q}`:U,JSON.stringify(B)),q++}}else await V(T,U,Q);this._onDidChangePassword.fire({service:T,account:U})}async deletePassword(R,T,U){const se=await(await this.withKeytar()).deletePassword(T,U);return se&&this._onDidChangePassword.fire({service:T,account:U}),se}async findPassword(R,T){return(await this.withKeytar()).findPassword(T)}async findCredentials(R,T){return(await this.withKeytar()).findCredentials(T)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,T)=>{G(["keytar"],R,T)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,de([k.memoize],b.prototype,"cliPath",null),b=de([re(1,r.IWindowsMainService),re(2,M.IDialogMainService),re(3,l.ILifecycleMainService),re(4,c.IEnvironmentMainService),re(5,s.ITelemetryService),re(6,o.ILogService),re(7,h.IProductService),re(8,i.IThemeMainService),re(9,d.IWorkspacesManagementMainService)],b),e.NativeHostMainService=b}),define(ee[237],te([0,1,14,21,4,82,2,32,89,6,50,22,36]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let t=class extends k.Disposable{constructor(y,w,M,c,a){super();this.logService=y,this.windowsMainService=w,this.nativeHostMainService=M,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const y=D.Event.fromNodeEventEmitter(v.app,"login",(w,M,c,a,l)=>({event:w,webContents:M,req:c,authInfo:a,callback:l}));this._register(y(this.onLogin,this))}async onLogin({event:y,authInfo:w,req:M,callback:c}){if(!w.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&M.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(w);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(y){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.doResolveProxyCredentials(y);if(w)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(y){this.logService.trace("auth#doResolveProxyCredentials - enter",y);const w=String((0,C.hash)({scheme:y.scheme,host:y.host,port:y.port}));let M,c;try{const h=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,w);if(h){const s=JSON.parse(await this.encryptionMainService.decrypt(h));M=s.username,c=s.password}}catch(h){this.logService.error(h)}if(this.state!==S.StoredCredentialsUsed&&typeof M=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:M,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const l={authInfo:y,username:this.sessionCredentials?.username??M,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,P.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,l),this.state=S.LoginDialogShown;const o=await new Promise(h=>{const s=async(i,r,u)=>{if(r===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",s),u){const d={username:u.username,password:u.password};try{if(u.remember){const b=await this.encryptionMainService.encrypt(JSON.stringify(d));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,w,b)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,w)}catch(b){this.logService.error(b)}h({username:d.username,password:d.password})}else h(void 0)};a.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=o,o}};t=de([re(0,m.ILogService),re(1,p.IWindowsMainService),re(2,E.INativeHostMainService),re(3,f.IEncryptionMainService),re(4,I.IProductService)],t),e.ProxyAuthHandler=t}),define(ee[238],te([0,1,14,26,33,2,10,3,84,150,74,49,23,5,101,6,50,55,22,56,67]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let l=class Pt{constructor(h,s,i,r,u,d,b,L,R){this.userEnv=h,this.environmentMainService=s,this.launchMainService=i,this.logService=r,this.diagnosticsService=u,this.dialogMainService=d,this.nativeHostMainService=b,this.protocolMainService=L,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async h=>{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),r=await this.diagnosticsService.getSystemInfo(s,i);this.safeSend(h,"vscode:issueSystemInfoResponse",r)}),v.ipcMain.on("vscode:listProcesses",async h=>{const s=[];try{const i=await this.launchMainService.getMainProcessId();s.push({name:(0,m.localize)(0,null),rootProcess:await(0,f.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,E.isRemoteDiagnosticError)(u)?s.push({name:u.hostName,rootProcess:u}):u.processes&&s.push({name:u.hostName,rootProcess:u.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(h,"vscode:listProcessesResponse",s)}),v.ipcMain.on("vscode:issueReporterClipboard",async h=>{const s={title:this.productService.nameLong,message:(0,m.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,m.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,m.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(h,"vscode:issueReporterClipboardResponse",i.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async h=>{const s=await this.getPerformanceInfo();this.safeSend(h,"vscode:issuePerformanceInfoResponse",s)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const h={title:this.productService.nameLong,message:(0,m.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,m.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,m.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(h,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(h,s)=>{const{id:i,from:r,args:u}=s;let d;switch(r){case"issueReporter":d=this.issueReporterParentWindow;break;case"processExplorer":d=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${r}`)}d&&d.webContents.send("vscode:runAction",{id:i,from:r,args:u})}),v.ipcMain.on("vscode:openExternal",(h,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),v.ipcMain.on("vscode:closeIssueReporter",h=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",h=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async h=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(h,"vscode:windowsInfoResponse",s.windows)})}safeSend(h,s,...i){h.sender.isDestroyed()||h.sender.send(s,...i)}async openReporter(h){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new C.DisposableStore,i=s.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(r,i,{backgroundColor:h.styles.backgroundColor,title:(0,m.localize)(7,null),zoomLevel:h.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:h,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:w.default}),this.issueReporterWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",G).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(h){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new C.DisposableStore,i=s.add(this.protocolMainService.createIPCObjectUrl()),r=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(r,i,{backgroundColor:h.styles.backgroundColor,title:(0,m.localize)(8,null),zoomLevel:h.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:h,product:w.default}),this.processExplorerWindow.loadURL(k.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",G).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(h){h.isMinimized()&&h.restore(),h.focus()}createBrowserWindow(h,s,i,r){const u=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:h.width,height:h.height,minWidth:300,minHeight:200,x:h.x,y:h.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",G).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`,`--vscode-window-kind=${r}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return u.setMenuBarVisibility(!1),u}async getSystemStatus(){const[h,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(h,s)}getWindowPosition(h,s,i){let r;const u=v.screen.getAllDisplays();if(u.length===1)r=u[0];else{if(P.isMacintosh){const L=v.screen.getCursorScreenPoint();r=v.screen.getDisplayNearestPoint(L)}!r&&h&&(r=v.screen.getDisplayMatching(h.getBounds())),r||(r=v.screen.getPrimaryDisplay()||u[0])}const d={width:s,height:i},b=r.bounds;return d.x=b.x+b.width/2-d.width/2,d.y=b.y+b.height/2-d.height/2,b.width>0&&b.height>0&&(d.x<b.x&&(d.x=b.x),d.y<b.y&&(d.y=b.y),d.x>b.x+b.width&&(d.x=b.x),d.y>b.y+b.height&&(d.y=b.y),d.width>b.width&&(d.width=b.width),d.height>b.height&&(d.height=b.height)),d}async getPerformanceInfo(){try{const[h,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(h,s)}catch(h){throw this.logService.warn("issueService#getPerformanceInfo ",h.message),h}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=de([re(1,p.IEnvironmentMainService),re(2,t.ILaunchMainService),re(3,g.ILogService),re(4,E.IDiagnosticsService),re(5,I.IDialogMainService),re(6,y.INativeHostMainService),re(7,c.IProtocolMainService),re(8,M.IProductService)],l),e.IssueMainService=l}),define(ee[239],te([0,1,21,19,23,20,6,50,22,48,29,41,79]),function(G,e,v,n,D,C,k,P,f,m,E,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends p.AbstractUpdateService{constructor(g,y,w,M,c,a,l,o){super(g,y,M,c,a,o);this.telemetryService=w,this.nativeHostMainService=l}buildUpdateFeedUrl(g){return(0,p.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(I.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},v.CancellationToken.None).then(m.asJson).then(y=>{!y||!y.url||!y.version||!y.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(y))}).then(void 0,y=>{this.logService.error(y),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const w=g?y.message||y:void 0;this.setState(I.State.Idle(1,w))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(I.State.Idle(1))}};S=de([re(0,C.ILifecycleMainService),re(1,n.IConfigurationService),re(2,E.ITelemetryService),re(3,D.IEnvironmentMainService),re(4,m.IRequestService),re(5,k.ILogService),re(6,P.INativeHostMainService),re(7,f.IProductService)],S),e.LinuxUpdateService=S}),define(ee[240],te([0,1,44,28,26,8,21,46,9,7,116,24,19,23,18,20,6,50,22,48,29,41,79]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function h(u,d=1e3){for(;!u();)await(0,C.timeout)(d)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends o.AbstractUpdateService{constructor(d,b,L,R,T,U,Q,se,ne){super(d,b,R,T,U,ne);this.telemetryService=L,this.fileService=Q,this.nativeHostMainService=se}get cachePath(){const d=f.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(d,{recursive:!0}).then(()=>d)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(d){let b="win32";return process.arch!=="ia32"&&(b+=`-${process.arch}`),i()===1?b+="-archive":this.productService.target==="user"&&(b+="-user"),(0,o.createUpdateURL)(b,d,this.productService)}doCheckForUpdates(d){!this.url||(this.setState(l.State.CheckingForUpdates(d)),this.requestService.request({url:this.url},k.CancellationToken.None).then(c.asJson).then(b=>{const L=i();return!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d}),this.setState(l.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(l.State.AvailableForDownload(b)),Promise.resolve(null)):(this.setState(l.State.Downloading(b)),this.cleanup(b.version).then(()=>this.getUpdatePackagePath(b.version).then(R=>I.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const U=b.url,Q=b.hash,se=`${R}.tmp`;return this.requestService.request({url:U},k.CancellationToken.None).then(ne=>this.fileService.writeFile(m.URI.file(se),ne.stream)).then(Q?()=>(0,E.checksum)(se,b.hash):()=>{}).then(()=>I.Promises.rename(se,R)).then(()=>R)})).then(R=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},T&&b.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(b)):this.setState(l.State.Ready(b))})))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!d});const L=d?b.message||b:void 0;this.setState(l.State.Idle(i(),L))}))}async doDownloadUpdate(d){d.update.url&&this.nativeHostMainService.openExternal(void 0,d.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(d){const b=await this.cachePath;return f.join(b,`CodeSetup-${this.productService.quality}-${d}.exe`)}async cleanup(d=null){const b=d?U=>!new RegExp(`${this.productService.quality}-${d}\\.exe$`).test(U):()=>!0,L=await this.cachePath,T=(await I.Promises.readdir(L)).filter(b).map(async U=>{try{await I.Promises.unlink(f.join(L,U))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const d=this.state.update;this.setState(l.State.Updating(d));const b=await this.cachePath;this.availableUpdate.updateFilePath=f.join(b,`CodeSetup-${this.productService.quality}-${d.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,T=await new Promise((U,Q)=>{G(["windows-mutex"],U,Q)});h(()=>T.isActive(R)).then(()=>this.setState(l.State.Ready(d)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};de([P.memoize],r.prototype,"cachePath",null),r=de([re(0,g.ILifecycleMainService),re(1,p.IConfigurationService),re(2,a.ITelemetryService),re(3,S.IEnvironmentMainService),re(4,c.IRequestService),re(5,y.ILogService),re(6,t.IFileService),re(7,w.INativeHostMainService),re(8,M.IProductService)],r),e.Win32UpdateService=r}),define(ee[241],te([0,1,14,8,21,39,4,33,2,10,9,63,3,7,156,52,19,49,23,54,207,18,20,6,22,56,78,29,210,66,67,36,30,45]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o,h,s,i,r,u,d,b,L,R,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.LOADING=1]="LOADING",ne[ne.NAVIGATING=2]="NAVIGATING",ne[ne.READY=3]="READY"})(Q||(Q={}));let se=class extends f.Disposable{constructor(V,J,q,K,j,B,$,Y,H,F,W,A,_,N,O){super();this.logService=J,this.environmentMainService=q,this.fileService=K,this.globalStorageMainService=j,this.configurationService=B,this.themeMainService=$,this.workspacesManagementMainService=Y,this.backupMainService=H,this.telemetryService=F,this.dialogMainService=W,this.lifecycleMainService=A,this.productService=_,this.protocolMainService=N,this.windowsMainService=O,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[z,x]=this.restoreWindowState(V.state);this.windowState=z,this.logService.trace("window#ctor: using window state",z);const ie=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),Z={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!ie,title:this.productService.nameLong,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",G).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(oe?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};p.isLinux?Z.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):p.isWindows&&!this.environmentMainService.isBuilt&&(Z.icon=(0,E.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),p.isMacintosh&&!this.useNativeFullScreen()&&(Z.fullscreenable=!1),p.isMacintosh&&(Z.acceptFirstMouse=!0,oe?.clickThroughInactive===!1&&(Z.acceptFirstMouse=!1));const ce=p.isMacintosh&&oe?.nativeTabs===!0;ce&&(Z.tabbingIdentifier=this.productService.nameShort);const le=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(Z.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,p.isMacintosh||(Z.frame=!1)),(0,I.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(Z),(0,I.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),p.isMacintosh&&le&&this._win.setSheetOffset(22),p.isMacintosh&&x&&(!ce||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}ie&&((0,I.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,I.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(V){p.isMacintosh?this._win.setRepresentedFilename(V):this.representedFilename=V}getRepresentedFilename(){return p.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(V){p.isMacintosh&&this._win.setDocumentEdited(V),this.documentEdited=V}isDocumentEdited(){return p.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(V){p.isMacintosh&&V?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(V=>{if(this.isReady)return V(this);this.whenReadyCallbacks.push(V)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(V=>{function J(){q.dispose(),K.dispose(),V()}const q=this.onDidClose(()=>J()),K=this.onWillLoad(()=>J())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(j,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(j,B,$)=>this.onWindowError(3,{reason:$,exitCode:B})),this._win.webContents.on("will-prevent-unload",j=>{j.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const V=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,"devtools"]),J=j=>{for(let B=j;B;B=B.parent)if(B.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},q=j=>j.resourceType==="xhr"||J(j.frame);this._win.webContents.session.webRequest.onBeforeRequest((j,B)=>{const $=S.URI.parse(j.url);return $.path.endsWith(".svg")&&!V.has($.scheme)?B({cancel:!q(j)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((j,B)=>{const $=j.responseHeaders,Y=$["content-type"]||$["Content-Type"];if(Y&&Array.isArray(Y)){const H=S.URI.parse(j.url);if(H.path.endsWith(".svg")&&V.has(H.scheme))return $["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:$});if(!H.path.includes(m.Schemas.vscodeRemoteResource)&&Y.some(F=>F.toLowerCase().includes("image/svg")))return B({cancel:!q(j)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",j=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",j,this._win)}),this._win.on("unmaximize",j=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",j,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(j=>this.onDidDeleteUntitledWorkspace(j)));const K=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:K},async(j,B)=>{const $=await this.getMarketplaceHeaders();B({cancel:!1,requestHeaders:Object.assign(j.requestHeaders,$)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(V,J){switch(V){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${J?.reason||"<unknown>"}, code: ${J?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${J?.reason||"<unknown>"}, code: ${J?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:V,reason:J?.reason,code:J?.exitCode}),V){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(V===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const q=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(q.response!==1){const K=q.response===0;this.destroyWindow(K)}}else if(V===2){let q;J?q=(0,t.localize)(6,null,J.reason,J.exitCode??"<unknown>"):q=(0,t.localize)(5,null);const j=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,P.mnemonicButtonLabel)((0,t.localize)(8,null))],message:q,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(j)}break}}destroyWindow(V){if(this._onDidDestroy.fire(),this._win?.destroy(),V&&this.config){let J,q;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?J={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?J={workspaceUri:this.openedWorkspace.configPath}:q=!0;const[K]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:q,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});K.focus()}}onDidDeleteUntitledWorkspace(V){this.openedWorkspace?.id===V.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const V=this.getMenuBarVisibility();V!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=V,this.setMenuBarVisibility(V));let J=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;J?.endsWith("/")&&(J=J.substr(0,J.length-1));const q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((J||"").indexOf("@")===-1&&(J!==this.currentHttpProxy||q!==this.currentNoProxy)){this.currentHttpProxy=J,this.currentNoProxy=q;const K=J||"",j=q?`${q},<local>`:"<local>";this.logService.trace(`Setting proxy to '${K}', bypassing '${j}'`),this._win.webContents.session.setProxy({proxyRules:K,proxyBypassRules:j,pacScript:""})}}addTabbedWindow(V){p.isMacintosh&&V.win&&this._win.addTabbedWindow(V.win)}load(V,J=Object.create(null)){this.isDocumentEdited()&&(!J.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),J.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(V,J),this.readyState===0?this.currentConfig=V:(this.pendingLoadConfig=V,this.readyState=2),this._win.loadURL(m.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",G).toString(!0));const q=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:V.workspace,reason:J.isReload?3:q?2:1})}updateConfiguration(V,J){const q=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(q){const K=(0,c.isLaunchedFromCli)(q)&&!(0,c.isLaunchedFromCli)(V.userEnv),j=this.isExtensionDevelopmentHost;(K||j)&&(V.userEnv={...q,...V.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(V.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),J.disableExtensions!==void 0&&(V["disable-extensions"]=J.disableExtensions),V.fullscreen=this.isFullScreen,V.maximized=this._win.isMaximized(),V.partsSplash=this.themeMainService.getWindowSplash(),(0,I.mark)("code/willOpenNewWindow"),V.perfMarks=(0,I.getMarks)(),this.configObjectUrl.update(V)}async reload(V){const J=Object.assign({},this.currentConfig);J.workspace=await this.validateWorkspaceBeforeReload(J),delete J.filesToOpenOrCreate,delete J.filesToDiff,delete J.filesToWait,this.isExtensionDevelopmentHost&&V&&(J.verbose=V.verbose,J.debugId=V.debugId,J.extensionEnvironment=V.extensionEnvironment,J["inspect-extensions"]=V["inspect-extensions"],J["inspect-brk-extensions"]=V["inspect-brk-extensions"],J["extensions-dir"]=V["extensions-dir"]),J.isInitialStartup=!1,this.load(J,{isReload:!0,disableExtensions:V?.["disable-extensions"]})}async validateWorkspaceBeforeReload(V){if((0,T.isWorkspaceIdentifier)(V.workspace)){const J=V.workspace.configPath;if(J.scheme===m.Schemas.file&&!await this.fileService.exists(J))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(V.workspace)){const J=V.workspace.uri;if(J.scheme===m.Schemas.file&&!await this.fileService.exists(J))return}return V.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let q;try{q=v.screen.getDisplayMatching(this.getBounds())}catch{}const K=(0,R.defaultWindowState)();return{mode:3,display:q?q.id:void 0,width:this.windowState.width||K.width,height:this.windowState.height||K.height,x:this.windowState.x||0,y:this.windowState.y||0}}const V=Object.create(null);let J;if(!p.isMacintosh&&this._win.isMaximized()?J=0:J=1,J===0?V.mode=0:V.mode=1,J===1||J===0){let q;J===1?q=this.getBounds():q=this._win.getNormalBounds(),V.x=q.x,V.y=q.y,V.width=q.width,V.height=q.height}return V}restoreWindowState(V){(0,I.mark)("code/willRestoreCodeWindowState");let J=!1;if(V)try{const q=v.screen.getAllDisplays();J=q.length>1,V=this.validateWindowState(V,q)}catch(q){this.logService.warn(`Unexpected error validating window state: ${q}
${q.stack}`)}return(0,I.mark)("code/didRestoreCodeWindowState"),[V||(0,R.defaultWindowState)(),J]}validateWindowState(V,J){if(this.logService.trace(`window#validateWindowState: validating window state on ${J.length} display(s)`,V),typeof V.x!="number"||typeof V.y!="number"||typeof V.width!="number"||typeof V.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(V.width<=0||V.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(J.length===1){const j=this.getWorkingArea(J[0]);if(j){let B=function(){!V||typeof V.x!="number"||typeof V.y!="number"||!j||(V.x<j.x&&(V.x=j.x),V.y<j.y&&(V.y=j.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",j),B(),V.width>j.width&&(V.width=j.width),V.height>j.height&&(V.height=j.height),V.x>j.x+j.width-128&&(V.x=j.x+j.width-V.width),V.y>j.y+j.height-128&&(V.y=j.y+j.height-V.height),B()}return V}if(V.display&&V.mode===3){const j=J.find(B=>B.id===V.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=j.bounds.x,B.y=j.bounds.y,B}}let q,K;try{q=v.screen.getDisplayMatching({x:V.x,y:V.y,width:V.width,height:V.height}),K=this.getWorkingArea(q)}catch{}if(q&&K&&V.x+V.width>K.x&&V.y+V.height>K.y&&V.x<K.x+K.width&&V.y<K.y+K.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",K),V}getWorkingArea(V){if(V.workArea.width>0&&V.workArea.height>0)return V.workArea;if(V.bounds.width>0&&V.bounds.height>0)return V.bounds}getBounds(){const[V,J]=this._win.getPosition(),[q,K]=this._win.getSize();return{x:V,y:J,width:q,height:K}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(V){this.useNativeFullScreen()?this.setNativeFullScreen(V):this.setSimpleFullScreen(V),this.sendWhenReady(V?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(V){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(V)}setSimpleFullScreen(V){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(V),this._win.webContents.focus()}useNativeFullScreen(){const V=this.configurationService.getValue("window");return!V||typeof V.nativeFullScreen!="boolean"||V.nativeTabs?!0:V.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let V=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(V)<0&&(V="classic"),V}setMenuBarVisibility(V,J=!0){p.isMacintosh||(V==="toggle"&&J&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),V==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(V)}):this.doSetMenuBarVisibility(V))}doSetMenuBarVisibility(V){const J=this.isFullScreen;switch(V){case"classic":this._win.setMenuBarVisibility(!J),this._win.autoHideMenuBar=J;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(p.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(V,J,...q){this.isReady?this.send(V,...q):this.ready().then(()=>{J.isCancellationRequested||this.send(V,...q)})}send(V,...J){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${V}' for window that is destroyed`);return}try{this._win.webContents.send(V,...J)}catch(q){this.logService.warn(`Error sending IPC message to channel '${V}' of window ${this._id}: ${(0,C.toErrorMessage)(q)}`)}}}updateTouchBar(V){!p.isMacintosh||this.touchBarGroups.forEach((J,q)=>{const K=V[q];J.segments=this.createTouchBarGroupSegments(K)})}createTouchBar(){if(!!p.isMacintosh){for(let V=0;V<10;V++){const J=this.createTouchBarGroup();this.touchBarGroups.push(J)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(V=[]){const J=this.createTouchBarGroupSegments(V),q=new v.TouchBar.TouchBarSegmentedControl({segments:J,mode:"buttons",segmentStyle:"automatic",change:K=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:q.segments[K].id,from:"touchbar"})}});return q}createTouchBarGroupSegments(V=[]){return V.map(q=>{let K;q.icon&&!d.ThemeIcon.isThemeIcon(q.icon)&&q.icon?.dark?.scheme===m.Schemas.file&&(K=v.nativeImage.createFromPath(S.URI.revive(q.icon.dark).fsPath),K.isEmpty()&&(K=void 0));let j;return typeof q.title=="string"?j=q.title:j=q.title.value,{id:q.id,label:K?void 0:j,icon:K}})}dispose(){super.dispose(),this._win=null}};se=de([re(1,h.ILogService),re(2,M.IEnvironmentMainService),re(3,l.IFileService),re(4,r.IGlobalStorageMainService),re(5,y.IConfigurationService),re(6,b.IThemeMainService),re(7,U.IWorkspacesManagementMainService),re(8,g.IBackupMainService),re(9,u.ITelemetryService),re(10,w.IDialogMainService),re(11,o.ILifecycleMainService),re(12,s.IProductService),re(13,i.IProtocolMainService),re(14,R.IWindowsMainService)],se),e.CodeWindow=se}),define(ee[68],te([0,1,14,31,8,4,33,2,10,3,16,7,24,159,5,20,6,38,78,30,45]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let l=class ze extends P.Disposable{constructor(h,s,i,r,u){super();this.stateMainService=h,this.logService=s,this.workspacesManagementMainService=i,this.lifecycleMainService=r,this.globalStorageMainService=u,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(h=>this.addRecentlyOpened([{workspace:h.workspace,remoteAuthority:h.window.remoteAuthority}])))}async addRecentlyOpened(h){const s=[],i=[];for(let r of h)if((0,c.isRecentWorkspace)(r))!this.workspacesManagementMainService.isUntitledWorkspace(r.workspace)&&this.indexOfWorkspace(s,r.workspace)===-1&&s.push(r);else if((0,c.isRecentFolder)(r))this.indexOfFolder(s,r.folderUri)===-1&&s.push(r);else{const u=this.indexOfFile(i,r.fileUri)>=0,d=r.fileUri.scheme===f.Schemas.file&&ze.COMMON_FILES_FILTER.indexOf((0,E.basename)(r.fileUri))>=0;!u&&!d&&(i.push(r),m.isWindows&&r.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(r.fileUri.fsPath))}await this.addEntriesFromStorage(s,i),s.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(s.length=ze.MAX_TOTAL_RECENT_ENTRIES),i.length>ze.MAX_TOTAL_RECENT_ENTRIES&&(i.length=ze.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:s,files:i}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(h){const s=d=>{const b=this.location(d);for(const L of h)if(E.extUriBiasedIgnorePathCase.isEqual(L,b))return!1;return!0},i=await this.getRecentlyOpened(),r=i.workspaces.filter(s),u=i.files.filter(s);(r.length!==i.workspaces.length||u.length!==i.files.length)&&(await this.saveRecentlyOpened({files:u,workspaces:r}),this._onDidChangeRecentlyOpened.fire(),m.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(h){const s=[],i=[];if(h){const u=h.config?.workspace;(0,c.isWorkspaceIdentifier)(u)&&!this.workspacesManagementMainService.isUntitledWorkspace(u)?s.push({workspace:u,remoteAuthority:h.remoteAuthority}):(0,c.isSingleFolderWorkspaceIdentifier)(u)&&s.push({folderUri:u.uri,remoteAuthority:h.remoteAuthority})}const r=h?.config?.filesToOpenOrCreate;if(r)for(let u of r){const d=u.fileUri;d&&this.indexOfFile(i,d)===-1&&i.push({fileUri:d})}return await this.addEntriesFromStorage(s,i),{workspaces:s,files:i}}async addEntriesFromStorage(h,s){let i=await this.getRecentlyOpenedFromStorage();for(let r of i.workspaces){let u=(0,c.isRecentFolder)(r)?this.indexOfFolder(h,r.folderUri):this.indexOfWorkspace(h,r.workspace);u>=0?h[u].label=h[u].label||r.label:h.push(r)}for(let r of i.files){let u=this.indexOfFile(s,r.fileUri);u>=0?s[u].label=s[u].label||r.label:s.push(r)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let h;const s=this.globalStorageMainService.get(ze.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof s=="string")try{h=JSON.parse(s)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}else h=this.stateMainService.getItem(ze.legacyRecentlyOpenedStorageKey),h&&(this.stateMainService.removeItem(ze.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(h),0,1));return(0,c.restoreRecentlyOpened)(h,this.logService)}async saveRecentlyOpened(h){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store(ze.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,c.toStoreData)(h)),0,1)}location(h){return(0,c.isRecentFolder)(h)?h.folderUri:(0,c.isRecentFile)(h)?h.fileUri:h.workspace.configPath}indexOfWorkspace(h,s){return h.findIndex(i=>(0,c.isRecentWorkspace)(i)&&i.workspace.id===s.id)}indexOfFolder(h,s){return h.findIndex(i=>(0,c.isRecentFolder)(i)&&E.extUriBiasedIgnorePathCase.isEqual(i.folderUri,s))}indexOfFile(h,s){return h.findIndex(i=>E.extUriBiasedIgnorePathCase.isEqual(i.fileUri,s))}async handleWindowsJumpList(){!m.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!m.isWindows)return;const h=[];if(h.push({type:"tasks",items:[{type:"task",title:(0,S.localize)(0,null),description:(0,S.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let s=[];for(let u of v.app.getJumpListSettings().removedItems){const d=u.args;if(d){const b=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);b&&s.push(I.URI.parse(b[2]))}}await this.removeRecentlyOpened(s);let i=!1;const r=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,ze.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(u=>{const d=(0,c.isRecentWorkspace)(u)?u.workspace:u.folderUri,{title:b,description:L}=this.getWindowsJumpListLabel(d,u.label);let R;return I.URI.isUri(d)?R=`--folder-uri "${d.toString()}"`:(i=!0,R=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:b.substr(0,255),description:L.substr(0,255),program:process.execPath,args:R,iconPath:"explorer.exe",iconIndex:0}}));r.length>0&&h.push({type:"custom",name:i?(0,S.localize)(2,null):(0,S.localize)(3,null),items:r})}h.push({type:"recent"});try{v.app.setJumpList(h)}catch(s){this.logService.warn("updateWindowsJumpList#setJumpList",s)}}getWindowsJumpListLabel(h,s){if(s)return{title:(0,k.splitName)(s).name,description:s};if(I.URI.isUri(h))return{title:(0,E.basename)(h),description:this.renderJumpListPathDescription(h)};if(this.workspacesManagementMainService.isUntitledWorkspace(h))return{title:(0,S.localize)(4,null),description:""};let i=(0,E.basename)(h.configPath);return i.endsWith(c.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,S.localize)(5,null,i),description:this.renderJumpListPathDescription(h.configPath)}}renderJumpListPathDescription(h){return h.scheme==="file"?(0,k.normalizeDriveLetter)(h.fsPath):h.toString()}async updateMacOSRecentDocuments(){if(!m.isMacintosh)return;v.app.clearRecentDocuments();const h=await this.getRecentlyOpened(),s=[];let i=0;for(let u=0;u<h.workspaces.length&&i<ze.MAX_MACOS_DOCK_RECENT_WORKSPACES;u++){const d=this.location(h.workspaces[u]);if(d.scheme===f.Schemas.file){const b=(0,E.originalFSPath)(d);await p.Promises.exists(b)&&(s.push(b),i++)}}const r=[];for(let u=0;u<h.files.length&&i<ze.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;u++){const d=this.location(h.files[u]);if(d.scheme===f.Schemas.file){const b=(0,E.originalFSPath)(d);if(ze.COMMON_FILES_FILTER.includes((0,E.basename)(d))||s.includes(b))continue;await p.Promises.exists(b)&&(r.push(b),i++)}}r.reverse().forEach(u=>v.app.addRecentDocument(u)),s.reverse().forEach(u=>v.app.addRecentDocument(u))}};l.MAX_TOTAL_RECENT_ENTRIES=500,l.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",l.legacyRecentlyOpenedStorageKey="openedPathsList",l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l=de([re(0,w.IStateMainService),re(1,y.ILogService),re(2,a.IWorkspacesManagementMainService),re(3,g.ILifecycleMainService),re(4,M.IGlobalStorageMainService)],l),e.WorkspacesHistoryMainService=l}),define(ee[242],te([0,1,14,8,21,33,3,7,151,19,23,20,6,189,50,22,38,29,41,67,36,68]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const o="menu";let h=class bt{constructor(r,u,d,b,L,R,T,U,Q,se,ne){this.updateService=r,this.configurationService=u,this.windowsMainService=d,this.environmentMainService=b,this.telemetryService=L,this.workspacesHistoryMainService=R,this.stateMainService=T,this.lifecycleMainService=U,this.logService=Q,this.nativeHostMainService=se,this.productService=ne,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(k.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(bt.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,T,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,T,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,T,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,T,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:o}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const u=this.productService.requestFeatureUrl;u&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(u,"openUserVoiceUrl"));const d=this.productService.reportIssueUrl;d&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(d,"openReportIssues"));const b=this.productService.licenseUrl;b&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(k.language){const R=b.indexOf("?")>0?"&":"?";this.openUrl(`${b}${R}lang=${k.language}`,"openLicenseUrl")}else this.openUrl(b,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&b&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!k.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,u){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(bt.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!k.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!k.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=v.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(k.isMacintosh?new v.Menu:null);return}const u=new v.Menu;let d;if(k.isMacintosh){const L=new v.Menu;d=new v.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),u.append(d)}if(k.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new v.Menu;L.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:L});this.setMenuById(L,"File"),u.append(R)}if(this.shouldDrawMenu("Edit")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),u.append(R)}if(this.shouldDrawMenu("Selection")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),u.append(R)}if(this.shouldDrawMenu("View")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:L});this.setMenuById(L,"View"),u.append(R)}if(this.shouldDrawMenu("Go")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),u.append(R)}if(this.shouldDrawMenu("Run")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),u.append(R)}if(this.shouldDrawMenu("Terminal")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),u.append(R)}let b;if(this.shouldDrawMenu("Window")){const L=new v.Menu;b=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(b&&u.append(b),this.shouldDrawMenu("Help")){const L=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),u.append(R)}u.items&&u.items.length>0?v.Menu.setApplicationMenu(u):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const u=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),d=this.getUpdateMenuItems();let b;if(this.shouldDrawMenu("Preferences")){const V=new v.Menu;this.setMenuById(V,"Preferences"),b=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:V})}const L=new v.Menu,R=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:L}),T=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const V=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||V?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),ne=[u];ne.push(...d),b&&ne.push(s(),b),ne.push(s(),R,s(),T,U,Q,s(),se),ne.forEach(V=>r.append(V))}shouldDrawMenu(r){if(!k.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(k.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,u){u.forEach(d=>{if((0,S.isMenubarMenuItemSeparator)(d))r.append(s());else if((0,S.isMenubarMenuItemSubmenu)(d)){const b=new v.Menu,L=new v.MenuItem({label:this.mnemonicLabel(d.label),submenu:b});this.setMenu(b,d.submenu.items),r.append(L)}else(0,S.isMenubarMenuItemRecentAction)(d)?r.append(this.createOpenRecentMenuItem(d)):(0,S.isMenubarMenuItemAction)(d)&&(d.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),k.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[d.id]?r.append(new v.MenuItem(this.likeAction(d.id,{label:this.mnemonicLabel(d.label),click:this.fallbackMenuHandlers[d.id]}))):r.append(this.createMenuItem(d.label,d.id,!1,d.checked)):r.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)):r.append(this.createMenuItem(d.label,d.id,d.enabled!==!1,!!d.checked)))})}setMenuById(r,u){this.menubarMenus&&this.menubarMenus[u]&&this.setMenu(r,this.menubarMenus[u].items)}insertCheckForUpdatesItems(r){const u=this.getUpdateMenuItems();u.length&&(u.forEach(d=>r.append(d)),r.append(s()))}createOpenRecentMenuItem(r){const u=P.URI.revive(r.uri),d=r.id,b=d==="openRecentFile"?{fileUri:u}:d==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new v.MenuItem(this.likeAction(d,{label:r.label,click:(L,R,T)=>{const U=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[b],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([u])}},!1))}isOptionClick(r){return!!(r&&(!k.isMacintosh&&(r.ctrlKey||r.shiftKey)||k.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,u,d){const b={label:this.mnemonicLabel(r),role:d,enabled:!0};return new v.MenuItem(this.withKeybinding(u,b))}setMacWindowMenu(r){const u=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),d=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),b=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(s()),R.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,d,s(),L,...R,s(),b].forEach(T=>r.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,u,d,b){const L=this.mnemonicLabel(r),R=typeof u=="function"?u:(ne,V,J)=>{const q=ne?ne.userSettingsLabel:null;let K=u;Array.isArray(u)&&(K=this.isOptionClick(J)?u[1]:u[0]),q&&J.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:q}):this.runActionInRenderer({type:"commandId",commandId:K})},T=typeof d=="boolean"?d:this.windowsMainService.getWindowCount()>0,U=typeof b=="boolean"?b:!1,Q={label:L,click:R,enabled:T};U&&(Q.type="checkbox",Q.checked=U);let se;return typeof u=="string"?se=u:Array.isArray(u)&&(se=u[0]),k.isMacintosh&&(se==="editor.action.clipboardCutAction"?Q.role="cut":se==="editor.action.clipboardCopyAction"?Q.role="copy":se==="editor.action.clipboardPasteAction"&&(Q.role="paste"),se==="undo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(R,{inDevTools:ne=>ne.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(se,Q))}makeContextAwareClickHandler(r,u){return(d,b,L)=>{const R=v.BrowserWindow.getFocusedWindow();if(!R)return u.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return u.inDevTools(R.webContents.devToolsWebContents);r(d,b||R,L)}}runActionInRenderer(r){let u=v.BrowserWindow.getFocusedWindow();if(!u){const b=this.windowsMainService.getLastActiveWindow();b?.isMinimized()&&(u=b.win)}const d=u?this.windowsMainService.getWindowById(u.id):void 0;if(d){if(this.logService.trace("menubar#runActionInRenderer",r),k.isMacintosh&&!this.environmentMainService.isBuilt&&!d.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const b={id:r.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",D.CancellationToken.None,b)}else{const b={userSettingsLabel:r.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,b)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,u){const d=typeof r=="string"?this.keybindings[r]:void 0;if(d?.label){if(d.isNative!==!1)u.accelerator=d.label,u.userSettingsLabel=d.userSettingsLabel;else if(typeof u.label=="string"){const b=u.label.indexOf("[");b>=0?u.label=`${u.label.substr(0,b)} [${d.label}]`:u.label=`${u.label} [${d.label}]`}}else u.accelerator=void 0;return u}likeAction(r,u,d=!u.accelerator){d&&(u=this.withKeybinding(r,u));const b=u.click;return u.click=(L,R,T)=>{this.reportMenuActionTelemetry(r),b&&b(L,R,T)},u}openUrl(r,u){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(u)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:o})}mnemonicLabel(r){return(0,C.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};h.lastKnownMenubarStorageKey="lastKnownMenubarData",h=de([re(0,M.IUpdateService),re(1,m.IConfigurationService),re(2,a.IWindowsMainService),re(3,E.IEnvironmentMainService),re(4,w.ITelemetryService),re(5,l.IWorkspacesHistoryMainService),re(6,y.IStateMainService),re(7,I.ILifecycleMainService),re(8,p.ILogService),re(9,t.INativeHostMainService),re(10,g.IProductService)],h),e.Menubar=h;function s(){return new v.MenuItem({type:"separator"})}}),define(ee[243],te([0,1,5,20,6,242]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let k=class{constructor(f,m,E){this.instantiationService=f,this.lifecycleMainService=m,this.logService=E,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(f,m){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(m,f)}};k=de([re(0,v.IInstantiationService),re(1,n.ILifecycleMainService),re(2,D.ILogService)],k),e.MenubarMainService=k}),define(ee[244],te([0,1,14,28,26,31,21,4,27,42,33,2,10,9,63,3,34,16,13,7,157,52,19,49,23,18,5,20,6,55,22,56,64,38,67,241,99,223,30,100,68,45]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o,h,s,i,r,u,d,b,L,R,T,U,Q,se,ne,V,J,q,K,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function B(H){return(0,J.isWorkspaceIdentifier)(H?.workspace)}function $(H){return(0,J.isSingleFolderWorkspaceIdentifier)(H?.workspace)}let Y=class it extends I.Disposable{constructor(F,W,A,_,N,O,z,x,ie,oe,Z,ce,le,he,ge){super();this.machineId=F,this.initialUserEnv=W,this.logService=A,this.stateMainService=_,this.environmentMainService=N,this.lifecycleMainService=O,this.backupMainService=z,this.configurationService=x,this.workspacesHistoryMainService=ie,this.workspacesManagementMainService=oe,this.instantiationService=Z,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=ge,this._onDidOpenWindow=this._register(new P.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new P.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new P.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new P.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new V.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const W=new I.DisposableStore;if(W.add(P.Event.any(F.onDidClose,F.onDidDestroy)(()=>W.dispose())),F.config.extensionDevelopmentPath)for(const A of F.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(c.URI.file(A)));F.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(c.URI.file(F.config.extensionTestsPath)))}}))}openEmptyWindow(F,W){let A=this.environmentMainService.args;const _=W?.remoteAuthority||void 0,N=!0,O=W?.forceReuseWindow,z=!O;return this.open({...F,cli:A,forceEmpty:N,forceNewWindow:z,forceReuseWindow:O,remoteAuthority:_})}openExistingWindow(F,W){F.focus(),this.handleWaitMarkerFile(W,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const W=[],A=[],_=[],N=[],O=[];let z,x=0;const ie=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ie);for(const le of ie)$(le)?F.addMode?W.push(le):A.push(le):B(le)?_.push(le):le.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),z.filesToOpenOrCreate.push(le)):le.backupPath?O.push({backupFolder:(0,S.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):x++;F.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),z&&F.waitMarkerFileURI&&(z.filesToWait={paths:[...z.filesToDiff,...z.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(N.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),_.push(...N),O.push(...this.backupMainService.getEmptyWindowBackupPaths())):O.length=0;const{windows:oe,filesOpenedInWindow:Z}=this.doOpen(F,_,A,O,x,z,W);if(this.logService.trace(`windowsManager#open used window count ${oe.length} (workspacesToOpen: ${_.length}, foldersToOpen: ${A.length}, emptyToRestore: ${O.length}, emptyToOpen: ${x})`),oe.length>1)if(Z)Z.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let he=!0,ge=!0;if(le){const be=oe.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),he=!1,ge=!1)}if(he)for(let be=oe.length-1;be>=0;be--){const fe=oe[be];if(!(fe.openedWorkspace&&N.some(me=>fe.openedWorkspace&&me.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&O.some(me=>fe.backupPath&&me.backupFolder===(0,S.basename)(fe.backupPath)))){fe.focus(),ge=!1;break}}ge&&oe[oe.length-1].focus()}const ce=z&&z.filesToDiff.length>0;if(!oe.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!F.noRecentEntry){const le=[];for(const he of ie)B(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):$(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(F,oe),oe}handleWaitMarkerFile(F,W){const A=F.waitMarkerFileURI;F.context===0&&A&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(A)}catch{}})()}doOpen(F,W,A,_,N,O,z){const x=[];let ie;function oe(fe,me){x.push(fe),me&&(ie=fe,O=void 0)}let{openFolderInNewWindow:Z,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&z.length>0){const fe=z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(fe);me&&oe(this.doAddFoldersToExistingWindow(me,z.map(Se=>Se.workspace.uri)))}const le=A.length+W.length+_.length;if(O&&le===0){const fe=O.filesToOpenOrCreate[0]||O.filesToDiff[0],me=this.getWindows().filter(Pe=>O&&(0,w.isEqualAuthority)(Pe.remoteAuthority,O.remoteAuthority));let Se;fe?.fileUri&&!ce&&((F.context===4||F.context===0||F.context===1)&&(Se=(0,ne.findWindowOnFile)(me,fe.fileUri,Pe=>Pe.configPath.scheme===p.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Pe.configPath):void 0)),Se||(Se=this.doGetLastActiveWindow(me))),Se?(0,J.isWorkspaceIdentifier)(Se.openedWorkspace)?W.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):(0,J.isSingleFolderWorkspaceIdentifier)(Se.openedWorkspace)?A.push({workspace:Se.openedWorkspace,remoteAuthority:Se.remoteAuthority}):oe(this.doOpenFilesInExistingWindow(F,Se,O),!0):oe(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:O,forceNewWindow:!0,remoteAuthority:O.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const he=(0,C.distinct)(W,fe=>fe.workspace.id);if(he.length>0){const fe=(0,C.coalesce)(he.map(me=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(fe.length>0){const me=fe[0],Se=(0,w.isEqualAuthority)(O?.remoteAuthority,me.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(F,me,Se),!!Se),Z=!0}he.forEach(me=>{if(fe.some(Me=>Me.openedWorkspace&&Me.openedWorkspace.id===me.workspace.id))return;const Se=me.remoteAuthority,Pe=(0,w.isEqualAuthority)(O?.remoteAuthority,Se)?O:void 0;oe(this.doOpenFolderOrWorkspace(F,me,Z,Pe),!!Pe),Z=!0})}const ge=(0,C.distinct)(A,fe=>w.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(ge.length>0){const fe=(0,C.coalesce)(ge.map(me=>(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(fe.length>0){const me=fe[0],Se=(0,w.isEqualAuthority)(O?.remoteAuthority,me.remoteAuthority)?O:void 0;oe(this.doOpenFilesInExistingWindow(F,me,Se),!!Se),Z=!0}ge.forEach(me=>{if(fe.some(Me=>(0,J.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(Me.openedWorkspace.uri,me.workspace.uri)))return;const Se=me.remoteAuthority,Pe=(0,w.isEqualAuthority)(O?.remoteAuthority,Se)?O:void 0;oe(this.doOpenFolderOrWorkspace(F,me,Z,Pe),!!Pe),Z=!0})}const be=(0,C.distinct)(_,fe=>fe.backupFolder);if(be.length>0&&be.forEach(fe=>{const me=fe.remoteAuthority,Se=(0,w.isEqualAuthority)(O?.remoteAuthority,me)?O:void 0;oe(this.doOpenEmpty(F,!0,me,Se,fe),!!Se),Z=!0}),x.length===0||O){O&&!N&&N++;const fe=O?O.remoteAuthority:F.remoteAuthority;for(let me=0;me<N;me++)oe(this.doOpenEmpty(F,Z,fe,O),!!O),Z=!0}return{windows:(0,C.distinct)(x),filesOpenedInWindow:ie}}doOpenFilesInExistingWindow(F,W,A){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:A}),W.focus();const _={filesToOpenOrCreate:A?.filesToOpenOrCreate,filesToDiff:A?.filesToDiff,filesToWait:A?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",k.CancellationToken.None,_),W}doAddFoldersToExistingWindow(F,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),F.focus();const A={foldersToAdd:W};return F.sendWhenReady("vscode:addFolders",k.CancellationToken.None,A),F}doOpenEmpty(F,W,A,_,N){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!N,remoteAuthority:A,filesToOpen:_,forceNewWindow:W});let O;return!W&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:A,forceNewWindow:W,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:_,windowToUse:O,emptyWindowBackupInfo:N})}doOpenFolderOrWorkspace(F,W,A,_,N){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:_}),!A&&!N&&typeof F.contextWindowId=="number"&&(N=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:A,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:_,windowToUse:N})}getPathsToOpen(F){let W,A=!1,_=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(F),A=!0):F.forceEmpty?W=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(W=this.doExtractPathsFromCLI(F.cli),W.length===0&&W.push(Object.create(null)),A=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),_=!0),!F.addMode&&A){const N=W.filter(O=>$(O));if(N.length>1){const O=N[0].remoteAuthority;if(N.every(z=>(0,w.isEqualAuthority)(z.remoteAuthority,O))){const z=this.workspacesManagementMainService.createUntitledWorkspaceSync(N.map(x=>({uri:x.workspace.uri})));W.push({workspace:z,remoteAuthority:O}),W=W.filter(x=>!$(x))}}}return F.initialStartup&&!_&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(N=>B(N)||$(N)||N.backupPath)),W}doExtractPathsFromAPI(F){const W=[],A={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const _ of(0,C.coalesce)(F.urisToOpen||[])){const N=this.resolveOpenable(_,A);if(N)N.label=_.label,W.push(N);else{const O=this.resourceFromOpenable(_),z={title:this.productService.nameLong,type:"info",buttons:[(0,E.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:O.scheme===p.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:O.scheme===p.Schemas.file?(0,a.localize)(3,null,(0,E.getPathLabel)(O.fsPath,this.environmentMainService)):(0,a.localize)(4,null,O.toString()),noLink:!0};this.dialogMainService.showMessageBox(z,(0,M.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(F){const W=[],A={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},_=F["folder-uri"];if(_)for(const z of _){const x=this.cliArgToUri(z);if(x){const ie=this.resolveOpenable({folderUri:x},A);ie&&W.push(ie)}}const N=F["file-uri"];if(N)for(const z of N){const x=this.cliArgToUri(z);if(x){const ie=this.resolveOpenable((0,J.hasWorkspaceFileExtension)(z)?{workspaceUri:x}:{fileUri:x},A);ie&&W.push(ie)}}const O=F._;for(const z of O){const x=A.remoteAuthority?this.doResolvePathRemote(z,A):this.doResolveFilePath(z,A);x&&W.push(x)}return W}cliArgToUri(F){try{const W=c.URI.parse(F);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${F}, ${W.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];F!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const A=[];for(const _ of W)if(_.workspace){const N=this.resolveOpenable({workspaceUri:_.workspace.configPath},{remoteAuthority:_.remoteAuthority,rejectTransientWorkspaces:!0});B(N)&&A.push(N)}else if(_.folderUri){const N=this.resolveOpenable({folderUri:_.folderUri},{remoteAuthority:_.remoteAuthority});$(N)&&A.push(N)}else F!=="folders"&&_.backupPath&&A.push({backupPath:_.backupPath,remoteAuthority:_.remoteAuthority});return A}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,W=Object.create(null)){let A=this.resourceFromOpenable(F);return A.scheme===p.Schemas.file?((0,Q.isFileToOpen)(F)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(A.fsPath,W)):this.doResolveRemoteOpenable(F,W)}doResolveRemoteOpenable(F,W){let A=this.resourceFromOpenable(F);const _=(0,T.getRemoteAuthority)(A)||W.remoteAuthority;if(A=(0,w.removeTrailingPathSeparator)((0,w.normalizePath)(A)),(0,Q.isFileToOpen)(F)){if(W.gotoLineMode){const{path:N,line:O,column:z}=(0,f.parseLineAndColumnAware)(A.path);return{fileUri:A.with({path:N}),selection:O?{startLineNumber:O,startColumn:z||1}:void 0,remoteAuthority:_}}return{fileUri:A,remoteAuthority:_}}else if((0,Q.isWorkspaceToOpen)(F))return{workspace:(0,q.getWorkspaceIdentifier)(A),remoteAuthority:_};return{workspace:(0,q.getSingleFolderWorkspaceIdentifier)(A),remoteAuthority:_}}resourceFromOpenable(F){return(0,Q.isWorkspaceToOpen)(F)?F.workspaceUri:(0,Q.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,W){let A,_;W.gotoLineMode&&({path:F,line:A,column:_}=(0,f.parseLineAndColumnAware)(F)),F=(0,f.sanitizeFilePath)((0,S.normalize)(F),(0,y.cwd)());try{const N=(0,n.statSync)(F);if(N.isFile()){if(!W.forceOpenWorkspaceAsFile){const O=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(F));if(O)return O.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:O.id,configPath:O.configPath},type:i.FileType.File,exists:!0,remoteAuthority:O.remoteAuthority,transient:O.transient}}return{fileUri:c.URI.file(F),type:i.FileType.File,exists:!0,selection:A?{startLineNumber:A,startColumn:_||1}:void 0}}else{if(N.isDirectory())return{workspace:(0,q.getSingleFolderWorkspaceIdentifier)(c.URI.file(F),N),type:i.FileType.Directory,exists:!0};if(!g.isWindows&&F==="/dev/null")return{fileUri:c.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const O=c.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([O]),W.ignoreFileNotFound)return{fileUri:O,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,W){const A=F.charCodeAt(0),_=W.remoteAuthority;let N,O;W.gotoLineMode&&({path:F,line:N,column:O}=(0,f.parseLineAndColumnAware)(F)),A!==47&&((0,f.isWindowsDriveLetter)(A)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,f.toSlashes)(F)),F=`/${F}`);const z=c.URI.from({scheme:p.Schemas.vscodeRemote,authority:_,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,J.hasWorkspaceFileExtension)(F))return W.forceOpenWorkspaceAsFile?{fileUri:z,selection:N?{startLineNumber:N,startColumn:O||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,q.getWorkspaceIdentifier)(z),remoteAuthority:_};if(W.gotoLineMode||S.posix.basename(F).indexOf(".")!==-1)return{fileUri:z,selection:N?{startLineNumber:N,startColumn:O||1}:void 0,remoteAuthority:_}}return{workspace:(0,q.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:_}}shouldOpenNewWindow(F){const W=this.configurationService.getValue("window"),A=W?.openFoldersInNewWindow||"default",_=W?.openFilesInNewWindow||"off";let N=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(A==="on"||A==="off")&&(N=A==="on");let O=!1;return F.forceNewWindow||F.forceReuseWindow?O=!!F.forceNewWindow&&!F.forceReuseWindow:(g.isMacintosh?F.context===1&&(O=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(O=!0),!F.cli.extensionDevelopmentPath&&(_==="on"||_==="off")&&(O=_==="on")),{openFolderInNewWindow:!!N,openFilesInNewWindow:O}}openExtensionDevelopmentHostWindow(F,W){const A=(0,ne.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(A)return this.lifecycleMainService.reload(A,W.cli),A.focus(),[A];let _=W.cli["folder-uri"]||[],N=W.cli["file-uri"]||[],O=W.cli._;if(!O.length&&!_.length&&!N.length&&!W.cli.extensionTestsPath){const oe=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,Z=oe&&(oe.workspace||oe.folderUri);Z&&(c.URI.isUri(Z)?Z.scheme===p.Schemas.file?O=[Z.fsPath]:_=[Z.toString()]:Z.configPath.scheme===p.Schemas.file?O=[(0,w.originalFSPath)(Z.configPath)]:N=[Z.configPath.toString()])}let z=W.remoteAuthority;for(const oe of F)if(oe.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const Z=c.URI.parse(oe),ce=(0,T.getRemoteAuthority)(Z);ce&&(z?(0,w.isEqualAuthority)(ce,z)||this.logService.error("more than one extension development path authority"):z=ce)}O=O.filter(oe=>{const Z=c.URI.file(oe);return(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(Z),z)}),_=_.filter(oe=>{const Z=this.cliArgToUri(oe);return Z&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(Z),z):!1}),N=N.filter(oe=>{const Z=this.cliArgToUri(oe);return Z&&!!(0,ne.findWindowOnWorkspaceOrFolder)(this.getWindows(),Z)?!1:Z?(0,w.isEqualAuthority)((0,T.getRemoteAuthority)(Z),z):!1}),W.cli._=O,W.cli["folder-uri"]=_,W.cli["file-uri"]=N;const x=!O.length&&!_.length&&!N.length,ie={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:x,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:z};return this.open(ie)}openInBrowserWindow(F){const W=this.configurationService.getValue("window"),A={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:b.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let _;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(_=F.windowToUse||this.getLastActiveWindow(),_&&_.focus()),_){const N=_.config;!A.extensionDevelopmentPath&&N&&!!N.extensionDevelopmentPath&&(A.extensionDevelopmentPath=N.extensionDevelopmentPath,A.verbose=N.verbose,A["inspect-brk-extensions"]=N["inspect-brk-extensions"],A.debugId=N.debugId,A.extensionEnvironment=N.extensionEnvironment,A["inspect-extensions"]=N["inspect-extensions"],A["extensions-dir"]=N["extensions-dir"])}else{const N=this.windowsStateHandler.getNewWindowState(A);(0,t.mark)("code/willCreateCodeWindow");const O=_=this.instantiationService.createInstance(se.CodeWindow,{state:N,extensionDevelopmentPath:A.extensionDevelopmentPath,isExtensionTestHost:!!A.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const x=this.getLastActiveWindow();x&&x.addTabbedWindow(O)}it.WINDOWS.push(O),this._onDidOpenWindow.fire(O),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.once)(O.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(O)),(0,m.once)(O.onDidClose)(()=>this.onWindowClosed(O)),(0,m.once)(O.onDidDestroy)(()=>this._onDidDestroyWindow.fire(O));const z=(0,M.assertIsDefined)(O.win?.webContents);z.removeAllListeners("devtools-reload-page"),z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(O)),this.lifecycleMainService.registerWindow(O)}return A.windowId=_.id,_.isReady?this.lifecycleMainService.unload(_,4).then(N=>{N||this.doOpenInBrowserWindow(_,A,F)}):this.doOpenInBrowserWindow(_,A,F),_}doOpenInBrowserWindow(F,W,A){if(!W.extensionDevelopmentPath)if((0,J.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,J.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority});else{const _=A.emptyWindowBackupInfo&&A.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(_,W.remoteAuthority)}F.load(W)}onWindowClosed(F){const W=it.WINDOWS.indexOf(F);it.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=v.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,w.isEqualAuthority)(W.remoteAuthority,F)))}doGetLastActiveWindow(F){const W=Math.max.apply(Math,F.map(A=>A.lastFocusTime));return F.find(A=>A.lastFocusTime===W)}sendToFocused(F,...W){const A=this.getFocusedWindow()||this.getLastActiveWindow();A&&A.sendWhenReady(F,k.CancellationToken.None,...W)}sendToAll(F,W,A){for(const _ of this.getWindows())A&&A.indexOf(_.id)>=0||_.sendWhenReady(F,k.CancellationToken.None,W)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(F){const W=this.getWindows().filter(A=>A.id===F);return(0,C.firstOrDefault)(W)}getWindowByWebContents(F){const W=v.BrowserWindow.fromWebContents(F);if(!!W)return this.getWindowById(W.id)}};Y.WINDOWS=[],Y=de([re(2,d.ILogService),re(3,U.IStateMainService),re(4,s.IEnvironmentMainService),re(5,u.ILifecycleMainService),re(6,l.IBackupMainService),re(7,o.IConfigurationService),re(8,K.IWorkspacesHistoryMainService),re(9,j.IWorkspacesManagementMainService),re(10,r.IInstantiationService),re(11,h.IDialogMainService),re(12,i.IFileService),re(13,L.IProductService),re(14,R.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(ee[245],te([0,1,52,36,68,45]),function(G,e,v,n,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(f,m,E,I){this.workspacesManagementMainService=f,this.windowsMainService=m,this.workspacesHistoryMainService=E,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,m){const E=this.windowsMainService.getWindowById(f);if(E)return this.workspacesManagementMainService.enterWorkspace(E,this.windowsMainService.getWindows(),m)}createUntitledWorkspace(f,m,E){return this.workspacesManagementMainService.createUntitledWorkspace(m,E)}deleteUntitledWorkspace(f,m){return this.workspacesManagementMainService.deleteUntitledWorkspace(m)}getWorkspaceIdentifier(f,m){return this.workspacesManagementMainService.getWorkspaceIdentifier(m)}getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}addRecentlyOpened(f,m){return this.workspacesHistoryMainService.addRecentlyOpened(m)}removeRecentlyOpened(f,m){return this.workspacesHistoryMainService.removeRecentlyOpened(m)}clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=de([re(0,C.IWorkspacesManagementMainService),re(1,n.IWindowsMainService),re(2,D.IWorkspacesHistoryMainService),re(3,v.IBackupMainService)],k),e.WorkspacesMainService=k}),define(ee[246],te([0,1,14,28,26,17,39,15,27,42,43,33,2,10,9,3,13,7,32,71,123,37,126,86,237,136,52,227,19,165,74,49,228,89,23,54,91,173,190,174,224,90,175,176,18,185,94,73,5,75,238,203,101,20,6,187,243,50,22,64,233,76,38,221,78,204,29,206,208,65,41,212,235,239,236,240,98,213,214,215,216,218,36,244,219,30,68,245,45]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o,h,s,i,r,u,d,b,L,R,T,U,Q,se,ne,V,J,q,K,j,B,$,Y,H,F,W,A,_,N,O,z,x,ie,oe,Z,ce,le,he,ge,be,fe,me,Se,Pe,Me,Te,Oe,Be,He,wt,at,ct,lt,Ve,je,X,ae,ue,pe,Ie,Re,_e,Ke,Ne,We,$e,qe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ye=class extends p.Disposable{constructor(we,ye,Ee,ve,ke,De,Ce,Ae,Fe,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=Ee,this.logService=ve,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Ce,this.stateMainService=Ae,this.fileService=Fe,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=ve=>ve?.startsWith(`${S.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((ve,ke,De,Ce)=>we(Ce.requestingUrl)?De(ye.has(ke)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((ve,ke,De,Ce)=>we(Ce.requestingUrl)?ye.has(ke):!1);const Ee=v.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,P.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,P.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,P.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,a.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Ee,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),v.app.on("activate",(Ee,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Ee,ve)=>{ve.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),ve.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let we=[],ye;v.app.on("open-file",(Ee,ve)=>{this.logService.trace("app#open-file: ",ve),Ee.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const ve=this.windowsMainService?.getWindowByWebContents(Ee.sender);let ke,De;return ve?.config?(ke=ve.config,De={...process.env,...ve.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(ke,De,!1)}),v.ipcMain.handle("vscode:writeNlsFile",(Ee,ve,ke)=>{const De=this.validateNlsPath([ve]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(ke))}),v.ipcMain.handle("vscode:readNlsFile",async(Ee,...ve)=>{const ke=this.validateNlsPath(ve);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(we){let ye;for(const Ee of we)typeof Ee=="string"&&(typeof ye!="string"?ye=Ee:ye=(0,t.join)(ye,Ee));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,f.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return w.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;g.isWindows&&we&&v.app.setAppUserModelId(we);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Fe){this.logService.error(Fe)}const ye=new o.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:ve,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(Ee),Ce=await this.initServices(Ee,ve,ke);if(this.environmentMainService.driverHandle){const Fe=await(0,T.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Ce);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Fe)}this._register(Ce.createInstance(s.ProxyAuthHandler)),Ce.invokeFunction(Fe=>this.initChannels(Fe,ye,De));const Ae=Ce.invokeFunction(Fe=>this.openFirstWindow(Fe,ye));Ce.invokeFunction(Fe=>this.afterWindowOpen(Fe,ve)),this.environmentMainService.args.trace&&Ce.invokeFunction(Fe=>this.stopTracingEventually(Fe,Ae))}async resolveMachineId(){let we=this.stateMainService.getItem(Me.machineIdKey);return(!we||g.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,c.getMachineId)(),this.stateMainService.setItem(Me.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(ge.SharedProcess,we,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new h.Client(ke,"main")})(),ve=(async()=>(await ye.whenReady(),Ee))();return{sharedProcess:ye,sharedProcessReady:ve,sharedProcessClient:Ee}}async initServices(we,ye,Ee){const ve=new _.ServiceCollection;switch(process.platform){case"win32":ve.set(He.IUpdateService,new W.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":g.isLinuxSnap?ve.set(He.IUpdateService,new W.SyncDescriptor(lt.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(He.IUpdateService,new W.SyncDescriptor(ct.LinuxUpdateService));break;case"darwin":ve.set(He.IUpdateService,new W.SyncDescriptor(at.DarwinUpdateService));break}ve.set(Re.IWindowsMainService,new W.SyncDescriptor(_e.WindowsMainService,[we,this.userEnv])),ve.set(R.IDialogMainService,new W.SyncDescriptor(R.DialogMainService)),ve.set(z.ILaunchMainService,new W.SyncDescriptor(z.LaunchMainService)),ve.set(L.IDiagnosticsService,l.ProxyChannel.toService((0,l.getDelayedChannel)(Ee.then(De=>De.getChannel("diagnostics"))))),ve.set(N.IIssueMainService,new W.SyncDescriptor(N.IssueMainService,[this.userEnv])),ve.set(U.IEncryptionMainService,new W.SyncDescriptor(U.EncryptionMainService,[we])),ve.set(O.IKeyboardLayoutMainService,new W.SyncDescriptor(O.KeyboardLayoutMainService)),ve.set(ce.INativeHostMainService,new W.SyncDescriptor(ce.NativeHostMainService,[ye])),ve.set(pe.IWebviewManagerService,new W.SyncDescriptor(Ie.WebviewMainService)),ve.set(Ne.IWorkspacesService,new W.SyncDescriptor($e.WorkspacesMainService)),ve.set(qe.IWorkspacesManagementMainService,new W.SyncDescriptor(qe.WorkspacesManagementMainService)),ve.set(We.IWorkspacesHistoryMainService,new W.SyncDescriptor(We.WorkspacesHistoryMainService)),ve.set(Z.IMenubarMainService,new W.SyncDescriptor(Z.MenubarMainService)),ve.set(V.IExtensionUrlTrustService,new W.SyncDescriptor(J.ExtensionUrlTrustService)),ve.set(q.IExtensionHostStarter,new W.SyncDescriptor(K.WorkerMainProcessExtensionHostStarter)),ve.set(Se.IStorageMainService,new W.SyncDescriptor(Se.StorageMainService)),ve.set(Se.IGlobalStorageMainService,new W.SyncDescriptor(Se.GlobalStorageMainService)),g.isWindows?ve.set(j.IExternalTerminalMainService,new W.SyncDescriptor(B.WindowsExternalTerminalService)):g.isMacintosh?ve.set(j.IExternalTerminalMainService,new W.SyncDescriptor(B.MacExternalTerminalService)):g.isLinux&&ve.set(j.IExternalTerminalMainService,new W.SyncDescriptor(B.LinuxExternalTerminalService));const ke=new u.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(r.IBackupMainService,ke),ve.set(je.IURLService,new W.SyncDescriptor(ae.NativeURLService)),(0,Be.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,l.getDelayedChannel)(Ee.then(Je=>Je.getChannel("telemetryAppender"))),Ce=new Te.TelemetryAppenderClient(De),Ae=(0,Pe.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Fe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Ce],commonProperties:Ae,piiPaths:Fe,sendErrorTelemetry:!0};ve.set(Me.ITelemetryService,new W.SyncDescriptor(Oe.TelemetryService,[Xe]))}else ve.set(Me.ITelemetryService,Be.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,ye,Ee){const ve=l.ProxyChannel.fromService(we.get(z.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const ke=this.fileService.getProvider(S.Schemas.file);(0,y.assertType)(ke instanceof F.DiskFileSystemProvider);const De=new H.DiskFileSystemProviderChannel(ke,this.logService);ye.registerChannel($.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De),Ee.then(Le=>Le.registerChannel($.LOCAL_FILE_SYSTEM_CHANNEL_NAME,De));const Ce=new wt.UpdateChannel(we.get(He.IUpdateService));ye.registerChannel("update",Ce);const Ae=l.ProxyChannel.fromService(we.get(N.IIssueMainService));ye.registerChannel("issue",Ae);const Fe=l.ProxyChannel.fromService(we.get(U.IEncryptionMainService));ye.registerChannel("encryption",Fe);const Xe=l.ProxyChannel.fromService(we.get(be.ISignService));ye.registerChannel("sign",Xe);const Je=l.ProxyChannel.fromService(we.get(O.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Je),this.nativeHostMainService=we.get(ce.INativeHostMainService);const Ze=l.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",Ze),Ee.then(Le=>Le.registerChannel("nativeHost",Ze));const nt=l.ProxyChannel.fromService(we.get(Ne.IWorkspacesService));ye.registerChannel("workspaces",nt);const pt=l.ProxyChannel.fromService(we.get(Z.IMenubarMainService));ye.registerChannel("menubar",pt);const Ue=l.ProxyChannel.fromService(we.get(je.IURLService));ye.registerChannel("url",Ue);const ht=l.ProxyChannel.fromService(we.get(V.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",ht);const rt=l.ProxyChannel.fromService(we.get(pe.IWebviewManagerService));ye.registerChannel("webview",rt);const xe=this._register(new me.StorageDatabaseChannel(this.logService,we.get(Se.IStorageMainService)));ye.registerChannel("storage",xe),Ee.then(Le=>Le.registerChannel("storage",xe));const dt=l.ProxyChannel.fromService(we.get(j.IExternalTerminalMainService));ye.registerChannel("externalTerminal",dt);const st=new oe.LogLevelChannel(we.get(ie.ILogService));ye.registerChannel("logLevel",st),Ee.then(Le=>Le.registerChannel("logLevel",st));const et=new oe.LoggerChannel(we.get(ie.ILoggerService));ye.registerChannel("logger",et),Ee.then(Le=>Le.registerChannel("logger",et));const ot=new b.ElectronExtensionHostDebugBroadcastChannel(we.get(Re.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ot);const ft=l.ProxyChannel.fromService(we.get(q.IExtensionHostStarter));ye.registerChannel(q.ipcExtensionHostStarterChannelName,ft)}openFirstWindow(we,ye){const Ee=this.windowsMainService=we.get(Re.IWindowsMainService),ve=we.get(je.IURLService),ke=we.get(ce.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Ce=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Le=>{try{return{uri:w.URI.parse(Le),url:Le}}catch{return}}).filter(Le=>{if(!Le||this.shouldBlockURI(Le.uri))return!1;const tt=this.getWindowOpenableFromProtocolLink(Le.uri);return tt?(De.push(tt),!1):!0}),Ae=this,Fe=this.environmentMainService,Xe=this.productService;ve.registerHandler({async handleURL(Le,tt){if(Le.scheme===Xe.urlProtocol&&Le.path==="workspace"&&(Le=Le.with({authority:"file",path:w.URI.parse(Le.query).path,query:""})),Ae.shouldBlockURI(Le))return!0;const Et=Ae.getWindowOpenableFromProtocolLink(Le);if(Et){const[vt]=Ee.open({context:5,cli:{...Fe.args},urisToOpen:[Et],gotoLineMode:!0});return vt.focus(),!0}if(g.isMacintosh&&Ee.getWindowCount()===0){const[vt]=Ee.open({context:5,cli:{...Fe.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,he.getRemoteAuthority)(Le)});return await vt.ready(),ve.open(Le,tt)}return!1}});const Je=this._register(new Ke.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Ze=new l.StaticRouter(Le=>Je.getActiveClientId().then(tt=>Le===tt)),nt=new X.URLHandlerRouter(Ze),pt=ye.getChannel("urlHandler",nt);ve.registerHandler(new X.URLHandlerChannelClient(pt)),this._register(new ue.ElectronURLListener(Ce,ve,Ee,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ht=global.macOpenFiles,rt=(0,se.isLaunchedFromCli)(process.env)?0:4,xe=Ue._.length,dt=!!Ue["folder-uri"],st=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,ot=Ue.wait&&Ue.waitMarkerFilePath?w.URI.file(Ue.waitMarkerFilePath):void 0,ft=Ue.remote||void 0;return De.length>0?Ee.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!xe&&!dt&&!st?Ee.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:ot,initialStartup:!0,remoteAuthority:ft}):ht.length&&!xe&&!dt&&!st?Ee.open({context:1,cli:Ue,urisToOpen:ht.map(Le=>this.getWindowOpenableFromPathSync(Le)),noRecentEntry:et,waitMarkerFileURI:ot,initialStartup:!0}):Ee.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!xe&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:ot,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ft})}shouldBlockURI(we){return!!(we.authority===S.Schemas.file&&g.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,I.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===S.Schemas.file){const ye=w.URI.file(we.fsPath);return(0,Ne.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===S.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const Ee=we.path.substring(1,ye),ve=we.path.substring(ye),ke=w.URI.from({scheme:S.Schemas.vscodeRemote,authority:Ee,path:ve,query:we.query,fragment:we.fragment});return(0,Ne.hasWorkspaceFileExtension)(ve)?{workspaceUri:ke}:/:[\d]+$/.test(ve)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(we){try{if((0,n.statSync)(we).isDirectory())return{folderUri:w.URI.file(we)};if((0,Ne.hasWorkspaceFileExtension)(we))return{workspaceUri:w.URI.file(we)}}catch{}return{fileUri:w.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let Ee=!1;(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const ve=we.get(Me.ITelemetryService);this._register(ye.onDidError(({type:Ce,details:Ae})=>{let Fe;switch(Ce){case 1:Fe="SharedProcess: detected unresponsive window";break;case 2:Fe=`SharedProcess: crashed (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break;case 3:Fe=`SharedProcess: failed to load (detail: ${Ae?.reason??"<unknown>"}, code: ${Ae?.exitCode??"<unknown>"})`;break}(0,P.onUnexpectedError)(new Error(Fe)),ve.publicLog2("sharedprocesserror",{type:Ce,reason:Ae?.reason,code:Ae?.exitCode,visible:ye.isVisible(),shuttingdown:Ee})}));const ke=this.productService.win32MutexName;if(g.isWindows&&ke)try{const Ce=G.__$__nodeRequire("windows-mutex").Mutex,Ae=new Ce(ke);(0,m.once)(this.lifecycleMainService.onWillShutdown)(()=>Ae.release())}catch(Ce){this.logService.error(Ce)}v.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Ce,Ae)=>{Ae({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})});const De=we.get(He.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof ct.LinuxUpdateService||De instanceof at.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ae=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,E.stripComments)(Ae))["enable-crash-reporter"]===void 0){const Je=(0,Be.getTelemetryLevel)(this.configurationService)>=1,Ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Je},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,M.generateUuid)()}"`,"}"],nt=Ae.substring(0,Ae.length-2).concat(`,
`,Ze.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(nt))}}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(we,ye,Ee){try{return await(0,ne.getResolvedShellEnv)(this.logService,we,ye)}catch(ve){const ke=(0,k.toErrorMessage)(ve);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=we.get(R.IDialogMainService);let ve=!1;const ke=async Ce=>{if(ve)return;ve=!0;const Ae=await v.contentTracing.stopRecording(`${(0,f.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Ce?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ae}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ae),buttons:[(0,I.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(ye.map(Ce=>Ce.ready())).then(()=>{clearTimeout(De),ke(!1)})}};Ye=de([re(2,A.IInstantiationService),re(3,ie.ILogService),re(4,Q.IEnvironmentMainService),re(5,x.ILifecycleMainService),re(6,d.IConfigurationService),re(7,fe.IStateMainService),re(8,Y.IFileService),re(9,le.IProductService)],Ye),e.CodeApplication=Ye}),define(ee[253],te([0,1,14,28,31,8,39,15,27,42,33,10,9,63,3,34,25,24,37,58,246,11,19,194,205,23,54,168,18,184,94,73,178,75,20,95,6,188,96,55,22,56,191,97,230,48,232,76,202,38,234,65,66,211]),function(G,e,v,n,D,C,k,P,f,m,E,I,p,S,t,g,y,w,M,c,a,l,o,h,s,i,r,u,d,b,L,R,T,U,Q,se,ne,V,J,q,K,j,B,$,Y,H,F,W,A,_,N,O,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class x{main(){try{this.startup()}catch(Z){console.error(Z.message),v.app.exit(1)}}async startup(){(0,P.setUnexpectedErrorHandler)(me=>console.error(me));const[Z,ce,le,he,ge,be,fe]=this.createServices();try{try{await this.initServices(le,he,ge)}catch(me){throw this.handleStartupDataDirError(le,fe.nameLong,me),me}await Z.invokeFunction(async me=>{const Se=me.get(ne.ILogService),Pe=me.get(Q.ILifecycleMainService),Me=me.get(d.IFileService),Te=await this.claimInstance(Se,le,Pe,Z,fe,!0);return w.Promises.writeFile(le.mainLockfile,String(process.pid)).catch(Oe=>{Se.warn(`Error writing main lockfile: ${Oe.stack}`)}),be.logger=new J.SpdLogLogger("main",(0,p.join)(le.logsPath,"main.log"),!0,!1,be.getLevel()),(0,m.once)(Pe.onWillShutdown)(Oe=>{Me.dispose(),he.dispose(),Oe.join(w.Promises.unlink(le.mainLockfile).catch(()=>{}))}),Z.createInstance(a.CodeApplication,Te,ce).startup()})}catch(me){Z.invokeFunction(this.quit,me)}}createServices(){const Z=new U.ServiceCollection,ce={_serviceBrand:void 0,...q.default};Z.set(K.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);Z.set(i.IEnvironmentMainService,le);const ge=new se.BufferLogService,be=new ne.MultiplexLogService([new ne.ConsoleMainLogger((0,ne.getLogLevel)(le)),ge]);process.once("exit",()=>be.dispose()),Z.set(ne.ILogService,be);const fe=new b.FileService(be);Z.set(d.IFileService,fe);const me=new L.DiskFileSystemProvider(be);fe.registerProvider(I.Schemas.file,me),Z.set(ne.ILoggerService,new V.LoggerService(be,fe));const Se=new h.ConfigurationService(le.settingsResource,fe);Z.set(o.IConfigurationService,Se),Z.set(Q.ILifecycleMainService,new R.SyncDescriptor(Q.LifecycleMainService));const Pe=new N.StateMainService(le,be,fe);return Z.set(_.IStateMainService,Pe),Z.set(H.IRequestService,new R.SyncDescriptor(F.RequestMainService)),Z.set(z.IThemeMainService,new R.SyncDescriptor(z.ThemeMainService)),Z.set(W.ISignService,new R.SyncDescriptor(A.SignService)),Z.set($.ITunnelService,new R.SyncDescriptor(Y.TunnelService)),Z.set(j.IProtocolMainService,new R.SyncDescriptor(B.ProtocolMainService)),[new T.InstantiationService(Z,!0),he,le,Se,Pe,ge,ce]}patchEnvironment(Z){const ce={VSCODE_IPC_HOOK:Z.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(Z,ce,le){return C.Promises.settled([Promise.all([Z.extensionsPath,Z.codeCachePath,Z.logsPath,Z.globalStorageHome.fsPath,Z.workspaceStorageHome.fsPath,Z.backupHome].map(he=>he?w.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(Z,ce,le,he,ge,be){let fe;try{(0,S.mark)("code/willStartMainServer"),fe=await(0,c.serve)(ce.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,m.once)(le.onWillShutdown)(()=>fe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,ge.nameLong,me),me;let Se;try{Se=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(Te){if(!be||t.isWindows||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.showStartupWarningDialog((0,l.localize)(0,null,ge.nameShort),(0,l.localize)(1,null),ge.nameLong),Te;try{(0,n.unlinkSync)(ce.mainIPCHandle)}catch(Oe){throw Z.warn("Could not delete obsolete instance handle",Oe),Oe}return this.claimInstance(Z,ce,le,he,ge,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Te="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw Z.error(Te),Se.dispose(),new Error(Te)}let Pe;!ce.args.wait&&!ce.args.status&&(Pe=setTimeout(()=>{this.showStartupWarningDialog((0,l.localize)(2,null,ge.nameShort),(0,l.localize)(3,null),ge.nameLong)},1e4));const Me=M.ProxyChannel.toService(Se.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const Te=new s.DiagnosticsService(O.NullTelemetryService,ge),Oe=await Me.getMainProcessInfo(),Be=await Me.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),He=await Te.getDiagnostics(Oe,Be);throw console.log(He),new P.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Me,Z),Z.trace("Sending env to running instance..."),await Me.start(ce.args,process.env),Se.dispose(),Pe&&clearTimeout(Pe),new P.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw Z.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new P.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}handleStartupDataDirError(Z,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,D.coalesce)([Z.userDataPath,Z.extensionsPath,c.XDG_RUNTIME_DIR]).map(ge=>(0,E.getPathLabel)(ge,Z));this.showStartupWarningDialog((0,l.localize)(4,null),(0,l.localize)(5,null,(0,k.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(Z,ce,le){v.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,E.mnemonicButtonLabel)((0,l.localize)(6,null))],message:Z,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(Z,ce){if(t.isWindows){const le=await Z.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,ge)=>{G(["windows-foreground-love"],he,ge)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(Z,ce){const le=Z.get(ne.ILogService),he=Z.get(Q.ILifecycleMainService);let ge=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(ge=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(ge)}resolveArgs(){const Z=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(Z.wait&&!Z.waitMarkerFilePath){const ce=(0,u.createWaitMarkerFile)(Z.verbose);ce&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",ce),Z.waitMarkerFilePath=ce)}return Z}validatePaths(Z){if(Z["open-url"]&&(Z._urls=Z._,Z._=[]),!Z.remote){const ce=this.doValidatePaths(Z._,Z.goto);Z._=ce}return Z}doValidatePaths(Z,ce){const le=(0,g.cwd)(),he=Z.map(fe=>{let me=String(fe),Se;ce&&(Se=(0,f.parseLineAndColumnAware)(me),me=Se.path),me&&(me=this.preparePath(le,me));const Pe=(0,f.sanitizeFilePath)(me,le),Me=(0,p.basename)(Pe);return Me&&!(0,f.isValidBasename)(Me)?null:ce&&Se?(Se.path=Pe,this.toPath(Se)):Pe}),ge=t.isWindows||t.isMacintosh,be=(0,D.distinct)(he,fe=>fe&&ge?fe.toLowerCase():fe||"");return(0,D.coalesce)(be)}preparePath(Z,ce){return t.isWindows&&(ce=(0,y.rtrim)(ce,'"')),ce=(0,y.trim)((0,y.trim)(ce," "),"	"),t.isWindows&&(ce=(0,p.resolve)(Z,ce),ce=(0,y.rtrim)(ce,".")),ce}toPath(Z){const ce=[Z.path];return typeof Z.line=="number"&&ce.push(String(Z.line)),typeof Z.column=="number"&&ce.push(String(Z.column)),ce.join(":")}}new x().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a06afb22ce06dbd4f01d3bb5bf946e08bff55180/core/vs/code/electron-main/main.js.map
